#procedure treat
*
*   Treat routine for d_(ka,la)-P(ka)*P(la)/P.P on gluonic currents
*   Insertion is a photon current.
*
*  #[ Physics :
*
Multiply,g_(1,Q)/Q.Q;
.sort:Physics;
*
*  #] Physics :
*  #[ feynman :
sum mu,mu1,nu,nu1,mu2,nu2,mu3,nu3,mu4,nu4,ro,ro1,si,si1,ka,ka1,la,la1;
sum mu5,nu5,mu6,nu6,mu7,nu7,mu8,nu8,mu9,nu9,mu10,nu10;
*
#call intpow(`TOPO')
id  fp(ii1?,p?) = i_*g_(ii1,p)/p.p;
id  vqg(ii1?,mu?) = i_*g_(ii1,mu);
id  fp(ii1?,p?,1) = i_*g_(ii1,p)/p.p*fermi1*epexp(p,1)*s/ep;
id  fp(ii1?,p?,2) = i_*g_(ii1,p)/p.p*fermi2*epexp(p,2)*s^2/ep^2;
id  fp(ii1?,p?,3) = i_*g_(ii1,p)/p.p*fermi3*epexp(p,3)*s^3/ep^3;
id  vgh(p?,mu?) = i_*p(mu);
id  Dg(ii1?,ii2?,p?,1) = DL(ii1,ii2,p)*gluon1*epexp(p,1)*s/ep;
id  Dg(ii1?,ii2?,p?,2) = DL(ii1,ii2,p)*gluon2*epexp(p,2)*s^2/ep^2;
id  Dg(ii1?,ii2?,p?,3) = DL(ii1,ii2,p)*gluon3*epexp(p,3)*s^3/ep^3;
id  Dgh(p?,1) = Dgh(p)*ghost1*epexp(p,1)*s/ep;
id  Dgh(p?,2) = Dgh(p)*ghost2*epexp(p,2)*s^2/ep^2;
id  Dgh(p?,3) = Dgh(p)*ghost3*epexp(p,3)*s^3/ep^3;
id  Dgh(p?) = i_/p.p;
#define TRIM "0"
if ( count(s,1) == 3 ) redefine TRIM "3";
if ( count(s,1) == 2 ) redefine TRIM "2";
if ( count(s,1) == 1 ) redefine TRIM "1";
id  s = 1;

id  epexp(p?mncpp18[D],x?) = mncee18[D]^x/mnceq^x;
id  epexp(-p?mncpp18[D],x?) = mncee18[D]^x/mnceq^x;
id  epexp(-p?[mncPp],x?) = epexp(p,x);
id  epexp(Q,x?) = 1;
id  epexp(-Q,x?) = 1;

id  DL(ii1?,ii2?,p?) = -i_*(d_(ii1,ii2)-p(ii1)*p(ii2)/p.p)/p.p;
.sort
#call vertsubm
#ifdef `GAUGE'
#if ( `GAUGE' > 0 )
if ( count(fermi1,1,fermi2,1,fermi3,1,gluon1,1,gluon2,1,gluon3,1
    ,ghost1,1,ghost2,1,ghost3,1) > 0 );
    if ( count(xi,1) > `GAUGE' ) discard;
else;
    if ( count(xi,1) != `GAUGE' ) discard;
endif;  
#endif
#endif
#call ACCU(Vertex substitutions)

tracen,3;
tracen,2;
tracen,1;
id D = acc(4-2*ep);
id [D-4] = acc(-2*ep);
id [1-ep/2] = acc(1-ep/2);

#call ACCU(Traces)
*  #] feynman :
*  #[ Psub :
#call ACCU(sym1)
#call momsubs(`TOPO')
#call ACCU(moms)
#call scalars(`TOPO')
id  epexp(p?[mncpp18][D],x?)  = mncee18[D]^x/mnceq^x
    *epexp( 2*proexp*P.mncpp18[D]/mncpp18[D].mncpp18[D],x);
id  epexp(p?[-mncpp18][D],x?) = mncee18[D]^x/mnceq^x
    *epexp(-2*proexp*P.mncpp18[D]/mncpp18[D].mncpp18[D],x);
*
*   Now convert the metric:
*
#call momsubs(`TOPO')
#call sym2(`TOPO')
#call ACCU(moms)
Multiply replace_(fermi1,mncfermi1,fermi2,mncfermi2,fermi3,mncfermi3,
	gluon1,mncgluon1,gluon2,mncgluon2,gluon3,mncgluon3,
	ghost1,mncghost1,ghost2,mncghost2);
*  #] Psub :
#endprocedure
