#ifndef `MINCERHFILE'
#define  MINCERHFILE  "1"
*
*	This is the mincer system as adapted to version 3 of FORM.
*	All necessary files are included in the file mincer.h
*	All local variables have names that start with mnc to avoid namespace problems.
*	When needed one should use replace_ to change external names to internal ones.
*	All procedures are included here as well.
*	The only variables that have external names are:
*	S D,ep,z3,z4,z5,z6,zz5;
*	CF acc;
*	V P,Q,p1,p2,p3,p4,p5,p6,p7,p8;
*	I mu,nu,ka,la,ro,si,ga,alfa,beta,MU,NU,KA,RO,SI,mmu,nnu;
*	S cw1,cw2,cw3;
*	S cf,ca,nf,nc,[cf-ca/2],[cf-ca],[dabc^2/n];
*	CF Glonel;
*	S ab,a,[alfas/pi];  * used in total and other renormalizations.
*
*	Conversion by J. Vermaseren 2-may-2000.
*
*--#[ Declarations :
#define OLDTWO "1"
#define EXTRARED "1"
#define LATRANS "0"
#define BEPATH "0"
#define O1PATH "0"
#define INNOTABL "11"
#define NOSPEC "0"
S   D,[D-4],ep(:6),[1-ep/2];
dimension D:[D-4];
AutoDeclare Index mnci,mncj,mu,nu,ka,la,ro,si,ga;
AutoDeclare Vector Q,P,mncp,mncq;
AutoDeclare Symbol mnce,mncx,mncy,mncsgn,mnck,D;
V	p1,p2,p3,p4,p5,p6,p7,p8;
V	[P+Q],[P+p1],[P+p2],[P+p3],[P+p4],[P+p5],[P+p6],[P+p7],[P+p8];
V	[P-Q],[P-p1],[P-p2],[P-p3],[P-p4],[P-p5],[P-p6],[P-p7],[P-p8];
set mncpp18:p1,p2,p3,p4,p5,p6,p7,p8;
set mncpQ18:p1,p2,p3,p4,p5,p6,p7,p8,Q;
set [mncpp18]:[P+p1],[P+p2],[P+p3],[P+p4],[P+p5],[P+p6],[P+p7],[P+p8];
set [-mncpp18]:[P-p1],[P-p2],[P-p3],[P-p4],[P-p5],[P-p6],[P-p7],[P-p8];
set mncee18:mnce1,mnce2,mnce3,mnce4,mnce5,mnce6,mnce7,mnce8;
set [mncPp]:[P+p1],[P+p2],[P+p3],[P+p4],[P+p5],[P+p6],[P+p7],[P+p8],[P+Q],
	[P-p1],[P-p2],[P-p3],[P-p4],[P-p5],[P-p6],[P-p7],[P-p8],[P-Q];
set mncPcenter:[P+p7],[P+p2],[P+p8],[P-p7],[P-p2],[P-p8];
set mncpcenter:p7,p2,p8;
set [mncx18]:mncx1,mncx2,mncx3,mncx4,mncx5,mncx6,mncx7,mncx8;
S	z3,z4,z5,z6,zz5;
S   mncs,mncj;
S   mncexp11,mncexp10,mncexp20,mncG311,mncF321,mncint1,mncint2,mncint3;
S	mncN1,mncN2,mncN3,mncA,mncB,mncm;
I	alfa,beta;
I	MU,NU,KA,RO,SI,mmu,nnu;
S	mncxi;
S	cw1,cw2,cw3;
S	cf,ca,nf,nc,[cf-ca/2],[cf-ca],[dabc^2/n];
S	mncfermi1,mncfermi2,mncfermi3,mncghost1,mncghost2,mncghost3,mncgluon1,mncgluon2,mncgluon3;
F	mncS,mncSS,mncSSS;
S	ab,[(mu^2/Q.Q)^ep],a,[ln(mu^2/Q.Q)],[alfas/pi];
CF	mncv2gi,mncV3G,mncv3g,mncv3gi,mncV4G,mncv4g,mncv4gi,mncDg,mncDs,Glonel,mncVgh,mncDgh,mncDL,mncVv;
CF	mncv2gp,mncv2gc,mncv3gp,mncv3gc,mncv4gp,mncv4gc;
CF  mncG,mncdeno,mncpo,mncpoinv,mncaccm,mncftri;
F   mncdel,mncdd,mncfp;
S	mncproexp;
CF	mncepexp,mncpropxp,mncnaar,mncsumm1,mncsumm2,mncsumm3;
T	mncFQ,mncFFPP;
CF	acc;
#ifndef `SCHEME'
#define SCHEME "1"
#endif
*--#] Declarations : 
*--#[ Procedures :
*--#[ benz :
#procedure benz(P1,P2,P3,P4,P5,P6,P7,P8,Q)
*
*   Reduction procedure for three loop graphs of the BE or benz type.
*   Notation is from S.G.Gorishny et.al. Comp.Phys.Comm 55(1989)381
*
*                     /-<------<------<-\
*                 P1 /    \   P2    /    \ P3
*                   /      \       /      \
*                  /     P6 v     ^ P7     \
*                 /          \   /          \
*          Q --<--            \ /            --<-- Q
*                 \            |            /
*                  \           v P8        / 
*                   \          |          /
*                 P5 \         |         / P4
*                     \---->------->----/
*
*   We start with reducing the dotproducts in the numerator to sums
*   of denominators. Only one dotproduct is irreducible: Q.P2 
*   The easiest reduction (and quite fast) is by writing everything
*   in terms of Q,P1,P2,P3 and use vertex identities and P8 = P3-P1
*   to write the few remaining dotproducts in terms of denominators.
*
*   Routine coded by J.A.M.Vermaseren 8-jul-1990, modified 13-nov-1990.
*
*  id  `P4'.P?!{,`P4'} = `P3'.P-'Q'.P;
*  id  `P5'.P?!{,`P5'} = `P1'.P-'Q'.P;

*#call ACCU(Benz momenta 1)

*  id  `P6'.P?!{,`P6'} = `P2'.P-`P1'.P;

*#call ACCU(Benz momenta 2)

*  id  `P7'.P?!{,`P7'} = `P2'.P-`P3'.P;

*#call ACCU(Benz momenta 3)

*  id  `P8'.P?!{,`P8'} = `P3'.P-`P1'.P;

*#call ACCU(Benz momenta 4)

  id  'Q'.`P1' = `P1'.`P1'/2+'Q'.'Q'/2-`P5'.`P5'/2;

#call ACCU(Benz scalar 1)

  id  'Q'.`P3' = `P3'.`P3'/2+'Q'.'Q'/2-`P4'.`P4'/2;

#call ACCU(Benz scalar 2)

  id  `P1'.`P2' = `P1'.`P1'/2+`P2'.`P2'/2-`P6'.`P6'/2;

#call ACCU(Benz scalar 3)

  id  `P2'.`P3' = `P2'.`P2'/2+`P3'.`P3'/2-`P7'.`P7'/2;

#call ACCU(Benz scalar 4)

  id  `P1'.`P3' = `P1'.`P1'/2+`P3'.`P3'/2-`P8'.`P8'/2;

#call ACCU(Benz scalar 5)

  if ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
              /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8') > 0 );
    #call triangle(`P2',`P6',`P7',`P1',`P3')
  endif;
*
#endprocedure
*--#] benz : 
*--#[ benzbar :
#procedure benzbar(P1,P2,P3,P4,P5,P6,P7,Q)
*
*   Reduction procedure for three loop graphs of the BEbar or benz-bar type.
*   Notation is from S.G.Gorishny et.al. Comp.Phys.Comm 55(1989)381
*
*                     /-<------<------<-\
*                 P1 /     |  P2   |     \ P3
*                   /      \       /      \
*                  /     P6 |     | P7     \
*                 /         \     /         \
*          Q --<--           v   ^           --<-- Q
*                 \          \   /          /
*                  \          | |          / 
*                   \         \ /         /
*                 P5 \         |         / P4
*                     \---->------->----/
*
*
*   Note that from the ladder graphs we can have powers of p7.p8 (P6.P7)
*   Here they can be written as a fake (P6-P7)^2
*   Such a (P6-P7)^2 isn't affected by the transformations here.
*	It is better than writing it as (P3-P1)^2 because then we would
*	generate positive powers of P1.P1 and P3.P3 in the end.
*
*	Coded by J.A.M. Vermaseren, 13-nov-1990.
*
  id  `P6'.`P7' = `P6'.`P6'/2+`P7'.`P7'/2-mncx8/2;

  if ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
              /`P5'.`P5'/`P6'.`P6'/`P7'.`P7') > 0 );
    #call triangle(`P2',`P6',`P7',`P1',`P3')
  endif;

  id  mncx8 = `P6'.`P6' + `P7'.`P7' - 2*`P6'.`P7';

#endprocedure
*--#] benzbar : 
*--#[ benzbu :
#procedure benzbu(P1,P2,P3,P4,P5,P6,P7,Q)
*
*   Reduction procedure for three loop graphs of the BU or benz-bu type.
*   Notation is from S.G.Gorishny et.al. Comp.Phys.Comm 55(1989)381
*
*                     /-<-------------<-\
*                 P1 /         |         \ P6
*                   /          ^ P4       \
*                  /           |           \
*                 /     P2     |            \
*          Q --<-- ----->------|             --<-- Q
*                 \            |            /
*                  \           |           / 
*                   \          v P5       /
*                 P3 \         |         / P7
*                     \---->------->----/
*
*   The main complication is to make sure that no loop momentum
*   survives in the numerator (Q.P4 and Q.P5 are independent objects)
*   Because this is a service routine it is best if the calling
*   routine takes care of that.
*   BU is BE with 1 or 3 missing.
*
*   Procedure coded by J.A.M. Vermaseren, 13-nov-1990.
*
  if ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
              /`P5'.`P5'/`P6'.`P6'/`P7'.`P7') > 0 );
    if ( count(`P6'.`P6',1) > count(`P7'.`P7',1) );
      #call triangle(`P4',`P2',`P1',`P5',`P6')
    else;
      #call triangle(`P5',`P2',`P3',`P4',`P7')
    endif;
  endif;
*
#endprocedure
*--#] benzbu : 
*--#[ benzred :
#procedure benzred(P1,P2,P3,P4,P5,P6,P7,P8,Q)
*
*   Reduction procedure for three loop graphs of the BE or benz type.
*   Notation is from S.G.Gorishny et.al. Comp.Phys.Comm 55(1989)381
*
*                     /-<------<------<-\
*                 P1 /    \   P2    /    \ P3
*                   /      \       /      \
*                  /     P6 v     ^ P7     \
*                 /          \   /          \
*          `Q' --<--            \ /            --<-- `Q'
*                 \            |            /
*                  \           v P8        / 
*                   \          |          /
*                 P5 \         |         / P4
*                     \---->------->----/
*
*   We start with reducing the dotproducts in the numerator to sums
*   of denominators. Only one dotproduct is irreducible: `Q'.P2 
*   The easiest reduction (and quite fast) is by writing everything
*   in terms of `Q',P1,P2,P3 and use vertex identities and P8 = P3-P1
*   to write the few remaining dotproducts in terms of denominators.
*
*   Routine coded by J.A.M.Vermaseren 8-jul-1990, modified 13-nov-1990.
*	BEPATH added 21-dec-1994 to improve efficiency.
*
#ifndef `BEPATH'
if ( count(`P6'.`P6',1) < count(`P7'.`P7',1) );
	multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
elseif ( count(`P6'.`P6',1) == count(`P7'.`P7',1) );
    if ( count(`P1'.`P1',1) < count(`P3'.`P3',1) );
		multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
	elseif ( count(`P1'.`P1',1) == count(`P3'.`P3',1) );
	    if ( count(`P5'.`P5',1) < count(`P4'.`P4',1) )
			multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
	endif;
endif;
#call ACCU2(AB `P1'.`P3' `P1'.`P1' `P3'.`P3' `P8'.`P8',Benz scalar 0)
  id  `P1'.`P3' = `P1'.`P1'/2+`P3'.`P3'/2-`P8'.`P8'/2;
#call ACCU2(AB `P2'.`P3' `P2'.`P2' `P3'.`P3' `P7'.`P7',Benz scalar 1)
  id  `P2'.`P3' = `P2'.`P2'/2+`P3'.`P3'/2-`P7'.`P7'/2;
#call ACCU2(AB `P1'.`P2' `P1'.`P1' `P2'.`P2' `P6'.`P6',Benz scalar 2)
  id  `P1'.`P2' = `P1'.`P1'/2+`P2'.`P2'/2-`P6'.`P6'/2;
#call ACCU2(AB `Q'.`P1' `P1'.`P1' `Q'.`Q' `P5'.`P5',Benz scalar 3)
  id  `Q'.`P1' = `P1'.`P1'/2+`Q'.`Q'/2-`P5'.`P5'/2;
#call ACCU2(AB `Q'.`P3' `P3'.`P3' `Q'.`Q' `P4'.`P4',Benz scalar 4)
  id  `Q'.`P3' = `P3'.`P3'/2+`Q'.`Q'/2-`P4'.`P4'/2;

if ( count(`P6'.`P6',1) < count(`P7'.`P7',1) );
	multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
elseif ( count(`P6'.`P6',1) == count(`P7'.`P7',1) );
    if ( count(`P1'.`P1',1) < count(`P3'.`P3',1) );
		multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
	elseif ( count(`P1'.`P1',1) == count(`P3'.`P3',1) );
	    if ( count(`P5'.`P5',1) < count(`P4'.`P4',1) )
			multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
	endif;
endif;
#call ACCU(Benz scalar 5)
#else
#if `BEPATH' == 0
if ( count(`P6'.`P6',1) < count(`P7'.`P7',1) );
	multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
elseif ( count(`P6'.`P6',1) == count(`P7'.`P7',1) );
    if ( count(`P1'.`P1',1) < count(`P3'.`P3',1) );
		multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
	elseif ( count(`P1'.`P1',1) == count(`P3'.`P3',1) );
	    if ( count(`P5'.`P5',1) < count(`P4'.`P4',1) )
			multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
	endif;
endif;
#call ACCU2(AB `P1'.`P3' `P1'.`P1' `P3'.`P3' `P8'.`P8',Benz scalar 0 \(0\))
  id  `P1'.`P3' = `P1'.`P1'/2+`P3'.`P3'/2-`P8'.`P8'/2;
#call ACCU2(AB `P2'.`P3' `P2'.`P2' `P3'.`P3' `P7'.`P7',Benz scalar 1 \(0\))
  id  `P2'.`P3' = `P2'.`P2'/2+`P3'.`P3'/2-`P7'.`P7'/2;
#call ACCU2(AB `P1'.`P2' `P1'.`P1' `P2'.`P2' `P6'.`P6',Benz scalar 2 \(0\))
  id  `P1'.`P2' = `P1'.`P1'/2+`P2'.`P2'/2-`P6'.`P6'/2;
#call ACCU2(AB `Q'.`P1' `P1'.`P1' `Q'.`Q' `P5'.`P5',Benz scalar 3 \(0\))
  id  `Q'.`P1' = `P1'.`P1'/2+`Q'.`Q'/2-`P5'.`P5'/2;
#call ACCU2(AB `Q'.`P3' `P3'.`P3' `Q'.`Q' `P4'.`P4',Benz scalar 4 \(0\))
  id  `Q'.`P3' = `P3'.`P3'/2+`Q'.`Q'/2-`P4'.`P4'/2;

if ( count(`P6'.`P6',1) < count(`P7'.`P7',1) );
	multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
elseif ( count(`P6'.`P6',1) == count(`P7'.`P7',1) );
    if ( count(`P1'.`P1',1) < count(`P3'.`P3',1) );
		multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
	elseif ( count(`P1'.`P1',1) == count(`P3'.`P3',1) );
	    if ( count(`P5'.`P5',1) < count(`P4'.`P4',1) )
			multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
	endif;
endif;
#call ACCU(Benz scalar 5 \(0\))
#endif
#if `BEPATH' == 1
#call ACCU2(AB `Q'.`P1' `P1'.`P1' `Q'.`Q' `P5'.`P5',Benz scalar 0 \(1\))
	id  `Q'.`P1' = `P1'.`P1'/2+`Q'.`Q'/2-`P5'.`P5'/2;
#call ACCU2(AB `P1'.`P6' `P2'.`P2' `P1'.`P1' `P6'.`P6',Benz scalar 1 \(1\))
	id	`P1'.`P6' = `P2'.`P2'/2-`P1'.`P1'/2-`P6'.`P6'/2;
#call ACCU2(AB `P6'.`P8' `P6'.`P6' `P8'.`P8' `P7'.`P7',Benz scalar 2 \(1\))
	id	`P6'.`P8' = `P6'.`P6'/2+`P8'.`P8'/2-`P7'.`P7'/2;
#call ACCU2(AB `P1'.`P8' `P3'.`P3' `P1'.`P1' `P8'.`P8',Benz scalar 3 \(1\))
	id	`P1'.`P8' = `P3'.`P3'/2-`P1'.`P1'/2-`P8'.`P8'/2;
#call ACCU2(AB `Q'.`P8' `P3'.`P3' `P4'.`P4' `P1'.`P1' `P5'.`P5',Benz scalar 4 \(1\))
	id	`Q'.`P8' = `P3'.`P3'/2-`P4'.`P4'/2-`P1'.`P1'/2+`P5'.`P5'/2;
#call ACCU2(AB `Q'.`P6' `Q'.`P2' `Q'.`Q' `P1'.`P1' `P5'.`P5',Benz scalar 5 \(1\))
	id	`Q'.`P6' = `Q'.`P2'-`Q'.`Q'/2-`P1'.`P1'/2+`P5'.`P5'/2;

if ( count(`P6'.`P6',1) < count(`P7'.`P7',1) );
	multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',
           `P7',`P7',`P6',`P8',-`P8');
elseif ( count(`P6'.`P6',1) == count(`P7'.`P7',1) );
    if ( count(`P1'.`P1',1) < count(`P3'.`P3',1) );
		multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',
            `P7',`P7',`P6',`P8',-`P8');
	elseif ( count(`P1'.`P1',1) == count(`P3'.`P3',1) );
	    if ( count(`P5'.`P5',1) < count(`P4'.`P4',1) )
			multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',
              `P7',`P7',`P6',`P8',-`P8');
	endif;
endif;
#call ACCU(Benz scalar 6 \(1\))
#endif
#if `BEPATH' == 2
#call ACCU2(AB `P1'.`P2' `P1'.`P1' `P2'.`P2' `P6'.`P6',Benz scalar 0 \(2\))
	id	`P1'.`P2' = `P1'.`P1'/2+`P2'.`P2'/2-`P6'.`P6'/2;
#call ACCU2(AB `P2'.`P7' `P2'.`P2' `P7'.`P7' `P3'.`P3',Benz scalar 1 \(2\))
	id	`P2'.`P7' = `P2'.`P2'/2+`P7'.`P7'/2-`P3'.`P3'/2;
#call ACCU2(AB `Q'.`P1' `P1'.`P1' `Q'.`Q' `P5'.`P5',Benz scalar 2 \(2\))
	id	`Q'.`P1' = `P1'.`P1'/2+`Q'.`Q'/2-`P5'.`P5'/2;
#call ACCU2(AB `Q'.`P7' `Q'.`P2' `Q'.`Q' `P3'.`P3' `P4'.`P4',Benz scalar 3 \(2\))
	id	`Q'.`P7' = `Q'.`P2'-`Q'.`Q'/2-`P3'.`P3'/2+`P4'.`P4'/2;
#call ACCU2(AB `P1'.`P7' `P2'.`P2' `P6'.`P6' `P3'.`P3' `P8'.`P8',Benz scalar 4 \(2\))
	id	`P1'.`P7' = `P2'.`P2'/2-`P6'.`P6'/2-`P3'.`P3'/2+`P8'.`P8'/2;

if ( count(`P6'.`P6',1) < count(`P7'.`P7',1) );
	multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
elseif ( count(`P6'.`P6',1) == count(`P7'.`P7',1) );
    if ( count(`P1'.`P1',1) < count(`P3'.`P3',1) );
		multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
	elseif ( count(`P1'.`P1',1) == count(`P3'.`P3',1) );
	    if ( count(`P5'.`P5',1) < count(`P4'.`P4',1) )
			multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
	endif;
endif;
#call ACCU(Benz scalar 5 \(2\))
#endif
#if `BEPATH' == 3
#call ACCU2(AB `P6'.`P8' `P6'.`P6' `P8'.`P8' `P7'.`P7',Benz scalar 0 \(3\))
	id	`P6'.`P8' = `P6'.`P6'/2+`P8'.`P8'/2-`P7'.`P7'/2;
#call ACCU2(AB `P2'.`P6' `P2'.`P2' `P6'.`P6' `P1'.`P1',Benz scalar 1 \(3\))
	id	`P2'.`P6' = `P2'.`P2'/2+`P6'.`P6'/2-`P1'.`P1'/2;
#call ACCU2(AB `P2'.`P8' `P3'.`P3' `P1'.`P1' `P7'.`P7' `P6'.`P6',Benz scalar 2 \(3\))
	id	`P2'.`P8' = `P3'.`P3'/2-`P1'.`P1'/2-`P7'.`P7'/2+`P6'.`P6'/2;
#call ACCU2(AB `Q'.`P8' `P3'.`P3' `P4'.`P4' `P1'.`P1' `P5'.`P5',Benz scalar 3 \(3\))
	id	`Q'.`P8' = `P3'.`P3'/2-`P4'.`P4'/2-`P1'.`P1'/2+`P5'.`P5'/2;
#call ACCU2(AB `Q'.`P6' `Q'.`P2' `Q'.`Q' `P1'.`P1' `P5'.`P5',Benz scalar 4 \(3\))
	id	`Q'.`P6' = `Q'.`P2'-`Q'.`Q'/2-`P1'.`P1'/2+`P5'.`P5'/2;

if ( count(`P6'.`P6',1) < count(`P7'.`P7',1) );
	multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
elseif ( count(`P6'.`P6',1) == count(`P7'.`P7',1) );
    if ( count(`P1'.`P1',1) < count(`P3'.`P3',1) );
		multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
	elseif ( count(`P1'.`P1',1) == count(`P3'.`P3',1) );
	    if ( count(`P5'.`P5',1) < count(`P4'.`P4',1) )
			multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
	endif;
endif;
#call ACCU(Benz scalar 5 \(3\))
#endif
#if `BEPATH' == 4
#call ACCU2(AB `P6'.`P8' `P6'.`P6' `P8'.`P8' `P7'.`P7',Benz scalar 0 \(4\))
	id	`P6'.`P8' = `P6'.`P6'/2+`P8'.`P8'/2-`P7'.`P7'/2;
#call ACCU2(AB `P4'.`P8' `P4'.`P4' `P8'.`P8' `P5'.`P5',Benz scalar 1 \(4\))
	id	`P4'.`P8' = `P4'.`P4'/2+`P8'.`P8'/2-`P5'.`P5'/2;
#call ACCU2(AB `Q'.`P4' `P3'.`P3' `Q'.`Q' `P4'.`P4',Benz scalar 2 \(4\))
	id	`Q'.`P4' = `P3'.`P3'/2-`Q'.`Q'/2-`P4'.`P4'/2;
#call ACCU2(AB `Q'.`P8' `P3'.`P3' `P4'.`P4' `P1'.`P1' `P5'.`P5',Benz scalar 3 \(4\))
	id	`Q'.`P8' = `P3'.`P3'/2-`P4'.`P4'/2-`P1'.`P1'/2+`P5'.`P5'/2;
#call ACCU2(AB `Q'.`P6' `Q'.`P2' `Q'.`Q' `P1'.`P1' `P5'.`P5',Benz scalar 4 \(4\))
	id	`Q'.`P6' = `Q'.`P2'-`Q'.`Q'/2-`P1'.`P1'/2+`P5'.`P5'/2;
#call ACCU2(AB `P4'.`P6' `Q'.`P2' `Q'.`Q' `P2'.`P2' `P8'.`P8' `P7'.`P7' `P5'.`P5',Benz scalar 5 \(4\))
	id	`P4'.`P6' = -`Q'.`P2'+`Q'.`Q'/2+`P2'.`P2'/2+`P8'.`P8'/2
	                -`P7'.`P7'/2-`P5'.`P5'/2;

if ( count(`P6'.`P6',1) < count(`P7'.`P7',1) );
	multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
elseif ( count(`P6'.`P6',1) == count(`P7'.`P7',1) );
    if ( count(`P1'.`P1',1) < count(`P3'.`P3',1) );
		multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
	elseif ( count(`P1'.`P1',1) == count(`P3'.`P3',1) );
	    if ( count(`P5'.`P5',1) < count(`P4'.`P4',1) )
			multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
	endif;
endif;
#call ACCU(Benz scalar 6 \(4\))
#endif
#if `BEPATH' == 5
#call ACCU2(AB `P1'.`P6' `P2'.`P2' `P1'.`P1' `P6'.`P6',Benz scalar 0 \(5\))
	id	`P1'.`P6' = `P2'.`P2'/2-`P1'.`P1'/2-`P6'.`P6'/2;
#call ACCU2(AB `P6'.`P7' `P6'.`P6' `P7'.`P7' `P8'.`P8',Benz scalar 1 \(5\))
	id	`P6'.`P7' = `P6'.`P6'/2+`P7'.`P7'/2-`P8'.`P8'/2;
#call ACCU2(AB `Q'.`P1' `P1'.`P1' `Q'.`Q' `P5'.`P5',Benz scalar 2 \(5\))
	id	`Q'.`P1' = `P1'.`P1'/2+`Q'.`Q'/2-`P5'.`P5'/2;
#call ACCU2(AB `P1'.`P7' `P2'.`P2' `P6'.`P6' `P3'.`P3' `P8'.`P8',Benz scalar 3 \(5\))
	id	`P1'.`P7' = `P2'.`P2'/2-`P6'.`P6'/2-`P3'.`P3'/2+`P8'.`P8'/2;
	if ( count(`P6'.`P6',1) < count(`P7'.`P7',1) );
		multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
	elseif ( count(`P6'.`P6',1) == count(`P7'.`P7',1) );
    	if ( count(`P1'.`P1',1) < count(`P3'.`P3',1) );
			multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
		elseif ( count(`P1'.`P1',1) == count(`P3'.`P3',1) );
		    if ( count(`P5'.`P5',1) < count(`P4'.`P4',1) )
				multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
		endif;
	endif;
#call ACCU2(AB `Q'.`P6' `Q'.`P2' `Q'.`Q' `P1'.`P1' `P5'.`P5',Benz scalar 4 \(5\))
	id	`Q'.`P6' = `Q'.`P2'-`Q'.`Q'/2-`P1'.`P1'/2+`P5'.`P5'/2;
#call ACCU2(AB `Q'.`P7' `Q'.`P2' `Q'.`Q' `P3'.`P3' `P4'.`P4',Benz scalar 5 \(5\))
	id	`Q'.`P7' = `Q'.`P2'-`Q'.`Q'/2-`P3'.`P3'/2+`P4'.`P4'/2;

if ( count(`P6'.`P6',1) < count(`P7'.`P7',1) );
	multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
elseif ( count(`P6'.`P6',1) == count(`P7'.`P7',1) );
    if ( count(`P1'.`P1',1) < count(`P3'.`P3',1) );
		multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
	elseif ( count(`P1'.`P1',1) == count(`P3'.`P3',1) );
	    if ( count(`P5'.`P5',1) < count(`P4'.`P4',1) )
			multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
	endif;
endif;
#call ACCU(Benz scalar 6 \(5\))
#endif
#if `BEPATH' == 6
#call ACCU2(AB `P5'.`P8' `P4'.`P4' `P5'.`P5' `P8'.`P8',Benz scalar 0 \(6\))
	id	`P5'.`P8' = `P4'.`P4'/2-`P5'.`P5'/2-`P8'.`P8'/2;
#call ACCU2(AB `P6'.`P8' `P6'.`P6' `P8'.`P8' `P7'.`P7',Benz scalar 1 \(6\))
	id	`P6'.`P8' = `P6'.`P6'/2+`P8'.`P8'/2-`P7'.`P7'/2;
#call ACCU2(AB `Q'.`P5' `P1'.`P1' `Q'.`Q' `P5'.`P5',Benz scalar 2 \(6\))
	id	`Q'.`P5' = `P1'.`P1'/2-`Q'.`Q'/2-`P5'.`P5'/2;
#call ACCU2(AB `P5'.`P6' `P2'.`P2' `P1'.`P1' `P6'.`P6' `Q'.`P6',Benz scalar 3 \(6\))
	id	`P5'.`P6' = `P2'.`P2'/2-`P1'.`P1'/2-`P6'.`P6'/2-`Q'.`P6';
#call ACCU2(AB `Q'.`P8' `P3'.`P3' `P4'.`P4' `P1'.`P1' `P5'.`P5',Benz scalar 4 \(6\))
	id	`Q'.`P8' = `P3'.`P3'/2-`P4'.`P4'/2-`P1'.`P1'/2+`P5'.`P5'/2;
#call ACCU2(AB `Q'.`P6' `Q'.`P2' `Q'.`Q' `P1'.`P1' `P5'.`P5',Benz scalar 5 \(6\))
	id	`Q'.`P6' = `Q'.`P2'-`Q'.`Q'/2-`P1'.`P1'/2+`P5'.`P5'/2;

if ( count(`P6'.`P6',1) < count(`P7'.`P7',1) );
	multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
elseif ( count(`P6'.`P6',1) == count(`P7'.`P7',1) );
    if ( count(`P1'.`P1',1) < count(`P3'.`P3',1) );
		multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
	elseif ( count(`P1'.`P1',1) == count(`P3'.`P3',1) );
	    if ( count(`P5'.`P5',1) < count(`P4'.`P4',1) )
			multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
	endif;
endif;
#call ACCU(Benz scalar 6 \(6\))
#endif
#if `BEPATH' == 7
#call ACCU2(AB `P4'.`P5' `P4'.`P4' `P5'.`P5' `P8'.`P8',Benz scalar 0 \(7\))
	id	`P4'.`P5' = `P4'.`P4'/2+`P5'.`P5'/2-`P8'.`P8'/2;
#call ACCU2(AB `Q'.`P4' `P3'.`P3' `Q'.`Q' `P4'.`P4',Benz scalar 1 \(7\))
	id	`Q'.`P4' = `P3'.`P3'/2-`Q'.`Q'/2-`P4'.`P4'/2;
#call ACCU2(AB `Q'.`P5' `P1'.`P1' `Q'.`Q' `P5'.`P5',Benz scalar 2 \(7\))
	id	`Q'.`P5' = `P1'.`P1'/2-`Q'.`Q'/2-`P5'.`P5'/2;
#call ACCU2(AB `P2'.`P4' `P2'.`P2' `P3'.`P3' `P7'.`P7' `Q'.`P2',Benz scalar 3 \(7\))
	id	`P2'.`P4' = `P2'.`P2'/2+`P3'.`P3'/2-`P7'.`P7'/2-`Q'.`P2';
#call ACCU2(AB `P2'.`P5' `P2'.`P2' `P1'.`P1' `P6'.`P6' `Q'.`P2',Benz scalar 4 \(7\))
	id	`P2'.`P5' = `P2'.`P2'/2+`P1'.`P1'/2-`P6'.`P6'/2-`Q'.`P2';

if ( count(`P6'.`P6',1) < count(`P7'.`P7',1) );
	multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
elseif ( count(`P6'.`P6',1) == count(`P7'.`P7',1) );
    if ( count(`P1'.`P1',1) < count(`P3'.`P3',1) );
		multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
	elseif ( count(`P1'.`P1',1) == count(`P3'.`P3',1) );
	    if ( count(`P5'.`P5',1) < count(`P4'.`P4',1) )
			multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
	endif;
endif;
#call ACCU(Benz scalar 5 \(7\))
#endif
#if `BEPATH' == 8
if ( count(`P6'.`P6',1) < count(`P7'.`P7',1) );
	multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
elseif ( count(`P6'.`P6',1) == count(`P7'.`P7',1) );
    if ( count(`P1'.`P1',1) < count(`P3'.`P3',1) );
		multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
	elseif ( count(`P1'.`P1',1) == count(`P3'.`P3',1) );
	    if ( count(`P5'.`P5',1) < count(`P4'.`P4',1) )
			multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
	endif;
endif;
#call ACCU2(AB `P2'.`P6' `P2'.`P2' `P1'.`P1' `P6'.`P6',Benz scalar 0 \(8\))
	id	`P2'.`P6' = `P2'.`P2'/2+`P6'.`P6'/2-`P1'.`P1'/2;
#call ACCU2(AB `P2'.`P7' `P2'.`P2' `P7'.`P7' `P3'.`P3',Benz scalar 1 \(8\))
	id	`P2'.`P7' = `P2'.`P2'/2+`P7'.`P7'/2-`P3'.`P3'/2;
if ( count(`P6'.`P6',1) < count(`P7'.`P7',1) );
	multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
elseif ( count(`P6'.`P6',1) == count(`P7'.`P7',1) );
    if ( count(`P1'.`P1',1) < count(`P3'.`P3',1) );
		multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
	elseif ( count(`P1'.`P1',1) == count(`P3'.`P3',1) );
	    if ( count(`P5'.`P5',1) < count(`P4'.`P4',1) )
			multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
	endif;
endif;
#call ACCU2(AB `P6'.`P7' `P6'.`P6' `P7'.`P7' `P8'.`P8',Benz scalar 2 \(8\))
	id	`P6'.`P7' = `P6'.`P6'/2+`P7'.`P7'/2-`P8'.`P8'/2;
	if ( count(`P6'.`P6',1) < count(`P7'.`P7',1) );
		multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
	elseif ( count(`P6'.`P6',1) == count(`P7'.`P7',1) );
    	if ( count(`P1'.`P1',1) < count(`P3'.`P3',1) );
			multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
		elseif ( count(`P1'.`P1',1) == count(`P3'.`P3',1) );
		    if ( count(`P5'.`P5',1) < count(`P4'.`P4',1) )
				multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
		endif;
	endif;
#call ACCU2(AB `Q'.`P6' `Q'.`P2' `Q'.`Q' `P1'.`P1' `P5'.`P5',Benz scalar 3 \(8\))
	id	`Q'.`P6' = `Q'.`P2'-`Q'.`Q'/2-`P1'.`P1'/2+`P5'.`P5'/2;
#call ACCU2(AB `Q'.`P7' `Q'.`P2' `Q'.`Q' `P3'.`P3' `P4'.`P4',Benz scalar 4 \(8\))
	id	`Q'.`P7' = `Q'.`P2'-`Q'.`Q'/2-`P3'.`P3'/2+`P4'.`P4'/2;
if ( count(`P6'.`P6',1) < count(`P7'.`P7',1) );
	multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
elseif ( count(`P6'.`P6',1) == count(`P7'.`P7',1) );
    if ( count(`P1'.`P1',1) < count(`P3'.`P3',1) );
		multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
	elseif ( count(`P1'.`P1',1) == count(`P3'.`P3',1) );
	    if ( count(`P5'.`P5',1) < count(`P4'.`P4',1) )
			multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
	endif;
endif;
#call ACCU(Benz scalar 5 \(8\))
#endif
#endif
*
#endprocedure
*--#] benzred : 
*--#[ dotwo :
#procedure dotwo()
#ifdef `OLDTWO'
 
if ( count(p1.p1,1,p3.p3,1) > count(p4.p4,1,p6.p6,1) );
    multiply replace_(p1,p6,p6,p1,p3,p4,p4,p3,mnce1,mnce6,mnce6,mnce1,mnce3,mnce4,mnce4,mnce3);
    id  Q.mncq1?{p1,p3,p4,p6,p7} = -Q.mncq1;
endif;
if ( count(p1.p1,1,p6.p6,1) > count(p3.p3,1,p4.p4,1) );
    multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,mnce1,mnce3,mnce3,mnce1,mnce4,mnce6,mnce6,mnce4);
    id  p7.mncq1?{Q,p1,p3,p4,p6} = -p7.mncq1;
endif;

#call ACCU(Presymmetrize)

id  p7.Q = Q.p1-Q.p3;
id  p1.p4 = p1.p3-p1.Q;
id  p3.p6 = p1.p3-p3.Q;
id  p1.p7 = p1.p1/2+p7.p7/2-p3.p3/2;
id  p3.p7 = p1.p1/2-p3.p3/2-p7.p7/2;
id  p4.p7 = p6.p6/2-p4.p4/2-p7.p7/2;
id  p6.p7 = p6.p6/2+p7.p7/2-p4.p4/2;

#call ACCU2(AB p1.Q Q.Q p6.Q p1.p6 p1.p1,Rewrite vectors\(2\))

id  p6.Q = p1.Q-Q.Q;
id  p1.p6 = p1.p1-p1.Q;
 
#call ACCU2(AB  p3.Q Q.Q p4.Q p3.p4 p3.p3,Scalars\(2\) 1)

id  p4.Q = p3.Q-Q.Q;
id  p3.p4 = p3.p3-p3.Q;

#call ACCU2(AB p1.Q p1.p1 Q.Q p6.p6,Scalars\(2\) 2)

id  p1.Q = p1.p1/2+Q.Q/2-p6.p6/2;

#call ACCU2(AB p3.Q p3.p3 Q.Q p4.p4,Scalars\(2\) 3)

id  p3.Q = p3.p3/2+Q.Q/2-p4.p4/2;

#call ACCU2(AB p1.p3 p1.p1 p3.p3 p7.p7,Scalars\(2\) 4)

id  p1.p3 = p1.p1/2+p3.p3/2-p7.p7/2;

#call ACCU2(AB p4.p6 p4.p4 p6.p6 p7.p7,Scalars\(2\) 5)

id  p4.p6 = p4.p4/2+p6.p6/2-p7.p7/2;

#call ACCU(Scalars\(2\) 6)

*id p1.p6 = p1.p1/2+p6.p6/2-Q.Q/2;
*id p3.p4 = p3.p3/2+p4.p4/2-Q.Q/2;

*#call ACCU(Scalars\(2\) 7)

#else
 
if ( count(Q.p6,1,p4.p6,1,Q.p4,1,p4.p7,1,p6.p7,1)
   > count(Q.p1,1,Q.p3,1,p1.p3,1,p1.p7,1,p3.p7,1) );
    multiply replace_(p1,p6,p6,p1,p3,p4,p4,p3,mnce1,mnce6,mnce6,mnce1,mnce3,mnce4,mnce4,mnce3);
    id  Q = -Q;
endif;
if ( count(Q.p3,1,p3.p4,1,Q.p4,1,p3.p7,1,p4.p7,1)
   > count(Q.p1,1,Q.p6,1,p1.p6,1,p1.p7,1,p6.p7,1) );
    multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,mnce1,mnce3,mnce3,mnce1,mnce4,mnce6,mnce6,mnce4);
    id  p7 = -p7;
endif;

#call ACCU(Presymmetrize)

id  p7.mncq1?{Q,p1,p3,p4,p6,p7} = p1.mncq1-p3.mncq1;

#call ACCU(Eliminate p7)

id  p6.mncq1?{Q,p1,p3,p4} = p1.mncq1-Q.mncq1;

#call ACCU(Eliminate p6)

id  p4.mncq1?{Q,p1,p3} = p3.mncq1-Q.mncq1;

#call ACCU2(AB p1.Q p1.p1 Q.Q p6.p6,Eliminate p4)

id  p1.Q = p1.p1/2+Q.Q/2-p6.p6/2;

#call ACCU2(AB p3.Q p3.p3 Q.Q p4.p4,Eliminate Q.p1)

id  p3.Q = p3.p3/2+Q.Q/2-p4.p4/2;

#call ACCU2(AB p1.p3 p1.p1 p3.p3 p7.p7,Eliminate Q.p3)

id  p1.p3 = p1.p1/2+p3.p3/2-p7.p7/2;

#call ACCU(Eliminate p1.p3)
#endif
*
*   Now relabel the lines so that we get a uniform orientation.
*   This can be done easily because we have only squares of momenta.
*
if ( count(mnce7,1,mnceq,1) > 0 );
label 2;
  if ( ( ( count(p1.p1,1) > count(p3.p3,1) ) &&
         ( count(p6.p6,1) > count(p3.p3,1) ) ) ||
       ( ( count(p1.p1,1) > count(p4.p4,1) ) &&
         ( count(p6.p6,1) > count(p4.p4,1) ) ) );
    multiply replace_(p1,p3,p3,p1,mnce1,mnce3,mnce3,mnce1,p6,p4,p4,p6,mnce6,mnce4,mnce4,mnce6);
  endif;
  if ( ( count(p1.p1,1) > count(p6.p6,1) ) ||
     ( ( count(p1.p1,1) == count(p6.p6,1) ) &&
       ( count(p3.p3,1) > count(p4.p4,1) ) ) );
    multiply replace_(p1,p6,p6,p1,mnce1,mnce6,mnce6,mnce1,p3,p4,p4,p3,mnce3,mnce4,mnce4,mnce3);
  endif;
else;
  if ( ( count(mnce3,1) > 0 ) || ( count(mnce4,1) > 0 ) );
    multiply replace_(p1,p3,p3,p1,mnce1,mnce3,mnce3,mnce1,p6,p4,p4,p6,mnce6,mnce4,mnce4,mnce6);
  endif;
  if ( count(mnce6,1) > 0 );
    multiply replace_(p1,p6,p6,p1,mnce1,mnce6,mnce6,mnce1,p3,p4,p4,p3,mnce3,mnce4,mnce4,mnce3);
  endif;
  if ( count(mnce1,1) == 0 ) goto 2;
endif;
#call ACCU(Use symmetry\(2\))

multiply acc(1/ep);
#call newtwo(p1,mnce1,p3,mnce3,p4,mnce4,p6,mnce6,p7,mnce7,Q,mnceq,0,mncint1*mncint3)
multiply ep;
if ( count(mnce7,1) );
    if ( count(p1.p1,1) < count(p6.p6,1) )
        multiply replace_(p1,-p6,p6,-p1,p3,-p4,p4,-p3,p7,-p7);
    if ( count(p1.p1,1) < count(p3.p3,1) );
        multiply replace_(p1,-p3,p3,-p1,p6,-p4,p4,-p6,Q,-Q);
        if ( count(p1.p1,1) < count(p6.p6,1) );
            multiply replace_(p1,-p6,p6,-p1,p3,-p4,p4,-p3,p7,-p7);
        endif;
    elseif ( count(p1.p1,1) < count(p4.p4,1) );
        multiply replace_(p1,p4,p4,p1,p3,p6,p6,p3,p7,-p7,Q,-Q);
    endif;
endif;
#call ACCU(Two loop reduction)
if ( count(mncint3,1) );
if ( count(mnce7,1) );
    if ( count(p1.p1,1) < count(p6.p6,1) )
        multiply replace_(p1,-p6,p6,-p1,p3,-p4,p4,-p3,p7,-p7);
    if ( count(p1.p1,1) < count(p3.p3,1) );
        multiply replace_(p1,-p3,p3,-p1,p6,-p4,p4,-p6,Q,-Q);
        if ( count(p1.p1,1) < count(p6.p6,1) );
            multiply replace_(p1,-p6,p6,-p1,p3,-p4,p4,-p3,p7,-p7);
        endif;
    elseif ( count(p1.p1,1) < count(p4.p4,1) );
        multiply replace_(p1,p4,p4,p1,p3,p6,p6,p3,p7,-p7,Q,-Q);
    endif;
    id p1.p1 = Q.Q+p6.p6+2*Q.p6;
    id p1 = Q+p6;
    if ( count(p6.p6,1) >= 0 ) discard;
*   Integrate over (6,7)->4
    multiply replace_(p6,-mncp9,p7,-p8,p4,-p1,p3,-p2,mnce7,mnce8);
    multiply mncnaar(p1,mnce1);
elseif ( count(mnce1,1) );
    if ( count(p7.p7,1) >= 0 );
        id  p7.p7 = p6.p6+p4.p4-2*p4.p6;
        id  p7 = p6-p4;
        if ( count(p6.p6,1) >= 0 ) discard;
        if ( count(p3.p3,1) >= 0 ) discard;
        if ( count(p4.p4,1) >= 0 ) discard;
*       Integrate over (6,1)->Q
        multiply replace_(p6,-mncp9,p1,-p8,mnce1,mnce8,p3,p1,p4,p2);
        multiply mncnaar(Q,mnceq);
    elseif ( count(p3.p3,1) >= 0 );
        id  p3.p3 = Q.Q+p4.p4+2*Q.p4;
        id  p3 = p4+Q;
        if ( count(p4.p4,1) >= 0 ) discard;
*       if ( count(p7.p7,1) >= 0 ) discard;
*       Integrate over (4,7)->6
        multiply replace_(p4,-mncp9,p7,p8,p6,-p1,p1,-p2,mnce1,mnce2);
        multiply mncnaar(p1,mnce1);
    elseif ( count(p4.p4,1) >= 0 );
        id  p4.p4 = p3.p3+Q.Q-2*Q.p3;
        id  p4 = p3-Q;
        if ( count(p3.p3,1) >= 0 ) discard;
        if ( count(p6.p6,1) >= 0 ) discard;
*       if ( count(p7.p7,1) >= 0 ) discard;
*       Integrate over (3,7)->1
*       id p7 = -p7;
        multiply replace_(p3,mncp9,p7,-p8,p6,p2);
        multiply mncnaar(p1,mnce1);
    else;
        id  p6.p6 = p4.p4+p7.p7+2*p4.p7;
        id  p6 = p4+p7;
        if ( count(p4.p4,1) >= 0 ) discard;
        if ( count(p7.p7,1) >= 0 ) discard;
*       Integrate over (7,1)->3
        multiply replace_(p1,-p8,p7,-mncp9,p3,p1,p4,p2,mnce1,mnce8);
        multiply mncnaar(p1,mnce1);
    endif;
else;
*   Here we have no internal fractional power.
*   1: order so that p1.p1 has the highest power (or p7.p7).
    if ( count(p1.p1,1) < count(p6.p6,1) )
        multiply replace_(p1,-p6,p6,-p1,p3,-p4,p4,-p3,p7,-p7);
    if ( count(p1.p1,1) < count(p3.p3,1) );
        multiply replace_(p1,-p3,p3,-p1,p6,-p4,p4,-p6,Q,-Q);
        if ( count(p1.p1,1) < count(p6.p6,1) )
            multiply replace_(p1,-p6,p6,-p1,p3,-p4,p4,-p3,p7,-p7);
    elseif ( count(p1.p1,1) < count(p4.p4,1) );
        multiply replace_(p1,p4,p4,p1,p3,p6,p6,p3,p7,-p7,Q,-Q);
    endif;
    if ( count(p7.p7,1) >= 0 );
        id p7.p7 = p1.p1+p3.p3-2*p1.p3;
        if ( count(p1.p1,1) >= 0 ) discard;
        if ( count(p3.p3,1) >= 0 ) discard;
        if ( count(p1.p1,1) < count(p3.p3,1) )
            multiply replace_(p1,-p3,p3,-p1,p6,-p4,p4,-p6,Q,-Q);
*       Integrate over (1,6)->Q
        multiply replace_(p1,mncp9,p6,p8,p3,p1,p4,p2);
        multiply mncnaar(Q,mnceq);
    else;
*       p1.p1 is missing or positive
        if ( count(p7.p7,1) >= 0 ) discard;
        if ( count(p3.p3,1) >= 0 ) discard;
        id p1.p1 = Q.Q+p6.p6+2*Q.p6;
        if ( count(p6.p6,1) >= 0 ) discard;
*       Integrate over (6,7)->4
        multiply replace_(p6,-mncp9,p7,-p8,p4,-p1,p3,-p2);
        multiply mncnaar(p1,mnce1);
    endif;
endif;
ToTensor,nosquare,mncFQ,mncp9;
endif;

#call ACCU2(B mncnaar p8 mncp9 mnce8 mnce9 mncint3 mncFQ,Prepare second loop)

Keep brackets;
if ( count(mncint3,1) );
if ( count(mncFQ,1) == 0 );
    id  mncint3/mncp9.mncp9^mncx1?/p8.p8^mncx2?*mnce9^mncy1?*mnce8^mncy2? =
        mncq1.mncq1^2/mncq1.mncq1^mncx1/mncq1.mncq1^mncx2*mnce3^mncy1*mnce3^mncy2*mnce3*mncG(mncx1,mncy1,mncx2,mncy2,0,0);
elseif ( match(mncFQ(mnci1?)) );
    id  mncint3/mncp9.mncp9^mncx1?/p8.p8^mncx2?*mnce9^mncy1?*mnce8^mncy2?*mncFQ(mnci1?) =
        mncq1.mncq1^2/mncq1.mncq1^mncx1/mncq1.mncq1^mncx2*mnce3^mncy1*mnce3^mncy2*mnce3*mncG(mncx1,mncy1,mncx2,mncy2,1,0)*mncq1(mnci1);
elseif ( match(mncFQ(mnci1?,mnci2?)) );
    id  mncint3/mncp9.mncp9^mncx1?/p8.p8^mncx2?*mnce9^mncy1?*mnce8^mncy2?*mncFQ(mnci1?,mnci2?) =
        mncq1.mncq1^2/mncq1.mncq1^mncx1/mncq1.mncq1^mncx2*mnce3^mncy1*mnce3^mncy2*mnce3*(
        +mncG(mncx1,mncy1,mncx2,mncy2,2,0)*mncq1(mnci1)*mncq1(mnci2)+mncG(mncx1,mncy1,mncx2,mncy2,2,1)*mncq1.mncq1*d_(mnci1,mnci2)/2);
else;
    id  mncint3/mncp9.mncp9^mncx1?/p8.p8^mncx2?*mnce9^mncy1?*mnce8^mncy2?*mncFQ(?a) =
        mncq1.mncq1^2/mncq1.mncq1^mncx1/mncq1.mncq1^mncx2*mnce3^mncy1*mnce3^mncy2*mnce3
        *sum_(mncj,0,integer_(nargs_(?a)/2),mncG(mncx1,mncy1,mncx2,mncy2,nargs_(?a),mncj)
        *mncy^mncj*mncq1.mncq1^mncj/2^mncj)*mncFQ(?a);
endif;
#call simplify
if ( count(mncFQ,1) );
    id  mncy^mncj?*mncFQ(?a) = distrib_(1,2*mncj,mncdel,mncFQ,?a);
    tovector,mncFQ,mncq1;
    id  mncnaar(mncq2?,mnce4?) = replace_(mncq1,mncq2,mnce3,mnce4);
    id  mncdel(?a) = dd_(?a);
else;
    id  mncnaar(mncq2?,mnce4?) = replace_(mncq1,mncq2,mnce3,mnce4);
endif;
else;
    multiply ep;
endif;

#call ACCU(Second loop)

if ( count(mncint1,1) );
    #call one(p1,p2,Q,mnce1,mnce2,mnceq,mncint1)
endif;

#call ACCU(Third loop)

multiply 1/Q.Q/mnceq^3;
#call simplify

#endprocedure
*--#] dotwo : 
*--#[ dovert1 :
#procedure dovert1(P1,P2,P3)
*
*	P3 = P1+P2
*
id	g_(mnci1?,`P1',`P2',`P3') = g_(mnci1,`P1')*`P3'.`P3'-g_(mnci1,`P3')*`P1'.`P1';
id	g_(mnci1?,`P1',`P3',`P2') = g_(mnci1,`P1')*`P2'.`P2'+g_(mnci1,`P2')*`P1'.`P1';
id	g_(mnci1?,`P2',`P1',`P3') = g_(mnci1,`P2')*`P3'.`P3'-g_(mnci1,`P3')*`P2'.`P2';
id	g_(mnci1?,`P3',`P2',`P1') = g_(mnci1,`P1')*`P3'.`P3'-g_(mnci1,`P3')*`P1'.`P1';
id	g_(mnci1?,`P2',`P3',`P1') = g_(mnci1,`P1')*`P2'.`P2'+g_(mnci1,`P2')*`P1'.`P1';
id	g_(mnci1?,`P3',`P1',`P2') = g_(mnci1,`P2')*`P3'.`P3'-g_(mnci1,`P3')*`P2'.`P2';
*
id	g_(mnci1?,[P+`P1'],`P2',[P+`P3']) =
	g_(mnci1,[P+`P1'])*[P+`P3'].[P+`P3']-g_(mnci1,[P+`P3'])*[P+`P1'].[P+`P1'];
id	g_(mnci1?,[P+`P1'],[P+`P3'],`P2') =
	g_(mnci1,[P+`P1'])*`P2'.`P2'+g_(mnci1,`P2')*[P+`P1'].[P+`P1'];
id	g_(mnci1?,`P2',[P+`P1'],[P+`P3']) =
	g_(mnci1,`P2')*[P+`P3'].[P+`P3']-g_(mnci1,[P+`P3'])*`P2'.`P2';
id	g_(mnci1?,[P+`P3'],`P2',[P+`P1']) =
	g_(mnci1,[P+`P1'])*[P+`P3'].[P+`P3']-g_(mnci1,[P+`P3'])*[P+`P1'].[P+`P1'];
id	g_(mnci1?,`P2',[P+`P3'],[P+`P1']) =
	g_(mnci1,[P+`P1'])*`P2'.`P2'+g_(mnci1,`P2')*[P+`P1'].[P+`P1'];
id	g_(mnci1?,[P+`P3'],[P+`P1'],`P2') =
	g_(mnci1,`P2')*[P+`P3'].[P+`P3']-g_(mnci1,[P+`P3'])*`P2'.`P2';
*
id	g_(mnci1?,`P1',[P+`P2'],[P+`P3']) =
	g_(mnci1,`P1')*[P+`P3'].[P+`P3']-g_(mnci1,[P+`P3'])*`P1'.`P1';
id	g_(mnci1?,`P1',[P+`P3'],[P+`P2']) =
	g_(mnci1,`P1')*[P+`P2'].[P+`P2']+g_(mnci1,[P+`P2'])*`P1'.`P1';
id	g_(mnci1?,[P+`P2'],`P1',[P+`P3']) =
	g_(mnci1,[P+`P2'])*[P+`P3'].[P+`P3']-g_(mnci1,[P+`P3'])*[P+`P2'].[P+`P2'];
id	g_(mnci1?,[P+`P3'],[P+`P2'],`P1') =
	g_(mnci1,`P1')*[P+`P3'].[P+`P3']-g_(mnci1,[P+`P3'])*`P1'.`P1';
id	g_(mnci1?,[P+`P2'],[P+`P3'],`P1') =
	g_(mnci1,`P1')*[P+`P2'].[P+`P2']+g_(mnci1,[P+`P2'])*`P1'.`P1';
id	g_(mnci1?,[P+`P3'],`P1',[P+`P2']) =
	g_(mnci1,[P+`P2'])*[P+`P3'].[P+`P3']-g_(mnci1,[P+`P3'])*[P+`P2'].[P+`P2'];
*
id	g_(mnci1?,[P-`P3'],`P2',[P-`P1']) =
	g_(mnci1,[P-`P3'])*[P-`P1'].[P-`P1']-g_(mnci1,[P-`P1'])*[P-`P3'].[P-`P3'];
id	g_(mnci1?,[P-`P3'],[P-`P1'],`P2') =
	g_(mnci1,[P-`P3'])*`P2'.`P2'+g_(mnci1,`P2')*[P-`P3'].[P-`P3'];
id	g_(mnci1?,`P2',[P-`P3'],[P-`P1']) =
	g_(mnci1,`P2')*[P-`P1'].[P-`P1']-g_(mnci1,[P-`P1'])*`P2'.`P2';
id	g_(mnci1?,[P-`P1'],`P2',[P-`P3']) =
	g_(mnci1,[P-`P3'])*[P-`P1'].[P-`P1']-g_(mnci1,[P-`P1'])*[P-`P3'].[P-`P3'];
id	g_(mnci1?,`P2',[P-`P1'],[P-`P3']) =
	g_(mnci1,[P-`P3'])*`P2'.`P2'+g_(mnci1,`P2')*[P-`P3'].[P-`P3'];
id	g_(mnci1?,[P-`P1'],[P-`P3'],`P2') =
	g_(mnci1,`P2')*[P-`P1'].[P-`P1']-g_(mnci1,[P-`P1'])*`P2'.`P2';
*
id	g_(mnci1?,`P1',[P-`P3'],[P-`P2']) =
	g_(mnci1,`P1')*[P-`P2'].[P-`P2']-g_(mnci1,[P-`P2'])*`P1'.`P1';
id	g_(mnci1?,`P1',[P-`P2'],[P-`P3']) =
	g_(mnci1,`P1')*[P-`P3'].[P-`P3']+g_(mnci1,[P-`P3'])*`P1'.`P1';
id	g_(mnci1?,[P-`P3'],`P1',[P-`P2']) =
	g_(mnci1,[P-`P3'])*[P-`P2'].[P-`P2']-g_(mnci1,[P-`P2'])*[P-`P3'].[P-`P3'];
id	g_(mnci1?,[P-`P2'],[P-`P3'],`P1') =
	g_(mnci1,`P1')*[P-`P2'].[P-`P2']-g_(mnci1,[P-`P2'])*`P1'.`P1';
id	g_(mnci1?,[P-`P3'],[P-`P2'],`P1') =
	g_(mnci1,`P1')*[P-`P3'].[P-`P3']+g_(mnci1,[P-`P3'])*`P1'.`P1';
id	g_(mnci1?,[P-`P2'],`P1',[P-`P3']) =
	g_(mnci1,[P-`P3'])*[P-`P2'].[P-`P2']-g_(mnci1,[P-`P2'])*[P-`P3'].[P-`P3'];
*
id	g_(mnci1?,`P3',[P-`P2'],[P+`P1']) =
	g_(mnci1,`P3')*[P+`P1'].[P+`P1']-g_(mnci1,[P+`P1'])*`P3'.`P3';
id	g_(mnci1?,`P3',[P+`P1'],[P-`P2']) =
	g_(mnci1,`P3')*[P-`P2'].[P-`P2']+g_(mnci1,[P-`P2'])*`P3'.`P3';
id	g_(mnci1?,[P-`P2'],`P3',[P+`P1']) =
	g_(mnci1,[P-`P2'])*[P+`P1'].[P+`P1']-g_(mnci1,[P+`P1'])*[P-`P2'].[P-`P2'];
id	g_(mnci1?,[P+`P1'],[P-`P2'],`P3') =
	g_(mnci1,`P3')*[P+`P1'].[P+`P1']-g_(mnci1,[P+`P1'])*`P3'.`P3';
id	g_(mnci1?,[P-`P2'],[P+`P1'],`P3') =
	g_(mnci1,`P3')*[P-`P2'].[P-`P2']+g_(mnci1,[P-`P2'])*`P3'.`P3';
id	g_(mnci1?,[P+`P1'],`P3',[P-`P2']) =
	g_(mnci1,[P-`P2'])*[P+`P1'].[P+`P1']-g_(mnci1,[P+`P1'])*[P-`P2'].[P-`P2'];
*
id	g_(mnci1?,[P-`P1'],`P3',[P+`P2']) =
	g_(mnci1,[P-`P1'])*[P+`P2'].[P+`P2']-g_(mnci1,[P+`P2'])*[P-`P1'].[P-`P1'];
id	g_(mnci1?,[P-`P1'],[P+`P2'],`P3') =
	g_(mnci1,[P-`P1'])*`P3'.`P3'+g_(mnci1,`P3')*[P-`P1'].[P-`P1'];
id	g_(mnci1?,`P3',[P-`P1'],[P+`P2']) =
	g_(mnci1,`P3')*[P+`P2'].[P+`P2']-g_(mnci1,[P+`P2'])*`P3'.`P3';
id	g_(mnci1?,[P+`P2'],`P3',[P-`P1']) =
	g_(mnci1,[P-`P1'])*[P+`P2'].[P+`P2']-g_(mnci1,[P+`P2'])*[P-`P1'].[P-`P1'];
id	g_(mnci1?,`P3',[P+`P2'],[P-`P1']) =
	g_(mnci1,[P-`P1'])*`P3'.`P3'+g_(mnci1,`P3')*[P-`P1'].[P-`P1'];
id	g_(mnci1?,[P+`P2'],[P-`P1'],`P3') =
	g_(mnci1,`P3')*[P+`P2'].[P+`P2']-g_(mnci1,[P+`P2'])*`P3'.`P3';
*
#endprocedure
*--#] dovert1 : 
*--#[ dovert2 :
#procedure dovert2(P1,P2,P3)
*
*	P1 + P2 + P3 = 0
*
id	g_(mnci1?,`P3',`P2',`P1') = -g_(mnci1,`P3')*`P1'.`P1'-g_(mnci1,`P1')*`P3'.`P3';
id	g_(mnci1?,`P3',`P1',`P2') = -g_(mnci1,`P3')*`P2'.`P2'-g_(mnci1,`P2')*`P3'.`P3';
id	g_(mnci1?,`P2',`P3',`P1') = -g_(mnci1,`P2')*`P1'.`P1'-g_(mnci1,`P1')*`P2'.`P2';
id	g_(mnci1?,`P1',`P2',`P3') = -g_(mnci1,`P3')*`P1'.`P1'-g_(mnci1,`P1')*`P3'.`P3';
id	g_(mnci1?,`P2',`P1',`P3') = -g_(mnci1,`P3')*`P2'.`P2'-g_(mnci1,`P2')*`P3'.`P3';
id	g_(mnci1?,`P1',`P3',`P2') = -g_(mnci1,`P2')*`P1'.`P1'-g_(mnci1,`P1')*`P2'.`P2';
*
#endprocedure
*--#] dovert2 : 
*--#[ expandP :
*
#procedure expandP(topo,power)
*
*	Expands the denominators in P.
*
id	1/P.Q = 1/Q.Q/mncproexp;
#do mnci = 1,8
id	1/P.p`mnci' = 1/P.p`mnci'/mncproexp;
#enddo
id  P = mncproexp*P;
if ( count(mncproexp,1) > `power' ) discard;

id	mncepexp(mncp?mncpp18[mncn],mncx?) = mncee18[mncn]^mncx/mnceq^mncx;
id	mncepexp(-mncp?mncpp18[mncn],mncx?) = mncee18[mncn]^mncx/mnceq^mncx;
id	mncepexp(-mncp?[mncPp],mncx?) = mncepexp(mncp,mncx);

id  mncepexp([P+Q],mncx?) = mncepexp( mncproexp*2*P.Q/Q.Q,mncx);
id  mncepexp([P-Q],mncx?) = mncepexp(-mncproexp*2*P.Q/Q.Q,mncx);
id  mncepexp(mncp?[mncpp18][D],mncx?)  = mncee18[D]^mncx/mnceq^mncx
    *mncepexp( 2*mncproexp*P.mncpp18[D]/mncpp18[D].mncpp18[D],mncx);
id  mncepexp(mncp?[-mncpp18][D],mncx?) = mncee18[D]^mncx/mnceq^mncx
    *mncepexp(-2*mncproexp*P.mncpp18[D]/mncpp18[D].mncpp18[D],mncx);

#do mnci = 1,8
if ( count([P+p`mnci'].[P+p`mnci'],1) < 0 );
    repeat;
      id,once,mncproexp^mncx?/[P+p`mnci'].[P+p`mnci'] = (
        sum_(mncj,0,`power'-mncx,2^mncj*mncproexp^mncj*P.p`mnci'^mncj/
			p`mnci'.p`mnci'^mncj*sign_(mncj)))*mncproexp^mncx/p`mnci'.p`mnci';
    endrepeat;
endif;
if ( count([P-p`mnci'].[P-p`mnci'],1) < 0 );
    repeat;
      id,once,mncproexp^mncx?/[P-p`mnci'].[P-p`mnci'] = (
        sum_(mncj,0,`power'-mncx,2^mncj*mncproexp^mncj*P.p`mnci'^mncj/
			p`mnci'.p`mnci'^mncj))*mncproexp^mncx/p`mnci'.p`mnci';
    endrepeat;
endif;
#enddo
if ( count([P+Q].[P+Q],1) < 0 );
    repeat;
      id,once,mncproexp^mncx?/[P+Q].[P+Q] =
        (sum_(mncj,0,`power'-mncx,2^mncj*mncproexp^mncj*P.Q^mncj/
			Q.Q^mncj*sign_(mncj)))*mncproexp^mncx/Q.Q;
	endrepeat;
endif;
if ( count([P-Q].[P-Q],1) < 0 );
    repeat;
      id,once,mncproexp^mncx?/[P-Q].[P-Q] =
        (sum_(mncj,0,`power'-mncx,2^mncj*mncproexp^mncj*P.Q^mncj/Q.Q^mncj))
				*mncproexp^mncx/Q.Q;
    endrepeat;
endif;

repeat;
    id,once,mncproexp^mncx?*mncepexp(y?,D?) =
    sump_(mncj,0,`power'-mncx, y*acc((-D*ep-mncj+1)/mncj))*mncproexp^mncx;
    if ( count(P.P,1) > 0 ) discard;
    if ( count(mncproexp,1) > `power' ) discard;
endrepeat;
if ( count(mncproexp,1) != `power' ) discard;
id  mncproexp^`power' = 1;

#call ACCU(Expand in P)
#endprocedure
*
*--#] expandP : 
*--#[ finish :
#procedure finish(LOOPS,SCHEME)
*
id  ep = 0;
*
*   Substitute the integrals.
*
id  mncexp20*mncexp10 = 1
       + ep * ( 3 )
       + ep^2 * ( 13 )
       + ep^3 * ( 55 - 22*z3 )
       + ep^4 * ( 229 - 66*z3 - 33*z4 )
       + ep^5 * ( 943 - 286*z3 - 99*z4 - 234*z5 )
       + ep^6 * ( 3853 - 1210*z3 + 242*z3^2 - 429*z4 - 702*z5 - 530*z6 );
id  mncexp11 = 1
       + ep * ( 2 )
       + ep^2 * ( 8 )
       + ep^3 * ( 32 - 22*z3 )
       + ep^4 * ( 128 - 44*z3 - 33*z4 )
       + ep^5 * ( 512 - 176*z3 - 66*z4 - 234*z5 )
       + ep^6 * ( 2048 - 704*z3 + 242*z3^2 - 264*z4 - 468*z5 - 530*z6 );
id  mncexp20 = 1
       + ep * ( 2 )
       + ep^2 * ( 8 )
       + ep^3 * ( 32 - 16*z3 )
       + ep^4 * ( 128 - 32*z3 - 24*z4 )
       + ep^5 * ( 512 - 128*z3 - 48*z4 - 192*z5 )
       + ep^6 * ( 2048 - 512*z3 + 128*z3^2 - 192*z4 - 384*z5 - 440*z6 );
id  mncexp10 = 1
       + ep * ( 1 )
       + ep^2 * ( 3 )
       + ep^3 * ( 9 - 6*z3 )
       + ep^4 * ( 27 - 6*z3 - 9*z4 )
       + ep^5 * ( 81 - 18*z3 - 9*z4 - 42*z5 )
       + ep^6 * ( 243 - 54*z3 + 18*z3^2 - 27*z4 - 42*z5 - 90*z6 );
*
*   Note that in Gorishny,Larin,Surguladze and Tkachov Comp.Phys.Comm.
*   55(1989)381 the factor (1-2*ep) is erroneously absent in the
*   following integral:
*
id  mncG311 = (1-2*ep)*(6*z3+9*z4*ep+102*z5*ep^2);
*id  mncG311 = (1-2*ep)*(6*z3+9*z4*ep+102*z5*ep^2+240*z6*ep^3-186*ep^3*z3^2);
*
id  mncF321 = 20*z5;
*id  mncF321 = (20*z5+50*z6*ep+68*z3^2*ep)*(1+2*ep);
*id  mncF321 = (20*z5+50*z6*ep+68*z3^2*ep+450*z7*ep^2+204*z3*z4*ep^2)*(1+2*ep+4*ep^2);
*
*   Now follow some convenient integrals.
*
*
*	The three loop fermion propagator
*
id	mncfermi3 =ep^3*(
    +cf*ca*nf*(+260075/1296-1/6*ep^-3*mncxi+1/6*ep^-3-13/12*ep^-2*mncxi
        +227/36*ep^-2+2*ep^-1*z3*mncxi-6*ep^-1*z3-155/24*ep^-1*mncxi
        +8267/216*ep^-1+61/6*z3*mncxi-137/6*z3+3*z4*mncxi-9*z4-4483/144*mncxi)
    +cf*ca^2*(-2008997/2592+55/24*ep^-3*mncxi-5/8*ep^-3*mncxi^2+1/12*ep^-3*mncxi^3
        -7/4*ep^-3+623/48*ep^-2*mncxi-49/16*ep^-2*mncxi^2+3/8*ep^-2*mncxi^3
        -1841/72*ep^-2-18*ep^-1*z3*mncxi+11/8*ep^-1*z3*mncxi^2+83/2*ep^-1*z3
        +6869/96*ep^-1*mncxi-497/32*ep^-1*mncxi^2+89/48*ep^-1*mncxi^3
        -66629/432*ep^-1-2917/24*z3*mncxi+23*z3*mncxi^2-29/12*z3*mncxi^3+1015/4*z3
        -27*z4*mncxi+33/16*z4*mncxi^2+249/4*z4+5*z5*mncxi-5/4*z5*mncxi^2-45*z5
        +189061/576*mncxi-4403/64*mncxi^2+49/6*mncxi^3)
    +cf*nf^2*(-1108/81-4/9*ep^-2-68/27*ep^-1)
    +cf^2*ca*(-1199/16+9/4*ep^-3*mncxi-3/2*ep^-3*mncxi^2+1/4*ep^-3*mncxi^3-ep^-3
        +49/4*ep^-2*mncxi-47/8*ep^-2*mncxi^2+7/8*ep^-2*mncxi^3-43/12*ep^-2
        -9*ep^-1*z3*mncxi+3*ep^-1*z3*mncxi^2+2*ep^-1*z3+365/8*ep^-1*mncxi
        -81/4*ep^-1*mncxi^2+11/4*ep^-1*mncxi^3-93/8*ep^-1-101/4*z3*mncxi
        +3/2*z3*mncxi^2+3/4*z3*mncxi^3+23*z3-27/2*z4*mncxi+9/2*z4*mncxi^2+3*z4
        +20*z5*mncxi+2147/16*mncxi-217/4*mncxi^2+27/4*mncxi^3)
    +cf^2*nf*(+163/8-1/2*ep^-2*mncxi-1/6*ep^-2-9/4*ep^-1*mncxi+11/12*ep^-1
        -16*z3-67/8*mncxi)
    +cf^3*(+79/48+1/2*ep^-3*mncxi-1/2*ep^-3*mncxi^2+1/6*ep^-3*mncxi^3-1/6*ep^-3
        +3/4*ep^-2*mncxi-3/2*ep^-2*mncxi^2+1/2*ep^-2*mncxi^3+1/4*ep^-2+13/8*ep^-1*mncxi
        -3*ep^-1*mncxi^2+ep^-1*mncxi^3-1/8*ep^-1-5/2*z3*mncxi-7/2*z3*mncxi^2
        +7/6*z3*mncxi^3+29/6*z3+103/16*mncxi-3*mncxi^2+mncxi^3))
	+2*mncfermi2*mncfermi1-mncfermi1^3;
*
*   The two loop fermion propagator
*
id  mncfermi2 =
    +cf*ca*(-1+5/4*mncxi-1/4*mncxi^2-25/4*ep+15/4*ep*mncxi-5/8*ep*mncxi^2
        -175/8*ep^2+55/4*ep^2*mncxi-17/8*ep^2*mncxi^2+6*ep^2*z3-3*ep^2*z3*mncxi
        -1165/16*ep^3+175/4*ep^3*mncxi-53/8*ep^3*mncxi^2
        +50/3*ep^3*z3-49/3*ep^3*z3*mncxi+8/3*ep^3*z3*mncxi^2
        +9*ep^3*z4-9/2*ep^3*z4*mncxi)
    +cf*nf*(+1/2*ep+7/4*ep^2+53/8*ep^3)
    +cf^2*(+1/2-mncxi+1/2*mncxi^2+7/4*ep-2*ep*mncxi+ep*mncxi^2+29/8*ep^2-6*ep^2*mncxi
        +3*ep^2*mncxi^2+79/16*ep^3-18*ep^3*mncxi+9*ep^3*mncxi^2+2/3*ep^3*z3
        +32/3*ep^3*z3*mncxi-16/3*ep^3*z3*mncxi^2);
*
*   The one loop fermion propagator in QCD (times ep)
*
id  mncfermi1 =
    cf*(mncxi-1)*(1+ep+2*ep^2-7/3*ep^3*z3+4*ep^3);
*
*   The two loop ghost propagator
*
id  mncghost2 =
    +ca*nf*(-1/4-7/8*ep-53/16*ep^2-351/32*ep^3+8/3*ep^3*z3)
    +ca^2*(+5/4+7/16*mncxi-1/32*mncxi^2+83/16*ep+7/32*ep*mncxi
        +599/32*ep^2-9/64*ep^2*mncxi+3/8*ep^2*mncxi^2-3/4*ep^2*z3-3/16*ep^2*z3*mncxi^2
        +3881/64*ep^3-383/128*ep^3*mncxi+17/8*ep^3*mncxi^2
        -40/3*ep^3*z3-85/24*ep^3*z3*mncxi-29/48*ep^3*z3*mncxi^2
        -9/8*ep^3*z4-9/32*ep^3*z4*mncxi^2);
*
*   The one loop ghost propagator (times ep)
*
id  mncghost1 =
    ca*(1/2+1/4*mncxi+ep+2*ep^2-7/12*ep^3*z3*mncxi-7/6*ep^3*z3+4*ep^3);
*
*	The three loop gluon propagator
*
id	mncgluon3 = ep^3*(
  + cf*ca*nf*(-416699/648-1/2*ep^-2*mncxi-131/18*ep^-2+4*ep^-1*z3
    *mncxi+68*ep^-1*z3-49/12*ep^-1*mncxi-9551/108*ep^-1+26/3*z3*mncxi+
    358*z3+6*z4*mncxi+102*z4+40*z5-1309/72*mncxi)
  + cf*nf^2*(11536/81+16/9*ep^-2-16*ep^-1*z3+566/27*ep^-1-256/
    3*z3-24*z4)
  + cf^2*nf*(143/9+1/3*ep^-1+148/3*z3-80*z5)
  + ca*nf^2*(475477/1944+2/9*ep^-3*mncxi+31/9*ep^-3+14/27*ep^-2*mncxi
    +1021/54*ep^-2+8*ep^-1*z3+22/27*ep^-1*mncxi+8003/108*ep^-1-26/
    3*z3*mncxi-5/3*z3+12*z4+586/243*mncxi)
  + ca^2*nf*(-3265189/2592-73/36*ep^-3*mncxi-155/12*ep^-3-947/216
    *ep^-2*mncxi-1/24*ep^-2*mncxi^2-16451/216*ep^-2+2/3*ep^-1*z3*mncxi-89/
    3*ep^-1*z3-2299/432*ep^-1*mncxi-121/144*ep^-1*mncxi^2-144949/432*
    ep^-1+2735/36*z3*mncxi+13/12*z3*mncxi^2+1913/36*z3+z4*mncxi-89/2*z4
    +80/3*z5+14435/7776*mncxi-5503/864*mncxi^2)
  + ca^3*(99584761/46656+665/144*ep^-3*mncxi+3325/216*ep^-3+5455/
    864*ep^-2*mncxi+37/24*ep^-2*mncxi^2-47/96*ep^-2*mncxi^3+1/16*ep^-2*mncxi^4
    +14017/144*ep^-2-379/24*ep^-1*z3*mncxi-1/16*ep^-1*z3*mncxi^2-77/6*
    ep^-1*z3-1519/192*ep^-1*mncxi+281/18*ep^-1*mncxi^2-757/192*ep^-1*mncxi^3
    +15/32*ep^-1*mncxi^4+1266119/2592*ep^-1-23483/144*z3*mncxi-247/24*
    z3*mncxi^2+59/32*z3*mncxi^3-13/96*z3*mncxi^4-73711/216*z3-379/16*z4*mncxi
    -3/32*z4*mncxi^2-77/4*z4+505/24*z5*mncxi-55/24*z5*mncxi^2-15/16*z5*
    mncxi^3+35/192*z5*mncxi^4-655/12*z5-4628509/31104*mncxi+178133/1728*
    mncxi^2-8873/384*mncxi^3+493/192*mncxi^4)
  + nf^3*(-11656/729-8/27*ep^-3-40/27*ep^-2-424/81*ep^-1+56/
    27*z3) );
*
*   The two loop gluon propagator
*
id  mncgluon2 =
    +nf^2*(+4/9+40/27*ep+4*ep^2+2432/243*ep^3-56/27*ep^3*z3)
    +cf*nf*(-ep-55/6*ep^2+8*z3*ep^2-1711/36*ep^3+76/3*ep^3*z3+12*ep^3*z4)
    +ca*nf*(-55/18-1/3*mncxi-1199/108*ep-2/9*ep*mncxi-2371/72*ep^2
        +5/27*ep^2*mncxi-4*ep^2*z3-337315/3888*ep^3+37/81*ep^3*mncxi
        +286/27*ep^3*z3+50/9*ep^3*z3*mncxi-6*ep^3*z4)
    +ca^2*(+175/36+35/24*mncxi+4229/216*ep-97/144*ep*mncxi+5/8*ep*mncxi^2
        -1/8*ep*mncxi^3+9821/144*ep^2-6121/864*ep^2*mncxi+27/8*ep^2*mncxi^2
        -9/16*ep^2*mncxi^3-ep^2*z3-2*ep^2*z3*mncxi+1659373/7776*ep^3
        -165073/5184*ep^3*mncxi+113/8*ep^3*mncxi^2-33/16*ep^3*mncxi^3
        -1184/27*ep^3*z3-134/9*ep^3*z3*mncxi-3/2*ep^3*z3*mncxi^2
        -3/2*ep^3*z4-3*ep^3*z4*mncxi);
*
*   The one loop gluon propagator
*
id  mncgluon1 =
    +ca*(5/3+mncxi/2-ep*mncxi+ep*mncxi^2/4+31/9*ep-2*ep^2*mncxi+ep^2*mncxi^2/2+188/27*ep^2
        -7/6*ep^3*z3*mncxi-35/9*ep^3*z3-4*ep^3*mncxi+ep^3*mncxi^2+1132/81*ep^3)
    +nf*(-2/3-10/9*ep-56/27*ep^2+14/9*ep^3*z3-328/81*ep^3);

id  ep = 0;
*
.sort: Sub integrals;
*
*   The next factor is the conversion to MS-bar. Because there are three
*   loops we need the factor (1/(1-2*ep)-7/3*ep^3*z3+...)^3
*   We have multiplied it out here.
*   Note also that somehow the original Mincer program has a different
*   normalization for mncG311, using effectively only two powers.
*   For the comparison we have corrected that in subint.prc
*   This may have to be changed as it isn't clear to me why this has
*   been done! (But the factor 1-2*ep was needed to get the answer to
*   come out right)
*
#if `SCHEME' == 0
*
*   This is MS-bar
*
#message Answer in MS-bar
#if `LOOPS' == 0
#else
#if `LOOPS' == 1
multiply,1+2*ep+4*ep^2+8*ep^3-7/3*ep^3*z3;
#else
#if `LOOPS' == 2
multiply,1+4*ep+12*ep^2+32*ep^3-14/3*ep^3*z3;
#else
#if `LOOPS' == 3
multiply,1+6*ep+24*ep^2+80*ep^3-7*ep^3*z3;
#else
#message Illegal number of loops specified: 'LOOPS'
#message Answer will be in the G-scheme anyway
#endif
#endif
#endif
#endif
#else
#if ( `SCHEME' != 1 )
#message Invalid value `SCHEME' for output corrected to G-scheme
#else
#message Answer in the G-scheme
#endif
#endif
id  ep = 0;
#endprocedure
*--#] finish : 
*--#[ gtreat :
#procedure gtreat(POWER)
Multiply d_(MU,NU)/Q.Q;
sum mu,mu1,nu,nu1,MU,NU,ga1,ga2,ro,ro1,si,si1,ka,ka1,la,la1;

id	mncVv(mnci1?,p1?,mnci2?,p2?) = p1(11)*p2(mnci2)-p1(mnci2)*p2(mnci1);
*print +f +s;
.sort
id Glonel(mu?,ro?,Q?,p1?,p2?)  =
   (-1)*nf/2
  *mncSS(mu,p1,ro,-p2)
   +1/2*ca
  *mncV3G(mu,Q,ga4,-p2,ga2,-p1)*mncV3G(ro,-Q,ga3,p1,ga5,p2)
  *mncDg(ga4,ga5,p2)*mncDg(ga2,ga3,p1)
   +(-1)*ca
  *mncVgh(p1,ro)*(-mncVgh(p2,mu))*mncDs(p1)*mncDs(p2);
.sort
repeat;
	id	mncS(mnci1?index_,?a) = g_(1,mnci1)*mncS(?a);
	id	mncS(mncp?,?a)     = g_(1,mncp) *mncS(?a)*mncpropxp(mncp);
endrepeat;
id	mncS = 1;
repeat;
	id	mncSS(mnci1?index_,?a) = g_(2,mnci1)*mncSS(?a);
	id	mncSS(mncp?,?a)     = g_(2,mncp) *mncSS(?a)*mncpropxp(mncp);
endrepeat;
id	mncSS = 1;
repeat;
	id	mncSSS(mnci1?index_,?a) = g_(3,mnci1)*mncSSS(?a);
	id	mncSSS(mncp?,?a)     = g_(3,mncp) *mncSSS(?a)*mncpropxp(mncp);
endrepeat;
id	mncSSS = 1;
id	mncVgh(mncp?,mu?) = mncp(mu);
id	mncDs(mncp?) = mncpropxp(mncp);
id	mncDL(mnci1?,mnci2?,mncp?) = (d_(mnci1,mnci2)-mncp(mnci1)*mncp(mnci2)*mncpropxp(mncp))*mncpropxp(mncp);

#call vertsub
#call ACCU(Vertex substitutions)
id	mncpropxp(mncp?) = 1/mncp.mncp;

*#call reduceto(`TOPO')
*id	g_(1,P,Q,[P+Q]) = [P+Q].[P+Q]*g_(1,P);

#call sym1(`TOPO')
id	P.P = 0;
id D = acc(4-2*ep);

#call ACCU(Vertex identities)

*tracen,3;
*tracen,2;
*tracen,1;
*id	P.P = 0;
*id D = acc(4-2*ep);
*id [D-4] = acc(-2*ep);
*id [1-ep/2] = acc(1-ep/2);

*#call ACCU(Traces)

#do mnci = 1,8
id	[P+p`mnci'] = P+p`mnci';
id	[P-p`mnci'] = P-p`mnci';
#enddo
id	[P+Q] = P+Q;
id	[P-Q] = P-Q;
id	P.P = 0;
#call ACCU(Introduce P)
#call momsubs(`TOPO')
#call ACCU(moms)
id	P = mncproexp*P;
if ( count(mncproexp,1) > `POWER' ) discard;
#do mnci = 1,8
repeat id,once,mncproexp^mncx?/[P+p`mnci'].[P+p`mnci'] =
	sump_(mncj,0,`POWER'-mncx,-2*mncproexp*P.p`mnci'/p`mnci'.p`mnci')*mncproexp^mncx/p`mnci'.p`mnci';
repeat id,once,mncproexp^mncx?/[P-p`mnci'].[P-p`mnci'] =
	sump_(mncj,0,`POWER'-mncx, 2*mncproexp*P.p`mnci'/p`mnci'.p`mnci')*mncproexp^mncx/p`mnci'.p`mnci';
#enddo
repeat id,once,mncproexp^mncx?/[P-Q].[P-Q] =
	sump_(mncj,0,`POWER'-mncx, 2*mncproexp*P.Q/Q.Q)*mncproexp^mncx/Q.Q;
repeat id,once,mncproexp^mncx?/[P+Q].[P+Q] =
	sump_(mncj,0,`POWER'-mncx,-2*mncproexp*P.Q/Q.Q)*mncproexp^mncx/Q.Q;
if ( count(mncproexp,1) != `POWER' ) discard;
id	mncproexp^`POWER' = 1;

#call ACCU(Expand in P)
#call momsubs(`TOPO')
#call sym2(`TOPO')
#call ACCU(moms)
#call harmo(P,Q,mncFFPP)
#call ACCU(Harmonics)
#endprocedure
*--#] gtreat : 
*--#[ harmo :
#procedure harmo(P,Q,TT)
*
*   Routine to generate the harmonic projection for
*   P(mnci1)*P(mnci2)*...*P(in) = TT(mnci1,mnci2,...,in) at P->Q
*   The object mnchfac is a table to give better speed.
*
id  `P'.`P' = 0;
id  `Q'.`P' = `Q'.`Q';
ToTensor,nosquare,`TT',`P';
*
*   Next generate the splits between indices that connect to a Q and
*   the indices that go to d_.
*
id  `TT'(?a) = sum_(mncj,0,nargs_(?a),2,`Q'.`Q'^(mncj/2)*
               acc(mnchfac(nargs_(?a),mncj))*distrib_(1,mncj,mncdd,`TT',?a));
*
*   The indices in TT contract with Q and the indices in mncdd go to d_'mncs.
*	We used mncdd as an intemediary to have the mnchfac worked out before
*	the dd_ is expanded. At that moment there are fewer terms. 
*
tovector,`TT',`Q';
id  mncdd(?a) = dd_(?a);
id  D = acc(4-2*ep);
*
#endprocedure
*
*	Table is good up to D12 or P10.
*	We have only terms up to ep^3 as the integrals at this point can have
*	divergences up to ep^-3 only.
*
CTable,relax,mnchfac(0:12,0:12);
Fill mnchfac(0,0) = 1;
Fill mnchfac(1,0) = 1;
Fill mnchfac(2,0) = 4/3 + 2/9*ep + 4/27*ep^2 + 8/81*ep^3;
Fill mnchfac(2,2) = - 1/3 - 2/9*ep - 4/27*ep^2 - 8/81*ep^3;
Fill mnchfac(3,0) = 2 + 2/3*ep + 4/9*ep^2 + 8/27*ep^3;
Fill mnchfac(3,2) = - 1/3 - 2/9*ep - 4/27*ep^2 - 8/81*ep^3;
Fill mnchfac(4,0) = 16/5 + 116/75*ep + 1196/1125*ep^2 + 12176/16875*ep^3;
Fill mnchfac(4,2) = - 2/5 - 22/75*ep - 232/1125*ep^2 - 2392/16875*ep^3;
Fill mnchfac(4,4) = 1/15 + 16/225*ep + 196/3375*ep^2 + 2176/50625*ep^3;
Fill mnchfac(5,0) = 16/3 + 148/45*ep + 1588/675*ep^2 + 16528/10125*ep^3;
Fill mnchfac(5,2) = - 8/15 - 98/225*ep - 1088/3375*ep^2 - 11528/50625*ep^3;
Fill mnchfac(5,4) = 1/15 + 16/225*ep + 196/3375*ep^2 + 2176/50625*ep^3;
Fill mnchfac(6,0) = 64/7 + 1648/245*ep + 129016/25725*ep^2 + 9613672/2701125*ep^3;
Fill mnchfac(6,2) =
       - 16/21 - 1516/2205*ep - 123292/231525*ep^2 - 9367864/24310125*ep^3;
Fill mnchfac(6,4) =
      8/105 + 926/11025*ep + 81092/1157625*ep^2 + 6386864/121550625*ep^3;
Fill mnchfac(6,6) =
       - 1/105 - 142/11025*ep - 13864/1157625*ep^2 - 1162288/121550625*ep^3;
Fill mnchfac(7,0) = 16 + 472/35*ep + 38464/3675*ep^2 + 2929288/385875*ep^3;
Fill mnchfac(7,2) = - 8/7 - 276/245*ep - 23372/25725*ep^2 - 1815224/2701125*ep^3;
Fill mnchfac(7,4) = 2/21 + 242/2205*ep + 21764/231525*ep^2 + 1742288/24310125*ep^3;
Fill mnchfac(7,6) =
       - 1/105 - 142/11025*ep - 13864/1157625*ep^2 - 1162288/121550625*ep^3;
Fill mnchfac(8,0) =
      256/9 + 75808/2835*ep + 19246768/893025*ep^2 + 4489358368/281302875*ep^3;
Fill mnchfac(8,2) =
       - 16/9 - 5368/2835*ep - 1414288/893025*ep^2 - 336272488/281302875*ep^3;
Fill mnchfac(8,4) =
      8/63 + 3044/19845*ep + 844124/6251175*ep^2 + 206121824/1969120125*ep^3;
Fill mnchfac(8,6) =
       - 2/189 - 866/59535*ep - 256496/18753525*ep^2 - 64996496/5907360375*
      ep^3;
Fill mnchfac(8,8) =
      1/945 + 496/297675*ep + 159496/93767625*ep^2 + 42546496/29536801875*ep^3;
Fill mnchfac(9,0) =
      256/5 + 82976/1575*ep + 21820976/496125*ep^2 + 5190442976/156279375*ep^3;
Fill mnchfac(9,2) =
       - 128/45 - 45968/14175*ep - 12519368/4465125*ep^2 - 3033399368/
      1406514375*ep^3;
Fill mnchfac(9,4) =
      8/45 + 3188/14175*ep + 907988/4465125*ep^2 + 225339488/1406514375*ep^3;
Fill mnchfac(9,6) =
       - 4/315 - 1774/99225*ep - 533824/31255875*ep^2 - 136691824/9845600625*
      ep^3;
Fill mnchfac(9,8) =
      1/945 + 496/297675*ep + 159496/93767625*ep^2 + 42546496/29536801875*ep^3;
Fill mnchfac(10,0) =
      1024/11 + 3941248/38115*ep + 11779286528/132068475*ep^2 + 31395360315808/
      457617265875*ep^3;
Fill mnchfac(10,2) =
       - 256/55 - 1074016/190575*ep - 3316968176/660342375*ep^2 - 
      8998169551936/2288086329375*ep^3;
Fill mnchfac(10,4) =
      128/495 + 586288/1715175*ep + 1884204968/5943081375*ep^2 + 5224503688648/
      20592776964375*ep^3;
Fill mnchfac(10,6) =
       - 8/495 - 40108/1715175*ep - 135134588/5943081375*ep^2 - 385061648968/
      20592776964375*ep^3;
Fill mnchfac(10,8) =
      4/3465 + 22034/12006225*ep + 78474124/41601569625*ep^2 + 231375515864/
      144149438750625*ep^3;
Fill mnchfac(10,10) =
       - 1/10395 - 6086/36018675*ep - 23133196/124804708875*ep^2 - 71203299656/
      432448316251875*ep^3;
Fill mnchfac(11,0) =
      512/3 + 2105024/10395*ep + 6484548064/36018675*ep^2 + 17587269036704/
      124804708875*ep^3;
Fill mnchfac(11,2) =
       - 256/33 - 1133152/114345*ep - 3599216912/396205425*ep^2 - 
      9927387845632/1372851797625*ep^3;
Fill mnchfac(11,4) =
      64/165 + 305464/571725*ep + 1005647504/1981027125*ep^2 + 2830303821544/
      6864258988125*ep^3;
Fill mnchfac(11,6) =
       - 32/1485 - 165052/5145525*ep - 566368772/17829244125*ep^2 - 
      1633203887992/61778330893125*ep^3;
Fill mnchfac(11,8) =
      2/1485 + 11182/5145525*ep + 40241252/17829244125*ep^2 + 119504735272/
      61778330893125*ep^3;
Fill mnchfac(11,10) =
       - 1/10395 - 6086/36018675*ep - 23133196/124804708875*ep^2 - 71203299656/
      432448316251875*ep^3;
Fill mnchfac(12,0) =
      4096/13 + 231932416/585585*ep + 9552620306048/26377676325*ep^2 + 
      342403963966857664/1188182430059625*ep^3;
Fill mnchfac(12,2) =
       - 512/39 - 30913472/1756755*ep - 1310118983776/79133028975*ep^2 - 
      47718354631206368/3564547290178875*ep^3;
Fill mnchfac(12,4) =
      256/429 + 16505056/19324305*ep + 722647696208/870463318725*ep^2 + 
      26818419631574944/39210020191967625*ep^3;
Fill mnchfac(12,6) =
       - 64/2145 - 4414552/96621525*ep - 200547273536/4352316593625*ep^2 - 
      7607970101536648/196050100959838125*ep^3;
Fill mnchfac(12,8) =
      32/19305 + 2367436/869593725*ep + 112122653948/39170849342625*ep^2 + 
      4365158933778064/1764450908638543125*ep^3;
Fill mnchfac(12,10) =
       - 2/19305 - 159226/869593725*ep - 7904207768/39170849342625*ep^2 - 
      317328063224824/1764450908638543125*ep^3;
Fill mnchfac(12,12) =
      1/135135 + 86048/6087156075*ep + 4505822764/274195945398375*ep^2 + 
      187659001098752/12351156360469801875*ep^3;

*--#] harmo : 
*--#[ harmo1 :
#procedure harmo1(P,Q,TT)
*
*   Routine to generate the harmonic projection for
*   P(mnci1)*P(mnci2)*...*P(in) = TT(mnci1,mnci2,...,in) at P->Q
*   The object mnchfac1 is a table to give better speed.
*	It has been generated with the program hfac1.frm
*
id  `P'.`P' = 0;
id  `Q'.`P' = `Q'.`Q';
id  1/`Q'.`P' = 1/`Q'.`Q';
ToTensor,nosquare,`TT',`P';
*
*   Next generate the splits between indices that connect to a Q and
*   the indices that go to d_.
*
id  `TT'(?a) = sum_(mncj,0,nargs_(?a),2,`Q'.`Q'^(mncj/2)*
               acc(mnchfac1(nargs_(?a),mncj))*distrib_(1,mncj,mncdd,`TT',?a));
*
*   The indices in TT contract with Q and the indices in mncdd go to
*   d_'mncs. We do not expand the mncdd directly to make the multiplication
*   of the acc'mncs much faster.
*
tovector,`TT',`Q';
id  mncdd(?a) = dd_(?a);
id  D = acc(4-2*ep);
*
#endprocedure
#procedure harmo1x(P,Q,TT)
*
*   Routine to generate the harmonic projection for
*   P(mnci1)*P(mnci2)*...*P(in) = TT(mnci1,mnci2,...,in) at P->Q
*   The object mnchfac1 is a table to give better speed.
*	It has been generated with the program hfac1.frm
*
id	`P' = mncx*`P';
id  `P'.`P' = 0;
id  `Q'.`P' = `Q'.`Q';
id  1/`Q'.`P' = 1/`Q'.`Q'/mncx;
ToTensor,nosquare,`TT',`P';
*
*   Next generate the splits between indices that connect to a Q and
*   the indices that go to d_.
*
id  `TT'(?a) = sum_(mncj,0,nargs_(?a),2,`Q'.`Q'^(mncj/2)*
               acc(mnchfac1(nargs_(?a),mncj))*distrib_(1,mncj,mncdd,`TT',?a));
*
*   The indices in TT contract with Q and the indices in mncdd go to
*   d_'mncs. We do not expand the mncdd directly to make the multiplication
*   of the acc'mncs much faster.
*
tovector,`TT',`Q';
id  mncdd(?a) = dd_(?a);
id  D = acc(4-2*ep);
id	mncx^n? = (`P'.`Q'/`Q'.`Q')^n;
*
#endprocedure

CTable,relax,mnchfac1(0:30,0:30);
Fill mnchfac1(0,0)=
      1;
Fill mnchfac1(1,0)=
      1;
Fill mnchfac1(2,0)=
      4/3+2/9*ep+4/27*ep^2+8/81*ep^3+16/243*ep^4+32/729*ep^5+64/2187*ep^6;
Fill mnchfac1(2,2)=
      -1/3-2/9*ep-4/27*ep^2-8/81*ep^3-16/243*ep^4-32/729*ep^5-64/2187*ep^6;
Fill mnchfac1(3,0)=
      2+2/3*ep+4/9*ep^2+8/27*ep^3+16/81*ep^4+32/243*ep^5+64/729*ep^6;
Fill mnchfac1(3,2)=
      -1/3-2/9*ep-4/27*ep^2-8/81*ep^3-16/243*ep^4-32/729*ep^5-64/2187*ep^6;
Fill mnchfac1(4,0)=
      16/5+116/75*ep+1196/1125*ep^2+12176/16875*ep^3+123056/253125*ep^4+
      1238336/3796875*ep^5+12430016/56953125*ep^6;
Fill mnchfac1(4,2)=
      -2/5-22/75*ep-232/1125*ep^2-2392/16875*ep^3-24352/253125*ep^4-246112/
      3796875*ep^5-2476672/56953125*ep^6;
Fill mnchfac1(4,4)=
      1/15+16/225*ep+196/3375*ep^2+2176/50625*ep^3+23056/759375*ep^4+238336/
      11390625*ep^5+2430016/170859375*ep^6;
Fill mnchfac1(5,0)=
      16/3+148/45*ep+1588/675*ep^2+16528/10125*ep^3+169168/151875*ep^4+
      1715008/2278125*ep^5+17290048/34171875*ep^6;
Fill mnchfac1(5,2)=
      -8/15-98/225*ep-1088/3375*ep^2-11528/50625*ep^3-119168/759375*ep^4-
      1215008/11390625*ep^5-12290048/170859375*ep^6;
Fill mnchfac1(5,4)=
      1/15+16/225*ep+196/3375*ep^2+2176/50625*ep^3+23056/759375*ep^4+238336/
      11390625*ep^5+2430016/170859375*ep^6;
Fill mnchfac1(6,0)=
      64/7+1648/245*ep+129016/25725*ep^2+9613672/2701125*ep^3+697694224/
      283618125*ep^4+49885657408/29779903125*ep^5+3536215611136/3126889828125
      *ep^6;
Fill mnchfac1(6,2)=
      -16/21-1516/2205*ep-123292/231525*ep^2-9367864/24310125*ep^3-687208288/
      2552563125*ep^4-49440388096/268019128125*ep^5-3517368500032/
      28142008453125*ep^6;
Fill mnchfac1(6,4)=
      8/105+926/11025*ep+81092/1157625*ep^2+6386864/121550625*ep^3+477728288/
      12762815625*ep^4+34752488096/1340095640625*ep^5+2488486500032/
      140710042265625*ep^6;
Fill mnchfac1(6,6)=
      -1/105-142/11025*ep-13864/1157625*ep^2-1162288/121550625*ep^3-90226096/
      12762815625*ep^4-6712496032/1340095640625*ep^5-487263833344/
      140710042265625*ep^6;
Fill mnchfac1(7,0)=
      16+472/35*ep+38464/3675*ep^2+2929288/385875*ep^3+215266096/40516875*
      ep^4+15505796032/4254271875*ep^5+1104009833344/446698546875*ep^6;
Fill mnchfac1(7,2)=
      -8/7-276/245*ep-23372/25725*ep^2-1815224/2701125*ep^3-134861408/
      283618125*ep^4-9775819136/29779903125*ep^5-698642203712/3126889828125*
      ep^6;
Fill mnchfac1(7,4)=
      2/21+242/2205*ep+21764/231525*ep^2+1742288/24310125*ep^3+131636096/
      2552563125*ep^4+9635496032/268019128125*ep^5+692602833344/
      28142008453125*ep^6;
Fill mnchfac1(7,6)=
      -1/105-142/11025*ep-13864/1157625*ep^2-1162288/121550625*ep^3-90226096/
      12762815625*ep^4-6712496032/1340095640625*ep^5-487263833344/
      140710042265625*ep^6;
Fill mnchfac1(8,0)=
      256/9+75808/2835*ep+19246768/893025*ep^2+4489358368/281302875*ep^3+
      1001728100368/88610405625*ep^4+218025485306368/27912277771875*ep^5+
      46771949116202368/8792367498140625*ep^6;
Fill mnchfac1(8,2)=
      -16/9-5368/2835*ep-1414288/893025*ep^2-336272488/281302875*ep^3-
      75848735488/88610405625*ep^4-16613136791488/27912277771875*ep^5-
      3577389080927488/8792367498140625*ep^6;
Fill mnchfac1(8,4)=
      8/63+3044/19845*ep+844124/6251175*ep^2+206121824/1969120125*ep^3+
      47199849824/620272839375*ep^4+10430561637824/195385944403125*ep^5+
      2258069814165824/61546572486984375*ep^6;
Fill mnchfac1(8,6)=
      -2/189-866/59535*ep-256496/18753525*ep^2-64996496/5907360375*ep^3-
      15212278496/1860818518125*ep^4-3406285030496/586157833209375*ep^5-
      743347417642496/184639717460953125*ep^6;
Fill mnchfac1(8,8)=
      1/945+496/297675*ep+159496/93767625*ep^2+42546496/29536801875*ep^3+
      10286568496/9304092590625*ep^4+2351196330496/2930789166046875*ep^5+
      519799077642496/923198587304765625*ep^6;
Fill mnchfac1(9,0)=
      256/5+82976/1575*ep+21820976/496125*ep^2+5190442976/156279375*ep^3+
      1171598464976/49228003125*ep^4+256775705086976/15506820984375*ep^5+
      55317926550958976/4884648610078125*ep^6;
Fill mnchfac1(9,2)=
      -128/45-45968/14175*ep-12519368/4465125*ep^2-3033399368/1406514375*ep^3
      -691968210368/443052028125*ep^4-152606739906368/139561388859375*ep^5-
      33000199172202368/43961837490703125*ep^6;
Fill mnchfac1(9,4)=
      8/45+3188/14175*ep+907988/4465125*ep^2+225339488/1406514375*ep^3+
      52120755488/443052028125*ep^4+11590175991488/139561388859375*ep^5+
      2518875627927488/43961837490703125*ep^6;
Fill mnchfac1(9,6)=
      -4/315-1774/99225*ep-533824/31255875*ep^2-136691824/9845600625*ep^3-
      32211509824/3101364196875*ep^4-7244605937824/976929722015625*ep^5-
      1585445081165824/307732862434921875*ep^6;
Fill mnchfac1(9,8)=
      1/945+496/297675*ep+159496/93767625*ep^2+42546496/29536801875*ep^3+
      10286568496/9304092590625*ep^4+2351196330496/2930789166046875*ep^5+
      519799077642496/923198587304765625*ep^6;
Fill mnchfac1(10,0)=
      1024/11+3941248/38115*ep+11779286528/132068475*ep^2+31395360315808/
      457617265875*ep^3+78817416774749888/1585643826256875*ep^4+
      191296333735703644768/5494255857980071875*ep^5+455196393432838909648448/
      19037596547900949046875*ep^6;
Fill mnchfac1(10,2)=
      -256/55-1074016/190575*ep-3316968176/660342375*ep^2-8998169551936/
      2288086329375*ep^3-22822219943433296/7928219131284375*ep^4-
      55731982644325548256/27471279289900359375*ep^5-133110230344468529882816/
      95187982739504745234375*ep^6;
Fill mnchfac1(10,4)=
      128/495+586288/1715175*ep+1884204968/5943081375*ep^2+5224503688648/
      20592776964375*ep^3+13422543891846128/71353972181559375*ep^4+
      33033670720523533408/247241513609103234375*ep^5+79273078399635825303488/
      856691844655542707109375*ep^6;
Fill mnchfac1(10,6)=
      -8/495-40108/1715175*ep-135134588/5943081375*ep^2-385061648968/
      20592776964375*ep^3-1005688819949648/71353972181559375*ep^4-
      2500193390173412128/247241513609103234375*ep^5-6037463662096098209408/
      856691844655542707109375*ep^6;
Fill mnchfac1(10,8)=
      4/3465+22034/12006225*ep+78474124/41601569625*ep^2+231375515864/
      144149438750625*ep^3+617375290327504/499477805270915625*ep^4+
      1555697463798820544/1730690595263722640625*ep^5+3788802075628465273984/
      5996842912588798949765625*ep^6;
Fill mnchfac1(10,10)=
      -1/10395-6086/36018675*ep-23133196/124804708875*ep^2-71203299656/
      432448316251875*ep^3-195463728133216/1498433415812746875*ep^4-
      501804668946637376/5192071785791167921875*ep^5-1236992715223799403136/
      17990528737766396849296875*ep^6;
Fill mnchfac1(11,0)=
      512/3+2105024/10395*ep+6484548064/36018675*ep^2+17587269036704/
      124804708875*ep^3+44620587006331744/432448316251875*ep^4+
      109002812721985297184/1498433415812746875*ep^5+260418148499992639897024/
      5192071785791167921875*ep^6;
Fill mnchfac1(11,2)=
      -256/33-1133152/114345*ep-3599216912/396205425*ep^2-9927387845632/
      1372851797625*ep^3-25437420674539952/4756931478770625*ep^4-
      62514193873472733472/16482767573940215625*ep^5-149901045320140230992192/
      57112789643702847140625*ep^6;
Fill mnchfac1(11,4)=
      64/165+305464/571725*ep+1005647504/1981027125*ep^2+2830303821544/
      6864258988125*ep^3+7340055442799984/23784657393853125*ep^4+
      18171877679298377824/82413837869701078125*ep^5+43771816945911945664064/
      285563948218514235703125*ep^6;
Fill mnchfac1(11,6)=
      -32/1485-165052/5145525*ep-566368772/17829244125*ep^2-1633203887992/
      61778330893125*ep^3-4298811218276912/214061916544678125*ep^4-
      10740981158685800032/741724540827309703125*ep^5-26021186219050005844352/
      2570075533966628121328125*ep^6;
Fill mnchfac1(11,8)=
      2/1485+11182/5145525*ep+40241252/17829244125*ep^2+119504735272/
      61778330893125*ep^3+320436189606992/214061916544678125*ep^4+
      810100247041390912/741724540827309703125*ep^5+1977198808190427804032/
      2570075533966628121328125*ep^6;
Fill mnchfac1(11,10)=
      -1/10395-6086/36018675*ep-23133196/124804708875*ep^2-71203299656/
      432448316251875*ep^3-195463728133216/1498433415812746875*ep^4-
      501804668946637376/5192071785791167921875*ep^5-1236992715223799403136/
      17990528737766396849296875*ep^6;
Fill mnchfac1(12,0)=
      4096/13+231932416/585585*ep+9552620306048/26377676325*ep^2+
      342403963966857664/1188182430059625*ep^3+11407792075081681333952/
      53521677562035808125*ep^4+364561360009988883783267136/
      2410883965781902976990625*ep^5+11366945928654188627099169856448/
      108598268238645819598542703125*ep^6;
Fill mnchfac1(12,2)=
      -512/39-30913472/1756755*ep-1310118983776/79133028975*ep^2-
      47718354631206368/3564547290178875*ep^3-1605096783082101070624/
      160565032686107424375*ep^4-51595302050743047366763232/
      7232651897345708930971875*ep^5-1614544106154750292440383714176/
      325794804715937458795628109375*ep^6;
Fill mnchfac1(12,4)=
      256/429+16505056/19324305*ep+722647696208/870463318725*ep^2+
      26818419631574944/39210020191967625*ep^3+912369819932349930992/
      1766215359547181668125*ep^4+29533805437994496650793856/
      79559170870802798240690625*ep^5+928212986345962610005192697408/
      3583742851875312046751909203125*ep^6;
Fill mnchfac1(12,6)=
      -64/2145-4414552/96621525*ep-200547273536/4352316593625*ep^2-
      7607970101536648/196050100959838125*ep^3-262362556305459313664/
      8831076797735908340625*ep^4-8565263494376565641097952/
      397795854354013991203453125*ep^5-270635475996909892431623899136/
      17918714259376560233759546015625*ep^6;
Fill mnchfac1(12,8)=
      32/19305+2367436/869593725*ep+112122653948/39170849342625*ep^2+
      4365158933778064/1764450908638543125*ep^3+153028898616288867152/
      79479691179623175065625*ep^4+5048541384762808600644736/
      3580162689186125920831078125*ep^5+160585687629192803262038853248/
      161268428334389042103835914140625*ep^6;
Fill mnchfac1(12,10)=
      -2/19305-159226/869593725*ep-7904207768/39170849342625*ep^2-
      317328063224824/1764450908638543125*ep^3-11351061489513328832/
      79479691179623175065625*ep^4-379447407147066524694976/
      3580162689186125920831078125*ep^5-12173131533692001654488077568/
      161268428334389042103835914140625*ep^6;
Fill mnchfac1(12,12)=
      1/135135+86048/6087156075*ep+4505822764/274195945398375*ep^2+
      187659001098752/12351156360469801875*ep^3+6883116416827133536/
      556357838257362225459375*ep^4+234016557715815866651648/
      25061138824302881445817546875*ep^5+7592462315747275929147393664/
      1128878998340723294726851398984375*ep^6;
Fill mnchfac1(13,0)=
      4096/7+244097536/315315*ep+10319742128768/14203364175*ep^2+
      375711675205023424/639790539262875*ep^3+12639066969880845261632/
      28819364841096204375*ep^4+406365756421014097219725376/
      1298168289267178526071875*ep^5+12718704458788802860399082024768/
      58475990590040056706907609375*ep^6;
Fill mnchfac1(13,2)=
      -2048/91-129145088/4099095*ep-5607358794304/184643734275*ep^2-
      207285335824775072/8317277010417375*ep^3-7037777173573268255296/
      374651742934250656875*ep^4-227568776116938423114463328/
      16876187760473320838934375*ep^5-7147878038639593066291156443904/
      760187877670520737189798921875*ep^6;
Fill mnchfac1(13,4)=
      256/273+17104096/12297285*ep+765124349648/553931202825*ep^2+
      28782752505588064/24951831031252125*ep^3+987765403914509727152/
      1123955228802751970625*ep^4+32153921399561393777604736/
      50628563281419962516803125*ep^5+1014182537283552715179078333248/
      2280563633011562211569396765625*ep^6;
Fill mnchfac1(13,6)=
      -128/3003-9076208/135270135*ep-419729246584/6093243231075*ep^2-
      16110167517555512/274470141343773375*ep^3-559853837941644685216/
      12363507516830271676875*ep^4-18369562166151731874761888/
      556914196095619587684834375*ep^5-582314625712167699616689097984/
      25086199963127184327263364421875*ep^6;
Fill mnchfac1(13,8)=
      32/15015+2413196/676350675*ep+115802553028/30466216155375*ep^2+
      4549174479503504/1372350706718866875*ep^3+160455215928334705072/
      61817537584151358384375*ep^4+5315161061687116647687296/
      2784570980478097938424171875*ep^5+169520799430411541843679699328/
      125430999815635921636316822109375*ep^6;
Fill mnchfac1(13,10)=
      -16/135135-1286678/6087156075*ep-64341099904/274195945398375*ep^2-
      2596614444771272/12351156360469801875*ep^3-93223663260247568896/
      556357838257362225459375*ep^4-3124164965461097406168128/
      25061138824302881445817546875*ep^5-100396845367338563439711330304/
      1128878998340723294726851398984375*ep^6;
Fill mnchfac1(13,12)=
      1/135135+86048/6087156075*ep+4505822764/274195945398375*ep^2+
      187659001098752/12351156360469801875*ep^3+6883116416827133536/
      556357838257362225459375*ep^4+234016557715815866651648/
      25061138824302881445817546875*ep^5+7592462315747275929147393664/
      1128878998340723294726851398984375*ep^6;
Fill mnchfac1(14,0)=
      16384/15+1022076928/675675*ep+8855205451264/6087156075*ep^2+
      1635953439324307456/1370979726991875*ep^3+55546394976216520160384/
      61755781802349009375*ep^4+1796409882008846330444963968/
      2781789191286811127296875*ep^5+11286825660272378214206183220352/
      25061138824302881445817546875*ep^6;
Fill mnchfac1(14,2)=
      -4096/105-268698112/4729725*ep-2386708597888/42610092525*ep^2-
      447384534399600064/9596858088943125*ep^3-15326058483484843246016/
      432290472616443065625*ep^4-498414063672824065755297472/
      19472524339007677891078125*ep^5-628487173008311367973015945664/
      35085594354024034024144565625*ep^6;
Fill mnchfac1(14,4)=
      2048/1365+141445376/61486425*ep+1291375944512/553931202825*ep^2+
      246065355438470432/124759155156260625*ep^3+8515645698336721669888/
      5619776144013759853125*ep^4+278713744181148773463810656/
      253142816407099812584015625*ep^5+1764366557238314519942960648768/
      2280563633011562211569396765625*ep^6;
Fill mnchfac1(14,6)=
      -256/4095-18641632/184459275*ep-175417198288/1661793608475*ep^2-
      34050530970176704/374277465468781875*ep^3-1192272892921391011376/
      16859328432041279559375*ep^4-39314712394447268191928992/
      759428449221299437752046875*ep^5-50012267996984120317592154368/
      1368338179806937326941638059375*ep^6;
Fill mnchfac1(14,8)=
      128/45045+9844976/2029052025*ep+95771634488/18279729693225*ep^2+
      18986189701230152/4117052120156600625*ep^3+673884893287232978128/
      185452612752454075153125*ep^4+22416914835234853141398656/
      8353712941434293815272515625*ep^5+143390123242517645516785885184/
      75258599889381552981790093265625*ep^6;
Fill mnchfac1(14,10)=
      -32/225225-2605388/10145260125*ep-131450513356/456993242330625*ep^2-
      1067733252543928/4117052120156600625*ep^3-192519245502228862912/
      927263063762270375765625*ep^4-6471431650173503198336768/
      41768564707171469076362578125*ep^5-208388217921353602052890327936/
      1881464997234538824544752331640625*ep^6;
Fill mnchfac1(14,12)=
      16/2027025+1382774/91307341125*ep+72646040548/4112939180975625*ep^2+
      606585312860512/37053469081409405625*ep^3+111439420205448744256/
      8345367573860433381890625*ep^4+3793470123215022564169664/
      375917082364543221687263203125*ep^5+123180426927367988960114332288/
      16933184975110849420902770984765625*ep^6;
Fill mnchfac1(14,14)=
      -1/2027025-92054/91307341125*ep-5058699088/4112939180975625*ep^2-
      43608309564256/37053469081409405625*ep^3-8192673953041741216/
      8345367573860433381890625*ep^4-283221757477784564394944/
      375917082364543221687263203125*ep^5-9293492191158850022903427328/
      16933184975110849420902770984765625*ep^6;
Fill mnchfac1(15,0)=
      2048+133140992/45045*ep+5900508278272/2029052025*ep^2+
      221097615608542592/91398648466125*ep^3+7574121111626553240832/
      4117052120156600625*ep^4+246347542921060776392076032/
      185452612752454075153125*ep^5+7767029312071063526660719270912/
      8353712941434293815272515625*ep^6;
Fill mnchfac1(15,2)=
      -1024/15-69645568/675675*ep-631879955968/6087156075*ep^2-
      120036485343130816/1370979726991875*ep^3-4147530121298698460864/
      61755781802349009375*ep^4-135628804414790379674012608/
      2781789191286811127296875*ep^5-858161591138629454698283899456/
      25061138824302881445817546875*ep^6;
Fill mnchfac1(15,4)=
      256/105+18235072/4729725*ep+169704257824/42610092525*ep^2+
      32739238583526304/9596858088943125*ep^3+1142221030467170498336/
      432290472616443065625*ep^4+37582297269225715996899232/
      19472524339007677891078125*ep^5+238724606077404111918575630656/
      175427971770120170120722828125*ep^6;
Fill mnchfac1(15,6)=
      -128/1365-9561056/61486425*ep-18295588144/110786240565*ep^2-
      17954474614737152/124759155156260625*ep^3-633322769773649480848/
      5619776144013759853125*ep^4-20985612031878553449587936/
      253142816407099812584015625*ep^5-133905332176793893499852254976/
      2280563633011562211569396765625*ep^6;
Fill mnchfac1(15,8)=
      16/4095+1255192/184459275*ep+12377077984/1661793608475*ep^2+
      2476611609254344/374277465468781875*ep^3+88461927049944678896/
      16859328432041279559375*ep^4+2955265462648549019604352/
      759428449221299437752046875*ep^5+18956832068182634863949499136/
      6841690899034686634708190296875*ep^6;
Fill mnchfac1(15,10)=
      -8/45045-660356/2029052025*ep-6729370556/18279729693225*ep^2-
      1376089666761272/4117052120156600625*ep^3-49866050710359748288/
      185452612752454075153125*ep^4-1681834208983197679041536/
      8353712941434293815272515625*ep^5-10855838251248556331109767552/
      75258599889381552981790093265625*ep^6;
Fill mnchfac1(15,12)=
      2/225225+174098/10145260125*ep+9195937636/456993242330625*ep^2+
      77089103554336/4117052120156600625*ep^3+14202752012392469632/
      927263063762270375765625*ep^4+484434848685621299217728/
      41768564707171469076362578125*ep^5+15751934589965076556213465216/
      1881464997234538824544752331640625*ep^6;
Fill mnchfac1(15,14)=
      -1/2027025-92054/91307341125*ep-5058699088/4112939180975625*ep^2-
      43608309564256/37053469081409405625*ep^3-8192673953041741216/
      8345367573860433381890625*ep^4-283221757477784564394944/
      375917082364543221687263203125*ep^5-9293492191158850022903427328/
      16933184975110849420902770984765625*ep^6;
Fill mnchfac1(16,0)=
      65536/17+75196264448/13018005*ep+57875871822457856/9968732598825*ep^2+
      37362483254848926620672/7633706518539226125*ep^3+
      21945499113835013680434024704/5845625272169190493610625*ep^4+
      12201132004815697250304907827488768/4476375236542640158339740253125*
      ep^5+6562774638413504361334915855526075204096/3427851483011074840851031\
      194934265625*ep^6;
Fill mnchfac1(16,2)=
      -2048/17-2447901184/13018005*ep-1925778310087168/9968732598825*ep^2-
      1259745953440522719616/7633706518539226125*ep^3-
      746088682309618045037734912/5845625272169190493610625*ep^4-
      416993412638542080463173436789504/4476375236542640158339740253125*ep^5-
      225044142489744084807083745911634508288/3427851483011074840851031194934\
      265625*ep^6;
Fill mnchfac1(16,4)=
      1024/255+1276226816/195270075*ep+41121672409088/5981239559295*ep^2+
      682355539174170147008/114505597778088391875*ep^3+
      407879273785189582693772864/87684379082537857404159375*ep^4+
      229319351125278753617686516874816/67145628548139602375096103796875*ep^5
      +24845810687833729610895677465758697152/1028355444903322452255309358480\
      2796875*ep^6;
Fill mnchfac1(16,6)=
      -256/1785-333059264/1366890525*ep-55045592329888/209343384575325*ep^2-
      185643166225862781152/801539184446618743125*ep^3-
      112124035530936525145504736/613790653577765001829115625*ep^4-
      63462742214773088988567874516064/470019399836977216625672726578125*ep^5
      -6905703340416942609714357629708156416/71984881143232571657871655093619\
      578125*ep^6;
Fill mnchfac1(16,8)=
      128/23205+174069472/17769576825*ep+29573508614576/2721463999479225*ep^2
      +101531720737639386976/10420009397806043660625*ep^3+
      62042743775518910662573648/7979278496510945023778503125*ep^4+
      35385998929483485926862837993472/6110252197880703816133745445515625*
      ep^5+773946824719343250512309981851034368/18716069097240468631046630324\
      3410903125*ep^6;
Fill mnchfac1(16,10)=
      -16/69615-22779704/53308730475*ep-3987420244048/8164391998437675*ep^2-
      13963726285198013672/31260028193418130981875*ep^3-
      8646420710171918577783296/23937835489532835071335509375*ep^4-
      4975010395779169010000873554304/18330756593642111448401236336546875*
      ep^5-547211579378320120852582387612089856/28074103645860702946569945486\
      51163546875*ep^6;
Fill mnchfac1(16,12)=
      8/765765+11946772/586396035225*ep+432009005716/17961662396562885*ep^2+
      7733720815921990336/343860310127599440800625*ep^3+
      4861593329686368646132288/263316190384861185784690603125*ep^4+
      2825945017535701058300936006272/201638322530063225932413599702015625*
      ep^5+312951422168309626261015125821369984/30881514010446773241226940035\
      162799015625*ep^6;
Fill mnchfac1(16,14)=
      -2/3828825-3139846/2931980176125*ep-2940494702944/2245207799570360625*
      ep^2-86344119864019552/68772062025519888160125*ep^3-
      1380696594790769492126272/1316580951924305928923453015625*ep^4-
      812215167174920624589041469376/1008191612650316129662067998510078125*
      ep^5-453385872459557342035111641356383744/77203785026116933103067350087\
      9069975390625*ep^6;
Fill mnchfac1(16,16)=
      1/34459425+1655008/26387821585125*ep+1611063707152/20206870196133245625
      *ep^2+243275770764654464/3094742791148394967205625*ep^3+
      793843892172937871410336/11849228567318753360311077140625*ep^4+
      473651791152994731083469173248/9073724513852845166958611986590703125*
      ep^5+266993598880031227711792795283997952/69483406523505239792760615079\
      11629778515625*ep^6;
Fill mnchfac1(17,0)=
      65536/9+77820325888/6891885*ep+61109998518578176/5277564317025*ep^2+
      39955008832559536602112/4041374039226649125*ep^3+
      23662077982138671952596553984/3094742791148394967205625*ep^4+
      13225884902343267962156434980425728/2369845713463750672062215428125*
      ep^5+7138499064172458233255011552746366716416/1814744902770569033391722\
      397318140625*ep^6;
Fill mnchfac1(17,2)=
      -32768/153-40386197504/117162045*ep-32374195525856768/89718593389425*
      ep^2-21435800053741986415616/68703358666853035125*ep^3-
      12796614604490143754389699712/52610627449522714442495625*ep^4-
      7189365956030892506494701513739904/40287377128883761425057662278125*
      ep^5-3893094521575640669582559606059597333888/3085066334709967356765928\
      0754408390625*ep^6;
Fill mnchfac1(17,4)=
      1024/153+1311077632/117162045*ep+1074442195362304/89718593389425*ep^2+
      721291890912662995648/68703358666853035125*ep^3+
      434415461693112953503577536/52610627449522714442495625*ep^4+
      245458945877429555880438613045312/40287377128883761425057662278125*ep^5
      +133406945654853136165628992346777625664/308506633470996735676592807544\
      08390625*ep^6;
Fill mnchfac1(17,6)=
      -512/2295-681676928/1757430675*ep-114404277306496/269155780168275*ep^2-
      389848209260201134304/1030550380002795526875*ep^3-
      237109871777499004859142272/789159411742840716637434375*ep^4-
      134834169002827879637283378650528/604310656933256421375864934171875*
      ep^5-14717378397837986833235489987375383552/925519900412990207029778422\
      63225171875*ep^6;
Fill mnchfac1(17,8)=
      128/16065+177420512/12302014725*ep+30541961017648/1884090461177925*ep^2
      +105814896878864290976/7213852660019568688125*ep^3+
      65065278266406430770445328/5524115882199885016462040625*ep^4+
      37267450308683735656387277990912/4230174598532794949631054539203125*
      ep^5+4087031872111342434521921124425427712/6478639302890931449208448958\
      42576203125*ep^6;
Fill mnchfac1(17,10)=
      -64/208845-92480176/159926191425*ep-3272097892456/4898635199062605*ep^2
      -57726021598310162488/93780084580254392945625*ep^3-
      35932990435451675506578304/71813506468598505214006528125*ep^4-
      20750357955942148773908633992576/54992269780926334345203709009640625*
      ep^5-2287975903134625671966378179279251712/8422231093758210883970983645\
      953490640625*ep^6;
Fill mnchfac1(17,12)=
      8/626535+12070532/479778574275*ep+2199114365068/73479527985939075*ep^2+
      7917421371358060736/281340253740763178836875*ep^3+
      4996864152467959886614208/215440519405795515642019584375*ep^4+
      2912663384302320871953006664832/164976809342779003035611127028921875*
      ep^5+323170582499832654704315508221491072/25266693281274632651912950937\
      860471921875*ep^6;
Fill mnchfac1(17,14)=
      -4/6891885-6313726/5277564317025*ep-1187463189632/808274807845329825*
      ep^2-4372036935410188768/3094742791148394967205625*ep^3-
      2802791427492560234391424/2369845713463750672062215428125*ep^4-
      1651448017376055016693662314176/1814744902770569033391722397318140625*
      ep^5-184578401995843141349583614511017984/27793362609402095917104246031\
      6465191140625*ep^6;
Fill mnchfac1(17,16)=
      1/34459425+1655008/26387821585125*ep+1611063707152/20206870196133245625
      *ep^2+243275770764654464/3094742791148394967205625*ep^3+
      793843892172937871410336/11849228567318753360311077140625*ep^4+
      473651791152994731083469173248/9073724513852845166958611986590703125*
      ep^5+266993598880031227711792795283997952/69483406523505239792760615079\
      11629778515625*ep^6;
Fill mnchfac1(18,0)=
      262144/19+2034644402176/92147055*ep+30936861817158135808/
      1340696801869425*ep^2+389006823534136572381927424/
      19506515043187264467375*ep^3+4411972764703764644295250155246592/
      283810723348879615922328920625*ep^4+47098469043699353462338273266177106\
      095616/4129314052739841182648481912145659375*ep^5+484620769213642826023\
      838328042569508681648268288/60079599336330165181385480277630196174640625
      *ep^6;
Fill mnchfac1(18,2)=
      -65536/171-1578956541952/2487970485*ep-24478928777902468096/
      36198813650474475*ep^2-311541619373746828516953088/
      526675906166056140619125*ep^3-3560801001029768347812904674613504/
      7662889530419749629902880856875*ep^4-3820207393791438457555348439490798\
      4456192/111491479423975711931509011627932803125*ep^5-394344599789802850\
      928182944119464217157059616256/1622149182080914459897407967496015296715\
      296875*ep^6;
Fill mnchfac1(18,4)=
      32768/2907+817522927616/42295498245*ep+12939145474166025728/
      615379832058066075*ep^2+166844842036665778207913984/
      8953490404822954390525125*ep^3+1923195492796174763514586560083072/
      130269122017135743708348974566875*ep^4+20747013447444262440004518677833\
      889814656/1895355150207587102835653197674857653125*ep^5+214928735088963\
      834694681539392749632345852219008/2757653609537554581825593544743226004\
      4160046875*ep^6;
Fill mnchfac1(18,6)=
      -1024/2907-26478761728/42295498245*ep-428426650475075584/
      615379832058066075*ep^2-5603489347772047996313152/
      8953490404822954390525125*ep^3-65195369424101497881333209751616/
      130269122017135743708348974566875*ep^4-70762931456225161293619642005377\
      6450368/1895355150207587102835653197674857653125*ep^5-73600028139832129\
      29285150767301371157483193024/27576536095375545818255935447432260044160\
      046875*ep^6;
Fill mnchfac1(18,8)=
      512/43605+13736004992/634432473675*ep+45507364852724608/
      1846139496174198225*ep^2+3022448339780186174642336/
      134302356072344315857876875*ep^3+35529365905738996344298256883392/
      1954036830257036155625234618503125*ep^4+3882770407993495550131808459578\
      15080032/28430327253113806542534797965122864796875*ep^5+811323619995742\
      150633831079124708302821031104/8272960828612663745476780634229678013248\
      0140625*ep^6;
Fill mnchfac1(18,10)=
      -128/305235-3567025568/4441027315725*ep-12118249261002736/
      12922976473219387575*ep^2-818581689145647773134784/
      940116492506410211005138125*ep^3-9733054543333586398424321329808/
      13678257811799253089376642329521875*ep^4-107184361466633176751823683492\
      260058528/199012290771796645797743585755860053578125*ep^5-4502184562439\
      1195352582539661377015000066368/115821451600577292436674928879215492185\
      472196875*ep^6;
Fill mnchfac1(18,12)=
      64/3968055+1855141264/57733355104425*ep+6474377595893864/
      167998694151852038475*ep^2+445521299740006052164792/
      12221514402583332743066795625*ep^3+5365152482729309272764735047344/
      177817351553390290161896350283784375*ep^4+59596832566224817667443769387\
      442197344/2587159780033356395370666614826180696515625*ep^5+125894709465\
      769185343319295049358211511449536/7528394354037524008383870377149006992\
      055692796875*ep^6;
Fill mnchfac1(18,14)=
      -8/11904165-241592348/173200065313275*ep-867881471536036/
      503996082455556115425*ep^2-60951525736652864663624/
      36664543207749998229200386875*ep^3-744545423425232962201730265488/
      533452054660170870485689050851353125*ep^4-83523365455460394473227838032\
      86687008/7761479340100069186111999844478542089546875*ep^5-3552443112981\
      566950416994040378464513309376/4517036612422514405030322226289404195233\
      415678125*ep^6;
Fill mnchfac1(18,16)=
      4/130945815+126086914/1905200718446025*ep+467295389736836/
      5543956907011117269675*ep^2+33566185881196766955112/
      403309975285249980521204255625*ep^3+416670202284887226800887448464/
      5867972601261879575342579559364884375*ep^4+4727291699282205785242523716\
      414949344/85376272741100761047231998289263962985015625*ep^5+10131651346\
      706934247853186597315422737887168/2484370136832382922766677224459172307\
      37837862296875*ep^6;
Fill mnchfac1(18,18)=
      -1/654729075-32976682/9526003592230125*ep-632098776065332/
      138598922675277931741875*ep^2-1862244159376232552168/
      403309975285249980521204255625*ep^3-117714943858916843543175683056/
      29339863006309397876712897796824421875*ep^4-135309269439038601403272679\
      0280955232/426881363705503805236159991446319814925078125*ep^5-
      14633251134911390307284448204707320220500672/62109253420809573069166930\
      61147930768445946557421875*ep^6;
Fill mnchfac1(19,0)=
      131072/5+1047433306112/24249225*ep+16213367928007141376/352814947860375
      *ep^2+206247925186001974627463168/5133293432417701175625*ep^3+
      2357123617857184999963740483106304/74687032460231477874297084375*ep^4+
      25289472617501961380594504604509557663232/10866615928262739954338110295\
      12015625*ep^5+261072211731185835277436236662544995221740660736/
      15810420877981622416154073757271104256484375*ep^6;
Fill mnchfac1(19,2)=
      -65536/95-540445044736/460735275*ep-8520537863685833728/
      6703484009347125*ep^2-109648692270186369778453504/
      97532575215936322336875*ep^3-1262526939764871765435267689043712/
      1419053616744398079611644603125*ep^4-1361153525078002771775579006415533\
      6951296/20646570263699205913242409560728296875*ep^5-1409593431569064855\
      64005380909750409211379511808/30039799668165082590692740138815098087320\
      3125*ep^6;
Fill mnchfac1(19,4)=
      16384/855+418577093632/12439852425*ep+6728742401875323136/
      180994068252372375*ep^2+87675412151643615089592448/
      2633379530830280703095625*ep^3+1017763898031418495480481514444544/
      38314447652098748149514404284375*ep^4+110313176300930515938524318598533\
      85962752/557457397119878559657545058139664015625*ep^5+11463620414296630\
      3474201910247871247682621796096/811074591040457229948703983748007648357\
      6484375*ep^6;
Fill mnchfac1(19,6)=
      -8192/14535-216299710976/211477491225*ep-3549492390075026048/
      3076899160290330375*ep^2-46875556885329468963107264/
      44767452024114771952625625*ep^3-549000628753802900399660924652992/
      651345610085678718541744872834375*ep^4-59855237481686117782477677305955\
      79449536/9476775751037935514178265988374288265625*ep^5-6244084249897199\
      8970573198375004503491093531328/137882680476877729091279677237161300220\
      800234375*ep^6;
Fill mnchfac1(19,8)=
      256/14535+6992158528/211477491225*ep+117279928141637344/
      3076899160290330375*ep^2+1571509178872435748461792/
      44767452024114771952625625*ep^3+18585315136107950916082906324576/
      651345610085678718541744872834375*ep^4+20394809794644614279723213586055\
      8099808/9476775751037935514178265988374288265625*ep^5+21367357024213278\
      60345620378208137308639797184/13788268047687772909127967723716130022080\
      0234375*ep^6;
Fill mnchfac1(19,10)=
      -128/218025-3620235296/3172162368375*ep-62151480080644496/
      46153487404354955625*ep^2-169207919683712107074304/
      134302356072344315857876875*ep^3-10113289751292428201975231045168/
      9770184151285180778126173092515625*ep^4-1117836265199944366892577808119\
      29609696/142151636265569032712673989825614323984375*ep^5-11767945036426\
      36413933852869500435205907118016/20682402071531659363691951585574195033\
      12003515625*ep^6;
Fill mnchfac1(19,12)=
      32/1526175+938314904/22205136578625*ep+16513016129930384/
      323074411830484689375*ep^2+45734218580042122048168/
      940116492506410211005138125*ep^3+2765969442797383177713126333392/
      68391289058996265446883211647609375*ep^4+308204472883493966332107560277\
      75871904/995061453858983228988717928779300267890625*ep^5+32622885280619\
      4434808019078603864945792691264/144776814500721615545843661099019365231\
      84024609375*ep^6;
Fill mnchfac1(19,14)=
      -16/19840275-487064572/288666775522125*ep-8801628298624732/
      4199967353796300961875*ep^2-24837256966756922410232/
      12221514402583332743066795625*ep^3-1521973390453239157741161182896/
      889086757766951450809481751418921875*ep^4-17113608652903011315753496903\
      979224672/12935798900166781976853333074130903482578125*ep^5-18226789163\
      9383003153544274269381501253124672/188209858850938100209596759428725174\
      801392319921875*ep^6;
Fill mnchfac1(19,16)=
      2/59520825+63307994/866000326566375*ep+1176962026868324/
      12599902061388902885625*ep^2+3390061290904475641768/
      36664543207749998229200386875*ep^3+210798263558388165553708055312/
      2667260273300854352428445254256765625*ep^4+2394785807744709177661642923\
      876059744/38807396700500345930559999222392710447734375*ep^5+25687071448\
      863285164627141940209109898925504/5646295765528143006287902782861755244\
      04176959765625*ep^6;
Fill mnchfac1(19,18)=
      -1/654729075-32976682/9526003592230125*ep-632098776065332/
      138598922675277931741875*ep^2-1862244159376232552168/
      403309975285249980521204255625*ep^3-117714943858916843543175683056/
      29339863006309397876712897796824421875*ep^4-135309269439038601403272679\
      0280955232/426881363705503805236159991446319814925078125*ep^5-
      14633251134911390307284448204707320220500672/62109253420809573069166930\
      61147930768445946557421875*ep^6;
Fill mnchfac1(20,0)=
      1048576/21+1721904332800/20369349*ep+27108206457847021568/
      296364556202715*ep^2+348687951609134651084066816/4311966483230868987525
      *ep^3+573499901426290890388104664567808/8962443895227777344915650125*
      ep^4+1731292929627261545714560281195489901568/
      36511829518962806246576050591603725*ep^5+448254550256421612121106702037\
      098017287971345408/13280753537504562829569421956107727575446875*ep^6;
Fill mnchfac1(20,2)=
      -131072/105-1107974152192/509233725*ep-17748654471475030016/
      7409113905067875*ep^2-230841703227490779469733888/
      107799162080771724688125*ep^3-382427720109774592621652377098752/
      224061097380694433622891253125*ep^4-28998902949973540898900819950130551\
      450112/22819893449351753904110031619752328125*ep^5-30125512158187567169\
      4816135842842396449617355776/332018838437614070739235548902693189386171\
      875*ep^6;
Fill mnchfac1(20,4)=
      65536/1995+570715467776/9675440775*ep+9311361165919003648/
      140773164196289625*ep^2+122551166096965355563377664/
      2048184079534662769074375*ep^3+204620344870064821382681888102656/
      4257160850233194238834933809375*ep^4+1559628916371274676507317574736578\
      8327936/433577975537683324178090600775294234375*ep^5+162570653162388327\
      373964328347602761123750588928/6308357930314667344045475429151170598337\
      265625*ep^6;
Fill mnchfac1(20,6)=
      -16384/17955-441279910912/261236900925*ep-7340210736028754176/
      3800875433299819875*ep^2-97846521962236578888650368/
      55300970147435894765008125*ep^3-164763841159832979392731095695872/
      114943342956296244448543212853125*ep^4-12629475812552671945738311741463\
      678642432/11706605339517449752808446220932944328125*ep^5-13213648989214\
      6164409253116678665223267080545536/170325664118496018289227836587081606\
      155106171875*ep^6;
Fill mnchfac1(20,8)=
      8192/305235+227651119616/4441027315725*ep+3864941716993328768/
      64614882366096937875*ep^2+52231090674315614837061824/
      940116492506410211005138125*ep^3+88767954881211688344418911759296/
      1954036830257036155625234618503125*ep^4+6846545392450351979565244404798\
      105267776/199012290771796645797743585755860053578125*ep^5+7192789505292\
      8678198097370589401094017492701248/289553629001443231091687322198038730\
      4636804921875*ep^6;
Fill mnchfac1(20,10)=
      -256/305235-7346890048/4441027315725*ep-127460293274449504/
      64614882366096937875*ep^2-1748127083454042192669472/
      940116492506410211005138125*ep^3-3001091770262530508742744798688/
      1954036830257036155625234618503125*ep^4-2330577577795439073475790501569\
      44106528/199012290771796645797743585755860053578125*ep^5-24596768456437\
      08466439940240639110048732450944/28955362900144323109168732219803873046\
      36804921875*ep^6;
Fill mnchfac1(20,12)=
      128/4578525+3797601056/66615409735875*ep+67413701935912016/
      969223235491454068125*ep^2+187890548556019147716448/
      2820349477519230633015414375*ep^3+1630723033340074780579497649424/
      29310552453855542334378519277546875*ep^4+127601134419252826637696928367\
      071088256/2985184361576949686966153786337900803671875*ep^5+135360756757\
      3362478220910372230834600770809536/434330443502164846637530983297058095\
      69552073828125*ep^6;
Fill mnchfac1(20,14)=
      -32/32049675-982656344/466307868151125*ep-17874653546120864/
      6784562648440178476875*ep^2-50687892815892781571944/
      19742446342634614431107900625*ep^3-3117152904988373930917104545792/
      1436217070238921574384547444599796875*ep^4-5019970364886376676866380040\
      534781792/2985184361576949686966153786337900803671875*ep^5-374921009154\
      779173796853136419239763392735744/3040313104515153926462716883079406669\
      86864516796875*ep^6;
Fill mnchfac1(20,16)=
      16/416645775+509235292/6062002285964625*ep+9507260365690372/
      88199314429722320199375*ep^2+5494408412188431592816/
      51330360490849997520880541625*ep^3+1712309313066167757871594850896/
      18670821913105980466999116779797359375*ep^4+278375775696277257040048996\
      3002897856/38807396700500345930559999222392710447734375*ep^5+2092694789\
      17017238626932202758621079557989312/39524070358697001044015319480032286\
      70829238718359375*ep^6;
Fill mnchfac1(20,18)=
      -2/1249937325-66079334/18186006857893875*ep-1268526177612104/
      264597943289166960598125*ep^2-3741613024610828471704/
      769955407362749962813208124375*ep^3-236721468157450598995638463712/
      56012465739317941400997350339392078125*ep^4-388971949218063392738847039\
      126838112/116422190101501037791679997667178131343203125*ep^5-2945997877\
      4974242474542209177157310265510784/118572211076091003132045958440096860\
      12487716155078125*ep^6;
Fill mnchfac1(20,20)=
      1/13749310575+34362352/200046075436832625*ep+679713656361172/
      2910577376180836566579375*ep^2+2050615923818229593216/
      8469509480990249590945289368125*ep^3+131922328694702874545333756656/
      616137123132497355410970853733312859375*ep^4+21941335822753927802913705\
      9552353536/1280644091116511415708479974338959444775234375*ep^5+
      16761492691577470766990888649876688290104512/13042943218370010344525055\
      4284106546137364877705859375*ep^6;
Fill mnchfac1(21,0)=
      1048576/11+588644679680/3556553*ep+28250985333859155968/155238577058565
      *ep^2+367273591924227707607535616/2258649110263788517275*ep^3+
      4258703363965218552169776465760256/32862294282501850264690717125*ep^4+
      1845354426808603360009855613902819638272/
      19125244033742422319635074119411475*ep^5+684696581906496366680491306490\
      60337281477817344/993797883758844837586827493314183696121875*ep^6;
Fill mnchfac1(21,2)=
      -524288/231-907183357952/224062839*ep-14754021048736251904/
      3260010118229865*ep^2-193858898135415034891675648/
      47431631315539558862775*ep^3-323380558810322793112008904351744/
      98586882847505550794072151375*ep^4-492705518427019838933670119970220587\
      1616/2008150623542954343561682782538204875*ep^5-25671198506024294284355\
      2424150189569510477717504/146088288912550191125263641517185003329915625
      *ep^6;
Fill mnchfac1(21,4)=
      65536/1155+582881570816/5601570975*ep+9645295946232275968/
      81500252955746625*ep^2+128178539882387627673601024/
      1185790782888488971569375*ep^3+30776262294051978642555924291328/
      352096010169662681407400540625*ep^4+16494109199114769376621035028407759\
      333376/251018827942869292945210347817275609375*ep^5+1724440716169689545\
      80324061637970715378675112448/36522072228137547781315910379296250832478\
      90625*ep^6;
Fill mnchfac1(21,6)=
      -32768/21945-299804981248/106429848525*ep-5052228134581512704/
      1548504806159185875*ep^2-67958089418671625912579072/
      22530024874881290459818125*ep^3-115151193221137507765652322601088/
      46828769352565136627184271903125*ep^4-886430587389627523374967076992023\
      4732928/4769357730914516565958996608528236578125*ep^5-93010010996008658\
      494534347456113326239598166144/6939193723346134078450022972066287658170\
      9921875*ep^6;
Fill mnchfac1(21,8)=
      8192/197505+231475390976/2873605910175*ep+3976274395527467648/
      41809629766298018625*ep^2+54182619479966537990320064/
      608310671621794842415089375*ep^3+92619997443753566882326475541056/
      1264376772519258688933975341384375*ep^4+7172287475508574279151405830838\
      990908736/128772658734691947280892908430262387609375*ep^5+7555492200561\
      6140775045935560695882323661748928/187358230530345620118150620245789766\
      7706167890625*ep^6;
Fill mnchfac1(21,10)=
      -4096/3357585-119243277568/48851300472975*ep-2090192153086694464/
      710763706027066316625*ep^2-28880211145163281885646752/
      10341281417570512321056519375*ep^3-49841037737540172100911837903808/
      21494405132827397711877580803534375*ep^4-388474064722432424752968422262\
      3640625248/2189135198489763103775179443314460589359375*ep^5-41102235709\
      438244416392485670701497109152501504/3185089919015875542008560544178426\
      0351004854140625*ep^6;
Fill mnchfac1(21,12)=
      128/3357585+3842748704/48851300472975*ep+68812892706774992/
      710763706027066316625*ep^2+965081322716881776628256/
      10341281417570512321056519375*ep^3+240414689495033378639166358832/
      3070629304689628244553940114790625*ep^4+1321105311649341266706314670897\
      25545344/2189135198489763103775179443314460589359375*ep^5+1404579040735\
      745128555314302367128657309554112/3185089919015875542008560544178426035\
      1004854140625*ep^6;
Fill mnchfac1(21,14)=
      -64/50363775-1983452368/732769507094625*ep-36330333663324088/
      10661455590405994749375*ep^2-20711198350860867625096/
      6204768850542307392633911625*ep^3-913198628779710271342249191712/
      322416076992410965678163712053015625*ep^4-72255686107778850880600724288\
      512651168/32837027977346446556627691649716908840390625*ep^5-77237529596\
      6148708487462555120968656395550848/477763487852381331301284081626763905\
      265072812109375*ep^6;
Fill mnchfac1(21,16)=
      16/352546425+512491132/5129386549662375*ep+9615191105989852/
      74630189132841963245625*ep^2+27887520217551628264496/
      217166909768980758742186906875*ep^3+1743008475888948342613676731696/
      15798387772628137318230021890597765625*ep^4+283933534900478457251175730\
      7105008576/32837027977346446556627691649716908840390625*ep^5+2137493285\
      10078341274475564205857199574793792/33443444149666693191089885713873473\
      36855509684765625*ep^6;
Fill mnchfac1(21,18)=
      -8/4583103525-265199126/66682025145610875*ep-5104405088818496/
      970192458726945522193125*ep^2-15086325039451857458392/
      2823169826996749863648429789375*ep^3-955926935707120779347563538048/
      205379041044165785136990284577770953125*ep^4-22464372180256075600883769\
      2833329824/60983051957929115033737141635188544989296875*ep^5-1191942506\
      35957202917982026082827929833609216/43476477394566701148416851428035515\
      379121625901953125*ep^6;
Fill mnchfac1(21,20)=
      1/13749310575+34362352/200046075436832625*ep+679713656361172/
      2910577376180836566579375*ep^2+2050615923818229593216/
      8469509480990249590945289368125*ep^3+131922328694702874545333756656/
      616137123132497355410970853733312859375*ep^4+21941335822753927802913705\
      9552353536/1280644091116511415708479974338959444775234375*ep^5+
      16761492691577470766990888649876688290104512/13042943218370010344525055\
      4284106546137364877705859375*ep^6;
Fill mnchfac1(22,0)=
      4194304/23+55449783894016/171037867*ep+62148447012132082024448/
      171707978824687305*ep^2+18773640843278935056606227120128/
      57460238696848076587523025*ep^3+5041448329983946376409848137016655847424
      /19228454342647346039835476757497625*ep^4+25238480256124189915183972630\
      4251570188585611264/1286919319489547947773009251294531753830125*ep^5+
      43208773716402314365724491929872346118892115358985406464/30760984761789\
      6628576382938294123183144388655759375*ep^6;
Fill mnchfac1(22,2)=
      -1048576/253-14216885108736/1881416537*ep-16185865646494692933632/
      1888787767071560355*ep^2-4939611430400022842765148762112/
      632062625665328842462753275*ep^3-13354979068614011175609644733439262351\
      36/211512997769120806438190244332473875*ep^4-67159019652865511163476517\
      453240188013484381184/14156112514385027425503101764239849292131375*ep^5
      -1647410043030677534927152648628894859139012208775308288/48338690339955\
      1844905744617319336430655467887621875*ep^6;
Fill mnchfac1(22,4)=
      524288/5313+21882303447040/118529241831*ep+8441631814548135510016/
      39664543108502767455*ep^2+2604324848699357943102458894336/
      13273315138971905691717818775*ep^3+101321343397331258710314036451040088\
      064/634538993307362419314570732997421625*ep^4+7167983351101874733275580\
      885186961755973448192/59455672560417115187113027409807367026951775*ep^5
      +43217128157661483349691907463896316521620720902405037056/4974051235981\
      38848408011211221597187144476456362909375*ep^6;
Fill mnchfac1(22,6)=
      -65536/26565-14041955012608/2963231045775*ep-5510969387405605061632/
      991613577712569186375*ep^2-1719912378720983085985487541248/
      331832878474297642292945469375*ep^3-67436913073875512185452978431109980\
      416/15863474832684060482864268324935540625*ep^4-11989820446380228297642\
      1606865374599415825975808/371597953502606969919456421311296043918448593\
      75*ep^5-29016837689164161775189595060355807051671221091269944832/
      12435128089953471210200280280539929678611911409072734375*ep^6;
Fill mnchfac1(22,8)=
      32768/504735+7213354010624/56301389869725*ep+2882530576483548740096/
      18840657976538814541125*ep^2+910725032979212811114814879744/
      6304824691011655203565963918125*ep^3+3600991813154125875858030821225567\
      2448/301406021820997149174421098173775271875*ep^4+643886989601390919023\
      46347637310732074867965824/70603611165495324284696720049146248344505232\
      8125*ep^5+15642470921943931856938603300843064339023769706166925696/
      236267433709115952993805325330258663893626316772381953125*ep^6;
Fill mnchfac1(22,10)=
      -8192/4542615-5562313573888/1520137526482575*ep-2265307307282547469952/
      508697765366547992610375*ep^2-725158267118879226334680363328/
      170230266657314690496281025789375*ep^3-28933362872653294042582652859042\
      781376/8137962589166923027709369650691932340625*ep^4-520568399479444585\
      25126066033796625460291034688/19062975014683737556868114413269487053016\
      412859375*ep^5-12699645677051080547117814240906398768455443776609817152/
      6379220710146130730832743783916983925127910552854312734375*ep^6;
Fill mnchfac1(22,12)=
      4096/77224455+2861785174784/25842337950203775*ep+1188986936108863222336/
      8647862011231315874376375*ep^2+385983943086118989229844859104/
      2893914533174349738436777438419375*ep^3+1555210495275940680030962700858\
      3453568/138345364015837691471059284061762849790625*ep^4+281713858062515\
      97501802751344470734586349460384/32407057524962353846675794502558127990\
      1279018609375*ep^5+6904367130707357876096731176747405396863924588894719\
      936/108446752072484222424156644326588726727174479398523316484375*ep^6;
Fill mnchfac1(22,14)=
      -128/77224455-92107901152/25842337950203775*ep-39082274505059099408/
      8647862011231315874376375*ep^2-12879402295078230664046341312/
      2893914533174349738436777438419375*ep^3-5244850139955206056350879524507\
      37104/138345364015837691471059284061762849790625*ep^4-95714287544315204\
      8186356880274330079482289952/324070575249623538466757945025581279901279\
      018609375*ep^5-235780074498604806653923410329417045348156910237070208/
      108446752072484222424156644326588726727174479398523316484375*ep^6;
Fill mnchfac1(22,16)=
      64/1158366825+47481744944/387635069253056625*ep+20600421127746044632/
      129717930168469738115645625*ep^2+1379856370959773100966653608/
      8681743599523049215310332315258125*ep^3+2842308011395603339349332996328\
      38192/2075180460237565372065889260926442746859375*ep^4+5229583433396126\
      73898170304288726912690368704/48610586287443530770013691753837191985191\
      85279140625*ep^5+129556865019910360937793395257963062233911832671889152/
      1626701281087263336362349664898830900907617190977849747265625*ep^6;
Fill mnchfac1(22,18)=
      -16/8108567775-12252881156/2713445484771396375*ep-5442983541528756628/
      908025511179288166809519375*ep^2-370984610303709300320350024/
      60772205196661344507172326206806875*ep^3-541741770621990984093718349138\
      928736/101683842551640703231228573785395694596109375*ep^4-2052696215611\
      2824890581469675838190357916928/486105862874435307700136917538371919851\
      9185279140625*ep^5-35823780429819038845933790843591299215393469184799808
      /11386908967610843354536447654291816306353320336844948230859375*ep^6;
Fill mnchfac1(22,20)=
      8/105411381075+6332372458/35274791302028152875*ep+2884496441406398444/
      11804331645330746168523751875*ep^2+40068509905531577410044976/158007733\
      511319495718648048137697875*ep^3+296656458978635304970034464545198368/
      1321889953171329142005971459210144029749421875*ep^4+1135439219076379187\
      7198815926286703123515104/631937621736765900010177992799883495807494086\
      28828125*ep^5+19957842628748162433017141557085541526770654970625984/
      148029816578940963608973819505793611982593164378984327001171875*ep^6;
Fill mnchfac1(22,22)=
      -1/316234143225-819433166/105824373906084458625*ep-383413267272815608/
      35412994935992238505571255625*ep^2-27181237845756473555515984/237011600\
      2669792435779720722065468125*ep^3-40872020098055931250366286319046096/
      3965669859513987426017914377630432089248265625*ep^4-1582125028602134326\
      134975265181511626491808/1895812865210297700030533978399650487422482258\
      86484375*ep^5-2803571040256992259702239379013002878077204164761088/
      444089449736822890826921458517380835947779493136952981003515625*ep^6;
Fill mnchfac1(23,0)=
      1048576/3+42519666950144/66927861*ep+16117764640820675428352/
      22396692890176605*ep^2+4916822256033218930723353403392/
      7494813743067140424459525*ep^3+1329188644911598202334432724426974703616/
      2508059262084436439978540446630125*ep^4+6684197693303930940701575099321\
      0783356571215872/167859041672549732318218597994938924412625*ep^5+
      11477890342832701810009410232447772818601434197345468416/40123023602334\
      342857789078907929110844920259446875*ep^6;
Fill mnchfac1(23,2)=
      -524288/69-21768376582144/1539340803*ep-8375602077385422217216/
      515123936474061915*ep^2-2580272243587601374400838496256/
      172380716090544229762569075*ep^3-702136083773405432930109465944111392768
      /57685363027942038119506430272492875*ep^4-35464139171644473586629231542\
      322423028880960512/3860757958468643843319027753883595261490375*ep^5-
      6107507124361145387865589070758260748688938202817707008/922829542853689\
      885729148814882369549433165967278125*ep^6;
Fill mnchfac1(23,4)=
      131072/759+5575008821248/16932748833*ep+2178701295587778279424/
      5666363301214681065*ep^2+678208019413177329505688858624/
      1896187876995986527388259825*ep^3+1858501600461628204774155352676723307\
      52/634538993307362419314570732997421625*ep^4+94314235964746337981245997\
      30291304463861871104/42468337543155082276509305292719547876394125*ep^5+
      1629348373216418551652563707856703809682953192335665152/101511249713905\
      88743020636963706065043764825640059375*ep^6;
Fill mnchfac1(23,6)=
      -65536/15939-2857126383616/355587725493*ep-1134879542427718740992/
      118993629325508302365*ep^2-357188547865480560572893852672/
      39819945416915717075153456325*ep^3-140881361081385936278502498027720404\
      48/1903616979922087257943712198992264875*ep^4-5030008069968843820082382\
      281017387077860976128/891835088406256727806695411147110505404276625*
      ep^5-6103490354990504280213952370180361692140664253673759232/
      1492215370794416545224033633664791561433429369088728125*ep^6;
Fill mnchfac1(23,8)=
      8192/79695+1831393409536/8889693137325*ep+739942524904759583744/
      2974840733137707559125*ep^2+235623535029629047272867730816/
      995498635422892926878836408125*ep^3+93682914676148940087435818609981918\
      72/47590424498052181448592804974806621875*ep^4+168160247096686642863145\
      60283190599155321505536/111479386050782090975836926393388813175534578125
      *ep^5+4096046612954382604986251504590101321781433941752134144/
      37305384269860413630600840841619789035835734227218203125*ep^6;
Fill mnchfac1(23,10)=
      -4096/1514205-939743767808/168904169609175*ep-386522588838556133632/
      56521973929616443623375*ep^2-124619433330379533202860160448/
      18914474073034965610697891754375*ep^3-713956974388359284595787048185700\
      288/129174009351855921074751899217332259375*ep^4-9024169471663381838066\
      971604906370551893193408/2118108334964859728540901601474387450335156984\
      375*ep^5-2206962348592962423137354906048766578341138269627840832/
      708802301127347858981415975990775991680878950317145859375*ep^6;
Fill mnchfac1(23,12)=
      1024/13627845+723845084096/4560412579447725*ep+303348998066114433184/
      1526093296099643977831125*ep^2+99104158213634143122765270176/
      510690799971944071488843077368125*ep^3+40114816284533352217379827941640\
      84192/24413887767500769083128108952075797021875*ep^4+729017132425649450\
      4369169602590177376686926496/571889250440512126706043432398084611590492\
      38578125*ep^5+1790753865071395315279594978383125109153700162510187584/
      19137662130438392192498231351750951775383731658562938203125*ep^6;
Fill mnchfac1(23,14)=
      -512/231673365-372001090528/77527013850611325*ep-158997215879735569712/
      25943586033693947623129125*ep^2-52681886037342346539747501568/
      8681743599523049215310332315258125*ep^3-3076981832204068338373832353577\
      01008/59290870292501867773311121740755507053125*ep^4-394187550936056140\
      6886762921062081164462936928/972211725748870615400273835076743839703837\
      055828125*ep^5-972971431409164673146292110227091066502112899598902912/
      325340256217452667272469932979766180181523438195569949453125*ep^6;
Fill mnchfac1(23,16)=
      16/231673365+11959673384/77527013850611325*ep+5218799045569783936/
      25943586033693947623129125*ep^2+1755459894013456818451059704/
      8681743599523049215310332315258125*ep^3+
      72554030069535752494552348768961968/41503609204751307441317785218528854\
      9371875*ep^4+133805860378888157790961535029886365752008384/972211725748\
      870615400273835076743839703837055828125*ep^5+33203900989168781648065234\
      904854991307205271110961536/3253402562174526672724699329797661801815234\
      38195569949453125*ep^6;
Fill mnchfac1(23,18)=
      -8/3475100475-6158310988/1162905207759169875*ep-2746787050051437524/
      389153790505409214346936875*ep^2-187801761526841858742203048/
      26045230798569147645930996945774375*ep^3-
      39269674604059214268914222105985824/62255413807126961161976677827793282\
      40578125*ep^4-73035479277414057528318685430352458034836608/145831758862\
      33059231004107526151157595557555837421875*ep^5-182313199629667736512663\
      89633155947151057261441459264/48801038432617900090870489946964927027228\
      51572933549241796875*ep^6;
Fill mnchfac1(23,20)=
      2/24325703325+1587383362/8140336454314189125*ep+724639681443448196/
      2724076533537864500428558125*ep^2+50414624944191277558592816/1823166155\
      89984033521516978620420625*ep^3+74747185933232136723910458944129792/
      305051527654922109693685721356187083788328125*ep^4+28636482022688957141\
      43569100709471740271456/14583175886233059231004107526151157595557555837\
      421875*ep^5+5036974612827574755265838725329433102805105633953856/
      34160726902832530063609342962875448919059961010534844692578125*ep^6;
Fill mnchfac1(23,22)=
      -1/316234143225-819433166/105824373906084458625*ep-383413267272815608/
      35412994935992238505571255625*ep^2-27181237845756473555515984/237011600\
      2669792435779720722065468125*ep^3-40872020098055931250366286319046096/
      3965669859513987426017914377630432089248265625*ep^4-1582125028602134326\
      134975265181511626491808/1895812865210297700030533978399650487422482258\
      86484375*ep^5-2803571040256992259702239379013002878077204164761088/
      444089449736822890826921458517380835947779493136952981003515625*ep^6;
Fill mnchfac1(24,0)=
      16777216/25+17366559184912384/13943304375*ep+33374413283574558039605248/
      23329888427267296875*ep^2+51388229764415700241549844693549056/
      39035488245141356377393359375*ep^3+699102033793153959975854773105822721\
      42098432/65314043283448865624441157464326171875*ep^4+882770314528551867\
      80029445308724636035459266770427904/10928323025556623197800689973628836\
      2247802734375*ep^5+1520327694244988289926166464482031364650297330164279\
      1425552384/26121760157769754464706431580683014872994960577392578125*
      ep^6;
Fill mnchfac1(24,2)=
      -1048576/75-1109777639604224/41829913125*ep-2163270667311263626313728/
      69989665281801890625*ep^2-3362580067075132823134658137071616/
      117106464735424069132180078125*ep^3-46038150980098947145816902319951920\
      74186752/195942129850346596873323472392978515625*ep^4-58382764417923112\
      67587421620328656385351071491794944/32784969076669869593402069920886508\
      6743408203125*ep^5-1008351141369762085874363677139625419703391032097304\
      620724224/78365280473309263394119294742049044618984881732177734375*ep^6
      ;
Fill mnchfac1(24,4)=
      524288/1725+567602397478912/962088001875*ep+1122927088396648522686464/
      1609762301481443484375*ep^2+1762980368412942069384954078507008/
      2693448688914753590040141796875*ep^3+2430160271877632332748289205190748\
      340299776/4506668986557971728086439865038505859375*ep^4+309592673055262\
      1270505975210069553065942453252918272/754054288763407000648247608180389\
      6995098388671875*ep^5+5363500666303174233064469485898407918283291100409\
      36775078912/1802401450886113058064743779067128026236652279840087890625*
      ep^6;
Fill mnchfac1(24,6)=
      -131072/18975-145223466262528/10582968020625*ep-
      291776653876385611913216/17707385316295878328125*ep^2-
      462935986800603525774110865661952/29627935578062289490441559765625*ep^3
      -642748380897236068970162766542701626489344/495733588521376890089508385\
      15423564453125*ep^4-822865517063911307294927287502098931283514146426368/
      82945971763974770071307236899842866946082275390625*ep^5-204325540713922\
      87012590247688576120915974453057666981397504/28323451371067490912445973\
      67105486898371882154034423828125*ep^6;
Fill mnchfac1(24,8)=
      65536/398475+74352282456064/222242328433125*ep+151812421253969222622208/
      371855091642213444890625*ep^2+243563803671443546017933042994176/
      622186647139308079299272755078125*ep^3+48682912308434151749099266693325\
      836439296/148720076556413067026852515546270693359375*ep^4+4385847850990\
      72903946768832054823142382739886761984/17418654070434701714974519748967\
      00205867727783203125*ep^5+535542267051284391980146420502135852504439842\
      698986050472448/2914483146082844814890690690751546018424666736501422119\
      140625*ep^6;
Fill mnchfac1(24,10)=
      -8192/1992375-9522482405888/1111211642165625*ep-19773201880291424884736/
      1859275458211067224453125*ep^2-32099698092641797157463570411392/
      3110933235696540396496363775390625*ep^3-6469000490712535990591857792568\
      828946432/743600382782065335134262577731353466796875*ep^4-5861146633683\
      3341491034609209990010193613787587328/870932703521735085748725987448350\
      1029338638916015625*ep^5-7184620847140775032186517390201139558008843866\
      6533523490816/145724157304142240744534534537577300921233336825071105957\
      03125*ep^6;
Fill mnchfac1(24,12)=
      4096/37855125+4881476518144/21113021201146875*ep+
      10316478284726114560768/35326233706010277264609375*ep^2+
      16958348815596777287143833570496/59107731478234267533430911732421875*
      ep^3+3447843480754722082198545358730521614016/1412840727285924136755098\
      8976895715869140625*ep^4+3143112464816398324851349371973076879323124839\
      6864/165477213669129666292257937615186519557434139404296875*ep^5+
      38691022579817023813646849535609005489013322930058586255808/
      276875898877870257414615615621396871750343339967635101318359375*ep^6;
Fill mnchfac1(24,14)=
      -1024/340696125-3756293679808/570051572430965625*ep-
      8086526354207597490976/953808310062277486144453125*ep^2-
      13470447600318753590385639736672/1595908749912325223402634616775390625*
      ep^3-2764761230526739398154976684264569825312/3814669963671995169238767\
      02376184328466796875*ep^4-253723391629899013232748141118521045330525067\
      46848/4467884769066500989890964315610036028050721763916015625*ep^5-
      31376761919231440721579377184594082040017781193730891264256/
      7475649269702496950194621621777715537259270179126147735595703125*ep^6;
Fill mnchfac1(24,16)=
      512/5791834125+1928539582304/9690876731326415625*ep+
      4233076455188269586288/16214741271058717264455703125*ep^2+
      7151857259858219788871659235936/27130448748509528797844788485181640625*
      ep^3+1482939125469174701963423585027682142256/6484938938242391787705903\
      940395133583935546875*ep^4+13707860178003829175849276299278965120913963\
      021824/75954041074130516828146393365370612476862269986572265625*ep^5+
      17037554136969949091008784064515771869768269876400411276928/
      127086037584942448153308567570221164133407593045144511505126953125*ep^6
      ;
Fill mnchfac1(24,18)=
      -16/5791834125-61940058472/9690876731326415625*ep-138761007386736375184/
      16214741271058717264455703125*ep^2-238006441580881033030299665848/
      27130448748509528797844788485181640625*ep^3-498974865189540813194347336\
      44664484608/6484938938242391787705903940395133583935546875*ep^4-
      464896762271884549775772339295584685219758288832/7595404107413051682814\
      6393365370612476862269986572265625*ep^5-5810400447251276799619002399723\
      98698627315835525865896704/12708603758494244815330856757022116413340759\
      3045144511505126953125*ep^6;
Fill mnchfac1(24,20)=
      8/86877511875+31862400716/145363150969896234375*ep+72934640903779435052/
      243221119065880758966835546875*ep^2+127138819971262290521514472544/
      406956731227642931967671827277724609375*ep^3+26974726419177199367947256\
      852787753824/97274084073635876815588559105927003759033203125*ep^4+
      253510923106059000447337558037496898864952866496/1139310616111957752422\
      195900480559187152934049798583984375*ep^5+31879826206860384838051402982\
      6887724705598956463592690112/190629056377413672229962851355331746200111\
      3895677167672576904296875*ep^6;
Fill mnchfac1(24,22)=
      -2/608142583125-8204628254/1017542056789273640625*ep-
      19214228474766974288/1702547833461165312767848828125*ep^2-
      34081075015282440599196185936/2848697118593500523773702790944072265625*
      ep^3-51278938110976877572771554928190645792/476643011960815796396383939\
      6190423184192626953125*ep^4-9929469101267174259957074014856473052081788\
      832/1139310616111957752422195900480559187152934049798583984375*ep^5-
      88006542114818516629293318902134755718649435660641276928/
      13344033946418957056097399594873222234007797269740173708038330078125*
      ep^6;
Fill mnchfac1(24,24)=
      1/7905853580625+4231021552/13228046738260557328125*ep+
      10151678126460910744/22133121834995149065982034765625*ep^2+
      18347133858726828484613167168/37033062541715506809058136282272939453125
      *ep^3+28000881410575482659056990331383145296/61963591554906053531529912\
      150475501394504150390625*ep^4+54795804569315211501470196008285538573907\
      54816/14811038009455450781488546706247269432988142647381591796875*ep^5+
      48940109892253114734625888300797575093534786728536600064/
      173472441303446441729266194733351889042101364506622258204498291015625*
      ep^6;
Fill mnchfac1(25,0)=
      16777216/13+17712055548116992/7250518275*ep+34491779685453570345140224/
      12131541982178994375*ep^2+53593899818198107634118071655497728/
      20298453887473505316244546875*ep^3+733688319219147658390615420291054329\
      89679616/33963302507393410124709401881449609375*ep^4+930412045105300862\
      62166663638758767230080445615562752/56827279732894440628563587862869948\
      368857421875*ep^5+16069977079718367584102878631428363160574577275994006\
      292180992/13583315282040272321647344421955167733957379500244140625*ep^6
      ;
Fill mnchfac1(25,2)=
      -8388608/325-9043171637460992/181262956875*ep-
      17851129977077916838068224/303288549554474859375*ep^2-
      27991687854897857821366825432137728/507461347186837632906113671875*ep^3
      -38557839754865374916996972737086095287279616/8490825626848352531177350\
      47036240234375*ep^4-491011959948389470172409917481478713454600280155627\
      52/1420681993322361015714089696571748709221435546875*ep^5-
      8504451114212946329673763558460208400409407457437244532180992/
      339582882051006808041183610548879193348934487506103515625*ep^6;
Fill mnchfac1(25,4)=
      524288/975+577382072614912/543788870625*ep+1155948693463060153278464/
      909865648663424578125*ep^2+1830069213305311216515905477931008/
      1522384041560512898718341015625*ep^3+2537451045021249702792224781605490\
      404427776/2547247688054505759353205141108720703125*ep^4+324572701096439\
      9753322113371825958228491643393334272/426204597996708304714226908971524\
      6127664306640625*ep^5+5638540229469059942115710396620679429583699525021\
      26069414912/1018748646153020424123550831646637580046803462518310546875*
      ep^6;
Fill mnchfac1(25,6)=
      -262144/22425-295047825145856/12507144024375*ep-
      599438390024697636524032/20926909919258765296875*ep^2-
      958642355832695553893071148591104/35014832955891796670521843359375*ep^3
      -1338464525053976141924670515472327543897088/58586696825253632465123718\
      245500576171875*ep^4-17202336877498558904915464910546424699027952879375\
      36/98027057539242910084272189063450660936279052734375*ep^5-
      299804583079235568194116179027981619713711523850836076025856/
      23431218861519469754841669127872664341076479637921142578125*ep^6;
Fill mnchfac1(25,8)=
      65536/246675+75423389732864/137578584268125*ep+155595877215481169271808/
      230196009111846418265625*ep^2+251494338097322514320018965605376/
      385163162514809763375740276953125*ep^3+35374337910720381469773665028558\
      2324361472/644453665077789957116360900700506337890625*ep^4+456962157967\
      642655587386481337432281235836903542784/1078297632931672010926994079697\
      957270299069580078125*ep^5+79915999631938507332753634980409489638730640\
      783972307172864/2577434074767141673032583604065993077518412760171325683\
      59375*ep^6;
Fill mnchfac1(25,10)=
      -32768/5180175-38581969528832/2889150269630625*ep-
      80871996576469041288704/4834116191348774783578125*ep^2-
      132190728269687918905454294924288/8088426412811005030890545816015625*
      ep^3-26772017331997966959682467740219443710848/193336099523336987134908\
      2702101519013671875*ep^4-2434126944395342510016950807108360659360597779\
      05792/22644250291565112229466875673657102676280461181640625*ep^5-
      299100154639266467635805054724526805895980390009819406141824/
      37888280899076982593578978979770098239520667574518487548828125*ep^6;
Fill mnchfac1(25,12)=
      4096/25900875+4936969740544/14445751348153125*ep+
      10522025602754048781568/24170580956743873917890625*ep^2+
      17404111867435445105731789948096/40442132064055025154452729080078125*
      ep^3+507786533476804764497124361201045329088/13809721394524070509636305\
      01501085009765625*ep^4+325081721299169868303589631303078712259514036352\
      64/113221251457825561147334378368285513381402305908203125*ep^5+
      40107147362002255999627000921177563352768017670297230380608/
      189441404495384912967894894898850491197603337872592437744140625*ep^6;
Fill mnchfac1(25,14)=
      -2048/492116625-2528602527872/274469275614909375*ep-
      5483689062573953129984/459241038178133604439921875*ep^2-
      9184965906542946023002847716448/768400509217045477934601852521484375*
      ep^3-1892803641883637217461370864686853982208/1836692945471701377781628\
      56699644306298828125*ep^4-174208875035242472955120734266124632484225366\
      59232/2151203777698685661799353188997424754246643812255859375*ep^5-
      21587708861701796201291997794954719362118261470407146325504/
      3599386685412313346390003003078159332754463419579256317138671875*ep^6;
Fill mnchfac1(25,16)=
      512/4429049625+1944045041504/7410670441602553125*ep+
      4293476208479796712688/12399508030809607319877890625*ep^2+
      7287826067251574594606357176736/20746813748860227904234250018080078125*
      ep^3+1516380233401059269544231645110564979056/4959070952773593720010397\
      130890396270068359375*ep^4+14052355347628595977625339906445914877772590\
      209024/58082501997864512868582536102930468364659382930908203125*ep^5+
      17497023431593976805435203706405435625696190418249136435328/
      97183440506132460352530081083110301984370512328639920562744140625*ep^6;
Fill mnchfac1(25,18)=
      -256/75293843625-997218891952/125981397507243403125*ep-
      2244887703338629936744/210791636523763324437924140625*ep^2-
      3864862345639988856622062742168/352695833730623874371982250307361328125
      *ep^3-812531917089842057090928920189967099328/8430420619715109324017675\
      1225136736591162109375*ep^4-7585982324454544041698773314869250793781564\
      283712/987402533963696718765903113749817962199209509825439453125*ep^5-
      9495149319561033438660533771273421416230966089628746600064/
      1652118488604251825993011378412875133734298709586878649566650390625*
      ep^6;
Fill mnchfac1(25,20)=
      8/75293843625+31999688636/125981397507243403125*ep+73499101218509509892/
      210791636523763324437924140625*ep^2+128463100848089237871361181024/
      352695833730623874371982250307361328125*ep^3+39015379129390238080542234\
      00222114272/12043458028164441891453821603590962370166015625*ep^4+
      257054069153340815768955484004441647654117754816/9874025339636967187659\
      03113749817962199209509825439453125*ep^5+323604789689062266525971775272\
      039722345976704632081657152/1652118488604251825993011378412875133734298\
      709586878649566650390625*ep^6;
Fill mnchfac1(25,22)=
      -4/1129407654375-16446030058/1889720962608651046875*ep-
      38584046632127498176/3161874547856449866568862109375*ep^2-
      68535463273732197822682393072/5290437505959358115579733754610419921875*
      ep^3-14747509352323477015594779484270299712/126456309295726639860265126\
      8377051048867431640625*ep^4-1400422592303363076797360013947912573918447\
      64448/14811038009455450781488546706247269432988142647381591796875*ep^5-
      177423609611020992235723560332763853504216033863629971456/
      24781777329063777389895170676193127006014480643803179743499755859375*
      ep^6;
Fill mnchfac1(25,24)=
      1/7905853580625+4231021552/13228046738260557328125*ep+
      10151678126460910744/22133121834995149065982034765625*ep^2+
      18347133858726828484613167168/37033062541715506809058136282272939453125
      *ep^3+28000881410575482659056990331383145296/61963591554906053531529912\
      150475501394504150390625*ep^4+54795804569315211501470196008285538573907\
      54816/14811038009455450781488546706247269432988142647381591796875*ep^5+
      48940109892253114734625888300797575093534786728536600064/
      173472441303446441729266194733351889042101364506622258204498291015625*
      ep^6;
Fill mnchfac1(26,0)=
      67108864/27+649630401232371712/135528918525*ep+
      3843556378482312345660424192/680299546539114376875*ep^2+180743658470891\
      38731789559108881743872/3414824511684965855894371078125*ep^3+7468254618\
      4320506403371326748725723314168266752/171410175193083202944783373649377\
      60546875*ep^4+285308665580901526549564629704738404621481549505087864832/
      86040872844812405760924392300374553364940048828125*ep^5+148252276811607\
      597936431740727223027010185818920115315444956758016/6169855262224584925\
      5458003136310053809419177085378173828125*ep^6;
Fill mnchfac1(26,2)=
      -16777216/351-165646628713136128/1761875940825*ep-
      992869021182976308479131648/8843894105008486899375*ep^2-471027588439038\
      1684697921828195565568/44392718651904556126626824015625*ep^3-1958000776\
      6259352182949778819218946289555980288/222833227751008163828218385744190\
      887109375*ep^4-75107304966838246289844549830396417787583469300600823808/
      1118531346982561274892017099904869193744220634765625*ep^5-
      39134540878824355427996869965867437394545897295653160929497698304/
      802081184089196040320954040772030699522449302109916259765625*ep^6;
Fill mnchfac1(26,4)=
      8388608/8775+84507609127190528/44046898520625*ep+
      513402251142808971175067648/221097352625212172484375*ep^2+2458220685699\
      909872266034716730605568/1109817966297613903165670600390625*ep^3+
      10283574240209220858405536189237034176480780288/55708306937752040957054\
      59643604772177734375*ep^4+396184253654148331785112741383093866520390000\
      47160823808/27963283674564031872300427497621729843605515869140625*ep^5+
      20703660353367331212131116729703003870777057888570311776377698304/
      20052029602229901008023851019300767488061232552747906494140625*ep^6;
Fill mnchfac1(26,6)=
      -524288/26325-5391380177911808/132140695561875*ep-
      33215245518755050561200128/663292057875636517453125*ep^2-16058574702861\
      9713632277089045557248/3329453898892841709497011801171875*ep^3-
      676309829249678251199848655980832380285319168/1671249208132561228711637\
      8930814316533203125*ep^4-2617601492353915199566412615108467816415046820\
      499237888/83889851023692095616901282492865189530816547607421875*ep^5-
      1372188802814768646866394850862074364218208873352994907440569344/
      60156088806689703024071553057902302464183697658243719482421875*ep^6;
Fill mnchfac1(26,8)=
      262144/605475+2752901188501504/3039235997923125*ep+
      17208424242282188730609664/15255717331139639901421875*ep^2+
      84048492076428854588327707688372224/76577439674535359318431271426953125
      *ep^3+356497911782287490022566096607642301634397184/3843873178704890826\
      03676715408729280263671875*ep^4+138660392885050716302538845074032800223\
      4176695737260544/1929466573544918199188729497335899359208780594970703125
      *ep^5+729325349394415674296458700758127563923360648171098074625385472/
      1383590042553863169553645720331752956676225046139605548095703125*ep^6;
Fill mnchfac1(26,10)=
      -65536/6660225-703178198142976/33431595977154375*ep-
      4462545422059900213974016/167812890642536038915640625*ep^2-
      22030311495404297744336665105478656/842351836419888952502743985696484375
      *ep^3-94150983487223421295080994127079981637808896/42282604965753799086\
      40443869496022082900390625*ep^4-368132768357556964903102637998760496059\
      468581216308736/21224132308994100191076024470694892951296586544677734375
      *ep^5-194330528298366793986428018610659014675268324837017532625223168/
      15219490468092494865090102923649282523438475507535661029052734375*ep^6;
Fill mnchfac1(26,12)=
      32768/139864725+359421571033088/702063515520241875*ep+
      2317184557267464892932608/3524070703493256817228453125*ep^2+
      11569027911845518265656094947708928/17689388564817668002557623699626171\
      875*ep^3+7120116316428773510851087435844011648436864/126847814897261397\
      25921331608488066248701171875*ep^4+195979738057022906699919408289505608\
      761958373134851968/4457067784888761040125965138845927519772283174382324\
      21875*ep^5+727001508571058204571884403955886119727513180090116745509282\
      688/2237265098809596745168245129776444530945455899607742171270751953125
      *ep^6;
Fill mnchfac1(26,14)=
      -4096/699323625-45955708324096/3510317577601209375*ep-
      301182009379201761761536/17620353517466284086142265625*ep^2-
      1521718992703559452465003855542976/884469428240883400127881184981308593\
      75*ep^3-944574573781127318092000510949203801012288/63423907448630698629\
      606658042440331243505859375*ep^4-26156949096304498593664736165667554959\
      183875993950656/2228533892444380520062982569422963759886141587191162109\
      375*ep^5-97440046021263062179803634029601281555382094233630966984760896/
      11186325494047983725841225648882222654727279498038710856353759765625*
      ep^6;
Fill mnchfac1(26,16)=
      2048/13287148875+23518913080448/66696033974422978125*ep+
      156804441053492876519168/334786716831859397636703046875*ep^2+
      802285493068927876775258663585888/1680491913657678460242974251464486328\
      125*ep^3+502566564312988659998541405893129385633344/1205054241523983273\
      962526502806366293626611328125*ep^4+14007882190719792160187804171970039\
      100526623165581728/4234214395644322988119666881903631143783669015663208\
      0078125*ep^5+5242075034812443795692526079710392053986714262481061721234\
      2848/212540184386911690790983287328762230439818310462735506270721435546\
      875*ep^6;
Fill mnchfac1(26,18)=
      -512/119584339875-6022507706912/600264305769806803125*ep-
      40880583424538365276592/3013080451486734578730327421875*ep^2-
      211971581621550334612143732270272/1512442722291910614218676826318037695\
      3125*ep^3-134086167596531257499293116131262095722736/108454881737158494\
      65662738525257296642639501953125*ep^4-376371514229854569249893138017096\
      7154630404903203232/381079295607989068930770019371326802940530211409688\
      720703125*ep^5-14154760103228410683438470291195232826469574180099755828\
      280512/1912861659482205217118849585958860073958364794164619556436492919\
      921875*ep^6;
Fill mnchfac1(26,20)=
      256/2032933777875+3086842967056/10204493198086715653125*ep+
      21351743757980733581896/51222367675274487838415566171875*ep^2+
      112290319656400544561279958507736/2571152627896248044171750604740664082\
      03125*ep^3+71779649495078114090017346539428225865168/184373298953169440\
      916266554929374042924871533203125*ep^4+20302181983327161878423116777213\
      26738673720012717216/64783480253358141718230903293125556499890135939647\
      08251953125*ep^5+767684252828045149218552981862060061632980793136188996\
      4529856/325186482111974886910204429613006212572922015007985324594203796\
      38671875*ep^6;
Fill mnchfac1(26,22)=
      -8/2032933777875-98973637508/10204493198086715653125*ep-
      698292432376584535628/51222367675274487838415566171875*ep^2-
      3728143827628698030611531508248/257115262789624804417175060474066408203\
      125*ep^3-2410201117178919722503048101085575695024/184373298953169440916\
      266554929374042924871533203125*ep^4-68737290123529419116438949433637017\
      683010684673888/6478348025335814171823090329312555649989013593964708251\
      953125*ep^5-261465890566127780030965473188208552278789690817725341361408
      /32518648211197488691020442961300621257292201500798532459420379638671875
      *ep^6;
Fill mnchfac1(26,24)=
      4/30494006668125+50825375974/153067397971300734796875*ep+
      366154384680595325884/768335515129117317576233492578125*ep^2+
      1986601562626566082145836024744/385672894184437206625762590711099612304\
      6875*ep^3+1300071268050783868146646261394829985072/27655994842975416137\
      43998323940610643873072998046875*ep^4+374140296809015906866121121177766\
      08499088923521664/97175220380037212577346354939688334749835203909470623\
      779296875*ep^5+14325315017273017009624508659777911855278705590935046408\
      4224/487779723167962330365306644419509318859383022511977986891305694580\
      078125*ep^6;
Fill mnchfac1(26,26)=
      -1/213458046676875-13064886106/1071471785799105143578125*ep-
      96222908034165970396/5378348605903821223033634448046875*ep^2-
      531150355374104609737853307736/2699710259291060446380338134977697286132\
      8125*ep^3-2465564489559828963828028953611730506176/13551437473057953907\
      3455917873089921549780576904296875*ep^4-1462502302973880420497516516740\
      466640748181173888/9717522038003721257734635493968833474983520390947062\
      3779296875*ep^5-3948386819989313335207424675985515930346418418766734952\
      9856/341445806217573631255714651093656523201568115758384590823913986206\
      0546875*ep^6;
Fill mnchfac1(27,0)=
      33554432/7+47229678395588608/5019589575*ep+1979928360456130264959287296/
      176373956510140764375*ep^2+9389791444050161230739377115371995136/
      885324873399805962639281390625*ep^3+39027799523170633104694270841561213\
      545231384576/4443967505005860817086976353872752734375*ep^4+
      149705299324728350277192879486515966589568437057794031616/2230689295976\
      6179271350768374171180502021494140625*ep^5+5460376526794955444973176337\
      54951718092392161385121222673031520256/11197144735148320790805341309922\
      9356913390358414204833984375*ep^6;
Fill mnchfac1(27,2)=
      -16777216/189-24060419824943104/135528918525*ep-
      1021275810882281951318376448/4762096825773800638125*ep^2-48847618484511\
      68542593702628956602368/23903771581794760991260597546875*ep^3-
      20422029378283213423197924056964334712387289088/11998712263515824206134\
      8361554564323828125*ep^4-7864932395005210660143289762318316406030680592\
      4031684608/602286109913686840326470746102621873554580341796875*ep^5-
      287640579176061823174708492913452617884441662704331636744960380928/
      3023229078490046613517442153679192636661539677183530517578125*ep^6;
Fill mnchfac1(27,4)=
      4194304/2457+6130784542130176/1761875940825*ep+
      263604266382867966991040512/61907258735059408295625*ep^2+12720822016305\
      21635868028390794452992/310749030563331892886387768109375*ep^3+
      5351096981411096217538523375250155301422620672/155983259425705714679752\
      8700209336209765625*ep^4+2069541985761706924123815917869192534462100799\
      6175255552/7829719428877928924244119699334084356209544443359375*ep^5+
      75905626092767095220806824147807483340208026986221099672462405632/
      39301978020370605975726747997829504276600015803385896728515625*ep^6;
Fill mnchfac1(27,6)=
      -2097152/61425-446506522247168/6292414074375*ep-
      136195040980547108025024512/1547681468376485207390625*ep^2-663386829130\
      166899583566670579412992/7768725764083297322159694202734375*ep^3-
      2808745675173311792255651411663392877281820672/389958148564264286699382\
      17505233405244140625*ep^4-109116599492055863082443209317787466841478272\
      53375255552/195742985721948223106102992483352108905238611083984375*ep^5
      -40143695227462643232988449269988176992596583550708282489502405632/
      982549450509265149393168699945737606915000395084647418212890625*ep^6;
Fill mnchfac1(27,8)=
      131072/184275+199262839463936/132140695561875*ep+
      8803920215517798507333632/4643044405129455622171875*ep^2+
      43303012909508135166238019420966912/23306177292249891966479082608203125
      *ep^3+184603411038609380918400682156217598492411392/1169874445692792860\
      09814652515700215732421875*ep^4+720588470056967626388403724478848266876\
      907700831555072/587228957165844669318308977450056326715715833251953125*
      ep^5+2659691717223213300125600005886144356554875792891404850195965952/
      2947648351527795448179506099837212820745001185253942254638671875*ep^6;
Fill mnchfac1(27,10)=
      -65536/4238325-101674673287168/3039235997923125*ep-
      4557288625607446919689216/106790021317977479309953125*ep^2-
      22646102910204729261398916270201856/536042077721747515229018899988671875
      *ep^3-97244059522889073942514056296639369660260096/26907112250934235782\
      25737007861104961845703125*ep^4-381517072742039181430864805990623006807\
      202236053607936/13506266014814427394321106481351295514461464164794921875
      *ep^5-1413109298655974325686795766568503864917637304228805883214629376/
      67795912085139295308128640296255894877135027260840671856689453125*ep^6;
Fill mnchfac1(27,12)=
      16384/46621575+25952700500992/33431595977154375*ep+
      1180772307953913413672704/1174690234497752272409484375*ep^2+
      5930934471526371104064463952116864/5896462854939222667519207899875390625
      *ep^3+25664235646325991518880478773342074674887424/29597823476027659360\
      483107086472154580302734375*ep^4+10123490135372076508861214999409560015\
      3934033004720384/148568926162958701337532171294864250659076105812744140\
      625*ep^5+376375399912234042326236282520703174687866401843937851045311744
      /745755032936532248389415043258814843648485299869247390423583984375*
      ep^6;
Fill mnchfac1(27,14)=
      -8192/979053075-92792569743872/4914444608641693125*ep-
      612566183297137674042752/24668494924452797720599171875*ep^2-
      3111887751366797523268648454320832/123825719953723676017903365897383203\
      125*ep^3-13575946361988279990341912134559071242802112/62155429299658084\
      6570145248815915246186357421875*ep^4-7694640428867099183279788692341513\
      692845980419950656/4457067784888761040125965138845927519772283174382324\
      21875*ep^5-201062345582821961203412221803111702168043012720848403813326\
      272/15660855691667177216177715908435111716618191297254195198895263671875
      *ep^6;
Fill mnchfac1(27,16)=
      1024/4895265375+11856074204224/24572223043208465625*ep+
      79546404235939669823584/123342474622263988602995859375*ep^2+
      408950483992422620757351273566944/6191285997686183800895168294869160156\
      25*ep^3+1799631474555513447100127969690364163700704/3107771464982904232\
      850726244079576230931787109375*ep^4+10263544206692497768945172746700011\
      25420502175483552/22285338924443805200629825694229637598861415871911621\
      09375*ep^5+269359504804390308965363059006957949960450336640687708477754\
      24/78304278458335886080888579542175558583090956486270975994476318359375
      *ep^6;
Fill mnchfac1(27,18)=
      -512/93010042125-6063301831712/466872237820960846875*ep-
      41375059310840359101392/2343507017823015783456921328125*ep^2-
      215406074437353465696286355267072/1176344339560374922170081976025140429\
      6875*ep^3-956723636521831115497390253535357921427952/590476578346751804\
      24163798637511948387703955078125*ep^4-549285180199595360080802404675998\
      228246291816860576/4234214395644322988119666881903631143783669015663208\
      0078125*ep^5-1448378066914705213357129865334926611457856412436323256213\
      3312/148778129070838183553688301130133561307872817323914854389505004882\
      8125*ep^6;
Fill mnchfac1(27,20)=
      128/837090379125+1551520317128/4201850140388647621875*ep+
      10776431228224334372048/21091563160407142051112291953125*ep^2+
      56856699823166106122696383938968/10587099056043374299530737784226263867\
      1875*ep^3+255036314558306052751393698923297325304688/531428920512076623\
      817474187737607535489335595703125*ep^4+14748143493722656852853628273912\
      7112448277681067744/381079295607989068930770019371326802940530211409688\
      720703125*ep^5+39088381624655743022590494802220956557400072323213502826\
      54528/13390031616375436519831947101712020517708553559152336895055450439\
      453125*ep^6;
Fill mnchfac1(27,22)=
      -64/14230536445125-794657436964/71431452386607009571875*ep-
      5622854095658091541924/358556573726921414868908963203125*ep^2-
      30088609899836665359479802901384/17998068395273736309202254233184648574\
      21875*ep^3-136402420372062551060473816877345243797744/90342916487053026\
      04897061191539328103318705126953125*ep^4-794943659333559128571341881406\
      39028824500094239072/64783480253358141718230903293125556499890135939647\
      08251953125*ep^5-211872517732526711551752207223857030554524457165495417\
      5569664/227630537478382420837143100729104348801045410505589727215942657\
      470703125*ep^6;
Fill mnchfac1(27,24)=
      2/14230536445125+25460493602/71431452386607009571875*ep+
      183701767255499948132/358556573726921414868908963203125*ep^2+
      997900776608944786299770585912/1799806839527373630920225423318464857421\
      875*ep^3+4575641407573871164456114981038008685392/903429164870530260489\
      7061191539328103318705126953125*ep^4+2689268952456623435173809676750502\
      785372352391296/6478348025335814171823090329312555649989013593964708251\
      953125*ep^5+72115985840593163825190939980277609898429183982719196509952/
      227630537478382420837143100729104348801045410505589727215942657470703125
      *ep^6;
Fill mnchfac1(27,26)=
      -1/213458046676875-13064886106/1071471785799105143578125*ep-
      96222908034165970396/5378348605903821223033634448046875*ep^2-
      531150355374104609737853307736/2699710259291060446380338134977697286132\
      8125*ep^3-2465564489559828963828028953611730506176/13551437473057953907\
      3455917873089921549780576904296875*ep^4-1462502302973880420497516516740\
      466640748181173888/9717522038003721257734635493968833474983520390947062\
      3779296875*ep^5-3948386819989313335207424675985515930346418418766734952\
      9856/341445806217573631255714651093656523201568115758384590823913986206\
      0546875*ep^6;
Fill mnchfac1(28,0)=
      268435456/29+78000310823201800192/4221474832575*ep+
      13705259305863474244225322713088/614512060760831871763125*ep^2+
      1900396737535984816840884348536253822533632/
      89453351683298308723067654463234375*ep^3+230382762154814676375467511520\
      887291624131368898920448/13021554235190493870361816850537251196417578125
      *ep^4+25729816395581576455947799313251900181505964546260353639004700672/
      1895522878788519733952317742889467458386124622586943359375*ep^5+
      27289635522302797832288155253916947310783942972000450169484212297924667\
      31008/27592765956468442630063600298956953571108538692545868211719262695\
      3125*ep^6;
Fill mnchfac1(28,2)=
      -33554432/203-1417783381204140032/4221474832575*ep-
      1764753420662213284351303745536/4301584425325823102341875*ep^2-
      246724299274542653053615298304309506146304/6261734617830881610614735812\
      42640625*ep^3-30080530515622997281242807109947911026735570880659456/
      91150879646333457092532717953760758374923046875*ep^4-337261153531248372\
      0626053928112633307563318893937998542712029184/132686601515196381376662\
      24200226272208702872358108603515625*ep^5-358654181364220663685421256043\
      866028303257698614289182020678093854557003776/1931493616952790984104452\
      020926986749977597708478210774820348388671875*ep^6;
Fill mnchfac1(28,4)=
      16777216/5481+721813528789385216/113979820479525*ep+
      909617864250871366671252717568/116142779483797223763230625*ep^2+
      128266273419130427778935858604212079460352/1690668346814338034865978669\
      3551296875*ep^3+15731801458459062874861724605820545630008503263510528/
      2461073750451003341498383384751540476122922265625*ep^4+1771122375482489\
      131407724661446651322662802862307638412218785792/3582538240910302297169\
      88053406109349634977553668932294921875*ep^5+188875939383910813440224908\
      531820882541963917016391549687688903358380658688/5215032765772535657082\
      0204565028642249395138128911690920149406494140625*ep^6;
Fill mnchfac1(28,6)=
      -4194304/71253-26258298598326272/211676809461975*ep-
      234608164454328735642686881792/1509856133289363908921998125*ep^2-
      33380086208576460347295268416750675058688/21978688508586394453257722701\
      6166859375*ep^3-4119837889599764895736232768953401979543098167468032/
      31993958755863043439478984001770026189597989453125*ep^4-465846630959792\
      453736529939313491466314995641188990371886082048/4657299713183392986320\
      844694279421545254708197696119833984375*ep^5-49827154379713270548642654\
      399168610951407143016167049098435601437146243072/6779542595504296354206\
      62659345372349242136795675851981961942284423828125*ep^6;
Fill mnchfac1(28,8)=
      2097152/1781325+93648493249429504/37043441655845625*ep+
      121121107470650236830707105792/37746403332234097723049953125*ep^2+
      17395297872399901608477004384985194098688/54946721271465986133144306754\
      04171484375*ep^3+2161206961590891590428243191768898111291015018668032/
      799848968896576085986974600044250654739949736328125*ep^4+24550742692312\
      6342085296753657468481809159160377989587166082048/116432492829584824658\
      021117356985538631367704942402995849609375*ep^5+26343099153947978477562\
      844840295136893832757162784491675006807038986243072/1694885648876074088\
      5516566483634308731053419891896299549048557110595703125*ep^6;
Fill mnchfac1(28,10)=
      -131072/5343975-852371667361792/15875760709648125*ep-
      7823395382930901194566387712/113239209996702293169149859375*ep^2-
      1134657649660520077732580028467088621568/164840163814397958399432920262\
      12514453125*ep^3-141957516581658579287876649573624941830158927652352/
      2399546906689728257960923800132751964219849208984375*ep^4-
      16205234417672867554634353773111996056245312858677300630358528/
      349297478488754473974063352070956615894103114827208987548828125*ep^5-
      17447339115616684769472758028915657154741195100062336784156491596938577\
      92/50846569466282222656549699450902926193160259675688898647145671331787\
      109375*ep^6;
Fill mnchfac1(28,12)=
      65536/122911425+3042555188867072/2555997474253348125*ep+
      4046493030439453208866272256/2604501829924152742890446765625*ep^2+
      592939272338791215948109044484611728384/3791323767731153043186957166028\
      87832421875*ep^3+74731499243488271618484688052859726572116536952576/
      55189578853863749933101247403053295177056531806640625*ep^4+
      8575596434109272443868329469424284560328032645973229880868864/
      8033842005241352901403457097632002165564371641025806713623046875*ep^5+
      926642314882651641635907942273793082993356515274839440196239684569463296
      /1169471097724491121100643087370767302442685972540844668884350440631103\
      515625*ep^6;
Fill mnchfac1(28,14)=
      -16384/1352025675-776125730413568/28115972216786829375*ep-
      1047571167743066070097694464/28649520129165680171794914421875*ep^2-
      155166315451404006305025424054237421696/4170456144504268347505652882631\
      766156640625*ep^3-19709568691031151545789183684673364711169292972544/
      607085367392501249264113721433586246947621849873046875*ep^4-
      2274312036724961045725499054881936992570480425260942746818816/
      88372262057654881915438028073952023821208088051283873849853515625*ep^5-
      246709091298181424800556057734774361190507103539894426009582839461268224
      /1286418207496940233210707396107844032686954569794929135772785484694213\
      8671875*ep^6;
Fill mnchfac1(28,16)=
      8192/28392539175+2773225478169088/4133047915867663918125*ep+
      543009067551576672294069632/601639922712479283607693202859375*ep^2+
      81347195677309554873120073670653344448/87579579034589635297618710535267\
      089289453125*ep^3+10418667989608048871227025895483961490140450436672/
      12748792715242526234546388150105311185900058847333984375*ep^4+
      172768041259637764103201967883768041289678558529754183262144/
      265116786172964645746314084221856071463624264153851621549560546875*ep^5
      +1317377173508245057603091998144393670224200055624180334524059623712725\
      12/27014782357435744897424855318264724686426045965693511851228495178578\
      4912109375*ep^6;
Fill mnchfac1(28,18)=
      -1024/141962695875-354106271372096/20665239579338319590625*ep-
      70453462258868250376632544/3008199613562396418038466014296875*ep^2-
      10681188283445737339429109293960454816/43789789517294817648809355267633\
      5446447265625*ep^3-1380075511667490842832798797457569474979701912224/
      63743963576212631172731940750526555929500294236669921875*ep^4-
      67145682818095580610947258788168820024392305099369131936/
      3864676183279368013794665950755919409090732713612997398681640625*ep^5-
      17640615700109101983678667796127957672172913901196619315294425458757504/
      13507391178717872448712427659132362343213022982846755925614247589289245\
      60546875*ep^6;
Fill mnchfac1(28,20)=
      512/2697291221625+180975812844448/392639552007428072221875*ep+
      36613273487379026559129872/57155792657685531942730854271640625*ep^2+
      5621105961260356986446440771733187808/832006000828601535327377750085037\
      3482498046875*ep^3+733103740129022916779999616698035214430591121712/
      1211135307948039992281906874260004562660505590496728515625*ep^4+
      12317864429235793766898841203148111664821038654717446948224/
      25186094686431641345899838001076326789044305094615904047208251953125*
      ep^5+948091925251122620597947110262867630209779014607167910071036606087\
      6352/256640432395639576525536125523514884521047436674088362586670704196\
      49566650390625*ep^6;
Fill mnchfac1(28,22)=
      -128/24275620994625-46279104127912/3533755968066852649996875*ep-
      9527582880178278290327168/514402133919169787484577688444765625*ep^2-
      1482327163387780881921592259551637752/748805400745741381794639975076533\
      61342482421875*ep^3-195263687549274516490614347715060845607056304128/
      10900217771532359930537161868340041063944550314470556640625*ep^4-
      3305054706845087125787362265778634187966339558508958639456/
      226674852177884772113098542009686941101398745851543136424874267578125*
      ep^5-255732835116729038131395101627374211551410581347662751296292833844\
      4288/230976389156075618872982512971163396068942693006679526328003633776\
      846099853515625*ep^6;
Fill mnchfac1(28,24)=
      64/412685556908625+23687573137556/60073851457136495049946875*ep+
      4966624084805107263915484/8744836276625886387237820703561015625*ep^2+
      783691935805179696109766787296812976/1272969181267760349050887957630107\
      142822201171875*ep^3+104342464025131271643791488517218271068620824464/
      185303702116050118819131751761780698087057355345999462890625*ep^4+
      1780165454219690475543600437156611801564780054910904374528/
      3853472487024041125922675214164677998723778679476233319222862548828125*
      ep^5+138536694564379745585493940167218309081679863298020415294600162817\
      2544/392659861565328552084070272050977773317202578111355194757606177420\
      6383697509765625*ep^6;
Fill mnchfac1(28,26)=
      -2/412685556908625-758432672758/60073851457136495049946875*ep-
      162107227736906342974712/8744836276625886387237820703561015625*ep^2-
      25965225541476206236959582507462568/12729691812677603490508879576301071\
      42822201171875*ep^3-3496933781271290560942870060005166753083796352/
      185303702116050118819131751761780698087057355345999462890625*ep^4-
      8596455469392886447004131095711487921421294473234579072/
      550496069574863017988953602023525428389111239925176188460408935546875*
      ep^5-471250366639899962264741295683171401955803852941646732231550468817\
      92/39265986156532855208407027205097777331720257811135519475760617742063\
      83697509765625*ep^6;
Fill mnchfac1(28,28)=
      1/6190283353629375+388920876224/901107771857047425749203125*ep+
      84827912008321292632636/131172544149388295808567310553415234375*ep^2+
      13805828622791011074395112263112704/19094537719016405235763319364451607\
      142333017578125*ep^3+1882446104598762122550738656233208736235589056/
      2779555531740751782286976276426710471305860330189991943359375*ep^4+
      32697347461181348958224518309789769409688869127892160512/
      57802087305360616888840128212470169980856680192143499788342938232421875
      *ep^5+25783707310834906055388638332911578193458006963614675719440400645\
      376/5889897923479928281261054080764666599758038671670327921364092661309\
      5755462646484375*ep^6;
Fill mnchfac1(29,0)=
      268435456/15+79257917585266573312/2183521465125*ep+
      14082891378046516465513244131328/317851065910775106084375*ep^2+
      1968269941312660162454311760742311570440192/
      46268975008602573477448786791328125*ep^3+239944704573899557950976765485\
      369914839729017078284288/6735286673374393381221629405450302342974609375
      *ep^4+26901942430543726177519644383992455040845896943743748686603026432/
      980442868338889517561543660115241788820409287544970703125*ep^5+
      28608814063094621616929834374093885937016264591586418731850654086302322\
      19648/14272120322311263429343241533943251847125106220282345626751342773\
      4375*ep^6;
Fill mnchfac1(29,2)=
      -134217728/435-40302676700882272256/63322122488625*ep-
      7243748584835602279875151396864/9217680911412478076446875*ep^2-
      1020495615536691873520063422624401007312896/134180027524947463084601481\
      6948515625*ep^3-125094821440030965533796911652229219856791820063801344/
      195323313527857408055427252758058767946263671875*ep^4-14078895876858729\
      011030453479892953337926483684809407404514902016/2843284318182779600928\
      4766143342011875791869338804150390625*ep^5-1501110982125721640738010242\
      999887437541830459199997823862163514406776193024/4138914893470266394509\
      540044843543035666280803881880231757889404296875*ep^6;
Fill mnchfac1(29,4)=
      16777216/3045+732150999339237376/63322122488625*ep+
      932113030150616026686788599808/64523766379887346535128125*ep^2+
      132407877678411666109085172454083248422912/9392601926746322415922103718\
      639609375*ep^3+16325222782533530750689856727553302830634968355258368/
      1367263194695001856387990769306411375623845703125*ep^4+1844734542627840\
      279531629439906198990462907784022918218881687552/1990299022727945720649\
      93363003394083130543085371629052734375*ep^5+197229390554490058841721263\
      859277755317074912891755655258652815116503011328/2897240425429186476156\
      6780313904801249663965627173161622305225830078125*ep^6;
Fill mnchfac1(29,6)=
      -8388608/82215-372536418763276288/1709697307192875*ep-
      480115993762648425853104226304/1742141692256958356448459375*ep^2-
      68792441501256607010885907383211104813056/25360025202215070522989680040\
      3269453125*ep^3-8533499718813307797737510939859624665709024859971584/
      36916106256765050122475750771273107141843833984375*ep^4-968374875779764\
      607343255206490316787606519468083508988605157376/5373807361365453445754\
      820801091640244524663305033984423828125*ep^5-10383560225885705779679585\
      4009299423142981828867980393611178852407077976064/782254914865880348562\
      303068475429633740927071933675363802241097412109375*ep^6;
Fill mnchfac1(29,8)=
      2097152/1068795+94811458686287872/22226064993507375*ep+
      123744793277249931884093259776/22647841999340458633829971875*ep^2+
      17890929381258590269640353169567465304064/32968032762879591679886584052\
      42502890625*ep^3+2233542181844387633388370485630640498230493212164096/
      479909381337945651592184760026550392843969841796875*ep^4+25459881457909\
      3322246107663394170283825446293965943694253446144/698594956977508947948\
      12670414191323178820622965441797509765625*ep^5+273843415304292133240321\
      03915152878935802574092783608203126866351582729216/10169313893256444531\
      309939890180585238632051935137779729429134266357421875*ep^6;
Fill mnchfac1(29,10)=
      -1048576/26719875-48277953420787712/555651624837684375*ep-
      63840160993574737232086245376/566196049983511465845749296875*ep^2-
      9317188322273311630692688173220436056064/824200819071989791997164601310\
      62572265625*ep^3-1171022506112315848914280713211627039319855251204096/
      11997734533448641289804619000663759821099246044921875*ep^4-
      134117948031521896243662013999611493424938497173937427442246144/
      1746487392443772369870316760354783079470515574136044937744140625*ep^5-
      14473102547575532796867996263719745999378649743891141497653477660238729\
      216/2542328473314111132827484972545146309658012983784444932357283566589\
      35546875*ep^6;
Fill mnchfac1(29,12)=
      65536/80159625+3074157510520832/1666954874513053125*ep+
      4120530679820038543209051136/1698588149950534397537247890625*ep^2+
      607316678995118540338298005147498824704/2472602457215969375991493803931\
      87716796875*ep^3+76872487200670492079149577557250388361510102157056/
      35993203600345923869413857001991279463297738134765625*ep^4+
      8848629323859593078415040855675252190618655480091820715075584/
      5239462177331317109610950281064349238411546722408134813232421875*ep^5+
      958238831627865068688602874876986237001342032309995517595871976961573376
      /7626985419942333398482454917635438928974038951353334797071850699768066\
      40625*ep^6;
Fill mnchfac1(29,14)=
      -32768/1843671375-1566705931810816/38339962113800221875*ep-
      2129675636204318022550880768/39067527448862291143356701484375*ep^2-
      317137158237866136784951153195206065152/5686985651596729564780435749043\
      317486328125*ep^3-40443419810193577721448122688991439608311518457728/
      827843682807956248996518711045799427655847977099609375*ep^4-
      4680282996070722134095062352447908248706786647032089264606592/
      120507630078620293521051856464480032483465574615387100704345703125*ep^5
      -5087411502625701222062029367539867003831574383754565813600912625983898\
      88/17542066465867366816509646310561509536640289588112670033265256609466\
      552734375*ep^6;
Fill mnchfac1(29,16)=
      8192/20280385125+399419949551104/421739583251802440625*ep+
      550918891578679085471019392/429742801937485202576923716328125*ep^2+
      82929572060390529289934380309550385088/62556842167564025212584793239476\
      492349609375*ep^3+10659577681904434410649399593486097501706236317632/
      9106280510887518738961705821503793704214327748095703125*ep^4+
      1240602314707394842083085718121281131944103338459917193456448/
      1325583930864823228731570421109280357318121320769258107747802734375*
      ep^5+135394020243967855161420817019445591882651804930829000344090092618\
      804672/1929627311245410349816061094161766049030431854692393703659178227\
      04132080078125*ep^6;
Fill mnchfac1(29,18)=
      -4096/425888087625-1426362534289664/61995718738014958771875*ep-
      285346725823217559206696896/9024598840687189254115398042890625*ep^2-
      43442756509046482665985073453396493344/13136936855188445294642806580290\
      06339341796875*ep^3-5630925956322699129602666919245718765310350510016/
      191231890728637893518195822251579667788500882710009765625*ep^4-
      94190527102301505391768969675610231373927636452786569286432/
      3976751792594469686194711263327841071954363962307774323243408203125*
      ep^5-722673887384131143320999300159805770166156516759282087866502091188\
      17536/40522173536153617346137282977397087029639068948540267776842742767\
      86773681640625*ep^6;
Fill mnchfac1(29,20)=
      512/2129440438125+182021860086688/309978593690074793859375*ep+
      36993169523306404038399632/45122994203435946270576990214453125*ep^2+
      5699595829354635323848872785757564448/656846842759422264732140329014503\
      1696708984375*ep^3+745349710660113300552135263436505170185622386672/
      956159453643189467590979111257898338942504413550048828125*ep^4+
      12548809741240576471552120191292257784413977252767866262144/
      19883758962972348430973556316639205359771819811538871616217041015625*
      ep^5+967277081904290419053196331379835200004845498616917542038346637127\
      2512/202610867680768086730686414886985435148195344742701338884213713839\
      33868408203125*ep^6;
Fill mnchfac1(29,22)=
      -256/40459368324375-92972268622544/5889593280111421083328125*ep-
      19208889829017034792830616/857336889865282979140962814074609375*ep^2-
      2996966417354089544553996419174488424/124800900124290230299106662512755\
      602237470703125*ep^3-395636050075851119848821969352883752133494815136/
      18167029619220599884228603113900068439907583857450927734375*ep^4-
      6707427330629255807000958198416402866443748497728469344672/
      377791420296474620188497570016144901835664576419238560708123779296875*
      ep^5-519610709676834831630190455284231793368172406826739330957879626762\
      9056/384960648593459364788304188285272326781571155011132543880006056294\
      743499755859375*ep^6;
Fill mnchfac1(29,24)=
      64/364134314919375+23760642614036/53006339521002789749953125*ep+
      4994377543079856463428004/7716032008787546812268665326671484375*ep^2+
      789631717561682112027013979882638256/1123208101118612072691959962614800\
      420137236328125*ep^3+105294856240590388546697084741673514182601462384/
      163503266572985398958057428025100615959168254717058349609375*ep^4+
      1798504228831165896033031633178018829749773850320307418368/
      3400122782668271581696478130145304116520981187773147046373114013671875*
      ep^5+140083976723429652116797928857912161173732156870952118196087355533\
      2864/346464583734113428309473769456745094103414039510019289492005450665\
      2691497802734375*ep^6;
Fill mnchfac1(29,26)=
      -32/6190283353629375-12154331843818/901107771857047425749203125*ep-
      2601264240070237729885952/131172544149388295808567310553415234375*ep^2-
      417090040367725115703183962138163928/1909453771901640523576331936445160\
      7142333017578125*ep^3-56218898928266882659244528212543918768728123392/
      2779555531740751782286976276426710471305860330189991943359375*ep^4-
      968022519208615774851882801669285770568613657945415123584/
      57802087305360616888840128212470169980856680192143499788342938232421875
      *ep^5-75844296458151975550788922019058025932062179333969944978620650451\
      7632/588989792347992828126105408076466659975803867167032792136409266130\
      95755462646484375*ep^6;
Fill mnchfac1(29,28)=
      1/6190283353629375+388920876224/901107771857047425749203125*ep+
      84827912008321292632636/131172544149388295808567310553415234375*ep^2+
      13805828622791011074395112263112704/19094537719016405235763319364451607\
      142333017578125*ep^3+1882446104598762122550738656233208736235589056/
      2779555531740751782286976276426710471305860330189991943359375*ep^4+
      32697347461181348958224518309789769409688869127892160512/
      57802087305360616888840128212470169980856680192143499788342938232421875
      *ep^5+25783707310834906055388638332911578193458006963614675719440400645\
      376/5889897923479928281261054080764666599758038671670327921364092661309\
      5755462646484375*ep^6;
Fill mnchfac1(30,0)=
      1073741824/31+9979074250129694261248/139890941865675*ep+
      55561575535333391193766474444439552/631273406969860079023974375*ep^2+
      242579953380780498786203325032020785111727341568/2848691337927977150697\
      798735087609421875*ep^3+92171906492868117670384297402405443859850510839\
      1338520870912/12855035946688212509626306180978461918178258730859375*
      ep^4+321573588208152967151109544887892296919447341058747348917434752997\
      3137408/580097769773975201525456094929659981188758593748499301373730468\
      75*ep^5+106289853282720462094841819733484468255437601141487116179120983\
      97149645240626751209472/26177555931567382290692474565949893082829400811\
      9009291129825421517782958984375*ep^6;
Fill mnchfac1(30,2)=
      -268435456/465-2535146722500146102272/2098364127985125*ep-
      14271731585745417099392829681041408/9469101104547901185359615625*ep^2-
      62791747456575801927692462892683153545910812672/42730370068919657260466\
      981026314141328125*ep^3-23987492396667781197054759288926113779909771713\
      2906831413248/192825539200323187644394592714676928772673880962890625*
      ep^4-840016044760872457195230616985502179756529733361823291638486607084\
      716032/8701466546609628022881841423944899717831378906227489520605957031\
      25*ep^5-278360185430874000136716516656785767159305475408040202347912320\
      2803674843514029375488/392663338973510734360387118489248396242441012178\
      5139366947381322766744384765625*ep^6;
Fill mnchfac1(30,4)=
      134217728/13485+1288458616405791604736/60852559711568625*ep+
      7336359329473321050467830573563904/274603932031889134375428853125*ep^2+
      32537464625356927413998478954159333709511131136/12391807319986700605535\
      42449763110098515625*ep^3+125000528248480466303815289139379376825242311\
      284551844429824/5591940636809372441687443188725630934407542547923828125
      *ep^4+43945901418286876090335817874352991257660633666066972602149926099\
      6386816/252342529851679212663573401294402091817109988280597196097572753\
      90625*ep^5+146018394762756526113411617647580112558050340828800699188648\
      5942809235110359107026944/113872368302318112964512264361882034910307893\
      531769041641474058360235587158203125*ep^6;
Fill mnchfac1(30,6)=
      -16777216/94395-23394460241631379456/60852559711568625*ep-
      943437441003849812089947793522688/1922227524223223940628001971875*ep^2-
      4219231871042162864050436205165916811992072192/867426512399069042387479\
      7148341770689609375*ep^3-1630505718358282598808255046216665081958880976\
      2757977980928/39143584457665607091812102321079416540852797835466796875*
      ep^4-575601760892008666063646866943995795712771921736318069812413368433\
      13152/17663977089617544886450138090608146427197699179641803726830092773\
      4375*ep^5-1917996607887825408256340990298835355943425332138494594708855\
      52145618836563080941568/79710657811622679075158585053317424437215525472\
      2383291490318408521649110107421875*ep^6;
Fill mnchfac1(30,8)=
      8388608/2548665+11897518612719075328/1643019112212352875*ep+
      485638058126995029210380974751744/51900143154027046396956053240625*ep^2
      +2190782441324191059393974498566489182422941696/23420515834774864144461\
      9523005227808619453125*ep^3+8518682258624894431622791452917672120477811\
      687634133540864/1056876780356971391478926762669144246603025541557603515\
      625*ep^4+30203847285476720175703822368096409068156651355034023726515298\
      608050176/4769273814196737119341537284464199535343378778503287006244125\
      048828125*ep^5+10094791240721367127043706479149166202867332874974569010\
      3289407210954293333367773184/215218776091381233502928179643957045980481\
      91877504348870238597030084525972900390625*ep^6;
Fill mnchfac1(30,10)=
      -2097152/33132645-3026377627039301632/21359248458760587375*ep-
      125086362815637269475044303323136/674701861002351603160428692128125*
      ep^2-569405844957389010843482851516773535543988224/30446670585207323387\
      80053799067961512052890625*ep^3-222849776063005693106133279099365716741\
      2168045891561660416/137393981446406280892260479146988752058393320402488\
      45703125*ep^4-793774426638169395943856912383896366905419620251710434076\
      3184865209344/620005595845575825514399846980345939594639241205427310811\
      73625634765625*ep^5-266146685753927436252517602236351506019674624119739\
      35667805653154030463348655594496/27978440891879560355380663353714415977\
      4626494407556535313101761391098837647705078125*ep^6;
Fill mnchfac1(30,12)=
      1048576/828316125+1540227759926607872/533981211469014684375*ep+
      64489307064807723157632960372736/16867546525058790079010717303203125*
      ep^2+296343528808450223189375221763085687456180224/76116676463018308469\
      501344976699037801322265625*ep^3+11677402033612373620143784831535823011\
      01743571706528700416/34348495361601570223065119786747188014598330100622\
      1142578125*ep^4+4179654425968419054611269355339229407463931138023686547\
      390302838009344/1550013989613939563785999617450864848986598103013568277\
      029340640869140625*ep^5+14061780473917996745570540788493031785123459164\
      391707162047504525655487297871594496/6994610222969890088845165838428603\
      994365662360188913382827544034777470941192626953125*ep^6;
Fill mnchfac1(30,14)=
      -65536/2484948375-98024583068782592/1601943634407044053125*ep-
      4159599512464964778362237572096/50602639575176370237032151909609375*
      ep^2-19303581160182341180962373722201988251710464/228350029389054925408\
      504034930097113403966796875*ep^3-76613327427655839239109308352236140593\
      818553672929656576/1030454860848047106691953593602415640437949903018663\
      427734375*ep^4-27563365771619571644578456828473600956555429460110273762\
      0545618870784/465004196884181869135799885235259454695979430904070483108\
      8021922607421875*ep^5-9306874247647668615944460379566680248290861393591\
      60051905151613427294783783251456/20983830668909670266535497515285811983\
      096987080566740148482632104332412823577880859375*ep^6;
Fill mnchfac1(30,16)=
      32768/57153812625+49930734007453696/36844703591362013221875*ep+
      2148374793902090112834545013248/1163860710229056515451739493921015625*
      ep^2+10073302744746764976823981444043721952940032/525205067594826328439\
      5592803392233608291236328125*ep^3+4028305054224406844546265659811795142\
      6939694500786671488/237004617995050834539149326528555597300728477694292\
      58837890625*ep^4+145720382689201803194366775255126019235347475793515734\
      520907721144192/1069509652833618299012339736041096745800752691079362111\
      15024504219970703125*ep^5+493934121335285314488992366902399302840066317\
      298498769161534711014367457903084928/4826281053849224161303164428515736\
      75611230702853035023415100538399645494942291259765625*ep^6;
Fill mnchfac1(30,18)=
      -8192/628691938875-12722730966413824/405291739504982145440625*ep-
      555361387223274046608681264512/12802467812519621669969134433131171875*
      ep^2-2632240682571576364976485157432666176575808/5777255743543089612835\
      1520837314569691203599609375*ep^3-1061068437793944096830858104292656645\
      5328157102267915072/260705079794555917993064259181411157030801325463721\
      847216796875*ep^4-38606545278560498066837095779632369427121833430854438\
      429399863030848/1176460618116980128913573709645206420380827960187298322\
      265269546419677734375*ep^5-13140245405991759883341580636831112143179510\
      6603380086690926529501432282624154432/530890915923414657743348087136731\
      0431723537731383385257566105922396100444365203857421875*ep^6;
Fill mnchfac1(30,20)=
      4096/13202530716375+45409732419133184/59577885707232375379771875*ep+
      287438620244480061132327211456/268851824062912055069351823095754609375*
      ep^2+1377886945455635176939362480484709707140704/1213223706144048818695\
      381937583605963515275591796875*ep^3+56014311330314820205015346061515824\
      47844337503041012736/54748066756856742778543494428096342976468278347381\
      58791552734375*ep^4+292956330155078587213408905911051381961300322846231\
      3849011785976032/352938185435094038674072112893561926114248388056189496\
      6795808639259033203125*ep^5+7010788691715294894372209626497762466713047\
      0809852598583900944336963428956308416/111487092343917078126103098298713\
      519066194292359051090408888224370318109331669281005859375*ep^6;
Fill mnchfac1(30,22)=
      -512/66012653581875-5791739394706528/297889428536161876898859375*ep-
      37236620883731024772630291152/1344259120314560275346759115478773046875*
      ep^2-180637587484083746197841950938659651013568/60661185307202440934769\
      09687918029817576377958984375*ep^3-740936250095857415988023244601047423\
      299645130910220912/2737403337842837138927174721404817148823413917369079\
      3957763671875*ep^4-3900779633593622484006607602695851297329674336255356\
      10987824325344/17646909271754701933703605644678096305712419402809474833\
      979043196295166015625*ep^5-93795804063662123746399727623494736767304620\
      79226291935047578640827896233769472/55743546171958539063051549149356759\
      5330971461795255452044441121851590546658346405029296875*ep^6;
Fill mnchfac1(30,24)=
      256/1254240418055625+2956671193308464/5659899142187075661078328125*ep+
      19320537127806141023822664376/25540923285976645231588423194096687890625
      *ep^2+94907534210903578211849391543155806490984/11525625208368463777606\
      1284070442566533951181220703125*ep^3+3930092190223125343002029020998314\
      02488123181006938256/52010663419013905639616319706691525827644864430012\
      5085197509765625*ep^4+2976765016029416621650160150000880714650210342271\
      3059732175600896/478987537376199052486240724641262614012194240933400031\
      20800260104229736328125*ep^5+503621975544884753327265884970504261681694\
      5103125390610799916073794961403201536/105912737726721224219797943383777\
      84311288457774109853588844381315180220386508581695556640625*ep^6;
Fill mnchfac1(30,26)=
      -64/11288163762500625-755212637537516/50939092279683680949704953125*ep-
      5019466552872653062484062444/229868309573789807084295808746870191015625
      *ep^2-24985266892769995625068909234641658719896/10373062687531617399845\
      51556633983098805560630986328125*ep^3-104516126473131649169952945713863\
      118431753957930017664/4680959707711251507565468773602237324488037798701\
      125766777587890625*ep^4-55836567343361282277724404493124282107879182910\
      821380054771168768/3017621485470054030663316565239954468276823717880420\
      196610416386566473388671875*ep^5-13570427703558731776019144942055402312\
      56641862301257393265823247163391848073984/95321463954049101797818149045\
      400058801596119966988682299599431836621983478577235260009765625*ep^6;
Fill mnchfac1(30,28)=
      32/191898783962510625+386100645409558/865964568754622576144984203125*ep
      +2612222807634216617065555172/39077612627544267204330287486967932472656\
      25*ep^2+13186042002216019682283767030369636429248/176342065688037495797\
      37376462777712679694530726767578125*ep^3+557582678573824279794689776716\
      64356259388587424700032/79576315031091275628612969151238034516296642577\
      919138035218994140625*ep^4+42903855118381948393143647676680347530180964\
      28120601984630474112/73285093218558455030394830870113179943865718862810\
      20477482439795947149658203125*ep^5+734326162105216794673641156751346459\
      833444411463144928944024730808624668584192/1620464887218834730562908533\
      771800999627134039438807599093190341222573719135812999420166015625*ep^6
      ;
Fill mnchfac1(30,30)=
      -1/191898783962510625-12347683358294/865964568754622576144984203125*ep-
      85114480994316988246696096/3907761262754426720433028748696793247265625*
      ep^2-436069346667442343847318558027528918464/17634206568803749579737376\
      462777712679694530726767578125*ep^3-18654340794626727598833755208267321\
      35180736766528576/79576315031091275628612969151238034516296642577919138\
      035218994140625*ep^4-10136823521329120662307781492859245838866065811126\
      61666970474112/51299565252990918521276381609079225960706003203967143342\
      377078571630047607421875*ep^5-24948972511246495142796358164207857912831\
      761190063538178659686989159424083456/1620464887218834730562908533771800\
      999627134039438807599093190341222573719135812999420166015625*ep^6;
*--#] harmo1 : 
*--#[ harmo2 :
#procedure harmo2(P,Q,TT)
*
*   Routine to generate the harmonic projection for
*   P(mnci1)*P(mnci2)*...*P(in) = TT(mnci1,mnci2,...,in) at P->Q
*   The object mnchfac2 is a table to give better speed.
*
*id  `P'.`P' = 0;
*id  `Q'.`P' = `Q'.`Q';
ToTensor,`TT',`P';
*
*   Next generate the splits between indices that connect to a Q and
*   the indices that go to d_.
*
id  'TT'(?a) = sum_(mncj,0,nargs_(?a),2,`Q'.`Q'^(mncj/2)*
               acc(mnchfac2(nargs_(?a),mncj))*distrib_(1,mncj,mncdd,`TT',?a));
*
*   The indices in TT contract with Q and the indices in mncdd go to d_'mncs.
*	We used mncdd as an intemediary to have the mnchfac2 worked out before
*	the dd_ is expanded. At that moment there are fewer terms. 
*
tovector,`TT',`Q';
id	mncdd = 1;
id  mncdd(?a) = dd_(?a);
id  D = acc(4-2*ep);
*
#endprocedure
*
*	Table is good up to D12 or P10.
*	We have only terms up to ep^3 as the integrals at this point can have
*	divergences up to ep^-3 only.
*
CTable,relax,mnchfac2(2:12,0:12);
Fill mnchfac2(2,0) =
       - 1/3 - 2/9*ep - 4/27*ep^2 - 8/81*ep^3;
Fill mnchfac2(2,2) =
      1/3 + 2/9*ep + 4/27*ep^2 + 8/81*ep^3;
Fill mnchfac2(3,0) =
       - 1 - 2/3*ep - 4/9*ep^2 - 8/27*ep^3;
Fill mnchfac2(3,2) =
      1/3 + 2/9*ep + 4/27*ep^2 + 8/81*ep^3;
Fill mnchfac2(4,0) =
       - 12/5 - 44/25*ep - 464/375*ep^2 - 4784/5625*ep^3;
Fill mnchfac2(4,2) =
      7/15 + 82/225*ep + 892/3375*ep^2 + 9352/50625*ep^3;
Fill mnchfac2(4,4) =
       - 2/15 - 32/225*ep - 392/3375*ep^2 - 4352/50625*ep^3;
Fill mnchfac2(5,0) =
       - 16/3 - 196/45*ep - 2176/675*ep^2 - 23056/10125*ep^3;
Fill mnchfac2(5,2) =
      11/15 + 146/225*ep + 1676/3375*ep^2 + 18056/50625*ep^3;
Fill mnchfac2(5,4) =
       - 2/15 - 32/225*ep - 392/3375*ep^2 - 4352/50625*ep^3;
Fill mnchfac2(6,0) =
       - 80/7 - 1516/147*ep - 123292/15435*ep^2 - 9367864/1620675*ep^3;
Fill mnchfac2(6,2) =
      128/105 + 13136/11025*ep + 1103012/1157625*ep^2 + 85160504/121550625*
      ep^3;
Fill mnchfac2(6,4) =
       - 17/105 - 1994/11025*ep - 176048/1157625*ep^2 - 13936016/121550625*
      ep^3;
Fill mnchfac2(6,6) =
      1/35 + 142/3675*ep + 13864/385875*ep^2 + 1162288/40516875*ep^3;
Fill mnchfac2(7,0) =
       - 24 - 828/35*ep - 23372/1225*ep^2 - 1815224/128625*ep^3;
Fill mnchfac2(7,2) =
      44/21 + 4904/2205*ep + 427988/231525*ep^2 + 33759896/24310125*ep^3;
Fill mnchfac2(7,4) =
       - 23/105 - 2846/11025*ep - 259232/1157625*ep^2 - 20909744/121550625*
      ep^3;
Fill mnchfac2(7,6) =
      1/35 + 142/3675*ep + 13864/385875*ep^2 + 1162288/40516875*ep^3;
Fill mnchfac2(8,0) =
       - 448/9 - 21472/405*ep - 5657152/127575*ep^2 - 1345089952/40186125*ep^3
      ;
Fill mnchfac2(8,2) =
      232/63 + 83236/19845*ep + 22561876/6251175*ep^2 + 5445734776/1969120125*
      ep^3;
Fill mnchfac2(8,4) =
       - 20/63 - 1564/3969*ep - 440248/1250235*ep^2 - 108447328/393824025*ep^3
      ;
Fill mnchfac2(8,6) =
      31/945 + 13486/297675*ep + 4006936/93767625*ep^2 + 1017493936/
      29536801875*ep^3;
Fill mnchfac2(8,8) =
       - 4/945 - 1984/297675*ep - 637984/93767625*ep^2 - 170185984/29536801875
      *ep^3;
Fill mnchfac2(9,0) =
       - 512/5 - 183872/1575*ep - 50077472/496125*ep^2 - 12133597472/156279375
      *ep^3;
Fill mnchfac2(9,2) =
      296/45 + 112916/14175*ep + 31587116/4465125*ep^2 + 7765528616/1406514375
      *ep^3;
Fill mnchfac2(9,4) =
       - 152/315 - 62372/99225*ep - 18050072/31255875*ep^2 - 4521671072/
      9845600625*ep^3;
Fill mnchfac2(9,6) =
      13/315 + 5818/99225*ep + 1760968/31255875*ep^2 + 452621968/9845600625*
      ep^3;
Fill mnchfac2(9,8) =
       - 4/945 - 1984/297675*ep - 637984/93767625*ep^2 - 170185984/29536801875
      *ep^3;
Fill mnchfac2(10,0) =
       - 2304/11 - 1074016/4235*ep - 3316968176/14674275*ep^2 - 8998169551936/
      50846362875*ep^3;
Fill mnchfac2(10,2) =
      5888/495 + 26082208/1715175*ep + 82610452688/5943081375*ep^2 + 
      227269629249568/20592776964375*ep^3;
Fill mnchfac2(10,4) =
       - 376/495 - 1774196/1715175*ep - 5795428756/5943081375*ep^2 - 
      16224932111816/20592776964375*ep^3;
Fill mnchfac2(10,6) =
      64/1155 + 324824/4002075*ep + 1102890364/13867189875*ep^2 + 
      3158182574504/48049812916875*ep^3;
Fill mnchfac2(10,8) =
       - 7/1485 - 38642/5145525*ep - 137831812/17829244125*ep^2 - 406815641432/
      61778330893125*ep^3;
Fill mnchfac2(10,10) =
      1/2079 + 6086/7203735*ep + 23133196/24960941775*ep^2 + 71203299656/
      86489663250375*ep^3;
Fill mnchfac2(11,0) =
       - 1280/3 - 1133152/2079*ep - 3599216912/7203735*ep^2 - 9927387845632/
      24960941775*ep^3;
Fill mnchfac2(11,2) =
      3584/165 + 2380352/81675*ep + 1106110096/40429125*ep^2 + 3092405649056/
      140086918125*ep^3;
Fill mnchfac2(11,4) =
       - 608/495 - 2988148/1715175*ep - 9998466428/5943081375*ep^2 - 
      28414250145208/20592776964375*ep^3;
Fill mnchfac2(11,6) =
      116/1485 + 606976/5145525*ep + 2101518836/17829244125*ep^2 + 
      6094659016696/61778330893125*ep^3;
Fill mnchfac2(11,8) =
       - 59/10395 - 331354/36018675*ep - 1196154644/124804708875*ep^2 - 
      3559742486584/432448316251875*ep^3;
Fill mnchfac2(11,10) =
      1/2079 + 6086/7203735*ep + 23133196/24960941775*ep^2 + 71203299656/
      86489663250375*ep^3;
Fill mnchfac2(12,0) =
       - 11264/13 - 61826944/53235*ep - 2620237967552/2397970575*ep^2 - 
      95436709262412736/108016584550875*ep^3;
Fill mnchfac2(12,2) =
      17152/429 + 1082775712/19324305*ep + 46930455150896/870463318725*ep^2 + 
      1731730784364142528/39210020191967625*ep^3;
Fill mnchfac2(12,4) =
       - 4352/2145 - 288658016/96621525*ep - 12841800621088/4352316593625*ep^2
       - 481207359158775584/196050100959838125*ep^3;
Fill mnchfac2(12,6) =
      736/6435 + 51568148/289864575*ep + 2365538731564/13056949780875*ep^2 + 
      90297525582720152/588150302879514375*ep^3;
Fill mnchfac2(12,8) =
       - 28/3861 - 59572/4969107*ep - 2833804928/223833424815*ep^2 - 
      110654880654064/10082576620791675*ep^3;
Fill mnchfac2(12,10) =
      71/135135 + 5658958/6087156075*ep + 281153094644/274195945398375*ep^2 + 
      11294141213967592/12351156360469801875*ep^3;
Fill mnchfac2(12,12) =
       - 2/45045 - 172096/2029052025*ep - 9011645528/91398648466125*ep^2 - 
      375318002197504/4117052120156600625*ep^3;

*--#] harmo2 : 
*--#[ integral :
#procedure integral(TOPO1)
#switch `TOPO1'
*--#[ la :
#case la
*
*   Reduction procedure for three loop graphs of the la or ladder type.
*   Notation is from S.G.Gorishny et.al. Comp.Phys.Comm 55(1989)381
*
*                     /-<------<-----<-\
*                 P1 /    |   P2   |    \ P3
*                   /     |        |     \
*                  /      |        |      \
*                 /       |        |       \
*          Q --<--     P7 ^        v P8     --<-- Q
*                 \       |        |       /
*                  \      |        |      / 
*                   \     |        |     /
*                 P6 \    |   P5   |    / P4
*                     \->------>----->-/
*
#call ladder(p1,p2,p3,p4,p5,p6,p7,p8,Q) 
multiply Q.Q;
#call ACCU(Ladder recursion)
*
*   Now use some symmetry relations to diminish the number of terms.
*   Note that these transformations are sign insensitive, because the
*   only `nonsquare' is p7.p8 and either both change sign or neither.
*
if ( ( count(p2.p2,1) > count(p5.p5,1) )
  || ( ( count(p2.p2,1) == count(p5.p5,1) )
  && ( ( count(p1.p1,1) < count(p6.p6,1) )
  || ( ( count(p1.p1,1) == count(p6.p6,1) )
  && ( count(p3.p3,1) < count(p4.p4,1) ) ) ) ) );
    multiply replace_(p1,p6,p6,p1,p2,p5,p5,p2,p3,p4,p4,p3);
endif;
if ( ( count(p1.p1,1) < count(p3.p3,1) )
  || ( ( count(p1.p1,1) == count(p3.p3,1) )
  && ( ( count(p6.p6,1) < count(p4.p4,1) )
  || ( ( count(p6.p6,1) == count(p4.p4,1) )
  && ( count(p7.p7,1) < count(p8.p8,1) ) ) ) ) );
    multiply replace_(p1,p3,p3,p1,p7,p8,p8,p7,p6,p4,p4,p6);
endif;
if ( match(1/p1.p1/p2.p2/p3.p3/p4.p4/p6.p6/p7.p7/p8.p8) );
*
*   type BEbar or benzbar. Note the introduction of Q.p2. This will
*   need some sign corrections in future transformations.
*
    id  p5.p5 = p2.p2+Q.Q-2*Q.p2;
endif;
if ( match(1/p1.p1/p2.p2/p3.p3/p4.p4/p6.p6/p7.p7/p8.p8) );
    id  p7.p8 = p7.p7/2+p8.p8/2-mncx8/2;
endif;

#call ACCU2(AB Q.Q mncx8,Rearrange)
Keep Brackets;
if ( match(1/p1.p1/p2.p2/p3.p3/p4.p4/p6.p6/p7.p7/p8.p8) );
    multiply acc(1/ep);
    #call triangle(p2,p7,p8,p1,p3)
    multiply ep;
endif;
#call ACCU(Second recursion)

id  mncx8 = p7.p7 + p8.p8 - 2*p7.p8;
#call ACCU(Second recursion B)

*
*   Now bring the integrals to a standard form again. We can make it
*   such that either p1.p1 is missing, or p2.p2 and p5.p5, or p8.p8.
*   `missing' means: not occurring in the denominator.
*
if ( ( count(p7.p7,1) >= 0 ) || ( count(p8.p8,1) >= 0 ) );
  if ( count(p7.p7,1) > count(p8.p8,1) );
    multiply replace_(p1,p3,p3,p1,p7,p8,p8,p7,p6,p4,p4,p6);
  endif;
  if ( ( count(p1.p1,1) < count(p6.p6,1) )
    || ( ( count(p1.p1,1) == count(p6.p6,1) )
    && ( ( count(p3.p3,1) < count(p4.p4,1) )
    || ( ( count(p3.p3,1) == count(p4.p4,1) )
    && ( count(p2.p2,1) < count(p5.p5,1) ) ) ) ) );
      id  Q.p2 = -Q.p2;
      multiply replace_(p1,p6,p6,p1,p2,p5,p5,p2,p3,p4,p4,p3);
  endif;
else;
if ( ( count(p1.p1,1) >= 0 ) || ( count(p3.p3,1) >= 0 )
  || ( count(p4.p4,1) >= 0 ) || ( count(p6.p6,1) >= 0 ) );
    if ( count(p1.p1,1) < count(p3.p3,1) );
      multiply replace_(p1,p3,p3,p1,p7,p8,p8,p7,p6,p4,p4,p6);
    endif;
    if ( count(p1.p1,1) < count(p6.p6,1) );
      id  Q.p2 = -Q.p2;
      multiply replace_(p1,p6,p6,p1,p2,p5,p5,p2,p3,p4,p4,p3);
    endif;
    if ( count(p1.p1,1) < count(p4.p4,1) );
      id  Q.p2 = -Q.p2;
     multiply replace_(p1,p4,p4,p1,p2,p5,p5,p2,p6,p3,p3,p6,p7,p8,p8,p7);
    endif;
    if ( count(p1.p1,1) < count(p3.p3,1) );
      multiply replace_(p1,p3,p3,p1,p7,p8,p8,p7,p6,p4,p4,p6);
    endif;
    if ( ( count(p1.p1,1) == count(p3.p3,1) )
    && ( count(p4.p4,1) > count(p6.p6,1) ) );
      multiply replace_(p1,p3,p3,p1,p7,p8,p8,p7,p6,p4,p4,p6);
    else;
    if ( ( count(p1.p1,1) == count(p6.p6,1) )
    && ( count(p4.p4,1) > count(p3.p3,1) ) );
      id  Q.p2 = -Q.p2;
      multiply replace_(p1,p6,p6,p1,p2,p5,p5,p2,p3,p4,p4,p3);
    endif;
    endif;
else;
if ( ( count(p2.p2,1) > count(p5.p5,1) )
  || ( ( count(p2.p2,1) == count(p5.p5,1) )
  && ( ( count(p1.p1,1) < count(p6.p6,1) )
  || ( ( count(p1.p1,1) == count(p6.p6,1) )
  && ( count(p3.p3,1) < count(p4.p4,1) ) ) ) ) );
    id  Q.p2 = -Q.p2;
    multiply replace_(p1,p6,p6,p1,p2,p5,p5,p2,p3,p4,p4,p3);
endif;
if ( ( count(p1.p1,1) < count(p3.p3,1) )
  || ( ( count(p1.p1,1) == count(p3.p3,1) )
  && ( ( count(p6.p6,1) < count(p4.p4,1) )
  || ( ( count(p6.p6,1) == count(p4.p4,1) )
  && ( count(p7.p7,1) < count(p8.p8,1) ) ) ) ) );
    multiply replace_(p1,p3,p3,p1,p7,p8,p8,p7,p6,p4,p4,p6);
endif;
endif;
endif;

#call ACCU(Use symmetry)

repeat;
if ( count(p1.p1,1) >= 0 );
    id  p1 = p6+Q;
    if ( count(p6.p6,1) >= 0 ) discard;
elseif ( ( count(p2.p2,1) >= 0 ) && ( count(p5.p5,1) >= 0 ) );
    if ( match(1/p7.p7/p8.p8) == 0 ) discard;
    repeat id p2.p2/p1.p1 = 1-2*p1.p7/p1.p1+p7.p7/p1.p1;
    repeat id p5.p5/p6.p6 = 1+p7.p7/p6.p6-2*p6.p7/p6.p6;
    if ( count(p7.p7,1) >= 0 ) discard;
    if ( ( count(p1.p1,1) < 0 ) && ( count(p6.p6,1) >= 0 ) );
        multiply replace_(p1,p6,p6,p1,p2,p5,p5,p2,p3,p4,p4,p3,Q,-Q);
    endif;
    if ( count(p1.p1,1) < 0 );
        id  p2 = p1-p7;
        id  p5 = p6-p7;
        if ( count(p7.p7,1) >= 0 ) discard;
    endif;
else;
    if ( match(1/p3.p3/p4.p4) == 0 ) discard;
    id  p8 = p3-p2;
    if ( count(p3.p3,1) >= 0 ) discard;
endif;
endrepeat;
if ( count(p1.p1,1) >= 0 );
    id  p6.p7 = p6.p6/2+p7.p7/2-p5.p5/2;
    id  p5.p7 = p6.p6/2-p7.p7/2-p5.p5/2;
    id  p5.p6 = p6.p6/2+p5.p5/2-p7.p7/2;
    if ( match(1/p6.p6/p7.p7) == 0 ) discard;
    if ( count(p7.p2,1,p7.p3,1,p7.p4,1,p7.p8,1,p7.Q,1)
       > count(p6.p2,1,p6.p3,1,p6.p4,1,p6.p8,1,p6.Q,1) );
        multiply replace_(p6,-p7,p7,-p6);
    endif;
    id  p7 = p6-p5;
elseif ( ( count(p2.p2,1) >= 0 ) && ( count(p5.p5,1) >= 0 ) );
    id  p7.p8 = p7.p7/2+p8.p8/2-mncp9.mncp9/2;
    if ( match(1/p7.p7/p8.p8) == 0 ) discard;
    if ( count(p8.p1,1,p8.p3,1,p8.p4,1,p8.p6,1,p8.Q,1)
       > count(p7.p1,1,p7.p3,1,p7.p4,1,p7.p6,1,p7.Q,1) );
        multiply replace_(p7,-p8,p8,-p7);
    endif;
    id  p8 = p7-mncp9;
else;
    id  p3.p4 = p3.p3/2+p4.p4/2-Q.Q/2;
    id  p3.Q = p3.p3/2+Q.Q/2-p4.p4/2;
    id  p4.Q = p3.p3/2-p4.p4/2-Q.Q/2;
    if ( match(1/p3.p3/p4.p4) == 0 ) discard;
    if ( count(p4.p1,1,p4.p2,1,p4.p5,1,p4.p6,1,p4.p7,1)
       > count(p3.p1,1,p3.p2,1,p3.p5,1,p3.p6,1,p3.p7,1) );
        multiply replace_(p3,-p4,p4,-p3);
    endif;
    id  p4 = p3-Q;
endif;

#call ACCU(Prepare first loop)

multiply mncint1*mncint2*mncint3;
*
*   Now we do the first integral.
*   The order of the selection of the integrals determines the speed only.
*   On atari ST (4 Mbytes, 28msec hard disk):
*       8, 1, 2+5:   426 sec.
*       2+5, 8, 1:   416 sec.
*       2+5, 1, 8:   408 sec.
*       1, 2+5, 8:   408 sec.
*   It seems important to keep the p8.p8 for the last.
*
if ( count(p1.p1,1) >= 0 );
    if ( count(p6.p6,1) >= 0 ) discard;
    if ( count(p7.p7,1) >= 0 ) discard;
    totensor,nosquare,mncFQ,p6;
    if ( count(mncFQ,1) == 0 );
        id  mncint2/p6.p6^mncx1?/p7.p7^mncx2? =
            p5.p5^2/p5.p5^mncx1/p5.p5^mncx2*mnce5*mncG(mncx1,0,mncx2,0,0,0);
    elseif ( match(mncFQ(mnci1?)) );
        id  mncint2/p6.p6^mncx1?/p7.p7^mncx2?*mncFQ(mnci1?) =
            p5.p5^2/p5.p5^mncx1/p5.p5^mncx2*mnce5*mncG(mncx1,0,mncx2,0,1,0)*p5(mnci1);
    elseif ( match(mncFQ(mnci1?,mnci2?)) );
        id  mncint2/p6.p6^mncx1?/p7.p7^mncx2?*mncFQ(mnci1?,mnci2?) =
            p5.p5^2/p5.p5^mncx1/p5.p5^mncx2*mnce5*(
            +mncG(mncx1,0,mncx2,0,2,0)*p5(mnci1)*p5(mnci2)
            +mncG(mncx1,0,mncx2,0,2,1)*p5.p5*d_(mnci1,mnci2)/2
            );
    else;
        id  mncint2/p6.p6^mncx1?/p7.p7^mncx2?*mncFQ(?a) =
            p5.p5^2/p5.p5^mncx1/p5.p5^mncx2*mnce5
            *sum_(mncj,0,integer_(nargs_(?a)/2),mncG(mncx1,0,mncx2,0,nargs_(?a),mncj)
            *p5.p5^mncj/2^mncj*mncy^mncj)*mncFQ(?a);
    endif;
    #call simplify
    if ( count(mncFQ,1) );
        id  mncy^mncj?*mncFQ(?a) = distrib_(1,2*mncj,mncdel,mncFQ,?a);
        tovector,mncFQ,p5;
        id  mncdel(?a) = dd_(?a);
    endif;
*    #call one(p6,p7,p5,mnce6,mnce7,mnce5,mncint2)
    id  1/p8.p8 = 1/p7.p7;
    id  p8 = -p7;
    multiply replace_(p2,p1,mnce2,mnce1,p5,p6,mnce5,mnce6);
elseif ( ( count(p2.p2,1) >= 0 ) && ( count(p5.p5,1) >= 0 ) );
    if ( count(p7.p7,1) >= 0 ) discard;
    if ( count(p8.p8,1) >= 0 ) discard;
    totensor,nosquare,mncFQ,p7;
    if ( count(mncFQ,1) == 0 );
        id  mncint2/p7.p7^mncx1?/p8.p8^mncx2? =
            mncp9.mncp9^2/mncp9.mncp9^mncx1/mncp9.mncp9^mncx2*mnce9*mncG(mncx1,0,mncx2,0,0,0);
    elseif ( match(mncFQ(mnci1?)) );
        id  mncint2/p7.p7^mncx1?/p8.p8^mncx2?*mncFQ(mnci1?) =
            mncp9.mncp9^2/mncp9.mncp9^mncx1/mncp9.mncp9^mncx2*mnce9*mncG(mncx1,0,mncx2,0,1,0)*mncp9(mnci1);
    elseif ( match(mncFQ(mnci1?,mnci2?)) );
        id  mncint2/p7.p7^mncx1?/p8.p8^mncx2?*mncFQ(mnci1?,mnci2?) =
            mncp9.mncp9^2/mncp9.mncp9^mncx1/mncp9.mncp9^mncx2*mnce9*(
            +mncG(mncx1,0,mncx2,0,2,0)*mncp9(mnci1)*mncp9(mnci2)
            +mncG(mncx1,0,mncx2,0,2,1)*mncp9.mncp9*d_(mnci1,mnci2)/2
            );
    else;
        id  mncint2/p7.p7^mncx1?/p8.p8^mncx2?*mncFQ(?a) =
            mncp9.mncp9^2/mncp9.mncp9^mncx1/mncp9.mncp9^mncx2*mnce9
            *sum_(mncj,0,integer_(nargs_(?a)/2),mncG(mncx1,0,mncx2,0,nargs_(?a),mncj)
            *mncp9.mncp9^mncj/2^mncj*mncy^mncj)*mncFQ(?a);
    endif;
    #call simplify
    if ( count(mncFQ,1) );
        id  mncy^mncj?*mncFQ(?a) = distrib_(1,2*mncj,mncdel,mncFQ,?a);
        tovector,mncFQ,mncp9;
        id  mncdel(?a) = dd_(?a);
    endif;
*    #call one(p7,p8,mncp9,mnce7,mnce8,mnce9,mncint2)
    multiply replace_(mncp9,p7,mnce9,mnce7);
elseif ( count(p8.p8,1) >= 0 );
*    #call one(p3,p4,Q,mnce3,mnce4,mnceq,mncint2)
    if ( count(p3.p3,1) >= 0 ) discard;
    if ( count(p4.p4,1) >= 0 ) discard;
    totensor,nosquare,mncFQ,p3;
    if ( count(mncFQ,1) == 0 );
        id  mncint2/p3.p3^mncx1?/p4.p4^mncx2? =
            Q.Q^2/Q.Q^mncx1/Q.Q^mncx2*mnceq*mncG(mncx1,0,mncx2,0,0,0);
    elseif ( match(mncFQ(mnci1?)) );
        id  mncint2/p3.p3^mncx1?/p4.p4^mncx2?*mncFQ(mnci1?) =
            Q.Q^2/Q.Q^mncx1/Q.Q^mncx2*mnceq*mncG(mncx1,0,mncx2,0,1,0)*Q(mnci1);
    elseif ( match(mncFQ(mnci1?,mnci2?)) );
        id  mncint2/p3.p3^mncx1?/p4.p4^mncx2?*mncFQ(mnci1?,mnci2?) =
            Q.Q^2/Q.Q^mncx1/Q.Q^mncx2*mnceq*(
            +mncG(mncx1,0,mncx2,0,2,0)*Q(mnci1)*Q(mnci2)
            +mncG(mncx1,0,mncx2,0,2,1)*Q.Q*d_(mnci1,mnci2)/2
            );
    else;
        id  mncint2/p3.p3^mncx1?/p4.p4^mncx2?*mncFQ(?a) =
            Q.Q^2/Q.Q^mncx1/Q.Q^mncx2*mnceq
            *sum_(mncj,0,integer_(nargs_(?a)/2),mncG(mncx1,0,mncx2,0,nargs_(?a),mncj)
            *Q.Q^mncj/2^mncj*mncy^mncj)*mncFQ(?a);
    endif;
    #call simplify
    if ( count(mncFQ,1) );
        id  mncy^mncj?*mncFQ(?a) = distrib_(1,2*mncj,mncdel,mncFQ,?a);
        tovector,mncFQ,Q;
        id  mncdel(?a) = dd_(?a);
    endif;
    multiply replace_(p2,p3,mnce2,mnce3,p5,p4,mnce5,mnce4);
else;
	print "Illegal symmetry in LA";
	setexitflag;
endif;
#call ACCU(First loop integral)
*
*   The rest is standard. Note that the momenta that still exist
*   have to be called p1,p3,p4,p6,p7.
*
#call dotwo{}
#call ACCU(Simplify mncG\(3\))
repeat id acc(mncx1?)*acc(mncx2?) = acc(mncx1*mncx2);
multiply ep^-6;
id      acc(mncx1?) = mncx1;
id      ep = 0;
.sort: Expression G scheme;
*
*   Now approximate and convert to MSbar.
*
#call finish(3,`SCHEME')
*
#break
*--#] la : 
*--#[ bu :
#case bu
*
*   Integral of type BU
*   It may as well be handled by BE
*   We only need renumbering.
*
multiply replace_(p1,p2,p2,p6,p3,p5,p4,p7,p5,p8,p6,p3,p7,p4,p8,p1);
*
*--#] bu : 
*--#[ fa :
#case fa
*
*   Integral of type FA.
*   This may as well be done by BE.
*
*--#] fa : 
*--#[ be :
#case be
*
*   Reduction procedure for three loop graphs of the BE or benz type.
*   Notation is from S.G.Gorishny et.al. Comp.Phys.Comm 55(1989)381
*
*                     /-<------<------<-\
*                 P1 /    \   P2    /    \ P3
*                   /      \       /      \
*                  /     P6 v     ^ P7     \
*                 /          \   /          \
*          Q --<--            \ /            --<-- Q
*                 \            |            /
*                  \           v P8        / 
*                   \          |          /
*                 P5 \         |         / P4
*                     \---->------->----/
*
#ifdef `BEPATH'
#call benzred(p1,p2,p3,p4,p5,p6,p7,p8,Q)
#else
if ( count(p6.p6,1) < count(p7.p7,1) );
    multiply replace_(p1,p3,p3,p1,p4,p5,p5,p4,p6,p7,p7,p6,p8,-p8);
elseif ( count(p6.p6,1) == count(p7.p7,1) );
    if ( count(p1.p1,1) < count(p3.p3,1) );
        multiply replace_(p1,p3,p3,p1,p4,p5,p5,p4,p6,p7,p7,p6,p8,-p8);
    elseif ( count(p1.p1,1) == count(p3.p3,1) );
        if ( count(p5.p5,1) < count(p4.p4,1) )
            multiply replace_(p1,p3,p3,p1,p4,p5,p5,p4,p6,p7,p7,p6,p8,-p8);
    endif;
endif;
#call ACCU2(AB p1.p3 p1.p1 p3.p3 p8.p8,Benz scalar 0)
  id  p1.p3 = p1.p1/2+p3.p3/2-p8.p8/2;
#call ACCU2(AB p2.p3 p2.p2 p3.p3 p7.p7,Benz scalar 1)
  id  p2.p3 = p2.p2/2+p3.p3/2-p7.p7/2;
#call ACCU2(AB p1.p2 p1.p1 p2.p2 p6.p6,Benz scalar 2)
  id  p1.p2 = p1.p1/2+p2.p2/2-p6.p6/2;
#call ACCU2(AB Q.p1 p1.p1 Q.Q p5.p5,Benz scalar 3)
  id  Q.p1 = p1.p1/2+Q.Q/2-p5.p5/2;
#call ACCU2(AB Q.p3 p3.p3 Q.Q p4.p4,Benz scalar 4)
  id  Q.p3 = p3.p3/2+Q.Q/2-p4.p4/2;

if ( count(p6.p6,1) < count(p7.p7,1) );
    multiply replace_(p1,p3,p3,p1,p4,p5,p5,p4,p6,p7,p7,p6,p8,-p8);
elseif ( count(p6.p6,1) == count(p7.p7,1) );
    if ( count(p1.p1,1) < count(p3.p3,1) );
        multiply replace_(p1,p3,p3,p1,p4,p5,p5,p4,p6,p7,p7,p6,p8,-p8);
    elseif ( count(p1.p1,1) == count(p3.p3,1) );
        if ( count(p5.p5,1) < count(p4.p4,1) )
            multiply replace_(p1,p3,p3,p1,p4,p5,p5,p4,p6,p7,p7,p6,p8,-p8);
    endif;
endif;
#call ACCU(Benz scalar 5)
#endif
multiply Q.Q;
  if ( match(1/p1.p1/p2.p2/p3.p3/p4.p4/p5.p5/p6.p6/p7.p7) > 0 );
    multiply acc(1/ep);
    #call triangle(p2,p6,p7,p1,p3)
    multiply ep;
  endif;
*#call ACCU(Benz recursion)
*
*   Use the left-right symmetry relation.
*
if ( ( count(p1.p1,1) < count(p3.p3,1) )
  || ( ( count(p1.p1,1) == count(p3.p3,1) )
  && ( ( count(p5.p5,1) < count(p4.p4,1) )
  || ( ( count(p5.p5,1) == count(p4.p4,1) )
  && ( count(p6.p6,1) < count(p7.p7,1) ) ) ) ) );
    multiply replace_(p1,-p3,p2,-p2,p3,-p1,p4,-p5,p5,-p4,p6,-p7,p7,-p6,Q,-Q);
endif;
#call ACCU2(AB p1.p1 p5.p5 p3.p3 p4.p4 Q.p8 Q.Q Q.p2 Q.p7,Benz recursion)
*#call ACCU(Rearrange)
*
*   Now we use the second level reduction. We have only BU left
*   because FA was treated already together with BE.
*
if ( match(1/p2.p2/p3.p3/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8) > 0 );
    id  p1.p1 = p5.p5 + p3.p3 - p4.p4 -2*Q.p8;
endif;
if ( match(1/p2.p2/p3.p3/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8) > 0 );
    id  Q.p2 = Q.p7 + p3.p3/2 + Q.Q/2 - p4.p4/2;
endif;
*if ( match(1/p2.p2/p3.p3/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8) > 0 );
*    if ( ( count(p3.p3,1) > count(p4.p4,1) )
*   || ( ( count(p3.p3,1) == count(p4.p4,1) )
*   && ( ( count(p7.p7,1) > count(p8.p8,1) )
*   || ( ( count(p7.p7,1) == count(p8.p8,1) )
*   && ( ( count(p5.p5,1) > count(p2.p2,1) )
*   || ( ( count(p5.p5,1) == count(p2.p2,1) )
*   && ( count(Q.p7,1) < count(Q.p8,1) ) ) ) ) ) ) );
*       Multiply,replace_(p3,-p4,p4,-p3,p2,-p5,p5,-p2,p7,p8,p8,p7);
*   endif;
*endif;
#call ACCU(Prepare second)
if ( match(1/p2.p2/p3.p3/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8) > 0 );
    multiply acc(1/ep);
    if ( count(p3.p3,1) > count(p4.p4,1) );
        #call triangle(p7,p2,p6,p3,p8)
    else;
        #call triangle(p8,p5,p6,p4,p7)
    endif;
    multiply ep;
endif;
#call ACCU(Second recursion)
if ( match(1/p6.p6/p7.p7) == 0 );
  if ( ( count(p6.p6,1) < count(p7.p7,1) )
  || ( ( count(p6.p6,1) == count(p7.p7,1) )
  && ( ( count(p1.p1,1) < count(p3.p3,1) )
  || ( ( count(p1.p1,1) == count(p3.p3,1) )
  && ( count(p5.p5,1) < count(p4.p4,1) ) ) ) ) );
    multiply replace_(p1,-p3,p2,-p2,p3,-p1,p4,-p5,p5,-p4,p6,-p7,p7,-p6,Q,-Q);
  endif;
elseif ( ( count(p5.p5,1) >= 0 ) || ( count(p4.p4,1) >= 0 ) );
  if ( ( count(p4.p4,1) < count(p5.p5,1) )
  || ( ( count(p4.p4,1) == count(p5.p5,1) )
  && ( ( count(p1.p1,1) < count(p3.p3,1) )
  || ( ( count(p1.p1,1) == count(p3.p3,1) )
  && ( count(p6.p6,1) < count(p7.p7,1) ) ) ) ) );
    multiply replace_(p1,-p3,p2,-p2,p3,-p1,p4,-p5,p5,-p4,p6,-p7,p7,-p6,Q,-Q);
  endif;
elseif ( ( count(p1.p1,1) < count(p3.p3,1) )
  || ( ( count(p1.p1,1) == count(p3.p3,1) )
  && ( ( count(p5.p5,1) < count(p4.p4,1) )
  || ( ( count(p5.p5,1) == count(p4.p4,1) )
  && ( count(p6.p6,1) < count(p7.p7,1) ) ) ) ) );
    multiply replace_(p1,-p3,p2,-p2,p3,-p1,p4,-p5,p5,-p4,p6,-p7,p7,-p6,Q,-Q);
endif;
#call ACCU(Use Symmetry)
*
#ifdef `POW'
#if `POW' >= 1
if ( count(p6.p6,1) >= 0 );
*    id  p6.p6 = p1.p1+p2.p2-2*p1.p2;
*    id  p6 = p2-p1;
    if ( ( count(p2.p2,1) >= 0 ) || ( count(p7.p7,1) >= 0 ) ) discard;
elseif ( ( count(p8.p8,1) >= 0 ) && ( count(p1.p1,1) >= 0 ) );
*    id  p8 = p6-p7;
*    id  p1 = p2-p6;
    if ( ( count(p6.p6,1) >= 0 ) || ( count(p5.p5,1) >= 0 ) ) discard;
elseif ( count(p2.p2,1) >= 0 );
*    id  p2.p2 = p1.p1+p6.p6+2*p1.p6;
*    id  p2 = p1+p6;
    if ( ( count(p6.p6,1) >= 0 ) || ( count(p7.p7,1) >= 0 ) ) discard;
    if ( ( count(p1.p1,1) >= 0 ) && ( count(p3.p3,1) >= 0 ) ) discard;
elseif ( count(p4.p4,1) >= 0 );
    if ( count(p5.p5,1) >= 0 ) discard;
    id  p4.p4 = Q.Q+p3.p3-2*Q.p3;
    id  p4 = p3-Q;
    if ( count(p3.p3,1) >= 0 );
*       repeat id p3.p3/p2.p2 = 1+p7.p7/p2.p2-2*p2.p7/p2.p2;
*       repeat id p2.p3/p2.p2 = 1-p2.p7/p2.p2;
        if ( count(p7.p7,1) >= 0 ) discard;
        if ( count(p8.p8,1) >= 0 ) discard;
*       if ( count(p2.p2,1) < 0 );
*           id p3 = p2-p7;
*       endif;
    endif;
elseif ( ( count(p1.p1,1) >= 0 ) && ( count(p3.p3,1) >= 0 ) );
    repeat id  p3.p3/p4.p4 = 1+Q.Q/p4.p4+2*Q.p4/p4.p4;
    repeat id  p3.p4/p4.p4 = 1+Q.p4/p4.p4;
    if ( count(p4.p4,1) < 0 );
        repeat id  p1.p1/p5.p5 = 1+Q.Q/p5.p5+2*Q.p5/p5.p5;
        repeat id  p1.p5/p5.p5 = 1+Q.p5/p5.p5;
        if ( count(p5.p5,1) >= 0 );
            multiply replace_(p1,-p3,p3,-p1,p2,-p2,p6,-p7,p7,-p6
            ,Q,-Q,p4,-p5,p5,-p4);
        else;
            id  p1 = Q+p5;
            id  p3 = Q+p4;
        endif;
    endif;
else;
    exit "mincer integral Pre-Setup 1";*       Just in case we forgot something
endif;
#call ACCU(Pre-setup 1)
if ( count(p6.p6,1) >= 0 );
*    id  p6.p6 = p1.p1+p2.p2-2*p1.p2;
*    id  p6 = p2-p1;
    if ( ( count(p2.p2,1) >= 0 ) || ( count(p7.p7,1) >= 0 ) ) discard;
elseif ( ( count(p8.p8,1) >= 0 ) && ( count(p1.p1,1) >= 0 ) );
*    id  p8 = p6-p7;
*    id  p1 = p2-p6;
    if ( ( count(p6.p6,1) >= 0 ) || ( count(p5.p5,1) >= 0 ) ) discard;
elseif ( count(p2.p2,1) >= 0 );
*   id  Q.p2 = Q.Q/2+p1.p1/2-p5.p5/2+Q.p6;
*    id  p2.p2 = p1.p1+p6.p6+2*p1.p6;
*    id  p2 = p1+p6;
    if ( ( count(p6.p6,1) >= 0 ) || ( count(p7.p7,1) >= 0 ) ) discard;
    if ( ( count(p1.p1,1) >= 0 ) && ( count(p3.p3,1) >= 0 ) ) discard;
elseif ( count(p4.p4,1) >= 0 );
    id Q.p5 = p1.p1/2-Q.Q/2-p5.p5/2;
    if ( count(p5.p5,1) >= 0 ) discard;
    id  p4.p4 = Q.Q+p3.p3-2*Q.p3;
    id  p4 = p3-Q;
    if ( count(p3.p3,1) >= 0 );
        repeat id p3.p3/p2.p2 = 1+p7.p7/p2.p2-2*p2.p7/p2.p2;
        repeat id p2.p3/p2.p2 = 1-p2.p7/p2.p2;
        if ( count(p7.p7,1) >= 0 ) discard;
        if ( count(p8.p8,1) >= 0 ) discard;
        if ( count(p2.p2,1) < 0 );
            id p3 = p2-p7;
        endif;
    endif;
elseif ( ( count(p1.p1,1) >= 0 ) && ( count(p3.p3,1) >= 0 ) );
    repeat id  p3.p3/p4.p4 = 1+Q.Q/p4.p4+2*Q.p4/p4.p4;
    repeat id  p3.p4/p4.p4 = 1+Q.p4/p4.p4;
    if ( count(p4.p4,1) < 0 );
        repeat id  p1.p1/p5.p5 = 1+Q.Q/p5.p5+2*Q.p5/p5.p5;
        repeat id  p1.p5/p5.p5 = 1+Q.p5/p5.p5;
        if ( count(p5.p5,1) >= 0 );
            multiply replace_(p1,-p3,p3,-p1,p2,-p2,p6,-p7,p7,-p6
            ,Q,-Q,p4,-p5,p5,-p4);
        else;
            id  p1 = Q+p5;
            id  p3 = Q+p4;
        endif;
    endif;
else;
    exit "mincer integral Pre-Setup 2";*       Just in case we forgot something
endif;
#call ACCU(Pre-setup 2)
#if `POW' >= 4
if ( count(p6.p6,1) >= 0 );
*    id  p6.p6 = p1.p1+p2.p2-2*p1.p2;
*    id  p6 = p2-p1;
*   id Q.p5 = p1.p1/2-Q.Q/2-p5.p5/2;
*   id Q.p4 = p3.p3/2-Q.Q/2-p4.p4/2;
*   id Q.p3 = p3.p3/2+Q.Q/2-p4.p4/2;
    if ( ( count(p2.p2,1) >= 0 ) || ( count(p7.p7,1) >= 0 ) ) discard;
elseif ( ( count(p8.p8,1) >= 0 ) && ( count(p1.p1,1) >= 0 ) );
*   id  p8.p8 = p6.p6-2*p6.p7+p7.p7;
*   id  p1.p1 = p2.p2-2*p2.p6+p6.p6;
*   id  p8 = p6-p7;
*   id  p1 = p2-p6;
*   id  Q.p4  = p3.p3/2-Q.Q/2-p4.p4/2;
*   id  Q.p3  = p3.p3/2+Q.Q/2-p4.p4/2;
    if ( ( count(p6.p6,1) >= 0 ) || ( count(p5.p5,1) >= 0 ) ) discard;
elseif ( count(p2.p2,1) >= 0 );
    id  Q.p5  = p1.p1/2-Q.Q/2-p5.p5/2;
    id  Q.p4  = p3.p3/2-Q.Q/2-p4.p4/2;
    id  Q.p3  = p3.p3/2+Q.Q/2-p4.p4/2;
    id  p2.p2 = p1.p1+p6.p6+2*p1.p6;
    id  Q.p2  = Q.Q/2+p1.p1/2-p5.p5/2+Q.p6;
    id  p2 = p1+p6;
    if ( ( count(p6.p6,1) >= 0 ) || ( count(p7.p7,1) >= 0 ) ) discard;
    if ( ( count(p1.p1,1) >= 0 ) && ( count(p3.p3,1) >= 0 ) ) discard;
elseif ( count(p4.p4,1) >= 0 );
    id Q.p5 = p1.p1/2-Q.Q/2-p5.p5/2;
    if ( count(p5.p5,1) >= 0 ) discard;
    id  p4.p4 = Q.Q+p3.p3-2*Q.p3;
    id  p4 = p3-Q;
    if ( count(p3.p3,1) >= 0 );
        repeat id p3.p3/p2.p2 = 1+p7.p7/p2.p2-2*p2.p7/p2.p2;
        repeat id p2.p3/p2.p2 = 1-p2.p7/p2.p2;
        if ( count(p7.p7,1) >= 0 ) discard;
        if ( count(p8.p8,1) >= 0 ) discard;
        if ( count(p2.p2,1) < 0 );
            id p3 = p2-p7;
        endif;
    endif;
elseif ( ( count(p1.p1,1) >= 0 ) && ( count(p3.p3,1) >= 0 ) );
    repeat id  p3.p3/p4.p4 = 1+Q.Q/p4.p4+2*Q.p4/p4.p4;
    repeat id  p3.p4/p4.p4 = 1+Q.p4/p4.p4;
    if ( count(p4.p4,1) < 0 );
        repeat id  p1.p1/p5.p5 = 1+Q.Q/p5.p5+2*Q.p5/p5.p5;
        repeat id  p1.p5/p5.p5 = 1+Q.p5/p5.p5;
        if ( count(p5.p5,1) >= 0 );
            multiply replace_(p1,-p3,p3,-p1,p2,-p2,p6,-p7,p7,-p6
            ,Q,-Q,p4,-p5,p5,-p4);
        else;
            id  p1 = Q+p5;
            id  p3 = Q+p4;
        endif;
    endif;
else;
    exit "mincer integral Pre-Setup 3";*       Just in case we forgot something
endif;
#call ACCU(Pre-setup 3)
#if `POW' >= 6
if ( count(p6.p6,1) >= 0 );
*    id  p6.p6 = p1.p1+p2.p2-2*p1.p2;
*    id  p6 = p2-p1;
*   id Q.p5 = p1.p1/2-Q.Q/2-p5.p5/2;
*   id Q.p4 = p3.p3/2-Q.Q/2-p4.p4/2;
*   id Q.p3 = p3.p3/2+Q.Q/2-p4.p4/2;
    if ( ( count(p2.p2,1) >= 0 ) || ( count(p7.p7,1) >= 0 ) ) discard;
elseif ( ( count(p8.p8,1) >= 0 ) && ( count(p1.p1,1) >= 0 ) );
    id  p8.p8 = p6.p6-2*p6.p7+p7.p7;
    id  p1.p1 = p2.p2-2*p2.p6+p6.p6;
    id  p8 = p6-p7;
    id  p1 = p2-p6;
    id Q.p4 = p3.p3/2-Q.Q/2-p4.p4/2;
    id Q.p3 = p3.p3/2+Q.Q/2-p4.p4/2;
    if ( ( count(p6.p6,1) >= 0 ) || ( count(p5.p5,1) >= 0 ) ) discard;
elseif ( count(p2.p2,1) >= 0 );
    id Q.p5 = p1.p1/2-Q.Q/2-p5.p5/2;
    id Q.p4 = p3.p3/2-Q.Q/2-p4.p4/2;
    id Q.p3 = p3.p3/2+Q.Q/2-p4.p4/2;
    id  p2.p2 = p1.p1+p6.p6+2*p1.p6;
    id  Q.p2 = Q.Q/2+p1.p1/2-p5.p5/2+Q.p6;
    id  p2 = p1+p6;
    if ( ( count(p6.p6,1) >= 0 ) || ( count(p7.p7,1) >= 0 ) ) discard;
    if ( ( count(p1.p1,1) >= 0 ) && ( count(p3.p3,1) >= 0 ) ) discard;
elseif ( count(p4.p4,1) >= 0 );
    id Q.p5 = p1.p1/2-Q.Q/2-p5.p5/2;
    if ( count(p5.p5,1) >= 0 ) discard;
    id  p4.p4 = Q.Q+p3.p3-2*Q.p3;
    id  p4 = p3-Q;
    if ( count(p3.p3,1) >= 0 );
        repeat id p3.p3/p2.p2 = 1+p7.p7/p2.p2-2*p2.p7/p2.p2;
        repeat id p2.p3/p2.p2 = 1-p2.p7/p2.p2;
        if ( count(p7.p7,1) >= 0 ) discard;
        if ( count(p8.p8,1) >= 0 ) discard;
        if ( count(p2.p2,1) < 0 );
            id p3 = p2-p7;
        endif;
    endif;
elseif ( ( count(p1.p1,1) >= 0 ) && ( count(p3.p3,1) >= 0 ) );
    repeat id  p3.p3/p4.p4 = 1+Q.Q/p4.p4+2*Q.p4/p4.p4;
    repeat id  p3.p4/p4.p4 = 1+Q.p4/p4.p4;
    if ( count(p4.p4,1) < 0 );
        repeat id  p1.p1/p5.p5 = 1+Q.Q/p5.p5+2*Q.p5/p5.p5;
        repeat id  p1.p5/p5.p5 = 1+Q.p5/p5.p5;
        if ( count(p5.p5,1) >= 0 );
            multiply replace_(p1,-p3,p3,-p1,p2,-p2,p6,-p7,p7,-p6
            ,Q,-Q,p4,-p5,p5,-p4);
        else;
            id  p1 = Q+p5;
            id  p3 = Q+p4;
        endif;
    endif;
else;
    exit "mincer integral Pre-Setup 4";*       Just in case we forgot something
endif;
#call ACCU(Pre-setup 4)
#endif
#endif
#endif
#endif
repeat;
if ( count(p6.p6,1) >= 0 );
    id  p6.p6 = p1.p1+p2.p2-2*p1.p2;
    id  p6 = p2-p1;
    id Q.p5 = p1.p1/2-Q.Q/2-p5.p5/2;
    id Q.p4 = p3.p3/2-Q.Q/2-p4.p4/2;
    id Q.p3 = p3.p3/2+Q.Q/2-p4.p4/2;
    if ( ( count(p2.p2,1) >= 0 ) || ( count(p7.p7,1) >= 0 ) ) discard;
elseif ( ( count(p8.p8,1) >= 0 ) && ( count(p1.p1,1) >= 0 ) );
    id  p8.p8 = p6.p6-2*p6.p7+p7.p7;
    id  p1.p1 = p2.p2-2*p2.p6+p6.p6;
    id  p8 = p6-p7;
    id  p1 = p2-p6;
    id Q.p4 = p3.p3/2-Q.Q/2-p4.p4/2;
    id Q.p3 = p3.p3/2+Q.Q/2-p4.p4/2;
    if ( ( count(p6.p6,1) >= 0 ) || ( count(p5.p5,1) >= 0 ) ) discard;
elseif ( count(p2.p2,1) >= 0 );
    id Q.p5 = p1.p1/2-Q.Q/2-p5.p5/2;
    id Q.p4 = p3.p3/2-Q.Q/2-p4.p4/2;
    id Q.p3 = p3.p3/2+Q.Q/2-p4.p4/2;
    id  p2.p2 = p1.p1+p6.p6+2*p1.p6;
*   id  Q.p2 = Q.Q/2+p1.p1/2-p5.p5/2+Q.p6; Reactivated 13-sep-1994
    id  Q.p2 = Q.Q/2+p1.p1/2-p5.p5/2+Q.p6;
    id  p2 = p1+p6;
    if ( ( count(p6.p6,1) >= 0 ) || ( count(p7.p7,1) >= 0 ) ) discard;
    if ( ( count(p1.p1,1) >= 0 ) && ( count(p3.p3,1) >= 0 ) ) discard;
elseif ( count(p4.p4,1) >= 0 );
    id Q.p5 = p1.p1/2-Q.Q/2-p5.p5/2;
    if ( count(p5.p5,1) >= 0 ) discard;
    id  p4.p4 = Q.Q+p3.p3-2*Q.p3;
    id  p4 = p3-Q;
    if ( count(p3.p3,1) >= 0 );
        repeat id p3.p3/p2.p2 = 1+p7.p7/p2.p2-2*p2.p7/p2.p2;
        repeat id p2.p3/p2.p2 = 1-p2.p7/p2.p2;
        if ( count(p7.p7,1) >= 0 ) discard;
        if ( count(p8.p8,1) >= 0 ) discard;
        if ( count(p2.p2,1) < 0 );
            id p3 = p2-p7;
        endif;
    endif;
elseif ( ( count(p1.p1,1) >= 0 ) && ( count(p3.p3,1) >= 0 ) );
    repeat id  p3.p3/p4.p4 = 1+Q.Q/p4.p4+2*Q.p4/p4.p4;
    repeat id  p3.p4/p4.p4 = 1+Q.p4/p4.p4;
    if ( count(p4.p4,1) < 0 );
        repeat id  p1.p1/p5.p5 = 1+Q.Q/p5.p5+2*Q.p5/p5.p5;
        repeat id  p1.p5/p5.p5 = 1+Q.p5/p5.p5;
        if ( count(p5.p5,1) >= 0 );
            multiply replace_(p1,-p3,p3,-p1,p2,-p2,p6,-p7,p7,-p6
            ,Q,-Q,p4,-p5,p5,-p4);
        else;
            id  p1 = Q+p5;
            id  p3 = Q+p4;
        endif;
    endif;
else;
    exit "mincer integral setup first loop";*       Just in case we forgot something
endif;
endrepeat;
#call ACCU(setup first loop)
if ( count(p6.p6,1) >= 0 );
    multiply replace_(p2,mncp9,p7,p8,p8,-p7,p5,p6);
    multiply mncnaar(p3,mnce3);
    id  p8.mncp9 = mncp9.mncp9/2+p8.p8/2-p3.p3/2;
    if ( ( count(p8.p8,1) >= 0 ) || ( count(mncp9.mncp9,1) >= 0 ) ) discard;
    if ( count(p8.Q,1,p8.p1,1,p8.p3,1,p8.p4,1,p8.p6,1,p8.p7,1)
    > count(mncp9.Q,1,mncp9.p1,1,mncp9.p3,1,mncp9.p4,1,mncp9.p6,1,mncp9.p7,1) )
        multiply replace_(p8,-mncp9,mncp9,-p8);
    id  p8.mncq1?!{p8} = mncp9.mncq1 - p3.mncq1;
    totensor,nosquare,mncp9,mncFQ;
elseif ( ( count(p8.p8,1) >= 0 ) && ( count(p1.p1,1) >= 0 ) );
    multiply replace_(p2,p4,p3,p6,p4,p1,p7,-p7,p5,mncp9,p6,-p8,Q,-Q);
    multiply mncnaar(p3,mnce3);
    id  p8.mncp9 = mncp9.mncp9/2+p8.p8/2-p3.p3/2;
    if ( ( count(p8.p8,1) >= 0 ) || ( count(mncp9.mncp9,1) >= 0 ) ) discard;
    if ( count(p8.Q,1,p8.p1,1,p8.p3,1,p8.p4,1,p8.p6,1,p8.p7,1)
    > count(mncp9.Q,1,mncp9.p1,1,mncp9.p3,1,mncp9.p4,1,mncp9.p6,1,mncp9.p7,1) )
        multiply replace_(p8,-mncp9,mncp9,-p8);
    id  p8.mncq1?!{p8} = mncp9.mncq1 - p3.mncq1;
    totensor,nosquare,mncp9,mncFQ;
elseif ( count(p2.p2,1) >= 0 );
    multiply replace_(p5,p6,p8,-p7,p6,p8,p7,mncp9);
label 2;
    multiply mncnaar(p7,mnce7);
    id  p8.mncp9 = mncp9.mncp9/2+p8.p8/2-p7.p7/2;
    if ( ( count(p8.p8,1) >= 0 ) || ( count(mncp9.mncp9,1) >= 0 ) ) discard;
    if ( count(p8.Q,1,p8.p1,1,p8.p3,1,p8.p4,1,p8.p6,1,p8.p7,1)
    > count(mncp9.Q,1,mncp9.p1,1,mncp9.p3,1,mncp9.p4,1,mncp9.p6,1,mncp9.p7,1) )
        multiply replace_(p8,-mncp9,mncp9,-p8);
    id  p8.mncq1?!{p8} = mncp9.mncq1 - p7.mncq1;
    totensor,nosquare,mncp9,mncFQ;
elseif ( count(p4.p4,1) >= 0 );
    if ( count(p3.p3,1) >= 0 );
        multiply replace_(p2,p3,p6,-p7,p5,p6,p7,-mncp9);
        goto 2;
    else;
        multiply replace_(p2,p1,p8,p4,p1,mncp9,p5,p8);
        multiply mncnaar(Q,mnceq,1);
        id  Q.p8 = mncp9.mncp9/2-p8.p8/2-Q.Q/2;
        if ( count(p8.p8,1) >= 0 ) discard;
        id  p8 = mncp9-Q;
        id  mncp9.mncq1?{p1,p3,p4,p6,p7} = p1.mncq1-p6.mncq1;
        id  Q.mncp9 = mncp9.mncp9/2+Q.Q/2-p8.p8/2;
        if ( count(p8.p8,1) >= 0 ) discard;
        if ( count(p1.p1,1,p3.p3,1) > count(p4.p4,1,p6.p6,1) );
            multiply replace_(p1,-p6,p6,-p1,p3,-p4,p4,-p3,p7,-p7);
        endif;
        if ( count(p1.p1,1,p6.p6,1) > count(p3.p3,1,p4.p4,1) );
            multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4);
            id p7 = -p7;
        endif;
        totensor,nosquare,Q,mncFQ;
        id,many,mncq1?{p1,p3,p4,p6,p7}.mncq2?{p1,p3,p4,p6,p7}^D? = mncx^D*mncq1.mncq2^D;
    endif;
elseif ( ( count(p1.p1,1) >= 0 ) && ( count(p3.p3,1) >= 0 ) );
    multiply replace_(p5,-p1,p4,-p3,p7,p4,p8,p7,p2,-p8);
    multiply mncnaar(Q,mnceq,1);
    id  Q.p8 = mncp9.mncp9/2-p8.p8/2-Q.Q/2;
    if ( count(p8.p8,1) >= 0 ) discard;
    id  p8 = mncp9-Q;
    id  mncp9.mncq1?{p1,p3,p4,p6,p7} = p1.mncq1-p6.mncq1;
    id  Q.mncp9 = mncp9.mncp9/2+Q.Q/2-p8.p8/2;
    if ( count(p8.p8,1) >= 0 ) discard;
    if ( count(p1.p1,1,p3.p3,1) > count(p4.p4,1,p6.p6,1) );
        multiply replace_(p1,-p6,p6,-p1,p3,-p4,p4,-p3,p7,-p7);
    endif;
    if ( count(p1.p1,1,p6.p6,1) > count(p3.p3,1,p4.p4,1) );
        multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4);
        id p7 = -p7;
    endif;
    totensor,nosquare,Q,mncFQ;
    id,many,mncq1?{p1,p3,p4,p6,p7}.mncq2?{p1,p3,p4,p6,p7}^D? = mncx^D*mncq1.mncq2^D;
else;
    Print "Illegal case in BE";
    SetExitFlag;
endif;

#call ACCU2(B p8 mncp9 mncnaar mncFQ mncx mncint3,Prepare first loop)
keep brackets;
*
multiply mncint1*mncint2*mncint3;
if ( match(mncnaar(Q,mnceq,1)) );
  id  mncnaar(Q,mnceq,1) = 1;
  id  mncx^D? = mncp9.mncp9^D/Q.Q^D;
  multiply mncp9.mncp9^4/Q.Q^4;
  if ( count(p8.p8,1) >= 0 ) discard;
  if ( count(mncFQ,1) == 0 );
  id  mncint2/mncp9.mncp9^mncx1?/p8.p8^mncx2? =
        1/Q.Q^mncx1/Q.Q^mncx2*Q.Q^2*mnceq*mncG(mncx1,2,mncx2,0,0,0);
  elseif ( match(mncFQ(mnci1?)) );
  id  mncint2*mncFQ(mnci1?)/mncp9.mncp9^mncx1?/p8.p8^mncx2? =
        1/Q.Q^mncx1/Q.Q^mncx2*Q.Q^2*mnceq*Q(mnci1)*mncG(mncx1,2,mncx2,0,1,0);
  elseif ( match(mncFQ(mnci1?,mnci2?)) );
  id  mncint2*mncFQ(mnci1?,mnci2?)/mncp9.mncp9^mncx1?/p8.p8^mncx2? =
        1/Q.Q^mncx1/Q.Q^mncx2*Q.Q^2*mnceq*
        (mncG(mncx1,2,mncx2,0,2,0)*mncFFPP(mnci1,mnci2)
        +mncG(mncx1-1,2,mncx2,0,0,0)*acc(mncpoch(3,1))*d_(mnci1,mnci2)*Q.Q/2);
  else;
  id  mncint2*mncFQ(?a)/mncp9.mncp9^mncx1?/p8.p8^mncx2? =
        mncFQ(?a)/Q.Q^mncx1/Q.Q^mncx2*Q.Q^2*mnceq*
        sum_(mncs,0,integer_(nargs_(?a)/2),mncG(mncx1-mncs,2,mncx2,0,nargs_(?a)-2*mncs,0)
        *acc(mncpoch(nargs_(?a)+2-mncs,mncs))*Q.Q^mncs
        *sum_(mncj,0,integer_(nargs_(?a)/2)-mncs,sign_(mncj)*Q.Q^mncj
*   the original mncy/4 becomes mncy/2 when we consider the normalization of 
*   the distrib_ to expand the mncFQ.
        *mncy^mncj*mncy^mncs/2^mncj/2^mncs*acc(mncpoch(nargs_(?a)+1-2*mncs,mncj))
        ));
  endif;
  #call simplify
  if ( count(mncFQ,1) );
    id  mncy^mncs?*mncFQ(?a) = fac_(mncs)*distrib_(1,2*mncs,mncdel,mncFQ,?a);
    tovector,mncFQ,Q;
    id  mncdel(?a) = dd_(?a);
  else;
    id mncFFPP(mnci1?,mnci2?) = Q(mnci1)*Q(mnci2) - d_(mnci1,mnci2)*Q.Q/2*acc(mncpoch(3,1));
  endif;
else;
  id  p8 = mncp9 - mncq9;
  id  mncnaar(mncq1?,mncy?) = mncnaar(mncq1,mncy)*replace_(mncq9,mncq1);
  repeat;
    id mncFQ(mncp9) = mncp9.mncp9;
    id mncFQ(?a,mncp9,?b) = mncFQ(?a,?b)*mncp9.mncp9;
  endrepeat;
  totensor,nosquare,mncFQ,mncp9;
  if ( count(mncFQ,1) == 0 );
    id  mncnaar(mncq9?,mncy?)*mncint2/mncp9.mncp9^mncx1?/p8.p8^mncx2? =
          mncq9.mncq9^2/mncq9.mncq9^mncx1/mncq9.mncq9^mncx2*mncy
          *mncG(mncx1,0,mncx2,0,0,0);
  elseif ( match(mncFQ(mnci1?)) );
    id  mncnaar(mncq9?,mncy?)*mncint2/mncp9.mncp9^mncx1?/p8.p8^mncx2?*mncFQ(mnci1?) =
          mncq9.mncq9^2/mncq9.mncq9^mncx1/mncq9.mncq9^mncx2*mncy
          *mncG(mncx1,0,mncx2,0,1,0)*mncq9(mnci1);
  elseif ( match(mncFQ(mnci1?,mnci2?)) );
    id  mncnaar(mncq9?,mncy?)*mncint2/mncp9.mncp9^mncx1?/p8.p8^mncx2?*mncFQ(mnci1?,mnci2?) =
          mncq9.mncq9^2/mncq9.mncq9^mncx1/mncq9.mncq9^mncx2*mncy*(
          +mncG(mncx1,0,mncx2,0,2,0)*mncq9(mnci1)*mncq9(mnci2)
          +mncG(mncx1,0,mncx2,0,2,1)*mncq9.mncq9*d_(mnci1,mnci2)/2
      );
  else;
    id  mncnaar(mncq9?,mncx?)*mncint2/mncp9.mncp9^mncx1?/p8.p8^mncx2?*mncFQ(?a) =
          mncnaar(mncq9,mncx)*mncq9.mncq9^2/mncq9.mncq9^mncx1/mncq9.mncq9^mncx2*mncx
          *sum_(mncj,0,integer_(nargs_(?a)/2),mncG(mncx1,0,mncx2,0,nargs_(?a),mncj)
      *mncq9.mncq9^mncj/2^mncj*mncy^mncj)*mncFQ(?a);
  endif;
  #call simplify
  if ( count(mncFQ,1) );
    id  mncy^mncj?*mncFQ(?a) = distrib_(1,2*mncj,mncdel,mncFQ,?a);
    tovector,mncFQ,mncq9;
    id  mncnaar(mncq1?,mncy?) = replace_(mncq9,mncq1);
    id  mncdel(?a) = dd_(?a);
  endif;
endif;

#call ACCU(First loop integral)
*
*   The rest is standard. Note that the momenta that still exist
*   have to be called p1,p3,p4,p6,p7.
*
#call dotwo{}
#call ACCU(Simplify mncG\(3\))
repeat id acc(mncx1?)*acc(mncx2?) = acc(mncx1*mncx2);
multiply ep^-6;
id  acc(mncx1?) = mncx1;
id  ep = 0;
.sort: Expression G scheme;
*
*   Now approximate and convert to MSbar.
*
#call finish(3,`SCHEME')
*
#break
*--#] be : 
*--#[ no :
#case no
*
*   Reduction procedure for three loop graphs of the NO or nonplanar type.
*   Notation is from S.mncG.Gorishny et.al. Comp.Phys.Comm 55(1989)381
*
*                     /-<------<-----<-\
*                 P1 /     \  P2   /    \ P3
*                   /       v     /      \
*                  /      P7 \   /        \
*                 /           \ /          \
*          Q --<--             /            --<-- Q
*                 \           / \          /
*                  \      P8 /   \        / 
*                   \       ^     \      /
*                 P6 \     /  P5   \    / P4
*                     \->------>----->-/
*
multiply mncint3*Q.Q;
#call newplane(p1,p2,p3,p4,p5,p6,p7,p8,Q,mncint3)
#call ACCU(noplane recursion)
repeat id Q.p2/p1.p1/p3.p3/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8 =
    ( p1.p1/2+p3.p3/2-p4.p4/2-p6.p6/2-Q.p5 )
        /p1.p1/p3.p3/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8;
repeat id Q.p2/p1.p1/p2.p2/p3.p3/p4.p4/p5.p5/p6.p6/p8.p8 =
    ( Q.p8+p3.p3/2+Q.Q/2-p4.p4/2 )
        /p1.p1/p2.p2/p3.p3/p4.p4/p5.p5/p6.p6/p8.p8;
repeat id Q.p2/p1.p1/p2.p2/p3.p3/p4.p4/p5.p5/p6.p6/p7.p7 =
    ( Q.p7+p1.p1/2+Q.Q/2-p6.p6/2 )
        /p1.p1/p2.p2/p3.p3/p4.p4/p5.p5/p6.p6/p7.p7;

if ( match(1/p2.p2/p3.p3/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8) );
label 1;
    if ( count(p3.p3,1) < count(p4.p4,1) );
        multiply replace_(p3,-p4,p4,-p3,p2,-p7,p7,-p2,p5,p8,p8,p5);
*    elseif ( ( count(p3.p3,1) == count(p4.p4,1) )
*    && ( count(p5.p5,1) < count(p8.p8,1) ) );
*        multiply replace_(p3,-p4,p4,-p3,p2,-p7,p7,-p2,p5,p8,p8,p5);
    endif;
elseif ( match(1/p1.p1/p2.p2/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8) );
    multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
    goto 1;
elseif ( match(1/p1.p1/p2.p2/p3.p3/p5.p5/p6.p6/p7.p7/p8.p8) );
    multiply replace_(p1,p4,p4,p1,p3,p6,p6,p3,p2,p5,p5,p2,p7,-p7,p8,-p8,Q,-Q);
    goto 1;
elseif ( match(1/p1.p1/p2.p2/p3.p3/p4.p4/p5.p5/p7.p7/p8.p8) );
    multiply replace_(p1,-p6,p6,-p1,p2,-p5,p5,-p2,p3,-p4,p4,-p3,p7,p8,p8,p7);
    goto 1;
elseif ( match(1/p1.p1/p3.p3/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8) );
    if ( count(p7.p7,1) > count(p8.p8,1) );
        multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
    elseif ( count(p7.p7,1) == count(p8.p8,1) );
        if ( count(p1.p1,1) < count(p3.p3,1) );
            multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
        elseif ( count(p1.p1,1) == count(p3.p3,1) );
            if ( count(p6.p6,1) < count(p4.p4,1) )
                multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
        endif;
    endif;
elseif ( match(1/p1.p1/p2.p2/p3.p3/p4.p4/p6.p6/p7.p7/p8.p8) );
    if ( count(p7.p7,1) < count(p8.p8,1) );
        multiply replace_(p1,p4,p4,p1,p3,p6,p6,p3,p2,p5,p5,p2,p7,-p7,p8,-p8,Q,-Q);
    else;
        multiply replace_(p1,-p6,p6,-p1,p2,-p5,p5,-p2,p3,-p4,p4,-p3,p7,p8,p8,p7);
    endif;
    if ( count(p7.p7,1) > count(p8.p8,1) );
        multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
    elseif ( count(p7.p7,1) == count(p8.p8,1) );
        if ( count(p1.p1,1) < count(p3.p3,1) );
            multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
        elseif ( count(p1.p1,1) == count(p3.p3,1) );
            if ( count(p6.p6,1) < count(p4.p4,1) )
                multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
        endif;
    endif;
elseif ( match(1/p1.p1/p2.p2/p3.p3/p4.p4/p5.p5/p6.p6/p8.p8) );
    multiply replace_(p3,-p4,p4,-p3,p2,-p7,p7,-p2,p5,p8,p8,p5);
    if ( count(p7.p7,1) > count(p8.p8,1) );
        multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
    elseif ( count(p7.p7,1) == count(p8.p8,1) );
        if ( count(p1.p1,1) < count(p3.p3,1) );
            multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
        elseif ( count(p1.p1,1) == count(p3.p3,1) );
            if ( count(p6.p6,1) < count(p4.p4,1) )
                multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
        endif;
    endif;
elseif ( match(1/p1.p1/p2.p2/p3.p3/p4.p4/p5.p5/p6.p6/p7.p7) );
    multiply replace_(p1,-p6,p6,-p1,p2,-p8,p8,-p2,p5,p7,p7,p5);
    if ( count(p7.p7,1) > count(p8.p8,1) );
        multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
    elseif ( count(p7.p7,1) == count(p8.p8,1) );
        if ( count(p1.p1,1) < count(p3.p3,1) );
            multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
        elseif ( count(p1.p1,1) == count(p3.p3,1) );
            if ( count(p6.p6,1) < count(p4.p4,1) )
                multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
        endif;
    endif;
else;
    repeat;
    if ( count(p2.p2,1) < count(p5.p5,1) )
        multiply replace_(p1,-p6,p6,-p1,p2,-p5,p5,-p2,p3,-p4,p4,-p3,p7,p8,p8,p7);
    if ( count(p7.p7,1) < count(p8.p8,1) )
        multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
    if ( count(p2.p2,1) < count(p7.p7,1) )
        multiply replace_(p3,-p4,p4,-p3,p2,-p7,p7,-p2,p5,p8,p8,p5);
    endrepeat;
endif;
#call ACCU(Move Q.p2)
#ifdef `POW'
#if `POW' >= 6
if ( match(1/p2.p2/p3.p3/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8) );
    repeat id p1.p1/p6.p6 = 1+mncx/p6.p6;
    id mncx = Q.Q+2*Q.p5+2*Q.p8;
*    repeat id Q.p7/p6.p6/p3.p3/p4.p4 =
*        (p3.p3/2-Q.Q/2-p4.p4/2-Q.p5)/p6.p6/p3.p3/p4.p4;
*    repeat id p7.p8/p6.p6/p3.p3/p4.p4/p2.p2/p5.p5 =
*        (p2.p2/2-p3.p3/2+p5.p5/2-p6.p6/2-Q.p8)/p6.p6/p3.p3/p4.p4/p2.p2/p5.p5;
elseif ( match(1/p1.p1/p3.p3/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8) );
    repeat id p2.p2/p5.p5/p7.p7/p8.p8 =
        (mncx-p5.p5+p7.p7+p8.p8)/p5.p5/p7.p7/p8.p8;
    id mncx = 2*p1.p3-2*Q.p5-Q.Q;
    repeat id p2.p5/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8 =
        (p4.p4/2+p6.p6/2-p7.p7/2-p8.p8/2+Q.p5)/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8;
*    repeat id p7.p8/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8 =
*        (p7.p7+p8.p8-mncy9)/2/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8;
*    if ( match(1/p1.p1/p3.p3/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8) );
*        repeat id Q.p2/p1.p1/p3.p3/p4.p4/p6.p6 =
*            (p1.p1/2+p3.p3/2-p4.p4/2-p6.p6/2-Q.p5)/p1.p1/p3.p3/p4.p4/p6.p6;
*        repeat id Q.p7/p1.p1/p3.p3/p4.p4/p6.p6 =
*            (p3.p3/2-Q.Q/2-p4.p4/2-Q.p5)/p1.p1/p3.p3/p4.p4/p6.p6;
*        repeat id Q.p8/p1.p1/p3.p3/p4.p4/p6.p6 =
*            (p1.p1/2-Q.Q/2-p6.p6/2-Q.p5)/p1.p1/p3.p3/p4.p4/p6.p6;
*    endif;
endif;

#call ACCU(Prepare second A)
#if `POW' >= 8
if ( match(1/p2.p2/p3.p3/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8) );
    repeat id p1.p1/p6.p6 = 1+mncx/p6.p6;
    id mncx = Q.Q+2*Q.p5+2*Q.p8;
    repeat id Q.p7/p6.p6/p3.p3/p4.p4 =
        (p3.p3/2-Q.Q/2-p4.p4/2-Q.p5)/p6.p6/p3.p3/p4.p4;
*    repeat id p7.p8/p6.p6/p3.p3/p4.p4/p2.p2/p5.p5 =
*        (p2.p2/2-p3.p3/2+p5.p5/2-p6.p6/2-Q.p8)/p6.p6/p3.p3/p4.p4/p2.p2/p5.p5;
elseif ( match(1/p1.p1/p3.p3/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8) );
    repeat id p2.p2/p5.p5/p7.p7/p8.p8 =
        (mncx-p5.p5+p7.p7+p8.p8)/p5.p5/p7.p7/p8.p8;
    id mncx = 2*p1.p3-2*Q.p5-Q.Q;
    repeat id p2.p5/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8 =
        (p4.p4/2+p6.p6/2-p7.p7/2-p8.p8/2+Q.p5)/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8;
    repeat id p7.p8/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8 =
        (p7.p7+p8.p8-mncy9)/2/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8;
    if ( match(1/p1.p1/p3.p3/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8) );
        repeat id Q.p2/p1.p1/p3.p3/p4.p4/p6.p6 =
            (p1.p1/2+p3.p3/2-p4.p4/2-p6.p6/2-Q.p5)/p1.p1/p3.p3/p4.p4/p6.p6;
*        repeat id Q.p7/p1.p1/p3.p3/p4.p4/p6.p6 =
*            (p3.p3/2-Q.Q/2-p4.p4/2-Q.p5)/p1.p1/p3.p3/p4.p4/p6.p6;
*        repeat id Q.p8/p1.p1/p3.p3/p4.p4/p6.p6 =
*            (p1.p1/2-Q.Q/2-p6.p6/2-Q.p5)/p1.p1/p3.p3/p4.p4/p6.p6;
    endif;
endif;

#call ACCU(Prepare second B)
#endif
#endif
#endif
if ( match(1/p2.p2/p3.p3/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8) );
    repeat id p1.p1/p6.p6 = 1+mncx/p6.p6;
    id mncx = Q.Q+2*Q.p5+2*Q.p8;
    repeat id Q.p7/p6.p6/p3.p3/p4.p4 =
        (p3.p3/2-Q.Q/2-p4.p4/2-Q.p5)/p6.p6/p3.p3/p4.p4;
    repeat id p7.p8/p6.p6/p3.p3/p4.p4/p2.p2/p5.p5 =
        (p2.p2/2-p3.p3/2+p5.p5/2-p6.p6/2-Q.p8)/p6.p6/p3.p3/p4.p4/p2.p2/p5.p5;
elseif ( match(1/p1.p1/p3.p3/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8) );
    repeat id p2.p2/p5.p5/p7.p7/p8.p8 =
        (mncx-p5.p5+p7.p7+p8.p8)/p5.p5/p7.p7/p8.p8;
    id mncx = 2*p1.p3-2*Q.p5-Q.Q;
    repeat id p2.p5/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8 =
        (p4.p4/2+p6.p6/2-p7.p7/2-p8.p8/2+Q.p5)/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8;
    repeat id p7.p8/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8 =
        (p7.p7+p8.p8-mncy9)/2/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8;
    if ( match(1/p1.p1/p3.p3/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8) );
        repeat id Q.p2/p1.p1/p3.p3/p4.p4/p6.p6 =
            (p1.p1/2+p3.p3/2-p4.p4/2-p6.p6/2-Q.p5)/p1.p1/p3.p3/p4.p4/p6.p6;
        repeat id Q.p7/p1.p1/p3.p3/p4.p4/p6.p6 =
            (p3.p3/2-Q.Q/2-p4.p4/2-Q.p5)/p1.p1/p3.p3/p4.p4/p6.p6;
        repeat id Q.p8/p1.p1/p3.p3/p4.p4/p6.p6 =
            (p1.p1/2-Q.Q/2-p6.p6/2-Q.p5)/p1.p1/p3.p3/p4.p4/p6.p6;
    endif;
endif;
if ( ( match(1/p2.p2/p3.p3/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8) == 0 )
  && ( match(1/p1.p1/p3.p3/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8) == 0 ) );
    repeat;
    if ( count(p2.p2,1) < count(p5.p5,1) )
        multiply replace_(p1,-p6,p6,-p1,p2,-p5,p5,-p2,p3,-p4,p4,-p3,p7,p8,p8,p7);
    if ( count(p7.p7,1) < count(p8.p8,1) )
        multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
    if ( count(p2.p2,1) < count(p7.p7,1) )
        multiply replace_(p3,-p4,p4,-p3,p2,-p7,p7,-p2,p5,p8,p8,p5,mncy9,mncx9,mncx9,mncy9);
    endrepeat;
endif;

#call ACCU(Prepare second)

if ( match(1/p2.p2/p3.p3/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8) );
    id Q.p8 = Q.p2 - p3.p3/2 - Q.Q/2 + p4.p4/2;
    id p2.p5 = Q.p5+p4.p4/2+p6.p6/2-p7.p7/2-p8.p8/2;
elseif ( match(1/p1.p1/p3.p3/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8) );
    id  mncy9 = p1.p1+p3.p3-2*p1.p3;
endif;
#call ACCU(Minimize second)
if ( match(1/p2.p2/p3.p3/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8) );
    multiply acc(1/ep);
    #call triangle(p5,p6,p7,p8,p4)
    multiply ep;
elseif ( match(1/p1.p1/p3.p3/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8) );
    multiply acc(1/ep);
    #call triangle(p5,p8,p7,p6,p4)
    multiply ep;
endif;
id  mncx9 = p2.p2+p5.p5+2*p2.p5;
id  mncy9 = p7.p7+p8.p8-2*p7.p8;
repeat;
    if ( count(p2.p2,1) < count(p5.p5,1) )
        multiply replace_(p1,-p6,p6,-p1,p2,-p5,p5,-p2,p3,-p4,p4,-p3,p7,p8,p8,p7);
    if ( count(p7.p7,1) < count(p8.p8,1) )
        multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
    if ( count(p2.p2,1) < count(p7.p7,1) )
        multiply replace_(p3,-p4,p4,-p3,p2,-p7,p7,-p2,p5,p8,p8,p5);
endrepeat;
#call ACCU(Second recursion)
*
*   Now we try to reduce the number of one loop integrals
*
if ( count(mncint3,1) );
if ( count(p2.p2,1) >= 0 );
    if ( count(p8.p8,1) >= 0 );
            multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
*           Everybody flips sign -> nobody flips sign
    elseif ( count(p3.p3,1) >= 0 );
            multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
*           Everybody flips sign -> nobody flips sign
    elseif ( count(p4.p4,1) >= 0 );
            multiply replace_(p1,p4,p4,p1,p3,p6,p6,p3,p2,p5,p5,p2);
            id  Q = -Q;
            id  p7 = -p7;
            id  p8 = -p8;
    elseif ( count(p6.p6,1) >= 0 );
            multiply replace_(p1,p6,p6,p1,p7,p8,p8,p7,p3,p4,p4,p3
            ,p2,p5,p5,p2);
            id  Q = -Q;
            id  p7 = -p7;
            id  p8 = -p8;
    endif;
elseif ( count(p5.p5,1) >= 0 );
    if ( count(p7.p7,1) >= 0 );
            multiply replace_(p1,p4,p4,p1,p3,p6,p6,p3,p2,p5,p5,p2);
            id  Q = -Q;
            id  p7 = -p7;
            id  p8 = -p8;
    elseif ( count(p8.p8,1) >= 0 );
            multiply replace_(p1,p6,p6,p1,p7,p8,p8,p7,p3,p4,p4,p3
            ,p2,p5,p5,p2);
            id  Q = -Q;
            id  p7 = -p7;
            id  p8 = -p8;
    elseif ( count(p3.p3,1) >= 0 );
            multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
*           Everybody flips sign -> nobody flips sign
    elseif ( count(p4.p4,1) >= 0 );
            multiply replace_(p1,p4,p4,p1,p3,p6,p6,p3,p2,p5,p5,p2);
            id  Q = -Q;
            id  p7 = -p7;
            id  p8 = -p8;
    elseif ( count(p6.p6,1) >= 0 );
            multiply replace_(p1,p6,p6,p1,p7,p8,p8,p7,p3,p4,p4,p3
            ,p2,p5,p5,p2);
            id  Q = -Q;
            id  p7 = -p7;
            id  p8 = -p8;
    endif;
elseif ( count(p7.p7,1) >= 0 );
    if ( count(p8.p8,1) >= 0 );
            multiply replace_(p3,-p4,p4,-p3,p5,p8,p8,p5,p2,-p7,p7,-p2);
    elseif ( count(p1.p1,1) >= 0 );
            multiply replace_(p3,-p4,p4,-p3,p5,p8,p8,p5,p2,-p7,p7,-p2);
    elseif ( count(p3.p3,1) >= 0 );
            multiply replace_(p3,p4,p4,p3,p5,p8,p8,p5,p2,p7,p7,p2);
            id p3 = -p3;
            id p4 = -p4;
            id p2 = -p2;
            id p7 = -p7;
            multiply replace_(p1,p4,p4,p1,p3,p6,p6,p3,p2,p5,p5,p2);
            id  Q = -Q;
            id  p7 = -p7;
            id  p8 = -p8;
    elseif ( count(p4.p4,1) >= 0 );
            multiply replace_(p3,-p4,p4,-p3,p5,p8,p8,p5,p2,-p7,p7,-p2);
            multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
*           Everybody flips sign -> nobody flips sign
    elseif ( count(p6.p6,1) >= 0 );
            multiply replace_(p1,-p6,p6,-p1,p5,p7,p7,p5,p2,-p8,p8,-p2);
    endif;
elseif ( count(p8.p8,1) >= 0 );
    if ( count(p1.p1,1) >= 0 );
            multiply replace_(p3,-p4,p4,-p3,p5,p8,p8,p5,p2,-p7,p7,-p2);
    elseif ( count(p3.p3,1) >= 0 );
            multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
*           Everybody flips sign -> nobody flips sign
            multiply replace_(p3,-p4,p4,-p3,p5,p8,p8,p5,p2,-p7,p7,-p2);
    elseif ( count(p4.p4,1) >= 0 );
            multiply replace_(p1,p4,p4,p1,p3,p6,p6,p3,p2,p5,p5,p2);
            id  Q = -Q;
            id  p7 = -p7;
            id  p8 = -p8;
            multiply replace_(p3,-p4,p4,-p3,p5,p8,p8,p5,p2,-p7,p7,-p2);
    elseif ( count(p6.p6,1) >= 0 );
            multiply replace_(p1,-p6,p6,-p1,p5,p7,p7,p5,p2,-p8,p8,-p2);
    endif;
elseif ( count(p3.p3,1) >= 0 );
    if ( count(p4.p4,1) >= 0 );
            multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
*           Everybody flips sign -> nobody flips sign
    elseif ( count(p6.p6,1) >= 0 );
            multiply replace_(p1,p6,p6,p1,p5,p7,p7,p5,p2,p8,p8,p2);
            id  p1 = -p1;
            id  p6 = -p6;
            id  p2 = -p2;
            id  p8 = -p8;
    endif;
elseif ( count(p4.p4,1) >= 0 );
    if ( count(p1.p1,1) >= 0 );
            multiply replace_(p3,-p4,p4,-p3,p5,p8,p8,p5,p2,-p7,p7,-p2);
    elseif ( count(p6.p6,1) >= 0 );
            multiply replace_(p1,p6,p6,p1,p7,p8,p8,p7,p3,p4,p4,p3
            ,p2,p5,p5,p2);
            id  Q = -Q;
            id  p7 = -p7;
            id  p8 = -p8;
    endif;
endif;
endif;
#call ACCU(Symmetry)
if ( count(mncint3,1) );
  if ( count(p2.p2,1) >= 0 );
      if ( count(p1.p1,1) >= 0 );
*          id  p1.p1 = p6.p6+Q.Q+2*Q.p6;
*          id  p2.p2 = p3.p3+p8.p8+2*p3.p8;
*          id  p1 = p6+Q;
*          id  p2 = p3+p8;
          if ( ( count(p6.p6,1) >= 0 ) || ( count(p8.p8,1) >= 0 ) ) discard;
      elseif ( count(p7.p7,1) >= 0 );
          if ( count(p5.p5,1) >= 0 ) discard;
*          id  p2.p2 = p3.p3+p8.p8+2*p3.p8;
*          id  p7.p7 = p4.p4+p5.p5-2*p4.p5;
*          id  p2 = p3+p8;
*          id  p7 = p4-p5;
          if ( ( count(p3.p3,1) >= 0 ) || ( count(p4.p4,1) >= 0 ) ) discard;
      elseif( count(p5.p5,1) >= 0);
          repeat id  p5.p5/p6.p6 = 1+p8.p8/p6.p6-2*p6.p8/p6.p6;
          if ( count(p8.p8,1) >= 0 ) discard;
          repeat id  p5.p6/p6.p6 = 1-p6.p8/p6.p6;
          if ( count(p6.p6,1) >= 0 );
             multiply replace_(p1,-p6,p6,-p1,p5,-p2,p2,-p5,p3,-p4,p4,-p3
             ,p7,p8,p8,p7);
          else;
             repeat id  p2.p2/p3.p3 = 1+p8.p8/p3.p3+2*p3.p8/p3.p3;
             repeat id  p2.p3/p3.p3 = 1+p3.p8/p3.p3;
             if ( count(p8.p8,1) >= 0 ) discard;
             if ( count(p3.p3,1) >= 0 );
                multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
             else;
*                id  p5 = p6-p8;
*                id  p2 = p3+p8;
                if ( count(p8.p8,1) >= 0 ) discard;
             endif;
          endif;
      else;
          exit "mincer integral Setup first loop";
      endif;
  elseif ( count(p1.p1,1) >= 0 );
      if ( count(p6.p6,1) >= 0 );
*          id  p1.p1 = p2.p2+p7.p7-2*p2.p7;
          if ( ( count(p2.p2,1) >= 0 ) || ( count(p7.p7,1) >= 0 ) ) discard;
*          id  p6.p6 = p5.p5+p8.p8+2*p5.p8;
          if ( ( count(p5.p5,1) >= 0 ) || ( count(p8.p8,1) >= 0 ) ) discard;
*          id  p1 = p2-p7;
*          id  p6 = p5+p8;
*          if ( ( count(p2.p2,1) >= 0 ) || ( count(p8.p8,1) >= 0 ) ) discard;
*          if ( ( count(p5.p5,1) >= 0 ) || ( count(p7.p7,1) >= 0 ) ) discard;
      elseif ( count(p5.p5,1) >= 0 );
          repeat id  p1.p1/p2.p2/p7.p7 = 1/p7.p7+1/p2.p2-2*p2.p7/p2.p2/p7.p7;
          repeat id  p1.p2/p2.p2 = 1-p2.p7/p2.p2;
          repeat id  p1.p7/p7.p7 = p2.p7/p7.p7-1;
          if ( ( count(p6.p6,1) >= 0 ) || ( count(p7.p7,1) >= 0 ) ) discard;
          if ( count(p2.p2,1) < 0 );
             repeat id  p5.p5/p4.p4 = 1+p7.p7/p4.p4-2*p4.p7/p4.p4;
             id  p5.p7 = p4.p7-p7.p7;
             if ( count(p7.p7,1) >= 0 ) discard;
             repeat id  p4.p5/p4.p4 = 1-p4.p7/p4.p4;
             if ( count(p4.p4,1) >= 0 );
               multiply replace_(Q,-Q,p1,p4,p4,p1,p2,p5,p5,p2,p3,p6,p6,p3
               ,p7,-p7,p8,-p8);
             else;
*               id  p1 = p2-p7;
*               id  p5 = p4-p7;
             endif;
          endif;
      elseif ( count(p3.p3,1) >= 0 );
          repeat id  p1.p1/p6.p6 = 1+Q.Q/p6.p6+2*Q.p6/p6.p6;
          repeat id  p1.p6/p6.p6 = 1+Q.p6/p6.p6;
          if ( count(p6.p6,1) < 0 );
            repeat id  p3.p3/p4.p4 = 1+Q.Q/p4.p4+2*Q.p4/p4.p4;
            repeat id  p3.p4/p4.p4 = 1+Q.p4/p4.p4;
            if ( count(p4.p4,1) >= 0 );
              multiply replace_(p1,p3,p3,p1,p7,p8,p8,p7,p4,p6,p6,p4);
            else;
              id  p1 = Q+p6;
              id  p3 = Q+p4;
            endif;
          endif;
      else;
          exit "mincer integral Setup first loop";
      endif;
  else;
      exit "mincer integral Setup first loop";
  endif;
endif;
#call ACCU(Setup first loop)
if ( count(mncint3,1) );
  repeat;
  if ( count(p2.p2,1) >= 0 );
      if ( count(p1.p1,1) >= 0 );
          id  p1.p1 = p6.p6+Q.Q+2*Q.p6;
          id  p2.p2 = p3.p3+p8.p8+2*p3.p8;
          id  p1 = p6+Q;
          id  p2 = p3+p8;
          if ( ( count(p6.p6,1) >= 0 ) || ( count(p8.p8,1) >= 0 ) ) discard;
      elseif ( count(p7.p7,1) >= 0 );
          if ( count(p5.p5,1) >= 0 ) discard;
          id  p2.p2 = p3.p3+p8.p8+2*p3.p8;
          id  p7.p7 = p4.p4+p5.p5-2*p4.p5;
          id  p2 = p3+p8;
          id  p7 = p4-p5;
          if ( ( count(p3.p3,1) >= 0 ) || ( count(p4.p4,1) >= 0 ) ) discard;
      elseif( count(p5.p5,1) >= 0);
          repeat id  p5.p5/p6.p6 = 1+p8.p8/p6.p6-2*p6.p8/p6.p6;
          if ( count(p8.p8,1) >= 0 ) discard;
          repeat id  p5.p6/p6.p6 = 1-p6.p8/p6.p6;
          if ( count(p6.p6,1) >= 0 );
             multiply replace_(p1,-p6,p6,-p1,p5,-p2,p2,-p5,p3,-p4,p4,-p3
             ,p7,p8,p8,p7);
          else;
             repeat id  p2.p2/p3.p3 = 1+p8.p8/p3.p3+2*p3.p8/p3.p3;
             repeat id  p2.p3/p3.p3 = 1+p3.p8/p3.p3;
             if ( count(p8.p8,1) >= 0 ) discard;
             if ( count(p3.p3,1) >= 0 );
                multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
             else;
                id  p5 = p6-p8;
                id  p2 = p3+p8;
                if ( count(p8.p8,1) >= 0 ) discard;
             endif;
          endif;
      else;
          exit "mincer integral Prepare first loop";
      endif;
  elseif ( count(p1.p1,1) >= 0 );
      if ( count(p6.p6,1) >= 0 );
          id  p1.p1 = p2.p2+p7.p7-2*p2.p7;
          if ( ( count(p2.p2,1) >= 0 ) || ( count(p7.p7,1) >= 0 ) ) discard;
          id  p6.p6 = p5.p5+p8.p8+2*p5.p8;
          if ( ( count(p5.p5,1) >= 0 ) || ( count(p8.p8,1) >= 0 ) ) discard;
          id  p1 = p2-p7;
          id  p6 = p5+p8;
          if ( ( count(p2.p2,1) >= 0 ) || ( count(p8.p8,1) >= 0 ) ) discard;
          if ( ( count(p5.p5,1) >= 0 ) || ( count(p7.p7,1) >= 0 ) ) discard;
      elseif ( count(p5.p5,1) >= 0 );
          repeat id  p1.p1/p2.p2/p7.p7 = 1/p7.p7+1/p2.p2-2*p2.p7/p2.p2/p7.p7;
          repeat id  p1.p2/p2.p2 = 1-p2.p7/p2.p2;
          repeat id  p1.p7/p7.p7 = p2.p7/p7.p7-1;
          if ( ( count(p6.p6,1) >= 0 ) || ( count(p7.p7,1) >= 0 ) ) discard;
          if ( count(p2.p2,1) < 0 );
             repeat id  p5.p5/p4.p4 = 1+p7.p7/p4.p4-2*p4.p7/p4.p4;
             id  p5.p7 = p4.p7-p7.p7;
             if ( count(p7.p7,1) >= 0 ) discard;
             repeat id  p4.p5/p4.p4 = 1-p4.p7/p4.p4;
             if ( count(p4.p4,1) >= 0 );
               multiply replace_(Q,-Q,p1,p4,p4,p1,p2,p5,p5,p2,p3,p6,p6,p3
               ,p7,-p7,p8,-p8);
             else;
               id  p1 = p2-p7;
               id  p5 = p4-p7;
             endif;
          endif;
      elseif ( count(p3.p3,1) >= 0 );
          repeat id  p1.p1/p6.p6 = 1+Q.Q/p6.p6+2*Q.p6/p6.p6;
          repeat id  p1.p6/p6.p6 = 1+Q.p6/p6.p6;
          if ( count(p6.p6,1) < 0 );
            repeat id  p3.p3/p4.p4 = 1+Q.Q/p4.p4+2*Q.p4/p4.p4;
            repeat id  p3.p4/p4.p4 = 1+Q.p4/p4.p4;
            if ( count(p4.p4,1) >= 0 );
              multiply replace_(p1,p3,p3,p1,p7,p8,p8,p7,p4,p6,p6,p4);
            else;
              id  p1 = Q+p6;
              id  p3 = Q+p4;
            endif;
          endif;
      else;
          exit "mincer integral Prepare first loop";
      endif;
  else;
      exit "mincer integral Prepare first loop";
  endif;
  endrepeat;
  if ( count(p2.p2,1) >= 0 );
      if ( count(p1.p1,1) >= 0 );
        multiply replace_(p5,p6,p6,mncp9,p7,-p7);
        multiply mncnaar(p6,mnce6);
        id  p8.mncp9 = mncp9.mncp9/2+p8.p8/2-p6.p6/2;
        if ( ( count(p8.p8,1) >= 0 ) || ( count(mncp9.mncp9,1) >= 0 ) ) discard;
        if ( count(p8.Q,1,p8.p1,1,p8.p3,1,p8.p4,1,p8.p6,1,p8.p7,1)
        > count(mncp9.Q,1,mncp9.p1,1,mncp9.p3,1,mncp9.p4,1,mncp9.p6,1,mncp9.p7,1) )
            multiply replace_(p8,-mncp9,mncp9,-p8);
        id  p8.mncq1?!{p8} = mncp9.mncq1 - p6.mncq1;
        totensor,nosquare,mncp9,mncFQ;
      elseif ( count(p7.p7,1) >= 0 );
        multiply replace_(p8,p7,p5,p4,p3,mncp9,p4,p8);
        multiply mncnaar(Q,mnceq);
        id  p8.mncp9 = mncp9.mncp9/2+p8.p8/2-Q.Q/2;
        if ( ( count(p8.p8,1) >= 0 ) || ( count(mncp9.mncp9,1) >= 0 ) ) discard;
        if ( count(p8.Q,1,p8.p1,1,p8.p3,1,p8.p4,1,p8.p6,1,p8.p7,1)
        > count(mncp9.Q,1,mncp9.p1,1,mncp9.p3,1,mncp9.p4,1,mncp9.p6,1,mncp9.p7,1) )
            multiply replace_(p8,-mncp9,mncp9,-p8);
        id  p8.mncq1?!{p8} = mncp9.mncq1 - Q.mncq1;
        totensor,nosquare,mncp9,mncFQ;
      else;   * must be p5
        multiply replace_(p7,-mncp9,p8,-p8);
        multiply mncnaar(p7,mnce7);
        id  p8.mncp9 = mncp9.mncp9/2+p8.p8/2-p7.p7/2;
        if ( ( count(p8.p8,1) >= 0 ) || ( count(mncp9.mncp9,1) >= 0 ) ) discard;
        if ( count(p8.Q,1,p8.p1,1,p8.p3,1,p8.p4,1,p8.p6,1,p8.p7,1)
        > count(mncp9.Q,1,mncp9.p1,1,mncp9.p3,1,mncp9.p4,1,mncp9.p6,1,mncp9.p7,1) )
            multiply replace_(p8,-mncp9,mncp9,-p8);
        id  p8.mncq1?!{p8} = mncp9.mncq1 - p7.mncq1;
        totensor,nosquare,mncp9,mncFQ;
      endif;
  else;
      if ( count(p6.p6,1) >= 0 );
        multiply replace_(p7,-p8,p8,p7,p2,p1,p5,mncp9);
        multiply mncnaar(p4,mnce4);
        id  p8.mncp9 = mncp9.mncp9/2+p8.p8/2-p4.p4/2;
        if ( ( count(p8.p8,1) >= 0 ) || ( count(mncp9.mncp9,1) >= 0 ) ) discard;
        if ( count(p8.Q,1,p8.p1,1,p8.p3,1,p8.p4,1,p8.p6,1,p8.p7,1)
        > count(mncp9.Q,1,mncp9.p1,1,mncp9.p3,1,mncp9.p4,1,mncp9.p6,1,mncp9.p7,1) )
            multiply replace_(p8,-mncp9,mncp9,-p8);
        id  p8.mncq1?!{p8} = mncp9.mncq1 - p4.mncq1;
        totensor,nosquare,mncp9,mncFQ;
      elseif ( count(p5.p5,1) >= 0 );
        multiply replace_(p8,p7,p7,-p8,p2,p1,p6,mncp9);
        multiply mncnaar(p6,mnce6);
        id  p8.mncp9 = mncp9.mncp9/2+p8.p8/2-p6.p6/2;
        if ( ( count(p8.p8,1) >= 0 ) || ( count(mncp9.mncp9,1) >= 0 ) ) discard;
        if ( count(p8.Q,1,p8.p1,1,p8.p3,1,p8.p4,1,p8.p6,1,p8.p7,1)
        > count(mncp9.Q,1,mncp9.p1,1,mncp9.p3,1,mncp9.p4,1,mncp9.p6,1,mncp9.p7,1) )
            multiply replace_(p8,-mncp9,mncp9,-p8);
        id  p8.mncq1?!{p8} = mncp9.mncq1 - p6.mncq1;
        totensor,nosquare,mncp9,mncFQ;
      else;
          if ( count(p2.p2,1) >= 0 ) discard;
          multiply replace_(p7,-p1,p4,-p3,p8,p4,p5,p7,p2,-p8);
        multiply mncnaar(Q,mnceq,1);
        id  Q.p8 = mncp9.mncp9/2-p8.p8/2-Q.Q/2;
        if ( count(p8.p8,1) >= 0 ) discard;
        id  p8 = mncp9-Q;
        id  mncp9.mncq1?{p1,p3,p4,p6,p7} = p1.mncq1-p6.mncq1;
        id  Q.mncp9 = mncp9.mncp9/2+Q.Q/2-p8.p8/2;
        if ( count(p8.p8,1) >= 0 ) discard;
        if ( count(p1.p1,1,p3.p3,1) > count(p4.p4,1,p6.p6,1) );
            multiply replace_(p1,-p6,p6,-p1,p3,-p4,p4,-p3,p7,-p7);
        endif;
        if ( count(p1.p1,1,p6.p6,1) > count(p3.p3,1,p4.p4,1) );
            multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4);
            id p7 = -p7;
        endif;
        totensor,nosquare,Q,mncFQ;
        id,many,mncq1?{p1,p3,p4,p6,p7}.mncq2?{p1,p3,p4,p6,p7}^D? = mncx^D*mncq1.mncq2^D;
      endif;
  endif;
endif;
if ( ( count(mncint3,1) > 0 ) && ( count(mncnaar,1) == 0 ) );
    Print "Illegal case in NO";
    SetExitFlag;
endif;

#call ACCU2(B p8 mncp9 mncnaar mncFQ mncx mncint3,Prepare first loop)
keep brackets;
if ( count(mncint3,1) );
  id  mncint3 = mncint1*mncint2*mncint3;
  if ( match(mncnaar(Q,mnceq,1)) );
    id  mncnaar(Q,mnceq,1) = 1;
    id  mncx^D? = mncp9.mncp9^D/Q.Q^D;
    multiply mncp9.mncp9^4/Q.Q^4;
    if ( count(p8.p8,1) >= 0 ) discard;
    if ( count(mncFQ,1) == 0 );
    id  mncint2/mncp9.mncp9^mncx1?/p8.p8^mncx2? =
          1/Q.Q^mncx1/Q.Q^mncx2*Q.Q^2*mnceq*
          mncG(mncx1,2,mncx2,0,0,0);
    elseif ( match(mncFQ(mnci1?)) );
    id  mncint2*mncFQ(mnci1?)/mncp9.mncp9^mncx1?/p8.p8^mncx2? =
          1/Q.Q^mncx1/Q.Q^mncx2*Q.Q^2*mnceq*Q(mnci1)*
          mncG(mncx1,2,mncx2,0,1,0);
    elseif ( match(mncFQ(mnci1?,mnci2?)) );
    id  mncint2*mncFQ(mnci1?,mnci2?)/mncp9.mncp9^mncx1?/p8.p8^mncx2? =
          1/Q.Q^mncx1/Q.Q^mncx2*Q.Q^2*mnceq*
        (mncG(mncx1,2,mncx2,0,2,0)*mncFFPP(mnci1,mnci2)
        +mncG(mncx1-1,2,mncx2,0,0,0)*acc(mncpoch(3,1))*d_(mnci1,mnci2)*Q.Q/2);
    else;
    id  mncint2*mncFQ(?a)/mncp9.mncp9^mncx1?/p8.p8^mncx2? =
          mncFQ(?a)/Q.Q^mncx1/Q.Q^mncx2*Q.Q^2*mnceq*
          sum_(mncs,0,integer_(nargs_(?a)/2),mncG(mncx1-mncs,2,mncx2,0,nargs_(?a)-2*mncs,0)
          *acc(mncpoch(nargs_(?a)+2-mncs,mncs))*Q.Q^mncs
          *sum_(mncj,0,integer_(nargs_(?a)/2)-mncs,sign_(mncj)*Q.Q^mncj
*   the original mncy/4 becomes mncy/2 when we consider the normalization of 
*   the distrib_ to expand the mncFQ.
          *mncy^mncj*mncy^mncs/2^mncj/2^mncs*acc(mncpoch(nargs_(?a)+1-2*mncs,mncj))
          ));
    endif;
    #call simplify
    if ( count(mncFQ,1) );
      id  mncy^mncs?*mncFQ(?a) = fac_(mncs)*distrib_(1,2*mncs,mncdel,mncFQ,?a);
      tovector,mncFQ,Q;
      id  mncdel(?a) = dd_(?a);
    else;
      id mncFFPP(mnci1?,mnci2?) = Q(mnci1)*Q(mnci2) - d_(mnci1,mnci2)*Q.Q/2*acc(mncpoch(3,1));
    endif;
  else;
    id  p8 = mncp9 - mncq9;
    id  mncnaar(mncq1?,mncy?) = mncnaar(mncq1,mncy)*replace_(mncq9,mncq1);
    repeat;
      id mncFQ(mncp9) = mncp9.mncp9;
      id mncFQ(?a,mncp9,?b) = mncFQ(?a,?b)*mncp9.mncp9;
    endrepeat;
    totensor,nosquare,mncFQ,mncp9;
    if ( count(mncFQ,1) == 0 );
      id  mncnaar(mncq9?,mncy?)*mncint2/mncp9.mncp9^mncx1?/p8.p8^mncx2? =
            mncq9.mncq9^2/mncq9.mncq9^mncx1/mncq9.mncq9^mncx2*mncy
            *mncG(mncx1,0,mncx2,0,0,0);
    elseif ( match(mncFQ(mnci1?)) );
      id  mncnaar(mncq9?,mncy?)*mncint2/mncp9.mncp9^mncx1?/p8.p8^mncx2?*mncFQ(mnci1?) =
            mncq9.mncq9^2/mncq9.mncq9^mncx1/mncq9.mncq9^mncx2*mncy
            *mncG(mncx1,0,mncx2,0,1,0)*mncq9(mnci1);
    elseif ( match(mncFQ(mnci1?,mnci2?)) );
      id  mncnaar(mncq9?,mncy?)*mncint2/mncp9.mncp9^mncx1?/p8.p8^mncx2?*mncFQ(mnci1?,mnci2?) =
            mncq9.mncq9^2/mncq9.mncq9^mncx1/mncq9.mncq9^mncx2*mncy*(
            +mncG(mncx1,0,mncx2,0,2,0)*mncq9(mnci1)*mncq9(mnci2)
            +mncG(mncx1,0,mncx2,0,2,1)*mncq9.mncq9*d_(mnci1,mnci2)/2
        );
    else;
      id  mncnaar(mncq9?,mncx?)*mncint2/mncp9.mncp9^mncx1?/p8.p8^mncx2?*mncFQ(?a) =
            mncnaar(mncq9,mncx)*mncq9.mncq9^2/mncq9.mncq9^mncx1/mncq9.mncq9^mncx2*mncx
            *sum_(mncj,0,integer_(nargs_(?a)/2),mncG(mncx1,0,mncx2,0,nargs_(?a),mncj)
            *mncq9.mncq9^mncj/2^mncj*mncy^mncj)*mncFQ(?a);
    endif;
    #call simplify
    if ( count(mncFQ,1) );
      id  mncy^mncj?*mncFQ(?a) = distrib_(1,2*mncj,mncdel,mncFQ,?a);
      tovector,mncFQ,mncq9;
      id  mncnaar(mncq1?,mncy?) = replace_(mncq9,mncq1);
      id  mncdel(?a) = dd_(?a);
    endif;
  endif;
else;
  multiply ep;
endif;

#call ACCU(First loop integral)

#call dotwo{}
#call ACCU(Simplify mncG\(3\))
repeat id acc(mncx1?)*acc(mncx2?) = acc(mncx1*mncx2);
multiply ep^-6;
id  acc(mncx1?) = mncx1;
id  ep = 0;
.sort: Expression G scheme;
#call finish(3,`SCHEME')
*
#break
*--#] no : 
*--#[ o1 :
#case o1
*
*   Integral of type O1.
*
id	p6.p7 = p5.p5/2-p6.p6/2-p7.p7/2;
id  p7.mncq1?!{p7} = p5.mncq1-p6.mncq1;
id  p5.p6 = p5.p5/2+p6.p6/2-p7.p7/2;
if ( ( count(p6.p6,1) >= 0 ) || ( count(p7.p7,1) >= 0 ) ) discard;
#call ACCU(Momenta 1)
multiply mncint1*mncint2*mncint3*Q.Q;
#call one(p6,p7,p5,mnce6,mnce7,mnce5,mncint2)
#call ACCU2(B mncG,Integral 1)
Keep Brackets;
#call simplify
#call ACCU(Simplify 1)
*
*   The rest is standard. Note that the momenta that still exist
*   have to be called p1,p3,p4,p6,p7.
*
multiply replace_(p2,p3,p3,p4,p4,p6,p5,p7,mnce5,mnce7);
#call dotwo{}
#call ACCU(Simplify mncG\(3\))
repeat id acc(mncx1?)*acc(mncx2?) = acc(mncx1*mncx2);
multiply ep^-6;
id      acc(mncx1?) = mncx1;
id      ep = 0;
.sort: Expression G scheme;
*
#call finish(3,`SCHEME')
*
#break
*--#] o1 : 
*--#[ o2 :
#case o2
*
*   Integral of type O2.
*
*id  p7 = p4-p6;
id  p4.p6 = p4.p4/2+p6.p6/2-p7.p7/2;
if ( ( count(p6.p6,1) >= 0 ) || ( count(p7.p7,1) >= 0 ) ) discard;
#call ACCU(Momenta 1)
multiply mncint1*mncint2*mncint3*Q.Q;
#call one(p6,p7,p4,mnce6,mnce7,mnce4,mncint2)
#call ACCU2(B mncG,Integral 1)
Keep Brackets;
#call simplify
#call ACCU(Simplify 1)
*
*   The rest is standard. Note that the momenta that still exist
*   have to be called p1,p3,p4,p6,p7.
*
multiply replace_(p2,p3,p3,p4,p4,p6,p5,p7,mnce4,mnce6);
#call dotwo{}
#call ACCU(Simplify mncG\(3\))
repeat id acc(mncx1?)*acc(mncx2?) = acc(mncx1*mncx2);
multiply ep^-6;
id      acc(mncx1?) = mncx1;
id      ep = 0;
.sort: Expression G scheme;
*
#call finish(3,`SCHEME')
*
#break
*--#] o2 : 
*--#[ o3 :
#case o3
*
*   Integral of type O3.
*
id  p7 = Q-p6;
id  Q.p6 = Q.Q/2+p6.p6/2-p7.p7/2;
if ( ( count(p6.p6,1) >= 0 ) || ( count(p7.p7,1) >= 0 ) ) discard;
#call ACCU(Momenta 1)
multiply mncint1*mncint2*mncint3*Q.Q;
#call one(p6,p7,Q,mnce6,mnce7,mnceq,mncint2)
#call ACCU2(B mncG,Integral 1)
Keep Brackets;
#call simplify
#call ACCU(Simplify 1)
*
*   The rest is standard. Note that the momenta that still exist
*   have to be called p1,p3,p4,p6,p7.
*
multiply replace_(p2,p3,p3,p4,p4,p6,p5,p7);
#call dotwo{}
#call ACCU(Simplify mncG\(3\))
repeat id acc(mncx1?)*acc(mncx2?) = acc(mncx1*mncx2);
multiply ep^-6;
id      acc(mncx1?) = mncx1;
id      ep = 0;
.sort: Expression G scheme;
*
#call finish(3,`SCHEME')
*
#break
*--#] o3 : 
*--#[ o4 :
#case o4
*
*   Integral of type O4
*   Note that this is a hacked up version of BE
*   The multiplicative constant is for the Bjorken sumrule
*
id  p6.p1 = p1.p1/2+p6.p6/2-p4.p4/2;
#call ACCU(scalars 1)
id  p6.p2 = p2.p2/2+p6.p6/2-p3.p3/2;
#call ACCU(scalars 2)
id  p1.p2 = p1.p1/2+p2.p2/2-p5.p5/2;
#call ACCU(scalars 3)
id  Q.p6 = Q.Q/2+p6.p6/2-p7.p7/2;
if ( count(p7.p7,1) >= 0 ) discard;
#call ACCU(scalars 4)
id,many,mncq1?{p1,p2,p3,p4,p5}.mncq2?{p1,p2,p3,p4,p5}^mncx1?
        = mncq1.mncq2^mncx1*p6.p6^mncx1/Q.Q^mncx1;
totensor,nosquare,mncFQ,Q;
#call ACCU2(B p6 p7 mncFQ,Prepare first loop)
keep brackets;
multiply mncint1*mncint2*mncint3*mnce6^2/mnceq^2*p6.p6^4/Q.Q^3;
if ( count(mncFQ,1) == 0 );
   id  mncint2/p6.p6^mncx1?/p7.p7^mncx2?*mnce6^mncy1? =
        1/Q.Q^mncx1/Q.Q^mncx2*Q.Q^2*mnceq*mnceq^mncy1*
        mncG(mncx1,mncy1,mncx2,0,0,0);
   #call simplify
elseif ( match(mncFQ(mnci1?)) );
   id  mncint2*mncFQ(mnci1?)/p6.p6^mncx1?/p7.p7^mncx2?*mnce6^mncy1? =
        1/Q.Q^mncx1/Q.Q^mncx2*Q.Q^2*mnceq*mnceq^mncy1*Q(mnci1)*
        mncG(mncx1,mncy1,mncx2,0,1,0);
   #call simplify
elseif ( match(mncFQ(mnci1?,mnci2?)) );
   id  mncint2*mncFQ(mnci1?,mnci2?)/p6.p6^mncx1?/p7.p7^mncx2?*mnce6^mncy1? =
        1/Q.Q^mncx1/Q.Q^mncx2*Q.Q^2*mnceq*mnceq^mncy1*
        (mncG(mncx1,mncy1,mncx2,0,2,0)*Q(mnci1)*Q(mnci2)
        -mncG(mncx1,mncy1,mncx2,0,2,0)*d_(mnci1,mnci2)*Q.Q/2*acc(mncpoch(3,1))
        +mncG(mncx1-1,mncy1,mncx2,0,0,0)*acc(mncpoch(3,1))*d_(mnci1,mnci2)*Q.Q/2);
   #call simplify
else;
   id  mncint2*mncFQ(?a)/p6.p6^mncx1?/p7.p7^mncx2?*mnce6^mncy1? =
        mncFQ(?a)/Q.Q^mncx1/Q.Q^mncx2*Q.Q^2*mnceq*mnceq^mncy1*
        sum_(mncs,0,integer_(nargs_(?a)/2),mncG(mncx1-mncs,mncy1,mncx2,0,nargs_(?a)-2*mncs,0)
        *acc(mncpoch(nargs_(?a)+2-mncs,mncs))*Q.Q^mncs
        *sum_(mncj,0,integer_(nargs_(?a)/2)-mncs,sign_(mncj)*Q.Q^mncj
*   the original mncy/4 becomes mncy/2 when we consider the normalization of 
*   the distrib_ to expand the mncFQ.
        *mncy^mncj*mncy^mncs/2^mncj/2^mncs*acc(mncpoch(nargs_(?a)+1-2*mncs,mncj))
        ));
   #call simplify
   id  mncy^mncs?*mncFQ(?a) = fac_(mncs)*distrib_(1,2*mncs,mncdel,mncFQ,?a);
   tovector,mncFQ,Q;
   id  mncdel(?a) = dd_(?a);
endif;

*#call one4(p6,p7,Q,mnce6,mnce7,mnceq,p1,p2,p3,p4,p5,mncint2)
#call ACCU(First loop integral)
*#call simplify
*#call ACCU(Simplify first mncG)
*
*   The rest is standard. Note that the momenta that still exist
*   have to be called p1,p3,p4,p6,p7.
*
multiply replace_(p2,p3,p3,p4,p4,p6,p5,p7);
#call dotwo{}
#call ACCU(Simplify mncG\(3\));
repeat id acc(mncx1?)*acc(mncx2?) = acc(mncx1*mncx2);
multiply ep^-6;
id      acc(mncx1?) = mncx1;
id      ep = 0;
.sort: Expression G scheme;
*
#call finish(3,`SCHEME')
*
#break
*--#] o4 : 
*--#[ y1 :
#case y1
*
*   File inpy1 does 3-loop diagrams of type Y1.
*   The algorithm here is designed especially for these diagrams
*   so that things may proceed faster.
*
id  p1.p3 = p1.p1/2+p3.p3/2-p4.p4/2;
id  p2.p5 = p2.p2/2+p5.p5/2-p6.p6/2;
if ( ( count(p3.p3,1) >= 0 ) || ( count(p4.p4,1) >= 0 )
  || ( count(p5.p5,1) >= 0 ) || ( count(p6.p6,1) >= 0 ) ) discard;
#call ACCU(Momenta substitutions)
multiply mncint1*mncint2*mncint3/mnceq^3;
#call one(p3,p4,p1,mnce3,mnce4,mnce1,mncint1)
#call ACCU2(B mncG,integral 1)
Keep Brackets;
#call simplify
#call ACCU(Simplify 1)
#call one(p5,p6,p2,mnce5,mnce6,mnce2,mncint2)
#call ACCU2(B mncG mncexp10 mncexp20 mncexp11,integral 2)
Keep Brackets;
#call simplify
#call ACCU(Simplify 2)
id  p2.mncq1?!{p2} = Q.mncq1-p1.mncq1;
id  Q.p1 = Q.Q/2+p1.p1/2-p2.p2/2;
#call ACCU(Momenta 3)
#call one(p1,p2,Q,mnce1,mnce2,mnceq,mncint3)
#call ACCU2(B mncG mncexp10 mncexp20 mncexp11,integral 3)
Keep Brackets;
#call simplify
#call ACCU(Simplify 3)
repeat id acc(mncx1?)*acc(mncx2?) = acc(mncx1*mncx2);
multiply ep^-6;
id      acc(mncx1?) = mncx1;
id      ep = 0;
.sort: Expression G scheme;
*
#call finish(3,`SCHEME')
*
#break
*--#] y1 : 
*--#[ y2 :
#case y2
*
*   File inpy2 does 3-loop diagrams of type Y2.
*   The algorithm here is designed especially for these diagrams
*   so that things may proceed faster.
*
id  p1.p3 = p1.p1/2+p3.p3/2-p4.p4/2;
id  p1.p5 = p1.p1/2+p5.p5/2-p6.p6/2;
if ( ( count(p3.p3,1) >= 0 ) || ( count(p4.p4,1) >= 0 )
  || ( count(p5.p5,1) >= 0 ) || ( count(p6.p6,1) >= 0 ) ) discard;
#call ACCU(Momenta substitutions)
multiply mncint1*mncint2*mncint3/mnceq^3;
#call one(p3,p4,p1,mnce3,mnce4,mnce1,mncint1)
#call ACCU2(B mncG,integral 1)
Keep Brackets;
#call simplify
#call ACCU(Simplify 1)
#call one(p5,p6,p1,mnce5,mnce6,mnce1,mncint2)
#call ACCU2(B mncG mncexp10 mncexp20 mncexp11,integral 2)
Keep Brackets;
#call simplify
#call ACCU(Simplify 2)
id  p2.mncq1?!{p2} = Q.mncq1-p1.mncq1;
id  Q.p1 = Q.Q/2+p1.p1/2-p2.p2/2;
#call ACCU(Momenta 3)
#call one(p1,p2,Q,mnce1,mnce2,mnceq,mncint3)
#call ACCU2(B mncG mncexp10 mncexp20 mncexp11,integral 3)
Keep Brackets;
#call simplify
#call ACCU(Simplify 3)
repeat id acc(mncx1?)*acc(mncx2?) = acc(mncx1*mncx2);
multiply ep^-6;
id      acc(mncx1?) = mncx1;
id      ep = 0;
.sort: Expression G scheme;
*
#call finish(3,`SCHEME')
*
#break
*--#] y2 : 
*--#[ y3 :
#case y3
*
*   File inpy3 does 3-loop diagrams of type Y3.
*   The algorithm here is designed especially for these diagrams
*   so that things may proceed faster.
*
id  p2.mncq1?!{p2} = Q.mncq1-p1.mncq1;
id	p4.mncq1?!{p4} = p1.mncq1-p3.mncq1;
id	p6.mncq1?!{p6} = p3.mncq1-p5.mncq1;
id  p1.p3 = p1.p1/2+p3.p3/2-p4.p4/2;
id  p3.p5 = p3.p3/2+p5.p5/2-p6.p6/2;
if ( ( count(p5.p5,1) >= 0 ) || ( count(p6.p6,1) >= 0 )
  || ( count(p4.p4,1) >= 0 ) ) discard;
#call ACCU(Momenta substitutions)
multiply mncint1*mncint2*mncint3/mnceq^3;
#call one(p5,p6,p3,mnce5,mnce6,mnce3,mncint1)
#call ACCU2(B mncG,Integral 1)
Keep Brackets;
#call simplify
#call ACCU(Simplify 1)
id  p1.p3 = p1.p1/2+p3.p3/2-p4.p4/2;
if ( count(p4.p4,1) >= 0 ) discard;
#call one(p3,p4,p1,mnce3,mnce4,mnce1,mncint2)
#call ACCU2(B mncG mncexp10 mncexp20 mncexp11,Integral 2)
Keep Brackets;
#call simplify
#call ACCU(Simplify 2)
id  Q.p1 = Q.Q/2+p1.p1/2-p2.p2/2;
#call ACCU(Momenta 3)
#call one(p1,p2,Q,mnce1,mnce2,mnceq,mncint3)
#call ACCU2(B mncG mncexp10 mncexp20 mncexp11,integral 3)
Keep Brackets;
#call simplify
#call ACCU(Simplify 3)
repeat id acc(mncx1?)*acc(mncx2?) = acc(mncx1*mncx2);
multiply ep^-6;
id      acc(mncx1?) = mncx1;
id      ep = 0;
.sort: Expression G scheme;
*
#call finish(3,`SCHEME')
*
#break
*--#] y3 : 
*--#[ y4 :
#case y4
*
*   File inpy4 does 3-loop diagrams of type Y4.
*   The algorithm here is designed especially for these diagrams
*   so that things may proceed faster.
*
id  p1.p3 = p1.p1/2+p3.p3/2-p4.p4/2;
id  Q.p5 = Q.Q/2+p5.p5/2-p6.p6/2;
if ( ( count(p3.p3,1) >= 0 ) || ( count(p4.p4,1) >= 0 )
  || ( count(p5.p5,1) >= 0 ) || ( count(p6.p6,1) >= 0 ) ) discard;
#call ACCU(Momenta substitutions)
multiply mncint1*mncint2*mncint3/mnceq^3;
#call one(p5,p6,Q,mnce5,mnce6,mnceq,mncint1)
#call ACCU2(B mncG,integral 1)
Keep Brackets;
#call simplify
#call ACCU(Simplify 1)
#call one(p3,p4,p1,mnce3,mnce4,mnce1,mncint2)
#call ACCU2(B mncG mncexp10 mncexp20 mncexp11,integral 2)
Keep Brackets;
#call simplify
#call ACCU(Simplify 2)
id  p2.mncq1?!{p2} = Q.mncq1-p1.mncq1;
id  Q.p1 = Q.Q/2+p1.p1/2-p2.p2/2;
if ( count(p2.p2,1) >= 0 ) discard;
#call ACCU(Momenta 3)
#call one(p1,p2,Q,mnce1,mnce2,mnceq,mncint3)
#call ACCU2(B mncG mncexp10 mncexp20 mncexp11,integral3)
Keep Brackets;
#call simplify
#call ACCU(Simplify 3)
repeat id acc(mncx1?)*acc(mncx2?) = acc(mncx1*mncx2);
multiply ep^-6;
id      acc(mncx1?) = mncx1;
id      ep = 0;
.sort: Expression G scheme;
*
#call finish(3,`SCHEME')
*
#break
*--#] y4 : 
*--#[ y5 :
#case y5
*
*   File inpy5 does 3-loop diagrams of type Y5.
*   The algorithm here is designed especially for these diagrams
*   so that things may proceed faster.
*
id	p2.mncq1?!{p2} = Q.mncq1-p1.mncq1;
id	p4.mncq1?!{p4} = Q.mncq1-p3.mncq1;
id	p6.mncq1?!{p6} = Q.mncq1-p5.mncq1;
id  Q.p1 = Q.Q/2+p1.p1/2-p2.p2/2;
id  Q.p3 = Q.Q/2+p3.p3/2-p4.p4/2;
id  Q.p5 = Q.Q/2+p5.p5/2-p6.p6/2;
if ( ( count(p1.p1,1) >= 0 ) || ( count(p2.p2,1) >= 0 )
  || ( count(p3.p3,1) >= 0 ) || ( count(p4.p4,1) >= 0 )
  || ( count(p5.p5,1) >= 0 ) || ( count(p6.p6,1) >= 0 ) ) discard;
#call ACCU(Momenta substitutions)
multiply mncint1*mncint2*mncint3/mnceq^3;
#call one(p3,p4,Q,mnce3,mnce4,mnceq,mncint1)
id  Q.p1 = Q.Q/2+p1.p1/2-p2.p2/2;
id  Q.p5 = Q.Q/2+p5.p5/2-p6.p6/2;
if ( ( count(p1.p1,1) >= 0 ) || ( count(p2.p2,1) >= 0 )
  || ( count(p5.p5,1) >= 0 ) || ( count(p6.p6,1) >= 0 ) ) discard;
#call ACCU2(B mncG,integral 1)
Keep Brackets;
#call simplify
#call ACCU(Simplify 1)
#call one(p5,p6,Q,mnce5,mnce6,mnceq,mncint2)
#call ACCU2(B mncG mncexp10 mncexp20 mncexp11,integral 2)
Keep Brackets;
#call simplify
#call ACCU(Simplify 2)
*id  p2.mncq1?!{p2} = Q.mncq1-p1.mncq1;
id  Q.p1 = Q.Q/2+p1.p1/2-p2.p2/2;
if ( ( count(p1.p1,1) >= 0 ) || ( count(p2.p2,1) >= 0 ) ) discard;
#call ACCU(Momenta 3)
#call one(p1,p2,Q,mnce1,mnce2,mnceq,mncint3)
#call ACCU2(B mncG mncexp10 mncexp20 mncexp11,integral3)
Keep Brackets;
#call simplify
#call ACCU(Simplify 3)
repeat id acc(mncx1?)*acc(mncx2?) = acc(mncx1*mncx2);
multiply ep^-6;
id      acc(mncx1?) = mncx1;
id      ep = 0;
.sort: Expression G scheme;
*
#call finish(3,`SCHEME')
*
#break
*--#] y5 : 
*--#[ t1 :
#case t1
*
*   This is inpt1. It does two loop topologies of type T1.
*
multiply replace_(p2,p3,p3,p4,p4,p6,p5,p7,mnce2,mnce3,mnce3,mnce4,mnce4,mnce6,mnce5,mnce7)
     *mncint1*mncint3*Q.Q*mnceq;
*Print +f ">%t";
#call dotwo{}
;
*#message We are at the print statement
#call ACCU(Simplify mncG\(3\))
repeat id acc(mncx1?)*acc(mncx2?) = acc(mncx1*mncx2);
multiply ep^-6;
id      acc(mncx1?) = mncx1;
id      ep = 0;
.sort: Expression G scheme;
*
*   Now approximate and convert to MSbar.
*
#call finish(2,`SCHEME')
multiply ep;
*
#break
*--#] t1 : 
*--#[ t2 :
#case t2
*
*   This is inpt2. It does two loop topologies of type T2.
*
multiply mncint1*mncint2/mnceq^2;
if ( count(mnce3,1) < count(mnce4,1) ) multiply replace_(p3,p4,p4,p3,mnce3,mnce4,mnce4,mnce3);
id  p4.mncq1?!{p4} = p1.mncq1-p3.mncq1;
id  p1.p3 = p1.p1/2+p3.p3/2-p4.p4/2;
if ( ( count(p3.p3,1) >= 0 ) && ( count(mnce3,1) == 0 ) ) discard;
if ( ( count(p4.p4,1) >= 0 ) && ( count(mnce4,1) == 0 ) ) discard;
#call ACCU(momenta)
#call one(p3,p4,p1,mnce3,mnce4,mnce1,mncint1)
#call ACCU2(B mncG mncexp10 mncexp20 mncexp11,integral 1)
Keep Brackets;
#call simplify
#call ACCU(simplify 1)
id  p2.mncq1?!{p2} = Q.mncq1-p1.mncq1;
id  Q.p1 = Q.Q/2+p1.p1/2-p2.p2/2;
if ( ( count(p2.p2,1) >= 0 ) && ( count(mnce2,1) == 0 ) ) discard;
#call ACCU(momenta 2)
#call one(p1,p2,Q,mnce1,mnce2,mnceq,mncint2)
#call ACCU2(B mncG mncexp10 mncexp20 mncexp11,integral 2)
Keep Brackets;
#call simplify
#call ACCU(Simplify 2)
repeat id acc(mncx1?)*acc(mncx2?) = acc(mncx1*mncx2);
multiply ep^-6;
id      acc(mncx1?) = mncx1;
id      ep = 0;
.sort: Expression G scheme;
*
*   Now approximate and convert to MSbar.
*
#call finish(2,`SCHEME')
multiply ep;
*
#break
*--#] t2 : 
*--#[ t3 :
#case t3
*
*   This is inpt3. It does two loop topologies of type T3.
*
multiply mncint1*mncint2/mnceq^2;
id  p2.mncq1?!{p2} = Q.mncq1-p1.mncq1;
id  p4.mncq1?!{p4} = Q.mncq1-p3.mncq1;
id  Q.p1 = p1.p1/2+Q.Q/2-p2.p2/2;
id  Q.p3 = p3.p3/2+Q.Q/2-p4.p4/2;
if ( ( count(p1.p1,1) >= 0 ) && ( count(mnce1,1) == 0 ) ) discard;
if ( ( count(p2.p2,1) >= 0 ) && ( count(mnce2,1) == 0 ) ) discard;
if ( ( count(p3.p3,1) >= 0 ) && ( count(mnce3,1) == 0 ) ) discard;
if ( ( count(p4.p4,1) >= 0 ) && ( count(mnce4,1) == 0 ) ) discard;
#call ACCU(momenta 1)
#call one(p3,p4,Q,mnce3,mnce4,mnceq,mncint2)
#call ACCU2(B mncG mncexp10 mncexp20 mncexp11,integral 1)
Keep Brackets;
#call simplify
#call ACCU(Simplify 1)
id  Q.p1 = p1.p1/2+Q.Q/2-p2.p2/2;
if ( ( count(p1.p1,1) >= 0 ) && ( count(mnce1,1) == 0 ) ) discard;
if ( ( count(p2.p2,1) >= 0 ) && ( count(mnce2,1) == 0 ) ) discard;
#call ACCU(momenta 2)
#call one(p1,p2,Q,mnce1,mnce2,mnceq,mncint1)
#call ACCU2(B mncG mncexp10 mncexp20 mncexp11,integral 2)
Keep Brackets;
#call simplify
#call ACCU(Simplify 2)
repeat id acc(mncx1?)*acc(mncx2?) = acc(mncx1*mncx2);
multiply ep^-6;
id      acc(mncx1?) = mncx1;
id      ep = 0;
.sort: Expression G scheme;
*
#call finish(2,`SCHEME')
multiply ep;
*
#break
*--#] t3 : 
*--#[ l1 :
#case l1
*
*   This is inpl1. It does the one loop topology of type L1.
*
multiply mncint1/mnceq;
id  Q.p1 = Q.Q/2+p1.p1/2-p2.p2/2;
.sort:prepare 1;
id  Q.p2 = Q.Q/2-p1.p1/2+p2.p2/2;
.sort:prepare 2;
id	p1.p2 = Q.Q/2-p1.p1/2-p2.p2/2;
.sort:prepare 3;
id	P.p2 = Q.P-P.p1;
.sort:prepare 4;
#call one(p1,p2,Q,mnce1,mnce2,mnceq,mncint1)
#call ACCU(integral 1)
#call simplify
repeat id acc(mncx1?)*acc(mncx2?) = acc(mncx1*mncx2);
multiply ep^-6;
id  acc(mncx1?) = mncx1;
id      ep = 0;
.sort: Expression G scheme;
*
*   Now approximate and convert to MSbar.
*
#call finish(1,`SCHEME')
multiply ep^2;
*
#break
*--#] l1 : 
*--#[ l2 :
#case l2
*
*   This is file inpl2. It does topologies of type L2 which are
*   meant to have an entire expanded gluon propagator in two loops.
*   It is done to avoid enormous problems with the gluon insertion
*   inside the three loop graph.
*
multiply mnce2^2*mncint1/ep^5/mnceq^3;
id  p2 = Q-p1;
id  Q.p1 = Q.Q/2+p1.p1/2-p2.p2/2;
if ( count(p1.p1,1) >= 0 ) discard;
#call one(p1,p2,Q,mnce1,mnce2,mnceq,mncint1)
#call ACCU(integral 1)
#call simplify
repeat id acc(mncx1?)*acc(mncx2?) = acc(mncx1*mncx2);
multiply ep^-1;
id  acc(mncx1?) = mncx1;
.sort
#call finish(1,`SCHEME')
multiply,ep^2;
print +f +s;
B   ep;
.sort
multiply,
       + ep^-2*ca*nf * (  - 55/18 - 1/3*mncxi )
       + ep^-2*ca^2 * ( 175/36 + 35/24*mncxi )
       + ep^-2*nf^2 * ( 4/9 )
       + ep^-1*cf*nf * (  - 1 )
       + ep^-1*ca*nf * (  - 1199/108 - 2/9*mncxi )
       + ep^-1*ca^2 * ( 4229/216 - 97/144*mncxi + 5/8*mncxi^2 - 1/8*mncxi^3 )
       + ep^-1*nf^2 * ( 40/27 )
       + ep*cf*nf * (  - 1711/36 + 76/3*z3 + 12*z4 )
       + ep*ca*nf * (  - 337315/3888 + 50/9*z3*mncxi + 286/27*z3 - 6*z4 + 37/81*
         mncxi )
       + ep*ca^2 * ( 1659373/7776 - 134/9*z3*mncxi - 3/2*z3*mncxi^2 - 1184/27*z3 - 3
         *z4*mncxi - 3/2*z4 - 165073/5184*mncxi + 113/8*mncxi^2 - 33/16*mncxi^3 )
       + ep*nf^2 * ( 2432/243 - 56/27*z3 )
       + cf*nf * (  - 55/6 + 8*z3 )
       + ca*nf * (  - 2371/72 - 4*z3 + 5/27*mncxi )
       + ca^2 * ( 9821/144 - 2*z3*mncxi - z3 - 6121/864*mncxi + 27/8*mncxi^2 - 9/16*
         mncxi^3 )
       + nf^2 * ( 4 );
id  ep = 0;
*
#break
*--#] l2 : 
*--#[ l3 :
#case l3
*
*   This is file inpl3. It does topologies of type L3 which are
*   meant to have an entire expanded gluon propagator in one loop.
*   It is done to avoid enormous problems with the gluon insertion
*   inside the two loop graph.
*
multiply mnce1*mncint1/ep^5/mnceq^2;
id  p2 = Q-p1;
id  Q.p1 = Q.Q/2+p1.p1/2-p2.p2/2;
if ( count(p2.p2,1) >= 0 ) discard;
#call one(p1,p2,Q,mnce1,mnce2,mnceq,mncint1)

#call ACCU(integral 1)
#call simplify
repeat id acc(mncx1?)*acc(mncx2?) = acc(mncx1*mncx2);
multiply ep^-1;
id  acc(mncx1?) = mncx1;

.sort
#call finish(1,`SCHEME')
multiply,ep;

*B  ep;
.sort
multiply,ep^-1*(
    +ca*(5/3+mncxi/2-ep*mncxi+ep*mncxi^2/4+31/9*ep-2*ep^2*mncxi+ep^2*mncxi^2/2+188/27*ep^2
        -7/6*ep^3*z3*mncxi-35/9*ep^3*z3-4*ep^3*mncxi+ep^3*mncxi^2+1132/81*ep^3)
    +nf*(-2/3-10/9*ep-56/27*ep^2+14/9*ep^3*z3-328/81*ep^3));
id  ep = 0;
multiply ep;
*
#break
*--#] l3 : 
*--#[ tr :
#case tr
*
*   This is inptr. It does the tree level topology tr.
*
multiply 1/ep^6;
id      acc(mncx1?) = mncx1;
id      ep = 0;
.sort: Expression G scheme;
*
*   Now approximate and convert to MSbar.
*
#call finish(0,`SCHEME')
multiply ep^3;
*
#break
*--#] tr : 
#endswitch
*
#endprocedure
*--#] integral : 
*--#[ intpow :
#procedure intpow(TOPO)
#switch `TOPO'
#case la
#case be
#case no
#case fa
#case bu
#case o1
#case o2
#case o3
#case o4
#case y1
#case y2
#case y3
#case y4
#case y5
Multiply,i_^3;
#break
#case t1
#case t2
#case t3
Multiply,i_^2;
#break
#case l1
#case l2
#case l3
Multiply,i_;
#break
#endswitch
#endprocedure

*--#] intpow : 
*--#[ ladder :
#procedure ladder(P1,P2,P3,P4,P5,P6,P7,P8,Q)
*
*   Reduction procedure for three loop graphs of the LA or ladder type.
*   Notation is from S.G.Gorishny et.al. Comp.Phys.Comm 55(1989)381
*
*                     /-<------<-----<-\
*                 P1 /    |   P2   |    \ P3
*                   /     |        |     \
*                  /      |        |      \
*                 /       |        |       \
*          Q --<--     P7 ^        v P8     --<-- Q
*                 \       |        |       /
*                  \      |        |      / 
*                   \     |        |     /
*                 P6 \    |   P5   |    / P4
*                     \->------>----->-/
*
*   We start with reducing the dotproducts in the numerator to sums
*   of denominators. Only one dotproduct is irreducible: P7.P8
*   The easiest reduction (and quite fast) is by writing everything
*   in terms of Q,P1,P2,P3 and then rewriting
*   the few remaining dotproducts in terms of denominators.
*   There are variations to this principle.
*
*   Routine coded and tested by J.A.M.Vermaseren 8-jul-1990.
*   modified 13-nov-1990. Variations added april 1993.
*   Backward reduction added 15-may-1993
*
#ifdef `LATRANS'
#if ( `LATRANS' == 1 )
  #call ACCU2(AB `P3'.`P7' `P2'.`P7' `P7'.`P8',Ladder scalar 0)
    id  `P3'.`P7' = `P2'.`P7'+`P7'.`P8';
  #call ACCU2(AB `Q'.`P3' `P3'.`P3' `Q'.`Q' `P4'.`P4',Ladder scalar 1)
    id  `Q'.`P3' = `P3'.`P3'/2-`P4'.`P4'/2+`Q'.`Q'/2;
  #call ACCU2(AB `Q'.`P2' `P2'.`P2' `Q'.`Q' `P5'.`P5',Ladder scalar 2)
    id  `Q'.`P2' = `P2'.`P2'/2+`Q'.`Q'/2-`P5'.`P5'/2;
  #call ACCU2(AB `P2'.`P7' `P1'.`P1' `P2'.`P2' `P7'.`P7',Ladder scalar 3)
    id  `P2'.`P7' = `P1'.`P1'/2-`P2'.`P2'/2-`P7'.`P7'/2;
  #call ACCU2(AB `P2'.`P3' `P3'.`P3' `P2'.`P2' `P8'.`P8',Ladder scalar 4)
    id  `P2'.`P3' = `P3'.`P3'/2+`P2'.`P2'/2-`P8'.`P8'/2;
  #call ACCU2(AB `Q'.`P7' `P1'.`P1' `P2'.`P2' `P5'.`P5' `P6'.`P6',Ladder scalar 5)
    id  `Q'.`P7' = `P1'.`P1'/2-`P2'.`P2'/2+`P5'.`P5'/2-`P6'.`P6'/2;
  #call ACCU(Ladder scalar 6)
#else
#if ( `LATRANS' == 2 )
  #call ACCU2(AB `P3'.`P7' `P1'.`P7' `P7'.`P8' `P7'.`P7',Ladder scalar 0)
    id  `P3'.`P7' = `P1'.`P7'-`P7'.`P7'+`P7'.`P8';
  #call ACCU2(AB `Q'.`P3' `P3'.`P3' `Q'.`Q' `P4'.`P4',Ladder scalar 1)
    id  `Q'.`P3' = `P3'.`P3'/2-`P4'.`P4'/2+`Q'.`Q'/2;
  #call ACCU2(AB `Q'.`P1' `P1'.`P1' `Q'.`Q' `P6'.`P6',Ladder scalar 2)
    id  `Q'.`P1' = `P1'.`P1'/2+`Q'.`Q'/2-`P6'.`P6'/2;
  #call ACCU2(AB `P1'.`P7' `P1'.`P1' `P2'.`P2' `P7'.`P7',Ladder scalar 3)
    id  `P1'.`P7' = `P1'.`P1'/2-`P2'.`P2'/2+`P7'.`P7'/2;
  #call ACCU2(AB `Q'.`P7' `P1'.`P1' `P2'.`P2' `P5'.`P5' `P6'.`P6',Ladder scalar 4)
    id  `Q'.`P7' = `P1'.`P1'/2-`P2'.`P2'/2+`P5'.`P5'/2-`P6'.`P6'/2;
  #call ACCU2(AB `P1'.`P3' `P1'.`P1' `P3'.`P3' `P7'.`P7' `P8'.`P8' `P7'.`P8',Ladder scalar 5)
    id  `P1'.`P3' = `P1'.`P1'/2+`P3'.`P3'/2-`P7'.`P7'/2-`P8'.`P8'/2+`P7'.`P8';
  #call ACCU(Ladder scalar 6)
#else
#if ( `LATRANS' == 3 )
if ( count(`P7'.`P7',1) > count(`P8'.`P8',1) );
    multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4'
       ,`P7',`P8',`P8',`P7');
elseif ( count(`P7'.`P7',1) == count(`P8'.`P8',1) );
    if ( count(`P1'.`P1',1) > count(`P3'.`P3',1) );
        multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4'
           ,`P7',`P8',`P8',`P7');
    elseif ( count(`P1'.`P1',1) == count(`P3'.`P3',1) );
        if ( count(`P6'.`P6',1) > count(`P4'.`P4',1) )
            multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4'
               ,`P7',`P8',`P8',`P7');
    endif;
endif;
  #call ACCU2(AB `Q'.`P2' `P2'.`P2' `Q'.`Q' `P5'.`P5',Ladder scalar 0)
    id  `Q'.`P2' = `P2'.`P2'/2+`Q'.`Q'/2-`P5'.`P5'/2;
  #call ACCU2(AB `P2'.`P7' `P1'.`P1' `P2'.`P2' `P7'.`P7',Ladder scalar 1)
    id  `P2'.`P7' = `P1'.`P1'/2-`P2'.`P2'/2-`P7'.`P7'/2;
  #call ACCU2(AB `P2'.`P8' `P3'.`P3' `P2'.`P2' `P8'.`P8',Ladder scalar 2)
    id  `P2'.`P8' = `P3'.`P3'/2-`P2'.`P2'/2-`P8'.`P8'/2;
  #call ACCU2(AB `Q'.`P7' `P1'.`P1' `P2'.`P2' `P5'.`P5' `P6'.`P6',Ladder scalar 3)
    id  `Q'.`P7' = `P1'.`P1'/2-`P2'.`P2'/2+`P5'.`P5'/2-`P6'.`P6'/2;
  #call ACCU2(AB `Q'.`P8' `P3'.`P3' `P2'.`P2' `P5'.`P5' `P4'.`P4',Ladder scalar 4)
    id  `Q'.`P8' = `P3'.`P3'/2-`P2'.`P2'/2+`P5'.`P5'/2-`P4'.`P4'/2;
  #call ACCU(Ladder scalar 5)
#else
if ( count(`P7'.`P7',1) > count(`P8'.`P8',1) );
    multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4'
       ,`P7',`P8',`P8',`P7');
elseif ( count(`P7'.`P7',1) == count(`P8'.`P8',1) );
    if ( count(`P1'.`P1',1) > count(`P3'.`P3',1) );
        multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4'
           ,`P7',`P8',`P8',`P7');
    elseif ( count(`P1'.`P1',1) == count(`P3'.`P3',1) );
        if ( count(`P6'.`P6',1) > count(`P4'.`P4',1) )
            multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4'
               ,`P7',`P8',`P8',`P7');
    endif;
endif;
  #call ACCU2(AB `Q'.`P1' `P1'.`P1' `P6'.`P6' `Q'.`Q',Ladder scalar 0)
    id  `Q'.`P1' = `P1'.`P1'/2-`P6'.`P6'/2+`Q'.`Q'/2;
  #call ACCU2(AB `Q'.`P3' `P3'.`P3' `P4'.`P4' `Q'.`Q',Ladder scalar 1)
    id  `Q'.`P3' = `P3'.`P3'/2-`P4'.`P4'/2+`Q'.`Q'/2;
if ( count(`P7'.`P7',1) > count(`P8'.`P8',1) );
    multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4'
       ,`P7',`P8',`P8',`P7');
elseif ( count(`P7'.`P7',1) == count(`P8'.`P8',1) );
    if ( count(`P1'.`P1',1) > count(`P3'.`P3',1) );
        multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4'
           ,`P7',`P8',`P8',`P7');
    elseif ( count(`P1'.`P1',1) == count(`P3'.`P3',1) );
        if ( count(`P6'.`P6',1) > count(`P4'.`P4',1) )
            multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4'
               ,`P7',`P8',`P8',`P7');
    endif;
endif;
  #call ACCU2(AB `Q'.`P2' `P2'.`P2' `Q'.`Q' `P5'.`P5',Ladder scalar 2)
    id  `Q'.`P2' = `P2'.`P2'/2+`Q'.`Q'/2-`P5'.`P5'/2;
if ( count(`P7'.`P7',1) > count(`P8'.`P8',1) );
    multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4'
       ,`P7',`P8',`P8',`P7');
elseif ( count(`P7'.`P7',1) == count(`P8'.`P8',1) );
    if ( count(`P1'.`P1',1) > count(`P3'.`P3',1) );
        multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4'
           ,`P7',`P8',`P8',`P7');
    elseif ( count(`P1'.`P1',1) == count(`P3'.`P3',1) );
        if ( count(`P6'.`P6',1) > count(`P4'.`P4',1) )
            multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4'
               ,`P7',`P8',`P8',`P7');
    endif;
endif;
  #call ACCU2(AB `P1'.`P2' `P1'.`P1' `P2'.`P2' `P7'.`P7',Ladder scalar 3)
    id  `P1'.`P2' = `P1'.`P1'/2+`P2'.`P2'/2-`P7'.`P7'/2;
  #call ACCU2(AB `P2'.`P3' `P3'.`P3' `P2'.`P2' `P8'.`P8',Ladder scalar 4)
    id  `P2'.`P3' = `P3'.`P3'/2+`P2'.`P2'/2-`P8'.`P8'/2;
  #call ACCU2(AB `P1'.`P3' `P1'.`P1' `P3'.`P3' `P7'.`P7' `P8'.`P8' `P7'.`P8',Ladder scalar 5)
    id  `P1'.`P3' = `P1'.`P1'/2+`P3'.`P3'/2-`P7'.`P7'/2-`P8'.`P8'/2+`P7'.`P8';
  #call ACCU(Ladder scalar 6)
#endif
#endif
#endif
#else
if ( count(`P7'.`P7',1) > count(`P8'.`P8',1) );
    multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4'
       ,`P7',`P8',`P8',`P7');
elseif ( count(`P7'.`P7',1) == count(`P8'.`P8',1) );
    if ( count(`P1'.`P1',1) > count(`P3'.`P3',1) );
        multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4'
           ,`P7',`P8',`P8',`P7');
    elseif ( count(`P1'.`P1',1) == count(`P3'.`P3',1) );
        if ( count(`P6'.`P6',1) > count(`P4'.`P4',1) )
            multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4'
               ,`P7',`P8',`P8',`P7');
    endif;
endif;
  #call ACCU2(AB `Q'.`P1' `P1'.`P1' `P6'.`P6' `Q'.`Q',Ladder scalar 0)
    id  `Q'.`P1' = `P1'.`P1'/2-`P6'.`P6'/2+`Q'.`Q'/2;
  #call ACCU2(AB `Q'.`P3' `P3'.`P3' `P4'.`P4' `Q'.`Q',Ladder scalar 1)
    id  `Q'.`P3' = `P3'.`P3'/2-`P4'.`P4'/2+`Q'.`Q'/2;
  #call ACCU2(AB `Q'.`P2' `P2'.`P2' `Q'.`Q' `P5'.`P5',Ladder scalar 2)
    id  `Q'.`P2' = `P2'.`P2'/2+`Q'.`Q'/2-`P5'.`P5'/2;
  #call ACCU2(AB `P1'.`P2' `P1'.`P1' `P2'.`P2' `P7'.`P7',Ladder scalar 3)
    id  `P1'.`P2' = `P1'.`P1'/2+`P2'.`P2'/2-`P7'.`P7'/2;
  #call ACCU2(AB `P2'.`P3' `P3'.`P3' `P2'.`P2' `P8'.`P8',Ladder scalar 4)
    id  `P2'.`P3' = `P3'.`P3'/2+`P2'.`P2'/2-`P8'.`P8'/2;
  #call ACCU2(AB `P1'.`P3' `P1'.`P1' `P3'.`P3' `P7'.`P7' `P8'.`P8' `P7'.`P8',Ladder scalar 5)
    id  `P1'.`P3' = `P1'.`P1'/2+`P3'.`P3'/2-`P7'.`P7'/2-`P8'.`P8'/2+`P7'.`P8';
  #call ACCU(Ladder scalar 6)
#endif
  if ( count(`P7'.`P7',1) > count(`P8'.`P8',1) );
    multiply replace_(`P1',`P3',`P3',`P1',`P7',`P8',`P8',`P7',`P6',`P4',`P4',`P6');
  endif;
*
*   The rule of the triangle is applied in the procedure `triangle'
*   We apply it in the triangle at the right side. The above reordering
*   makes it the simplest triangle.
*
  if ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
            /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8') > 0 );
    multiply acc(1/ep);
    #call triangle(`P8',`P4',`P3',`P5',`P2')
    multiply ep;
  else;
    repeat;
        if ( match(`P2'.`P2'/`P7'.`P7'/`P1'.`P1'^2) );
            id `P7'.`P8'^mncx9?*`P2'.`P2'/`P1'.`P1'^mncx1?/`P7'.`P7'^mncx7?/`P6'.`P6'^mncx6? =
                `P1'.`P1'*`P7'.`P8'^mncx9/`P1'.`P1'^mncx1/`P7'.`P7'^mncx7/`P6'.`P6'^mncx6 *(
                    +`P7'.`P7'/`P1'.`P1'
                    +mncx6/(mncx1-1)*(`P7'.`P7'-`P5'.`P5')/`P6'.`P6'
                    -acc(5-2*mncx7+mncx9-mncx1-mncx6-2*ep)/(mncx1-1)
                );
        endif;
        if ( match(`P2'.`P2'/`P8'.`P8'/`P3'.`P3'^2) );
            id `P7'.`P8'^mncx9?*`P2'.`P2'/`P3'.`P3'^mncx3?/`P8'.`P8'^mncx8?/`P4'.`P4'^mncx4? =
                `P3'.`P3'*`P7'.`P8'^mncx9/`P3'.`P3'^mncx3/`P8'.`P8'^mncx8/`P4'.`P4'^mncx4 *(
                    +`P8'.`P8'/`P3'.`P3'
                    +mncx4/(mncx3-1)*(`P8'.`P8'-`P5'.`P5')/`P4'.`P4'
                    -acc(5-2*mncx8+mncx9-mncx3-mncx4-2*ep)/(mncx3-1)
                );
        endif;
        if ( match(`P5'.`P5'/`P7'.`P7'/`P6'.`P6'^2/`P2'.`P2') );
            id `P7'.`P8'^mncx9?*`P5'.`P5'/`P1'.`P1'^mncx1?/`P7'.`P7'^mncx7?/`P6'.`P6'^mncx6? =
                `P6'.`P6'*`P7'.`P8'^mncx9/`P1'.`P1'^mncx1/`P7'.`P7'^mncx7/`P6'.`P6'^mncx6 *(
                    +`P7'.`P7'/`P6'.`P6'
                    +mncx1/(mncx6-1)*(`P7'.`P7'-`P2'.`P2')/`P1'.`P1'
                    -acc(5-2*mncx7+mncx9-mncx1-mncx6-2*ep)/(mncx6-1)
                );
        endif;
        if ( match(`P5'.`P5'/`P8'.`P8'/`P4'.`P4'^2/`P2'.`P2') );
            id `P7'.`P8'^mncx9?*`P5'.`P5'/`P3'.`P3'^mncx3?/`P8'.`P8'^mncx8?/`P4'.`P4'^mncx4? =
                `P4'.`P4'*`P7'.`P8'^mncx9/`P3'.`P3'^mncx3/`P8'.`P8'^mncx8/`P4'.`P4'^mncx4 *(
                    +`P8'.`P8'/`P4'.`P4'
                    +mncx3/(mncx4-1)*(`P8'.`P8'-`P2'.`P2')/`P3'.`P3'
                    -acc(5-2*mncx8+mncx9-mncx3-mncx4-2*ep)/(mncx4-1)
                );
        endif;
    endrepeat;
  endif;
*
#endprocedure
*--#] ladder : 
*--#[ makepochs :
*
#procedure makepochs(nval)
#do mncj = 0,`nval'-2
L	mncFp`mncj' = mncpoc(`nval',`mncj');
#enddo
repeat;
	id	mncpoc(mncn?,mncj?pos_) =
			mncpoc(mncn,mncj-1)/mncj*mncden(mncn-mncj,-ep);
	id	mncpoc(mncn?,0) = 1;
endrepeat;
#do jj = 1,1
id,once,mncden(mncx?,-ep) = mncden1(mncx,-ep);
repeat id mncden1(mncx?,-ep) = 1/mncx+ep/mncx*mncden1(mncx,-ep);
if ( count(mncden,1) ) redefine jj "0";
.sort
#enddo
Format nospaces;
Format 80;
.sort
#do mncj = 0,`nval'-2
#write <> "Fill mncpoch(`nval',`mncj') = %e",mncFp`mncj';
Drop mncFp`mncj';
#enddo
#endprocedure
*
*--#] makepochs : 
*--#[ momsubs :
#procedure momsubs(TOPO)
#switch `TOPO'
*--#[ la :
#case la
*
#ifdef `LATRANS'
#if ( `LATRANS' == 1 )
id	p5.mncq1?!{p5} = p2.mncq1-Q.mncq1;
id	p4.mncq1?!{p4} = p3.mncq1-Q.mncq1;
#call ACCU(moms1\(1\))
id	p6.mncq1?!{p6} = p1.mncq1-Q.mncq1;
id	p8.mncq1?!{p8} = p3.mncq1-p2.mncq1;
#call ACCU(moms2\(1\))
id	p1.mncq1?!{p1} = p2.mncq1+p7.mncq1;
#call ACCU2(AB P Q p7 p2 p3,moms3\(1\))
#else
#if ( `LATRANS' == 2 )
id	p5.mncq1?!{p5} = p6.mncq1-p7.mncq1;
id	p4.mncq1?!{p4} = p3.mncq1-Q.mncq1;
#call ACCU(moms1\(2\))
id	p6.mncq1?!{p6} = p1.mncq1-Q.mncq1;
id	p8.mncq1?!{p8} = p3.mncq1-p2.mncq1;
#call ACCU(moms2\(2\))
id	p2.mncq1?!{p2} = p1.mncq1-p7.mncq1;
#call ACCU2(AB P Q p1 p7 p3,moms3\(2\))
#else
#if ( `LATRANS' == 3 )
id	p5.mncq1?!{p5} = p2.mncq1-Q.mncq1;
id	p4.mncq1?!{p4} = p3.mncq1-Q.mncq1;
#call ACCU(moms1\(3\))
id	p6.mncq1?!{p6} = p1.mncq1-Q.mncq1;
id	p3.mncq1?!{p3} = p2.mncq1+p8.mncq1;
#call ACCU(moms2\(3\))
id	p1.mncq1?!{p1} = p2.mncq1+p7.mncq1;
#call ACCU2(AB P Q p7 p2 p8,moms3\(3\))
#else
id	p5.mncq1?!{p5} = p2.mncq1-Q.mncq1;
id	p4.mncq1?!{p4} = p3.mncq1-Q.mncq1;
#call ACCU(moms1\(0\))
id	p6.mncq1?!{p6} = p1.mncq1-Q.mncq1;
id	p8.mncq1?!{p8} = p3.mncq1-p2.mncq1;
#call ACCU(moms2\(0\))
id	p7.mncq1?!{p7} = p1.mncq1-p2.mncq1;
#call ACCU2(AB P Q p1 p2 p3,moms3\(0\))
#endif
#endif
#endif
#else
id	p5.mncq1?!{p5} = p2.mncq1-Q.mncq1;
id	p4.mncq1?!{p4} = p3.mncq1-Q.mncq1;
#call ACCU(moms1)
id	p6.mncq1?!{p6} = p1.mncq1-Q.mncq1;
id	p8.mncq1?!{p8} = p3.mncq1-p2.mncq1;
#call ACCU(moms2)
id	p7.mncq1?!{p7} = p1.mncq1-p2.mncq1;
#call ACCU2(AB P Q p1 p2 p3,moms3)
#endif
*
#break
*--#] la : 
*--#[ be :
#case be
*
#ifndef `BEPATH'
id	p6.p7 = p6.p6/2+p7.p7/2-p8.p8/2;
id	p6.p8 = p6.p6/2+p8.p8/2-p7.p7/2;
id	p7.p8 = p6.p6/2-p7.p7/2-p8.p8/2;
*
id	p4.p5 = p4.p4/2+p5.p5/2-p8.p8/2;
id	p4.p8 = p4.p4/2+p8.p8/2-p5.p5/2;
id	p5.p8 = p4.p4/2-p5.p5/2-p8.p8/2;

id	p6.mncq1?!{p6} = p2.mncq1-p1.mncq1;
id	p7.mncq1?!{p7} = p2.mncq1-p3.mncq1;
id	p8.mncq1?!{p8} = p3.mncq1-p1.mncq1;
#call ACCU(moms1)
id	p4.mncq1?!{p4} = p3.mncq1-Q.mncq1;
id	p5.mncq1?!{p5} = p1.mncq1-Q.mncq1;
#call ACCU2(AB P Q p1 p2 p3,moms2)
#else
#if ( `BEPATH' == 0 )
id	p6.p7 = p6.p6/2+p7.p7/2-p8.p8/2;
id	p6.p8 = p6.p6/2+p8.p8/2-p7.p7/2;
id	p7.p8 = p6.p6/2-p7.p7/2-p8.p8/2;
*
id	p4.p5 = p4.p4/2+p5.p5/2-p8.p8/2;
id	p4.p8 = p4.p4/2+p8.p8/2-p5.p5/2;
id	p5.p8 = p4.p4/2-p5.p5/2-p8.p8/2;

id	p6.mncq1?!{p6} = p2.mncq1-p1.mncq1;
id	p7.mncq1?!{p7} = p2.mncq1-p3.mncq1;
id	p8.mncq1?!{p8} = p3.mncq1-p1.mncq1;
#call ACCU(moms1 \(0\))
id	p4.mncq1?!{p4} = p3.mncq1-Q.mncq1;
id	p5.mncq1?!{p5} = p1.mncq1-Q.mncq1;
#call ACCU2(AB P Q p1 p2 p3,moms2)
#endif
#if ( `BEPATH' == 1 )
id	p4.p5 = p4.p4/2+p5.p5/2-p8.p8/2;
id	p3.p4 = p3.p3/2+p4.p4/2-Q.Q/2;
id	p2.p3 = p2.p2/2+p3.p3/2-p7.p7/2;
id	p2.p7 = p2.p2/2+p7.p7/2-p3.p3/2;
id	p3.p7 = p2.p2/2-p3.p3/2-p7.p7/2;
id	p4.mncq1?!{p4} = p5.mncq1+p8.mncq1;
id	p3.mncq1?!{p3} = p1.mncq1+p8.mncq1;
id	p2.mncq1?!{p2} = p1.mncq1+p6.mncq1;
#call ACCU(moms1 \(1\))
id	p5.mncq1?!{p5} = p1.mncq1-Q.mncq1;
id	p7.mncq1?!{p7} = p6.mncq1-p8.mncq1;
#call ACCU2(AB P Q p1 p6 p8,moms2)
#endif
#if ( `BEPATH' == 2 )
id	p6.p8 = p6.p6/2+p8.p8/2-p7.p7/2;
id	p3.p4 = p3.p3/2+p4.p4/2-Q.Q/2;
id	p4.p5 = p4.p4/2+p5.p5/2-p8.p8/2;
id	p4.p8 = p4.p4/2+p8.p8/2-p5.p5/2;
id	p5.p8 = p4.p4/2-p5.p5/2-p8.p8/2;
id	p4.mncq1?!{p4} = p3.mncq1-Q.mncq1;
id	p8.mncq1?!{p8} = p6.mncq1-p7.mncq1;
id	p5.mncq1?!{p5} = p1.mncq1-Q.mncq1;
#call ACCU(moms1 \(2\))
id	p6.mncq1?!{p6} = p2.mncq1-p1.mncq1;
id	p3.mncq1?!{p3} = p2.mncq1-p7.mncq1;
#call ACCU2(AB P Q p1 p2 p7,moms2)
#endif
#if ( `BEPATH' == 3 )
id	p1.p5 = p1.p1/2+p5.p5/2-Q.Q/2;
id	p3.p7 = p2.p2/2-p3.p3/2-p7.p7/2;
id	p3.p4 = p3.p3/2+p4.p4/2-Q.Q/2;
id	p3.mncq1?!{p3} = p2.mncq1-p7.mncq1;
id	p4.mncq1?!{p4} = p8.mncq1+p5.mncq1;
id	p5.mncq1?!{p5} = p1.mncq1-Q.mncq1;
#call ACCU(moms1 \(3\))
id	p7.mncq1?!{p7} = p6.mncq1-p8.mncq1;
id	p1.mncq1?!{p1} = p2.mncq1-p6.mncq1;
#call ACCU2(AB P Q p2 p6 p8,moms2)
#endif
#if ( `BEPATH' == 4 )
id	p1.p2 = p1.p1/2+p2.p2/2-p6.p6/2;
id	p1.p5 = p1.p1/2+p5.p5/2-Q.Q/2;
id	p2.p3 = p2.p2/2+p3.p3/2-p7.p7/2;
id	p2.p7 = p2.p2/2+p7.p7/2-p3.p3/2;
id	p3.p7 = p2.p2/2-p3.p3/2-p7.p7/2;
id	p1.mncq1?!{p1} = Q.mncq1+p5.mncq1;
id	p2.mncq1?!{p2} = p3.mncq1+p7.mncq1;
id	p7.mncq1?!{p7} = p6.mncq1-p8.mncq1;
#call ACCU(moms1 \(4\))
id	p3.mncq1?!{p3} = Q.mncq1+p4.mncq1;
id	p5.mncq1?!{p5} = p4.mncq1-p8.mncq1;
#call ACCU2(AB P Q p4 p6 p8,moms2)
#endif
#if ( `BEPATH' == 5 )
id	p2.p3 = p2.p2/2+p3.p3/2-p7.p7/2;
id	p3.p4 = p3.p3/2+p4.p4/2-Q.Q/2;
id	p4.p5 = p4.p4/2+p5.p5/2-p8.p8/2;
id	p4.p8 = p4.p4/2+p8.p8/2-p5.p5/2;
id	p5.p8 = p4.p4/2-p5.p5/2-p8.p8/2;
id	p4.mncq1?!{p4} = -Q.mncq1+p3.mncq1;
id	p5.mncq1?!{p5} = -Q.mncq1+p1.mncq1;
id	p8.mncq1?!{p8} = p6.mncq1-p7.mncq1;
#call ACCU(moms1 \(5\))
id	p3.mncq1?!{p3} = p2.mncq1-p7.mncq1;
id	p2.mncq1?!{p2} = p1.mncq1+p6.mncq1;
#call ACCU2(AB P Q p1 p6 p7,moms2)
#endif
#if ( `BEPATH' == 6 )
id	p3.p4 = p3.p3/2+p4.p4/2-Q.Q/2;
id	p1.p2 = p1.p1/2+p2.p2/2-p6.p6/2;
id	p2.p3 = p2.p2/2+p3.p3/2-p7.p7/2;
id	p2.p7 = p2.p2/2+p7.p7/2-p3.p3/2;
id	p3.p7 = p2.p2/2-p3.p3/2-p7.p7/2;
id	p3.mncq1?!{p3} = Q.mncq1+p4.mncq1;
id	p2.mncq1?!{p2} = p1.mncq1+p6.mncq1;
id	p7.mncq1?!{p7} = p6.mncq1-p8.mncq1;
#call ACCU(moms1 \(6\))
id	p1.mncq1?!{p1} = Q.mncq1+p5.mncq1;
id	p4.mncq1?!{p4} = p5.mncq1+p8.mncq1;
#call ACCU2(AB P Q p5 p6 p8,moms2)
#endif
#if ( `BEPATH' == 7 )
id	p1.p6 = p2.p2/2-p1.p1/2-p6.p6/2;
id	p3.p7 = p2.p2/2-p3.p3/2-p7.p7/2;
id	p6.p7 = p6.p6/2+p7.p7/2-p8.p8/2;
id	p6.p8 = p6.p6/2+p8.p8/2-p7.p7/2;
id	p7.p8 = p6.p6/2-p7.p7/2-p8.p8/2;
id	p6.mncq1?!{p6} = p2.mncq1-p1.mncq1;
id	p7.mncq1?!{p7} = p2.mncq1-p3.mncq1;
id	p8.mncq1?!{p8} = p4.mncq1-p5.mncq1;
#call ACCU(moms1 \(7\))
id	p1.mncq1?!{p1} = Q.mncq1+p5.mncq1;
id	p3.mncq1?!{p3} = Q.mncq1+p4.mncq1;
#call ACCU2(AB P Q p2 p4 p5,moms2)
#endif
#if ( `BEPATH' == 8 )
id	p1.p5 = p1.p1/2+p5.p5/2-Q.Q/2;
id	p3.p4 = p3.p3/2+p4.p4/2-Q.Q/2;
id	p4.p5 = p4.p4/2+p5.p5/2-p8.p8/2;
id	p4.p8 = p4.p4/2+p8.p8/2-p5.p5/2;
id	p5.p8 = p4.p4/2-p5.p5/2-p8.p8/2;
id	p4.mncq1?!{p4} = -Q.mncq1+p3.mncq1;
id	p5.mncq1?!{p5} = -Q.mncq1+p1.mncq1;
id	p8.mncq1?!{p8} = p6.mncq1-p7.mncq1;
#call ACCU(moms1 \(8\))
id	p3.mncq1?!{p3} = p2.mncq1-p7.mncq1;
id	p1.mncq1?!{p1} = p2.mncq1-p6.mncq1;
#call ACCU2(AB P Q p2 p6 p7,moms2)
#endif
#endif
*
#break
*--#] be : 
*--#[ no :
#case no
*
#ifndef `NOSPEC'
id	p5.mncq1?!{p5} = p6.mncq1-p8.mncq1;
id	p4.mncq1?!{p4} = p3.mncq1-Q.mncq1;
#call ACCU(moms1)
id	p6.mncq1?!{p6} = p1.mncq1-Q.mncq1;
id	p7.mncq1?!{p7} = p2.mncq1-p1.mncq1;
#call ACCU(moms2)
id	p8.mncq1?!{p8} = p2.mncq1-p3.mncq1;
#call ACCU2(AB P Q p1 p2 p3,moms3)
#else
#if ( `NOSPEC' == 0 )
id	p5.mncq1?!{p5} = p6.mncq1-p8.mncq1;
id	p4.mncq1?!{p4} = p3.mncq1-Q.mncq1;
#call ACCU(moms1)
id	p6.mncq1?!{p6} = p1.mncq1-Q.mncq1;
id	p7.mncq1?!{p7} = p2.mncq1-p1.mncq1;
#call ACCU(moms2)
id	p8.mncq1?!{p8} = p2.mncq1-p3.mncq1;
#call ACCU2(AB P Q p1 p2 p3,moms3)
#endif
#if ( `NOSPEC' == 1 )
id	p5.mncq1?!{p5} = p6.mncq1-p8.mncq1;
id	p4.mncq1?!{p4} = p3.mncq1-Q.mncq1;
#call ACCU(moms1)
id	p6.mncq1?!{p6} = p1.mncq1-Q.mncq1;
id	p1.mncq1?!{p1} = p2.mncq1-p7.mncq1;
#call ACCU(moms2)
id	p3.mncq1?!{p3} = p2.mncq1-p8.mncq1;
#call ACCU2(AB P Q p7 p2 p8,moms3)
#endif
#if ( `NOSPEC' == 2 )
id	p5.mncq1?!{p5} = p6.mncq1-p8.mncq1;
id	p4.mncq1?!{p4} = p3.mncq1-Q.mncq1;
#call ACCU(moms1)
id	p6.mncq1?!{p6} = p1.mncq1-Q.mncq1;
id	p7.mncq1?!{p7} = p2.mncq1-p1.mncq1;
#call ACCU(moms2)
id	p3.mncq1?!{p3} = p2.mncq1-p8.mncq1;
#call ACCU2(AB P Q p1 p2 p8,moms3)
#endif
#endif
*
#break
*--#] no : 
*--#[ fa :
#case fa
*
id	p6.mncq1?!{p6} = p2.mncq1-p1.mncq1;
id	p7.mncq1?!{p7} = p2.mncq1-p3.mncq1;
id	p8.mncq1?!{p8} = p3.mncq1-p1.mncq1;
#call ACCU(moms1)
id	p4.mncq1?!{p4} = p3.mncq1-Q.mncq1;
id	p5.mncq1?!{p5} = p1.mncq1-Q.mncq1;
#call ACCU2(AB	P Q p1 p2 p3,moms2)
*
#break
*--#] fa : 
*--#[ bu :
#case bu
*
id	p2.mncq1?!{p2} = p1.mncq1-p8.mncq1;
id	p4.mncq1?!{p4} = p1.mncq1-p6.mncq1;
id	p5.mncq1?!{p5} = p6.mncq1-p8.mncq1;
#call ACCU(moms1)
id	p7.mncq1?!{p7} = p6.mncq1-Q.mncq1;
id	p3.mncq1?!{p3} = p8.mncq1-Q.mncq1;
#call ACCU2(AB	P Q p1 p6 p8,moms2)
*
#break
*--#] bu : 
*--#[ o1 :
#case o1
*
#ifndef `O1PATH'
id p7.mncq1?!{p7} = p5.mncq1-p6.mncq1;
id p3.mncq1?!{p3} = p2.mncq1-Q.mncq1;
#call ACCU(moms1)
id p4.mncq1?!{p4} = p1.mncq1-Q.mncq1;
id p5.mncq1?!{p5} = p1.mncq1-p2.mncq1;
#call ACCU2(AB P Q p1 p2 p6,moms2)
#else
#if ( `O1PATH' == 0 )
id p7.mncq1?!{p7} = p5.mncq1-p6.mncq1;
id p3.mncq1?!{p3} = p2.mncq1-Q.mncq1;
#call ACCU(moms1)
id p4.mncq1?!{p4} = p1.mncq1-Q.mncq1;
id p5.mncq1?!{p5} = p1.mncq1-p2.mncq1;
#call ACCU2(AB P Q p1 p2 p6,moms2)
#endif
#if ( `O1PATH' == 1 )
id p3.mncq1?!{p3} = p4.mncq1-p5.mncq1;
id p2.mncq1?!{p2} = p1.mncq1-p5.mncq1;
#call ACCU(moms1)
id p5.mncq1?!{p5} = p6.mncq1+p7.mncq1;
id p4.mncq1?!{p4} = p1.mncq1-Q.mncq1;
#call ACCU2(AB P Q p1 p6 p7,moms2)
#endif
#if ( `O1PATH' == 2 )
id p7.mncq1?!{p7} = p5.mncq1-p6.mncq1;
id p3.mncq1?!{p3} = p2.mncq1-Q.mncq1;
#call ACCU(moms1)
id p4.mncq1?!{p4} = p1.mncq1-Q.mncq1;
id p2.mncq1?!{p2} = p1.mncq1-p5.mncq1;
#call ACCU2(AB P Q p1 p5 p6,moms2)
#endif
#endif
*#call ACCU(moms2)
*
#break
*--#] o1 : 
*--#[ o2 :
#case o2
*
id	p7.mncq1?!{p7} = p4.mncq1-p6.mncq1;
id	p2.mncq1?!{p2} = p3.mncq1+Q.mncq1;
#call ACCU(moms1)
id	p1.mncq1?!{p1} = p4.mncq1+Q.mncq1;
id	p5.mncq1?!{p5} = p4.mncq1-p3.mncq1;
#call ACCU2(AB P Q p3 p4 p6,moms2)
*
#break
*--#] o2 : 
*--#[ o3 :
#case o3
*
id	p7.mncq1?!{p7} = Q.mncq1-p6.mncq1;
id	p4.mncq1?!{p4} = p1.mncq1-Q.mncq1;
#call ACCU(moms1)
id	p5.mncq1?!{p5} = p1.mncq1-p2.mncq1;
id	p3.mncq1?!{p3} = p2.mncq1-Q.mncq1;
#call ACCU2(AB P Q p1 p2 p6,moms2)
*
#break
*--#] o3 : 
*--#[ o4 :
#case o4
*
id	p7.mncq1?!{p7} = Q.mncq1-p6.mncq1;
id	p5.mncq1?!{p5} = p1.mncq1-p2.mncq1;
#call ACCU(moms1)
id	p4.mncq1?!{p4} = p1.mncq1-p6.mncq1;
id	p3.mncq1?!{p3} = p2.mncq1-p6.mncq1;
#call ACCU2(AB P Q p1 p2 p6,moms2)
*
#break
*--#] o4 : 
*--#[ y1 :
#case y1
*
id	p4.mncq1?!{p4} = p1.mncq1-p3.mncq1;
id	p6.mncq1?!{p6} = p2.mncq1-p5.mncq1;
id	p2.mncq1?!{p2} = Q.mncq1-p1.mncq1;
#call ACCU2(AB P Q p1 p3 p5,moms2)
*
#break
*--#] y1 : 
*--#[ y2 :
#case y2
*
id	p4.mncq1?!{p4} = p1.mncq1-p3.mncq1;
id	p6.mncq1?!{p6} = p1.mncq1-p5.mncq1;
id	p2.mncq1?!{p2} = Q.mncq1-p1.mncq1;
#call ACCU2(AB P Q p1 p3 p5,moms2)
*
#break
*--#] y2 : 
*--#[ y3 :
#case y3
*
id	p4.mncq1?!{p4} = p1.mncq1-p3.mncq1;
id	p6.mncq1?!{p6} = p3.mncq1-p5.mncq1;
id	p2.mncq1?!{p2} = Q.mncq1-p1.mncq1;
#call ACCU2(AB P Q p1 p3 p5,moms2)
*
#break
*--#] y3 : 
*--#[ y4 :
#case y4
*
id	p4.mncq1?!{p4} = p1.mncq1-p3.mncq1;
id	p6.mncq1?!{p6} = Q.mncq1-p5.mncq1;
id	p2.mncq1?!{p2} = Q.mncq1-p1.mncq1;
#call ACCU2(AB P Q p1 p3 p5,moms2)
*
#break
*--#] y4 : 
*--#[ y5 :
#case y5
*
id	p2.mncq1?!{p2} = Q.mncq1-p1.mncq1;
id	p4.mncq1?!{p4} = Q.mncq1-p3.mncq1;
id	p6.mncq1?!{p6} = Q.mncq1-p5.mncq1;
#call ACCU2(AB P Q p1 p3 p5,moms2)
*
#break
*--#] y5 : 
*--#[ t1 :
#case t1
*
id	p4.mncq1?!{p4} = p1.mncq1-Q.mncq1;
#call ACCU(moms1)
id	p3.mncq1?!{p3} = p2.mncq1-Q.mncq1;
#call ACCU(moms2)
id	p5.mncq1?!{p5} = p1.mncq1-p2.mncq1;
#call ACCU2(AB P Q p1 p2,moms3)
*
#break
*--#] t1 : 
*--#[ t2 :
#case t2
*
id	p2.mncq1?!{p2} = Q.mncq1-p1.mncq1;
#call ACCU(moms1)
id	p4.mncq1?!{p4} = p1.mncq1-p3.mncq1;
#call ACCU2(AB P Q p1 p3,moms2)
*
#break
*--#] t2 : 
*--#[ t3 :
#case t3
*
id	p2.mncq1?!{p2} = Q.mncq1-p1.mncq1;
#call ACCU{moms1}
id	p4.mncq1?!{p4} = Q.mncq1-p3.mncq1;
#call ACCU2(AB P Q p1 p3,moms2)
*
#break
*--#] t3 : 
*--#[ l1 :
#case l1
*
*
#break
*--#] l1 : 
*--#[ l2 :
#case l2
*
*
#break
*--#] l2 : 
*--#[ l3 :
#case l3
*
*
#break
*--#] l3 : 
*--#[ tr :
#case tr
*
*
#break
*--#] tr : 
#default
#message Unknown case `TOPO' in momsubs.prc
#break
#endswitch
#endprocedure
*--#] momsubs : 
*--#[ newplane :
#procedure newplane(P1,P2,P3,P4,P5,P6,P7,P8,Q,INTS)
*
*   Reduction procedure for three loop graphs of the NO or nonplanar type.
*   Notation is from S.G.Gorishny et.al. Comp.Phys.Comm 55(1989)381
*   For the first part we use the algorithms from Chetyrkin & Tkachov
*   (Nuclear physics B192(1981)159.
*   To reduce powers in the numerator. These algorithms work faster.
*
*                     /-<------<-----<-\
*                 P1 /     \  P2   /    \ P3
*                   /       v     /      \
*                  /      P7 \   /        \
*                 /           \ /          \
*          Q --<--             /            --<-- Q
*                 \           / \          /
*                  \      P8 /   \        / 
*                   \       ^     \      /
*                 P6 \     /  P5   \    / P4
*                     \->------>----->-/
*
*   Express everything in powers of pi.pi, Q.Q and Q.p2 or p2.p5;
*	We need p2.p5 only when there are enough denominators.
*   The only difficult relation here is the one for p7.p8
*
*   Note that the system here is optimized for the big and difficult
*   expressions.
*   Note also that the final stages can be improved.
*   At the moment the goto statements are not so good
*
#ifndef `NOSPEC'
if ( count(`P7'.`P7',1) < count(`P8'.`P8',1) );
	multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4'
       ,`P7',`P8',`P8',`P7');
elseif ( count(`P7'.`P7',1) == count(`P8'.`P8',1) );
    if ( count(`P1'.`P1',1) < count(`P3'.`P3',1) );
		multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4'
           ,`P7',`P8',`P8',`P7');
	elseif ( count(`P1'.`P1',1) == count(`P3'.`P3',1) );
	    if ( count(`P6'.`P6',1) < count(`P4'.`P4',1) )
			multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4'
               ,`P7',`P8',`P8',`P7');
	endif;
endif;
#call ACCU2(AB `P1'.`Q' `P1'.`P1' `Q'.`Q' `P6'.`P6',dots 0)
  id  `P1'.`Q' = `P1'.`P1'/2+`Q'.`Q'/2-`P6'.`P6'/2;
#call ACCU2(AB `P3'.`Q' `P3'.`P3' `Q'.`Q' `P4'.`P4',dots 1)
  id  `P3'.`Q' = `P3'.`P3'/2+`Q'.`Q'/2-`P4'.`P4'/2;
#call ACCU2(AB `P1'.`P2' `P1'.`P1' `P2'.`P2' `P7'.`P7',dots 2)
  id  `P1'.`P2' = `P1'.`P1'/2+`P2'.`P2'/2-`P7'.`P7'/2;
#call ACCU2(AB `P2'.`P3' `P3'.`P3' `P2'.`P2' `P8'.`P8',dots 3)
  id  `P3'.`P2' = `P3'.`P3'/2+`P2'.`P2'/2-`P8'.`P8'/2;
if ( count(`P7'.`P7',1) < count(`P8'.`P8',1) );
	multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4'
       ,`P7',`P8',`P8',`P7');
elseif ( count(`P7'.`P7',1) == count(`P8'.`P8',1) );
    if ( count(`P1'.`P1',1) < count(`P3'.`P3',1) );
		multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4'
           ,`P7',`P8',`P8',`P7');
	elseif ( count(`P1'.`P1',1) == count(`P3'.`P3',1) );
	    if ( count(`P6'.`P6',1) < count(`P4'.`P4',1) )
			multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4'
               ,`P7',`P8',`P8',`P7');
	endif;
endif;
#call ACCU(dots 4)
    id `P1'.`P3' = -`P2'.`Q'+`P1'.`P1'/2+`P2'.`P2'/2+`P3'.`P3'/2+`P5'.`P5'/2
                 +`Q'.`Q'/2-`P4'.`P4'/2-`P6'.`P6'/2-`P7'.`P7'/2-`P8'.`P8'/2;
*  repeat  id `P1'.`P3'/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
*    	/`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8' =
*		(`P2'.`P5'+`P2'.`P2'/2+`P5'.`P5'/2+`Q'.`Q'/2-`P4'.`P4'/2-`P6'.`P6'/2)
*		/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
*    	/`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8';
#call ACCU(dots 5)
  repeat id	`Q'.`P2'/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
    	/`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8' =
		(`P1'.`P1'/2+`P3'.`P3'/2-`P7'.`P7'/2-`P8'.`P8'/2-`P2'.`P5')
		/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
    	/`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8';
#call ACCU(dots 6)
*  if ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
*    	/`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8') == 0 );
*    id `P1'.`P3' = -`P2'.`Q'+`P1'.`P1'/2+`P2'.`P2'/2+`P3'.`P3'/2+`P5'.`P5'/2
*                 +`Q'.`Q'/2-`P4'.`P4'/2-`P6'.`P6'/2-`P7'.`P7'/2-`P8'.`P8'/2;
*  endif;
*#call ACCU(dots 7)
#else
#if ( `NOSPEC' == 0 )
if ( count(`P7'.`P7',1) < count(`P8'.`P8',1) );
	multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4'
       ,`P7',`P8',`P8',`P7');
elseif ( count(`P7'.`P7',1) == count(`P8'.`P8',1) );
    if ( count(`P1'.`P1',1) < count(`P3'.`P3',1) );
		multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4'
           ,`P7',`P8',`P8',`P7');
	elseif ( count(`P1'.`P1',1) == count(`P3'.`P3',1) );
	    if ( count(`P6'.`P6',1) < count(`P4'.`P4',1) )
			multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4'
               ,`P7',`P8',`P8',`P7');
	endif;
endif;
#call ACCU2(AB `P1'.`Q' `P1'.`P1' `Q'.`Q' `P6'.`P6',dots 0)
  id  `P1'.`Q' = `P1'.`P1'/2+`Q'.`Q'/2-`P6'.`P6'/2;
#call ACCU2(AB `P3'.`Q' `P3'.`P3' `Q'.`Q' `P4'.`P4',dots 1)
  id  `P3'.`Q' = `P3'.`P3'/2+`Q'.`Q'/2-`P4'.`P4'/2;
#call ACCU2(AB `P1'.`P2' `P1'.`P1' `P2'.`P2' `P7'.`P7',dots 2)
  id  `P1'.`P2' = `P1'.`P1'/2+`P2'.`P2'/2-`P7'.`P7'/2;
#call ACCU2(AB `P2'.`P3' `P3'.`P3' `P2'.`P2' `P8'.`P8',dots 3)
  id  `P3'.`P2' = `P3'.`P3'/2+`P2'.`P2'/2-`P8'.`P8'/2;
if ( count(`P7'.`P7',1) < count(`P8'.`P8',1) );
	multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4'
       ,`P7',`P8',`P8',`P7');
elseif ( count(`P7'.`P7',1) == count(`P8'.`P8',1) );
    if ( count(`P1'.`P1',1) < count(`P3'.`P3',1) );
		multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4'
           ,`P7',`P8',`P8',`P7');
	elseif ( count(`P1'.`P1',1) == count(`P3'.`P3',1) );
	    if ( count(`P6'.`P6',1) < count(`P4'.`P4',1) )
			multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4'
               ,`P7',`P8',`P8',`P7');
	endif;
endif;
#call ACCU(dots 4)
    id `P1'.`P3' = -`P2'.`Q'+`P1'.`P1'/2+`P2'.`P2'/2+`P3'.`P3'/2+`P5'.`P5'/2
                 +`Q'.`Q'/2-`P4'.`P4'/2-`P6'.`P6'/2-`P7'.`P7'/2-`P8'.`P8'/2;
*  repeat  id `P1'.`P3'/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
*    	/`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8' =
*		(`P2'.`P5'+`P2'.`P2'/2+`P5'.`P5'/2+`Q'.`Q'/2-`P4'.`P4'/2-`P6'.`P6'/2)
*		/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
*    	/`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8';
#call ACCU(dots 5)
  repeat id	`Q'.`P2'/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
    	/`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8' =
		(`P1'.`P1'/2+`P3'.`P3'/2-`P7'.`P7'/2-`P8'.`P8'/2-`P2'.`P5')
		/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
    	/`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8';
#call ACCU(dots 6)
*  if ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
*    	/`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8') == 0 );
*    id `P1'.`P3' = -`P2'.`Q'+`P1'.`P1'/2+`P2'.`P2'/2+`P3'.`P3'/2+`P5'.`P5'/2
*                 +`Q'.`Q'/2-`P4'.`P4'/2-`P6'.`P6'/2-`P7'.`P7'/2-`P8'.`P8'/2;
*  endif;
*#call ACCU(dots 7)
#endif
#if ( `NOSPEC' == 1 )
  id  `P2'.`P7' = `P2'.`P2'/2+`P7'.`P7'/2-`P1'.`P1'/2;
#call ACCU2(AB `P2'.`P8' `P3'.`P3' `P2'.`P2' `P8'.`P8',dots 0)
  id  `P2'.`P8' = -`P3'.`P3'/2+`P2'.`P2'/2+`P8'.`P8'/2;
#call ACCU2(AB `P7'.`P8' `P7'.`P7' `P8'.`P8' `P1'.`P1' `P3'.`P3' `P1'.`P3',dots 1)
  id  `P7'.`P8' = `P7'.`P7'/2+`P8'.`P8'/2-`P1'.`P1'/2-`P3'.`P3'/2+`P1'.`P3';
#call ACCU2(AB `P7'.`Q' `Q'.`P2' `P1'.`P1' `Q'.`Q' `P6'.`P6',dots 2)
  id  `P7'.`Q' = `Q'.`P2'-`P1'.`P1'/2-`Q'.`Q'/2+`P6'.`P6'/2;
#call ACCU2(AB `P8'.`Q' `P3'.`P3' `Q'.`Q' `P4'.`P4' `Q'.`P2',dots 3)
  id  `P8'.`Q' = `Q'.`P2'-`P3'.`P3'/2-`Q'.`Q'/2+`P4'.`P4'/2;
#call ACCU2(AB `P1'.`P3' `P2'.`P5' `P2'.`P2' `P5'.`P5' `Q'.`Q' `P4'.`P4' `P6'.`P6',dots 4)
  repeat  id `P1'.`P3'/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
    	/`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8' =
		(`P2'.`P5'+`P2'.`P2'/2+`P5'.`P5'/2+`Q'.`Q'/2-`P4'.`P4'/2-`P6'.`P6'/2)
		/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
    	/`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8';
#call ACCU2(AB `Q'.`P2' `P1'.`P1' `P3'.`P3' `P7'.`P7' `P8'.`P8' `P2'.`P5',dots 5)
#do ii6 = 1,1
  id	`Q'.`P2'/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
    	/`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8' =
		(`P1'.`P1'/2+`P3'.`P3'/2-`P7'.`P7'/2-`P8'.`P8'/2-`P2'.`P5')
		/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
    	/`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8';
  if ( match(`Q'.`P2'/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
    	/`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8') ) redefine ii6 "0";
#call ACCU2(AB `Q'.`P2' `P1'.`P1' `P3'.`P3' `P7'.`P7' `P8'.`P8' `P2'.`P5',dots 6)
#enddo
  if ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
    	/`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8') == 0 );
    id,once,`P1'.`P3' = -`P2'.`Q'+`P1'.`P1'/2+`P2'.`P2'/2+`P3'.`P3'/2+`P5'.`P5'/2
                 +`Q'.`Q'/2-`P4'.`P4'/2-`P6'.`P6'/2-`P7'.`P7'/2-`P8'.`P8'/2;
  endif;
#call ACCU(dots 7)
  if ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
    	/`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8') == 0 );
    id,`P1'.`P3' = -`P2'.`Q'+`P1'.`P1'/2+`P2'.`P2'/2+`P3'.`P3'/2+`P5'.`P5'/2
                 +`Q'.`Q'/2-`P4'.`P4'/2-`P6'.`P6'/2-`P7'.`P7'/2-`P8'.`P8'/2;
  endif;
#call ACCU(dots 8)
#endif
#if ( `NOSPEC' == 2 )
#call ACCU2(AB `P1'.`Q' `P1'.`P1' `Q'.`Q' `P6'.`P6',dots 0)
  id  `P1'.`Q' = `P1'.`P1'/2+`Q'.`Q'/2-`P6'.`P6'/2;
#call ACCU2(AB `P8'.`Q' `P2'.`Q' `P3'.`P3' `Q'.`Q' `P4'.`P4',dots 1)
  id  `P8'.`Q' = `P2'.`Q'-`P3'.`P3'/2-`Q'.`Q'/2+`P4'.`P4'/2;
#call ACCU2(AB `P1'.`P2' `P1'.`P1' `P2'.`P2' `P7'.`P7',dots 2)
  id  `P1'.`P2' = `P1'.`P1'/2+`P2'.`P2'/2-`P7'.`P7'/2;
#call ACCU2(AB `P2'.`P8' `P3'.`P3' `P2'.`P2' `P8'.`P8',dots 3)
  id  `P2'.`P8' = `P8'.`P8'/2+`P2'.`P2'/2-`P3'.`P3'/2;
#call ACCU2(AB `P1'.`P8' `P2'.`Q' `P3'.`P3' `P5'.`P5' `Q'.`Q' `P4'.`P4' `P6'.`P6' `P8'.`P8',dots 4)
  id `P1'.`P8' = +`P2'.`Q'-`P3'.`P3'/2-`P5'.`P5'/2
                 -`Q'.`Q'/2+`P4'.`P4'/2+`P6'.`P6'/2+`P8'.`P8'/2;
#call ACCU(dots 5)
  repeat id	`Q'.`P2'/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
    	/`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8' =
		(`P1'.`P1'/2+`P3'.`P3'/2-`P7'.`P7'/2-`P8'.`P8'/2-`P2'.`P5')
		/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
    	/`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8';
#call ACCU(dots 6)
*  if ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
*    	/`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8') == 0 );
*    id `P1'.`P3' = -`P2'.`Q'+`P1'.`P1'/2+`P2'.`P2'/2+`P3'.`P3'/2+`P5'.`P5'/2
*                 +`Q'.`Q'/2-`P4'.`P4'/2-`P6'.`P6'/2-`P7'.`P7'/2-`P8'.`P8'/2;
*  endif;
*#call ACCU(dots 7)
#endif
#endif
if ( count(`P7'.`P7',1) < count(`P8'.`P8',1) );
	multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4'
       ,`P7',`P8',`P8',`P7');
elseif ( count(`P7'.`P7',1) == count(`P8'.`P8',1) );
    if ( count(`P1'.`P1',1) < count(`P3'.`P3',1) );
		multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4'
           ,`P7',`P8',`P8',`P7');
	elseif ( count(`P1'.`P1',1) == count(`P3'.`P3',1) );
	    if ( count(`P6'.`P6',1) < count(`P4'.`P4',1) )
			multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4'
               ,`P7',`P8',`P8',`P7');
	endif;
endif;
*
* Now we start a set of iterations to make either
* 1:  the power of `P2'.`P5' equal to zero
* 2:  the power of `P2'.`P2',`P5'.`P5',`P7'.`P7',`P8'.`P8' >= 0
* 3:  the power of `P1'.`P1',`P3'.`P3',`P4'.`P4',`P6'.`P6' >= -1
*
repeat;
  if ( match(`P2'.`P5'/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'/`P5'.`P5'
  /`P6'.`P6'/`P7'.`P7'/`P8'.`P8') );
    if ( count(`P6'.`P6',1) < -1 );
      id `P2'.`P5'^mncx9?/`P1'.`P1'^mncx1?/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?/`P4'.`P4'^mncx4?
         /`P5'.`P5'^mncx5?/`P6'.`P6'^mncx6?/`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? =
         `P2'.`P5'^mncx9/`P1'.`P1'^mncx1/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3/`P4'.`P4'^mncx4
         /`P5'.`P5'^mncx5/`P6'.`P6'^mncx6/`P7'.`P7'^mncx7/`P8'.`P8'^mncx8 * (
        +acc(mncx6-1)*(`P3'.`P3'-`P2'.`P2'-`P8'.`P8')
        +acc(3-2*ep+mncx9-mncx1-mncx8-2*mncx2)*`P6'.`P6'
        +mncx1*`P6'.`P6'/`P1'.`P1'*(`P7'.`P7'-`P2'.`P2')
        +mncx8*`P6'.`P6'/`P8'.`P8'*(`P3'.`P3'-`P2'.`P2')
        )/(mncx6-1)/2/`P2'.`P5';
    elseif ( count(`P1'.`P1',1) < -1 );
      id `P2'.`P5'^mncx9?/`P1'.`P1'^mncx1?/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?/`P4'.`P4'^mncx4?
         /`P5'.`P5'^mncx5?/`P6'.`P6'/`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? =
         `P2'.`P5'^mncx9/`P1'.`P1'^mncx1/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3/`P4'.`P4'^mncx4
         /`P5'.`P5'^mncx5/`P6'.`P6'/`P7'.`P7'^mncx7/`P8'.`P8'^mncx8 * (
        +acc(mncx1-1)*(`P4'.`P4'-`P5'.`P5'-`P7'.`P7')
        +acc(2-2*ep+mncx9-mncx7-2*mncx5)*`P1'.`P1'
        +`P1'.`P1'/`P6'.`P6'*(`P8'.`P8'-`P5'.`P5')
        +mncx7*`P1'.`P1'/`P7'.`P7'*(`P4'.`P4'-`P5'.`P5')
        )/(mncx1-1)/2/`P2'.`P5';
    elseif ( count(`P4'.`P4',1) < -1 );
      id `P2'.`P5'^mncx9?/`P1'.`P1'/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?/`P4'.`P4'^mncx4?
         /`P5'.`P5'^mncx5?/`P6'.`P6'/`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? =
         `P2'.`P5'^mncx9/`P1'.`P1'/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3/`P4'.`P4'^mncx4
         /`P5'.`P5'^mncx5/`P6'.`P6'/`P7'.`P7'^mncx7/`P8'.`P8'^mncx8 * (
        +acc(mncx4-1)*(`P1'.`P1'-`P2'.`P2'-`P7'.`P7')
        +acc(3-2*ep+mncx9-mncx3-mncx7-2*mncx2)*`P4'.`P4'
        +mncx3*`P4'.`P4'/`P3'.`P3'*(`P8'.`P8'-`P2'.`P2')
        +mncx7*`P4'.`P4'/`P7'.`P7'*(`P1'.`P1'-`P2'.`P2')
        )/(mncx4-1)/2/`P2'.`P5';
    elseif ( count(`P3'.`P3',1) < -1 );
      id `P2'.`P5'^mncx9?/`P1'.`P1'/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?/`P4'.`P4'
         /`P5'.`P5'^mncx5?/`P6'.`P6'/`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? =
         `P2'.`P5'^mncx9/`P1'.`P1'/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3/`P4'.`P4'
         /`P5'.`P5'^mncx5/`P6'.`P6'/`P7'.`P7'^mncx7/`P8'.`P8'^mncx8 * (
        +acc(mncx3-1)*(`P6'.`P6'-`P5'.`P5'-`P8'.`P8')
        +acc(2-2*ep+mncx9-mncx8-2*mncx5)*`P3'.`P3'
        +`P3'.`P3'/`P4'.`P4'*(`P7'.`P7'-`P5'.`P5')
        +mncx8*`P3'.`P3'/`P8'.`P8'*(`P6'.`P6'-`P5'.`P5')
        )/(mncx3-1)/2/`P2'.`P5';
    endif;
  endif;
endrepeat;
#call ACCU(nonplanar pass 1)
*
* The next set of iterations has two phases.
* The first phase stops when either
* 1:  the power of `P2'.`P5' equal to zero
* 2:  the power of `P1'.`P1',`P3'.`P3',`P4'.`P4',`P6'.`P6',`P7'.`P7',`P8'.`P8' >= 0
* 3:  the power of `P2'.`P2',`P5'.`P5' >= -1
* The second phase stops when
* 1:  the power of `P2'.`P5' equal to zero
* 2:  the power of all others is >= -1
*
#ifdef `LONGINT'
#do i = 1,`LONGINT'
  if ( match(`P2'.`P5'/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'/`P5'.`P5'
  /`P6'.`P6'/`P7'.`P7'/`P8'.`P8') );
    if ( count(`P5'.`P5',1) < -1 );
      id `P2'.`P5'^mncx9?/`P1'.`P1'/`P2'.`P2'^mncx2?/`P3'.`P3'/`P4'.`P4'
         /`P5'.`P5'^mncx5?/`P6'.`P6'/`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? =
         `P2'.`P5'^mncx9/`P1'.`P1'/`P2'.`P2'^mncx2/`P3'.`P3'/`P4'.`P4'
         /`P5'.`P5'^mncx5/`P6'.`P6'/`P7'.`P7'^mncx7/`P8'.`P8'^mncx8 * (
          +acc(2*mncx2+mncx7+mncx8-mncx9-3+2*ep)
          +acc(mncx9-1)*`P2'.`P2'/`P2'.`P5'
          +mncx7*(`P2'.`P2'-`P1'.`P1')/`P7'.`P7'
          +mncx8*(`P2'.`P2'-`P3'.`P3')/`P8'.`P8'
        )/(mncx5-1)/2/`P2'.`P5'*`P5'.`P5';
    elseif ( count(`P2'.`P2',1) < -1 );
      id `P2'.`P5'^mncx9?/`P1'.`P1'/`P2'.`P2'^mncx2?/`P3'.`P3'/`P4'.`P4'
         /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? =
         `P2'.`P5'^mncx9/`P1'.`P1'/`P2'.`P2'^mncx2/`P3'.`P3'/`P4'.`P4'
         /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'^mncx7/`P8'.`P8'^mncx8 * (
          +acc(mncx7+mncx8-mncx9-1+2*ep)
          +acc(mncx9-1)*`P5'.`P5'/`P2'.`P5'
          +mncx7*(`P5'.`P5'-`P4'.`P4')/`P7'.`P7'
          +mncx8*(`P5'.`P5'-`P6'.`P6')/`P8'.`P8'
        )/(mncx2-1)/2/`P2'.`P5'*`P2'.`P2';
    elseif ( count(`P8'.`P8',1) < -1 );
      id `P2'.`P5'^mncx9?/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
         /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? =
         `P2'.`P5'^mncx9/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
         /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'^mncx7/`P8'.`P8'^mncx8 * (
          +acc(mncx8-1)*(2*`P1'.`P1'+2*`P3'.`P3'-2*`P2'.`P2'-`P7'.`P7'-`Q'.`Q')
          +acc(mncx9-1)*`P8'.`P8'*(`P1'.`P1'-`P2'.`P2'-`P7'.`P7')/`P2'.`P5'
          +acc(3-2*ep-2*mncx7-mncx8)*`P8'.`P8'
          +2*`P8'.`P8'/`P2'.`P2'*(`P1'.`P1'-`P7'.`P7')
        )/(mncx8-1)/2/`P2'.`P5';
    elseif ( count(`P7'.`P7',1) < -1 );
      id `P2'.`P5'^mncx9?/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
         /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'^mncx7?/`P8'.`P8' =
         `P2'.`P5'^mncx9/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
         /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'^mncx7/`P8'.`P8' * (
          +acc(mncx7-1)*(2*`P6'.`P6'+2*`P4'.`P4'-2*`P5'.`P5'-`P8'.`P8'-`Q'.`Q')
          +acc(mncx9-1)*`P7'.`P7'*(`P6'.`P6'-`P5'.`P5'-`P8'.`P8')/`P2'.`P5'
          +acc(1-2*ep-mncx7)*`P7'.`P7'
          +2*`P7'.`P7'/`P5'.`P5'*(`P6'.`P6'-`P8'.`P8')
        )/(mncx7-1)/2/`P2'.`P5';
    endif;
*    id  acc(0) = 0;
  endif;
#call ACCU(nonplanar pass 2\,`i')
#enddo
#endif
repeat;
  if ( match(`P2'.`P5'/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'/`P5'.`P5'
  /`P6'.`P6'/`P7'.`P7'/`P8'.`P8') );
    if ( count(`P5'.`P5',1) < -1 );
      id `P2'.`P5'^mncx9?/`P1'.`P1'/`P2'.`P2'^mncx2?/`P3'.`P3'/`P4'.`P4'
         /`P5'.`P5'^mncx5?/`P6'.`P6'/`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? =
         `P2'.`P5'^mncx9/`P1'.`P1'/`P2'.`P2'^mncx2/`P3'.`P3'/`P4'.`P4'
         /`P5'.`P5'^mncx5/`P6'.`P6'/`P7'.`P7'^mncx7/`P8'.`P8'^mncx8 * (
          +acc(2*mncx2+mncx7+mncx8-mncx9-3+2*ep)
          +acc(mncx9-1)*`P2'.`P2'/`P2'.`P5'
          +mncx7*(`P2'.`P2'-`P1'.`P1')/`P7'.`P7'
          +mncx8*(`P2'.`P2'-`P3'.`P3')/`P8'.`P8'
        )/(mncx5-1)/2/`P2'.`P5'*`P5'.`P5';
    elseif ( count(`P2'.`P2',1) < -1 );
      id `P2'.`P5'^mncx9?/`P1'.`P1'/`P2'.`P2'^mncx2?/`P3'.`P3'/`P4'.`P4'
         /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? =
         `P2'.`P5'^mncx9/`P1'.`P1'/`P2'.`P2'^mncx2/`P3'.`P3'/`P4'.`P4'
         /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'^mncx7/`P8'.`P8'^mncx8 * (
          +acc(mncx7+mncx8-mncx9-1+2*ep)
          +acc(mncx9-1)*`P5'.`P5'/`P2'.`P5'
          +mncx7*(`P5'.`P5'-`P4'.`P4')/`P7'.`P7'
          +mncx8*(`P5'.`P5'-`P6'.`P6')/`P8'.`P8'
        )/(mncx2-1)/2/`P2'.`P5'*`P2'.`P2';
    elseif ( count(`P8'.`P8',1) < -1 );
      id `P2'.`P5'^mncx9?/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
         /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? =
         `P2'.`P5'^mncx9/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
         /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'^mncx7/`P8'.`P8'^mncx8 * (
          +acc(mncx8-1)*(2*`P1'.`P1'+2*`P3'.`P3'-2*`P2'.`P2'-`P7'.`P7'-`Q'.`Q')
          +acc(mncx9-1)*`P8'.`P8'*(`P1'.`P1'-`P2'.`P2'-`P7'.`P7')/`P2'.`P5'
          +acc(3-2*ep-2*mncx7-mncx8)*`P8'.`P8'
          +2*`P8'.`P8'/`P2'.`P2'*(`P1'.`P1'-`P7'.`P7')
        )/(mncx8-1)/2/`P2'.`P5';
    elseif ( count(`P7'.`P7',1) < -1 );
      id `P2'.`P5'^mncx9?/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
         /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'^mncx7?/`P8'.`P8' =
         `P2'.`P5'^mncx9/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
         /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'^mncx7/`P8'.`P8' * (
          +acc(mncx7-1)*(2*`P6'.`P6'+2*`P4'.`P4'-2*`P5'.`P5'-`P8'.`P8'-`Q'.`Q')
          +acc(mncx9-1)*`P7'.`P7'*(`P6'.`P6'-`P5'.`P5'-`P8'.`P8')/`P2'.`P5'
          +acc(1-2*ep-mncx7)*`P7'.`P7'
          +2*`P7'.`P7'/`P5'.`P5'*(`P6'.`P6'-`P8'.`P8')
        )/(mncx7-1)/2/`P2'.`P5';
    endif;
*    id  acc(0) = 0;
  endif;
endrepeat;
#call ACCU(nonplanar pass 2)
*
*   Note: equation 6.14 is wrong!!! 6.13 is confusing. Use d/dk instead
*
multiply acc(1/ep);
while ( match(`P2'.`P5'/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'/`P5'.`P5'
  /`P6'.`P6'/`P7'.`P7'/`P8'.`P8') );
    id `P2'.`P5'^mncx9?/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
         /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8' =
         `P2'.`P5'^mncx9/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
         /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8' * (
            +2*`P3'.`P3'-2*`P8'.`P8'
            +acc(1+2*ep-mncx9)*mncdeno(mncx9-1,-4)*`Q'.`Q'
            +2*`Q'.`Q'*mncdeno(mncx9-1,-4)*(`P2'.`P2'-`P8'.`P8')/`P3'.`P3'
        )/2/`P2'.`P5';
*    id  acc(0) = 0;
*	id	acc(2*ep)*mncdeno(0,-4) = -1/2;
    id  1/`P2'.`P5' = 0;
    id  mncdeno(0,-4) = acc(-1/4/ep);
    id  mncdeno(mncx1?,-4)=acc(1+4/mncx1*ep+16/mncx1^2*ep^2+64/mncx1^3*ep^3
        +256/mncx1^4*ep^4+1024/mncx1^5*ep^5+4096/mncx1^6*ep^6)/mncx1;
endwhile;
multiply ep;

#call ACCU(nonplanar pass 3)
*
*   Next are four recursions that reduce the powers of the propagators
*   that connect to `Q' to 1.
*
#ifdef `LONGINT'
label 6;
while ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
  /`P5'.`P5'/`P6'.`P6'^2/`P7'.`P7'/`P8'.`P8') > 0 )
  id  1/`P1'.`P1'^mncx1?/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?
    /`P4'.`P4'^mncx4?/`P5'.`P5'^mncx5?/`P6'.`P6'^mncx6?
    /`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? = 
    1/`P1'.`P1'^mncx1/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3
    /`P4'.`P4'^mncx4/`P5'.`P5'^mncx5/`P6'.`P6'^mncx6
    /`P7'.`P7'^mncx7/`P8'.`P8'^mncx8/`Q'.`Q'*(
      +acc(2*mncx1+2*mncx2+mncx5+mncx6+2*mncx7+mncx8-9+4*ep)*`P6'.`P6'
      +acc(mncx6-1)*`P1'.`P1'
      +mncx8*`P2'.`P2'*`P6'.`P6'/`P8'.`P8'
      -mncx8*`P3'.`P3'*`P6'.`P6'/`P8'.`P8'
      +mncx5*`P6'.`P6'*`P7'.`P7'/`P5'.`P5'
      -mncx5*`P4'.`P4'*`P6'.`P6'/`P5'.`P5'
    )/(mncx6-1);
label 1;
while ( match(1/`P1'.`P1'^2/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
    /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8') > 0 )
  id  1/`P1'.`P1'^mncx1?/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?
    /`P4'.`P4'^mncx4?/`P5'.`P5'^mncx5?/`P6'.`P6'^mncx6?
    /`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? = 
    1/`P1'.`P1'^mncx1/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3
    /`P4'.`P4'^mncx4/`P5'.`P5'^mncx5/`P6'.`P6'^mncx6
    /`P7'.`P7'^mncx7/`P8'.`P8'^mncx8/`Q'.`Q'*(
      +acc(2*mncx6+2*mncx5+mncx2+mncx1+2*mncx8+mncx7-9+4*ep)*`P1'.`P1'
      +acc(mncx1-1)*`P6'.`P6'
      +mncx7*`P5'.`P5'*`P1'.`P1'/`P7'.`P7'
      -mncx7*`P4'.`P4'*`P1'.`P1'/`P7'.`P7'
      +mncx2*`P1'.`P1'*`P8'.`P8'/`P2'.`P2'
      -mncx2*`P3'.`P3'*`P1'.`P1'/`P2'.`P2'
    )/(mncx1-1);
label 3;
while ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'^2/`P4'.`P4'
    /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8') > 0 )
  id  1/`P1'.`P1'^mncx1?/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?
    /`P4'.`P4'^mncx4?/`P5'.`P5'^mncx5?/`P6'.`P6'^mncx6?
    /`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? = 
    1/`P1'.`P1'^mncx1/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3
    /`P4'.`P4'^mncx4/`P5'.`P5'^mncx5/`P6'.`P6'^mncx6
    /`P7'.`P7'^mncx7/`P8'.`P8'^mncx8/`Q'.`Q'*(
      +acc(2*mncx4+2*mncx5+mncx2+mncx3+2*mncx7+mncx8-9+4*ep)*`P3'.`P3'
      +acc(mncx3-1)*`P4'.`P4'
      +mncx8*`P5'.`P5'*`P3'.`P3'/`P8'.`P8'
      -mncx8*`P6'.`P6'*`P3'.`P3'/`P8'.`P8'
      +mncx2*`P3'.`P3'*`P7'.`P7'/`P2'.`P2'
      -mncx2*`P1'.`P1'*`P3'.`P3'/`P2'.`P2'
    )/(mncx3-1);
label 4;
while ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'^2
    /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8') > 0 )
  id  1/`P1'.`P1'^mncx1?/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?
    /`P4'.`P4'^mncx4?/`P5'.`P5'^mncx5?/`P6'.`P6'^mncx6?
    /`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? = 
    1/`P1'.`P1'^mncx1/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3
    /`P4'.`P4'^mncx4/`P5'.`P5'^mncx5/`P6'.`P6'^mncx6
    /`P7'.`P7'^mncx7/`P8'.`P8'^mncx8/`Q'.`Q'*(
      +acc(2*mncx3+2*mncx2+mncx5+mncx4+2*mncx8+mncx7-9+4*ep)*`P4'.`P4'
      +acc(mncx4-1)*`P3'.`P3'
      +mncx7*`P2'.`P2'*`P4'.`P4'/`P7'.`P7'
      -mncx7*`P1'.`P1'*`P4'.`P4'/`P7'.`P7'
      +mncx5*`P4'.`P4'*`P8'.`P8'/`P5'.`P5'
      -mncx5*`P6'.`P6'*`P4'.`P4'/`P5'.`P5'
    )/(mncx4-1);
id  mncdeno(0,mncx1?) = 1/mncx1/ep;
id  mncdeno(mncx1?,mncx2?) = mncaccm(1+ep*mncx2/mncx1)/mncx1;
repeat id mncaccm(mncx1?)*mncaccm(mncx2?) = mncaccm(mncx1*mncx2);
id  mncaccm(mncx1?) = mncaccm(mncx1-1);
id  mncaccm(mncx1?) = mncaccm(mncx1-mncx1^2,mncx1^3);
id  mncaccm(mncx1?,mncx2?) = acc(1-mncx1-mncx2+mncx2*mncx1+mncx2^2);
#call ACCU(Preparation)
#endif
label 6;
while ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
  /`P5'.`P5'/`P6'.`P6'^2/`P7'.`P7'/`P8'.`P8') > 0 )
  id  1/`P1'.`P1'^mncx1?/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?
    /`P4'.`P4'^mncx4?/`P5'.`P5'^mncx5?/`P6'.`P6'^mncx6?
    /`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? = 
    1/`P1'.`P1'^mncx1/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3
    /`P4'.`P4'^mncx4/`P5'.`P5'^mncx5/`P6'.`P6'^mncx6
    /`P7'.`P7'^mncx7/`P8'.`P8'^mncx8/`Q'.`Q'*(
      +acc(2*mncx1+2*mncx2+mncx5+mncx6+2*mncx7+mncx8-9+4*ep)*`P6'.`P6'
      +acc(mncx6-1)*`P1'.`P1'
      +mncx8*`P2'.`P2'*`P6'.`P6'/`P8'.`P8'
      -mncx8*`P3'.`P3'*`P6'.`P6'/`P8'.`P8'
      +mncx5*`P6'.`P6'*`P7'.`P7'/`P5'.`P5'
      -mncx5*`P4'.`P4'*`P6'.`P6'/`P5'.`P5'
    )/(mncx6-1);
label 1;
while ( match(1/`P1'.`P1'^2/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
    /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8') > 0 )
  id  1/`P1'.`P1'^mncx1?/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?
    /`P4'.`P4'^mncx4?/`P5'.`P5'^mncx5?/`P6'.`P6'^mncx6?
    /`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? = 
    1/`P1'.`P1'^mncx1/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3
    /`P4'.`P4'^mncx4/`P5'.`P5'^mncx5/`P6'.`P6'^mncx6
    /`P7'.`P7'^mncx7/`P8'.`P8'^mncx8/`Q'.`Q'*(
      +acc(2*mncx6+2*mncx5+mncx2+mncx1+2*mncx8+mncx7-9+4*ep)*`P1'.`P1'
      +acc(mncx1-1)*`P6'.`P6'
      +mncx7*`P5'.`P5'*`P1'.`P1'/`P7'.`P7'
      -mncx7*`P4'.`P4'*`P1'.`P1'/`P7'.`P7'
      +mncx2*`P1'.`P1'*`P8'.`P8'/`P2'.`P2'
      -mncx2*`P3'.`P3'*`P1'.`P1'/`P2'.`P2'
    )/(mncx1-1);
label 3;
while ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'^2/`P4'.`P4'
    /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8') > 0 )
  id  1/`P1'.`P1'^mncx1?/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?
    /`P4'.`P4'^mncx4?/`P5'.`P5'^mncx5?/`P6'.`P6'^mncx6?
    /`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? = 
    1/`P1'.`P1'^mncx1/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3
    /`P4'.`P4'^mncx4/`P5'.`P5'^mncx5/`P6'.`P6'^mncx6
    /`P7'.`P7'^mncx7/`P8'.`P8'^mncx8/`Q'.`Q'*(
      +acc(2*mncx4+2*mncx5+mncx2+mncx3+2*mncx7+mncx8-9+4*ep)*`P3'.`P3'
      +acc(mncx3-1)*`P4'.`P4'
      +mncx8*`P5'.`P5'*`P3'.`P3'/`P8'.`P8'
      -mncx8*`P6'.`P6'*`P3'.`P3'/`P8'.`P8'
      +mncx2*`P3'.`P3'*`P7'.`P7'/`P2'.`P2'
      -mncx2*`P1'.`P1'*`P3'.`P3'/`P2'.`P2'
    )/(mncx3-1);
label 4;
while ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'^2
    /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8') > 0 )
  id  1/`P1'.`P1'^mncx1?/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?
    /`P4'.`P4'^mncx4?/`P5'.`P5'^mncx5?/`P6'.`P6'^mncx6?
    /`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? = 
    1/`P1'.`P1'^mncx1/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3
    /`P4'.`P4'^mncx4/`P5'.`P5'^mncx5/`P6'.`P6'^mncx6
    /`P7'.`P7'^mncx7/`P8'.`P8'^mncx8/`Q'.`Q'*(
      +acc(2*mncx3+2*mncx2+mncx5+mncx4+2*mncx8+mncx7-9+4*ep)*`P4'.`P4'
      +acc(mncx4-1)*`P3'.`P3'
      +mncx7*`P2'.`P2'*`P4'.`P4'/`P7'.`P7'
      -mncx7*`P1'.`P1'*`P4'.`P4'/`P7'.`P7'
      +mncx5*`P4'.`P4'*`P8'.`P8'/`P5'.`P5'
      -mncx5*`P6'.`P6'*`P4'.`P4'/`P5'.`P5'
    )/(mncx4-1);
*
*   Now we have that in the 'active terms' the powers of `P1'.`P1', `P3'.`P3',
*   `P4'.`P4' and `P6'.`P6' is 1 and the power of `Q'.`P2' is zero.
*   The final recursion is for lines that don't touch the outside.
*
*   Remark: it seems better to combine this recursion more directly
*   with the above recursions.This can give:
*   1: 5 a: mncx7=mncx8=1 b: mncx7>1,mncx8=1 c: mncx7=1,mncx8>1 d: mncx7>1,mncx8>1
*   2: 2 mncx5=1 ( a: mncx7=mncx8=1 b: mncx7>1,mncx8=1 c: mncx7=1,mncx8>1 d: mncx7>1,mncx8>1 )
*   3: 8 mncx2=mncx5=1
*   4: 7 mncx2=mncx5=mncx8=1
*
if ( count(`P2'.`P2',-1,`P5'.`P5',-1,`P7'.`P7',-1,`P8'.`P8',-1) > `INNOTABL' );
while ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
    /`P5'.`P5'^2/`P6'.`P6'/`P7'.`P7'/`P8'.`P8') > 0 );
  id  1/`P1'.`P1'^mncx1?/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?
    /`P4'.`P4'^mncx4?/`P5'.`P5'^mncx5?/`P6'.`P6'^mncx6?
    /`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? = 
    1/`P1'.`P1'^mncx1/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3
    /`P4'.`P4'^mncx4/`P5'.`P5'^mncx5/`P6'.`P6'^mncx6
    /`P7'.`P7'^mncx7/`P8'.`P8'^mncx8*(
      +acc(mncx1+mncx2+mncx3+mncx4+mncx5+mncx6+mncx7+mncx8-8+4*ep)*(
        +acc(2*mncx1+2*mncx2+2*mncx3+mncx4+2*mncx5+mncx6+2*mncx7+2*mncx8-14+6*ep)
        +mncx4*`P3'.`P3'/`P4'.`P4'+mncx6*`P1'.`P1'/`P6'.`P6'
      )*`P5'.`P5'/`Q'.`Q'
      +acc(mncx5-1)*mncx4*`P7'.`P7'/`P4'.`P4'
      +acc(mncx5-1)*mncx6*`P8'.`P8'/`P6'.`P6'
      -acc(mncx1+mncx2+mncx3+mncx4+2*mncx5+mncx6+mncx7+mncx8-9+4*ep)*mncx4*`P5'.`P5'/`P4'.`P4'
      -acc(mncx1+mncx2+mncx3+mncx4+2*mncx5+mncx6+mncx7+mncx8-9+4*ep)*mncx6*`P5'.`P5'/`P6'.`P6'
    )/(mncx5-1)*mncdeno(mncx4+mncx6+2*mncx5-4,2);
  if ( count(`P4'.`P4',1) < -1 ) goto 4;
  if ( count(`P6'.`P6',1) < -1 ) goto 6;
  if ( count(`P2'.`P2',-1,`P5'.`P5',-1,`P7'.`P7',-1,`P8'.`P8',-1)
     <= `INNOTABL' ) goto 9;
endwhile;

while ( match(1/`P1'.`P1'/`P2'.`P2'^2/`P3'.`P3'/`P4'.`P4'
    /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8') > 0 );
  id  1/`P1'.`P1'^mncx1?/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?
    /`P4'.`P4'^mncx4?/`P5'.`P5'^mncx5?/`P6'.`P6'^mncx6?
    /`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? = 
    1/`P1'.`P1'^mncx1/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3
    /`P4'.`P4'^mncx4/`P5'.`P5'^mncx5/`P6'.`P6'^mncx6
    /`P7'.`P7'^mncx7/`P8'.`P8'^mncx8*(
      +acc(mncx1+mncx2+mncx3+mncx4+mncx5+mncx6+mncx7+mncx8-8+4*ep)*(
        +acc(2*mncx6+2*mncx2+2*mncx4+mncx3+2*mncx5+mncx1+2*mncx7+2*mncx8-14+6*ep)
        +mncx3*`P4'.`P4'/`P3'.`P3'+mncx1*`P6'.`P6'/`P1'.`P1'
      )*`P2'.`P2'/`Q'.`Q'
      +acc(mncx2-1)*mncx3*`P8'.`P8'/`P3'.`P3'
      +acc(mncx2-1)*mncx1*`P7'.`P7'/`P1'.`P1'
      -acc(mncx1+mncx5+mncx3+mncx4+2*mncx2+mncx6+mncx7+mncx8-9+4*ep)*mncx3*`P2'.`P2'/`P3'.`P3'
      -acc(mncx1+mncx5+mncx3+mncx4+2*mncx2+mncx6+mncx7+mncx8-9+4*ep)*mncx1*`P2'.`P2'/`P1'.`P1'
    )/(mncx2-1)*mncdeno(mncx3+mncx1+2*mncx2-4,2);
  if ( count(`P3'.`P3',1) < -1 ) goto 3;
  if ( count(`P1'.`P1',1) < -1 ) goto 1;
  if ( count(`P2'.`P2',-1,`P5'.`P5',-1,`P7'.`P7',-1,`P8'.`P8',-1)
     <= `INNOTABL' ) goto 9;
endwhile;

while ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
    /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8'^2) > 0 );
  id  1/`P1'.`P1'^mncx1?/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?
    /`P4'.`P4'^mncx4?/`P5'.`P5'^mncx5?/`P6'.`P6'^mncx6?
    /`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? = 
    1/`P1'.`P1'^mncx1/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3
    /`P4'.`P4'^mncx4/`P5'.`P5'^mncx5/`P6'.`P6'^mncx6
    /`P7'.`P7'^mncx7/`P8'.`P8'^mncx8*(
      +acc(mncx1+mncx2+mncx3+mncx4+mncx5+mncx6+mncx7+mncx8-8+4*ep)*(
        +acc(2*mncx1+2*mncx2+2*mncx4+mncx3+2*mncx5+mncx6+2*mncx7+2*mncx8-14+6*ep)
        +mncx3*`P4'.`P4'/`P3'.`P3'+mncx6*`P1'.`P1'/`P6'.`P6'
      )*`P8'.`P8'/`Q'.`Q'
      +acc(mncx8-1)*mncx3*`P2'.`P2'/`P3'.`P3'
      +acc(mncx8-1)*mncx6*`P5'.`P5'/`P6'.`P6'
      -acc(mncx1+mncx2+mncx3+mncx4+2*mncx8+mncx6+mncx7+mncx5-9+4*ep)*mncx3*`P8'.`P8'/`P3'.`P3'
      -acc(mncx1+mncx2+mncx3+mncx4+2*mncx8+mncx6+mncx7+mncx5-9+4*ep)*mncx6*`P8'.`P8'/`P6'.`P6'
    )/(mncx8-1)*mncdeno(mncx3+mncx6+2*mncx8-4,2);
  if ( count(`P3'.`P3',1) < -1 ) goto 3;
  if ( count(`P6'.`P6',1) < -1 ) goto 6;
  if ( count(`P2'.`P2',-1,`P5'.`P5',-1,`P7'.`P7',-1,`P8'.`P8',-1)
     <= `INNOTABL' ) goto 9;
endwhile;

while ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
    /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'^2/`P8'.`P8') > 0 );
  id  1/`P1'.`P1'^mncx1?/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?
    /`P4'.`P4'^mncx4?/`P5'.`P5'^mncx5?/`P6'.`P6'^mncx6?
    /`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? = 
    1/`P1'.`P1'^mncx1/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3
    /`P4'.`P4'^mncx4/`P5'.`P5'^mncx5/`P6'.`P6'^mncx6
    /`P7'.`P7'^mncx7/`P8'.`P8'^mncx8*(
      +acc(mncx1+mncx2+mncx3+mncx4+mncx5+mncx6+mncx7+mncx8-8+4*ep)*(
        +acc(2*mncx6+2*mncx2+2*mncx3+mncx4+2*mncx5+mncx1+2*mncx7+2*mncx8-14+6*ep)
        +mncx4*`P3'.`P3'/`P4'.`P4'+mncx1*`P6'.`P6'/`P1'.`P1'
      )*`P7'.`P7'/`Q'.`Q'
      +acc(mncx7-1)*mncx4*`P5'.`P5'/`P4'.`P4'
      +acc(mncx7-1)*mncx1*`P2'.`P2'/`P1'.`P1'
      -acc(mncx1+mncx5+mncx3+mncx4+2*mncx7+mncx6+mncx2+mncx8-9+4*ep)*mncx4*`P7'.`P7'/`P4'.`P4'
      -acc(mncx1+mncx5+mncx3+mncx4+2*mncx7+mncx6+mncx2+mncx8-9+4*ep)*mncx1*`P7'.`P7'/`P1'.`P1'
    )/(mncx7-1)*mncdeno(mncx4+mncx1+2*mncx7-4,2);
  if ( count(`P4'.`P4',1) < -1 ) goto 4;
  if ( count(`P1'.`P1',1) < -1 ) goto 1;
  if ( count(`P2'.`P2',-1,`P5'.`P5',-1,`P7'.`P7',-1,`P8'.`P8',-1)
     <= `INNOTABL' ) goto 9;
endwhile;
endif;
label 9;
*
*	Here we take those integrals that have been tabulated
*
if ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
     /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8') );
	if ( count(`P2'.`P2',1) > count(`P5'.`P5',1) )
		multiply replace_(`P2',`P5',`P5',`P2');
	if ( count(`P7'.`P7',1) > count(`P8'.`P8',1) )
		multiply replace_(`P7',`P8',`P8',`P7');
	if ( ( count(`P2'.`P2',1) > count(`P7'.`P7',1) )
	|| ( ( count(`P2'.`P2',1) == count(`P7'.`P7',1) )
	  && ( count(`P8'.`P8',1) > count(`P5'.`P5',1) ) ) )
		multiply replace_(`P2',`P7',`P7',`P2',`P8',`P5',`P5',`P8');
	if ( ( count(`P2'.`P2',1) > count(`P8'.`P8',1) )
	|| ( ( count(`P2'.`P2',1) == count(`P8'.`P8',1) )
	  && ( count(`P7'.`P7',1) > count(`P5'.`P5',1) ) ) )
		multiply replace_(`P2',`P8',`P8',`P2',`P7',`P5',`P5',`P7');
	if ( count(`P2'.`P2',1) > count(`P5'.`P5',1) )
		multiply replace_(`P2',`P5',`P5',`P2');
	if ( count(`P7'.`P7',1) > count(`P8'.`P8',1) )
		multiply replace_(`P7',`P8',`P8',`P7');
  id `INTS'/`P1'.`P1'/`P2'.`P2'^mncx2?/`P3'.`P3'/`P4'.`P4'
           /`P5'.`P5'^mncx5?/`P6'.`P6'/`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? =
           mncnoptab(mncx2,mncx7,mncx8,mncx5)*mnceq^3/`Q'.`Q'^(mncx2+mncx5+mncx7+mncx8-2);
endif;
*
*   The value will only be substituted when the routine subint is
*   invoked. This way we can keep an eye on the accuracy of the calculation.
*
id  mncdeno(0,mncx1?) = 1/mncx1/ep;
id  mncdeno(mncx1?,mncx2?) = mncaccm(1+ep*mncx2/mncx1)/mncx1;
repeat id mncaccm(mncx1?)*mncaccm(mncx2?) = mncaccm(mncx1*mncx2);
id  mncaccm(mncx1?) = mncaccm(mncx1-1);
id  mncaccm(mncx1?) = mncaccm(mncx1-mncx1^2,mncx1^3);
id  mncaccm(mncx1?,mncx2?) = acc(1-mncx1-mncx2+mncx2*mncx1+mncx2^2);
*
#endprocedure
*--#] newplane : 
*--#[ newtwo :
#procedure newtwo(P1,E1,P2,E2,P3,E3,P4,E4,P5,E5,Q,EQ,REDUCTION,INTS)
*
*   Newer way to do two loop integrals.
*   The case with the ep power on the outside can be done
*   with the resolved triangle and the part with the ep on the
*   inside and all other powers one is done with a table.
*   This leaves only one type of explicit recursion. We deal
*   with them by making powers equal to 1 as quickly as possible
*   so that in the next recursion they may get killed. It isn't
*   clear whether this is the best strategy.
*
#if ( `REDUCTION' > 0 )
  id  `P4'.mncp?!{`P4'} = `P1'.mncp-`Q'.mncp;
  id  `P3'.mncp?!{`P3'} = `P2'.mncp-`Q'.mncp;
  id  `P5'.mncp?!{`P5'} = `P1'.mncp-`P2'.mncp;
  #call ACCU(Two loop momenta)
  id  `P1'.`Q' = `P1'.`P1'/2+`Q'.`Q'/2-`P4'.`P4'/2;
  id  `P2'.`Q' = `P2'.`P2'/2+`Q'.`Q'/2-`P3'.`P3'/2;
  id  `P1'.`P2' = `P1'.`P1'/2+`P2'.`P2'/2-`P5'.`P5'/2;
  #call ACCU(Two loop scalars)
#endif

if ( count(`E5',1) == 1 );
  repeat;
    if ( match(`E5'/`P1'.`P1'^2/`P4'.`P4'^2/`P2'.`P2'/`P3'.`P3') );
      id  1/`P1'.`P1'^mncx1?/`P4'.`P4'^mncx4?/`P5'.`P5'^mncx5?*`E5' =
        1/`P1'.`P1'^mncx1/`P4'.`P4'^mncx4/`P5'.`P5'^mncx5*`E5' * (
          +acc(ep+mncx5)*acc(1-2*ep-mncx5)/(mncx1-1)/(mncx4-1)*
                 `P1'.`P1'*`P4'.`P4'/`P5'.`P5'/`Q'.`Q'
          +acc(mncx1+mncx4-3+ep)/(mncx1-1)*`P1'.`P1'/`Q'.`Q'
          +acc(mncx1+mncx4-3+ep)/(mncx4-1)*`P4'.`P4'/`Q'.`Q'
        );
    endif;
  endrepeat;
  repeat;
    if ( match(`E5'/`P1'.`P1'/`P4'.`P4'/`P2'.`P2'^2/`P3'.`P3'^2) );
      id  1/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?/`P5'.`P5'^mncx5?*`E5' =
        1/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3/`P5'.`P5'^mncx5*`E5' * (
          +acc(ep+mncx5)*acc(1-2*ep-mncx5)/(mncx2-1)/(mncx3-1)*
                 `P2'.`P2'*`P3'.`P3'/`P5'.`P5'/`Q'.`Q'
          +acc(mncx2+mncx3-3+ep)/(mncx2-1)*`P2'.`P2'/`Q'.`Q'
          +acc(mncx2+mncx3-3+ep)/(mncx3-1)*`P3'.`P3'/`Q'.`Q'
        );
    endif;
  endrepeat;
endif;

#call ACCU(Reduction 2 loops)

if ( count(`E5',1) == 0 );
  if ( count(`E2',1,`E3',1) == 0 );
    if ( ( match(1/`P2'.`P2'/`P3'.`P3'/`P5'.`P5') > 0 )
	&& ( ( count(`E1',1) > 0 ) || ( count(`P1'.`P1',1) < 0 ) )
	&& ( ( count(`E4',1) > 0 ) || ( count(`P4'.`P4',1) < 0 ) ) );
      #call triangl2(`P5',`P1',`P4',`P2',`P3',`E1',`E4')
    endif;
  else;
    if ( ( match(1/`P1'.`P1'/`P4'.`P4'/`P5'.`P5') > 0 )
	&& ( ( count(`E2',1) > 0 ) || ( count(`P2'.`P2',1) < 0 ) )
	&& ( ( count(`E3',1) > 0 ) || ( count(`P3'.`P3',1) < 0 ) ) );
      #call triangl2(`P5',`P2',`P3',`P1',`P4',`E2',`E3')
    endif;
  endif;
else;
  repeat;
    if ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4') > 0 );
      if ( count(`P1'.`P1',1) < count(`P4'.`P4',1) );
        multiply replace_(`P1',`P4',`P4',`P1',`P2',`P3',`P3',`P2');
      endif;
      if ( count(`P3'.`P3',1) < count(`P4'.`P4',1) );
        multiply replace_(`P3',`P4',`P4',`P3',`P2',`P1',`P1',`P2');
        if ( count(`P1'.`P1',1) < count(`P4'.`P4',1) );
          multiply replace_(`P1',`P4',`P4',`P1',`P2',`P3',`P3',`P2');
        endif;
      else;
        if ( count(`P2'.`P2',1) < count(`P4'.`P4',1) );
          multiply replace_(`P2',`P4',`P4',`P2',`P3',`P1',`P1',`P3');
        endif;
      endif;
      if ( count(`P4'.`P4',1) < -1 );
        id 1/`P1'.`P1'^mncx1?/`P4'.`P4'^mncx4?*`E5'^mncy5?/`P5'.`P5'^mncx5? =
           1/`P1'.`P1'^mncx1/`P4'.`P4'^mncx4*`E5'^mncy5/`P5'.`P5'^mncx5*(
             +acc((2*mncx1+mncx4+mncx5+mncy5*ep-5+2*ep)/(mncx4-1))*`P4'.`P4'
             +`P1'.`P1'
             +acc((mncx5+mncy5*ep)/(mncx4-1))*`P1'.`P1'*`P4'.`P4'/`P5'.`P5'
             -acc((mncx5+mncy5*ep)/(mncx4-1))*`P2'.`P2'*`P4'.`P4'/`P5'.`P5'
           )/`Q'.`Q';
      endif;
    endif;
  endrepeat;
  if ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4') > 0 );
*
*   Here we substitute from the table
*
    id `INTS'/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'*`E5'/`P5'.`P5'^mncx5? =
       mncTabTwo(mncx5)*`EQ'^3/`Q'.`Q'^mncx5;
  endif;
endif;
#endprocedure
*--#] newtwo : 
*--#[ noplane :
#procedure noplane(P1,P2,P3,P4,P5,P6,P7,P8,Q,INTS)
*
*   Reduction procedure for three loop graphs of the NO or nonplanar type.
*   Notation is from S.G.Gorishny et.al. Comp.Phys.Comm 55(1989)381
*
*                     /-<------<-----<-\
*                 P1 /     \  P2   /    \ P3
*                   /       v     /      \
*                  /      P7 \   /        \
*                 /           \ /          \
*          Q --<--             /            --<-- Q
*                 \           / \          /
*                  \      P8 /   \        / 
*                   \       ^     \      /
*                 P6 \     /  P5   \    / P4
*                     \->------>----->-/
*
*   Express everything in powers of pi.pi, Q.Q and p2.Q;
*   The only difficult relation here is the one for p1.p3
*   It is derived by squaring:
*   p1-p3 = p6-p4 = p5+p8-p4
*   and p2-Q = p4+p8
*
*  id  `P5'.P?!{`P5'} = `P6'.P-`P8'.P;
*  id  `P4'.P?!{`P4'} = `P3'.P-Q.P;
*#call ACCU(moms 1)
*  id  `P6'.P?!{`P6'} = `P1'.P-Q.P;
*#call ACCU(moms 2)
*  id  `P7'.P?!{`P7'} = `P2'.P-`P1'.P;
*#call ACCU(moms 3)
*  id  `P8'.P?!{`P8'} = `P2'.P-`P3'.P;
*#call ACCU(moms 4)
  id  `P1'.`Q' = `P1'.`P1'/2+`Q'.`Q'/2-`P6'.`P6'/2;
#call ACCU(dots 1)
  id  `P3'.`Q' = `P3'.`P3'/2+`Q'.`Q'/2-`P4'.`P4'/2;
#call ACCU(dots 2)
  id  `P1'.`P2' = `P1'.`P1'/2+`P2'.`P2'/2-`P7'.`P7'/2;
#call ACCU(dots 3)
  id  `P3'.`P2' = `P3'.`P3'/2+`P2'.`P2'/2-`P8'.`P8'/2;
#call ACCU(dots 4)
  id `P1'.`P3' = -`P2'.`Q'+`P1'.`P1'/2+`P2'.`P2'/2+`P3'.`P3'/2+`P5'.`P5'/2
                 +`Q'.`Q'/2-`P4'.`P4'/2-`P6'.`P6'/2-`P7'.`P7'/2-`P8'.`P8'/2;
#call ACCU(dots 5)
*
*   First step: eliminate the powers of `Q'.`P2'
*   Equation 3.18 hasn't been checked yet.
*   Note how common factors are kept together in acc till the end.
*   This trick allows us to do an 'intermediate sort' in the argument
*   of acc, thereby making in the end only the terms that are necessary.
*
while ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
  /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8'*`Q'.`P2') > 0 )
  id  1/`P1'.`P1'^mncx1?/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?
    /`P4'.`P4'^mncx4?/`P5'.`P5'^mncx5?/`P6'.`P6'^mncx6?
    /`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8?*`Q'.`P2'^mncx9? = 
    1/`P1'.`P1'^mncx1/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3
    /`P4'.`P4'^mncx4/`P5'.`P5'^mncx5/`P6'.`P6'^mncx6
    /`P7'.`P7'^mncx7/`P8'.`P8'^mncx8*`Q'.`P2'^mncx9*`Q'.`Q'/`Q'.`P2'/2*(
      +acc(3-2*mncx2-mncx1-mncx3+mncx9-2*ep)
      +mncx1*`P7'.`P7'/`P1'.`P1'-mncx1*`P2'.`P2'/`P1'.`P1'
      +mncx3*`P8'.`P8'/`P3'.`P3'-mncx3*`P2'.`P2'/`P3'.`P3'
      +2*acc(mncx9-1)*`P2'.`P2'/`Q'.`P2'/2
    )*mncdeno(7-mncx1-mncx2-mncx3-mncx4-mncx5-mncx6-mncx7-mncx8+mncx9,-4);
#ifdef `LONGINT'
id  mncdeno(0,-4) = -1/4/ep;
id  mncdeno(mncx1?,-4) = mncaccm(1-4*ep/mncx1)/mncx1;
repeat id mncaccm(mncx1?)*mncaccm(mncx2?) = mncaccm(mncx1*mncx2);
id  mncaccm(mncx1?) = mncaccm(mncx1-1);
id  mncaccm(mncx1?) = mncaccm(mncx1-mncx1^2,mncx1^3);
id  mncaccm(mncx1?,mncx2?) = acc(1-mncx1-mncx2+mncx2*mncx1+mncx2^2);
repeat id acc(mncx1?)*acc(mncx2?) = acc(mncx1*mncx2);
#endif
#call ACCU(Eliminate `Q'.`P2')
*
*   Next are four recursions that reduce the powers of the propagators
*   that connect to `Q' to 1.
*
#ifdef `LONGINT'
label 6;
while ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
  /`P5'.`P5'/`P6'.`P6'^2/`P7'.`P7'/`P8'.`P8') > 0 )
  id  1/`P1'.`P1'^mncx1?/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?
    /`P4'.`P4'^mncx4?/`P5'.`P5'^mncx5?/`P6'.`P6'^mncx6?
    /`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? = 
    1/`P1'.`P1'^mncx1/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3
    /`P4'.`P4'^mncx4/`P5'.`P5'^mncx5/`P6'.`P6'^mncx6
    /`P7'.`P7'^mncx7/`P8'.`P8'^mncx8/`Q'.`Q'*(
      +acc(2*mncx1+2*mncx2+mncx5+mncx6+2*mncx7+mncx8-9+4*ep)*`P6'.`P6'
      +acc(mncx6-1)*`P1'.`P1'
      +mncx8*`P2'.`P2'*`P6'.`P6'/`P8'.`P8'
      -mncx8*`P3'.`P3'*`P6'.`P6'/`P8'.`P8'
      +mncx5*`P6'.`P6'*`P7'.`P7'/`P5'.`P5'
      -mncx5*`P4'.`P4'*`P6'.`P6'/`P5'.`P5'
    )/(mncx6-1);
label 1;
while ( match(1/`P1'.`P1'^2/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
    /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8') > 0 )
  id  1/`P1'.`P1'^mncx1?/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?
    /`P4'.`P4'^mncx4?/`P5'.`P5'^mncx5?/`P6'.`P6'^mncx6?
    /`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? = 
    1/`P1'.`P1'^mncx1/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3
    /`P4'.`P4'^mncx4/`P5'.`P5'^mncx5/`P6'.`P6'^mncx6
    /`P7'.`P7'^mncx7/`P8'.`P8'^mncx8/`Q'.`Q'*(
      +acc(2*mncx6+2*mncx5+mncx2+mncx1+2*mncx8+mncx7-9+4*ep)*`P1'.`P1'
      +acc(mncx1-1)*`P6'.`P6'
      +mncx7*`P5'.`P5'*`P1'.`P1'/`P7'.`P7'
      -mncx7*`P4'.`P4'*`P1'.`P1'/`P7'.`P7'
      +mncx2*`P1'.`P1'*`P8'.`P8'/`P2'.`P2'
      -mncx2*`P3'.`P3'*`P1'.`P1'/`P2'.`P2'
    )/(mncx1-1);
label 3;
while ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'^2/`P4'.`P4'
    /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8') > 0 )
  id  1/`P1'.`P1'^mncx1?/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?
    /`P4'.`P4'^mncx4?/`P5'.`P5'^mncx5?/`P6'.`P6'^mncx6?
    /`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? = 
    1/`P1'.`P1'^mncx1/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3
    /`P4'.`P4'^mncx4/`P5'.`P5'^mncx5/`P6'.`P6'^mncx6
    /`P7'.`P7'^mncx7/`P8'.`P8'^mncx8/`Q'.`Q'*(
      +acc(2*mncx4+2*mncx5+mncx2+mncx3+2*mncx7+mncx8-9+4*ep)*`P3'.`P3'
      +acc(mncx3-1)*`P4'.`P4'
      +mncx8*`P5'.`P5'*`P3'.`P3'/`P8'.`P8'
      -mncx8*`P6'.`P6'*`P3'.`P3'/`P8'.`P8'
      +mncx2*`P3'.`P3'*`P7'.`P7'/`P2'.`P2'
      -mncx2*`P1'.`P1'*`P3'.`P3'/`P2'.`P2'
    )/(mncx3-1);
label 4;
while ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'^2
    /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8') > 0 )
  id  1/`P1'.`P1'^mncx1?/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?
    /`P4'.`P4'^mncx4?/`P5'.`P5'^mncx5?/`P6'.`P6'^mncx6?
    /`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? = 
    1/`P1'.`P1'^mncx1/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3
    /`P4'.`P4'^mncx4/`P5'.`P5'^mncx5/`P6'.`P6'^mncx6
    /`P7'.`P7'^mncx7/`P8'.`P8'^mncx8/`Q'.`Q'*(
      +acc(2*mncx3+2*mncx2+mncx5+mncx4+2*mncx8+mncx7-9+4*ep)*`P4'.`P4'
      +acc(mncx4-1)*`P3'.`P3'
      +mncx7*`P2'.`P2'*`P4'.`P4'/`P7'.`P7'
      -mncx7*`P1'.`P1'*`P4'.`P4'/`P7'.`P7'
      +mncx5*`P4'.`P4'*`P8'.`P8'/`P5'.`P5'
      -mncx5*`P6'.`P6'*`P4'.`P4'/`P5'.`P5'
    )/(mncx4-1);
id  mncdeno(0,mncx1?) = 1/mncx1/ep;
id  mncdeno(mncx1?,mncx2?) = mncaccm(1+ep*mncx2/mncx1)/mncx1;
repeat id mncaccm(mncx1?)*mncaccm(mncx2?) = mncaccm(mncx1*mncx2);
id  mncaccm(mncx1?) = mncaccm(mncx1-1);
id  mncaccm(mncx1?) = mncaccm(mncx1-mncx1^2,mncx1^3);
id  mncaccm(mncx1?,mncx2?) = acc(1-mncx1-mncx2+mncx2*mncx1+mncx2^2);
repeat id acc(mncx1?)*acc(mncx2?) = acc(mncx1*mncx2);
#call ACCU(Preparation)
#endif
label 6;
while ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
  /`P5'.`P5'/`P6'.`P6'^2/`P7'.`P7'/`P8'.`P8') > 0 )
  id  1/`P1'.`P1'^mncx1?/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?
    /`P4'.`P4'^mncx4?/`P5'.`P5'^mncx5?/`P6'.`P6'^mncx6?
    /`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? = 
    1/`P1'.`P1'^mncx1/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3
    /`P4'.`P4'^mncx4/`P5'.`P5'^mncx5/`P6'.`P6'^mncx6
    /`P7'.`P7'^mncx7/`P8'.`P8'^mncx8/`Q'.`Q'*(
      +acc(2*mncx1+2*mncx2+mncx5+mncx6+2*mncx7+mncx8-9+4*ep)*`P6'.`P6'
      +acc(mncx6-1)*`P1'.`P1'
      +mncx8*`P2'.`P2'*`P6'.`P6'/`P8'.`P8'
      -mncx8*`P3'.`P3'*`P6'.`P6'/`P8'.`P8'
      +mncx5*`P6'.`P6'*`P7'.`P7'/`P5'.`P5'
      -mncx5*`P4'.`P4'*`P6'.`P6'/`P5'.`P5'
    )/(mncx6-1);
label 1;
while ( match(1/`P1'.`P1'^2/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
    /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8') > 0 )
  id  1/`P1'.`P1'^mncx1?/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?
    /`P4'.`P4'^mncx4?/`P5'.`P5'^mncx5?/`P6'.`P6'^mncx6?
    /`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? = 
    1/`P1'.`P1'^mncx1/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3
    /`P4'.`P4'^mncx4/`P5'.`P5'^mncx5/`P6'.`P6'^mncx6
    /`P7'.`P7'^mncx7/`P8'.`P8'^mncx8/`Q'.`Q'*(
      +acc(2*mncx6+2*mncx5+mncx2+mncx1+2*mncx8+mncx7-9+4*ep)*`P1'.`P1'
      +acc(mncx1-1)*`P6'.`P6'
      +mncx7*`P5'.`P5'*`P1'.`P1'/`P7'.`P7'
      -mncx7*`P4'.`P4'*`P1'.`P1'/`P7'.`P7'
      +mncx2*`P1'.`P1'*`P8'.`P8'/`P2'.`P2'
      -mncx2*`P3'.`P3'*`P1'.`P1'/`P2'.`P2'
    )/(mncx1-1);
label 3;
while ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'^2/`P4'.`P4'
    /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8') > 0 )
  id  1/`P1'.`P1'^mncx1?/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?
    /`P4'.`P4'^mncx4?/`P5'.`P5'^mncx5?/`P6'.`P6'^mncx6?
    /`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? = 
    1/`P1'.`P1'^mncx1/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3
    /`P4'.`P4'^mncx4/`P5'.`P5'^mncx5/`P6'.`P6'^mncx6
    /`P7'.`P7'^mncx7/`P8'.`P8'^mncx8/`Q'.`Q'*(
      +acc(2*mncx4+2*mncx5+mncx2+mncx3+2*mncx7+mncx8-9+4*ep)*`P3'.`P3'
      +acc(mncx3-1)*`P4'.`P4'
      +mncx8*`P5'.`P5'*`P3'.`P3'/`P8'.`P8'
      -mncx8*`P6'.`P6'*`P3'.`P3'/`P8'.`P8'
      +mncx2*`P3'.`P3'*`P7'.`P7'/`P2'.`P2'
      -mncx2*`P1'.`P1'*`P3'.`P3'/`P2'.`P2'
    )/(mncx3-1);
label 4;
while ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'^2
    /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8') > 0 )
  id  1/`P1'.`P1'^mncx1?/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?
    /`P4'.`P4'^mncx4?/`P5'.`P5'^mncx5?/`P6'.`P6'^mncx6?
    /`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? = 
    1/`P1'.`P1'^mncx1/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3
    /`P4'.`P4'^mncx4/`P5'.`P5'^mncx5/`P6'.`P6'^mncx6
    /`P7'.`P7'^mncx7/`P8'.`P8'^mncx8/`Q'.`Q'*(
      +acc(2*mncx3+2*mncx2+mncx5+mncx4+2*mncx8+mncx7-9+4*ep)*`P4'.`P4'
      +acc(mncx4-1)*`P3'.`P3'
      +mncx7*`P2'.`P2'*`P4'.`P4'/`P7'.`P7'
      -mncx7*`P1'.`P1'*`P4'.`P4'/`P7'.`P7'
      +mncx5*`P4'.`P4'*`P8'.`P8'/`P5'.`P5'
      -mncx5*`P6'.`P6'*`P4'.`P4'/`P5'.`P5'
    )/(mncx4-1);
*
*   Now we have that in the 'active terms' the powers of `P1'.`P1', `P3'.`P3',
*   `P4'.`P4' and `P6'.`P6' is 1 and the power of `Q'.`P2' is zero.
*   The final recursion is for lines that don't touch the outside.
*
*   Remark: it seems better to combine this recursion more directly
*   with the above recursions.This can give:
*   1: 5 a: mncx7=mncx8=1 b: mncx7>1,mncx8=1 c: mncx7=1,mncx8>1 d: mncx7>1,mncx8>1
*   2: 2 mncx5=1 ( a: mncx7=mncx8=1 b: mncx7>1,mncx8=1 c: mncx7=1,mncx8>1 d: mncx7>1,mncx8>1 )
*   3: 8 mncx2=mncx5=1
*   4: 7 mncx2=mncx5=mncx8=1
*
if ( count(`P2'.`P2',-1,`P5'.`P5',-1,`P7'.`P7',-1,`P8'.`P8',-1) > `INNOTABL' );
while ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
    /`P5'.`P5'^2/`P6'.`P6'/`P7'.`P7'/`P8'.`P8') > 0 );
  id  1/`P1'.`P1'^mncx1?/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?
    /`P4'.`P4'^mncx4?/`P5'.`P5'^mncx5?/`P6'.`P6'^mncx6?
    /`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? = 
    1/`P1'.`P1'^mncx1/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3
    /`P4'.`P4'^mncx4/`P5'.`P5'^mncx5/`P6'.`P6'^mncx6
    /`P7'.`P7'^mncx7/`P8'.`P8'^mncx8*(
      +acc(mncx1+mncx2+mncx3+mncx4+mncx5+mncx6+mncx7+mncx8-8+4*ep)*(
        +acc(2*mncx1+2*mncx2+2*mncx3+mncx4+2*mncx5+mncx6+2*mncx7+2*mncx8-14+6*ep)
        +mncx4*`P3'.`P3'/`P4'.`P4'+mncx6*`P1'.`P1'/`P6'.`P6'
      )*`P5'.`P5'/`Q'.`Q'
      +acc(mncx5-1)*mncx4*`P7'.`P7'/`P4'.`P4'
      +acc(mncx5-1)*mncx6*`P8'.`P8'/`P6'.`P6'
      -acc(mncx1+mncx2+mncx3+mncx4+2*mncx5+mncx6+mncx7+mncx8-9+4*ep)*mncx4*`P5'.`P5'/`P4'.`P4'
      -acc(mncx1+mncx2+mncx3+mncx4+2*mncx5+mncx6+mncx7+mncx8-9+4*ep)*mncx6*`P5'.`P5'/`P6'.`P6'
    )/(mncx5-1)*mncdeno(mncx4+mncx6+2*mncx5-4,2);
  if ( count(`P4'.`P4',1) < -1 ) goto 4;
  if ( count(`P6'.`P6',1) < -1 ) goto 6;
  if ( count(`P2'.`P2',-1,`P5'.`P5',-1,`P7'.`P7',-1,`P8'.`P8',-1)
     <= `INNOTABL' ) goto 9;
endwhile;

while ( match(1/`P1'.`P1'/`P2'.`P2'^2/`P3'.`P3'/`P4'.`P4'
    /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8') > 0 );
  id  1/`P1'.`P1'^mncx1?/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?
    /`P4'.`P4'^mncx4?/`P5'.`P5'^mncx5?/`P6'.`P6'^mncx6?
    /`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? = 
    1/`P1'.`P1'^mncx1/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3
    /`P4'.`P4'^mncx4/`P5'.`P5'^mncx5/`P6'.`P6'^mncx6
    /`P7'.`P7'^mncx7/`P8'.`P8'^mncx8*(
      +acc(mncx1+mncx2+mncx3+mncx4+mncx5+mncx6+mncx7+mncx8-8+4*ep)*(
        +acc(2*mncx6+2*mncx2+2*mncx4+mncx3+2*mncx5+mncx1+2*mncx7+2*mncx8-14+6*ep)
        +mncx3*`P4'.`P4'/`P3'.`P3'+mncx1*`P6'.`P6'/`P1'.`P1'
      )*`P2'.`P2'/`Q'.`Q'
      +acc(mncx2-1)*mncx3*`P8'.`P8'/`P3'.`P3'
      +acc(mncx2-1)*mncx1*`P7'.`P7'/`P1'.`P1'
      -acc(mncx1+mncx5+mncx3+mncx4+2*mncx2+mncx6+mncx7+mncx8-9+4*ep)*mncx3*`P2'.`P2'/`P3'.`P3'
      -acc(mncx1+mncx5+mncx3+mncx4+2*mncx2+mncx6+mncx7+mncx8-9+4*ep)*mncx1*`P2'.`P2'/`P1'.`P1'
    )/(mncx2-1)*mncdeno(mncx3+mncx1+2*mncx2-4,2);
  if ( count(`P3'.`P3',1) < -1 ) goto 3;
  if ( count(`P1'.`P1',1) < -1 ) goto 1;
  if ( count(`P2'.`P2',-1,`P5'.`P5',-1,`P7'.`P7',-1,`P8'.`P8',-1)
     <= `INNOTABL' ) goto 9;
endwhile;

while ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
    /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8'^2) > 0 );
  id  1/`P1'.`P1'^mncx1?/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?
    /`P4'.`P4'^mncx4?/`P5'.`P5'^mncx5?/`P6'.`P6'^mncx6?
    /`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? = 
    1/`P1'.`P1'^mncx1/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3
    /`P4'.`P4'^mncx4/`P5'.`P5'^mncx5/`P6'.`P6'^mncx6
    /`P7'.`P7'^mncx7/`P8'.`P8'^mncx8*(
      +acc(mncx1+mncx2+mncx3+mncx4+mncx5+mncx6+mncx7+mncx8-8+4*ep)*(
        +acc(2*mncx1+2*mncx2+2*mncx4+mncx3+2*mncx5+mncx6+2*mncx7+2*mncx8-14+6*ep)
        +mncx3*`P4'.`P4'/`P3'.`P3'+mncx6*`P1'.`P1'/`P6'.`P6'
      )*`P8'.`P8'/`Q'.`Q'
      +acc(mncx8-1)*mncx3*`P2'.`P2'/`P3'.`P3'
      +acc(mncx8-1)*mncx6*`P5'.`P5'/`P6'.`P6'
      -acc(mncx1+mncx2+mncx3+mncx4+2*mncx8+mncx6+mncx7+mncx5-9+4*ep)*mncx3*`P8'.`P8'/`P3'.`P3'
      -acc(mncx1+mncx2+mncx3+mncx4+2*mncx8+mncx6+mncx7+mncx5-9+4*ep)*mncx6*`P8'.`P8'/`P6'.`P6'
    )/(mncx8-1)*mncdeno(mncx3+mncx6+2*mncx8-4,2);
  if ( count(`P3'.`P3',1) < -1 ) goto 3;
  if ( count(`P6'.`P6',1) < -1 ) goto 6;
  if ( count(`P2'.`P2',-1,`P5'.`P5',-1,`P7'.`P7',-1,`P8'.`P8',-1)
     <= `INNOTABL' ) goto 9;
endwhile;

while ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
    /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'^2/`P8'.`P8') > 0 );
  id  1/`P1'.`P1'^mncx1?/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?
    /`P4'.`P4'^mncx4?/`P5'.`P5'^mncx5?/`P6'.`P6'^mncx6?
    /`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? = 
    1/`P1'.`P1'^mncx1/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3
    /`P4'.`P4'^mncx4/`P5'.`P5'^mncx5/`P6'.`P6'^mncx6
    /`P7'.`P7'^mncx7/`P8'.`P8'^mncx8*(
      +acc(mncx1+mncx2+mncx3+mncx4+mncx5+mncx6+mncx7+mncx8-8+4*ep)*(
        +acc(2*mncx6+2*mncx2+2*mncx3+mncx4+2*mncx5+mncx1+2*mncx7+2*mncx8-14+6*ep)
        +mncx4*`P3'.`P3'/`P4'.`P4'+mncx1*`P6'.`P6'/`P1'.`P1'
      )*`P7'.`P7'/`Q'.`Q'
      +acc(mncx7-1)*mncx4*`P5'.`P5'/`P4'.`P4'
      +acc(mncx7-1)*mncx1*`P2'.`P2'/`P1'.`P1'
      -acc(mncx1+mncx5+mncx3+mncx4+2*mncx7+mncx6+mncx2+mncx8-9+4*ep)*mncx4*`P7'.`P7'/`P4'.`P4'
      -acc(mncx1+mncx5+mncx3+mncx4+2*mncx7+mncx6+mncx2+mncx8-9+4*ep)*mncx1*`P7'.`P7'/`P1'.`P1'
    )/(mncx7-1)*mncdeno(mncx4+mncx1+2*mncx7-4,2);
  if ( count(`P4'.`P4',1) < -1 ) goto 4;
  if ( count(`P1'.`P1',1) < -1 ) goto 1;
  if ( count(`P2'.`P2',-1,`P5'.`P5',-1,`P7'.`P7',-1,`P8'.`P8',-1)
     <= `INNOTABL' ) goto 9;
endwhile;
*
*   If we ever get here (luckily we have to do this only at the beginning
*   of the program and for rather few terms), the only interesting integral
*   left is the fundamental integral below:
*
endif;
label 9;
*
*	Here we take those integrals that have been tabulated
*
if ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
     /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8') );
	if ( count(`P2'.`P2',1) > count(`P5'.`P5',1) )
		multiply replace_(`P2',`P5',`P5',`P2');
	if ( count(`P7'.`P7',1) > count(`P8'.`P8',1) )
		multiply replace_(`P7',`P8',`P8',`P7');
	if ( ( count(`P2'.`P2',1) > count(`P7'.`P7',1) )
	|| ( ( count(`P2'.`P2',1) == count(`P7'.`P7',1) )
	  && ( count(`P8'.`P8',1) > count(`P5'.`P5',1) ) ) )
		multiply replace_(`P2',`P7',`P7',`P2',`P8',`P5',`P5',`P8');
	if ( ( count(`P2'.`P2',1) > count(`P8'.`P8',1) )
	|| ( ( count(`P2'.`P2',1) == count(`P8'.`P8',1) )
	  && ( count(`P7'.`P7',1) > count(`P5'.`P5',1) ) ) )
		multiply replace_(`P2',`P8',`P8',`P2',`P7',`P5',`P5',`P7');
	if ( count(`P2'.`P2',1) > count(`P5'.`P5',1) )
		multiply replace_(`P2',`P5',`P5',`P2');
	if ( count(`P7'.`P7',1) > count(`P8'.`P8',1) )
		multiply replace_(`P7',`P8',`P8',`P7');
  id `INTS'/`P1'.`P1'/`P2'.`P2'^mncx2?/`P3'.`P3'/`P4'.`P4'
           /`P5'.`P5'^mncx5?/`P6'.`P6'/`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? =
           mncnoptab(mncx2,mncx7,mncx8,mncx5)*mnceq^3/`Q'.`Q'^(mncx2+mncx5+mncx7+mncx8-2);
endif;
*
*   The value will only be substituted when the routine subint is
*   invoked. This way we can keep an eye on the accuracy of the calculation.
*
id  mncdeno(0,mncx1?) = 1/mncx1/ep;
id  mncdeno(mncx1?,mncx2?) = mncaccm(1+ep*mncx2/mncx1)/mncx1;
repeat id mncaccm(mncx1?)*mncaccm(mncx2?) = mncaccm(mncx1*mncx2);
id  mncaccm(mncx1?) = mncaccm(mncx1-1);
id  mncaccm(mncx1?) = mncaccm(mncx1-mncx1^2,mncx1^3);
id  mncaccm(mncx1?,mncx2?) = acc(1-mncx1-mncx2+mncx2*mncx1+mncx2^2);
repeat id acc(mncx1?)*acc(mncx2?) = acc(mncx1*mncx2);
*
#endprocedure
*--#] noplane : 
*--#[ noplred :
#procedure noplred(P1,P2,P3,P4,P5,P6,P7,P8,Q)
*
*                     /-<------<-----<-\
*                 P1 /     \  P2   /    \ P3
*                   /       v     /      \
*                  /      P7 \   /        \
*                 /           \ /          \
*          Q --<--             /            --<-- Q
*                 \           / \          /
*                  \      P8 /   \        / 
*                   \       ^     \      /
*                 P6 \     /  P5   \    / P4
*                     \->------>----->-/
*
*   Express everything in powers of pi.pi, Q.Q and p2.Q;
*   The only difficult relation here is the one for p1.p3
*   It is derived by squaring:
*   p1-p3 = p6-p4 = p5+p8-p4
*   and p2-Q = p4+p8
*
  id  `P5'.P?!{`P5'} = `P6'.P-`P8'.P;
  id  `P4'.P?!{`P4'} = `P3'.P-Q.P;
#call ACCU(moms 1)
  id  `P6'.P?!{`P6'} = `P1'.P-Q.P;
#call ACCU(moms 2)
  id  `P7'.P?!{`P7'} = `P2'.P-`P1'.P;
#call ACCU(moms 3)
  id  `P8'.P?!{`P8'} = `P2'.P-`P3'.P;
#call ACCU(moms 4)
  id  `P1'.`Q' = `P1'.`P1'/2+`Q'.`Q'/2-`P6'.`P6'/2;
#call ACCU(dots 1)
  id  `P3'.`Q' = `P3'.`P3'/2+`Q'.`Q'/2-`P4'.`P4'/2;
#call ACCU(dots 2)
  id  `P1'.`P2' = `P1'.`P1'/2+`P2'.`P2'/2-`P7'.`P7'/2;
#call ACCU(dots 3)
  id  `P3'.`P2' = `P3'.`P3'/2+`P2'.`P2'/2-`P8'.`P8'/2;
#call ACCU(dots 4)
  id `P1'.`P3' = -`P2'.`Q'+`P1'.`P1'/2+`P2'.`P2'/2+`P3'.`P3'/2+`P5'.`P5'/2
                 +`Q'.`Q'/2-`P4'.`P4'/2-`P6'.`P6'/2-`P7'.`P7'/2-`P8'.`P8'/2;
#call ACCU(dots 5)
#endprocedure
*--#] noplred : 
*--#[ one :
#procedure one(P,PQ,Q,EP,EPQ,EQ,INT)
*
*   Routine for the reduction of one loop integrals.
*   Notation is from S.G.Gorishny et.al. Comp.Phys.Comm 55(1989)381
*
*   Method involves a reduction to a standard function mncG.
*   One problem is the presence of loopmomenta in the numerator.
*   The two propagators are P and P-Q (=PQ) in which Q is the external
*   momentum.
*
*   The formula we use is (3.1)
*   This means that we have to find a way to take the d'Alembertian (dal)
*   of a polynomial in dotproducts. Such is done with the help of the
*   noncommuting(!) function mncFQ.
*	The use of the function distrib_ avoids the generation of double
*	terms. They can speed things up very much over the conventional
*	differentiation by commutation. Example:
*	8 FQ, 3 d'Alembertians: commutation: 229.7 sec, distrib_: 13.6 sec
*	The simple cases have dedicated code.
*
*   Recoded by J.A.M.Vermaseren 4-nov-1990
*
*   We start with some trivialities
*
id  `P'.`PQ' = `P'.`P'/2+`PQ'.`PQ'/2-`Q'.`Q'/2;
id  `PQ'.mncp?!{`PQ'} = `P'.mncp-`Q'.mncp;
id	`P'.`Q' = `P'.`P'/2+`Q'.`Q'/2-`PQ'.`PQ'/2;
if ( ( count(`EP',1) == 0 ) && ( count(`P'.`P',1) >= 0 ) ) discard;
if ( ( count(`EPQ',1) == 0 ) && ( count(`PQ'.`PQ',1) >= 0 ) ) discard;
totensor,nosquare,mncFQ,`P';
*
*   Now relation (3.1) after which we don't need mncx anymore
*
if ( count(mncFQ,1) == 0 );
	id  `INT'/`P'.`P'^mncx1?/`PQ'.`PQ'^mncx2?*`EP'^mncy1?*`EPQ'^mncy2? =
        `Q'.`Q'^2/`Q'.`Q'^mncx1/`Q'.`Q'^mncx2*`EQ'^mncy1*`EQ'^mncy2*`EQ'
        *mncG(mncx1,mncy1,mncx2,mncy2,0,0);
else;
if ( match(mncFQ(mnci1?)) );
	id  `INT'/`P'.`P'^mncx1?/`PQ'.`PQ'^mncx2?*`EP'^mncy1?*`EPQ'^mncy2?*mncFQ(mnci1?) =
        `Q'.`Q'^2/`Q'.`Q'^mncx1/`Q'.`Q'^mncx2*`EQ'^mncy1*`EQ'^mncy2*`EQ'
        *mncG(mncx1,mncy1,mncx2,mncy2,1,0)*`Q'(mnci1);
else;
if ( match(mncFQ(mnci1?,mnci2?)) );
	id  `INT'/`P'.`P'^mncx1?/`PQ'.`PQ'^mncx2?*`EP'^mncy1?*`EPQ'^mncy2?*mncFQ(mnci1?,mnci2?) =
        `Q'.`Q'^2/`Q'.`Q'^mncx1/`Q'.`Q'^mncx2*`EQ'^mncy1*`EQ'^mncy2*`EQ'*(
        +mncG(mncx1,mncy1,mncx2,mncy2,2,0)*`Q'(mnci1)*`Q'(mnci2)
        +mncG(mncx1,mncy1,mncx2,mncy2,2,1)*`Q'.`Q'*d_(mnci1,mnci2)/2
		);
else;
	id  `INT'/`P'.`P'^mncx1?/`PQ'.`PQ'^mncx2?*`EP'^mncy1?*`EPQ'^mncy2?*mncFQ(?a) =
        `Q'.`Q'^2/`Q'.`Q'^mncx1/`Q'.`Q'^mncx2*`EQ'^mncy1*`EQ'^mncy2*`EQ'
        *sum_(mncj,0,integer_(nargs_(?a)/2),mncG(mncx1,mncy1,mncx2,mncy2,nargs_(?a),mncj)
		*`Q'.`Q'^mncj/2^mncj*distrib_(1,2*mncj,mncdel,mncFQ,?a));
	tovector,mncFQ,`Q';
	id	mncdel(?a) = dd_(?a);
endif;
endif;
endif;
*
id  mncG(mncx1?,mncy1?,0,0,?a) = 0;
id  mncG(0,0,?a) = 0;
id  mncG(2,0,1,0,0,0) = mncG(1,0,2,0,0,0);
*

#endprocedure
*--#] one : 
*--#[ one4 :
#procedure one4(P,PQ,Q,EP,EPQ,EQ,P1,P2,P3,P4,P5,INT)
*
*   The procedure one4 does an integral of type one4 in which
*   P1-P5 are the 5 momenta in the sub two loop part, P is its
*   momentum flow, Q is the overall momentum flow and PQ = P-Q
*
*   Note that the central formula (B6 in ref 9b) is wrong
*   This can be tested by trying A16 on P.p1^2*P.p2^2. This shows
*   that it isn't an identity operator. Also the first two arguments
*   of the mncG function in B6 should be exchanged.
*
*   Recoded from the old one4 by J.A.M.Vermaseren, 25-mar-1993
*
id,many,mncq1?{`P1',`P2',`P3',`P4',`P5'}.mncq2?{`P1',`P2',`P3',`P4',`P5'}^mncx1?
        = mncq1.mncq2^mncx1*`P'.`P'^mncx1/`Q'.`Q'^mncx1;
multiply `EP'^2/`EQ'^2*`P'.`P'^4/`Q'.`Q'^4;
id  `Q'.`P' = `P'.`P'/2+`Q'.`Q'/2-`PQ'.`PQ'/2;
id  `Q'.`PQ' = `P'.`P'/2-`Q'.`Q'/2-`PQ'.`PQ'/2;
if ( ( count(`EPQ',1) == 0 ) && ( count(`PQ'.`PQ',1) >= 0 ) ) discard;
totensor,nosquare,mncFQ,`Q';
if ( count(mncFQ,1) == 0 );
id  `INT'/`P'.`P'^mncx1?/`PQ'.`PQ'^mncx2?*`EP'^mncy1?*`EPQ'^mncy2? =
        1/`Q'.`Q'^mncx1/`Q'.`Q'^mncx2*`Q'.`Q'^2*`EQ'*`EQ'^mncy1*`EQ'^mncy2*
        mncG(mncx1,mncy1,mncx2,mncy2,0,0);
elseif ( match(mncFQ(mnci1?)) );
id  `INT'*mncFQ(mnci1?)/`P'.`P'^mncx1?/`PQ'.`PQ'^mncx2?*`EP'^mncy1?*`EPQ'^mncy2? =
        1/`Q'.`Q'^mncx1/`Q'.`Q'^mncx2*`Q'.`Q'^2*`EQ'*`EQ'^mncy1*`EQ'^mncy2*`Q'(mnci1)*
        mncG(mncx1,mncy1,mncx2,mncy2,1,0);
elseif ( match(mncFQ(mnci1?,mnci2?)) );
id  `INT'*mncFQ(mnci1?,mnci2?)/`P'.`P'^mncx1?/`PQ'.`PQ'^mncx2?*`EP'^mncy1?*`EPQ'^mncy2? =
        1/`Q'.`Q'^mncx1/`Q'.`Q'^mncx2*`Q'.`Q'^2*`EQ'*`EQ'^mncy1*`EQ'^mncy2*
        (mncG(mncx1,mncy1,mncx2,mncy2,2,0)*`Q'(mnci1)*`Q'(mnci2)
        -mncG(mncx1,mncy1,mncx2,mncy2,2,0)*d_(mnci1,mnci2)*`Q'.`Q'/2*acc(mncpoch(3,1))
        +mncG(mncx1-1,mncy1,mncx2,mncy2,0,0)*acc(mncpoch(3,1))*d_(mnci1,mnci2)*`Q'.`Q'/2);
else;
id  `INT'*mncFQ(?a)/`P'.`P'^mncx1?/`PQ'.`PQ'^mncx2?*`EP'^mncy1?*`EPQ'^mncy2? =
        mncFQ(?a)/`Q'.`Q'^mncx1/`Q'.`Q'^mncx2*`Q'.`Q'^2*`EQ'*`EQ'^mncy1*`EQ'^mncy2*
        sum_(mncs,0,integer_(nargs_(?a)/2),mncG(mncx1-mncs,mncy1,mncx2,mncy2,nargs_(?a)-2*mncs,0)
        *acc(mncpoch(nargs_(?a)+2-mncs,mncs))*`Q'.`Q'^mncs
        *sum_(mncj,0,integer_(nargs_(?a)/2)-mncs,sign_(mncj)*`Q'.`Q'^mncj
*   the original mncy/4 becomes mncy/2 when we consider the normalization of 
*   the distrib_ to expand the mncFQ.
        *mncy^mncj*mncy^mncs/2^mncj/2^mncs*acc(mncpoch(nargs_(?a)+1-2*mncs,mncj))
        ));

id  mncy^mncs?*mncFQ(?a) = fac_(mncs)*distrib_(1,2*mncs,mncdel,mncFQ,?a);
tovector,mncFQ,`Q';
id  mncdel(?a) = dd_(?a);
endif;
#endprocedure

*--#] one4 : 
*--#[ pochtabl :
#procedure pochtabl(NN)
*  #[ Declarations :  The tables and their variables. Commentary.
*
*   The variable ep should be declared in the rest of the program.
*   It has a power limitation of 6.
*   Note the funny convention:
*   When the argument of mncPO or mncPOINV is 0 or less we have
*   taken out an overal factor of 1/mncx/ep, cq. x*ep. This is to
*   avoid a temporary anomalous number of powers of ep which could
*   destroy the accuracy.
*
*	The parameter NN was to be friendly to older versions of FORM
*	At the moment it has been disabled.
*
*	Values are generated with the program potabl.frm in lib/progs
*
CTable,check,strict,mncPO(-40:40,mncx?);
CTable,check,strict,mncPOINV(-40:40,mncx?);
*
*  #] Declarations : 
*--#[ mncPO-neg : mncPO negative values
*
Fill mncPO(0) =
      +1
      ;
Fill mncPO(-1) =
      -1
      -mncx*ep
      -mncx^2*ep^2
      -mncx^3*ep^3
      -mncx^4*ep^4
      -mncx^5*ep^5
      -mncx^6*ep^6
      ;
Fill mncPO(-2) =
      +1/2
      +3/4*mncx*ep
      +7/8*mncx^2*ep^2
      +15/16*mncx^3*ep^3
      +31/32*mncx^4*ep^4
      +63/64*mncx^5*ep^5
      +127/128*mncx^6*ep^6
      ;
Fill mncPO(-3) =
      -1/6
      -11/36*mncx*ep
      -85/216*mncx^2*ep^2
      -575/1296*mncx^3*ep^3
      -3661/7776*mncx^4*ep^4
      -22631/46656*mncx^5*ep^5
      -137845/279936*mncx^6*ep^6
      ;
Fill mncPO(-4) =
      +1/24
      +25/288*mncx*ep
      +415/3456*mncx^2*ep^2
      +5845/41472*mncx^3*ep^3
      +76111/497664*mncx^4*ep^4
      +952525/5971968*mncx^5*ep^5
      +11679655/71663616*mncx^6*ep^6
      ;
Fill mncPO(-5) =
      -1/120
      -137/7200*mncx*ep
      -12019/432000*mncx^2*ep^2
      -874853/25920000*mncx^3*ep^3
      -58067611/1555200000*mncx^4*ep^4
      -3673451957/93312000000*mncx^5*ep^5
      -226576032859/5598720000000*mncx^6*ep^6
      ;
Fill mncPO(-6) =
      +1/720
      +49/14400*mncx*ep
      +13489/2592000*mncx^2*ep^2
      +336581/51840000*mncx^3*ep^3
      +68165041/9331200000*mncx^4*ep^4
      +483900263/62208000000*mncx^5*ep^5
      +270127056529/33592320000000*mncx^6*ep^6
      ;
Fill mncPO(-7) =
      -1/5040
      -121/235200*mncx*ep
      -726301/889056000*mncx^2*ep^2
      -129973303/124467840000*mncx^3*ep^3
      -187059457981/156829478400000*mncx^4*ep^4
      -28139924320343/21956126976000000*mncx^5*ep^5
      -36845364451242061/27664719989760000000*mncx^6*ep^6
      ;
Fill mncPO(-8) =
      +1/40320
      +761/11289600*mncx*ep
      +3144919/28449792000*mncx^2*ep^2
      +1149858589/7965941760000*mncx^3*ep^3
      +3355156783231/20074173235200000*mncx^4*ep^4
      +339302688554687/1873589501952000000*mncx^5*ep^5
      +2678744365563671119/14164336634757120000000*mncx^6*ep^6
      ;
Fill mncPO(-9) =
      -1/362880
      -7129/914457600*mncx*ep
      -30300391/2304433152000*mncx^2*ep^2
      -101622655189/5807171543040000*mncx^3*ep^3
      -300222042894631/14634072288460800000*mncx^4*ep^4
      -826117151879597149/36877862166921216000000*mncx^5*ep^5
      -2184117445022203447471/92932212660641464320000000*mncx^6*ep^6
      ;
Fill mncPO(-10) =
      +1/3628800
      +7381/9144576000*mncx*ep
      +32160403/23044331520000*mncx^2*ep^2
      +21945415349/11614343086080000*mncx^3*ep^3
      +327873266234371/146340722884608000000*mncx^4*ep^4
      +908741214970658641/368778621669212160000000*mncx^5*ep^5
      +2413120231194809425003/929322126606414643200000000*mncx^6*ep^6
      ;
Fill mncPO(-11) =
      -1/39916800
      -83711/1106493696000*mncx*ep
      -4102360483/30672005253120000*mncx^2*ep^2
      -31276937512951/170045597123297280000*mncx^3*ep^3
      -5194481903600608411/23568319761289003008000000*mncx^4*ep^4
      -159443775809313077987411/653313823782931163381760000000*mncx^5*ep^5
      -4676788004935176736296015403/18109859195262851848942387200000000*mncx^6*
      ep^6
      ;
Fill mncPO(-12) =
      +1/479001600
      +86021/13277924352000*mncx*ep
      +4301068993/368064063037440000*mncx^2*ep^2
      +33264031387717/2040547165479567360000*mncx^3*ep^3
      +5578681466128739761/282819837135468036096000000*mncx^4*ep^4
      +172330529996070466835321/7839765885395173960581120000000*mncx^5*ep^5
      +5074871529226099514685606913/217318310343154222187308646400000000*mncx^6
      *ep^6
      ;
Fill mncPO(-13) =
      -1/6227020800
      -1145993/2243969215488000*mncx*ep
      -758647585777/808636746493255680000*mncx^2*ep^2
      -77287019174361937/58280067593261923368960000*mncx^3*ep^3
      -170044702211669500782121/105009025789539333526192128000000*mncx^4*ep^4
      -68698758619138470404367234173/37841052533518394229498595246080000000*
      mncx^5*ep^5
      -26399765160034818571989179349406177/136364016909786885445421137828773888\
      00000000*mncx^6*ep^6
      ;
Fill mncPO(-14) =
      +1/87178291200
      +1171733/31415569016832000*mncx*ep
      +112686856171/1617273492986511360000*mncx^2*ep^2
      +81347802723340093/815920946305666927165440000*mncx^3*ep^3
      +180514164422163370751221/1470126361053550669366689792000000*mncx^4*ep^4
      +10477884744480707938214808959/75682105067036788458997190492160000000*
      mncx^5*ep^5
      +28287670433295352528296723627638797/190909623673701639623589592960283443\
      200000000*mncx^6*ep^6
      ;
Fill mncPO(-15) =
      -1/1307674368000
      -1195757/471233535252480000*mncx*ep
      -476696711/99016744468561920000*mncx^2*ep^2
      -17055178843123409/2447762838917000781496320000*mncx^3*ep^3
      -190757504835343290196621/22051895415803260040500346880000000*mncx^4*ep^4
      -11132564501075606110169612231/1135231576005551826884957857382400000000*
      mncx^5*ep^5
      -6031962308062447011326345395460321/5727288710211049188707687788808503296\
      00000000*mncx^6*ep^6
      ;
Fill mncPO(-16) =
      +1/20922789888000
      +2436559/15079473128079360000*mncx*ep
      +96568406789/310516510653410181120000*mncx^2*ep^2
      +142531324182321979/313313643381376100031528960000*mncx^3*ep^3
      +3212628164810309981747311/5645285226445634570368088801280000000*mncx^4*
      ep^4
      +376915326274973740257971537677/581238566914842535365098422979788800000000
      *mncx^5*ep^5
      +81962999787375055541354912877997039/117294872785122287384733445914798147\
      502080000000*mncx^6*ep^6
      ;
Fill mncPO(-17) =
      -1/355687428096000
      -42142223/4357967734014935040000*mncx*ep
      -28776062218037/1525567616840204219842560000*mncx^2*ep^2
      -729291672694244960123/26168268808855913250733330268160000*mncx^3*ep^3
      -281462294311726805677013376031/80154977457654193641791234611190169600000\
      00*mncx^4*ep^4
      -564145222241140781833967990767603949/14029686014368128821510003376465837\
      765427200000000*mncx^5*ep^5
      -10461164856476842638038161189836649078663547/240653112241754467740880813\
      276977714544308859699200000000*mncx^6*ep^6
      ;
Fill mncPO(-18) =
      +1/6402373705728000
      +14274301/26147806404089610240000*mncx*ep
      +29608882035581/27460217103123675957166080000*mncx^2*ep^2
      +50500501069854396349/31401922570627095900879996321792000*mncx^3*ep^3
      +294352799712312489617077371031/14427895942377754855522422230014230528000\
      0000*mncx^4*ep^4
      +65863120942796227591592510480739821/280593720287362576430200067529316755\
      30854400000000*mncx^5*ep^5
      +88208355135479668752967444674123414750223/346540481628126433546868371118\
      84790894380475796684800000*mncx^6*ep^6
      ;
Fill mncPO(-19) =
      -1/121645100408832000
      -275295799/9439358111876349296640000*mncx*ep
      -1568274265798307/26907089872903613341457448960000*mncx^2*ep^2
      -1794683268312579709384043/20461649756633468824492910003261276160000*
      mncx^3*ep^3
      -40009517970859535080774906095604951/357248987150256164200042141613160061\
      961502720000000*mncx^4*ep^4
      -170864658958309558725823727346322640908759/13200778773986545574588597183\
      17620008155187930726400000000*mncx^5*ep^5
      -545107754958038941477256969841397265941063458146891/38720342868353865808\
      30089611201274450551405153503756576358400000000*mncx^6*ep^6
      ;
Fill mncPO(-20) =
      +1/2432902008176640000
      +11167027/7551486489501079437312000*mncx*ep
      +11256448518043769/3766992582206505867804042854400000*mncx^2*ep^2
      +9279131712715653650968723/2046164975663346882449291000326127616000000*
      mncx^3*ep^3
      +41629602590344731254886672725930611/714497974300512328400084283226320123\
      9230054400000000*mncx^4*ep^4
      +7142239112579651595742062778098987074987/1056062301918923645967087774654\
      096006524150344581120000000*mncx^5*ep^5
      +571294651960644279934630828168658674310905345370231/77440685736707731616\
      601792224025489011028103070075131527168000000000*mncx^6*ep^6
      ;
Fill mncPO(-21) =
      -1/51090942171709440000
      -18858053/264302027132537780305920000*mncx*ep
      -80676574383943103/553747909584356362567194299596800000*mncx^2*ep^2
      -9577241336253249489726083/42969464488930284531435111006848679936000000*
      mncx^3*ep^3
      -6174587158661922297334017385371973/2143493922901536985200252849678960371\
      7690163200000000*mncx^4*ep^4
      -111696754789037742399995916535691943099157/33265962510446094847963264901\
      6040242055107358543052800000000*mncx^5*ep^5
      -597296825451676635924546421568548733116332437242151/16262544004708623639\
      48637636704535269231590164471577762070528000000000*mncx^6*ep^6
      ;
Fill mncPO(-22) =
      +1/1124000727777607680000
      +6364399/1938214865638610388910080000*mncx*ep
      +82494882923667143/12182454010855839976478274591129600000*mncx^2*ep^2
      +9868213987506291289829963/945328218756466259691572442150670958592000000*
      mncx^3*ep^3
      +6398344963543032449814395864411773/4715686630383381367440556269293712817\
      89183590400000000*mncx^4*ep^4
      +116210352073359830867133385439115668950093/73185117522981408665519182783\
      52885325212361887947161600000000*mncx^5*ep^5
      +623120053293078163170149467651030900158655068872591/35777596810358972006\
      870028007499775923094983618374710765551616000000000*mncx^6*ep^6
      ;
Fill mncPO(-23) =
      -1/25852016738884976640000
      -444316699/3075946991768474687200296960000*mncx*ep
      -44570695662918553607/148223917950083004993811166950273843200000*mncx^2*
      ep^2
      -123525135034106281845251414461/26454159406502827457834932378388591172334\
      3872000000*mncx^3*ep^3
      -264591239933345908907390540426325365899/43359680905230948543794931799963\
      8620563548468255129600000000*mncx^4*ep^4
      -776713959740478684849561077289313689586845388571/10834023934084030762272\
      43586991318834832866105871976452482662400000000*mncx^5*ep^5
      -96041208895558385773482948005826382154738052851832630885359/
      1218164720524162610937517301815379439097517152218903519958149931487723520\
      00000000*mncx^6*ep^6
      ;
Fill mncPO(-24) =
      +1/620448401733239439360000
      +269564591/44293636681466035495684276224000*mncx*ep
      +45472764736767046157/3557374030801992119851468006806572236800000*mncx^2*
      ep^2
      +126906684898093000128113947991/63489982575606785898803837708132618813602\
      52928000000*mncx^3*ep^3
      +1912807200725066844334929443722155255943/7284426392078799355357548542393\
      9288254676142666861772800000000*mncx^4*ep^4
      +53677524641216006737724172489720819744162618911/173344382945344492196358\
      9739186110135732585769395162323972259840000000*mncx^5*ep^5
      +99813356898970334531896288222195044055013592737697579224909/
      2923595329257990266250041524356910653834041165325368447899559835570536448\
      000000000*mncx^6*ep^6
      ;
Fill mncPO(-25) =
      -1/15511210043330985984000000
      -34052522467/138417614629581360924013363200000000*mncx*ep
      -5793490591633676917801/11116793846256225374535837521270538240000000000*
      mncx^2*ep^2
      -81384656370757013035663184180567/992030977743856029668809964189572168962\
      53952000000000000*mncx^3*ep^3
      -176122096932442395019595242667343669886849/16259880339461605703923099424\
      9864482711330675595673600000000000000*mncx^4*ep^4
      -1446748397713984600368618807470929295440186517370209/1128544159800419871\
      070045403115957119617568860283308804669440000000000000000*mncx^5*ep^5
      -8090725701340520405271382597523589771894308313467672735828693401/
      5710147127457012238769612352259591120769611651026110249803827803848704000\
      000000000000000*mncx^6*ep^6
      ;
Fill mncPO(-26) =
      +1/403291461126605635584000000
      +34395742267/3598857980369115384024347443200000000*mncx*ep
      +5899738289669258497201/289036640002661859737931775553033994240000000000*
      mncx^2*ep^2
      +83409563366589638003220811960367/257928054213402567713890590689288763930\
      2602752000000000000*mncx^3*ep^3
      +1269661867514370193728286786947387535922143/2959298221782012238114004095\
      3475335853462182958412595200000000000000*mncx^4*ep^4
      +4485502890553923346111651037532362873187789797454427/8802644446443274994\
      3463541443044655330170371102098086764216320000000000000000*mncx^5*ep^5
      +8381693734884639563224191438763431636799403704468574686255012801/
      1484638253138823182080099211587493691400099029266788664948995229000663040\
      00000000000000000*mncx^6*ep^6
      ;
Fill mncPO(-27) =
      -1/10888869450418352160768000000
      -312536252003/874522489229695038317916428697600000000*mncx*ep
      -54027306066201893389609/702359035206468319163174214593872606003200000000\
      00*mncx^2*ep^2
      -6916882722942792550203844435294127/5640886545647114155902787218374745267\
      154792218624000000000000*mncx^3*ep^3
      -105781863112692028426923791152458954384121183/64719852110372607647553269\
      565250559511521794130048345702400000000000000*mncx^4*ep^4
      -10124450547451531665251301003609713279538398648943034649/
      5197873519180289451411578658670343852591230243207789925340209479680000000\
      000000000*mncx^5*ep^5
      -6321066054179278690866136146657264317464969772671961192473023910729/
      2922213473653145669288259278167663832782814919305820129219107309242005061\
      632000000000000000000*mncx^6*ep^6
      ;
Fill mncPO(-28) =
      +1/304888344611713860501504000000
      +315404588903/24486629698431461072901660003532800000000*mncx*ep
      +54931992686981698810309/196660529857811129365688780086284329680896000000\
      0000*mncx^2*ep^2
      +1010635169222484615218019977199461/2256354618258845662361114887349898106\
      8619168874496000000000000*mncx^3*ep^3
      +108680705261010625358435939397997327030532083/18121558590904330141314915\
      47827015666322610235641353679667200000000000000*mncx^4*ep^4
      +10436183424669712573258978534871152798761441249245797349/
      1455404585370481046395242024427696278725544468098181179095258654310400000\
      00000000000*mncx^5*ep^5
      +6530607484264318239070044916372416367692549786298717916415436057429/
      8182197726228807874007125978869458731791881774056296361813500465877614172\
      5696000000000000000000*mncx^6*ep^6
      ;
Fill mncPO(-29) =
      -1/8841761993739701954543616000000
      -9227046511387/20593255576380858762310296062971084800000000*mncx*ep
      -46938861633377181563318269/479635366270215563409978365752438851658737254\
      40000000000*mncx^2*ep^2
      -25186927017635217446536551133584958729/159587675075673461892043169863972\
      32829194034380722405376000000000000*mncx^3*ep^3
      -78890646478256977372499817524180507318888060599123/371693988370268760273\
      70128729720544557277340612164915885352209612800000000000000*mncx^4*ep^4
      -220394091880767057381928499928284371416460564271231904088227601/
      8657085888686975513843729395688454248908700080473386830091375281109030928\
      3840000000000000000*mncx^5*ep^5
      -400846187516914154875914463903897327820615883520726692055932081171823277\
      4109/14114189871322798085914817932007871078118996653282259744392959396270\
      27196088509806936064000000000000000000*mncx^6*ep^6
      ;
Fill mncPO(-30) =
      +1/265252859812191058636308480000000
      +9304682830147/617797667291425762869308881889132544000000000*mncx*ep
      +47661242955539172992975989/143890609881064669022993509725731655497621176\
      3200000000000*mncx^2*ep^2
      +25715533224862937981129332151160709249/478763025227020385676129509591916\
      984875821031421672161280000000000000*mncx^3*ep^3
      +80887105812785807182912885219853936646131104810363/111508196511080628082\
      1103861891616336718320218364947476560566288384000000000000000*mncx^4*ep^4
      +226673869011222345191985022310524244322560444045040215307537481/
      2597125766606092654153118818706536274672610024142016049027412584332709278\
      515200000000000000000*mncx^5*ep^5
      +413164874841296575681906255716369228175069979546000212222776589085717687\
      9029/42342569613968394257744453796023613234356989959846779233178878188810\
      815882655294208081920000000000000000000*mncx^6*ep^6
      ;
Fill mncPO(-31) =
      -1/8222838654177922817725562880000000
      -290774257297357/593703558267060158117405835495456374784000000000*mncx*ep
      -46479693768075341170975445029/428664515896679755486399964823927174892963\
      24637491200000000000*mncx^2*ep^2
      -781556503107229568390876511159818552568559/44214770782068309360000480082\
      7836765789503114759574096057466880000000000000*mncx^3*ep^3
      -76521255941455275592333629944010738538900877943907253323/
      3192384995653400474537578644877822973797563399792305441352141291565508198\
      4000000000000000*mncx^4*ep^4
      -6667705282222096185300565038664400439373549415795418232677816898893031/
      2304958677882854107587952889232422602531968466303538110272905138501002413\
      385094214451200000000000000000*mncx^5*ep^5
      -377556125228009940562091755613952065421188786959973299420548922518209727\
      5036627133349/11649547782572666665636314305404667771607764719807658217286\
      58963444626575362564967578131202435973120000000000000000000*mncx^6*ep^6
      ;
Fill mncPO(-32) =
      +1/263130836933693530167218012160000000
      +586061125622639/37997027729091850119513973471709207986176000000000*mncx*
      ep
      +188563440970824224217342974191/54869058034775008702259195497462678386299\
      29553598873600000000000*mncx^2*ep^2
      +6374011091027611713181285626046594885588997/1131898132020948719616012290\
      11926212042112797378450968590711521280000000000000*mncx^3*ep^3
      +1253103527804771871114914850704998968323017858623755794393/
      1634501117774541042963240266177445362584352460693660385972296341281540197\
      5808000000000000000*mncx^4*ep^4
      +219021337829810613341650082757499547365333779437895662406850111446001517/
      2360277686152042606170063758574000744992735709494823024919454861825026471\
      306336475598028800000000000000000*mncx^5*ep^5
      +248554426877018194483796891687105191326133831297962684645980033038470417\
      598667492069911/238582738587088213312231716974687595962527021461660840290\
      0293557134595226342533053600012702588872949760000000000000000000*mncx^6*
      ep^6
      ;
Fill mncPO(-33) =
      -1/8683317618811886495518194401280000000
      -53676090078349/113991083187275550358541920415127623958528000000000*mncx*
      ep
      -191147113675074393547229862991/18106789151475752871745534514162683867478\
      7675268762828800000000000*mncx^2*ep^2
      -6493501663928207284923763331891522805938597/3735263835669130774732840557\
      393564997389722313488881963493480202240000000000000*mncx^3*ep^3
      -1281518216016642673897384956891070655754678612565673196793/
      5393853688655985441778692878385569696528363120289079273708577926229082652\
      01664000000000000000*mncx^4*ep^4
      -224629088844679436707044990778140173948721827021389476075843741063887117/
      7788916364301740600361210403294202458476027841332915982234201044022587355\
      3109103694734950400000000000000000*mncx^5*ep^5
      -255435053228138403128470654509381028350984604020895179028694925583796862\
      430658515774711/787323037337391103930364666016469066676339170823480772957\
      09687385441642469303590768800419185432807342080000000000000000000*mncx^6*
      ep^6
      ;
Fill mncPO(-34) =
      +1/295232799039604140847618609643520000000
      +54062195834749/3875696828367368712190425294114339214589952000000000*mncx
      *ep
      +193672834401940297285176238591/61563083115017559763934817348153125149427\
      80959137936179200000000000*mncx^2*ep^2
      +6611010257989610727955230791776284831303797/1269989704127504463409165789\
      51381209911250558658621986758778326876160000000000000*mncx^3*ep^3
      +1309596256295164289625430756003219542652775000893320755593/
      1833910254143035050204755578651093696819643460898286953060916494917888101\
      6856576000000000000000*mncx^4*ep^4
      +230191158028949416073834042540087090094585156318457665222350343814884317/
      2648231563862591804122811537120028835881849466053191433959628354967679700\
      805709525620988313600000000000000000*mncx^5*ep^5
      +262278669329565080577541157375092806300683649718885554909323049217499202\
      181779758942311/267689832694712975336323986445599482669955318079983462805\
      4129371105015843956322086139214252304715449630720000000000000000000*
      mncx^6*ep^6
      ;
Fill mncPO(-35) =
      -1/10333147966386144929666651337523200000000
      -54437269998109/135649388992857904926664885294001872510648320000000000*
      mncx*ep
      -28020487719351088554569096233/307815415575087798819674086740765625747139\
      04795689680896000000000000*mncx^2*ep^2
      -6726617628860633132194043822000226660155477/4444963964446265621932080263\
      298342346893769553051769536557241440665600000000000000*mncx^3*ep^3
      -1337349041568427108208504105948050572191945009309584705513/
      6418685889500622675716644525278827938868752113144004335713207732212608355\
      89980160000000000000000*mncx^4*ep^4
      -235708813830701748331660980065818578642451649931134784063493088815524797/
      9268810473519071314429840379920100925586473131186170018858699242386878952\
      8199833396734590976000000000000000000*mncx^5*ep^5
      -269086107362662971607704557753188335966759017341527797426919736935809337\
      701066139462151/936914414431495413677133952559598189344843613279942119818\
      94527988675554538471273014872498830665040737075200000000000000000000*
      mncx^6*ep^6
      ;
Fill mncPO(-36) =
      +1/371993326789901217467999448150835200000000
      +54801925434709/4883378003742884577359935870584067410383339520000000000*
      mncx*ep
      +28365922323001895565692364433/110813549607031607575082671226675625268970\
      0572644828512256000000000000*mncx^2*ep^2
      +6840399294542448499145530506469847851081277/1600187027200655623895548894\
      78740324488175703909863703316060691863961600000000000000*mncx^3*ep^3
      +1364787318272393902310082315639579768613532772621310625713/
      2310726920220224163257992029100378057992750760731841560856754783596539008\
      1239285760000000000000000*mncx^4*ep^4
      +241183262100220140849575649035124968298858892399689742143012614029778597/
      3336771770466865673194742536771236333211130327227021206789131727259276423\
      015194002282445275136000000000000000000*mncx^5*ep^5
      +275858164018779108255860951501407989498653796590642496343098766635251225\
      077224664127551/337289189195338348923768222921455348164143700780779163134\
      8203007592319963384965828535409957903941466534707200000000000000000000*
      mncx^6*ep^6
      ;
Fill mncPO(-37) =
      -1/13763753091226345046315979581580902400000000
      -2040798836801833/6685344487124008986405752206829588284814791802880000000\
      000*mncx*ep
      -39296045464550797787239457431177/561303872824497201850066254564480044674\
      91403106178498631303168000000000000*mncx^2*ep^2
      -352161234046208215339252267574509136702023691081/29990081190854079447357\
      0581220365445283083865415414068070531622324454136217600000000000000*
      mncx^3*ep^3
      -2608684498588375105517626756450359829025314345805903633658883393/
      1602349481944936549073231791722793647371928150639061097268636868732627063\
      281683538452152320000000000000000*mncx^4*ep^4
      -171013050661720159566906093714710194318958438162996619791883595630791538\
      85873129/8561243452292523517171314326549614651700120853307180048661925366\
      808910708761138659914476119513706266624000000000000000000*mncx^5*ep^5
      -725063001035943052469479181619316097777903710198896844188251120449343750\
      417133885707805597715159/320194958669810512763942477217493534214642269186\
      7684368272132390570951849184846348139270834635216735174966551905304576000\
      00000000000000000*mncx^6*ep^6
      ;
Fill mncPO(-38) =
      +1/523022617466601111760007224100074291200000000
      +2053580969474233/2540430905107123414834185838595243548229620885094400000\
      00000*mncx*ep
      +39749780674985882178980437798777/213295471673308936703025176734502416976\
      4673318034782947989520384000000000000*mncx^2*ep^2
      +357750190719359398209347777918099374415101893881/11396230852524550189995\
      682086373886920757186885785734586680201648329257176268800000000000000*
      mncx^3*ep^3
      +2658985413003238910771173525609793878940548365941169558772311793/
      6088928031390758886478280808546615860013326972428432169620820101183982840\
      4703974461181788160000000000000000*mncx^4*ep^4
      +174751676137248367434629126308906747211036344655198215819163300076987902\
      67618329/3253272511871158936525099444088853567646045924256728418491531639\
      38738606932923269076750092541520838131712000000000000000000*mncx^5*ep^5
      +742262484176094563006431126693903121562516373538281131135537536308520808\
      714695198186793014024359/121674084294527994850298141342647543001564062290\
      9720059943410308416961702690241612292922917161382359366487289724015738880\
      0000000000000000000*mncx^6*ep^6
      ;
Fill mncPO(-39) =
      -1/20397882081197443358640281739902897356800000000
      -2066035355155033/9907680529917781317853324770521449838095521451868160000\
      000000*mncx*ep
      -40194562866176681556204641717977/831852339525904853141798189264559426208\
      22259403356534971591294976000000000000*mncx^2*ep^2
      -363256775189631187172928799970374912083283051481/44445300324845745740983\
      1601368581589909530288545643648880527864284841029874483200000000000000*
      mncx^3*ep^3
      -2708750952776367511754929445487032491402381958608770810738224593/
      2374681932242395965726529515333180185405197519247088546152119839461753307\
      783455003986089738240000000000000000*mncx^4*ep^4
      -178462617335950615774363407395022425191767023902592242501363486714297999\
      54676729/1268776279629751985244788783194652891381957910460124083211697339\
      3610805670384007493993253609119312687136768000000000000000000*mncx^5*ep^5
      -759376829623578102586033668224832815298091263145655117559915634200781766\
      870276142570887835970759/474528928748659179916162751236325417706099842934\
      7908233779300202826150640491942287942399376929391201529300429923661381632\
      00000000000000000000*mncx^6*ep^6
      ;
Fill mncPO(-40) =
      +1/815915283247897734345611269596115894272000000000
      +2078178381193813/3963072211967112527141329908208579935238208580747264000\
      00000000*mncx*ep
      +40630774334422967689121916324397/332740935810361941256719275705823770483\
      2890376134261398863651799040000000000000*mncx^2*ep^2
      +368683961247536801596614790345267288407486323741/17778120129938298296393\
      264054743263596381211541825745955221114571393641194979328000000000000000*
      mncx^3*ep^3
      +2757997281132970865939093578334734854928763733759781509645660373/
      9498727728969583862906118061332720741620790076988354184608479357847013231\
      1338200159443589529600000000000000000*mncx^4*ep^4
      +182146564943915647791277936566142100003343018525106594345690078194760414\
      34591069/5075105118519007940979155132778611565527831641840496332846789357\
      44432226815360299759730144364772507485470720000000000000000000*mncx^5*
      ep^5
      +776407770327188012905286289437702564472631687637943515864539604489420665\
      928534152925141981468899/189811571499463671966465100494530167082439937173\
      9163293511720081130460256196776915176959750771756480611720171969464552652\
      8000000000000000000000*mncx^6*ep^6
      ;
*--#] mncPO-neg : mncPO negative values 
*--#[ mncPO-pos : mncPO positive values
*
Fill mncPO(1) =
      +1
      ;
Fill mncPO(2) =
      +1
      +mncx*ep
      ;
Fill mncPO(3) =
      +2
      +3*mncx*ep
      +mncx^2*ep^2
      ;
Fill mncPO(4) =
      +6
      +11*mncx*ep
      +6*mncx^2*ep^2
      +mncx^3*ep^3
      ;
Fill mncPO(5) =
      +24
      +50*mncx*ep
      +35*mncx^2*ep^2
      +10*mncx^3*ep^3
      +mncx^4*ep^4
      ;
Fill mncPO(6) =
      +120
      +274*mncx*ep
      +225*mncx^2*ep^2
      +85*mncx^3*ep^3
      +15*mncx^4*ep^4
      +mncx^5*ep^5
      ;
Fill mncPO(7) =
      +720
      +1764*mncx*ep
      +1624*mncx^2*ep^2
      +735*mncx^3*ep^3
      +175*mncx^4*ep^4
      +21*mncx^5*ep^5
      +mncx^6*ep^6
      ;
Fill mncPO(8) =
      +5040
      +13068*mncx*ep
      +13132*mncx^2*ep^2
      +6769*mncx^3*ep^3
      +1960*mncx^4*ep^4
      +322*mncx^5*ep^5
      +28*mncx^6*ep^6
      ;
Fill mncPO(9) =
      +40320
      +109584*mncx*ep
      +118124*mncx^2*ep^2
      +67284*mncx^3*ep^3
      +22449*mncx^4*ep^4
      +4536*mncx^5*ep^5
      +546*mncx^6*ep^6
      ;
Fill mncPO(10) =
      +362880
      +1026576*mncx*ep
      +1172700*mncx^2*ep^2
      +723680*mncx^3*ep^3
      +269325*mncx^4*ep^4
      +63273*mncx^5*ep^5
      +9450*mncx^6*ep^6
      ;
Fill mncPO(11) =
      +3628800
      +10628640*mncx*ep
      +12753576*mncx^2*ep^2
      +8409500*mncx^3*ep^3
      +3416930*mncx^4*ep^4
      +902055*mncx^5*ep^5
      +157773*mncx^6*ep^6
      ;
Fill mncPO(12) =
      +39916800
      +120543840*mncx*ep
      +150917976*mncx^2*ep^2
      +105258076*mncx^3*ep^3
      +45995730*mncx^4*ep^4
      +13339535*mncx^5*ep^5
      +2637558*mncx^6*ep^6
      ;
Fill mncPO(13) =
      +479001600
      +1486442880*mncx*ep
      +1931559552*mncx^2*ep^2
      +1414014888*mncx^3*ep^3
      +657206836*mncx^4*ep^4
      +206070150*mncx^5*ep^5
      +44990231*mncx^6*ep^6
      ;
Fill mncPO(14) =
      +6227020800
      +19802759040*mncx*ep
      +26596717056*mncx^2*ep^2
      +20313753096*mncx^3*ep^3
      +9957703756*mncx^4*ep^4
      +3336118786*mncx^5*ep^5
      +790943153*mncx^6*ep^6
      ;
Fill mncPO(15) =
      +87178291200
      +283465647360*mncx*ep
      +392156797824*mncx^2*ep^2
      +310989260400*mncx^3*ep^3
      +159721605680*mncx^4*ep^4
      +56663366760*mncx^5*ep^5
      +14409322928*mncx^6*ep^6
      ;
Fill mncPO(16) =
      +1307674368000
      +4339163001600*mncx*ep
      +6165817614720*mncx^2*ep^2
      +5056995703824*mncx^3*ep^3
      +2706813345600*mncx^4*ep^4
      +1009672107080*mncx^5*ep^5
      +272803210680*mncx^6*ep^6
      ;
Fill mncPO(17) =
      +20922789888000
      +70734282393600*mncx*ep
      +102992244837120*mncx^2*ep^2
      +87077748875904*mncx^3*ep^3
      +48366009233424*mncx^4*ep^4
      +18861567058880*mncx^5*ep^5
      +5374523477960*mncx^6*ep^6
      ;
Fill mncPO(18) =
      +355687428096000
      +1223405590579200*mncx*ep
      +1821602444624640*mncx^2*ep^2
      +1583313975727488*mncx^3*ep^3
      +909299905844112*mncx^4*ep^4
      +369012649234384*mncx^5*ep^5
      +110228466184200*mncx^6*ep^6
      ;
Fill mncPO(19) =
      +6402373705728000
      +22376988058521600*mncx*ep
      +34012249593822720*mncx^2*ep^2
      +30321254007719424*mncx^3*ep^3
      +17950712280921504*mncx^4*ep^4
      +7551527592063024*mncx^5*ep^5
      +2353125040549984*mncx^6*ep^6
      ;
Fill mncPO(20) =
      +121645100408832000
      +431565146817638400*mncx*ep
      +668609730341153280*mncx^2*ep^2
      +610116075740491776*mncx^3*ep^3
      +371384787345228000*mncx^4*ep^4
      +161429736530118960*mncx^5*ep^5
      +52260903362512720*mncx^6*ep^6
      ;
Fill mncPO(21) =
      +2432902008176640000
      +8752948036761600000*mncx*ep
      +13803759753640704000*mncx^2*ep^2
      +12870931245150988800*mncx^3*ep^3
      +8037811822645051776*mncx^4*ep^4
      +3599979517947607200*mncx^5*ep^5
      +1206647803780373360*mncx^6*ep^6
      ;
Fill mncPO(22) =
      +51090942171709440000
      +186244810780170240000*mncx*ep
      +298631902863216384000*mncx^2*ep^2
      +284093315901811468800*mncx^3*ep^3
      +181664979520697076096*mncx^4*ep^4
      +83637381699544802976*mncx^5*ep^5
      +28939583397335447760*mncx^6*ep^6
      ;
Fill mncPO(23) =
      +1124000727777607680000
      +4148476779335454720000*mncx*ep
      +6756146673770930688000*mncx^2*ep^2
      +6548684852703068697600*mncx^3*ep^3
      +4280722865357147142912*mncx^4*ep^4
      +2021687376910682741568*mncx^5*ep^5
      +720308216440924653696*mncx^6*ep^6
      ;
Fill mncPO(24) =
      +25852016738884976640000
      +96538966652493066240000*mncx*ep
      +159539850276066860544000*mncx^2*ep^2
      +157375898285941510732800*mncx^3*ep^3
      +105005310755917452984576*mncx^4*ep^4
      +50779532534302850198976*mncx^5*ep^5
      +18588776355051949776576*mncx^6*ep^6
      ;
Fill mncPO(25) =
      +620448401733239439360000
      +2342787216398718566400000*mncx*ep
      +3925495373278097719296000*mncx^2*ep^2
      +3936561409138663118131200*mncx^3*ep^3
      +2677503356427960382362624*mncx^4*ep^4
      +1323714091579185857760000*mncx^5*ep^5
      +496910165055549644836800*mncx^6*ep^6
      ;
Fill mncPO(26) =
      +15511210043330985984000000
      +59190128811701203599360000*mncx*ep
      +100480171548351161548800000*mncx^2*ep^2
      +102339530601744675672576000*mncx^3*ep^3
      +70874145319837672677196800*mncx^4*ep^4
      +35770355645907606826362624*mncx^5*ep^5
      +13746468217967926978680000*mncx^6*ep^6
      ;
Fill mncPO(27) =
      +403291461126605635584000000
      +1554454559147562279567360000*mncx*ep
      +2671674589068831403868160000*mncx^2*ep^2
      +2761307967193712729035776000*mncx^3*ep^3
      +1945067308917524165279692800*mncx^4*ep^4
      +1000903392113435450162625024*mncx^5*ep^5
      +393178529313073708272042624*mncx^6*ep^6
      ;
Fill mncPO(28) =
      +10888869450418352160768000000
      +42373564558110787183902720000*mncx*ep
      +73689668464006010184007680000*mncx^2*ep^2
      +77226989703299075087834112000*mncx^3*ep^3
      +55278125307966865191587481600*mncx^4*ep^4
      +28969458895980281319670568448*mncx^5*ep^5
      +11616723683566425573507775872*mncx^6*ep^6
      ;
Fill mncPO(29) =
      +304888344611713860501504000000
      +1197348677077520393310044160000*mncx*ep
      +2105684281550279072336117760000*mncx^2*ep^2
      +2236045380156380112643362816000*mncx^3*ep^3
      +1625014498326371300452283596800*mncx^4*ep^4
      +866422974395414742142363398144*mncx^5*ep^5
      +354237722035840197377888292864*mncx^6*ep^6
      ;
Fill mncPO(30) =
      +8841761993739701954543616000000
      +35027999979859805266492784640000*mncx*ep
      +62262192842035613491057459200000*mncx^2*ep^2
      +66951000306085302338993639424000*mncx^3*ep^3
      +49361465831621147825759587123200*mncx^4*ep^4
      +26751280755793398822580822142976*mncx^5*ep^5
      +11139316913434780466101123891200*mncx^6*ep^6
      ;
Fill mncPO(31) =
      +265252859812191058636308480000000
      +1059681761389533859949327155200000*mncx*ep
      +1902893785240928209998216560640000*mncx^2*ep^2
      +2070792202024594683660866641920000*mncx^3*ep^3
      +1547794975254719737111781253120000*mncx^4*ep^4
      +851899888505423112503184251412480*mncx^5*ep^5
      +360930788158836812805614538878976*mncx^6*ep^6
      ;
Fill mncPO(32) =
      +8222838654177922817725562880000000
      +33115387462887740717065450291200000*mncx*ep
      +60049389103858308369894040535040000*mncx^2*ep^2
      +66097452048003363403485082460160000*mncx^3*ep^3
      +50052436434920906534126085488640000*mncx^4*ep^4
      +27956691518922836224710493046906880*mncx^5*ep^5
      +12040754321429364309477234956660736*mncx^6*ep^6
      ;
Fill mncPO(33) =
      +263130836933693530167218012160000000
      +1067915237466585625763819972198400000*mncx*ep
      +1954695838786353608553674747412480000*mncx^2*ep^2
      +2175167854639965937281416679260160000*mncx^3*ep^3
      +1667775417965472372495519818096640000*mncx^4*ep^4
      +944666565040451665724861862989660160*mncx^5*ep^5
      +413260829804662494127982011660050432*mncx^6*ep^6
      ;
Fill mncPO(34) =
      +8683317618811886495518194401280000000
      +35504333673331019180373277094707200000*mncx*ep
      +65572877917416254708035086636810240000*mncx^2*ep^2
      +73735235041905229538840425162997760000*mncx^3*ep^3
      +57211756647500554229633570676449280000*mncx^4*ep^4
      +32841772064300377341415961296755425280*mncx^5*ep^5
      +14582273948594313971948268247771324416*mncx^6*ep^6
      ;
Fill mncPO(35) =
      +295232799039604140847618609643520000000
      +1215830662512066538628209615621324800000*mncx*ep
      +2264982182865483679253566222746255360000*mncx^2*ep^2
      +2572570869342194059028609542178734080000*mncx^3*ep^3
      +2018934961056924073346381828162273280000*mncx^4*ep^4
      +1173832006833713383837776254766133739520*mncx^5*ep^5
      +528639086316507052387657081720980455424*mncx^6*ep^6
      ;
Fill mncPO(36) =
      +10333147966386144929666651337523200000000
      +42849305986961932992834955156389888000000*mncx*ep
      +80490207062803995312503027411740262400000*mncx^2*ep^2
      +92304962609842275745254900199001948160000*mncx^3*ep^3
      +73235294506334536626151973527858298880000*mncx^4*ep^4
      +43103055200236892507668550744976954163200*mncx^5*ep^5
      +19676200027911460217405774115000449679360*mncx^6*ep^6
      ;
Fill mncPO(37) =
      +371993326789901217467999448150835200000000
      +1552908163497015732671725036967559168000000*mncx*ep
      +2940496760247905764242943941979039334400000*mncx^2*ep^2
      +3403468861017125922141679434575810396160000*mncx^3*ep^3
      +2728775564837885594286725947201900707840000*mncx^4*ep^4
      +1624945281714862666902219800347028648755200*mncx^5*ep^5
      +751446256205049460334276418884993142620160*mncx^6*ep^6
      ;
Fill mncPO(38) =
      +13763753091226345046315979581580902400000000
      +57829595376179483326321825815950524416000000*mncx*ep
      +110351288292669529009660650890192014540800000*mncx^2*ep^2
      +128868844617881564883485083021284023992320000*mncx^3*ep^3
      +104368164760018892910750539481046136586240000*mncx^4*ep^4
      +62851750988287804269668858560041960711782400*mncx^5*ep^5
      +29428456761301692699270447299091774925701120*mncx^6*ep^6
      ;
Fill mncPO(39) =
      +523022617466601111760007224100074291200000000
      +2211288377386046711446545360587700830208000000*mncx*ep
      +4251178550497621585693426559643247076966400000*mncx^2*ep^2
      +5007367383772168994582093805698984926248960000*mncx^3*ep^3
      +4094859105498599495492005583301037214269440000*mncx^4*ep^4
      +2492734702314955455158167164762640643633971200*mncx^5*ep^5
      +1181133107917752126841945855925529407888424960*mncx^6*ep^6
      ;
Fill mncPO(40) =
      +20397882081197443358640281739902897356800000000
      +86763269335522422858175276287020406669312000000*mncx*ep
      +168007251846793288553490181186674336831897600000*mncx^2*ep^2
      +199538506517612212374395084981903659200675840000*mncx^3*ep^3
      +164706872498217549318770311554439436282757120000*mncx^4*ep^4
      +101311512495781862246660525009044022315994316800*mncx^5*ep^5
      +48556925911107288401994055545858287551282544640*mncx^6*ep^6
      ;
*--#] mncPO-pos : mncPO positivevalues 
*--#[ mncPOINV-pos : mncPOINV positive values
*
Fill mncPOINV(1) =
      +1
      ;
Fill mncPOINV(2) =
      +1
      -mncx*ep
      +mncx^2*ep^2
      -mncx^3*ep^3
      +mncx^4*ep^4
      -mncx^5*ep^5
      +mncx^6*ep^6
      ;
Fill mncPOINV(3) =
      +1/2
      -3/4*mncx*ep
      +7/8*mncx^2*ep^2
      -15/16*mncx^3*ep^3
      +31/32*mncx^4*ep^4
      -63/64*mncx^5*ep^5
      +127/128*mncx^6*ep^6
      ;
Fill mncPOINV(4) =
      +1/6
      -11/36*mncx*ep
      +85/216*mncx^2*ep^2
      -575/1296*mncx^3*ep^3
      +3661/7776*mncx^4*ep^4
      -22631/46656*mncx^5*ep^5
      +137845/279936*mncx^6*ep^6
      ;
Fill mncPOINV(5) =
      +1/24
      -25/288*mncx*ep
      +415/3456*mncx^2*ep^2
      -5845/41472*mncx^3*ep^3
      +76111/497664*mncx^4*ep^4
      -952525/5971968*mncx^5*ep^5
      +11679655/71663616*mncx^6*ep^6
      ;
Fill mncPOINV(6) =
      +1/120
      -137/7200*mncx*ep
      +12019/432000*mncx^2*ep^2
      -874853/25920000*mncx^3*ep^3
      +58067611/1555200000*mncx^4*ep^4
      -3673451957/93312000000*mncx^5*ep^5
      +226576032859/5598720000000*mncx^6*ep^6
      ;
Fill mncPOINV(7) =
      +1/720
      -49/14400*mncx*ep
      +13489/2592000*mncx^2*ep^2
      -336581/51840000*mncx^3*ep^3
      +68165041/9331200000*mncx^4*ep^4
      -483900263/62208000000*mncx^5*ep^5
      +270127056529/33592320000000*mncx^6*ep^6
      ;
Fill mncPOINV(8) =
      +1/5040
      -121/235200*mncx*ep
      +726301/889056000*mncx^2*ep^2
      -129973303/124467840000*mncx^3*ep^3
      +187059457981/156829478400000*mncx^4*ep^4
      -28139924320343/21956126976000000*mncx^5*ep^5
      +36845364451242061/27664719989760000000*mncx^6*ep^6
      ;
Fill mncPOINV(9) =
      +1/40320
      -761/11289600*mncx*ep
      +3144919/28449792000*mncx^2*ep^2
      -1149858589/7965941760000*mncx^3*ep^3
      +3355156783231/20074173235200000*mncx^4*ep^4
      -339302688554687/1873589501952000000*mncx^5*ep^5
      +2678744365563671119/14164336634757120000000*mncx^6*ep^6
      ;
Fill mncPOINV(10) =
      +1/362880
      -7129/914457600*mncx*ep
      +30300391/2304433152000*mncx^2*ep^2
      -101622655189/5807171543040000*mncx^3*ep^3
      +300222042894631/14634072288460800000*mncx^4*ep^4
      -826117151879597149/36877862166921216000000*mncx^5*ep^5
      +2184117445022203447471/92932212660641464320000000*mncx^6*ep^6
      ;
Fill mncPOINV(11) =
      +1/3628800
      -7381/9144576000*mncx*ep
      +32160403/23044331520000*mncx^2*ep^2
      -21945415349/11614343086080000*mncx^3*ep^3
      +327873266234371/146340722884608000000*mncx^4*ep^4
      -908741214970658641/368778621669212160000000*mncx^5*ep^5
      +2413120231194809425003/929322126606414643200000000*mncx^6*ep^6
      ;
Fill mncPOINV(12) =
      +1/39916800
      -83711/1106493696000*mncx*ep
      +4102360483/30672005253120000*mncx^2*ep^2
      -31276937512951/170045597123297280000*mncx^3*ep^3
      +5194481903600608411/23568319761289003008000000*mncx^4*ep^4
      -159443775809313077987411/653313823782931163381760000000*mncx^5*ep^5
      +4676788004935176736296015403/18109859195262851848942387200000000*mncx^6*
      ep^6
      ;
Fill mncPOINV(13) =
      +1/479001600
      -86021/13277924352000*mncx*ep
      +4301068993/368064063037440000*mncx^2*ep^2
      -33264031387717/2040547165479567360000*mncx^3*ep^3
      +5578681466128739761/282819837135468036096000000*mncx^4*ep^4
      -172330529996070466835321/7839765885395173960581120000000*mncx^5*ep^5
      +5074871529226099514685606913/217318310343154222187308646400000000*mncx^6
      *ep^6
      ;
Fill mncPOINV(14) =
      +1/6227020800
      -1145993/2243969215488000*mncx*ep
      +758647585777/808636746493255680000*mncx^2*ep^2
      -77287019174361937/58280067593261923368960000*mncx^3*ep^3
      +170044702211669500782121/105009025789539333526192128000000*mncx^4*ep^4
      -68698758619138470404367234173/37841052533518394229498595246080000000*
      mncx^5*ep^5
      +26399765160034818571989179349406177/136364016909786885445421137828773888\
      00000000*mncx^6*ep^6
      ;
Fill mncPOINV(15) =
      +1/87178291200
      -1171733/31415569016832000*mncx*ep
      +112686856171/1617273492986511360000*mncx^2*ep^2
      -81347802723340093/815920946305666927165440000*mncx^3*ep^3
      +180514164422163370751221/1470126361053550669366689792000000*mncx^4*ep^4
      -10477884744480707938214808959/75682105067036788458997190492160000000*
      mncx^5*ep^5
      +28287670433295352528296723627638797/190909623673701639623589592960283443\
      200000000*mncx^6*ep^6
      ;
Fill mncPOINV(16) =
      +1/1307674368000
      -1195757/471233535252480000*mncx*ep
      +476696711/99016744468561920000*mncx^2*ep^2
      -17055178843123409/2447762838917000781496320000*mncx^3*ep^3
      +190757504835343290196621/22051895415803260040500346880000000*mncx^4*ep^4
      -11132564501075606110169612231/1135231576005551826884957857382400000000*
      mncx^5*ep^5
      +6031962308062447011326345395460321/5727288710211049188707687788808503296\
      00000000*mncx^6*ep^6
      ;
Fill mncPOINV(17) =
      +1/20922789888000
      -2436559/15079473128079360000*mncx*ep
      +96568406789/310516510653410181120000*mncx^2*ep^2
      -142531324182321979/313313643381376100031528960000*mncx^3*ep^3
      +3212628164810309981747311/5645285226445634570368088801280000000*mncx^4*
      ep^4
      -376915326274973740257971537677/581238566914842535365098422979788800000000
      *mncx^5*ep^5
      +81962999787375055541354912877997039/117294872785122287384733445914798147\
      502080000000*mncx^6*ep^6
      ;
Fill mncPOINV(18) =
      +1/355687428096000
      -42142223/4357967734014935040000*mncx*ep
      +28776062218037/1525567616840204219842560000*mncx^2*ep^2
      -729291672694244960123/26168268808855913250733330268160000*mncx^3*ep^3
      +281462294311726805677013376031/80154977457654193641791234611190169600000\
      00*mncx^4*ep^4
      -564145222241140781833967990767603949/14029686014368128821510003376465837\
      765427200000000*mncx^5*ep^5
      +10461164856476842638038161189836649078663547/240653112241754467740880813\
      276977714544308859699200000000*mncx^6*ep^6
      ;
Fill mncPOINV(19) =
      +1/6402373705728000
      -14274301/26147806404089610240000*mncx*ep
      +29608882035581/27460217103123675957166080000*mncx^2*ep^2
      -50500501069854396349/31401922570627095900879996321792000*mncx^3*ep^3
      +294352799712312489617077371031/14427895942377754855522422230014230528000\
      0000*mncx^4*ep^4
      -65863120942796227591592510480739821/280593720287362576430200067529316755\
      30854400000000*mncx^5*ep^5
      +88208355135479668752967444674123414750223/346540481628126433546868371118\
      84790894380475796684800000*mncx^6*ep^6
      ;
Fill mncPOINV(20) =
      +1/121645100408832000
      -275295799/9439358111876349296640000*mncx*ep
      +1568274265798307/26907089872903613341457448960000*mncx^2*ep^2
      -1794683268312579709384043/20461649756633468824492910003261276160000*
      mncx^3*ep^3
      +40009517970859535080774906095604951/357248987150256164200042141613160061\
      961502720000000*mncx^4*ep^4
      -170864658958309558725823727346322640908759/13200778773986545574588597183\
      17620008155187930726400000000*mncx^5*ep^5
      +545107754958038941477256969841397265941063458146891/38720342868353865808\
      30089611201274450551405153503756576358400000000*mncx^6*ep^6
      ;
Fill mncPOINV(21) =
      +1/2432902008176640000
      -11167027/7551486489501079437312000*mncx*ep
      +11256448518043769/3766992582206505867804042854400000*mncx^2*ep^2
      -9279131712715653650968723/2046164975663346882449291000326127616000000*
      mncx^3*ep^3
      +41629602590344731254886672725930611/714497974300512328400084283226320123\
      9230054400000000*mncx^4*ep^4
      -7142239112579651595742062778098987074987/1056062301918923645967087774654\
      096006524150344581120000000*mncx^5*ep^5
      +571294651960644279934630828168658674310905345370231/77440685736707731616\
      601792224025489011028103070075131527168000000000*mncx^6*ep^6
      ;
Fill mncPOINV(22) =
      +1/51090942171709440000
      -18858053/264302027132537780305920000*mncx*ep
      +80676574383943103/553747909584356362567194299596800000*mncx^2*ep^2
      -9577241336253249489726083/42969464488930284531435111006848679936000000*
      mncx^3*ep^3
      +6174587158661922297334017385371973/2143493922901536985200252849678960371\
      7690163200000000*mncx^4*ep^4
      -111696754789037742399995916535691943099157/33265962510446094847963264901\
      6040242055107358543052800000000*mncx^5*ep^5
      +597296825451676635924546421568548733116332437242151/16262544004708623639\
      48637636704535269231590164471577762070528000000000*mncx^6*ep^6
      ;
Fill mncPOINV(23) =
      +1/1124000727777607680000
      -6364399/1938214865638610388910080000*mncx*ep
      +82494882923667143/12182454010855839976478274591129600000*mncx^2*ep^2
      -9868213987506291289829963/945328218756466259691572442150670958592000000*
      mncx^3*ep^3
      +6398344963543032449814395864411773/4715686630383381367440556269293712817\
      89183590400000000*mncx^4*ep^4
      -116210352073359830867133385439115668950093/73185117522981408665519182783\
      52885325212361887947161600000000*mncx^5*ep^5
      +623120053293078163170149467651030900158655068872591/35777596810358972006\
      870028007499775923094983618374710765551616000000000*mncx^6*ep^6
      ;
Fill mncPOINV(24) =
      +1/25852016738884976640000
      -444316699/3075946991768474687200296960000*mncx*ep
      +44570695662918553607/148223917950083004993811166950273843200000*mncx^2*
      ep^2
      -123525135034106281845251414461/26454159406502827457834932378388591172334\
      3872000000*mncx^3*ep^3
      +264591239933345908907390540426325365899/43359680905230948543794931799963\
      8620563548468255129600000000*mncx^4*ep^4
      -776713959740478684849561077289313689586845388571/10834023934084030762272\
      43586991318834832866105871976452482662400000000*mncx^5*ep^5
      +96041208895558385773482948005826382154738052851832630885359/
      1218164720524162610937517301815379439097517152218903519958149931487723520\
      00000000*mncx^6*ep^6
      ;
Fill mncPOINV(25) =
      +1/620448401733239439360000
      -269564591/44293636681466035495684276224000*mncx*ep
      +45472764736767046157/3557374030801992119851468006806572236800000*mncx^2*
      ep^2
      -126906684898093000128113947991/63489982575606785898803837708132618813602\
      52928000000*mncx^3*ep^3
      +1912807200725066844334929443722155255943/7284426392078799355357548542393\
      9288254676142666861772800000000*mncx^4*ep^4
      -53677524641216006737724172489720819744162618911/173344382945344492196358\
      9739186110135732585769395162323972259840000000*mncx^5*ep^5
      +99813356898970334531896288222195044055013592737697579224909/
      2923595329257990266250041524356910653834041165325368447899559835570536448\
      000000000*mncx^6*ep^6
      ;
Fill mncPOINV(26) =
      +1/15511210043330985984000000
      -34052522467/138417614629581360924013363200000000*mncx*ep
      +5793490591633676917801/11116793846256225374535837521270538240000000000*
      mncx^2*ep^2
      -81384656370757013035663184180567/992030977743856029668809964189572168962\
      53952000000000000*mncx^3*ep^3
      +176122096932442395019595242667343669886849/16259880339461605703923099424\
      9864482711330675595673600000000000000*mncx^4*ep^4
      -1446748397713984600368618807470929295440186517370209/1128544159800419871\
      070045403115957119617568860283308804669440000000000000000*mncx^5*ep^5
      +8090725701340520405271382597523589771894308313467672735828693401/
      5710147127457012238769612352259591120769611651026110249803827803848704000\
      000000000000000*mncx^6*ep^6
      ;
Fill mncPOINV(27) =
      +1/403291461126605635584000000
      -34395742267/3598857980369115384024347443200000000*mncx*ep
      +5899738289669258497201/289036640002661859737931775553033994240000000000*
      mncx^2*ep^2
      -83409563366589638003220811960367/257928054213402567713890590689288763930\
      2602752000000000000*mncx^3*ep^3
      +1269661867514370193728286786947387535922143/2959298221782012238114004095\
      3475335853462182958412595200000000000000*mncx^4*ep^4
      -4485502890553923346111651037532362873187789797454427/8802644446443274994\
      3463541443044655330170371102098086764216320000000000000000*mncx^5*ep^5
      +8381693734884639563224191438763431636799403704468574686255012801/
      1484638253138823182080099211587493691400099029266788664948995229000663040\
      00000000000000000*mncx^6*ep^6
      ;
Fill mncPOINV(28) =
      +1/10888869450418352160768000000
      -312536252003/874522489229695038317916428697600000000*mncx*ep
      +54027306066201893389609/702359035206468319163174214593872606003200000000\
      00*mncx^2*ep^2
      -6916882722942792550203844435294127/5640886545647114155902787218374745267\
      154792218624000000000000*mncx^3*ep^3
      +105781863112692028426923791152458954384121183/64719852110372607647553269\
      565250559511521794130048345702400000000000000*mncx^4*ep^4
      -10124450547451531665251301003609713279538398648943034649/
      5197873519180289451411578658670343852591230243207789925340209479680000000\
      000000000*mncx^5*ep^5
      +6321066054179278690866136146657264317464969772671961192473023910729/
      2922213473653145669288259278167663832782814919305820129219107309242005061\
      632000000000000000000*mncx^6*ep^6
      ;
Fill mncPOINV(29) =
      +1/304888344611713860501504000000
      -315404588903/24486629698431461072901660003532800000000*mncx*ep
      +54931992686981698810309/196660529857811129365688780086284329680896000000\
      0000*mncx^2*ep^2
      -1010635169222484615218019977199461/2256354618258845662361114887349898106\
      8619168874496000000000000*mncx^3*ep^3
      +108680705261010625358435939397997327030532083/18121558590904330141314915\
      47827015666322610235641353679667200000000000000*mncx^4*ep^4
      -10436183424669712573258978534871152798761441249245797349/
      1455404585370481046395242024427696278725544468098181179095258654310400000\
      00000000000*mncx^5*ep^5
      +6530607484264318239070044916372416367692549786298717916415436057429/
      8182197726228807874007125978869458731791881774056296361813500465877614172\
      5696000000000000000000*mncx^6*ep^6
      ;
Fill mncPOINV(30) =
      +1/8841761993739701954543616000000
      -9227046511387/20593255576380858762310296062971084800000000*mncx*ep
      +46938861633377181563318269/479635366270215563409978365752438851658737254\
      40000000000*mncx^2*ep^2
      -25186927017635217446536551133584958729/159587675075673461892043169863972\
      32829194034380722405376000000000000*mncx^3*ep^3
      +78890646478256977372499817524180507318888060599123/371693988370268760273\
      70128729720544557277340612164915885352209612800000000000000*mncx^4*ep^4
      -220394091880767057381928499928284371416460564271231904088227601/
      8657085888686975513843729395688454248908700080473386830091375281109030928\
      3840000000000000000*mncx^5*ep^5
      +400846187516914154875914463903897327820615883520726692055932081171823277\
      4109/14114189871322798085914817932007871078118996653282259744392959396270\
      27196088509806936064000000000000000000*mncx^6*ep^6
      ;
Fill mncPOINV(31) =
      +1/265252859812191058636308480000000
      -9304682830147/617797667291425762869308881889132544000000000*mncx*ep
      +47661242955539172992975989/143890609881064669022993509725731655497621176\
      3200000000000*mncx^2*ep^2
      -25715533224862937981129332151160709249/478763025227020385676129509591916\
      984875821031421672161280000000000000*mncx^3*ep^3
      +80887105812785807182912885219853936646131104810363/111508196511080628082\
      1103861891616336718320218364947476560566288384000000000000000*mncx^4*ep^4
      -226673869011222345191985022310524244322560444045040215307537481/
      2597125766606092654153118818706536274672610024142016049027412584332709278\
      515200000000000000000*mncx^5*ep^5
      +413164874841296575681906255716369228175069979546000212222776589085717687\
      9029/42342569613968394257744453796023613234356989959846779233178878188810\
      815882655294208081920000000000000000000*mncx^6*ep^6
      ;
Fill mncPOINV(32) =
      +1/8222838654177922817725562880000000
      -290774257297357/593703558267060158117405835495456374784000000000*mncx*ep
      +46479693768075341170975445029/428664515896679755486399964823927174892963\
      24637491200000000000*mncx^2*ep^2
      -781556503107229568390876511159818552568559/44214770782068309360000480082\
      7836765789503114759574096057466880000000000000*mncx^3*ep^3
      +76521255941455275592333629944010738538900877943907253323/
      3192384995653400474537578644877822973797563399792305441352141291565508198\
      4000000000000000*mncx^4*ep^4
      -6667705282222096185300565038664400439373549415795418232677816898893031/
      2304958677882854107587952889232422602531968466303538110272905138501002413\
      385094214451200000000000000000*mncx^5*ep^5
      +377556125228009940562091755613952065421188786959973299420548922518209727\
      5036627133349/11649547782572666665636314305404667771607764719807658217286\
      58963444626575362564967578131202435973120000000000000000000*mncx^6*ep^6
      ;
Fill mncPOINV(33) =
      +1/263130836933693530167218012160000000
      -586061125622639/37997027729091850119513973471709207986176000000000*mncx*
      ep
      +188563440970824224217342974191/54869058034775008702259195497462678386299\
      29553598873600000000000*mncx^2*ep^2
      -6374011091027611713181285626046594885588997/1131898132020948719616012290\
      11926212042112797378450968590711521280000000000000*mncx^3*ep^3
      +1253103527804771871114914850704998968323017858623755794393/
      1634501117774541042963240266177445362584352460693660385972296341281540197\
      5808000000000000000*mncx^4*ep^4
      -219021337829810613341650082757499547365333779437895662406850111446001517/
      2360277686152042606170063758574000744992735709494823024919454861825026471\
      306336475598028800000000000000000*mncx^5*ep^5
      +248554426877018194483796891687105191326133831297962684645980033038470417\
      598667492069911/238582738587088213312231716974687595962527021461660840290\
      0293557134595226342533053600012702588872949760000000000000000000*mncx^6*
      ep^6
      ;
Fill mncPOINV(34) =
      +1/8683317618811886495518194401280000000
      -53676090078349/113991083187275550358541920415127623958528000000000*mncx*
      ep
      +191147113675074393547229862991/18106789151475752871745534514162683867478\
      7675268762828800000000000*mncx^2*ep^2
      -6493501663928207284923763331891522805938597/3735263835669130774732840557\
      393564997389722313488881963493480202240000000000000*mncx^3*ep^3
      +1281518216016642673897384956891070655754678612565673196793/
      5393853688655985441778692878385569696528363120289079273708577926229082652\
      01664000000000000000*mncx^4*ep^4
      -224629088844679436707044990778140173948721827021389476075843741063887117/
      7788916364301740600361210403294202458476027841332915982234201044022587355\
      3109103694734950400000000000000000*mncx^5*ep^5
      +255435053228138403128470654509381028350984604020895179028694925583796862\
      430658515774711/787323037337391103930364666016469066676339170823480772957\
      09687385441642469303590768800419185432807342080000000000000000000*mncx^6*
      ep^6
      ;
Fill mncPOINV(35) =
      +1/295232799039604140847618609643520000000
      -54062195834749/3875696828367368712190425294114339214589952000000000*mncx
      *ep
      +193672834401940297285176238591/61563083115017559763934817348153125149427\
      80959137936179200000000000*mncx^2*ep^2
      -6611010257989610727955230791776284831303797/1269989704127504463409165789\
      51381209911250558658621986758778326876160000000000000*mncx^3*ep^3
      +1309596256295164289625430756003219542652775000893320755593/
      1833910254143035050204755578651093696819643460898286953060916494917888101\
      6856576000000000000000*mncx^4*ep^4
      -230191158028949416073834042540087090094585156318457665222350343814884317/
      2648231563862591804122811537120028835881849466053191433959628354967679700\
      805709525620988313600000000000000000*mncx^5*ep^5
      +262278669329565080577541157375092806300683649718885554909323049217499202\
      181779758942311/267689832694712975336323986445599482669955318079983462805\
      4129371105015843956322086139214252304715449630720000000000000000000*
      mncx^6*ep^6
      ;
Fill mncPOINV(36) =
      +1/10333147966386144929666651337523200000000
      -54437269998109/135649388992857904926664885294001872510648320000000000*
      mncx*ep
      +28020487719351088554569096233/307815415575087798819674086740765625747139\
      04795689680896000000000000*mncx^2*ep^2
      -6726617628860633132194043822000226660155477/4444963964446265621932080263\
      298342346893769553051769536557241440665600000000000000*mncx^3*ep^3
      +1337349041568427108208504105948050572191945009309584705513/
      6418685889500622675716644525278827938868752113144004335713207732212608355\
      89980160000000000000000*mncx^4*ep^4
      -235708813830701748331660980065818578642451649931134784063493088815524797/
      9268810473519071314429840379920100925586473131186170018858699242386878952\
      8199833396734590976000000000000000000*mncx^5*ep^5
      +269086107362662971607704557753188335966759017341527797426919736935809337\
      701066139462151/936914414431495413677133952559598189344843613279942119818\
      94527988675554538471273014872498830665040737075200000000000000000000*
      mncx^6*ep^6
      ;
Fill mncPOINV(37) =
      +1/371993326789901217467999448150835200000000
      -54801925434709/4883378003742884577359935870584067410383339520000000000*
      mncx*ep
      +28365922323001895565692364433/110813549607031607575082671226675625268970\
      0572644828512256000000000000*mncx^2*ep^2
      -6840399294542448499145530506469847851081277/1600187027200655623895548894\
      78740324488175703909863703316060691863961600000000000000*mncx^3*ep^3
      +1364787318272393902310082315639579768613532772621310625713/
      2310726920220224163257992029100378057992750760731841560856754783596539008\
      1239285760000000000000000*mncx^4*ep^4
      -241183262100220140849575649035124968298858892399689742143012614029778597/
      3336771770466865673194742536771236333211130327227021206789131727259276423\
      015194002282445275136000000000000000000*mncx^5*ep^5
      +275858164018779108255860951501407989498653796590642496343098766635251225\
      077224664127551/337289189195338348923768222921455348164143700780779163134\
      8203007592319963384965828535409957903941466534707200000000000000000000*
      mncx^6*ep^6
      ;
Fill mncPOINV(38) =
      +1/13763753091226345046315979581580902400000000
      -2040798836801833/6685344487124008986405752206829588284814791802880000000\
      000*mncx*ep
      +39296045464550797787239457431177/561303872824497201850066254564480044674\
      91403106178498631303168000000000000*mncx^2*ep^2
      -352161234046208215339252267574509136702023691081/29990081190854079447357\
      0581220365445283083865415414068070531622324454136217600000000000000*
      mncx^3*ep^3
      +2608684498588375105517626756450359829025314345805903633658883393/
      1602349481944936549073231791722793647371928150639061097268636868732627063\
      281683538452152320000000000000000*mncx^4*ep^4
      -171013050661720159566906093714710194318958438162996619791883595630791538\
      85873129/8561243452292523517171314326549614651700120853307180048661925366\
      808910708761138659914476119513706266624000000000000000000*mncx^5*ep^5
      +725063001035943052469479181619316097777903710198896844188251120449343750\
      417133885707805597715159/320194958669810512763942477217493534214642269186\
      7684368272132390570951849184846348139270834635216735174966551905304576000\
      00000000000000000*mncx^6*ep^6
      ;
Fill mncPOINV(39) =
      +1/523022617466601111760007224100074291200000000
      -2053580969474233/2540430905107123414834185838595243548229620885094400000\
      00000*mncx*ep
      +39749780674985882178980437798777/213295471673308936703025176734502416976\
      4673318034782947989520384000000000000*mncx^2*ep^2
      -357750190719359398209347777918099374415101893881/11396230852524550189995\
      682086373886920757186885785734586680201648329257176268800000000000000*
      mncx^3*ep^3
      +2658985413003238910771173525609793878940548365941169558772311793/
      6088928031390758886478280808546615860013326972428432169620820101183982840\
      4703974461181788160000000000000000*mncx^4*ep^4
      -174751676137248367434629126308906747211036344655198215819163300076987902\
      67618329/3253272511871158936525099444088853567646045924256728418491531639\
      38738606932923269076750092541520838131712000000000000000000*mncx^5*ep^5
      +742262484176094563006431126693903121562516373538281131135537536308520808\
      714695198186793014024359/121674084294527994850298141342647543001564062290\
      9720059943410308416961702690241612292922917161382359366487289724015738880\
      0000000000000000000*mncx^6*ep^6
      ;
Fill mncPOINV(40) =
      +1/20397882081197443358640281739902897356800000000
      -2066035355155033/9907680529917781317853324770521449838095521451868160000\
      000000*mncx*ep
      +40194562866176681556204641717977/831852339525904853141798189264559426208\
      22259403356534971591294976000000000000*mncx^2*ep^2
      -363256775189631187172928799970374912083283051481/44445300324845745740983\
      1601368581589909530288545643648880527864284841029874483200000000000000*
      mncx^3*ep^3
      +2708750952776367511754929445487032491402381958608770810738224593/
      2374681932242395965726529515333180185405197519247088546152119839461753307\
      783455003986089738240000000000000000*mncx^4*ep^4
      -178462617335950615774363407395022425191767023902592242501363486714297999\
      54676729/1268776279629751985244788783194652891381957910460124083211697339\
      3610805670384007493993253609119312687136768000000000000000000*mncx^5*ep^5
      +759376829623578102586033668224832815298091263145655117559915634200781766\
      870276142570887835970759/474528928748659179916162751236325417706099842934\
      7908233779300202826150640491942287942399376929391201529300429923661381632\
      00000000000000000000*mncx^6*ep^6
      ;
*--#] mncPOINV-pos : mncPOINV positive values 
*--#[ mncPOINV-neg : mncPOINV negative values
*
Fill mncPOINV(0) =
      +1
      ;
Fill mncPOINV(-1) =
      -1
      +mncx*ep
      ;
Fill mncPOINV(-2) =
      +2
      -3*mncx*ep
      +mncx^2*ep^2
      ;
Fill mncPOINV(-3) =
      -6
      +11*mncx*ep
      -6*mncx^2*ep^2
      +mncx^3*ep^3
      ;
Fill mncPOINV(-4) =
      +24
      -50*mncx*ep
      +35*mncx^2*ep^2
      -10*mncx^3*ep^3
      +mncx^4*ep^4
      ;
Fill mncPOINV(-5) =
      -120
      +274*mncx*ep
      -225*mncx^2*ep^2
      +85*mncx^3*ep^3
      -15*mncx^4*ep^4
      +mncx^5*ep^5
      ;
Fill mncPOINV(-6) =
      +720
      -1764*mncx*ep
      +1624*mncx^2*ep^2
      -735*mncx^3*ep^3
      +175*mncx^4*ep^4
      -21*mncx^5*ep^5
      +mncx^6*ep^6
      ;
Fill mncPOINV(-7) =
      -5040
      +13068*mncx*ep
      -13132*mncx^2*ep^2
      +6769*mncx^3*ep^3
      -1960*mncx^4*ep^4
      +322*mncx^5*ep^5
      -28*mncx^6*ep^6
      ;
Fill mncPOINV(-8) =
      +40320
      -109584*mncx*ep
      +118124*mncx^2*ep^2
      -67284*mncx^3*ep^3
      +22449*mncx^4*ep^4
      -4536*mncx^5*ep^5
      +546*mncx^6*ep^6
      ;
Fill mncPOINV(-9) =
      -362880
      +1026576*mncx*ep
      -1172700*mncx^2*ep^2
      +723680*mncx^3*ep^3
      -269325*mncx^4*ep^4
      +63273*mncx^5*ep^5
      -9450*mncx^6*ep^6
      ;
Fill mncPOINV(-10) =
      +3628800
      -10628640*mncx*ep
      +12753576*mncx^2*ep^2
      -8409500*mncx^3*ep^3
      +3416930*mncx^4*ep^4
      -902055*mncx^5*ep^5
      +157773*mncx^6*ep^6
      ;
Fill mncPOINV(-11) =
      -39916800
      +120543840*mncx*ep
      -150917976*mncx^2*ep^2
      +105258076*mncx^3*ep^3
      -45995730*mncx^4*ep^4
      +13339535*mncx^5*ep^5
      -2637558*mncx^6*ep^6
      ;
Fill mncPOINV(-12) =
      +479001600
      -1486442880*mncx*ep
      +1931559552*mncx^2*ep^2
      -1414014888*mncx^3*ep^3
      +657206836*mncx^4*ep^4
      -206070150*mncx^5*ep^5
      +44990231*mncx^6*ep^6
      ;
Fill mncPOINV(-13) =
      -6227020800
      +19802759040*mncx*ep
      -26596717056*mncx^2*ep^2
      +20313753096*mncx^3*ep^3
      -9957703756*mncx^4*ep^4
      +3336118786*mncx^5*ep^5
      -790943153*mncx^6*ep^6
      ;
Fill mncPOINV(-14) =
      +87178291200
      -283465647360*mncx*ep
      +392156797824*mncx^2*ep^2
      -310989260400*mncx^3*ep^3
      +159721605680*mncx^4*ep^4
      -56663366760*mncx^5*ep^5
      +14409322928*mncx^6*ep^6
      ;
Fill mncPOINV(-15) =
      -1307674368000
      +4339163001600*mncx*ep
      -6165817614720*mncx^2*ep^2
      +5056995703824*mncx^3*ep^3
      -2706813345600*mncx^4*ep^4
      +1009672107080*mncx^5*ep^5
      -272803210680*mncx^6*ep^6
      ;
Fill mncPOINV(-16) =
      +20922789888000
      -70734282393600*mncx*ep
      +102992244837120*mncx^2*ep^2
      -87077748875904*mncx^3*ep^3
      +48366009233424*mncx^4*ep^4
      -18861567058880*mncx^5*ep^5
      +5374523477960*mncx^6*ep^6
      ;
Fill mncPOINV(-17) =
      -355687428096000
      +1223405590579200*mncx*ep
      -1821602444624640*mncx^2*ep^2
      +1583313975727488*mncx^3*ep^3
      -909299905844112*mncx^4*ep^4
      +369012649234384*mncx^5*ep^5
      -110228466184200*mncx^6*ep^6
      ;
Fill mncPOINV(-18) =
      +6402373705728000
      -22376988058521600*mncx*ep
      +34012249593822720*mncx^2*ep^2
      -30321254007719424*mncx^3*ep^3
      +17950712280921504*mncx^4*ep^4
      -7551527592063024*mncx^5*ep^5
      +2353125040549984*mncx^6*ep^6
      ;
Fill mncPOINV(-19) =
      -121645100408832000
      +431565146817638400*mncx*ep
      -668609730341153280*mncx^2*ep^2
      +610116075740491776*mncx^3*ep^3
      -371384787345228000*mncx^4*ep^4
      +161429736530118960*mncx^5*ep^5
      -52260903362512720*mncx^6*ep^6
      ;
Fill mncPOINV(-20) =
      +2432902008176640000
      -8752948036761600000*mncx*ep
      +13803759753640704000*mncx^2*ep^2
      -12870931245150988800*mncx^3*ep^3
      +8037811822645051776*mncx^4*ep^4
      -3599979517947607200*mncx^5*ep^5
      +1206647803780373360*mncx^6*ep^6
      ;
Fill mncPOINV(-21) =
      -51090942171709440000
      +186244810780170240000*mncx*ep
      -298631902863216384000*mncx^2*ep^2
      +284093315901811468800*mncx^3*ep^3
      -181664979520697076096*mncx^4*ep^4
      +83637381699544802976*mncx^5*ep^5
      -28939583397335447760*mncx^6*ep^6
      ;
Fill mncPOINV(-22) =
      +1124000727777607680000
      -4148476779335454720000*mncx*ep
      +6756146673770930688000*mncx^2*ep^2
      -6548684852703068697600*mncx^3*ep^3
      +4280722865357147142912*mncx^4*ep^4
      -2021687376910682741568*mncx^5*ep^5
      +720308216440924653696*mncx^6*ep^6
      ;
Fill mncPOINV(-23) =
      -25852016738884976640000
      +96538966652493066240000*mncx*ep
      -159539850276066860544000*mncx^2*ep^2
      +157375898285941510732800*mncx^3*ep^3
      -105005310755917452984576*mncx^4*ep^4
      +50779532534302850198976*mncx^5*ep^5
      -18588776355051949776576*mncx^6*ep^6
      ;
Fill mncPOINV(-24) =
      +620448401733239439360000
      -2342787216398718566400000*mncx*ep
      +3925495373278097719296000*mncx^2*ep^2
      -3936561409138663118131200*mncx^3*ep^3
      +2677503356427960382362624*mncx^4*ep^4
      -1323714091579185857760000*mncx^5*ep^5
      +496910165055549644836800*mncx^6*ep^6
      ;
Fill mncPOINV(-25) =
      -15511210043330985984000000
      +59190128811701203599360000*mncx*ep
      -100480171548351161548800000*mncx^2*ep^2
      +102339530601744675672576000*mncx^3*ep^3
      -70874145319837672677196800*mncx^4*ep^4
      +35770355645907606826362624*mncx^5*ep^5
      -13746468217967926978680000*mncx^6*ep^6
      ;
Fill mncPOINV(-26) =
      +403291461126605635584000000
      -1554454559147562279567360000*mncx*ep
      +2671674589068831403868160000*mncx^2*ep^2
      -2761307967193712729035776000*mncx^3*ep^3
      +1945067308917524165279692800*mncx^4*ep^4
      -1000903392113435450162625024*mncx^5*ep^5
      +393178529313073708272042624*mncx^6*ep^6
      ;
Fill mncPOINV(-27) =
      -10888869450418352160768000000
      +42373564558110787183902720000*mncx*ep
      -73689668464006010184007680000*mncx^2*ep^2
      +77226989703299075087834112000*mncx^3*ep^3
      -55278125307966865191587481600*mncx^4*ep^4
      +28969458895980281319670568448*mncx^5*ep^5
      -11616723683566425573507775872*mncx^6*ep^6
      ;
Fill mncPOINV(-28) =
      +304888344611713860501504000000
      -1197348677077520393310044160000*mncx*ep
      +2105684281550279072336117760000*mncx^2*ep^2
      -2236045380156380112643362816000*mncx^3*ep^3
      +1625014498326371300452283596800*mncx^4*ep^4
      -866422974395414742142363398144*mncx^5*ep^5
      +354237722035840197377888292864*mncx^6*ep^6
      ;
Fill mncPOINV(-29) =
      -8841761993739701954543616000000
      +35027999979859805266492784640000*mncx*ep
      -62262192842035613491057459200000*mncx^2*ep^2
      +66951000306085302338993639424000*mncx^3*ep^3
      -49361465831621147825759587123200*mncx^4*ep^4
      +26751280755793398822580822142976*mncx^5*ep^5
      -11139316913434780466101123891200*mncx^6*ep^6
      ;
Fill mncPOINV(-30) =
      +265252859812191058636308480000000
      -1059681761389533859949327155200000*mncx*ep
      +1902893785240928209998216560640000*mncx^2*ep^2
      -2070792202024594683660866641920000*mncx^3*ep^3
      +1547794975254719737111781253120000*mncx^4*ep^4
      -851899888505423112503184251412480*mncx^5*ep^5
      +360930788158836812805614538878976*mncx^6*ep^6
      ;
Fill mncPOINV(-31) =
      -8222838654177922817725562880000000
      +33115387462887740717065450291200000*mncx*ep
      -60049389103858308369894040535040000*mncx^2*ep^2
      +66097452048003363403485082460160000*mncx^3*ep^3
      -50052436434920906534126085488640000*mncx^4*ep^4
      +27956691518922836224710493046906880*mncx^5*ep^5
      -12040754321429364309477234956660736*mncx^6*ep^6
      ;
Fill mncPOINV(-32) =
      +263130836933693530167218012160000000
      -1067915237466585625763819972198400000*mncx*ep
      +1954695838786353608553674747412480000*mncx^2*ep^2
      -2175167854639965937281416679260160000*mncx^3*ep^3
      +1667775417965472372495519818096640000*mncx^4*ep^4
      -944666565040451665724861862989660160*mncx^5*ep^5
      +413260829804662494127982011660050432*mncx^6*ep^6
      ;
Fill mncPOINV(-33) =
      -8683317618811886495518194401280000000
      +35504333673331019180373277094707200000*mncx*ep
      -65572877917416254708035086636810240000*mncx^2*ep^2
      +73735235041905229538840425162997760000*mncx^3*ep^3
      -57211756647500554229633570676449280000*mncx^4*ep^4
      +32841772064300377341415961296755425280*mncx^5*ep^5
      -14582273948594313971948268247771324416*mncx^6*ep^6
      ;
Fill mncPOINV(-34) =
      +295232799039604140847618609643520000000
      -1215830662512066538628209615621324800000*mncx*ep
      +2264982182865483679253566222746255360000*mncx^2*ep^2
      -2572570869342194059028609542178734080000*mncx^3*ep^3
      +2018934961056924073346381828162273280000*mncx^4*ep^4
      -1173832006833713383837776254766133739520*mncx^5*ep^5
      +528639086316507052387657081720980455424*mncx^6*ep^6
      ;
Fill mncPOINV(-35) =
      -10333147966386144929666651337523200000000
      +42849305986961932992834955156389888000000*mncx*ep
      -80490207062803995312503027411740262400000*mncx^2*ep^2
      +92304962609842275745254900199001948160000*mncx^3*ep^3
      -73235294506334536626151973527858298880000*mncx^4*ep^4
      +43103055200236892507668550744976954163200*mncx^5*ep^5
      -19676200027911460217405774115000449679360*mncx^6*ep^6
      ;
Fill mncPOINV(-36) =
      +371993326789901217467999448150835200000000
      -1552908163497015732671725036967559168000000*mncx*ep
      +2940496760247905764242943941979039334400000*mncx^2*ep^2
      -3403468861017125922141679434575810396160000*mncx^3*ep^3
      +2728775564837885594286725947201900707840000*mncx^4*ep^4
      -1624945281714862666902219800347028648755200*mncx^5*ep^5
      +751446256205049460334276418884993142620160*mncx^6*ep^6
      ;
Fill mncPOINV(-37) =
      -13763753091226345046315979581580902400000000
      +57829595376179483326321825815950524416000000*mncx*ep
      -110351288292669529009660650890192014540800000*mncx^2*ep^2
      +128868844617881564883485083021284023992320000*mncx^3*ep^3
      -104368164760018892910750539481046136586240000*mncx^4*ep^4
      +62851750988287804269668858560041960711782400*mncx^5*ep^5
      -29428456761301692699270447299091774925701120*mncx^6*ep^6
      ;
Fill mncPOINV(-38) =
      +523022617466601111760007224100074291200000000
      -2211288377386046711446545360587700830208000000*mncx*ep
      +4251178550497621585693426559643247076966400000*mncx^2*ep^2
      -5007367383772168994582093805698984926248960000*mncx^3*ep^3
      +4094859105498599495492005583301037214269440000*mncx^4*ep^4
      -2492734702314955455158167164762640643633971200*mncx^5*ep^5
      +1181133107917752126841945855925529407888424960*mncx^6*ep^6
      ;
Fill mncPOINV(-39) =
      -20397882081197443358640281739902897356800000000
      +86763269335522422858175276287020406669312000000*mncx*ep
      -168007251846793288553490181186674336831897600000*mncx^2*ep^2
      +199538506517612212374395084981903659200675840000*mncx^3*ep^3
      -164706872498217549318770311554439436282757120000*mncx^4*ep^4
      +101311512495781862246660525009044022315994316800*mncx^5*ep^5
      -48556925911107288401994055545858287551282544640*mncx^6*ep^6
      ;
Fill mncPOINV(-40) =
      +815915283247897734345611269596115894272000000000
      -3490928655502094357685651333220719164129280000000*mncx*ep
      +6807053343207253964997782523753993879945216000000*mncx^2*ep^2
      -8149547512551281783529293580462820704858931200000*mncx^3*ep^3
      +6787813406446314185125207547159481110510960640000*mncx^4*ep^4
      -4217167372329492039185191311916200328922529792000*mncx^5*ep^5
      +2043588548940073398326422746843375524367296102400*mncx^6*ep^6
      ;
*--#] mncPOINV-neg : mncPOINV negative values 
#endprocedure
*--#] pochtabl : 
*--#[ projectP :
*
#procedure projectP(topo,power)
*
*	Projects out the P, using harmonic projections.
*
id	1/P.Q = 1/Q.Q/mncproexp;
#do mnci = 1,8
id	1/P.p`mnci' = 1/P.p`mnci'/mncproexp;
#enddo
id  P = mncproexp*P;
if ( count(mncproexp,1) > `power' ) discard;

id	mncepexp(mncp?mncpp18[mncn],mncx?) = mncee18[mncn]^mncx/mnceq^mncx;
id	mncepexp(-mncp?mncpp18[mncn],mncx?) = mncee18[mncn]^mncx/mnceq^mncx;
id	mncepexp(-mncp?[mncPp],mncx?) = mncepexp(mncp,mncx);

id  mncepexp([P+Q],mncx?) = mncepexp( mncproexp*2*P.Q/Q.Q,mncx);
id  mncepexp([P-Q],mncx?) = mncepexp(-mncproexp*2*P.Q/Q.Q,mncx);
id  mncepexp(mncp?[mncpp18][D],mncx?)  = mncee18[D]^mncx/mnceq^mncx
    *mncepexp( 2*mncproexp*P.mncpp18[D]/mncpp18[D].mncpp18[D],mncx);
id  mncepexp(mncp?[-mncpp18][D],mncx?) = mncee18[D]^mncx/mnceq^mncx
    *mncepexp(-2*mncproexp*P.mncpp18[D]/mncpp18[D].mncpp18[D],mncx);

#do mnci = 1,8
if ( count([P+p`mnci'].[P+p`mnci'],1) < 0 );
    repeat;
      id,once,mncproexp^mncx?/[P+p`mnci'].[P+p`mnci'] = (
        sum_(mncj,0,`power'-mncx,2^mncj*mncproexp^mncj*P.p`mnci'^mncj/
			p`mnci'.p`mnci'^mncj*sign_(mncj)))*mncproexp^mncx/p`mnci'.p`mnci';
    endrepeat;
endif;
if ( count([P-p`mnci'].[P-p`mnci'],1) < 0 );
    repeat;
      id,once,mncproexp^mncx?/[P-p`mnci'].[P-p`mnci'] = (
        sum_(mncj,0,`power'-mncx,2^mncj*mncproexp^mncj*P.p`mnci'^mncj/
			p`mnci'.p`mnci'^mncj))*mncproexp^mncx/p`mnci'.p`mnci';
    endrepeat;
endif;
#enddo
if ( count([P+Q].[P+Q],1) < 0 );
    repeat;
      id,once,mncproexp^mncx?/[P+Q].[P+Q] =
        (sum_(mncj,0,`power'-mncx,2^mncj*mncproexp^mncj*P.Q^mncj/
			Q.Q^mncj*sign_(mncj)))*mncproexp^mncx/Q.Q;
	endrepeat;
endif;
if ( count([P-Q].[P-Q],1) < 0 );
    repeat;
      id,once,mncproexp^mncx?/[P-Q].[P-Q] =
        (sum_(mncj,0,`power'-mncx,2^mncj*mncproexp^mncj*P.Q^mncj/Q.Q^mncj))
				*mncproexp^mncx/Q.Q;
    endrepeat;
endif;

repeat;
    id,once,mncproexp^mncx?*mncepexp(y?,D?) =
    sump_(mncj,0,`power'-mncx, y*acc((-D*ep-mncj+1)/mncj))*mncproexp^mncx;
    if ( count(P.P,1) > 0 ) discard;
    if ( count(mncproexp,1) > `power' ) discard;
endrepeat;
if ( count(mncproexp,1) != `power' ) discard;
id  mncproexp^`power' = 1;

#call ACCU(Expand in P)
#call momsubs(`topo')
#call sym2(`topo')
#call ACCU(moms)
#call harmo1(P,Q,mncFFPP)
#call ACCU(Harmonics)
#endprocedure
*
*--#] projectP : 
*--#[ reduceto :
#procedure reduceto(TOPO)
#switch `TOPO'
*--#[ reducela :
#case reducela
*
#call dovert1(p2,p7,p1)
#call dovert1(p2,p8,p3)
#call dovert1(Q,p4,p3)
#call dovert1(p8,p5,p4)
#call dovert1(p5,p7,p6)
#call dovert1(p6,Q,p1)
*
#break
*--#] reducela : 
*--#[ reducebe :
#case reducebe
*
#call dovert1(p1,p6,p2)
#call dovert1(p7,p3,p2)
#call dovert1(Q,p4,p3)
#call dovert1(p8,p5,p4)
#call dovert1(p5,Q,p1)
#call dovert1(p7,p8,p6)
*
#break
*--#] reducebe : 
*--#[ reduceno :
#case reduceno
*
#call dovert1(p1,p7,p2)
#call dovert1(p8,p3,p2)
#call dovert1(Q,p4,p3)
#call dovert1(p7,p5,p4)
#call dovert1(p6,Q,p1)
#call dovert1(p5,p8,p6)
*
#break
*--#] reduceno : 
*--#[ reducefa :
#case reducefa
*
#call dovert1(p1,p6,p2)
#call dovert1(p7,p3,p2)
#call dovert1(Q,p4,p3)
#call dovert1(p5,Q,p1)
*
#break
*--#] reducefa : 
*--#[ reducebu :
#case reducebu
*
#call dovert1(p4,p6,p1)
#call dovert1(p4,p5,p2)
#call dovert1(p3,p5,p7)
#call dovert1(p7,Q,p6)
*
#break
*--#] reducebu : 
*--#[ reduceo1 :
#case reduceo1
*
#call dovert1(p2,p5,p1)
#call dovert1(p3,p5,p4)
#call dovert1(Q,p4,p1)
#call dovert1(p6,p7,p5)
#call dovert1(p3,Q,p2)
*
#break
*--#] reduceo1 : 
*--#[ reduceo2 :
#case reduceo2
*
#call dovert1(p2,p5,p1)
#call dovert1(p3,p5,p4)
#call dovert1(Q,p3,p2)
#call dovert1(p6,p7,p4)
#call dovert1(p4,Q,p1)
*
#break
*--#] reduceo2 : 
*--#[ reduceo3 :
#case reduceo3
*
#call dovert1(p3,p5,p4)
#call dovert1(p2,p5,p1)
#call dovert1(p7,p6,Q)
#call dovert1(p3,Q,p2)
#call dovert1(p4,Q,p1)
*
#break
*--#] reduceo3 : 
*--#[ reduceo4 :
#case reduceo4
*
#call dovert1(p4,p6,p1)
#call dovert1(p2,p5,p1)
#call dovert1(p7,p6,Q)
#call dovert1(p3,p5,p4)
#call dovert1(p3,p6,p2)
*
#break
*--#] reduceo4 : 
*--#[ reducey1 :
#case reducey1
*
#call dovert1(p5,p6,p2)
#call dovert1(p3,p4,p1)
#call dovert1(p1,p2,Q)
*
#break
*--#] reducey1 : 
*--#[ reducey2 :
#case reducey2
*
#call dovert1(p5,p6,p1)
#call dovert1(p3,p4,p1)
#call dovert1(p1,p2,Q)
*
#break
*--#] reducey2 : 
*--#[ reducey3 :
#case reducey3
*
#call dovert1(p5,p6,p3)
#call dovert1(p3,p4,p1)
#call dovert1(p1,p2,Q)
*
#break
*--#] reducey3 : 
*--#[ reducey4 :
#case reducey4
*
#call dovert1(p5,p6,Q)
#call dovert1(p3,p4,p1)
#call dovert1(p1,p2,Q)
*
#break
*--#] reducey4 : 
*--#[ reducey5 :
#case reducey5
*
#call dovert1(p5,p6,Q)
#call dovert1(p3,p4,Q)
#call dovert1(p1,p2,Q)
*
#break
*--#] reducey5 : 
*--#[ reducet1 :
#case reducet1
*
#call dovert1(p4,Q,p1)
#call dovert1(p2,p5,p1)
#call dovert1(p3,p5,p4)
#call dovert1(p3,Q,p2)
*
#break
*--#] reducet1 : 
*--#[ reducet2 :
#case reducet2
*
#call dovert1(p3,p4,p1)
#call dovert1(p1,p2,Q)
*
#break
*--#] reducet2 : 
*--#[ reducet3 :
#case reducet3
*
#call dovert1(p3,p4,Q)
#call dovert1(p1,p2,Q)
*
#break
*--#] reducet3 : 
*--#[ reducel1 :
#case reducel1
*
*
#break
*--#] reducel1 : 
*--#[ reducel2 :
#case reducel2
*
*
#break
*--#] reducel2 : 
*--#[ reducel3 :
#case reducel3
*
*
#break
*--#] reducel3 : 
*--#[ reducetr :
#case reducetr
*
*
#break
*--#] reducetr : 
#default
#message Illegal case `TOPO' in reduceto.prc
#break
#endswitch
#endprocedure
*--#] reduceto : 
*--#[ rename :
#procedure rename(TOPO)
#switch `TOPO'
*--#[ la :
*
*
*--#] la : 
*--#[ be :
*
*
*--#] be : 
*--#[ no :
*
*
*--#] no : 
*--#[ fa :
*
*
*--#] fa : 
*--#[ bu :
*
*
*--#] bu : 
*--#[ o1 :
#case o1
*
Multiply replace_(p8,p5,[P+p8],[P+p5],[P-p8],[P-p5]);
*
#break
*--#] o1 : 
*--#[ o2 :
#case o2
*
Multiply replace_(p8,p4,[P+p8],[P+p4],[P-p8],[P-p4]);
*
#break
*--#] o2 : 
*--#[ o3 :
#case o3
*
Multiply replace_(p8,Q,[P+p8],[P+Q],[P-p8],[P-Q]);
*
#break
*--#] o3 : 
*--#[ o4 :
#case o4
*
Multiply replace_(p8,p6,[P+p8],[P+p6],[P-p8],[P-p6]);
*
#break
*--#] o4 : 
*--#[ y1 :
#case y1
*
Multiply replace_(p8,p2,[P+p8],[P+p2],[P-p8],[P-p2]);
Multiply replace_(p7,p1,[P+p7],[P+p1],[P-p7],[P-p1]);
*
#break
*--#] y1 : 
*--#[ y2 :
#case y2
*
Multiply replace_(p8,p1,[P+p8],[P+p1],[P-p8],[P-p1]);
Multiply replace_(p7,p1,[P+p7],[P+p1],[P-p7],[P-p1]);
*
#break
*--#] y2 : 
*--#[ y3 :
#case y3
*
Multiply replace_(p8,p3,[P+p8],[P+p3],[P-p8],[P-p3]);
Multiply replace_(p7,p1,[P+p7],[P+p1],[P-p7],[P-p1]);
*
#break
*--#] y3 : 
*--#[ y4 :
#case y4
*
Multiply replace_(p8,Q,[P+p8],[P+Q],[P-p8],[P-Q]);
Multiply replace_(p7,p1,[P+p7],[P+p1],[P-p7],[P-p1]);
*
#break
*--#] y4 : 
*--#[ y5 :
#case y5
*
Multiply replace_(p8,Q,[P+p8],[P+Q],[P-p8],[P-Q]);
Multiply replace_(p7,Q,[P+p7],[P+Q],[P-p7],[P-Q]);
*
#break
*--#] y5 : 
*--#[ t1 :
*
*
*--#] t1 : 
*--#[ t2 :
#case t2
*
Multiply replace_(p5,p1,[P+p5],[P+p1],[P-p5],[P-p1]);
*
#break
*--#] t2 : 
*--#[ t3 :
#case t3
*
Multiply replace_(p5,Q,[P+p5],[P+Q],[P-p5],[P-Q]);
*
#break
*--#] t3 : 
*--#[ l1 :
*
*
*--#] l1 : 
*--#[ l2 :
*
*
*--#] l2 : 
*--#[ l3 :
*
*
*--#] l3 : 
*--#[ tr :
*
*
*--#] tr : 
#endswitch
#endprocedure
*--#] rename : 
*--#[ rplane :
#procedure rplane(P1,P2,P3,P4,P5,P6,P7,P8,Q,INTS)
*
*   Reduction procedure for three loop graphs of the NO or nonplanar type.
*   Notation is from S.G.Gorishny et.al. Comp.Phys.Comm 55(1989)381
*
*                     /-<------<-----<-\
*                 p1 /     \  p2   /    \ p3
*                   /       v     /      \
*                  /      p7 \   /        \
*                 /           \ /          \
*          Q --<--             /            --<-- Q
*                 \           / \          /
*                  \      p8 /   \        / 
*                   \       ^     \      /
*                 p6 \     /  p5   \    / p4
*                     \->------>----->-/
*
*   Routine put together 26-feb-1993 by J.Vermaseren.
*
*   First express everything in powers of pi.pi, Q.Q and p2.Q;
*
*  id  `P5'.P?!{`P5'} = `P6'.P-`P8'.P;
*  id  `P4'.P?!{`P4'} = `P3'.P-`Q'.P;
*#call ACCU(moms 1)
*  id  `P6'.P?!{`P6'} = `P1'.P-`Q'.P;
*#call ACCU(moms 2)
*  id  `P7'.P?!{`P7'} = `P2'.P-`P1'.P;
*#call ACCU(moms 3)
*  id  `P8'.P?!{`P8'} = `P2'.P-`P3'.P;
*#call ACCU(moms 4)
  id  `P1'.`Q' = `P1'.`P1'/2+`Q'.`Q'/2-`P6'.`P6'/2;
#call ACCU(dots 1)
  id  `P3'.`Q' = `P3'.`P3'/2+`Q'.`Q'/2-`P4'.`P4'/2;
#call ACCU(dots 2)
  id  `P1'.`P2' = `P1'.`P1'/2+`P2'.`P2'/2-`P7'.`P7'/2;
#call ACCU(dots 3)
  id  `P3'.`P2' = `P3'.`P3'/2+`P2'.`P2'/2-`P8'.`P8'/2;
#call ACCU(dots 4)
  id `P1'.`P3' = -`P2'.`Q'+`P1'.`P1'/2+`P2'.`P2'/2+`P3'.`P3'/2+`P5'.`P5'/2
                 +`Q'.`Q'/2-`P4'.`P4'/2-`P6'.`P6'/2-`P7'.`P7'/2-`P8'.`P8'/2;
#call ACCU(dots 5)
*
*   First step: eliminate the powers of `Q'.`P2'
*   Note how common factors are kept together in acc till the end.
*   This trick allows us to do an intermediate sort in the argument
*   of acc, thereby making in the end only the terms that are necessary.
*
while ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
  /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8'*`Q'.`P2') > 0 )
  id  1/`P1'.`P1'^mncx1?/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?
    /`P4'.`P4'^mncx4?/`P5'.`P5'^mncx5?/`P6'.`P6'^mncx6?
    /`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8?*`Q'.`P2'^mncx9? = 
    1/`P1'.`P1'^mncx1/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3
    /`P4'.`P4'^mncx4/`P5'.`P5'^mncx5/`P6'.`P6'^mncx6
    /`P7'.`P7'^mncx7/`P8'.`P8'^mncx8*`Q'.`P2'^mncx9*`Q'.`Q'/`Q'.`P2'/2*(
      +acc(3-2*mncx2-mncx1-mncx3+mncx9-2*ep)
      +mncx1*`P7'.`P7'/`P1'.`P1'-mncx1*`P2'.`P2'/`P1'.`P1'
      +mncx3*`P8'.`P8'/`P3'.`P3'-mncx3*`P2'.`P2'/`P3'.`P3'
      +2*acc(mncx9-1)*`P2'.`P2'/`Q'.`P2'/2
    )*mncdeno(7-mncx1-mncx2-mncx3-mncx4-mncx5-mncx6-mncx7-mncx8+mncx9,-4);
id  mncdeno(0,-4) = -1/4/ep;
id  mncdeno(mncx1?,-4) = acc(1+4*ep/mncx1+16*ep^2/mncx1^2+64*ep^3/mncx1^3+256*ep^4/mncx1^4
	+1024*ep^5/mncx1^5+4096*ep^6/mncx1^6)/mncx1;
repeat id acc(mncx1?)*acc(mncx2?) = acc(mncx1*mncx2);
#call ACCU(Eliminate `Q'.`P2')
*
*   The essence of the strategy is now to depopulate the inner
*   propagators. This will leave integrals with only excess powers
*   in `P1',`P3',`P4',`P6'. These are tabulated.
*   In case an integral is not in the tables we have to use
*   recursions at the edge to reach the table. The paper has the
*   extra recursion (29) which we combine directly with the
*   recursions below (more general form of (30)) to reach the
*   table automatically.
*
repeat;
repeat;
while ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'/`P5'.`P5'^2
               /`P6'.`P6'/`P7'.`P7'/`P8'.`P8') > 0 )
  id  1/`P1'.`P1'^mncx1?/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?/`P4'.`P4'^mncx4?/`P5'.`P5'^mncx5?
       /`P6'.`P6'^mncx6?/`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? =
    1/`P1'.`P1'^mncx1/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3/`P4'.`P4'^mncx4/`P5'.`P5'^mncx5
     /`P6'.`P6'^mncx6/`P7'.`P7'^mncx7/`P8'.`P8'^mncx8*(
        acc(-8+4*ep+mncx1+mncx2+mncx3+mncx4+mncx5+mncx6+mncx7+mncx8)*`P5'.`P5'/`Q'.`Q'*
            (acc(-14+6*ep+2*(mncx1+mncx2+mncx3+mncx5+mncx7+mncx8)+mncx4+mncx6)
                +mncx4*`P3'.`P3'/`P4'.`P4'+mncx6*`P1'.`P1'/`P6'.`P6')/(mncx5-1)
            +mncx4*`P7'.`P7'/`P4'.`P4'+mncx6*`P8'.`P8'/`P6'.`P6'
            -acc(mncx1+mncx2+mncx3+mncx4+mncx5+mncx6+mncx7+mncx8+mncx5-9+4*ep)*`P5'.`P5'
                *(mncx4/`P4'.`P4'+mncx6/`P6'.`P6')/(mncx5-1)
    )*mncdeno(-4+mncx4+mncx6+2*mncx5,2);

while ( match(1/`P1'.`P1'/`P2'.`P2'^2/`P3'.`P3'/`P4'.`P4'/`P5'.`P5'
               /`P6'.`P6'/`P7'.`P7'/`P8'.`P8') > 0 )
  id  1/`P1'.`P1'^mncx1?/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?/`P4'.`P4'^mncx4?/`P5'.`P5'
       /`P6'.`P6'^mncx6?/`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? =
    1/`P1'.`P1'^mncx1/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3/`P4'.`P4'^mncx4/`P5'.`P5'
     /`P6'.`P6'^mncx6/`P7'.`P7'^mncx7/`P8'.`P8'^mncx8*(
        acc(-7+4*ep+mncx1+mncx2+mncx3+mncx4+mncx6+mncx7+mncx8)*`P2'.`P2'/`Q'.`Q'*
            (acc(-12+6*ep+2*(mncx6+mncx2+mncx4+mncx7+mncx8)+mncx1+mncx3)
                +mncx3*`P4'.`P4'/`P3'.`P3'+mncx1*`P6'.`P6'/`P1'.`P1')/(mncx2-1)
            +mncx3*`P8'.`P8'/`P3'.`P3'+mncx1*`P7'.`P7'/`P1'.`P1'
            -acc(mncx1+mncx2+mncx3+mncx4+mncx6+mncx7+mncx8+mncx2-8+4*ep)*`P2'.`P2'
                *(mncx3/`P3'.`P3'+mncx1/`P1'.`P1')/(mncx2-1)
    )*mncdeno(-4+mncx1+mncx3+2*mncx2,2);

if ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'/`P5'.`P5'
               /`P6'.`P6'/`P7'.`P7'^2/`P8'.`P8') > 0 )
  id  1/`P1'.`P1'^mncx1?/`P2'.`P2'/`P3'.`P3'^mncx3?/`P4'.`P4'^mncx4?/`P5'.`P5'
       /`P6'.`P6'^mncx6?/`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? =
    1/`P1'.`P1'^mncx1/`P2'.`P2'/`P3'.`P3'^mncx3/`P4'.`P4'^mncx4/`P5'.`P5'
     /`P6'.`P6'^mncx6/`P7'.`P7'^mncx7/`P8'.`P8'^mncx8*(
        acc(-6+4*ep+mncx1+mncx3+mncx4+mncx6+mncx7+mncx8)*`P7'.`P7'/`Q'.`Q'*
            (acc(-10+6*ep+2*(mncx6+mncx3+mncx7+mncx8)+mncx4+mncx1)
                +mncx4*`P3'.`P3'/`P4'.`P4'+mncx1*`P6'.`P6'/`P1'.`P1')/(mncx7-1)
            +mncx4*`P5'.`P5'/`P4'.`P4'+mncx1*`P2'.`P2'/`P1'.`P1'
            -acc(mncx1+mncx3+mncx4+mncx6+mncx7+mncx8+mncx7-7+4*ep)*`P7'.`P7'
                *(mncx4/`P4'.`P4'+mncx1/`P1'.`P1')/(mncx7-1)
    )*mncdeno(-4+mncx4+mncx1+2*mncx7,2);
endrepeat;

if ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'/`P5'.`P5'
               /`P6'.`P6'/`P7'.`P7'/`P8'.`P8'^2) > 0 )
  id  1/`P1'.`P1'^mncx1?/`P2'.`P2'/`P3'.`P3'^mncx3?/`P4'.`P4'^mncx4?/`P5'.`P5'
       /`P6'.`P6'^mncx6?/`P7'.`P7'/`P8'.`P8'^mncx8? =
    1/`P1'.`P1'^mncx1/`P2'.`P2'/`P3'.`P3'^mncx3/`P4'.`P4'^mncx4/`P5'.`P5'
     /`P6'.`P6'^mncx6/`P7'.`P7'/`P8'.`P8'^mncx8*(
        acc(-5+4*ep+mncx1+mncx3+mncx4+mncx6+mncx8)*`P8'.`P8'/`Q'.`Q'*
            (acc(-8+6*ep+2*(mncx1+mncx4+mncx8)+mncx6+mncx3)
                +mncx3*`P4'.`P4'/`P3'.`P3'+mncx6*`P1'.`P1'/`P6'.`P6')/(mncx8-1)
            +mncx3*`P2'.`P2'/`P3'.`P3'+mncx6*`P5'.`P5'/`P6'.`P6'
            -acc(mncx1+mncx3+mncx4+mncx6+mncx8+mncx8-6+4*ep)*`P8'.`P8'
                *(mncx3/`P3'.`P3'+mncx6/`P6'.`P6')/(mncx8-1)
    )*mncdeno(-4+mncx6+mncx3+2*mncx8,2);
endrepeat;

id  mncdeno(0,2) = 1/2/ep;
id  mncdeno(mncx1?,2) = acc(1-2*ep/mncx1+4*ep^2/mncx1^2-8*ep^3/mncx1^3+16*ep^4/mncx1^4
	-32*ep^5/mncx1^5+64*ep^6/mncx1^6)/mncx1;
repeat id acc(mncx1?)*acc(mncx2?) = acc(mncx1*mncx2);
*
*   We arrange the integral so that mncx1 >= mncx3,mncx4,mncx5, mncx3 >= mncx4 etc.
*
if ( match( 1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
             /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8' ) > 0 );
    if ( count(`P1'.`P1',1) > count(`P6'.`P6',1) )
        multiply replace_(`P1',`P6',`P6',`P1');
    if ( count(`P3'.`P3',1) > count(`P4'.`P4',1) )
        multiply replace_(`P3',`P4',`P4',`P3');
    if ( ( count(`P1'.`P1',1) > count(`P3'.`P3',1) )
    || ( ( count(`P1'.`P1',1) == count(`P3'.`P3',1) )
      && ( count(`P4'.`P4',1) > count(`P6'.`P6',1) ) ) )
        multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4');
    if ( ( count(`P1'.`P1',1) > count(`P4'.`P4',1) )
    || ( ( count(`P1'.`P1',1) == count(`P4'.`P4',1) )
      && ( count(`P3'.`P3',1) > count(`P6'.`P6',1) ) ) )
        multiply replace_(`P1',`P4',`P4',`P1',`P3',`P6',`P6',`P3');
    if ( count(`P1'.`P1',1) > count(`P6'.`P6',1) )
        multiply replace_(`P1',`P6',`P6',`P1');
    if ( count(`P3'.`P3',1) > count(`P4'.`P4',1) )
        multiply replace_(`P3',`P4',`P4',`P3');
endif;

#call ACCU(Inside Reduction)
 
while ( ( match(1/`P1'.`P1'^2/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
               /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8') > 0 )
    && ( count(`P1'.`P1',-1,`P3'.`P3',-1,`P4'.`P4',-1,`P6'.`P6',-1)
        > `INRTABL' ) );
  id  1/`P1'.`P1'^mncx1?/`P2'.`P2'/`P3'.`P3'^mncx3?
    /`P4'.`P4'^mncx4?/`P5'.`P5'/`P6'.`P6'^mncx6?
    /`P7'.`P7'/`P8'.`P8' = 
    1/`P1'.`P1'^mncx1/`P2'.`P2'/`P3'.`P3'^mncx3
    /`P4'.`P4'^mncx4/`P5'.`P5'/`P6'.`P6'^mncx6
    /`P7'.`P7'/`P8'.`P8'/`Q'.`Q'*(
      +acc((2*mncx6+mncx1-3+4*ep)*(mncx3+mncx1-2+2*ep)*(mncx4+mncx1-2+2*ep)
            +(mncx6+mncx3+mncx4+mncx1-4+4*ep)*((mncx4-1)*(mncx3+mncx1-2+2*ep)
            +(mncx3-1)*(mncx4+mncx1-2+2*ep)))
        *`P1'.`P1'/(mncx1-1)*mncdeno(-2+mncx4+mncx1,2)*mncdeno(-2+mncx1+mncx3,2)
      +`P6'.`P6'
      +`P8'.`P8'*`P1'.`P1'/`P2'.`P2'*acc(1+2*ep/(mncx1-1))*mncdeno(-2+mncx1+mncx3,2)
      +`P5'.`P5'*`P1'.`P1'/`P7'.`P7'*acc(1+2*ep/(mncx1-1))*mncdeno(-2+mncx4+mncx1,2)
      +acc(-5+4*ep+mncx1+mncx3+mncx4+mncx6)*(
          -`P4'.`P4'*acc((-6+6*ep+2*(mncx6+mncx3)+mncx4+mncx1)*(mncx3+mncx1-2+2*ep)
           +(mncx3-1)*(mncx4+mncx1-2+2*ep))
          -`P3'.`P3'*acc((-6+6*ep+2*(mncx6+mncx4)+mncx1+mncx3)*(mncx4+mncx1-2+2*ep)
           +(mncx4-1)*(mncx3+mncx1-2+2*ep))
       )*`P1'.`P1'/`Q'.`Q'/(mncx1-1)*mncdeno(-2+mncx4+mncx1,2)*mncdeno(-2+mncx1+mncx3,2)
      +(-`P6'.`P6'*`P4'.`P4'*acc(-5+4*ep+mncx1+mncx3+mncx4+mncx6)/`Q'.`Q'
        -`P2'.`P2'*`P4'.`P4'/`P7'.`P7'
        +`P4'.`P4'*acc(mncx1+mncx3+mncx4+mncx6-4+4*ep)
      )*mncdeno(-2+mncx4+mncx1,2)
      +(-`P6'.`P6'*`P3'.`P3'*acc(-5+4*ep+mncx1+mncx3+mncx4+mncx6)/`Q'.`Q'
        -`P7'.`P7'*`P3'.`P3'/`P2'.`P2'
        +`P3'.`P3'*acc(mncx1+mncx3+mncx4+mncx6-4+4*ep)
      )*mncdeno(-2+mncx1+mncx3,2)
    );
#ifndef `STRATEGY2'
  if ( match( 1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
             /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8' ) > 0 );
    if ( count(`P1'.`P1',1) > count(`P6'.`P6',1) )
        multiply replace_(`P1',`P6',`P6',`P1');
    if ( count(`P3'.`P3',1) > count(`P4'.`P4',1) )
        multiply replace_(`P3',`P4',`P4',`P3');
    if ( ( count(`P1'.`P1',1) > count(`P3'.`P3',1) )
    || ( ( count(`P1'.`P1',1) == count(`P3'.`P3',1) )
      && ( count(`P4'.`P4',1) > count(`P6'.`P6',1) ) ) )
        multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4');
    if ( ( count(`P1'.`P1',1) > count(`P4'.`P4',1) )
    || ( ( count(`P1'.`P1',1) == count(`P4'.`P4',1) )
      && ( count(`P3'.`P3',1) > count(`P6'.`P6',1) ) ) )
        multiply replace_(`P1',`P4',`P4',`P1',`P3',`P6',`P6',`P3');
    if ( count(`P1'.`P1',1) > count(`P6'.`P6',1) )
        multiply replace_(`P1',`P6',`P6',`P1');
    if ( count(`P3'.`P3',1) > count(`P4'.`P4',1) )
        multiply replace_(`P3',`P4',`P4',`P3');
  endif;
#endif
endwhile;

#ifdef `STRATEGY2' 
while ( ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'^2/`P4'.`P4'
               /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8') > 0 )
    && ( count(`P1'.`P1',-1,`P3'.`P3',-1,`P4'.`P4',-1,`P6'.`P6',-1)
        > `INRTABL' ) )
  id  1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'^mncx3?
    /`P4'.`P4'^mncx4?/`P5'.`P5'/`P6'.`P6'^mncx6?
    /`P7'.`P7'/`P8'.`P8' = 
    1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'^mncx3
    /`P4'.`P4'^mncx4/`P5'.`P5'/`P6'.`P6'^mncx6
    /`P7'.`P7'/`P8'.`P8'/`Q'.`Q'*(
      +acc((2*mncx4+mncx3-3+4*ep)*(mncx6+mncx3-2+2*ep)*(1+mncx3-2+2*ep)
            +(mncx4+mncx6+1+mncx3-4+4*ep)*((1-1)*(mncx6+mncx3-2+2*ep)
            +(mncx6-1)*(1+mncx3-2+2*ep)))
        *`P3'.`P3'/(mncx3-1)*mncdeno(-2+1+mncx3,2)*mncdeno(-2+mncx3+mncx6,2)
      +`P4'.`P4'
      +`P5'.`P5'*`P3'.`P3'/`P8'.`P8'*acc(1+2*ep/(mncx3-1))*mncdeno(-2+mncx3+mncx6,2)
      +`P7'.`P7'*`P3'.`P3'/`P2'.`P2'*acc(1+2*ep/(mncx3-1))*mncdeno(-1+mncx3,2)
      +acc(-4+4*ep+mncx4+mncx6+mncx3)*(
          -`P1'.`P1'*acc((-5+6*ep+2*(mncx4+mncx6)+mncx3)*(mncx6+mncx3-2+2*ep)
           +(mncx6-1)*(mncx3-1+2*ep))*mncdeno(-1+mncx3,2)
          -`P6'.`P6'*acc(-6+6*ep+2*(mncx4+1)+mncx3+mncx6)
       )*`P3'.`P3'/`Q'.`Q'/(mncx3-1)*mncdeno(-2+mncx3+mncx6,2)
      +(-`P4'.`P4'*`P1'.`P1'*acc(-4+4*ep+mncx4+mncx6+mncx3)/`Q'.`Q'
        -`P8'.`P8'*`P1'.`P1'/`P2'.`P2'
        +`P1'.`P1'*acc(mncx4+mncx6+mncx3-3+4*ep)
      )*mncdeno(-1+mncx3,2)
      +(-`P4'.`P4'*`P6'.`P6'*acc(-4+4*ep+mncx4+mncx6+mncx3)/`Q'.`Q'
        -`P2'.`P2'*`P6'.`P6'/`P8'.`P8'
        +`P6'.`P6'*acc(mncx4+mncx6+mncx3-3+4*ep)
      )*mncdeno(-2+mncx3+mncx6,2)
    );

while ( ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
               /`P5'.`P5'/`P6'.`P6'^2/`P7'.`P7'/`P8'.`P8') > 0 )
    && ( count(`P1'.`P1',-1,`P3'.`P3',-1,`P4'.`P4',-1,`P6'.`P6',-1)
        > `INRTABL' ) )
  id  1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'
    /`P4'.`P4'^mncx4?/`P5'.`P5'/`P6'.`P6'^mncx6?
    /`P7'.`P7'/`P8'.`P8' = 
    1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'
    /`P4'.`P4'^mncx4/`P5'.`P5'/`P6'.`P6'^mncx6
    /`P7'.`P7'/`P8'.`P8'/`Q'.`Q'*(
      +acc(mncx6-2+4*ep+mncx4)*acc(mncx4+mncx6-2+2*ep)
        *`P6'.`P6'/(mncx6-1)*mncdeno(-2+mncx4+mncx6,2)
      +`P1'.`P1'
      +`P2'.`P2'*`P6'.`P6'/`P8'.`P8'*acc(1+2*ep/(mncx6-1))*mncdeno(-1+mncx6,2)
      +`P7'.`P7'*`P6'.`P6'/`P5'.`P5'*acc(1+2*ep/(mncx6-1))*mncdeno(-2+mncx4+mncx6,2)
      +acc(-3+4*ep+mncx4+mncx6)*(
          -`P4'.`P4'*acc(-2+6*ep+mncx4+mncx6)
          -`P3'.`P3'*acc((-3+6*ep+2*mncx4+mncx6)*(mncx4+mncx6-2+2*ep)
           +(mncx4-1)*(mncx6-1+2*ep))*mncdeno(-1+mncx6,2)
       )*`P6'.`P6'/`Q'.`Q'/(mncx6-1)*mncdeno(-2+mncx4+mncx6,2)
      +(-`P1'.`P1'*`P4'.`P4'*acc(-3+4*ep+mncx4+mncx6)/`Q'.`Q'
        -`P8'.`P8'*`P4'.`P4'/`P5'.`P5'
        +`P4'.`P4'*acc(mncx4+mncx6-2+4*ep)
      )*mncdeno(-2+mncx4+mncx6,2)
      +(-`P1'.`P1'*`P3'.`P3'*acc(-3+4*ep+mncx4+mncx6)/`Q'.`Q'
        -`P5'.`P5'*`P3'.`P3'/`P8'.`P8'
        +`P3'.`P3'*acc(mncx4+mncx6-2+4*ep)
      )*mncdeno(-1+mncx6,2)
    );

while ( ( match(1/`P1'.`P1'/`P7'.`P7'/`P4'.`P4'^2/`P3'.`P3'
               /`P8'.`P8'/`P6'.`P6'/`P2'.`P2'/`P5'.`P5') > 0 )
    && ( count(`P1'.`P1',-1,`P4'.`P4',-1,`P3'.`P3',-1,`P6'.`P6',-1)
        > `INRTABL' ) )
  id  1/`P1'.`P1'/`P7'.`P7'/`P4'.`P4'^mncx4?
    /`P3'.`P3'/`P8'.`P8'/`P6'.`P6'
    /`P2'.`P2'/`P5'.`P5' = 
    1/`P1'.`P1'/`P7'.`P7'/`P4'.`P4'^mncx4
    /`P3'.`P3'/`P8'.`P8'/`P6'.`P6'
    /`P2'.`P2'/`P5'.`P5'/`Q'.`Q'*(
      +acc(mncx4-1+4*ep)*`P4'.`P4'/(mncx4-1)
      +`P3'.`P3'
      +`P8'.`P8'*`P4'.`P4'/`P5'.`P5'*acc(1+2*ep/(mncx4-1))*mncdeno(-1+mncx4,2)
      +`P2'.`P2'*`P4'.`P4'/`P7'.`P7'*acc(1+2*ep/(mncx4-1))*mncdeno(-1+mncx4,2)
      +acc(-2+4*ep+mncx4)*(
          -`P1'.`P1'*acc(-1+6*ep+mncx4)
          -`P6'.`P6'*acc(-1+6*ep+mncx4)
       )*`P4'.`P4'/`Q'.`Q'/(mncx4-1)*mncdeno(-1+mncx4,2)
      +(-`P3'.`P3'*`P1'.`P1'*acc(-2+4*ep+mncx4)/`Q'.`Q'
        -`P5'.`P5'*`P1'.`P1'/`P7'.`P7'
        +`P1'.`P1'*acc(mncx4-1+4*ep)
      )*mncdeno(-1+mncx4,2)
      +(-`P3'.`P3'*`P6'.`P6'*acc(-2+4*ep+mncx4)/`Q'.`Q'
        -`P7'.`P7'*`P6'.`P6'/`P5'.`P5'
        +`P6'.`P6'*acc(mncx4-1+4*ep)
      )*mncdeno(-1+mncx4,2)
    );
#endif
id  mncdeno(0,2) = 1/2/ep;
id  mncdeno(mncx1?,2) = acc(1-2*ep/mncx1+4*ep^2/mncx1^2-8*ep^3/mncx1^3+16*ep^4/mncx1^4
	-32*ep^5/mncx1^5+64*ep^6/mncx1^6)/mncx1;
repeat id acc(mncx1?)*acc(mncx2?) = acc(mncx1*mncx2);
*
*   Integrals that are left can be looked up in the table.
*   We may have to apply symmetries to map it to an actual
*   element of the table.
*
if ( match( 1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
             /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8' ) > 0 );
    if ( count(`P1'.`P1',1) > count(`P6'.`P6',1) )
        multiply replace_(`P1',`P6',`P6',`P1');
    if ( count(`P3'.`P3',1) > count(`P4'.`P4',1) )
        multiply replace_(`P3',`P4',`P4',`P3');
    if ( ( count(`P1'.`P1',1) > count(`P3'.`P3',1) )
    || ( ( count(`P1'.`P1',1) == count(`P3'.`P3',1) )
      && ( count(`P4'.`P4',1) > count(`P6'.`P6',1) ) ) )
        multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4');
    if ( ( count(`P1'.`P1',1) > count(`P4'.`P4',1) )
    || ( ( count(`P1'.`P1',1) == count(`P4'.`P4',1) )
      && ( count(`P3'.`P3',1) > count(`P6'.`P6',1) ) ) )
        multiply replace_(`P1',`P4',`P4',`P1',`P3',`P6',`P6',`P3');
    if ( count(`P1'.`P1',1) > count(`P6'.`P6',1) )
        multiply replace_(`P1',`P6',`P6',`P1');
    if ( count(`P3'.`P3',1) > count(`P4'.`P4',1) )
        multiply replace_(`P3',`P4',`P4',`P3');
  id `INTS'/`P1'.`P1'^mncx1?/`P2'.`P2'/`P3'.`P3'^mncx3?/`P4'.`P4'^mncx4?
           /`P5'.`P5'/`P6'.`P6'^mncx6?/`P7'.`P7'/`P8'.`P8' =
           mncrtab(mncx1,mncx3,mncx4,mncx6)*mnceq^3/`Q'.`Q'^(mncx1+mncx3+mncx4+mncx6-2);
endif;

#endprocedure;
*--#] rplane : 
*--#[ scalars :
#procedure scalars(TOPO)
#switch `TOPO'
*--#[ la :
#case la
*
#ifdef `LATRANS'
#if ( `LATRANS' == 1 )
  #call ACCU2(AB Q.p3  p3.p3 Q.Q p4.p4,Ladder rewrite 0)
    id  Q.p3 = p3.p3/2-p4.p4/2+Q.Q/2;
  #call ACCU2(AB Q.p2  p2.p2 Q.Q p5.p5,Ladder rewrite 1)
    id  Q.p2 = p2.p2/2+Q.Q/2-p5.p5/2;
  #call ACCU2(AB p2.p7 p1.p1 p2.p2 p7.p7,Ladder rewrite 2)
    id  p2.p7 = p1.p1/2-p2.p2/2-p7.p7/2;
  #call ACCU2(AB p2.p3 p3.p3 p2.p2 p8.p8,Ladder rewrite 3)
    id  p2.p3 = p3.p3/2+p2.p2/2-p8.p8/2;
  #call ACCU2(AB Q.p7 p1.p1 p2.p2 p5.p5 p6.p6,Ladder rewrite 4)
    id  Q.p7 = p1.p1/2-p2.p2/2+p5.p5/2-p6.p6/2;
  #call ACCU(Ladder rewrite 5)
#else
#if ( `LATRANS' == 2 )
  #call ACCU2(AB p3.p7 p1.p7 p7.p8 p7.p7,Ladder rewrite 0)
    id  p3.p7 = p1.p7-p7.p7+p7.p8;
  #call ACCU2(AB Q.p3  p3.p3 Q.Q p4.p4,Ladder rewrite 1)
    id  Q.p3 = p3.p3/2-p4.p4/2+Q.Q/2;
  #call ACCU2(AB Q.p1  p1.p1 Q.Q p6.p6,Ladder rewrite 2)
    id  Q.p1 = p1.p1/2+Q.Q/2-p6.p6/2;
  #call ACCU2(AB p1.p7 p1.p1 p2.p2 p7.p7,Ladder rewrite 3)
    id  p1.p7 = p1.p1/2-p2.p2/2+p7.p7/2;
  #call ACCU2(AB Q.p7 p1.p1 p2.p2 p5.p5 p6.p6,Ladder rewrite 4)
    id  Q.p7 = p1.p1/2-p2.p2/2+p5.p5/2-p6.p6/2;
  #call ACCU(Ladder rewrite 5)
#else
#if ( `LATRANS' == 3 )
  #call ACCU2(AB Q.p2 p2.p2 Q.Q p5.p5,Ladder rewrite 0)
    id  Q.p2 = p2.p2/2+Q.Q/2-p5.p5/2;
  #call ACCU2(AB p2.p7 p1.p1 p2.p2 p7.p7,Ladder rewrite 1)
    id  p2.p7 = p1.p1/2-p2.p2/2-p7.p7/2;
  #call ACCU2(AB p2.p8 p3.p3 p2.p2 p8.p8,Ladder rewrite 2)
    id  p2.p8 = p3.p3/2-p2.p2/2-p8.p8/2;
  #call ACCU2(AB Q.p7 p1.p1 p2.p2 p5.p5 p6.p6,Ladder rewrite 3)
    id  Q.p7 = p1.p1/2-p2.p2/2+p5.p5/2-p6.p6/2;
  #call ACCU2(AB Q.p8 p3.p3 p2.p2 p5.p5 p4.p4,Ladder rewrite 4)
    id  Q.p8 = p3.p3/2-p2.p2/2+p5.p5/2-p4.p4/2;
  #call ACCU(Ladder rewrite 5)
#else
  #call ACCU2(AB Q.p1 p1.p1 p6.p6 Q.Q,Ladder rewrite 0)
    id  Q.p1 = p1.p1/2-p6.p6/2+Q.Q/2;
  #call ACCU2(AB Q.p3 p3.p3 p4.p4 Q.Q,Ladder rewrite 1)
    id  Q.p3 = p3.p3/2-p4.p4/2+Q.Q/2;
  #call ACCU2(AB Q.p2  p2.p2 Q.Q p5.p5,Ladder rewrite 2)
    id  Q.p2 = p2.p2/2+Q.Q/2-p5.p5/2;
  #call ACCU2(AB p1.p2 p1.p1 p2.p2 p7.p7,Ladder rewrite 3)
    id  p1.p2 = p1.p1/2+p2.p2/2-p7.p7/2;
  #call ACCU2(AB p2.p3 p3.p3 p2.p2 p8.p8,Ladder rewrite 4)
    id  p2.p3 = p3.p3/2+p2.p2/2-p8.p8/2;
  #call ACCU(Ladder rewrite 5)
#endif
#endif
#endif
#else
  #call ACCU2(AB Q.p1 p1.p1 p6.p6 Q.Q,Ladder rewrite 0)
    id  Q.p1 = p1.p1/2-p6.p6/2+Q.Q/2;
  #call ACCU2(AB Q.p3 p3.p3 p4.p4 Q.Q,Ladder rewrite 1)
    id  Q.p3 = p3.p3/2-p4.p4/2+Q.Q/2;
  #call ACCU2(AB Q.p2  p2.p2 Q.Q p5.p5,Ladder rewrite 2)
    id  Q.p2 = p2.p2/2+Q.Q/2-p5.p5/2;
  #call ACCU2(AB p1.p2 p1.p1 p2.p2 p7.p7,Ladder rewrite 3)
    id  p1.p2 = p1.p1/2+p2.p2/2-p7.p7/2;
  #call ACCU2(AB p2.p3 p3.p3 p2.p2 p8.p8,Ladder rewrite 4)
    id  p2.p3 = p3.p3/2+p2.p2/2-p8.p8/2;
  #call ACCU(Ladder rewrite 5)
#endif
*
#break
*--#] la : 
*--#[ be :
#case be
*
#ifndef `BEPATH'
#call ACCU2(AB p1.p3 p1.p1 p3.p3 p8.p8,Benz rewrite 0)
  id  p1.p3 = p1.p1/2+p3.p3/2-p8.p8/2;
#call ACCU2(AB p2.p3 p2.p2 p3.p3 p7.p7,Benz rewrite 1)
  id  p2.p3 = p2.p2/2+p3.p3/2-p7.p7/2;
#call ACCU2(AB p1.p2 p1.p1 p2.p2 p6.p6,Benz rewrite 2)
  id  p1.p2 = p1.p1/2+p2.p2/2-p6.p6/2;
#call ACCU2(AB Q.p1 p1.p1 Q.Q p5.p5,Benz rewrite 3)
  id  Q.p1 = p1.p1/2+Q.Q/2-p5.p5/2;
#call ACCU2(AB Q.p3 p3.p3 Q.Q p4.p4,Benz rewrite 4)
  id  Q.p3 = p3.p3/2+Q.Q/2-p4.p4/2;
#call ACCU(Benz rewrite 5)
#else
#if ( `BEPATH' == 0 )
#call ACCU2(AB p1.p3 p1.p1 p3.p3 p8.p8,Benz rewrite 0 \(0\))
  id  p1.p3 = p1.p1/2+p3.p3/2-p8.p8/2;
#call ACCU2(AB p2.p3 p2.p2 p3.p3 p7.p7,Benz rewrite 1 \(0\))
  id  p2.p3 = p2.p2/2+p3.p3/2-p7.p7/2;
#call ACCU2(AB p1.p2 p1.p1 p2.p2 p6.p6,Benz rewrite 2 \(0\))
  id  p1.p2 = p1.p1/2+p2.p2/2-p6.p6/2;
#call ACCU2(AB Q.p1 p1.p1 Q.Q p5.p5,Benz rewrite 3 \(0\))
  id  Q.p1 = p1.p1/2+Q.Q/2-p5.p5/2;
#call ACCU2(AB Q.p3 p3.p3 Q.Q p4.p4,Benz rewrite 4 \(0\))
  id  Q.p3 = p3.p3/2+Q.Q/2-p4.p4/2;
#call ACCU(Benz rewrite 5 \(0\))
#endif
#if ( `BEPATH' == 1 )
#call ACCU2(AB Q.p1 p1.p1 Q.Q p5.p5,Benz rewrite 0 \(1\))
    id  Q.p1 = p1.p1/2+Q.Q/2-p5.p5/2;
#call ACCU2(AB p1.p6 p2.p2 p1.p1 p6.p6,Benz rewrite 1 \(1\))
    id  p1.p6 = p2.p2/2-p1.p1/2-p6.p6/2;
#call ACCU2(AB p6.p8 p6.p6 p8.p8 p7.p7,Benz rewrite 2 \(1\))
    id  p6.p8 = p6.p6/2+p8.p8/2-p7.p7/2;
#call ACCU2(AB p1.p8 p3.p3 p1.p1 p8.p8,Benz rewrite 3 \(1\))
    id  p1.p8 = p3.p3/2-p1.p1/2-p8.p8/2;
#call ACCU2(AB Q.p8 p3.p3 p4.p4 p1.p1 p5.p5,Benz rewrite 4 \(1\))
    id  Q.p8 = p3.p3/2-p4.p4/2-p1.p1/2+p5.p5/2;
#call ACCU2(AB Q.p6 Q.p2 Q.Q p1.p1 p5.p5,Benz rewrite 5 \(1\))
#endif
#if ( `BEPATH' == 2 )
#call ACCU2(AB p1.p2 p1.p1 p2.p2 p6.p6,Benz rewrite 0 \(2\))
    id  p1.p2 = p1.p1/2+p2.p2/2-p6.p6/2;
#call ACCU2(AB p2.p7 p2.p2 p7.p7 p3.p3,Benz rewrite 1 \(2\))
    id  p2.p7 = p2.p2/2+p7.p7/2-p3.p3/2;
#call ACCU2(AB Q.p1 p1.p1 Q.Q p5.p5,Benz rewrite 2 \(2\))
    id  Q.p1 = p1.p1/2+Q.Q/2-p5.p5/2;
#call ACCU2(AB Q.p7 Q.p2 Q.Q p3.p3 p4.p4,Benz rewrite 3 \(2\))
    id  Q.p7 = Q.p2-Q.Q/2-p3.p3/2+p4.p4/2;
#call ACCU2(AB p1.p7 p2.p2 p6.p6 p3.p3 p8.p8,Benz rewrite 4 \(2\))
    id  p1.p7 = p2.p2/2-p6.p6/2-p3.p3/2+p8.p8/2;
#call ACCU(Benz rewrite 5 \(2\))
#endif
#if ( `BEPATH' == 3 )
#call ACCU2(AB p6.p8 p6.p6 p8.p8 p7.p7,Benz rewrite 0 \(3\))
    id  p6.p8 = p6.p6/2+p8.p8/2-p7.p7/2;
#call ACCU2(AB p2.p6 p2.p2 p6.p6 p1.p1,Benz rewrite 1 \(3\))
    id  p2.p6 = p2.p2/2+p6.p6/2-p1.p1/2;
#call ACCU2(AB p2.p8 p3.p3 p1.p1 p7.p7 p6.p6,Benz rewrite 2 \(3\))
    id  p2.p8 = p3.p3/2-p1.p1/2-p7.p7/2+p6.p6/2;
#call ACCU2(AB Q.p8 p3.p3 p4.p4 p1.p1 p5.p5,Benz rewrite 3 \(3\))
    id  Q.p8 = p3.p3/2-p4.p4/2-p1.p1/2+p5.p5/2;
#call ACCU2(AB Q.p6 Q.p2 Q.Q p1.p1 p5.p5,Benz rewrite 4 \(3\))
    id  Q.p6 = Q.p2-Q.Q/2-p1.p1/2+p5.p5/2;
#call ACCU(Benz rewrite 5 \(3\))
#endif
#if ( `BEPATH' == 4 )
#call ACCU2(AB p6.p8 p6.p6 p8.p8 p7.p7,Benz rewrite 0 \(4\))
    id  p6.p8 = p6.p6/2+p8.p8/2-p7.p7/2;
#call ACCU2(AB p4.p8 p4.p4 p8.p8 p5.p5,Benz rewrite 1 \(4\))
    id  p4.p8 = p4.p4/2+p8.p8/2-p5.p5/2;
#call ACCU2(AB Q.p4 p3.p3 Q.Q p4.p4,Benz rewrite 2 \(4\))
    id  Q.p4 = p3.p3/2-Q.Q/2-p4.p4/2;
#call ACCU2(AB Q.p8 p3.p3 p4.p4 p1.p1 p5.p5,Benz rewrite 3 \(4\))
    id  Q.p8 = p3.p3/2-p4.p4/2-p1.p1/2+p5.p5/2;
#call ACCU2(AB p4.p6 Q.p6 p1.p1 p2.p2 p7.p7 p8.p8,Benz rewrite 4 \(4\))
    id  p4.p6 = -Q.p6-p1.p1/2+p2.p2/2+p8.p8/2-p7.p7/2;
#call ACCU(Benz rewrite 5 \(4\))
#endif
#if ( `BEPATH' == 5 )
#call ACCU2(AB p1.p6 p2.p2 p1.p1 p6.p6,Benz rewrite 0 \(5\))
    id  p1.p6 = p2.p2/2-p1.p1/2-p6.p6/2;
#call ACCU2(AB p6.p7 p6.p6 p7.p7 p8.p8,Benz rewrite 1 \(5\))
    id  p6.p7 = p6.p6/2+p7.p7/2-p8.p8/2;
#call ACCU2(AB Q.p1 p1.p1 Q.Q p5.p5,Benz rewrite 2 \(5\))
    id  Q.p1 = p1.p1/2+Q.Q/2-p5.p5/2;
#call ACCU2(AB p1.p7 p2.p2 p6.p6 p3.p3 p8.p8,Benz rewrite 3 \(5\))
    id  p1.p7 = p2.p2/2-p6.p6/2-p3.p3/2+p8.p8/2;
#call ACCU2(AB Q.p6 Q.p2 Q.Q p1.p1 p5.p5,Benz rewrite 4 \(5\))
    id  Q.p6 = Q.p7+p3.p3/2-p4.p4/2-p1.p1/2+p5.p5/2;
#call ACCU(Benz rewrite 5 \(5\))
#endif
#if ( `BEPATH' == 6 )
#call ACCU2(AB p5.p8 p4.p4 p5.p5 p8.p8,Benz rewrite 0 \(6\))
    id  p5.p8 = p4.p4/2-p5.p5/2-p8.p8/2;
#call ACCU2(AB p6.p8 p6.p6 p8.p8 p7.p7,Benz rewrite 1 \(6\))
    id  p6.p8 = p6.p6/2+p8.p8/2-p7.p7/2;
#call ACCU2(AB Q.p5 p1.p1 Q.Q p5.p5,Benz rewrite 2 \(6\))
    id  Q.p5 = p1.p1/2-Q.Q/2-p5.p5/2;
#call ACCU2(AB p5.p6 p2.p2 p1.p1 p6.p6 Q.p6,Benz rewrite 3 \(6\))
    id  p5.p6 = p2.p2/2-p1.p1/2-p6.p6/2-Q.p6;
#call ACCU2(AB Q.p8 p3.p3 p4.p4 p1.p1 p5.p5,Benz rewrite 4 \(6\))
    id  Q.p8 = p3.p3/2-p4.p4/2-p1.p1/2+p5.p5/2;
#call ACCU(Benz rewrite 5 \(6\))
#endif
#if ( `BEPATH' == 7 )
#call ACCU2(AB p4.p5 p4.p4 p5.p5 p8.p8,Benz rewrite 0 \(7\))
    id  p4.p5 = p4.p4/2+p5.p5/2-p8.p8/2;
#call ACCU2(AB Q.p4 p3.p3 Q.Q p4.p4,Benz rewrite 1 \(7\))
    id  Q.p4 = p3.p3/2-Q.Q/2-p4.p4/2;
#call ACCU2(AB Q.p5 p1.p1 Q.Q p5.p5,Benz rewrite 2 \(7\))
    id  Q.p5 = p1.p1/2-Q.Q/2-p5.p5/2;
#call ACCU2(AB p2.p4 p2.p2 p3.p3 p7.p7 Q.p2,Benz rewrite 3 \(7\))
    id  p2.p4 = p2.p2/2+p3.p3/2-p7.p7/2-Q.p2;
#call ACCU2(AB p2.p5 p2.p2 p1.p1 p6.p6 Q.p2,Benz rewrite 4 \(7\))
    id  p2.p5 = p2.p2/2+p1.p1/2-p6.p6/2-Q.p2;
#call ACCU(Benz rewrite 5 \(7\))
#endif
#if ( `BEPATH' == 8 )
#call ACCU2(AB p2.p6 p2.p2 p1.p1 p6.p6,Benz rewrite 0 \(8\))
    id  p2.p6 = p2.p2/2+p6.p6/2-p1.p1/2;
#call ACCU2(AB p2.p7 p2.p2 p7.p7 p3.p3,Benz rewrite 1 \(8\))
    id  p2.p7 = p2.p2/2+p7.p7/2-p3.p3/2;
#call ACCU2(AB p6.p7 p6.p6 p7.p7 p8.p8,Benz rewrite 2 \(8\))
    id  p6.p7 = p6.p6/2+p7.p7/2-p8.p8/2;
#call ACCU2(AB Q.p6 Q.p2 Q.Q p1.p1 p5.p5,Benz rewrite 3 \(8\))
    id  Q.p6 = Q.p2-Q.Q/2-p1.p1/2+p5.p5/2;
#call ACCU2(AB Q.p7 Q.p2 Q.Q p3.p3 p4.p4,Benz rewrite 4 \(8\))
    id  Q.p7 = Q.p2-Q.Q/2-p3.p3/2+p4.p4/2;
#call ACCU(Benz rewrite 5 \(8\))
#endif
#endif
*
#break
*--#] be : 
*--#[ no :
#case no
*
#ifndef `NOSPEC'
#call ACCU2(AB p1.Q p1.p1 Q.Q p6.p6,no rewrite 0)
  id  p1.Q = p1.p1/2+Q.Q/2-p6.p6/2;
#call ACCU2(AB p3.Q p3.p3 Q.Q p4.p4,no rewrite 1)
  id  p3.Q = p3.p3/2+Q.Q/2-p4.p4/2;
#call ACCU2(AB p1.p2 p1.p1 p2.p2 p7.p7,no rewrite 2)
  id  p1.p2 = p1.p1/2+p2.p2/2-p7.p7/2;
#call ACCU2(AB p2.p3 p3.p3 p2.p2 p8.p8,no rewrite 3)
  id  p3.p2 = p3.p3/2+p2.p2/2-p8.p8/2;
#call ACCU(no rewrite 4)
    id p1.p3 = -p2.Q+p1.p1/2+p2.p2/2+p3.p3/2+p5.p5/2
                 +Q.Q/2-p4.p4/2-p6.p6/2-p7.p7/2-p8.p8/2;
#call ACCU(no rewrite 5)
#else
#if ( `NOSPEC' == 0 )
#call ACCU2(AB p1.Q p1.p1 Q.Q p6.p6,no rewrite 0)
  id  p1.Q = p1.p1/2+Q.Q/2-p6.p6/2;
#call ACCU2(AB p3.Q p3.p3 Q.Q p4.p4,no rewrite 1)
  id  p3.Q = p3.p3/2+Q.Q/2-p4.p4/2;
#call ACCU2(AB p1.p2 p1.p1 p2.p2 p7.p7,no rewrite 2)
  id  p1.p2 = p1.p1/2+p2.p2/2-p7.p7/2;
#call ACCU2(AB p2.p3 p3.p3 p2.p2 p8.p8,no rewrite 3)
  id  p2.p3 = p3.p3/2+p2.p2/2-p8.p8/2;
#call ACCU(no rewrite 4)
  id p1.p3 = -p2.Q+p1.p1/2+p2.p2/2+p3.p3/2+p5.p5/2
            +Q.Q/2-p4.p4/2-p6.p6/2-p7.p7/2-p8.p8/2;
#call ACCU(no rewrite 5)
#endif
#if ( `NOSPEC' == 1 )
  id  p2.p7 = p2.p2/2+p7.p7/2-p1.p1/2;
#call ACCU2(AB p2.p8 p3.p3 p2.p2 p8.p8,no rewrite 0)
  id  p2.p8 = -p3.p3/2+p2.p2/2+p8.p8/2;
#call ACCU2(AB p7.Q Q.p2 p1.p1 Q.Q p6.p6,no rewrite 2)
  id  p7.Q = Q.p2-p1.p1/2-Q.Q/2+p6.p6/2;
#call ACCU2(AB p8.Q p3.p3 Q.Q p4.p4 Q.p2,no rewrite 3)
  id  p8.Q = Q.p2-p3.p3/2-Q.Q/2+p4.p4/2;
#call ACCU(no rewrite 4)
    id,p1.p3 = -p2.Q+p1.p1/2+p2.p2/2+p3.p3/2+p5.p5/2
                 +Q.Q/2-p4.p4/2-p6.p6/2-p7.p7/2-p8.p8/2;
#call ACCU(no rewrite 5)
#endif
#if ( `NOSPEC' == 2 )
#call ACCU2(AB p1.Q p1.p1 Q.Q p6.p6,no rewrite 0)
  id  p1.Q = p1.p1/2+Q.Q/2-p6.p6/2;
#call ACCU2(AB p8.Q p2.Q p3.p3 Q.Q p4.p4,no rewrite 1)
  id  p8.Q = p2.Q-p3.p3/2-Q.Q/2+p4.p4/2;
#call ACCU2(AB p1.p2 p1.p1 p2.p2 p7.p7,no rewrite 2)
  id  p1.p2 = p1.p1/2+p2.p2/2-p7.p7/2;
#call ACCU2(AB p2.p8 p3.p3 p2.p2 p8.p8,no rewrite 3)
  id  p2.p8 = p8.p8/2+p2.p2/2-p3.p3/2;
#call ACCU2(AB p1.p8 p2.Q p3.p3 p5.p5 Q.Q p4.p4 p6.p6 p8.p8,no rewrite 4)
  id p1.p8 = +p2.Q-p3.p3/2-p5.p5/2
                 -Q.Q/2+p4.p4/2+p6.p6/2+p8.p8/2;
#call ACCU(no rewrite 5)
#endif
#endif
*
#break
*--#] no : 
*--#[ fa :
#case fa
*
*
#break
*--#] fa : 
*--#[ bu :
#case bu
*
*
#break
*--#] bu : 
*--#[ o1 :
#case o1
*
#ifndef `O1PATH'
id  p1.p2 = p1.p1/2+p2.p2/2-p5.p5/2;
#call ACCU(o1 rewite 1)
id  Q.p1 = p1.p1/2+Q.Q/2-p4.p4/2;
id  Q.p2 = p2.p2/2+Q.Q/2-p3.p3/2;
#call ACCU(o1 rewite 2)
#else
#if ( `O1PATH' == 0 )
id  p1.p2 = p1.p1/2+p2.p2/2-p5.p5/2;
#call ACCU(o1 rewite 1\(0\))
id  Q.p1 = p1.p1/2+Q.Q/2-p4.p4/2;
id  Q.p2 = p2.p2/2+Q.Q/2-p3.p3/2;
#call ACCU(o1 rewite 2\(0\))
#endif
#if ( `O1PATH' == 1 )
id  p1.p7 = -p1.p6+p1.p1/2+p5.p5/2-p2.p2/2;
id  p6.p7 = p5.p5/2-p6.p6/2-p7.p7/2;
#call ACCU(o1 rewite 1\(1\))
id  Q.p1 = p1.p1/2+Q.Q/2-p4.p4/2;
id  Q.p7 = -Q.p6+p1.p1/2-p2.p2/2+p3.p3/2-p4.p4/2;
#call ACCU(o1 rewite 2\(1\))
#endif
#if ( `O1PATH' == 2 )
id  p1.p5 = p1.p1/2+p5.p5/2-p2.p2/2;
id  p5.p6 = p5.p5/2+p6.p6/2-p7.p7/2;
#call ACCU(o1 rewite 1\(2\))
id  Q.p1 = p1.p1/2+Q.Q/2-p4.p4/2;
id  Q.p5 = p1.p1/2-p2.p2/2+p3.p3/2-p4.p4/2;
#call ACCU(o1 rewite 2\(2\))
#endif
#endif
*
#break
*--#] o1 : 
*--#[ o2 :
#case o2
*
id  p4.p6 = p4.p4/2+p6.p6/2-p7.p7/2;
id  p3.p4 = p3.p3/2+p4.p4/2-p5.p5/2;
#call ACCU(o2 rewrite 1)
id  Q.p3 = p2.p2/2-Q.Q/2-p3.p3/2;
id  Q.p4 = p1.p1/2-Q.Q/2-p4.p4/2;
#call ACCU(o2 rewrite 2)
*
#break
*--#] o2 : 
*--#[ o3 :
#case o3
*
id  Q.p6 = p6.p6/2+Q.Q/2-p7.p7/2;
id  p1.p2 = p1.p1/2+p2.p2/2-p5.p5/2;
#call ACCU(o3 rewrite 1)
id  Q.p1 = p1.p1/2+Q.Q/2-p4.p4/2;
id  Q.p2 = p2.p2/2+Q.Q/2-p3.p3/2;
#call ACCU(o3 rewrite 2)
*
#break
*--#] o3 : 
*--#[ o4 :
#case o4
*
id  Q.p6 = p6.p6/2+Q.Q/2-p7.p7/2;
id  p1.p2 = p1.p1/2+p2.p2/2-p5.p5/2;
#call ACCU(o4 rewrite 1)
id  p1.p6 = p1.p1/2+p6.p6/2-p4.p4/2;
id  p2.p6 = p2.p2/2+p6.p6/2-p3.p3/2;
#call ACCU(o4 rewrite 2)
*
#break
*--#] o4 : 
*--#[ y1 :
#case y1
*
id  p1.p3 = p1.p1/2+p3.p3/2-p4.p4/2;
id  Q.p1 = p1.p1/2+Q.Q/2-p2.p2/2;
#call ACCU(y1 rewrite)
*
#break
*--#] y1 : 
*--#[ y2 :
#case y2
*
id  p1.p3 = p1.p1/2+p3.p3/2-p4.p4/2;
#call ACCU(y2 rewrite 1)
id  p1.p5 = p1.p1/2+p5.p5/2-p6.p6/2;
#call ACCU(y2 rewrite 2)
id  Q.p1 = p1.p1/2+Q.Q/2-p2.p2/2;
#call ACCU(y2 rewrite 3)
*
#break
*--#] y2 : 
*--#[ y3 :
#case y3
*
id  p1.p3 = p1.p1/2+p3.p3/2-p4.p4/2;
#call ACCU(y3 rewrite 1)
id  p3.p5 = p3.p3/2+p5.p5/2-p6.p6/2;
#call ACCU(y3 rewrite 2)
id  Q.p1 = p1.p1/2+Q.Q/2-p2.p2/2;
#call ACCU(y3 rewrite 3)
*
#break
*--#] y3 : 
*--#[ y4 :
#case y4
*
id  Q.p5 = p5.p5/2+Q.Q/2-p6.p6/2;
#call ACCU(y4 rewrite 1)
id  p1.p3 = p1.p1/2+p3.p3/2-p4.p4/2;
#call ACCU(y4 rewrite 2)
id  Q.p1 = p1.p1/2+Q.Q/2-p2.p2/2;
#call ACCU(y4 rewrite 3)
*
#break
*--#] y4 : 
*--#[ y5 :
#case y5
*
id  Q.p5 = p5.p5/2+Q.Q/2-p6.p6/2;
#call ACCU(y5 rewrite 1)
id  Q.p3 = p3.p3/2+Q.Q/2-p4.p4/2;
#call ACCU(y5 rewrite 2)
id  Q.p1 = p1.p1/2+Q.Q/2-p2.p2/2;
#call ACCU(y5 rewrite 3)
*
#break
*--#] y5 : 
*--#[ t1 :
#case t1
*
id  p1.p2 = p1.p1/2+p2.p2/2-p5.p5/2;
#call ACCU(t1 rewrite 1)
id  Q.p1 = p1.p1/2+Q.Q/2-p4.p4/2;
#call ACCU(t1 rewrite 2)
id  Q.p2 = p2.p2/2+Q.Q/2-p3.p3/2;
#call ACCU(t1 rewrite 3)
*
#break
*--#] t1 : 
*--#[ t2 :
#case t2
*
id  p1.p3 = p1.p1/2+p3.p3/2-p4.p4/2;
#call ACCU(t2 rewrite 1)
id  Q.p1 = p1.p1/2+Q.Q/2-p2.p2/2;
#call ACCU(t2 rewrite 2)
*
#break
*--#] t2 : 
*--#[ t3 :
#case t3
*
id  Q.p3 = p3.p3/2+Q.Q/2-p4.p4/2;
#call ACCU(t3 rewrite 1)
id  Q.p1 = p1.p1/2+Q.Q/2-p2.p2/2;
#call ACCU(t3 rewrite 2)
*
#break
*--#] t3 : 
*--#[ l1 :
#case l1
*
*
#break
*--#] l1 : 
*--#[ l2 :
#case l2
*
*
#break
*--#] l2 : 
*--#[ l3 :
#case l3
*
*
#break
*--#] l3 : 
*--#[ tr :
#case tr
*
*
#break
*--#] tr : 
#endswitch
#endprocedure
*--#] scalars : 
*--#[ simplify :
#procedure simplify
*
*	Note: The acc's are leftovers when the gamma's are normalized.
*	In that case two gamma's had to be reduced down, so that the
*	first part is one. Actually the first acc can be cancelled
*	against the factors in the definition of the exp's.
*
if ( match(mncG(?a,0,0)) );
id	mncG(mncx1?,0,mncy1?,0,0,0) = mncaccm(mncT00(mncx1,mncy1));
id	mncG(mncx1?,1,mncy1?,0,0,0) = mncexp10*mncaccm(mncT10(mncx1,mncy1));
id	mncG(mncx1?,0,mncy1?,1,0,0) = mncexp10*mncaccm(mncT10(mncy1,mncx1));
id	mncG(mncx1?,2,mncy1?,0,0,0) = mncexp20*mncaccm(mncT20(mncx1,mncy1));
id	mncG(mncx1?,0,mncy1?,2,0,0) = mncexp20*mncaccm(mncT20(mncy1,mncx1));
id	mncG(mncx1?,1,mncy1?,1,0,0) = mncexp11*mncaccm(mncT11(mncx1,mncy1));
id	mncaccm(mncT00(mncx?,mncy?)) = mncG(mncx,0,mncy,0,0,0);
id	mncaccm(mncT10(mncx?,mncy?)) = mncG(mncx,1,mncy,0,0,0)/mncexp10;
id	mncaccm(mncT20(mncx?,mncy?)) = mncG(mncx,2,mncy,0,0,0)/mncexp20;
id	mncaccm(mncT11(mncx?,mncy?)) = mncG(mncx,1,mncy,1,0,0)/mncexp11;
id	mncaccm(mncx?) = acc(mncx);
endif;
if ( count(mncG,1) );
id	mncG(mncx1?,mncy1?,mncx2?,mncy2?,D?,mncs?) = mncpo(mncx1+mncx2-mncs-2,1+mncy1+mncy2)
	*mncpo(2-mncx1+D-mncs,-1-mncy1)*mncpo(2-mncx2+mncs,-1-mncy2)
		*acc(1-2*ep-ep*mncy1-ep*mncy2)
	*mncpoinv(mncx1,mncy1)*mncpoinv(mncx2,mncy2)*mncpoinv(4-mncx1-mncx2+D,-2-mncy1-mncy2)
	*mncG(1,mncy1,1,mncy2,0,0);
id  mncG(1,0,1,0,0,0) = 1;
id  mncG(1,1,1,1,0,0) = mncexp11; *1/3
id  mncG(1,0,1,1,0,0) = mncexp10; *1/2
id  mncG(1,1,1,0,0,0) = mncexp10; *1/2
id  mncG(1,0,1,2,0,0) = mncexp20; *1/3
id  mncG(1,2,1,0,0,0) = mncexp20; *1/3

id mncpo(1,?a) = 1;
id mncpoinv(1,?a) = 1;
id mncpo(mncx1?pos_,0) = fac_(mncx1-1);
id mncpoinv(mncx1?pos_,0) = invfac_(mncx1-1);

id,many,mncpo(mncx1?neg0_,mncx2?) = acc(mncPO(mncx1,mncx2))/mncx2/ep;
id,many,mncpo(mncx1?,mncx2?) = acc(mncPO(mncx1,mncx2));
id,many,mncpoinv(mncx1?neg0_,mncx2?) = acc(mncPOINV(mncx1,mncx2))*mncx2*ep;
id,many,mncpoinv(mncx1?,mncx2?) = acc(mncPOINV(mncx1,mncx2));

endif;
id  mncexp10*mncexp20 = mncexp11*acc(1+ep+3*ep^2+9*ep^3+27*ep^4+81*ep^5+243*ep^6);

multiply ep;

#endprocedure

*--#] simplify : 
*--#[ special :
#procedure special(TOPO)
#switch `TOPO'
*--#[ la :
#case la
*
id  mncDg(?a,mncp?[mncpp18][mncx]) = mncDg(?a,mncp)*[mncx18][mncx];
id  mncDg(?a,mncp?[-mncpp18][mncx]) = mncDg(?a,mncp)*[mncx18][mncx];
id  mncDg(?a,-mncp?[mncpp18][mncx]) = mncDg(?a,-mncp)*[mncx18][mncx];
id  mncDg(?a,-mncp?[-mncpp18][mncx]) = mncDg(?a,-mncp)*[mncx18][mncx];
id  mncDgh(?a,mncp?[mncpp18][mncx]) = mncDgh(?a,mncp)*[mncx18][mncx];
id  mncDgh(?a,mncp?[-mncpp18][mncx]) = mncDgh(?a,mncp)*[mncx18][mncx];
id  mncDgh(?a,-mncp?[mncpp18][mncx]) = mncDgh(?a,-mncp)*[mncx18][mncx];
id  mncDgh(?a,-mncp?[-mncpp18][mncx]) = mncDgh(?a,-mncp)*[mncx18][mncx];
id  mncfp(?a,mncp?[mncpp18][mncx]) = mncfp(?a,mncp)*[mncx18][mncx];
id  mncfp(?a,mncp?[-mncpp18][mncx]) = mncfp(?a,mncp)*[mncx18][mncx];
id  mncfp(?a,-mncp?[mncpp18][mncx]) = mncfp(?a,-mncp)*[mncx18][mncx];
id  mncfp(?a,-mncp?[-mncpp18][mncx]) = mncfp(?a,-mncp)*[mncx18][mncx];

if ( ( count(mncx5,1) > 0 ) && ( count(mncx2,1) == 0 ) );
	multiply,replace_(
	 [P-p1],[P+p6],[P+p1],[P-p6],[P+p6],[P-p1],[P-p6],[P+p1]
	,[P-p2],[P+p5],[P+p2],[P-p5],[P+p5],[P-p2],[P-p5],[P+p2]
	,[P-p3],[P+p4],[P+p3],[P-p4],[P+p4],[P-p3],[P-p4],[P+p3]
	,p1,-p6,p6,-p1,p2,-p5,p5,-p2,p3,-p4,p4,-p3,p7,-p7,p8,-p8,
	[P+p7],[P-p7],[P-p7],[P+p7],[P+p8],[P-p8],[P-p8],[P+p8]);
	multiply,replace_(mncx1,mncx6,mncx6,mncx1,mncx2,mncx5,mncx5,mncx2,mncx3,mncx4,mncx4,mncx3);
endif;
if ( ( count(mncx2,1) > 0 ) && ( count(mncx6,1) > 0 ) );
	multiply,replace_(
	 [P-p1],[P+p3],[P+p1],[P-p3],[P-p4],[P+p6],[P+p4],[P-p6]
	,[P-p3],[P+p1],[P+p3],[P-p1],[P-p6],[P+p4],[P+p6],[P-p4]
	,[P-p2],[P+p2],[P+p2],[P-p2],[P-p5],[P+p5],[P+p5],[P-p5]
	,[P-p7],[P+p8],[P+p7],[P-p8],[P-p8],[P+p7],[P+p8],[P-p7]
	,p1,-p3,p3,-p1,p4,-p6,p6,-p4,p2,-p2,p5,-p5,p7,-p8,p8,-p7,Q,-Q
	,[P+Q],[P-Q],[P-Q],[P+Q])*mncsgn3;
	multiply,replace_(mncx1,mncx3,mncx3,mncx1,mncx4,mncx6,mncx6,mncx4,mncx7,mncx8,mncx8,mncx7);
endif;
if ( match(mncx2*mncx8*mncx4) );
	if ( match(mncDg(?a,[P-p2])) || match(mncDg(?a,-[P-p2]))
	|| match(mncfp(?a,[P-p2])) || match(mncfp(?a,-[P-p2]))
	|| match(mncDgh(?a,[P-p2])) || match(mncDgh(?a,-[P-p2])) );
		multiply,replace_([P+p8],p8,[P+p4],p4,p4,-[P-p4],p3,-[P-p3],mncx8,mncx3,mncx3,mncx8);
	else;
		multiply,replace_([P-p8],-p8,[P-p4],-p4,p4,[P+p4],p3,[P+p3],mncx8,mncx3,mncx3,mncx8);
	endif;
endif;
if ( count(mncx7,1,mncx8,1) > 0 );
  if ( match(mncx7*mncx8) > 0 );
    redefine LATRANS "3";
	if ( count(mncx5,1) > 0 )
		multiply,replace_(
		 [P-p1],[P+p6],[P+p1],[P-p6],[P+p6],[P-p1],[P-p6],[P+p1]
		,[P-p2],[P+p5],[P+p2],[P-p5],[P+p5],[P-p2],[P-p5],[P+p2]
		,[P-p3],[P+p4],[P+p3],[P-p4],[P+p4],[P-p3],[P-p4],[P+p3]
		,p1,-p6,p6,-p1,p2,-p5,p5,-p2,p3,-p4,p4,-p3,p7,-p7,p8,-p8,
		[P+p7],[P-p7],[P-p7],[P+p7],[P+p8],[P-p8],[P-p8],[P+p8]);
  elseif ( (match(mncx7*mncx1) > 0) || (match(mncx7*mncx6) > 0) );
    redefine LATRANS "2";
	if ( count(mncx6,1) > 0 )
		multiply,replace_(
		 [P-p1],[P+p6],[P+p1],[P-p6],[P+p6],[P-p1],[P-p6],[P+p1]
		,[P-p2],[P+p5],[P+p2],[P-p5],[P+p5],[P-p2],[P-p5],[P+p2]
		,[P-p3],[P+p4],[P+p3],[P-p4],[P+p4],[P-p3],[P-p4],[P+p3]
		,p1,-p6,p6,-p1,p2,-p5,p5,-p2,p3,-p4,p4,-p3,p7,-p7,p8,-p8,
		[P+p7],[P-p7],[P-p7],[P+p7],[P+p8],[P-p8],[P-p8],[P+p8]);
  elseif ( (match(mncx8*mncx3) > 0) || (match(mncx8*mncx4) > 0) );
    redefine LATRANS "2";
	multiply,replace_(
		 [P-p1],[P+p3],[P+p1],[P-p3],[P-p4],[P+p6],[P+p4],[P-p6]
		,[P-p3],[P+p1],[P+p3],[P-p1],[P-p6],[P+p4],[P+p6],[P-p4]
		,[P-p2],[P+p2],[P+p2],[P-p2],[P-p5],[P+p5],[P+p5],[P-p5]
		,[P-p7],[P+p8],[P+p7],[P-p8],[P-p8],[P+p7],[P+p8],[P-p7]
		,p1,-p3,p3,-p1,p4,-p6,p6,-p4,p2,-p2,p5,-p5,p7,-p8,p8,-p7,Q,-Q
		,[P+Q],[P-Q],[P-Q],[P+Q])*mncsgn3;
	if ( count(mncx6,1) > 0 )
		multiply,replace_(
		 [P-p1],[P+p6],[P+p1],[P-p6],[P+p6],[P-p1],[P-p6],[P+p1]
		,[P-p2],[P+p5],[P+p2],[P-p5],[P+p5],[P-p2],[P-p5],[P+p2]
		,[P-p3],[P+p4],[P+p3],[P-p4],[P+p4],[P-p3],[P-p4],[P+p3]
		,p1,-p6,p6,-p1,p2,-p5,p5,-p2,p3,-p4,p4,-p3,p7,-p7,p8,-p8,
		[P+p7],[P-p7],[P-p7],[P+p7],[P+p8],[P-p8],[P-p8],[P+p8]);
  else;
    redefine LATRANS "1";
	if ( count(mncx8,1) > 0 )
		multiply,replace_(
		 [P-p1],[P+p3],[P+p1],[P-p3],[P-p4],[P+p6],[P+p4],[P-p6]
		,[P-p3],[P+p1],[P+p3],[P-p1],[P-p6],[P+p4],[P+p6],[P-p4]
		,[P-p2],[P+p2],[P+p2],[P-p2],[P-p5],[P+p5],[P+p5],[P-p5]
		,[P-p7],[P+p8],[P+p7],[P-p8],[P-p8],[P+p7],[P+p8],[P-p7]
		,p1,-p3,p3,-p1,p4,-p6,p6,-p4,p2,-p2,p5,-p5,p7,-p8,p8,-p7,Q,-Q
		,[P+Q],[P-Q],[P-Q],[P+Q])*mncsgn3;
	if ( count(mncx5,1) > 0 )
		multiply,replace_(
		 [P-p1],[P+p6],[P+p1],[P-p6],[P+p6],[P-p1],[P-p6],[P+p1]
		,[P-p2],[P+p5],[P+p2],[P-p5],[P+p5],[P-p2],[P-p5],[P+p2]
		,[P-p3],[P+p4],[P+p3],[P-p4],[P+p4],[P-p3],[P-p4],[P+p3]
		,p1,-p6,p6,-p1,p2,-p5,p5,-p2,p3,-p4,p4,-p3,p7,-p7,p8,-p8,
		[P+p7],[P-p7],[P-p7],[P+p7],[P+p8],[P-p8],[P-p8],[P+p8]);
  endif;
elseif ( count(mncx4,1,mncx5,1,mncx6,1) > count(mncx1,1,mncx2,1,mncx3,1) );
		multiply,replace_(
		 [P-p1],[P+p6],[P+p1],[P-p6],[P+p6],[P-p1],[P-p6],[P+p1]
		,[P-p2],[P+p5],[P+p2],[P-p5],[P+p5],[P-p2],[P-p5],[P+p2]
		,[P-p3],[P+p4],[P+p3],[P-p4],[P+p4],[P-p3],[P-p4],[P+p3]
		,p1,-p6,p6,-p1,p2,-p5,p5,-p2,p3,-p4,p4,-p3,p7,-p7,p8,-p8,
		[P+p7],[P-p7],[P-p7],[P+p7],[P+p8],[P-p8],[P-p8],[P+p8]);
endif;
repeat,id  mncx?[mncx18] = 1;
*
#break
*--#] la : 
*--#[ be :
#case be
*
id  mncDg(?a,mncp?[mncpp18][mncx]) = mncDg(?a,mncp)*[mncx18][mncx];
id  mncDg(?a,mncp?[-mncpp18][mncx]) = mncDg(?a,mncp)*[mncx18][mncx];
id  mncDg(?a,-mncp?[mncpp18][mncx]) = mncDg(?a,-mncp)*[mncx18][mncx];
id  mncDg(?a,-mncp?[-mncpp18][mncx]) = mncDg(?a,-mncp)*[mncx18][mncx];
id  mncDgh(?a,mncp?[mncpp18][mncx]) = mncDgh(?a,mncp)*[mncx18][mncx];
id  mncDgh(?a,mncp?[-mncpp18][mncx]) = mncDgh(?a,mncp)*[mncx18][mncx];
id  mncDgh(?a,-mncp?[mncpp18][mncx]) = mncDgh(?a,-mncp)*[mncx18][mncx];
id  mncDgh(?a,-mncp?[-mncpp18][mncx]) = mncDgh(?a,-mncp)*[mncx18][mncx];
id  mncfp(?a,mncp?[mncpp18][mncx]) = mncfp(?a,mncp)*[mncx18][mncx];
id  mncfp(?a,mncp?[-mncpp18][mncx]) = mncfp(?a,mncp)*[mncx18][mncx];
id  mncfp(?a,-mncp?[mncpp18][mncx]) = mncfp(?a,-mncp)*[mncx18][mncx];
id  mncfp(?a,-mncp?[-mncpp18][mncx]) = mncfp(?a,-mncp)*[mncx18][mncx];
if ( match(mncx4*mncx5) );
	redefine BEPATH "7";*  1,5,4 or 3,4,5 or 4,5
	if ( count(mncx3,1) > 0 )
		multiply,replace_(p1,-p3,p3,-p1,p2,-p2,p6,-p7,p7,-p6,p4,-p5,p5,-p4,Q,-Q
		,[P+p1],[P-p3],[P+p3],[P-p1],[P-p1],[P+p3],[P-p3],[P+p1]
		,[P+p4],[P-p5],[P+p5],[P-p4],[P-p4],[P+p5],[P-p5],[P+p4]
		,[P+p6],[P-p7],[P+p7],[P-p6],[P-p6],[P+p7],[P-p7],[P+p6]
		,[P+p2],[P-p2],[P-p2],[P+p2],[P+Q],[P-Q],[P-Q],[P+Q])*mncsgn3;
elseif ( match(mncx4*mncx6*mncx8) || match(mncx5*mncx7*mncx8) );
	redefine BEPATH "4";*  4,8,6 or 5,8,7 or 4,8 or 5,8
	if ( count(mncx5,1) > 0 )
		multiply,replace_(p1,-p3,p3,-p1,p2,-p2,p6,-p7,p7,-p6,p4,-p5,p5,-p4,Q,-Q
		,[P+p1],[P-p3],[P+p3],[P-p1],[P-p1],[P+p3],[P-p3],[P+p1]
		,[P+p4],[P-p5],[P+p5],[P-p4],[P-p4],[P+p5],[P-p5],[P+p4]
		,[P+p6],[P-p7],[P+p7],[P-p6],[P-p6],[P+p7],[P-p7],[P+p6]
		,[P+p2],[P-p2],[P-p2],[P+p2],[P+Q],[P-Q],[P-Q],[P+Q])*mncsgn3;
elseif ( ( count(mncx4,1,mncx5,1) > 0 ) && ( count(mncx1,1,mncx3,1) == 0 ) );
label 6;
	redefine BEPATH "6";*  4,8,7,or 5,8,6 or 4,8 or 5,8
	if ( count(mncx4,1) > 0 )
		multiply,replace_(p1,-p3,p3,-p1,p2,-p2,p6,-p7,p7,-p6,p4,-p5,p5,-p4,Q,-Q
		,[P+p1],[P-p3],[P+p3],[P-p1],[P-p1],[P+p3],[P-p3],[P+p1]
		,[P+p4],[P-p5],[P+p5],[P-p4],[P-p4],[P+p5],[P-p5],[P+p4]
		,[P+p6],[P-p7],[P+p7],[P-p6],[P-p6],[P+p7],[P-p7],[P+p6]
		,[P+p2],[P-p2],[P-p2],[P+p2],[P+Q],[P-Q],[P-Q],[P+Q])*mncsgn3;
elseif ( match(mncx1*mncx6*mncx7) || match(mncx3*mncx6*mncx7) );
	redefine BEPATH "5";*  1,6,7 or 3,7,6
	if ( count(mncx3,1) > 0 )
		multiply,replace_(p1,-p3,p3,-p1,p2,-p2,p6,-p7,p7,-p6,p4,-p5,p5,-p4,Q,-Q
		,[P+p1],[P-p3],[P+p3],[P-p1],[P-p1],[P+p3],[P-p3],[P+p1]
		,[P+p4],[P-p5],[P+p5],[P-p4],[P-p4],[P+p5],[P-p5],[P+p4]
		,[P+p6],[P-p7],[P+p7],[P-p6],[P-p6],[P+p7],[P-p7],[P+p6]
		,[P+p2],[P-p2],[P-p2],[P+p2],[P+Q],[P-Q],[P-Q],[P+Q])*mncsgn3;
elseif ( match(mncx6*mncx7) );
	redefine BEPATH "8";*  6,7
elseif ( match(mncx2*mncx8) );
	redefine BEPATH "3";*  2,6,8 or 2,7,8
	if ( count(mncx7,1) > 0 )
		multiply,replace_(p1,-p3,p3,-p1,p2,-p2,p6,-p7,p7,-p6,p4,-p5,p5,-p4,Q,-Q
		,[P+p1],[P-p3],[P+p3],[P-p1],[P-p1],[P+p3],[P-p3],[P+p1]
		,[P+p4],[P-p5],[P+p5],[P-p4],[P-p4],[P+p5],[P-p5],[P+p4]
		,[P+p6],[P-p7],[P+p7],[P-p6],[P-p6],[P+p7],[P-p7],[P+p6]
		,[P+p2],[P-p2],[P-p2],[P+p2],[P+Q],[P-Q],[P-Q],[P+Q])*mncsgn3;
elseif ( match(mncx2*mncx7) || match(mncx2*mncx6) );
	redefine BEPATH "2";*  1,2,7 or 3,2,6
	if ( count(mncx6,1) > 0 )
		multiply,replace_(p1,-p3,p3,-p1,p2,-p2,p6,-p7,p7,-p6,p4,-p5,p5,-p4,Q,-Q
		,[P+p1],[P-p3],[P+p3],[P-p1],[P-p1],[P+p3],[P-p3],[P+p1]
		,[P+p4],[P-p5],[P+p5],[P-p4],[P-p4],[P+p5],[P-p5],[P+p4]
		,[P+p6],[P-p7],[P+p7],[P-p6],[P-p6],[P+p7],[P-p7],[P+p6]
		,[P+p2],[P-p2],[P-p2],[P+p2],[P+Q],[P-Q],[P-Q],[P+Q])*mncsgn3;
elseif ( match(mncx6) || match(mncx7) || match(mncx8) );
	if ( match(mncx1*mncx5*mncx6) || match(mncx3*mncx4*mncx7) );
		if ( count(mncx3,1) )
			multiply,replace_(p1,-p3,p3,-p1,p2,-p2,p6,-p7,p7,-p6,p4,-p5,p5,-p4,Q,-Q
			,[P+p1],[P-p3],[P+p3],[P-p1],[P-p1],[P+p3],[P-p3],[P+p1]
			,[P+p4],[P-p5],[P+p5],[P-p4],[P-p4],[P+p5],[P-p5],[P+p4]
			,[P+p6],[P-p7],[P+p7],[P-p6],[P-p6],[P+p7],[P-p7],[P+p6]
			,[P+p2],[P-p2],[P-p2],[P+p2],[P+Q],[P-Q],[P-Q],[P+Q]
			,mncx3,mncx1,mncx1,mncx3,mncx4,mncx5,mncx5,mncx4,mncx6,mncx7,mncx7,mncx6)*mncsgn3;
		if ( match(mncDg(?a,[P-p6])) || match(mncDg(?a,-[P-p6]))
		|| match(mncfp(?a,[P-p6])) || match(mncfp(?a,-[P-p6]))
		|| match(mncDgh(?a,[P-p6])) || match(mncDgh(?a,-[P-p6])) );
			multiply,replace_([P+p5],p5,[P+p1],p1,[P-p6],-p6,
			p6,[P+p6],p8,[P+p8],p5,-[P-p5],[P-p5],-p5,[P-p1],-p1,[P+p6],p6,
			mncx1,mncx8,mncx8,mncx1);
		else;
*
*			This one still needs correcting in some databases
*
			multiply,replace_([P+p5],p5,[P+p1],p1,[P-p6],-p6,
			p6,-[P-p6],p8,-[P-p8],p5,[P+p5],[P-p5],-p5,[P-p1],-p1,[P+p6],p6,
			mncx1,mncx8,mncx8,mncx1);
		endif;
		goto 6;
	endif;
	if ( match(mncx3*mncx4*mncx8) || match(mncx1*mncx5*mncx8) );
		if ( count(mncx3,1) )
			multiply,replace_(p1,-p3,p3,-p1,p2,-p2,p6,-p7,p7,-p6,p4,-p5,p5,-p4,Q,-Q
			,[P+p1],[P-p3],[P+p3],[P-p1],[P-p1],[P+p3],[P-p3],[P+p1]
			,[P+p4],[P-p5],[P+p5],[P-p4],[P-p4],[P+p5],[P-p5],[P+p4]
			,[P+p6],[P-p7],[P+p7],[P-p6],[P-p6],[P+p7],[P-p7],[P+p6]
			,[P+p2],[P-p2],[P-p2],[P+p2],[P+Q],[P-Q],[P-Q],[P+Q]
			,mncx3,mncx1,mncx1,mncx3,mncx4,mncx5,mncx5,mncx4,mncx6,mncx7,mncx7,mncx6)*mncsgn3;
		if ( match(mncDg(?a,[P+p1])) || match(mncDg(?a,-[P+p1]))
		|| match(mncfp(?a,[P+p1])) || match(mncfp(?a,-[P+p1]))
		|| match(mncDgh(?a,[P+p1])) || match(mncDgh(?a,-[P+p1])) );
			multiply,replace_(p1,-[P-p1],p6,[P+p6],p8,[P+p8]
			,[P+p1],p1,[P+p5],p5,[P-p8],-p8
			,[P-p1],-p1,[P-p5],-p5,[P+p8],p8
			,mncx5,mncx6,mncx6,mncx5);
		else;
*
*			This one still needs correcting in some databases
*
			multiply,replace_(p1,[P+p1],p6,-[P-p6],p8,-[P-p8]
			,[P+p1],p1,[P+p5],p5,[P-p8],-p8
			,[P-p1],-p1,[P-p5],-p5,[P+p8],p8
			,mncx5,mncx6,mncx6,mncx5);
		endif;
	endif;
	redefine BEPATH "1";*  1,6,8 or 1,6 or 6,8 or 5,1,6 or vv
	if ( count(mncx7,1) > 0 )
		multiply,replace_(p1,-p3,p3,-p1,p2,-p2,p6,-p7,p7,-p6,p4,-p5,p5,-p4,Q,-Q
		,[P+p1],[P-p3],[P+p3],[P-p1],[P-p1],[P+p3],[P-p3],[P+p1]
		,[P+p4],[P-p5],[P+p5],[P-p4],[P-p4],[P+p5],[P-p5],[P+p4]
		,[P+p6],[P-p7],[P+p7],[P-p6],[P-p6],[P+p7],[P-p7],[P+p6]
		,[P+p2],[P-p2],[P-p2],[P+p2],[P+Q],[P-Q],[P-Q],[P+Q])*mncsgn3;
endif;
repeat,id  mncx?[mncx18] = 1;
*
#break
*--#] be : 
*--#[ no :
#case no
*
id  mncDg(?a,mncp?[mncpp18][mncx]) = mncDg(?a,mncp)*[mncx18][mncx];
id  mncDg(?a,mncp?[-mncpp18][mncx]) = mncDg(?a,mncp)*[mncx18][mncx];
id  mncDg(?a,-mncp?[mncpp18][mncx]) = mncDg(?a,-mncp)*[mncx18][mncx];
id  mncDg(?a,-mncp?[-mncpp18][mncx]) = mncDg(?a,-mncp)*[mncx18][mncx];
id  mncDgh(?a,mncp?[mncpp18][mncx]) = mncDgh(?a,mncp)*[mncx18][mncx];
id  mncDgh(?a,mncp?[-mncpp18][mncx]) = mncDgh(?a,mncp)*[mncx18][mncx];
id  mncDgh(?a,-mncp?[mncpp18][mncx]) = mncDgh(?a,-mncp)*[mncx18][mncx];
id  mncDgh(?a,-mncp?[-mncpp18][mncx]) = mncDgh(?a,-mncp)*[mncx18][mncx];
id  mncfp(?a,mncp?[mncpp18][mncx]) = mncfp(?a,mncp)*[mncx18][mncx];
id  mncfp(?a,mncp?[-mncpp18][mncx]) = mncfp(?a,mncp)*[mncx18][mncx];
id  mncfp(?a,-mncp?[mncpp18][mncx]) = mncfp(?a,-mncp)*[mncx18][mncx];
id  mncfp(?a,-mncp?[-mncpp18][mncx]) = mncfp(?a,-mncp)*[mncx18][mncx];

repeat id mncx?[mncx18]^2 = mncx;
if ( match(mncx2*mncx7*mncx8) || match(mncx5*mncx7*mncx8)
		 || match(mncx2*mncx5*mncx7) || match(mncx2*mncx5*mncx8) );
    redefine NOSPEC "1";
	if ( count(mncx2,1) == 0 );
		multiply,replace_([P-p1],[P+p6],[P+p1],[P-p6],[P+p6],[P-p1],[P-p6],[P+p1]
		,[P-p2],[P+p5],[P+p2],[P-p5],[P+p5],[P-p2],[P-p5],[P+p2]
		,[P-p3],[P+p4],[P+p3],[P-p4],[P+p4],[P-p3],[P-p4],[P+p3]);
		multiply,replace_(p1,-p6,p6,-p1,p2,-p5,p5,-p2,p3,-p4,p4,-p3,p7,p8,p8,p7
		,[P+p8],[P+p7],[P+p7],[P+p8],[P-p8],[P-p7],[P-p7],[P-p8]);
		multiply,replace_(mncx1,mncx6,mncx6,mncx1,mncx2,mncx5,mncx5,mncx2,mncx3,mncx4,mncx4,mncx3,mncx7,mncx8,mncx8,mncx7);
	elseif ( count(mncx7,1) == 0 );
		multiply,replace_(
			p1,-p6,p6,-p1,[P-p1],[P+p6],[P+p1],[P-p6],[P+p6],[P-p1],[P-p6],[P+p1],
			p7,p5,p5,p7,[P+p7],[P+p5],[P+p5],[P+p7],[P-p7],[P-p5],[P-p5],[P-p7],
			p2,-p8,p8,-p2,[P-p2],[P+p8],[P+p2],[P-p8],[P+p8],[P-p2],[P-p8],[P+p2],
			mncx1,mncx6,mncx6,mncx1,mncx5,mncx7,mncx7,mncx5,mncx2,mncx8,mncx8,mncx2);
	elseif ( count(mncx8,1) == 0 );
		multiply,replace_([P-p3],[P+p4],[P+p3],[P-p4],[P+p4],[P-p3],[P-p4],[P+p3]
		,[P-p2],[P+p7],[P+p2],[P-p7],[P+p7],[P-p2],[P-p7],[P+p2]
		,[P+p5],[P+p8],[P-p5],[P-p8],[P+p8],[P+p5],[P-p8],[P-p5]);
		multiply,replace_(p2,-p7,p7,-p2,p8,p5,p5,p8,p3,-p4,p4,-p3);
		multiply,replace_(mncx2,mncx7,mncx7,mncx2,mncx8,mncx5,mncx5,mncx8,mncx3,mncx4,mncx4,mncx3);
	endif;
*
*	We have now a configuration with 7,2,8
*	Now minimize the number of fermions
*
	id  mncfp(?a, mncp?mncPcenter,?b) = mncfp(?a, mncp,?b)*mncx;
	id  mncfp(?a,-mncp?mncPcenter,?b) = mncfp(?a,-mncp,?b)*mncx;
	id	mncfp(?a, mncp?mncpcenter,?b ) = mncfp(?a, mncp,?b)/mncx;
	id	mncfp(?a,-mncp?mncpcenter,?b ) = mncfp(?a,-mncp,?b)/mncx;
	if ( count(mncx,1) > 0 );
		if ( match(mncDg(?a,[P-p7])) || match(mncDg(?a,-[P-p7]))
		|| match(mncfp(?a,[P-p7])) || match(mncfp(?a,-[P-p7]))
		|| match(mncDgh(?a,[P-p7])) || match(mncDgh(?a,-[P-p7])) );
			multiply,replace_([P-p7],-p7,[P-p2],-p2,[P-p8],-p8,
			p7,[P+p7],p5,-[P-p5],p8,[P+p8],mncx2,mncx5,mncx5,mncx2);
		else;
			multiply,replace_([P+p7],p7,[P+p2],p2,[P+p8],p8,
			p7,-[P-p7],p5,[P+p5],p8,-[P-p8],mncx2,mncx5,mncx5,mncx2);
		endif;
		multiply,replace_([P-p1],[P+p6],[P+p1],[P-p6],[P+p6],[P-p1],[P-p6],[P+p1]
		,[P-p2],[P+p5],[P+p2],[P-p5],[P+p5],[P-p2],[P-p5],[P+p2]
		,[P-p3],[P+p4],[P+p3],[P-p4],[P+p4],[P-p3],[P-p4],[P+p3]);
		multiply,replace_(p1,-p6,p6,-p1,p2,-p5,p5,-p2,p3,-p4,p4,-p3,p7,p8,p8,p7
		,[P+p8],[P+p7],[P+p7],[P+p8],[P-p8],[P-p7],[P-p7],[P-p8]);
		multiply,replace_(mncx1,mncx6,mncx6,mncx1,mncx2,mncx5,mncx5,mncx2,mncx3,mncx4,mncx4,mncx3,mncx7,mncx8,mncx8,mncx7);
	endif;
	id	mncx = 1;
	id	1/mncx = 1;
else;
if ( ( count(mncx3,1) > 0 ) && ( count(mncx1,1,mncx4,1,mncx6,1) == 0 ) );
	multiply,replace_(
		p1,-p3,p3,-p1,[P+p1],[P-p3],[P+p3],[P-p1],[P-p1],[P+p3],[P-p3],[P+p1],
		p4,-p6,p6,-p4,[P+p4],[P-p6],[P+p6],[P-p4],[P-p4],[P+p6],[P-p6],[P+p4],
		p2,-p2,[P+p2],[P-p2],[P-p2],[P+p2],
		p5,-p5,[P+p5],[P-p5],[P-p5],[P+p5],
		p7,-p8,p8,-p7,[P+p7],[P-p8],[P+p8],[P-p7],[P-p7],[P+p8],[P-p8],[P+p7],
		Q,-Q,[P+Q],[P-Q],[P-Q],[P+Q],
		mncx1,mncx3,mncx3,mncx1,mncx4,mncx6,mncx6,mncx4,mncx7,mncx8,mncx8,mncx7)*mncsgn3;
endif;
if ( ( count(mncx4,1) > 0 ) && ( count(mncx1,1,mncx3,1,mncx6,1) == 0 ) );
	multiply,replace_(
		p1,p4,p4,p1,[P+p1],[P+p4],[P+p4],[P+p1],[P-p1],[P-p4],[P-p4],[P-p1],
		p2,p5,p5,p2,[P+p2],[P+p5],[P+p5],[P+p2],[P-p2],[P-p5],[P-p5],[P-p2],
		p3,p6,p6,p3,[P+p3],[P+p6],[P+p6],[P+p3],[P-p3],[P-p6],[P-p6],[P-p3],
		p7,-p7,[P+p7],[P-p7],[P-p7],[P+p7],
		p8,-p8,[P+p8],[P-p8],[P-p8],[P+p8],
		Q,-Q,[P+Q],[P-Q],[P-Q],[P+Q],
		mncx1,mncx4,mncx4,mncx1,mncx2,mncx5,mncx5,mncx2,mncx3,mncx6,mncx6,mncx3)*mncsgn3;
endif;
if ( ( count(mncx6,1) > 0 ) && ( count(mncx1,1) == 0 ) );
	multiply,replace_([P-p1],[P+p6],[P+p1],[P-p6],[P+p6],[P-p1],[P-p6],[P+p1]
		,[P-p2],[P+p5],[P+p2],[P-p5],[P+p5],[P-p2],[P-p5],[P+p2]
		,[P-p3],[P+p4],[P+p3],[P-p4],[P+p4],[P-p3],[P-p4],[P+p3]);
	multiply,replace_(p1,-p6,p6,-p1,p2,-p5,p5,-p2,p3,-p4,p4,-p3,p7,p8,p8,p7
		,[P+p8],[P+p7],[P+p7],[P+p8],[P-p8],[P-p7],[P-p7],[P-p8]);
	multiply,replace_(mncx1,mncx6,mncx6,mncx1,mncx2,mncx5,mncx5,mncx2,mncx3,mncx4,mncx4,mncx3,mncx7,mncx8,mncx8,mncx7);
endif;
if ( match(mncx1*mncx7) > 0 );
	multiply,replace_([P-p3],[P+p4],[P+p3],[P-p4],[P+p4],[P-p3],[P-p4],[P+p3]
		,[P-p2],[P+p7],[P+p2],[P-p7],[P+p7],[P-p2],[P-p7],[P+p2]
		,[P+p5],[P+p8],[P-p5],[P-p8],[P+p8],[P+p5],[P-p8],[P-p5]);
	multiply,replace_(p2,-p7,p7,-p2,p8,p5,p5,p8,p3,-p4,p4,-p3);
	multiply,replace_(mncx2,mncx7,mncx7,mncx2,mncx8,mncx5,mncx5,mncx8,mncx3,mncx4,mncx4,mncx3);
endif;
if ( match(mncx1*mncx2*mncx8) > 0 );
    redefine NOSPEC "2";
endif;
endif;
repeat,id  mncx?[mncx18] = 1;
*
#break
*--#] no : 
*--#[ fa :
#case fa
*
*
#break
*--#] fa : 
*--#[ bu :
#case bu
*
*
#break
*--#] bu : 
*--#[ o1 :
#case o1
*
id  mncDg(?a,mncp?[mncpp18][mncx]) = mncDg(?a,mncp)*[mncx18][mncx];
id  mncDg(?a,mncp?[-mncpp18][mncx]) = mncDg(?a,mncp)*[mncx18][mncx];
id  mncDg(?a,-mncp?[mncpp18][mncx]) = mncDg(?a,-mncp)*[mncx18][mncx];
id  mncDg(?a,-mncp?[-mncpp18][mncx]) = mncDg(?a,-mncp)*[mncx18][mncx];
id  mncDgh(?a,mncp?[mncpp18][mncx]) = mncDgh(?a,mncp)*[mncx18][mncx];
id  mncDgh(?a,mncp?[-mncpp18][mncx]) = mncDgh(?a,mncp)*[mncx18][mncx];
id  mncDgh(?a,-mncp?[mncpp18][mncx]) = mncDgh(?a,-mncp)*[mncx18][mncx];
id  mncDgh(?a,-mncp?[-mncpp18][mncx]) = mncDgh(?a,-mncp)*[mncx18][mncx];
id  mncfp(?a,mncp?[mncpp18][mncx]) = mncfp(?a,mncp)*[mncx18][mncx];
id  mncfp(?a,mncp?[-mncpp18][mncx]) = mncfp(?a,mncp)*[mncx18][mncx];
id  mncfp(?a,-mncp?[mncpp18][mncx]) = mncfp(?a,-mncp)*[mncx18][mncx];
id  mncfp(?a,-mncp?[-mncpp18][mncx]) = mncfp(?a,-mncp)*[mncx18][mncx];
if ( match(mncx6*mncx7) > 0 );
	redefine O1PATH "1";
elseif ( ( count(mncx6,1,mncx7,1) > 0 ) && ( count(mncx3,1,mncx4,1) > 0 ) );
	multiply replace_(
		p1,-p4,p4,-p1,[P+p1],[P-p4],[P-p1],[P+p4],[P+p4],[P-p1],[P-p4],[P+p1],
		p2,-p3,p3,-p2,[P+p2],[P-p3],[P-p2],[P+p3],[P+p3],[P-p2],[P-p3],[P+p2],
		p5,-p5,[P-p5],[P+p5],[P+p5],[P-p5],
		p6,-p6,[P-p6],[P+p6],[P+p6],[P-p6],
		p7,-p7,[P-p7],[P+p7],[P+p7],[P-p7],
		mncx1,mncx4,mncx4,mncx1,mncx2,mncx3,mncx3,mncx2);
endif;
if ( count(mncx3,1,mncx4,1) > count(mncx1,1,mncx2,1) );
	multiply replace_(
		p1,-p4,p4,-p1,[P+p1],[P-p4],[P-p1],[P+p4],[P+p4],[P-p1],[P-p4],[P+p1],
		p2,-p3,p3,-p2,[P+p2],[P-p3],[P-p2],[P+p3],[P+p3],[P-p2],[P-p3],[P+p2],
		p5,-p5,[P-p5],[P+p5],[P+p5],[P-p5],
		p6,-p6,[P-p6],[P+p6],[P+p6],[P-p6],
		p7,-p7,[P-p7],[P+p7],[P+p7],[P-p7],
		mncx1,mncx4,mncx4,mncx1,mncx2,mncx3,mncx3,mncx2);
endif;
if ( ( count(mncx7,1) > 0 ) && ( count(mncx6,1) == 0 ) );
	multiply replace_(p6,p7,p7,p6,[P+p6],[P+p7],[P+p7],[P+p6],
		[P-p6],[P-p7],[P-p7],[P-p6],mncx6,mncx7,mncx7,mncx6);
endif;
if ( ( count(mncx2,1) > 0 ) && ( count(mncx1,1) == 0 ) );
	multiply replace_(
		p1,-p2,p2,-p1,[P+p1],[P-p2],[P-p1],[P+p2],[P+p2],[P-p1],[P-p2],[P+p1],
		p4,-p3,p3,-p4,[P+p4],[P-p3],[P-p4],[P+p3],[P+p3],[P-p4],[P-p3],[P+p4],
		Q,-Q,[P-Q],[P+Q],[P+Q],[P-Q],mncx1,mncx2,mncx2,mncx1,mncx4,mncx3,mncx3,mncx4)*mncsgn3;
endif;
if ( count(mncx5,1) > 0 );
	redefine O1PATH "2";
endif;
repeat,id  mncx?[mncx18] = 1;
*
#break
*--#] o1 : 
*--#[ o2 :
#case o2
*
id  mncDg(?a,mncp?[mncpp18][mncx]) = mncDg(?a,mncp)*[mncx18][mncx];
id  mncDg(?a,mncp?[-mncpp18][mncx]) = mncDg(?a,mncp)*[mncx18][mncx];
id  mncDg(?a,-mncp?[mncpp18][mncx]) = mncDg(?a,-mncp)*[mncx18][mncx];
id  mncDg(?a,-mncp?[-mncpp18][mncx]) = mncDg(?a,-mncp)*[mncx18][mncx];
id  mncDgh(?a,mncp?[mncpp18][mncx]) = mncDgh(?a,mncp)*[mncx18][mncx];
id  mncDgh(?a,mncp?[-mncpp18][mncx]) = mncDgh(?a,mncp)*[mncx18][mncx];
id  mncDgh(?a,-mncp?[mncpp18][mncx]) = mncDgh(?a,-mncp)*[mncx18][mncx];
id  mncDgh(?a,-mncp?[-mncpp18][mncx]) = mncDgh(?a,-mncp)*[mncx18][mncx];
id  mncfp(?a,mncp?[mncpp18][mncx]) = mncfp(?a,mncp)*[mncx18][mncx];
id  mncfp(?a,mncp?[-mncpp18][mncx]) = mncfp(?a,mncp)*[mncx18][mncx];
id  mncfp(?a,-mncp?[mncpp18][mncx]) = mncfp(?a,-mncp)*[mncx18][mncx];
id  mncfp(?a,-mncp?[-mncpp18][mncx]) = mncfp(?a,-mncp)*[mncx18][mncx];
if ( ( count(mncx7,1) > 0 ) && ( count(mncx6,1) == 0 ) );
	multiply replace_(
		p6,p7,p7,p6,[P+p6],[P+p7],[P+p7],[P+p6],[P-p6],[P-p7],[P-p7],[P-p6]
		mncx6,mncx7,mncx7,mncx6);
endif;
if ( match(mncx6*mncx2*mncx1) );
	if ( match(mncDg(?a,[P-p2])) || match(mncDg(?a,-[P-p2]))
	|| match(mncfp(?a,[P-p2])) || match(mncfp(?a,-[P-p2]))
	|| match(mncDgh(?a,[P-p2])) || match(mncDgh(?a,-[P-p2])) );
		Multiply,replace_([P-p2],-p2,p2,[P+p2],[P-p1],-p1,[P-p4],-p4
		,[P-p6],-p6,p6,[P+p6],p4,[P+p4],p3,[P+p3],mncx1,mncx3,mncx3,mncx1);
	else;
		Multiply,replace_([P+p2],p2,p2,-[P-p2],[P+p4],p4,p4,-[P-p4],[P+p6],p6,
        p6,-[P-p6],p3,-[P-p3],[P+p1],p1,mncx1,mncx3,mncx3,mncx1);
	endif;	
endif;
repeat,id  mncx?[mncx18] = 1;
*
#break
*--#] o2 : 
*--#[ o3 :
#case o3
*
*
#break
*--#] o3 : 
*--#[ o4 :
#case o4
*
*
#break
*--#] o4 : 
*--#[ y1 :
#case y1
*
*
#break
*--#] y1 : 
*--#[ y2 :
#case y2
*
*
#break
*--#] y2 : 
*--#[ y3 :
#case y3
*
*
#break
*--#] y3 : 
*--#[ y4 :
#case y4
*
*
#break
*--#] y4 : 
*--#[ y5 :
#case y5
*
*
#break
*--#] y5 : 
*--#[ t1 :
#case t1
*
*
#break
*--#] t1 : 
*--#[ t2 :
#case t2
*
*
#break
*--#] t2 : 
*--#[ t3 :
#case t3
*
*
#break
*--#] t3 : 
*--#[ l1 :
#case l1
*
*
#break
*--#] l1 : 
*--#[ l2 :
#case l2
*
*
#break
*--#] l2 : 
*--#[ l3 :
#case l3
*
*
#break
*--#] l3 : 
*--#[ tr :
#case tr
*
*
#break
*--#] tr : 
#endswitch
#endprocedure
*--#] special : 
*--#[ subint :
#procedure subint
id  mncexp20*mncexp10 = 1
       + ep * ( 3 )
       + ep^2 * ( 13 )
       + ep^3 * ( 55 - 22*z3 )
       + ep^4 * ( 229 - 66*z3 - 33*z4 )
       + ep^5 * ( 943 - 286*z3 - 99*z4 - 234*z5 )
       + ep^6 * ( 3853 - 1210*z3 + 242*z3^2 - 429*z4 - 702*z5 - 530*z6 );
id  mncexp11 = 1
       + ep * ( 2 )
       + ep^2 * ( 8 )
       + ep^3 * ( 32 - 22*z3 )
       + ep^4 * ( 128 - 44*z3 - 33*z4 )
       + ep^5 * ( 512 - 176*z3 - 66*z4 - 234*z5 )
       + ep^6 * ( 2048 - 704*z3 + 242*z3^2 - 264*z4 - 468*z5 - 530*z6 );
id  mncexp20 = 1
       + ep * ( 2 )
       + ep^2 * ( 8 )
       + ep^3 * ( 32 - 16*z3 )
       + ep^4 * ( 128 - 32*z3 - 24*z4 )
       + ep^5 * ( 512 - 128*z3 - 48*z4 - 192*z5 )
       + ep^6 * ( 2048 - 512*z3 + 128*z3^2 - 192*z4 - 384*z5 - 440*z6 );
id  mncexp10 = 1
       + ep * ( 1 )
       + ep^2 * ( 3 )
       + ep^3 * ( 9 - 6*z3 )
       + ep^4 * ( 27 - 6*z3 - 9*z4 )
       + ep^5 * ( 81 - 18*z3 - 9*z4 - 42*z5 )
       + ep^6 * ( 243 - 54*z3 + 18*z3^2 - 27*z4 - 42*z5 - 90*z6 );
*
*   This integral is from the paper, but apparently there is a problem
*   with the relative normalization. We correct that here with the
*   factor 1-2*ep. It makes that all our results are in agreement with
*   the mincer paper. 
*
id  mncG311 = (1-2*ep)*(6*z3+9*z4*ep+102*z5*ep^2);
*id  mncG311 = (1-2*ep)*(6*z3+9*z4*ep+102*z5*ep^2+240*z6*ep^3-186*ep^3*z3^2);
*
id  mncF321 = 20*z5;
*id  mncF321 = (20*z5+50*z6*ep+68*z3^2*ep)*(1+2*ep);
*id  mncF321 = (20*z5+50*z6*ep+68*z3^2*ep+450*z7*ep^2+204*z3*z4*ep^2)*(1+2*ep+4*ep^2);
id  ep = 0;
#endprocedure
*--#] subint : 
*--#[ sym1 :
#procedure sym1(TOPO)
#switch `TOPO'
*--#[ la :
#case la
*
#ifdef `LATRANS'
*#if ( `LATRANS' == 0 )
*if ( count([P+p1].[P+p1],1,[P+p2].[P+p2],1,[P+p3].[P+p3],1,
*	[P-p1].[P-p1],1,[P-p2].[P-p2],1,[P-p3].[P-p3],1) >
*	count([P+p4].[P+p4],1,[P+p5].[P+p5],1,[P+p6].[P+p6],1,
*	[P-p4].[P-p4],1,[P-p5].[P-p5],1,[P-p6].[P-p6],1) );
*	multiply,replace_(
*		 [P-p1],[P+p6],[P+p1],[P-p6],[P+p6],[P-p1],[P-p6],[P+p1]
*		,[P-p2],[P+p5],[P+p2],[P-p5],[P+p5],[P-p2],[P-p5],[P+p2]
*		,[P-p3],[P+p4],[P+p3],[P-p4],[P+p4],[P-p3],[P-p4],[P+p3]);
*	multiply,replace_(p1,-p6,p6,-p1,p2,-p5,p5,-p2,p3,-p4,p4,-p3,
*	[P+p7],[P-p7],[P-p7],[P+p7],[P+p8],[P-p8],[P-p8],[P+p8]);
*	id p7 = -p7;
*	id p8 = -p8;
*endif;
*if ( count([P+p1].[P+p1],1,[P+p6].[P+p6],1,
*	[P-p1].[P-p1],1,[P-p6].[P-p6],1) >
*	count([P+p3].[P+p3],1,[P+p4].[P+p4],1,
*	[P-p3].[P-p3],1,[P-p4].[P-p4],1) );
*	multiply,replace_(
*		 [P-p1],[P+p3],[P+p1],[P-p3],[P-p4],[P+p6],[P+p4],[P-p6]
*		,[P-p3],[P+p1],[P+p3],[P-p1],[P-p6],[P+p4],[P+p6],[P-p4]
*		,[P-p2],[P+p2],[P+p2],[P-p2],[P-p5],[P+p5],[P+p5],[P-p5]
*		,[P-p7],[P+p8],[P+p7],[P-p8],[P-p8],[P+p7],[P+p8],[P-p7]
*		,p1,-p3,p3,-p1,p4,-p6,p6,-p4,p2,-p2,p5,-p5,p7,-p8,p8,-p7,Q,-Q
*		,[P+Q],[P-Q],[P-Q],[P+Q]);
*endif;
*#endif
#else
#ifdef `LASYM'
#if ( `LASYM' == 1 )
	multiply,replace_(
		 [P-p1],[P+p6],[P+p1],[P-p6],[P+p6],[P-p1],[P-p6],[P+p1]
		,[P-p2],[P+p5],[P+p2],[P-p5],[P+p5],[P-p2],[P-p5],[P+p2]
		,[P-p3],[P+p4],[P+p3],[P-p4],[P+p4],[P-p3],[P-p4],[P+p3]);
	multiply,replace_(p1,-p6,p6,-p1,p2,-p5,p5,-p2,p3,-p4,p4,-p3,
	[P+p7],[P-p7],[P-p7],[P+p7],[P+p8],[P-p8],[P-p8],[P+p8]);
	id p7 = -p7;
	id p8 = -p8;
#else
#if ( `LASYM' == 2 )
	multiply,replace_(
		 [P-p1],[P+p3],[P+p1],[P-p3],[P-p4],[P+p6],[P+p4],[P-p6]
		,[P-p3],[P+p1],[P+p3],[P-p1],[P-p6],[P+p4],[P+p6],[P-p4]
		,[P-p2],[P+p2],[P+p2],[P-p2],[P-p5],[P+p5],[P+p5],[P-p5]
		,[P-p7],[P+p8],[P+p7],[P-p8],[P-p8],[P+p7],[P+p8],[P-p7]
		,p1,-p3,p3,-p1,p4,-p6,p6,-p4,p2,-p2,p5,-p5,p7,-p8,p8,-p7,Q,-Q
		,[P+Q],[P-Q],[P-Q],[P+Q]);
#else
#if ( `LASYM' == 3 )
	multiply,replace_(
		 [P-p1],[P+p3],[P+p1],[P-p3],[P-p4],[P+p6],[P+p4],[P-p6]
		,[P-p3],[P+p1],[P+p3],[P-p1],[P-p6],[P+p4],[P+p6],[P-p4]
		,[P-p2],[P+p2],[P+p2],[P-p2],[P-p5],[P+p5],[P+p5],[P-p5]
		,[P-p7],[P+p8],[P+p7],[P-p8],[P-p8],[P+p7],[P+p8],[P-p7]
		,p1,-p3,p3,-p1,p4,-p6,p6,-p4,p2,-p2,p5,-p5,p7,-p8,p8,-p7,Q,-Q
		,[P+Q],[P-Q],[P-Q],[P+Q]);
	multiply,replace_(
		 [P-p1],[P+p6],[P+p1],[P-p6],[P+p6],[P-p1],[P-p6],[P+p1]
		,[P-p2],[P+p5],[P+p2],[P-p5],[P+p5],[P-p2],[P-p5],[P+p2]
		,[P-p3],[P+p4],[P+p3],[P-p4],[P+p4],[P-p3],[P-p4],[P+p3]);
	multiply,replace_(p1,-p6,p6,-p1,p2,-p5,p5,-p2,p3,-p4,p4,-p3,
	[P+p7],[P-p7],[P-p7],[P+p7],[P+p8],[P-p8],[P-p8],[P+p8]);
	id p7 = -p7;
	id p8 = -p8;
#endif
#endif
#endif
#else
if ( count([P+p1].[P+p1],1,[P+p2].[P+p2],1,[P+p3].[P+p3],1,
	[P-p1].[P-p1],1,[P-p2].[P-p2],1,[P-p3].[P-p3],1) >
	count([P+p4].[P+p4],1,[P+p5].[P+p5],1,[P+p6].[P+p6],1,
	[P-p4].[P-p4],1,[P-p5].[P-p5],1,[P-p6].[P-p6],1) );
	multiply,replace_(
		 [P-p1],[P+p6],[P+p1],[P-p6],[P+p6],[P-p1],[P-p6],[P+p1]
		,[P-p2],[P+p5],[P+p2],[P-p5],[P+p5],[P-p2],[P-p5],[P+p2]
		,[P-p3],[P+p4],[P+p3],[P-p4],[P+p4],[P-p3],[P-p4],[P+p3]);
	multiply,replace_(p1,-p6,p6,-p1,p2,-p5,p5,-p2,p3,-p4,p4,-p3,
	[P+p7],[P-p7],[P-p7],[P+p7],[P+p8],[P-p8],[P-p8],[P+p8]);
	id p7 = -p7;
	id p8 = -p8;
endif;
if ( count([P+p1].[P+p1],1,[P+p6].[P+p6],1,
	[P-p1].[P-p1],1,[P-p6].[P-p6],1) >
	count([P+p3].[P+p3],1,[P+p4].[P+p4],1,
	[P-p3].[P-p3],1,[P-p4].[P-p4],1) );
	multiply,replace_(
		 [P-p1],[P+p3],[P+p1],[P-p3],[P-p4],[P+p6],[P+p4],[P-p6]
		,[P-p3],[P+p1],[P+p3],[P-p1],[P-p6],[P+p4],[P+p6],[P-p4]
		,[P-p2],[P+p2],[P+p2],[P-p2],[P-p5],[P+p5],[P+p5],[P-p5]
		,[P-p7],[P+p8],[P+p7],[P-p8],[P-p8],[P+p7],[P+p8],[P-p7]
		,p1,-p3,p3,-p1,p4,-p6,p6,-p4,p2,-p2,p5,-p5,p7,-p8,p8,-p7,Q,-Q
		,[P+Q],[P-Q],[P-Q],[P+Q]);
endif;
#endif
#endif
*
#break
*--#] la : 
*--#[ be :
#case be
*
*
#break
*--#] be : 
*--#[ no :
#case no
*
#ifdef `NOSPEC'
#if ( `NOSPEC' == 1 )
if ( count([P+p2].[P+p2],1,[P-p2].[P-p2],1) == 0 );
	multiply,replace_([P-p1],[P+p6],[P+p1],[P-p6],[P+p6],[P-p1],[P-p6],[P+p1]
		,[P-p2],[P+p5],[P+p2],[P-p5],[P+p5],[P-p2],[P-p5],[P+p2]
		,[P-p3],[P+p4],[P+p3],[P-p4],[P+p4],[P-p3],[P-p4],[P+p3]);
	multiply,replace_(p1,-p6,p6,-p1,p2,-p5,p5,-p2,p3,-p4,p4,-p3,p7,p8,p8,p7
		,[P+p8],[P+p7],[P+p7],[P+p8],[P-p8],[P-p7],[P-p7],[P-p8]);
elseif( count([P+p7].[P+p7],1,[P-p7].[P-p7],1) == 0 );
	multiply,replace_([P-p1],[P+p6],[P+p1],[P-p6],[P+p6],[P-p1],[P-p6],[P+p1]
		,[P-p2],[P+p8],[P+p2],[P-p8],[P+p8],[P-p2],[P-p8],[P+p2]
		,[P+p5],[P+p7],[P-p5],[P-p7],[P+p7],[P+p5],[P-p7],[P-p5]);
	multiply,replace_(p2,-p8,p8,-p2,p7,p5,p5,p7,p1,-p6,p6,-p1);
elseif ( count([P+p8].[P+p8],1,[P-p8].[P-p8],1) == 0 );
	multiply,replace_([P-p3],[P+p4],[P+p3],[P-p4],[P+p4],[P-p3],[P-p4],[P+p3]
		,[P-p2],[P+p7],[P+p2],[P-p7],[P+p7],[P-p2],[P-p7],[P+p2]
		,[P+p5],[P+p8],[P-p5],[P-p8],[P+p8],[P+p5],[P-p8],[P-p5]);
	multiply,replace_(p2,-p7,p7,-p2,p8,p5,p5,p8,p3,-p4,p4,-p3);
else;
	if ( count([P+p2].[P+p2],1,[P-p2].[P-p2],1) > count([P+p5].[P+p5],1,[P-p5].[P-p5],1) );
	multiply,replace_([P-p1],[P+p6],[P+p1],[P-p6],[P+p6],[P-p1],[P-p6],[P+p1]
		,[P-p2],[P+p5],[P+p2],[P-p5],[P+p5],[P-p2],[P-p5],[P+p2]
		,[P-p3],[P+p4],[P+p3],[P-p4],[P+p4],[P-p3],[P-p4],[P+p3]);
	multiply,replace_(p1,-p6,p6,-p1,p2,-p5,p5,-p2,p3,-p4,p4,-p3,p7,p8,p8,p7
		,[P+p8],[P+p7],[P+p7],[P+p8],[P-p8],[P-p7],[P-p7],[P-p8]);
	endif;
	if ( count([P+p7].[P+p7],1,[P-p7].[P-p7],1) > count([P+p5].[P+p5],1,[P-p5].[P-p5],1) );
	multiply,replace_([P-p1],[P+p6],[P+p1],[P-p6],[P+p6],[P-p1],[P-p6],[P+p1]
		,[P-p2],[P+p8],[P+p2],[P-p8],[P+p8],[P-p2],[P-p8],[P+p2]
		,[P+p5],[P+p7],[P-p5],[P-p7],[P+p7],[P+p5],[P-p7],[P-p5]);
	multiply,replace_(p2,-p8,p8,-p2,p7,p5,p5,p7,p1,-p6,p6,-p1);
	if ( count([P+p2].[P+p2],1,[P-p2].[P-p2],1) > count([P+p5].[P+p5],1,[P-p5].[P-p5],1) );
	multiply,replace_([P-p1],[P+p6],[P+p1],[P-p6],[P+p6],[P-p1],[P-p6],[P+p1]
		,[P-p2],[P+p5],[P+p2],[P-p5],[P+p5],[P-p2],[P-p5],[P+p2]
		,[P-p3],[P+p4],[P+p3],[P-p4],[P+p4],[P-p3],[P-p4],[P+p3]);
	multiply,replace_(p1,-p6,p6,-p1,p2,-p5,p5,-p2,p3,-p4,p4,-p3,p7,p8,p8,p7
		,[P+p8],[P+p7],[P+p7],[P+p8],[P-p8],[P-p7],[P-p7],[P-p8]);
	endif;
	elseif ( count([P+p8].[P+p8],1,[P-p8].[P-p8],1) > count([P+p5].[P+p5],1,[P-p5].[P-p5],1) );
	multiply,replace_([P-p3],[P+p4],[P+p3],[P-p4],[P+p4],[P-p3],[P-p4],[P+p3]
		,[P-p2],[P+p7],[P+p2],[P-p7],[P+p7],[P-p2],[P-p7],[P+p2]
		,[P+p5],[P+p8],[P-p5],[P-p8],[P+p8],[P+p5],[P-p8],[P-p5]);
	multiply,replace_(p2,-p7,p7,-p2,p8,p5,p5,p8,p3,-p4,p4,-p3);
	endif;
endif;
#else
#if ( `NOSPEC' == 0 )
if ( count([P+p1].[P+p1],1,[P+p2].[P+p2],1,[P+p3].[P+p3],1,
	[P-p1].[P-p1],1,[P-p2].[P-p2],1,[P-p3].[P-p3],1) >
	count([P+p4].[P+p4],1,[P+p5].[P+p5],1,[P+p6].[P+p6],1,
	[P-p4].[P-p4],1,[P-p5].[P-p5],1,[P-p6].[P-p6],1) );
	multiply,replace_([P-p1],[P+p6],[P+p1],[P-p6],[P+p6],[P-p1],[P-p6],[P+p1]
		,[P-p2],[P+p5],[P+p2],[P-p5],[P+p5],[P-p2],[P-p5],[P+p2]
		,[P-p3],[P+p4],[P+p3],[P-p4],[P+p4],[P-p3],[P-p4],[P+p3]);
	multiply,replace_(p1,-p6,p6,-p1,p2,-p5,p5,-p2,p3,-p4,p4,-p3,p7,p8,p8,p7
		,[P+p8],[P+p7],[P+p7],[P+p8],[P-p8],[P-p7],[P-p7],[P-p8]);
endif;
if ( count([P+p2].[P+p2],1,[P+p3].[P+p3],1,
	[P-p2].[P-p2],1,[P-p3].[P-p3],1) >
	count([P+p4].[P+p4],1,[P+p7].[P+p7],1,
	[P-p4].[P-p4],1,[P-p7].[P-p7],1) );
	multiply,replace_([P-p3],[P+p4],[P+p3],[P-p4],[P+p4],[P-p3],[P-p4],[P+p3]
		,[P-p2],[P+p7],[P+p2],[P-p7],[P+p7],[P-p2],[P-p7],[P+p2]
		,[P+p5],[P+p8],[P-p5],[P-p8],[P+p8],[P+p5],[P-p8],[P-p5]);
	multiply,replace_(p2,-p7,p7,-p2,p8,p5,p5,p8,p3,-p4,p4,-p3);
endif;
if ( count([P+p2].[P+p2],1,[P+p1].[P+p1],1,
	[P-p2].[P-p2],1,[P-p1].[P-p1],1) >
	count([P+p6].[P+p6],1,[P+p8].[P+p8],1,
	[P-p6].[P-p6],1,[P-p8].[P-p8],1) );
	multiply,replace_([P-p1],[P+p6],[P+p1],[P-p6],[P+p6],[P-p1],[P-p6],[P+p1]
		,[P-p2],[P+p8],[P+p2],[P-p8],[P+p8],[P-p2],[P-p8],[P+p2]
		,[P+p5],[P+p7],[P-p5],[P-p7],[P+p7],[P+p5],[P-p7],[P-p5]);
	multiply,replace_(p2,-p8,p8,-p2,p7,p5,p5,p7,p1,-p6,p6,-p1);
endif;
#endif
#endif
#else
if ( count([P+p1].[P+p1],1,[P+p2].[P+p2],1,[P+p3].[P+p3],1,
	[P-p1].[P-p1],1,[P-p2].[P-p2],1,[P-p3].[P-p3],1) >
	count([P+p4].[P+p4],1,[P+p5].[P+p5],1,[P+p6].[P+p6],1,
	[P-p4].[P-p4],1,[P-p5].[P-p5],1,[P-p6].[P-p6],1) );
	multiply,replace_([P-p1],[P+p6],[P+p1],[P-p6],[P+p6],[P-p1],[P-p6],[P+p1]
		,[P-p2],[P+p5],[P+p2],[P-p5],[P+p5],[P-p2],[P-p5],[P+p2]
		,[P-p3],[P+p4],[P+p3],[P-p4],[P+p4],[P-p3],[P-p4],[P+p3]);
	multiply,replace_(p1,-p6,p6,-p1,p2,-p5,p5,-p2,p3,-p4,p4,-p3,p7,p8,p8,p7
		,[P+p8],[P+p7],[P+p7],[P+p8],[P-p8],[P-p7],[P-p7],[P-p8]);
endif;
if ( count([P+p2].[P+p2],1,[P+p3].[P+p3],1,
	[P-p2].[P-p2],1,[P-p3].[P-p3],1) >
	count([P+p4].[P+p4],1,[P+p7].[P+p7],1,
	[P-p4].[P-p4],1,[P-p7].[P-p7],1) );
	multiply,replace_([P-p3],[P+p4],[P+p3],[P-p4],[P+p4],[P-p3],[P-p4],[P+p3]
		,[P-p2],[P+p7],[P+p2],[P-p7],[P+p7],[P-p2],[P-p7],[P+p2]
		,[P+p5],[P+p8],[P-p5],[P-p8],[P+p8],[P+p5],[P-p8],[P-p5]);
	multiply,replace_(p2,-p7,p7,-p2,p8,p5,p5,p8,p3,-p4,p4,-p3);
endif;
if ( count([P+p2].[P+p2],1,[P+p1].[P+p1],1,
	[P-p2].[P-p2],1,[P-p1].[P-p1],1) >
	count([P+p6].[P+p6],1,[P+p8].[P+p8],1,
	[P-p6].[P-p6],1,[P-p8].[P-p8],1) );
	multiply,replace_([P-p1],[P+p6],[P+p1],[P-p6],[P+p6],[P-p1],[P-p6],[P+p1]
		,[P-p2],[P+p8],[P+p2],[P-p8],[P+p8],[P-p2],[P-p8],[P+p2]
		,[P+p5],[P+p7],[P-p5],[P-p7],[P+p7],[P+p5],[P-p7],[P-p5]);
	multiply,replace_(p2,-p8,p8,-p2,p7,p5,p5,p7,p1,-p6,p6,-p1);
endif;
#endif
*
#break
*--#] no : 
*--#[ fa :
#case fa
*
*
#break
*--#] fa : 
*--#[ bu :
#case bu
*
*
#break
*--#] bu : 
*--#[ o1 :
#case o1
*
*if ( count([P+p6].[P+p6],1,[P-p6].[P-p6],1) >
*	count([P+p7].[P+p7],1,[P-p7].[P-p7],1) );
*	multiply,replace_([P+p6],[P+p7],[P+p7],[P+p6],[P-p6],[P-p7],[P-p7],[P-p6]
*	p6,p7,p7,p6);
*endif;
*if ( count([P+p1].[P+p1],1,[P+p2].[P+p2],1,
*	[P-p1].[P-p1],1,[P-p2].[P-p2],1) >
*	count([P+p3].[P+p3],1,[P+p4].[P+p4],1,
*	[P-p3].[P-p3],1,[P-p4].[P-p4],1) );
*	multiply,replace_([P-p1],[P+p4],[P+p1],[P-p4],[P+p4],[P-p1],[P-p4],[P+p1]
*		,[P-p2],[P+p3],[P+p2],[P-p3],[P+p3],[P-p2],[P-p3],[P+p2]
*		,[P-p5],[P+p5],[P+p5],[P-p5],[P-p6],[P+p6],[P+p6],[P-p6]
*		,[P-p7],[P+p7],[P+p7],[P-p7]);
*	multiply,replace_(p1,-p4,p4,-p1,p2,-p3,p3,-p2);
*	id	p5 = -p5;
*	id	p6 = -p6;
*	id	p7 = -p7;
*endif;
*
#break
*--#] o1 : 
*--#[ o2 :
#case o2
*
if ( count([P+p6].[P+p6],1,[P-p6].[P-p6],1) >
	count([P+p7].[P+p7],1,[P-p7].[P-p7],1) );
	multiply,replace_([P+p6],[P+p7],[P+p7],[P+p6],[P-p6],[P-p7],[P-p7],[P-p6]
	p6,p7,p7,p6);
endif;
*
#break
*--#] o2 : 
*--#[ o3 :
#case o3
*
if ( count([P+p6].[P+p6],1,[P-p6].[P-p6],1) >
	count([P+p7].[P+p7],1,[P-p7].[P-p7],1) );
	multiply,replace_([P+p6],[P+p7],[P+p7],[P+p6],[P-p6],[P-p7],[P-p7],[P-p6]
	,p6,p7,p7,p6);
endif;
if ( count([P+p1].[P+p1],1,[P+p2].[P+p2],1,
	[P-p1].[P-p1],1,[P-p2].[P-p2],1) >
	count([P+p3].[P+p3],1,[P+p4].[P+p4],1,
	[P-p3].[P-p3],1,[P-p4].[P-p4],1) );
	multiply,replace_([P-p1],[P+p4],[P+p1],[P-p4],[P+p4],[P-p1],[P-p4],[P+p1]
		,[P-p2],[P+p3],[P+p2],[P-p3],[P+p3],[P-p2],[P-p3],[P+p2]
		,[P-p5],[P+p5],[P+p5],[P-p5]);
	multiply,replace_(p1,-p4,p4,-p1,p2,-p3,p3,-p2);
	id	p5 = -p5;
endif;
*
#break
*--#] o3 : 
*--#[ o4 :
#case o4
*
if ( count([P+p1].[P+p1],1,[P+p2].[P+p2],1,
	[P-p1].[P-p1],1,[P-p2].[P-p2],1) >
	count([P+p4].[P+p4],1,[P+p3].[P+p3],1,
	[P-p4].[P-p4],1,[P-p3].[P-p3],1) );
	multiply,replace_([P-p1],[P+p4],[P+p1],[P-p4],[P+p4],[P-p1],[P-p4],[P+p1]
		,[P-p2],[P+p3],[P+p2],[P-p3],[P+p3],[P-p2],[P-p3],[P+p2]
		,[P-p5],[P+p5],[P+p5],[P-p5]);
	multiply,replace_(p1,-p4,p4,-p1,p2,-p3,p3,-p2);
	id	p5 = -p5;
endif;
*
#break
*--#] o4 : 
*--#[ y1 :
#case y1
*
if ( count([P+p6].[P+p6],1,[P-p6].[P-p6],1) <
	count([P+p5].[P+p5],1,[P-p5].[P-p5],1) );
	multiply,replace_([P+p6],[P+p5],[P+p5],[P+p6],[P-p6],[P-p5],[P-p5],[P-p6]
	p6,p5,p5,p6);
endif;
if ( count([P+p4].[P+p4],1,[P-p4].[P-p4],1) <
	count([P+p3].[P+p3],1,[P-p3].[P-p3],1) );
	multiply,replace_([P+p4],[P+p3],[P+p3],[P+p4],[P-p4],[P-p3],[P-p3],[P-p4]
	p4,p3,p3,p4);
endif;
*
#break
*--#] y1 : 
*--#[ y2 :
#case y2
*
if ( count([P+p6].[P+p6],1,[P-p6].[P-p6],1) <
	count([P+p5].[P+p5],1,[P-p5].[P-p5],1) );
	multiply,replace_([P+p6],[P+p5],[P+p5],[P+p6],[P-p6],[P-p5],[P-p5],[P-p6]
	p6,p5,p5,p6);
endif;
if ( count([P+p4].[P+p4],1,[P-p4].[P-p4],1) <
	count([P+p3].[P+p3],1,[P-p3].[P-p3],1) );
	multiply,replace_([P+p4],[P+p3],[P+p3],[P+p4],[P-p4],[P-p3],[P-p3],[P-p4]
	p4,p3,p3,p4);
endif;
*
#break
*--#] y2 : 
*--#[ y3 :
#case y3
*
if ( count([P+p6].[P+p6],1,[P-p6].[P-p6],1) <
	count([P+p5].[P+p5],1,[P-p5].[P-p5],1) );
	multiply,replace_([P+p6],[P+p5],[P+p5],[P+p6],[P-p6],[P-p5],[P-p5],[P-p6]
	p6,p5,p5,p6);
endif;
*
#break
*--#] y3 : 
*--#[ y4 :
#case y4
*
if ( count([P+p6].[P+p6],1,[P-p6].[P-p6],1) <
	count([P+p5].[P+p5],1,[P-p5].[P-p5],1) );
	multiply,replace_([P+p6],[P+p5],[P+p5],[P+p6],[P-p6],[P-p5],[P-p5],[P-p6]
	p6,p5,p5,p6);
endif;
if ( count([P+p4].[P+p4],1,[P-p4].[P-p4],1) <
	count([P+p3].[P+p3],1,[P-p3].[P-p3],1) );
	multiply,replace_([P+p4],[P+p3],[P+p3],[P+p4],[P-p4],[P-p3],[P-p3],[P-p4]
	p4,p3,p3,p4);
endif;
*
#break
*--#] y4 : 
*--#[ y5 :
#case y5
*
if ( count([P+p6].[P+p6],1,[P-p6].[P-p6],1) <
	count([P+p5].[P+p5],1,[P-p5].[P-p5],1) );
	multiply,replace_([P+p6],[P+p5],[P+p5],[P+p6],[P-p6],[P-p5],[P-p5],[P-p6]
	p6,p5,p5,p6);
endif;
if ( count([P+p4].[P+p4],1,[P-p4].[P-p4],1) <
	count([P+p3].[P+p3],1,[P-p3].[P-p3],1) );
	multiply,replace_([P+p4],[P+p3],[P+p3],[P+p4],[P-p4],[P-p3],[P-p3],[P-p4]
	p4,p3,p3,p4);
endif;
if ( count([P+p2].[P+p2],1,[P-p2].[P-p2],1) <
	count([P+p1].[P+p1],1,[P-p1].[P-p1],1) );
	multiply,replace_([P+p2],[P+p1],[P+p1],[P+p2],[P-p2],[P-p1],[P-p1],[P-p2]
	p2,p1,p1,p2);
endif;
*
#break
*--#] y5 : 
*--#[ t1 :
#case t1
*
if ( count([P+p1].[P+p1],1,[P+p2].[P+p2],1,
	[P-p1].[P-p1],1,[P-p2].[P-p2],1) >
	count([P+p4].[P+p4],1,[P+p3].[P+p3],1,
	[P-p4].[P-p4],1,[P-p3].[P-p3],1) );
	multiply,replace_([P-p1],[P+p4],[P+p1],[P-p4],[P+p4],[P-p1],[P-p4],[P+p1]
		,[P-p2],[P+p3],[P+p2],[P-p3],[P+p3],[P-p2],[P-p3],[P+p2]
		,[P-p5],[P+p5],[P+p5],[P-p5]);
	multiply,replace_(p1,-p4,p4,-p1,p2,-p3,p3,-p2,mnce1,mnce4,mnce4,mnce1,mnce2,mnce3,mnce3,mnce2);
	id	p5 = -p5;
endif;
*
#break
*--#] t1 : 
*--#[ t2 :
#case t2
*
if ( count([P+p4].[P+p4],1,[P-p4].[P-p4],1) <
	count([P+p3].[P+p3],1,[P-p3].[P-p3],1) );
	multiply,replace_([P+p4],[P+p3],[P+p3],[P+p4],[P-p4],[P-p3],[P-p3],[P-p4]
	p4,p3,p3,p4,mnce3,mnce4,mnce4,mnce3);
endif;
*
#break
*--#] t2 : 
*--#[ t3 :
#case t3
*
if ( count([P+p4].[P+p4],1,[P-p4].[P-p4],1) <
	count([P+p3].[P+p3],1,[P-p3].[P-p3],1) );
	multiply,replace_([P+p4],[P+p3],[P+p3],[P+p4],[P-p4],[P-p3],[P-p3],[P-p4]
	p4,p3,p3,p4,mnce3,mnce4,mnce4,mnce3);
endif;
if ( count([P+p2].[P+p2],1,[P-p2].[P-p2],1) <
	count([P+p1].[P+p1],1,[P-p1].[P-p1],1) );
	multiply,replace_([P+p2],[P+p1],[P+p1],[P+p2],[P-p2],[P-p1],[P-p1],[P-p2]
	p2,p1,p1,p2,mnce1,mnce2,mnce2,mnce1);
endif;
*
#break
*--#] t3 : 
*--#[ l1 :
#case l1
*
*
#break
*--#] l1 : 
*--#[ l2 :
#case l2
*
*
#break
*--#] l2 : 
*--#[ l3 :
#case l3
*
*
#break
*--#] l3 : 
*--#[ tr :
#case tr
*
*
#break
*--#] tr : 
#endswitch
#endprocedure

*--#] sym1 : 
*--#[ sym2 :
#procedure sym2(TOPO)
#switch `TOPO'
*--#[ la :
#case la
*
#ifdef `LATRANS'
#if ( `LATRANS' != 1 )
#if ( `LATRANS' != 2 )
if ( count(p7.p7,1) < count(p8.p8,1) );
	multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
elseif ( count(p7.p7,1) == count(p8.p8,1) );
    if ( count(p6.p6,1) < count(p4.p4,1) );
		multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
	elseif ( count(p6.p6,1) == count(p4.p4,1) );
	    if ( count(p1.p1,1) < count(p3.p3,1) )
			multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
	endif;
endif;
#endif
#endif
#else
if ( count(p7.p7,1) < count(p8.p8,1) );
	multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
elseif ( count(p7.p7,1) == count(p8.p8,1) );
    if ( count(p1.p1,1) < count(p3.p3,1) );
		multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
	elseif ( count(p1.p1,1) == count(p3.p3,1) );
	    if ( count(p6.p6,1) < count(p4.p4,1) )
			multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
	endif;
endif;
#endif
*
#break
*--#] la : 
*--#[ be :
#case be
*
#ifndef `BEPATH'
if ( count(p6.p6,1) < count(p7.p7,1) );
	multiply replace_(p1,p3,p3,p1,p4,p5,p5,p4,p6,p7,p7,p6,p8,-p8);
elseif ( count(p6.p6,1) == count(p7.p7,1) );
    if ( count(p1.p1,1) < count(p3.p3,1) );
		multiply replace_(p1,p3,p3,p1,p4,p5,p5,p4,p6,p7,p7,p6,p8,-p8);
	elseif ( count(p1.p1,1) == count(p3.p3,1) );
	    if ( count(p5.p5,1) < count(p4.p4,1) )
			multiply replace_(p1,p3,p3,p1,p4,p5,p5,p4,p6,p7,p7,p6,p8,-p8);
	endif;
endif;
#else
#if ( `BEPATH' == 0 )
if ( count(p6.p6,1) < count(p7.p7,1) );
	multiply replace_(p1,p3,p3,p1,p4,p5,p5,p4,p6,p7,p7,p6,p8,-p8);
elseif ( count(p6.p6,1) == count(p7.p7,1) );
    if ( count(p1.p1,1) < count(p3.p3,1) );
		multiply replace_(p1,p3,p3,p1,p4,p5,p5,p4,p6,p7,p7,p6,p8,-p8);
	elseif ( count(p1.p1,1) == count(p3.p3,1) );
	    if ( count(p5.p5,1) < count(p4.p4,1) )
			multiply replace_(p1,p3,p3,p1,p4,p5,p5,p4,p6,p7,p7,p6,p8,-p8);
	endif;
endif;
#endif
#if ( `BEPATH' == 7 )
if ( count(p6.p6,1) < count(p7.p7,1) );
	multiply replace_(p1,p3,p3,p1,p4,p5,p5,p4,p6,p7,p7,p6,p8,-p8);
elseif ( count(p6.p6,1) == count(p7.p7,1) );
    if ( count(p1.p1,1) < count(p3.p3,1) );
		multiply replace_(p1,p3,p3,p1,p4,p5,p5,p4,p6,p7,p7,p6,p8,-p8);
	elseif ( count(p1.p1,1) == count(p3.p3,1) );
	    if ( count(p5.p5,1) < count(p4.p4,1) )
			multiply replace_(p1,p3,p3,p1,p4,p5,p5,p4,p6,p7,p7,p6,p8,-p8);
	endif;
endif;
#endif
#if ( `BEPATH' == 8 )
if ( count(p6.p6,1) < count(p7.p7,1) );
	multiply replace_(p1,p3,p3,p1,p4,p5,p5,p4,p6,p7,p7,p6,p8,-p8);
elseif ( count(p6.p6,1) == count(p7.p7,1) );
    if ( count(p1.p1,1) < count(p3.p3,1) );
		multiply replace_(p1,p3,p3,p1,p4,p5,p5,p4,p6,p7,p7,p6,p8,-p8);
	elseif ( count(p1.p1,1) == count(p3.p3,1) );
	    if ( count(p5.p5,1) < count(p4.p4,1) )
			multiply replace_(p1,p3,p3,p1,p4,p5,p5,p4,p6,p7,p7,p6,p8,-p8);
	endif;
endif;
#endif
#endif
*
#break
*--#] be : 
*--#[ no :
#case no
*
#ifndef `NOSPEC'
if ( count(p7.p7,1) < count(p8.p8,1) );
	multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
elseif ( count(p7.p7,1) == count(p8.p8,1) );
    if ( count(p1.p1,1) < count(p3.p3,1) );
		multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
	elseif ( count(p1.p1,1) == count(p3.p3,1) );
	    if ( count(p6.p6,1) < count(p4.p4,1) )
			multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
	endif;
endif;
#else
#if ( `NOSPEC' != 2 )
if ( count(p7.p7,1) < count(p8.p8,1) );
	multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
elseif ( count(p7.p7,1) == count(p8.p8,1) );
    if ( count(p1.p1,1) < count(p3.p3,1) );
		multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
	elseif ( count(p1.p1,1) == count(p3.p3,1) );
	    if ( count(p6.p6,1) < count(p4.p4,1) )
			multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
	endif;
endif;
#endif
#endif
*
#break
*--#] no : 
*--#[ fa :
#case fa
*
*
#break
*--#] fa : 
*--#[ bu :
#case bu
*
*
#break
*--#] bu : 
*--#[ o1 :
#case o1
*
*
#break
*--#] o1 : 
*--#[ o2 :
#case o2
*
*
#break
*--#] o2 : 
*--#[ o3 :
#case o3
*
*
#break
*--#] o3 : 
*--#[ o4 :
#case o4
*
*
#break
*--#] o4 : 
*--#[ y1 :
#case y1
*
*
#break
*--#] y1 : 
*--#[ y2 :
#case y2
*
*
#break
*--#] y2 : 
*--#[ y3 :
#case y3
*
*
#break
*--#] y3 : 
*--#[ y4 :
#case y4
*
*
#break
*--#] y4 : 
*--#[ y5 :
#case y5
*
*
#break
*--#] y5 : 
*--#[ t1 :
#case t1
*
*
#break
*--#] t1 : 
*--#[ t2 :
#case t2
*
*
#break
*--#] t2 : 
*--#[ t3 :
#case t3
*
*
#break
*--#] t3 : 
*--#[ l1 :
#case l1
*
*
#break
*--#] l1 : 
*--#[ l2 :
#case l2
*
*
#break
*--#] l2 : 
*--#[ l3 :
#case l3
*
*
#break
*--#] l3 : 
*--#[ tr :
#case tr
*
*
#break
*--#] tr : 
#endswitch
#endprocedure

*--#] sym2 : 
*--#[ tabtwo :
#procedure tabtwo(n)
Ctable,check,strict,mncTabTwo(-18:20);
* Program for the procedure (positive values. Negative to be added)
*   #-
*   CF	num,den,den1,G,Gamma,InvGamma;
*   S	ep,mncexp11,mncG311,G00,G01,mncG10,mncG20,n1,n2,n3,n4,n,z3,z4,z5,z6,x,x1,x2;
*   Format nospaces;
*   Format 80;
*   .global
*   G	F1 = mncG311;
*   G	[H1] = mncG311;
*   .store
*   #do i = 2,20
*   G	F`i' = -F{`i'-1}*num(`i'+ep-2+2*ep)*den(`i'+ep-1+ep)
*   			-num(3-3*ep-2*(`i'+ep))*den(`i'+ep-1+ep)*G(1,`i',ep,0,0)*G(1,`i',ep+ep,0,0);
*   G	[H{-`i'+2}] = -[H{-`i'+3}]*den(({-`i'+3})+ep-2+2*ep)*num(({-`i'+3})+ep-1+ep)
*   			-num(3-3*ep-2*(({-`i'+3})+ep))*den(({-`i'+3})+ep-2+2*ep)*G(1,({-`i'+3}),ep,0,0)*G(1,({-`i'+3}),ep+ep,0,0);
*   
*   id	G(n1?,n2?,n?,n3?,n4?) = Gamma(n1+n2+n-n4-2+ep)*Gamma(2-ep-n1+n3-n4)
*   		*Gamma(2-ep-n2-n+n4)*InvGamma(n1)*InvGamma(n2+n)*InvGamma(4-2*ep-n1-n2-n+n3)
*   		*InvGamma(ep+n)*InvGamma(1-ep)*InvGamma(1-ep-n)*Gamma(2-2*ep-n)*Gamma(1+n)*G(n);
*   .sort
*   id	G(ep) = mncG10/ep;
*   id	G(2*ep) = mncG20/ep;
*   id	Gamma(x?number_) = fac_(x-1);
*   id	InvGamma(x?number_) = invfac_(x-1);
*   SplitArg,((ep)),Gamma,InvGamma;
*   id	Gamma(x?) = Gamma(0,x);
*   id	InvGamma(x?) = InvGamma(0,x);
*   repeat id Gamma(x?{>1},x1?) = Gamma(x-1,x1)*num(x-1+x1);
*   repeat id InvGamma(x?{>1},x1?) = InvGamma(x-1,x1)*den(x-1+x1);
*   repeat id Gamma(x?neg0_,x1?) = Gamma(x+1,x1)*den(x+x1);
*   repeat id InvGamma(x?neg0_,x1?) = InvGamma(x+1,x1)*num(x+x1);
*   id	Gamma(x1?,x2?) = Gamma(x1+x2);
*   id	InvGamma(x1?,x2?) = InvGamma(x1+x2);
*   id	Gamma(x?)*InvGamma(x?) = 1;
*   id	num(x?)*den(x?) = 1;
*   .sort
*   splitarg,den;
*   id	den(x?) = 1/x;
*   id  mncG10*mncG20 = mncexp11*(1+ep+3*ep^2+9*ep^3+27*ep^4+81*ep^5+243*ep^6)/3;
*   id	ep^4 = 0;
*   .sort
*   #do i = 1,1
*   id,once,den(x1?,x2?)=den1(x1,x2);
*   repeat;
*   	id	den1(x1?,x2?) = 1/x1-x2/x1*den1(x1,x2);
*   	id	ep^4=0;
*   endrepeat;
*   if ( count(den,1) ) redefine i "0";
*   .sort
*   #enddo
*   #do i = 1,1
*   id,once,num(x?) = x;
*   id,once,num(x?) = x;
*   id	ep^4=0;
*   if ( count(num,1) ) redefine i "0";
*   .sort
*   #enddo
*   Print +f +s;
*   .store
*   #enddo
*   .end
*
#if ( `n' > 12 )
Fill mncTabTwo(-11)=
      -1/36*ep^-2*mncexp11
      +20239/997920*ep^-1*mncexp11
      +6100472680597/7302858393600*ep*mncexp11
      -1/6*ep*mncG311
      +4337250881169876763/1417046642694144000*ep^2*mncexp11
      -90641/166320*ep^2*mncG311
      +2091812554174566396199387/196402664677408358400000*ep^3*mncexp11
      -2374960501/1536796800*ep^3*mncG311
      +1090841057/5532468480*mncexp11
      ;
Fill mncTabTwo(-12)=
      +1/39*ep^-2*mncexp11
      -240007/14054040*ep^-1*mncexp11
      -13602195770972309/17381411548300800*ep*mncexp11
      +2/13*ep*mncG311
      -126089727300984118341343/43844958258819734016000*ep^2*mncexp11
      +1201433/2342340*ep^2*mncG311
      -791462137880746814741946553891/78999845790741396750028800000*ep^3*
      mncexp11
      +411081820769/281361880800*ep^3*mncG311
      -185130132773/1012902770880*mncexp11
      ;
#endif
#if ( `n' > 14 )
Fill mncTabTwo(-13)=
      -1/42*ep^-2*mncexp11
      +218227/15135120*ep^-1*mncexp11
      +96615712133749103/131029102441036800*ep*mncexp11
      -1/7*ep*mncG311
      +128330609845270447137163/47217647355652021248000*ep^2*mncexp11
      -1223213/2522520*ep^2*mncG311
      +806437143502720334013825585391/85076757005413811884646400000*ep^3*
      mncexp11
      -420364841549/303005102400*ep^3*mncG311
      +37176314653/218163673728*mncexp11
      ;
Fill mncTabTwo(-14)=
      +1/45*ep^-2*mncexp11
      -39527/3243240*ep^-1*mncexp11
      -489372048271962043/701941620219840000*ep*mncexp11
      +2/15*ep*mncG311
      -651802463411113795203911/252951682262421542400000*ep^2*mncexp11
      +248761/540540*ep^2*mncG311
      -820053293102922261930228979519/91153668220086227019264000000*ep^3*
      mncexp11
      +429255677789/324648324000*ep^3*mncG311
      -932246700037/5843669832000*mncexp11
      ;
#endif
#if ( `n' > 16 )
Fill mncTabTwo(-15)=
      -1/48*ep^-2*mncexp11
      +356231/34594560*ep^-1*mncexp11
      +3965025206576904973/5989901825875968000*ep*mncexp11
      -1/8*ep*mncG311
      +10591912614360039408002357/4317042043945327656960000*ep^2*mncexp11
      -2526649/5765760*ep^2*mncG311
      +26680062946841205007366078530809/3111378541912276548924211200000*ep^3*
      mncexp11
      -1751152491841/1385166182400*ep^3*mncG311
      +3739701326971/24932991283200*mncexp11
      ;
Fill mncTabTwo(-16)=
      +1/51*ep^-2*mncexp11
      -5425297/624864240*ep^-1*mncexp11
      -19704672113639282688689/31267661899936670208000*ep*mncexp11
      +2/17*ep*mncG311
      -897165022393987602347339676917/383098897836880068189265920000*ep^2*
      mncexp11
      +43583663/104144040*ep^2*mncG311
      -38455320697994403420164576387353627573/469381964003293544667125147566080\
      0000*ep^3*mncexp11
      +515566734862579/425332590883200*ep^3*mncG311
      -1083095292344179/7655986635897600*mncexp11
      ;
#endif
#if ( `n' > 18 )
Fill mncTabTwo(-17)=
      -1/54*ep^-2*mncexp11
      +4824697/661620960*ep^-1*mncexp11
      +6642238931730812316163/11035645376448236544000*ep*mncexp11
      -1/9*ep*mncG311
      +101074910958324854680006747813/45070458569044713904619520000*ep^2*
      mncexp11
      -44184263/110270160*ep^2*mncG311
      +4336657379681819493336208121320064197/
      552214075297992405490735467724800000*ep^3*mncexp11
      -58300111178131/50039128339200*ep^3*mncG311
      +1085239500610379/8106338790950400*mncexp11
      ;
Fill mncTabTwo(-18)=
      +1/57*ep^-2*mncexp11
      -26926121/4423058640*ep^-1*mncexp11
      -414252621011788053328688873/719088170552055317325312000*ep*mncexp11
      +2/19*ep*mncG311
      -120064470375697425044084448311403037/55799458696176523527257244426240000
      *ep^2*mncexp11
      +283463959/737176440*ep^2*mncG311
      -97966132225971532793728441924688581206532487/129896988364971951238104437\
      08530140774400000*ep^3*mncexp11
      +577794401298163817/514827571917859200*ep^3*mncG311
      -392335219349419459/3088965431507155200*mncexp11
      ;
#endif
#if ( `n' > 10 )
fill mncTabTwo(-10) =
     + 1/33*ep^-2*mncexp11 - 22129/914760*ep^-1*mncexp11 - 216938023/1014285888*mncexp11
	 - 5997222836107/6694286860800*ep*mncexp11
	 - 4249965245766403333/1298959422469632000*ep^2*mncexp11
	 - 2047223673498737416560637/180035775954290995200000*ep^3*mncexp11
	 + 2/11*ep*mncG311 + 88751/152460*ep^2*mncG311 + 2314681471/1408730400*ep^3*mncG311;
fill mncTabTwo(-9) =
     - 1/30*ep^-2*mncexp11 + 439/15120*ep^-1*mncexp11 + 44567623/190512000*mncexp11
	 + 22148701837/22861440000*ep*mncexp11
	 + 1422368328652361/403275801600000*ep^2*mncexp11
	 + 12441442444649011943/1016255020032000000*ep^3*mncexp11
	 - 1/5*ep*mncG311 - 1577/2520*ep^2*mncG311 - 18605911/10584000*ep^3*mncG311;
#endif
#if ( `n' > 8 )
fill mncTabTwo(-8) =
     + 1/27*ep^-2*mncexp11 - 797/22680*ep^-1*mncexp11 - 44217371/171460800*mncexp11
	 - 65104918307/61725888000*ep*mncexp11
	 - 4166135527435991/1088844664320000*ep^2*mncexp11
	 - 36393341868100266377/2743888554086400000*ep^3*mncexp11
	 + 2/9*ep*mncG311 + 2563/3780*ep^2*mncG311 + 74297/39200*ep^3*mncG311;
fill mncTabTwo(-7) =
	 - 1/24*ep^-2*mncexp11 + 289/6720*ep^-1*mncexp11 + 4876579/16934400*mncexp11
	 + 2364251101/2032128000*ep*mncexp11
	 + 16751468663557/3982970880000*ep^2*mncexp11
	 + 48704651163860173/3345695539200000*ep^3*mncexp11
	 - 1/4*ep*mncG311 - 831/1120*ep^2*mncG311 - 5823947/2822400*ep^3*mncG311;
#endif
#if ( `n' > 6 )
fill mncTabTwo(-6) =
      1/21*ep^-2*mncexp11 - 157/2940*ep^-1*mncexp11 - 172243/529200*mncexp11
	 - 288228947/222264000*ep*mncexp11 - 113013415303/24202080000*ep^2*mncexp11
	 - 1476575820814739/91483862400000*ep^3*mncexp11
	 + 2/7*ep*mncG311 + 403/490*ep^2*mncG311 + 1404743/617400*ep^3*mncG311;
fill mncTabTwo(-5) =
	 - 1/18*ep^-2*mncexp11 + 73/1080*ep^-1*mncexp11 + 24389/64800*mncexp11
	 + 1917641/1296000*ep*mncexp11 + 15283541/2880000*ep^2*mncexp11
	 + 9491140693/518400000*ep^3*mncexp11
	 - 1/3*ep*mncG311 - 167/180*ep^2*mncG311 - 1021/400*ep^3*mncG311;
#endif
#if ( `n' > 4 )
fill mncTabTwo(-4) =
      1/15*ep^-2*mncexp11 - 79/900*ep^-1*mncexp11 - 24007/54000*mncexp11
	 - 1857983/1080000*ep*mncexp11 - 398148641/64800000*ep^2*mncexp11
	 - 82309007731/3888000000*ep^3*mncexp11
	 + 2/5*ep*mncG311 + 161/150*ep^2*mncG311 + 8807/3000*ep^3*mncG311;
fill mncTabTwo(-3) =
	 - 1/12*ep^-2*mncexp11 + 17/144*ep^-1*mncexp11 + 955/1728*mncexp11
	 + 1619/768*ep*mncexp11 + 621317/82944*ep^2*mncexp11 + 25618703/995328*ep^3*mncexp11
	 - 1/2*ep*mncG311 - 31/24*ep^2*mncG311 - 337/96*ep^3*mncG311;
#endif
fill mncTabTwo(-2) =
      1/9*ep^-2*mncexp11 - 1/6*ep^-1*mncexp11 - 233/324*mncexp11
	 - 5251/1944*ep*mncexp11 - 111641/11664*ep^2*mncexp11 - 2301799/69984*ep^3*mncexp11
	 + 2/3*ep*mncG311 + 5/3*ep^2*mncG311 + 9/2*ep^3*mncG311;
fill mncTabTwo(-1) =
	 - 1/6*ep^-2*mncexp11 + 1/4*ep^-1*mncexp11 + 9/8*mncexp11
	 + 203/48*ep*mncexp11 + 477/32*ep^2*mncexp11 + 3261/64*ep^3*mncexp11
	 - ep*mncG311 - 5/2*ep^2*mncG311 - 27/4*ep^3*mncG311;
fill mncTabTwo(0) =
     + 1/3*ep^-2*mncexp11 - 1/3*ep^-1*mncexp11 - 5/3*mncexp11
	 - 7*ep*mncexp11 - 27*ep^2*mncexp11 - 99*ep^3*mncexp11
	 + 2*ep*mncG311 + 6*ep^2*mncG311 + 18*ep^3*mncG311;
fill mncTabTwo(1) = mncG311;
fill mncTabTwo(2) =
     + 1/3*ep^-2*mncexp11 - 2*ep^-1*mncexp11 + 28*ep*mncexp11
	 - 132*ep^2*mncexp11 + 436*ep^3*mncexp11
	 - 3*ep*mncG311 + 6*ep^2*mncG311 - 12*ep^3*mncG311;
fill mncTabTwo(3) =
	 - 1/6*ep^-2*mncexp11 + 2/3*ep^-1*mncexp11 + 23/6*mncexp11
	 - 373/12*ep*mncexp11 + 2429/24*ep^2*mncexp11 - 10693/48*ep^3*mncexp11
	 + 3/2*ep*mncG311 - 3*ep^3*mncG311;
fill mncTabTwo(4) =
     + 1/9*ep^-2*mncexp11 - 19/54*ep^-1*mncexp11 - 227/81*mncexp11
	 + 8801/486*ep*mncexp11 - 148589/2916*ep^2*mncexp11 + 1631399/17496*ep^3*mncexp11
	 - ep*mncG311 - 5/6*ep^2*mncG311 + 23/9*ep^3*mncG311;
fill mncTabTwo(5) =
	 - 1/12*ep^-2*mncexp11 + 2/9*ep^-1*mncexp11 + 995/432*mncexp11
	 - 65743/5184*ep*mncexp11 + 1861109/62208*ep^2*mncexp11
	 - 33766519/746496*ep^3*mncexp11
	 + 3/4*ep*mncG311 + ep^2*mncG311 - 43/24*ep^3*mncG311;
fill mncTabTwo(6) =
      1/15*ep^-2*mncexp11 - 139/900*ep^-1*mncexp11 - 12799/6750*mncexp11
	 + 7720709/810000*ep*mncexp11 - 999124577/48600000*ep^2*mncexp11
	 + 76898788103/2916000000*ep^3*mncexp11
	 - 3/5*ep*mncG311 - 101/100*ep^2*mncG311 + 464/375*ep^3*mncG311;
#if ( `n' > 6 )
fill mncTabTwo(7) =
	 - 1/18*ep^-2*mncexp11 + 41/360*ep^-1*mncexp11 + 13183/8100*mncexp11
	 - 2437711/324000*ep*mncexp11 + 856633049/58320000*ep^2*mncexp11
	 - 19656659797/1166400000*ep^3*mncexp11
	 + 1/2*ep*mncG311 + 39/40*ep^2*mncG311 - 383/450*ep^3*mncG311;
fill mncTabTwo(8) =
      1/21*ep^-2*mncexp11 - 257/2940*ep^-1*mncexp11 - 2620213/1852200*mncexp11
	 + 266505851/43218000*ep*mncexp11 - 1832447625539/163364040000*ep^2*mncexp11
	 + 254648720594909/22870965600000*ep^3*mncexp11
	 - 3/7*ep*mncG311 - 909/980*ep^2*mncG311 + 118681/205800*ep^3*mncG311;
#endif
#if ( `n' > 8 )
fill mncTabTwo(9) =
	 - 1/24*ep^-2*mncexp11 + 29/420*ep^-1*mncexp11 + 5316251/4233600*mncexp11
	 - 6129986999/1185408000*ep*mncexp11 + 26135084020949/2987228160000*ep^2*mncexp11
	 - 2198751676783421/278807961600000*ep^3*mncexp11
	 + 3/8*ep*mncG311 + 123/140*ep^2*mncG311 - 88531/235200*ep^3*mncG311;
fill mncTabTwo(10) =
      1/27*ep^-2*mncexp11 - 3791/68040*ep^-1*mncexp11 - 6029953/5358150*mncexp11
	 + 478951433329/108020304000*ep*mncexp11
	 - 1922783114144729/272211166080000*ep^2*mncexp11
	 + 3804584745942884587/685972138521600000*ep^3*mncexp11
	 - 1/3*ep*mncG311 - 6289/7560*ep^2*mncG311 + 539599/2381400*ep^3*mncG311;
#endif
#if ( `n' > 10 )
fill mncTabTwo(11) =
	 - 1/30*ep^-2*mncexp11 + 691/15120*ep^-1*mncexp11 + 12161273/11907000*mncexp11
	 - 462440372497/120022560000*ep*mncexp11
	 + 1749242338593257/302456851200000*ep^2*mncexp11
	 - 3135287147784104059/762191265024000000*ep^3*mncexp11
	 + 3/10*ep*mncG311 + 265/336*ep^2*mncG311 - 296629/2646000*ep^3*mncG311;
fill mncTabTwo(12) =
     + 1/33*ep^-2*mncexp11 - 34729/914760*ep^-1*mncexp11 - 1183461847/1267857360*mncexp11
	 + 119387071076071/35145006019200*ep*mncexp11
	 - 188324238814636153/38968782674088960*ep^2*mncexp11
	 + 402330866351205405392621/135026831965718246400000*ep^3*mncexp11
	 - 3/11*ep*mncG311 - 76151/101640*ep^2*mncG311 + 16227353/704365200*ep^3*mncG311;
#endif
#if ( `n' > 12 )
fill mncTabTwo(13) =
      +mncexp11*(118985473/138311712-1/36*ep^-2+31789/997920*ep^-1-
      115845953484031/38340006566400*ep+173427037149010237/42511399280824320*
      ep^2-331178083656667835129321/147301998508056268800000*ep^3)
      +mncG311*(1/4*ep+79091/110880*ep^2+9086983/192099600*ep^3);
fill mncTabTwo(14) =
      +mncexp11*(-80726970169/101290277088+1/39*ep^-2-378607/14054040*ep^-1+
      19057983628915939/7019416202198400*ep-917828713158387269051/
      263069749552918404096*ep^2+96982930360467673021945950803/
      59249884343056047562521600000*ep^3)
      +mncG311*(-3/13*ep-1062833/1561560*ep^2-29138373491/281361880800*ep^3);
#endif
#if ( `n' > 14 )
fill mncTabTwo(15) =
      +mncexp11*(31163414417/41954552640-1/42*ep^-2+49561/2162160*ep^-1-
      34465390136310241/14038832404396800*ep+608514247855190980417/
      202361345809937233920*ep^2-78326389799039898454344465203/
      63807567754060358913484800000*ep^3)
      +mncG311*(3/14*ep+22337/34320*ep^2+45158205011/303005102400*ep^3);
fill mncTabTwo(16) =
      +mncexp11*(-156220820947/224756532000+1/45*ep^-2-63551/3243240*ep^-1+
      1177467131554197689/526456215164880000*ep-496032103090787825106767/
      189713761696816156800000*ep^2+59696467372353531589643837207/
      68365251165064670264448000000*ep^3)
      +mncG311*(-1/5*ep-224737/360360*ep^2-60421943501/324648324000*ep^3);
#endif
#if ( `n' > 16 )
fill mncTabTwo(17) =
      -1/48*ep^-2*mncexp11
      +36341/2162160*ep^-1*mncexp11
      -9197044416984034249/4492426369406976000*ep*mncexp11
      +3/16*ep*mncG311
      +7406071119949915594782149/3237781532958995742720000*ep^2*mncexp11
      +143839/240240*ep^2*mncG311
      -1469249356813091246078334302257/2333533906434207411693158400000*ep^3*
      mncexp11
      +74998145141/346291545600*ep^3*mncG311
      +313260416543/479480601600*mncexp11
      ;
fill mncTabTwo(18) =
      +1/51*ep^-2*mncexp11
      -9028897/624864240*ep^-1*mncexp11
      +44198387591377070187407/23450746424952502656000*ep*mncexp11
      -3/17*ep*mncG311
      -578494640885671113688726388969/287324173377660051141949440000*ep^2*
      mncexp11
      -39980063/69429360*ep^2*mncG311
      +1456597704750079615919598045938433029/3520364730024701585003438606745600\
      000*ep^3*mncexp11
      -25705837121579/106333147720800*ep^3*mncG311
      -22675805832983/36807628057200*mncexp11
      ;
#endif
#if ( `n' > 18 )
fill mncTabTwo(19) =
      -1/54*ep^-2*mncexp11
      +914233/73513440*ep^-1*mncexp11
      -4804676536172077713623/2758911344112059136000*ep*mncexp11
      +1/6*ep*mncG311
      +541823298035903404576139231369/304225595341051818856181760000*ep^2*
      mncexp11
      +4531207/8168160*ep^2*mncG311
      -12086502741765690259876029009105109/46017839608166033790894622310400000*
      ep^3*mncexp11
      +29571569291879/112588038763200*ep^3*mncG311
      +22719045556433/38972782648800*mncexp11
      ;
fill mncTabTwo(20) =
      +1/57*ep^-2*mncexp11
      -47346521/4423058640*ep^-1*mncexp11
      +32289602952180473422990237/19974671404223758814592000*ep*mncexp11
      -3/19*ep*mncG311
      -66216776579743878776789051647946609/41849594022132392645442933319680000*
      ep^2*mncexp11
      -263043559/491450960*ep^2*mncG311
      +410886238297640666965038605417159731323917/32474247091242987809526109271\
      32535193600000*ep^3*mncexp11
      -3004004582171291/10725574414955400*ep^3*mncG311
      -16426028172582961/29701590687568800*mncexp11
		;
#endif
#endprocedure
*--#] tabtwo : 
*--#[ transfor :
#procedure transfor(TOPOL)
*
*	This file contains topology transformations.
*	The topology assignments of Paulo (lili or convert) sometimes
*	give a diagram a topology that is too complicated, because he
*	could not take the 4 and 5 point vertices into account properly.
*	This file also makes some diagrams zero of which it can be
*	easily seen that this must be the case.
*
#switch `TOPOL'
*--#[ la :
#case la
*
if ( count(mncx1,1) == 0 );
	multiply,replace_(
	 p8,-p5,[P+p8],[P-p5],[P-p8],[P+p5]
	,p7,-p7,[P+p7],[P-p7],[P-p7],[P+p7]
	,p2,p1,[P+p2],[P+p1],[P-p2],[P-p1]
	,p3,p2,[P+p3],[P+p2],[P-p3],[P-p2]
	,p4,p3,[P+p4],[P+p3],[P-p4],[P-p3]
	,p5,p4,[P+p5],[P+p4],[P-p5],[P-p4]
	);
	multiply,replace_(mncx8,mncx5,mncx2,mncx1,mncx3,mncx2,mncx4,mncx3,mncx5,mncx4);
	redefine TOPO "o2";
	Print,"Topology changed from la to o2";
elseif ( count(mncx2,1) == 0 );
	multiply,replace_(
	 p1,-p5,[P+p1],[P-p5],[P-p1],[P+p5]
	,p3,-p4,[P+p3],[P-p4],[P-p3],[P+p4]
	,p4,-p3,[P+p4],[P-p3],[P-p4],[P+p3]
	,p5,-p2,[P+p5],[P-p2],[P-p5],[P+p2]
	,p6,-p1,[P+p6],[P-p1],[P-p6],[P+p1]
	,p7,p6,[P+p7],[P+p6],[P-p7],[P-p6]
	,p8,p7,[P+p8],[P+p7],[P-p8],[P-p7]
	);
	multiply,replace_(mncx1,mncx5,mncx3,mncx4,mncx4,mncx3,mncx5,mncx2,mncx6,mncx1,mncx7,mncx6,mncx8,mncx7);
	redefine TOPO "be";
	Print,"Topology changed from la to be";
elseif ( count(mncx3,1) == 0 );
	multiply,replace_(
	 Q,-Q,[P+Q],[P-Q],[P-Q],[P+Q]
	,p1,-p2,[P+p1],[P-p2],[P-p1],[P+p2]
	,p2,-p1,[P+p2],[P-p1],[P-p2],[P+p1]
	,p7,p5,[P+p7],[P+p5],[P-p7],[P-p5]
	,p5,-p4,[P+p5],[P-p4],[P-p5],[P+p4]
	,p6,-p3,[P+p6],[P-p3],[P-p6],[P+p3]
	,p4,-p6,[P+p4],[P-p6],[P-p4],[P+p6]
	,p8,p7,[P+p8],[P+p7],[P-p8],[P-p7]
	)*mncsgn3;
	multiply,replace_(mncx1,mncx2,mncx2,mncx1,mncx7,mncx5,mncx5,mncx4,mncx6,mncx3,mncx4,mncx6,mncx8,mncx7);
	redefine TOPO "o2";
	Print,"Topology changed from la to o2";
elseif ( count(mncx4,1) == 0 );
	multiply,replace_(
	 Q,-Q,[P+Q],[P-Q],[P-Q],[P+Q]
	,p7,-p5,[P+p7],[P-p5],[P-p7],[P+p5]
	,p1,p3,[P+p1],[P+p3],[P-p1],[P-p3]
	,p2,p4,[P+p2],[P+p4],[P-p2],[P-p4]
	,p5,p1,[P+p5],[P+p1],[P-p5],[P-p1]
	,p6,p2,[P+p6],[P+p2],[P-p6],[P-p2]
	,p3,p6,[P+p3],[P+p6],[P-p3],[P-p6]
	,p8,-p7,[P+p8],[P-p7],[P-p8],[P+p7]
	)*mncsgn3;
	multiply,replace_(mncx7,mncx5,mncx1,mncx3,mncx2,mncx4,mncx5,mncx1,mncx6,mncx2,mncx3,mncx6,mncx8,mncx7);
	redefine TOPO "o2";
	Print,"Topology changed from la to o2";
elseif ( count(mncx5,1) == 0 );
	multiply,replace_(
	 p7,-p6,[P+p7],[P-p6],[P-p7],[P+p6]
	,p8,-p7,[P+p8],[P-p7],[P-p8],[P+p7]
	,p6,p5,[P+p6],[P+p5],[P-p6],[P-p5]
	);
	multiply,replace_(mncx7,mncx6,mncx8,mncx7,mncx6,mncx5);
	redefine TOPO "be";
	Print,"Topology changed from la to be";
elseif ( count(mncx6,1) == 0 );
	multiply,replace_(
	 p1,-p6,[P+p1],[P-p6],[P-p1],[P+p6]
	,p2,-p4,[P+p2],[P-p4],[P-p2],[P+p4]
	,p3,-p3,[P+p3],[P-p3],[P-p3],[P+p3]
	,p4,-p2,[P+p4],[P-p2],[P-p4],[P+p2]
	,p5,-p1,[P+p5],[P-p1],[P-p5],[P+p1]
	,p8,p5,[P+p8],[P+p5],[P-p8],[P-p5]
	);
	multiply,replace_(mncx1,mncx6,mncx2,mncx4,mncx4,mncx2,mncx5,mncx1,mncx8,mncx5);
	redefine TOPO "o2";
	Print,"Topology changed from la to o2";
elseif ( count(mncx7,1) == 0 );
	multiply,replace_(
	 p1,p7,[P+p1],[P+p7],[P-p1],[P-p7]
	,p6,-p6,[P+p6],[P-p6],[P-p6],[P+p6]
	,p2,p1,[P+p2],[P+p1],[P-p2],[P-p1]
	,p3,p2,[P+p3],[P+p2],[P-p3],[P-p2]
	,p4,p3,[P+p4],[P+p3],[P-p4],[P-p3]
	,p5,p4,[P+p5],[P+p4],[P-p5],[P-p4]
	,p8,-p5,[P+p8],[P-p5],[P-p8],[P+p5]
	);
	multiply,replace_(mncx1,mncx7,mncx2,mncx1,mncx3,mncx2,mncx4,mncx3,mncx5,mncx4,mncx8,mncx5);
	redefine TOPO "o3";
	Print,"Topology changed from la to o3";
elseif ( count(mncx8,1) == 0 );
	multiply,replace_(
	 p3,p7,[P+p3],[P+p7],[P-p3],[P-p7]
	,p4,-p6,[P+p4],[P-p6],[P-p4],[P+p6]
	,p7,p5,[P+p7],[P+p5],[P-p7],[P-p5]
	,p5,p3,[P+p5],[P+p3],[P-p5],[P-p3]
	,p6,p4,[P+p6],[P+p4],[P-p6],[P-p4]
	);
	multiply,replace_(mncx3,mncx7,mncx4,mncx6,mncx7,mncx5,mncx5,mncx3,mncx6,mncx4);
	redefine TOPO "o3";
	Print,"Topology changed from la to o3";
endif;
*
#break
*--#] la : 
*--#[ be :
#case be
*
if ( count(mncx1,1,mncx3,1) == 0 );
	multiply,replace_(
	 p2,p7,[P+p2],[P+p7],[P-p2],[P-p7]
	,p8,p5,[P+p8],[P+p5],[P-p8],[P-p5]
	,p4,-p2,[P+p4],[P-p2],[P-p4],[P+p2]
	,p5,-p1,[P+p5],[P-p1],[P-p5],[P+p1]
	,p7,p3,[P+p7],[P+p3],[P-p7],[P-p3]
	,p6,p4,[P+p6],[P+p4],[P-p6],[P-p4]
	);
	multiply,replace_(mncx2,mncx7,mncx8,mncx5,mncx4,mncx2,mncx5,mncx1,mncx7,mncx3,mncx6,mncx4);
	redefine TOPO "o4";
	Print,"Topology changed from be to o4";
elseif ( count(mncx1,1,mncx8,1) == 0 );
	multiply,replace_(
	 p2,p1,[P+p2],[P+p1],[P-p2],[P-p1]
	,p3,p2,[P+p3],[P+p2],[P-p3],[P-p2]
	,p4,p3,[P+p4],[P+p3],[P-p4],[P-p3]
	,p7,p5,[P+p7],[P+p5],[P-p7],[P-p5]
	,p5,p7,[P+p5],[P+p7],[P-p5],[P-p7]
	);
	multiply,replace_(mncx2,mncx1,mncx3,mncx2,mncx4,mncx3,mncx7,mncx5,mncx5,mncx7);
	redefine TOPO "o2";
	Print,"Topology changed from be to o2";
elseif ( count(mncx3,1,mncx8,1) == 0 );
	multiply,replace_(
	 Q,-Q,[P+Q],[P-Q],[P-Q],[P+Q]
	,p1,-p2,[P+p1],[P-p2],[P-p1],[P+p2]
	,p2,-p1,[P+p2],[P-p1],[P-p2],[P+p1]
	,p6,-p5,[P+p6],[P-p5],[P-p6],[P+p5]
	,p5,-p3,[P+p5],[P-p3],[P-p5],[P+p3]
	,p4,-p6,[P+p4],[P-p6],[P-p4],[P+p6]
	,p7,-p7,[P+p7],[P-p7],[P-p7],[P+p7]
	)*mncsgn3;
	multiply,replace_(mncx1,mncx2,mncx2,mncx1,mncx6,mncx5,mncx5,mncx3,mncx4,mncx6);
	redefine TOPO "o2";
	Print,"Topology changed from be to o2";
elseif ( count(mncx2,1) == 0 );
	multiply,replace_(
	 p3,p2,[P+p3],[P+p2],[P-p3],[P-p2]
	,p4,p3,[P+p4],[P+p3],[P-p4],[P-p3]
	,p5,p4,[P+p5],[P+p4],[P-p5],[P-p4]
	,p6,-p6,[P+p6],[P-p6],[P-p6],[P+p6]
	,p8,-p5,[P+p8],[P-p5],[P-p8],[P+p5]
	);
	multiply,replace_(mncx3,mncx2,mncx4,mncx3,mncx5,mncx4,mncx8,mncx5);
	redefine TOPO "o1";
	Print,"Topology changed from be to o1";
elseif ( count(mncx4,1) == 0 );
	multiply,replace_(
	 p1,p6,[P+p1],[P+p6],[P-p1],[P-p6]
	,p2,p1,[P+p2],[P+p1],[P-p2],[P-p1]
	,p3,p2,[P+p3],[P+p2],[P-p3],[P-p2]
	,p8,p3,[P+p8],[P+p3],[P-p8],[P-p3]
	,p6,p4,[P+p6],[P+p4],[P-p6],[P-p4]
	,p7,p5,[P+p7],[P+p5],[P-p7],[P-p5]
	,p5,-p7,[P+p5],[P-p7],[P-p5],[P+p7]
	);
	multiply,replace_(mncx1,mncx6,mncx2,mncx1,mncx3,mncx2,mncx8,mncx3,mncx6,mncx4,mncx7,mncx5,mncx5,mncx7);
	redefine TOPO "o4";
	Print,"Topology changed from be to o4";
elseif ( count(mncx5,1) == 0 );
	multiply,replace_(
	 p8,-p4,[P+p8],[P-p4],[P-p8],[P+p4]
	,p6,-p5,[P+p6],[P-p5],[P-p6],[P+p5]
	,p3,p6,[P+p3],[P+p6],[P-p3],[P-p6]
	,p4,-p7,[P+p4],[P-p7],[P-p4],[P+p7]
	,p7,p3,[P+p7],[P+p3],[P-p7],[P-p3]
	);
	multiply,replace_(mncx8,mncx4,mncx6,mncx5,mncx3,mncx6,mncx4,mncx7,mncx7,mncx3);
	redefine TOPO "o4";
	Print,"Topology changed from be to o4";
elseif ( count(mncx6,1) == 0 );
	multiply,replace_(
	 Q,-Q,[P+Q],[P-Q],[P-Q],[P+Q]
	,p1,p3,[P+p1],[P+p3],[P-p1],[P-p3]
	,p4,p1,[P+p4],[P+p1],[P-p4],[P-p1]
	,p5,p2,[P+p5],[P+p2],[P-p5],[P-p2]
	,p3,p4,[P+p3],[P+p4],[P-p3],[P-p4]
	,p2,p6,[P+p2],[P+p6],[P-p2],[P-p6]
	,p7,-p7,[P+p7],[P-p7],[P-p7],[P+p7]
	,p8,p5,[P+p8],[P+p5],[P-p8],[P-p5]
	)*mncsgn3;
	multiply,replace_(mncx1,mncx3,mncx4,mncx1,mncx5,mncx2,mncx3,mncx4,mncx2,mncx6,mncx8,mncx5);
	redefine TOPO "o2";
	Print,"Topology changed from be to o2";
elseif ( count(mncx7,1) == 0 );
	multiply,replace_(
	 p1,-p4,[P+p1],[P-p4],[P-p1],[P+p4]
	,p2,-p7,[P+p2],[P-p7],[P-p2],[P+p7]
	,p8,p5,[P+p8],[P+p5],[P-p8],[P-p5]
	,p3,-p3,[P+p3],[P-p3],[P-p3],[P+p3]
	,p4,-p2,[P+p4],[P-p2],[P-p4],[P+p2]
	,p5,-p1,[P+p5],[P-p1],[P-p5],[P+p1]
	);
	multiply,replace_(mncx1,mncx4,mncx2,mncx7,mncx8,mncx5,mncx4,mncx2,mncx5,mncx1);
	redefine TOPO "o2";
	Print,"Topology changed from be to o2";
endif;
*
#break
*--#] be : 
*--#[ no :
#case no
*
*	If we miss a line, we go to the benz topology
*
if ( count(mncx1,1) == 0 );
	multiply,replace_(p8,p7,[P+p8],[P+p7],[P-p8],[P-p7]
	,p5,p8,[P+p5],[P+p8],[P-p5],[P-p8]
	,p7,p5,[P+p7],[P+p5],[P-p7],[P-p5]);
	multiply,replace_(mncx8,mncx7,mncx5,mncx8,mncx7,mncx5);
	redefine TOPO "be";
	Print,"Topology changed from no to be";
elseif ( count(mncx2,1) == 0 );
	multiply,replace_(
	 p1,-p5,[P+p1],[P-p5],[P-p1],[P+p5]
	,p3,-p4,[P+p3],[P-p4],[P-p3],[P+p4]
	,p6,-p1,[P+p6],[P-p1],[P-p6],[P+p1]
	,p5,-p2,[P+p5],[P-p2],[P-p5],[P+p2]
	,p4,-p3,[P+p4],[P-p3],[P-p4],[P+p3]
	,p8,p6,[P+p8],[P+p6],[P-p8],[P-p6]
	);
	multiply,replace_(mncx1,mncx5,mncx3,mncx4,mncx6,mncx1,mncx5,mncx2,mncx4,mncx3,mncx8,mncx6);
	redefine TOPO "be";
	Print,"Topology changed from no to be";
elseif ( count(mncx3,1) == 0 );
	multiply,replace_(
	 p8,p4,[P+p8],[P+p4],[P-p8],[P-p4]
	,p6,p5,[P+p6],[P+p5],[P-p6],[P-p5]
	,p7,p6,[P+p7],[P+p6],[P-p7],[P-p6]
	,p4,p7,[P+p4],[P+p7],[P-p4],[P-p7]
	,p5,-p8,[P+p5],[P-p8],[P-p5],[P+p8]
	);
	multiply,replace_(mncx8,mncx4,mncx6,mncx5,mncx7,mncx6,mncx4,mncx7,mncx5,mncx8);
	redefine TOPO "be";
	Print,"Topology changed from no to be";
elseif ( count(mncx4,1) == 0 );
	multiply,replace_(
	 p7,-p2,[P+p7],[P-p2],[P-p7],[P+p2]
	,p2,-p6,[P+p2],[P-p6],[P-p2],[P+p6]
	,p3,-p7,[P+p3],[P-p7],[P-p3],[P+p7]
	,p8,-p8,[P+p8],[P-p8],[P-p8],[P+p8]
	,p6,p5,[P+p6],[P+p5],[P-p6],[P-p5]
	,p5,p4,[P+p5],[P+p4],[P-p5],[P-p4]
	);
	multiply,replace_(mncx7,mncx2,mncx2,mncx6,mncx3,mncx7,mncx6,mncx5,mncx5,mncx4);
	redefine TOPO "be";
	Print,"Topology changed from no to be";
elseif ( count(mncx5,1) == 0 );
	multiply,replace_(
	 p7,p6,[P+p7],[P+p6],[P-p7],[P-p6]
	,p8,p7,[P+p8],[P+p7],[P-p8],[P-p7]
	,p6,p5,[P+p6],[P+p5],[P-p6],[P-p5]
	);
	multiply,replace_(mncx7,mncx6,mncx8,mncx7,mncx6,mncx5);
	redefine TOPO "be";
	Print,"Topology changed from no to be";
elseif ( count(mncx6,1) == 0 );
	multiply,replace_(
	 p8,-p2,[P+p8],[P-p2],[P-p8],[P+p2]
	,p1,-p6,[P+p1],[P-p6],[P-p1],[P+p6]
	,p2,-p7,[P+p2],[P-p7],[P-p2],[P+p7]
	,p7,p8,[P+p7],[P+p8],[P-p7],[P-p8]
	);
	multiply,replace_(mncx8,mncx2,mncx1,mncx6,mncx2,mncx7,mncx7,mncx8);
	redefine TOPO "be";
	Print,"Topology changed from no to be";
elseif ( count(mncx7,1) == 0 );
	multiply,replace_(
	 p6,-p1,[P+p6],[P-p1],[P-p6],[P+p1]
	,p1,-p5,[P+p1],[P-p5],[P-p1],[P+p5]
	,p8,-p2,[P+p8],[P-p2],[P-p8],[P+p2]
	,p5,p6,[P+p5],[P+p6],[P-p5],[P-p6]
	,p2,-p7,[P+p2],[P-p7],[P-p2],[P+p7]
	);
	multiply,replace_(mncx6,mncx1,mncx1,mncx5,mncx8,mncx2,mncx5,mncx6,mncx2,mncx7);
	redefine TOPO "be";
	Print,"Topology changed from no to be";
elseif ( count(mncx8,1) == 0 );
	multiply,replace_(
	 p6,p5,[P+p6],[P+p5],[P-p6],[P-p5]
	,p3,-p4,[P+p3],[P-p4],[P-p3],[P+p4]
	,p4,-p3,[P+p4],[P-p3],[P-p4],[P+p3]
	,p7,-p2,[P+p7],[P-p2],[P-p7],[P+p2]
	,p2,-p6,[P+p2],[P-p6],[P-p2],[P+p6]
	,p5,p7,[P+p5],[P+p7],[P-p5],[P-p7]
	);
	multiply,replace_(mncx6,mncx5,mncx3,mncx4,mncx4,mncx3,mncx7,mncx2,mncx2,mncx6,mncx5,mncx7);
	redefine TOPO "be";
	Print,"Topology changed from no to be";
endif;
*
#break
*--#] no : 
*--#[ fa :
#case fa
*
*
#break
*--#] fa : 
*--#[ bu :
#case bu
*
*
#break
*--#] bu : 
*--#[ o1 :
#case o1
*
if ( count(mncx1,1) == 0 );
	multiply,replace_(
	 p3,-p1,[P+p3],[P-p1],[P-p3],[P+p1]
	,p4,-p4,[P+p4],[P-p4],[P-p4],[P+p4]
	,p5,p3,[P+p5],[P+p3],[P-p5],[P-p3]
	,p7,p5,[P+p7],[P+p5],[P-p7],[P-p5]
	);
	multiply,replace_(mncx3,mncx1,mncx5,mncx3,mncx7,mncx5);
	redefine TOPO "y3";
	Print,"Topology changed from o1 to y3";
elseif ( count(mncx2,1) == 0 );
	multiply,replace_(
	 p1,p2,[P+p1],[P+p2],[P-p1],[P-p2]
	,p4,-p1,[P+p4],[P-p1],[P-p4],[P+p1]
	,p3,-p4,[P+p3],[P-p4],[P-p3],[P+p4]
	,p5,-p3,[P+p5],[P-p3],[P-p5],[P+p3]
	,p6,-p6,[P+p6],[P-p6],[P-p6],[P+p6]
	,p7,-p5,[P+p7],[P-p5],[P-p7],[P+p5]
	);
	multiply,replace_(mncx1,mncx2,mncx4,mncx1,mncx3,mncx4,mncx5,mncx3,mncx7,mncx5);
	redefine TOPO "y3";
	Print,"Topology changed from o1 to y3";
elseif ( count(mncx3,1) == 0 );
	multiply,replace_(
	 p4,-p2,[P+p4],[P-p2],[P-p4],[P+p2]
	,p2,p4,[P+p2],[P+p4],[P-p2],[P-p4]
	,p5,p3,[P+p5],[P+p3],[P-p5],[P-p3]
	,p7,p5,[P+p7],[P+p5],[P-p7],[P-p5]
	);
	multiply,replace_(mncx4,mncx2,mncx2,mncx4,mncx5,mncx3,mncx7,mncx5);
	redefine TOPO "y3";
	Print,"Topology changed from o1 to y3";
elseif ( count(mncx4,1) == 0 );
	multiply,replace_(
	 p2,p1,[P+p2],[P+p1],[P-p2],[P-p1]
	,p3,-p2,[P+p3],[P-p2],[P-p3],[P+p2]
	,p1,p4,[P+p1],[P+p4],[P-p1],[P-p4]
	,p5,-p3,[P+p5],[P-p3],[P-p5],[P+p3]
	,p6,-p6,[P+p6],[P-p6],[P-p6],[P+p6]
	,p7,-p5,[P+p7],[P-p5],[P-p7],[P+p5]
	);
	multiply,replace_(mncx2,mncx1,mncx3,mncx2,mncx1,mncx4,mncx5,mncx3,mncx7,mncx5);
	redefine TOPO "y3";
	Print,"Topology changed from o1 to y3";
elseif ( ( count(mncx6,1) == 0 ) || ( count(mncx7,1) == 0 ) );
	Discard;
endif;
*
#break
*--#] o1 : 
*--#[ o2 :
#case o2
*
if ( count(mncx1,1) == 0 );
	multiply,replace_(
	 p3,-p1,[P+p3],[P-p1],[P-p3],[P+p1]
	,p5,p4,[P+p5],[P+p4],[P-p5],[P-p4]
	,p4,-p3,[P+p4],[P-p3],[P-p4],[P+p3]
	,p7,-p5,[P+p7],[P-p5],[P-p7],[P+p5]
	,p6,-p6,[P+p6],[P-p6],[P-p6],[P+p6]
	);
	multiply,replace_(mncx3,mncx1,mncx5,mncx4,mncx4,mncx3,mncx7,mncx5);
	redefine TOPO "y3";
	Print,"Topology changed from o2 to y3";
elseif ( count(mncx2,1) == 0 );
	multiply,replace_(
	 p1,p2,[P+p1],[P+p2],[P-p1],[P-p2]
	,p4,-p1,[P+p4],[P-p1],[P-p4],[P+p1]
	,p5,-p5,[P+p5],[P-p5],[P-p5],[P+p5]
	,p3,-p6,[P+p3],[P-p6],[P-p3],[P+p6]
	,p6,-p3,[P+p6],[P-p3],[P-p6],[P+p3]
	,p7,-p4,[P+p7],[P-p4],[P-p7],[P+p4]
	);
	multiply,replace_(mncx1,mncx2,mncx4,mncx1,mncx3,mncx6,mncx6,mncx3,mncx7,mncx4);
	redefine TOPO "y2";
	Print,"Topology changed from o2 to y2";
elseif ( count(mncx3,1) == 0 );
	multiply,replace_(
	 p2,p3,[P+p2],[P+p3],[P-p2],[P-p3]
	,p5,p4,[P+p5],[P+p4],[P-p5],[P-p4]
	,p4,-p2,[P+p4],[P-p2],[P-p4],[P+p2]
	,p6,-p6,[P+p6],[P-p6],[P-p6],[P+p6]
	,p7,-p5,[P+p7],[P-p5],[P-p7],[P+p5]
	);
	multiply,replace_(mncx2,mncx3,mncx5,mncx4,mncx4,mncx2,mncx7,mncx5);
	redefine TOPO "y1";
	Print,"Topology changed from o2 to y1";
elseif ( count(mncx5,1) == 0 );
	multiply,replace_(
	 p2,p5,[P+p2],[P+p5],[P-p2],[P-p5]
	,p3,-p6,[P+p3],[P-p6],[P-p3],[P+p6]
	,p4,-p1,[P+p4],[P-p1],[P-p4],[P+p1]
	,p1,p2,[P+p1],[P+p2],[P-p1],[P-p2]
	,p6,-p3,[P+p6],[P-p3],[P-p6],[P+p3]
	,p7,-p4,[P+p7],[P-p4],[P-p7],[P+p4]
	);
	multiply,replace_(mncx2,mncx5,mncx3,mncx6,mncx4,mncx1,mncx1,mncx2,mncx6,mncx3,mncx7,mncx4);
	redefine TOPO "y4";
	Print,"Topology changed from o2 to y4";
elseif ( ( count(mncx6,1) == 0 ) || ( count(mncx7,1) == 0 ) );
	Discard;
endif;
*
#break
*--#] o2 : 
*--#[ o3 :
#case o3
*
if ( count(mncx5,1) == 0 );
	multiply,replace_(
	 p7,p5,[P+p7],[P+p5],[P-p7],[P-p5]
	,p1,p3,[P+p1],[P+p3],[P-p1],[P-p3]
	,p4,-p4,[P+p4],[P-p4],[P-p4],[P+p4]
	,p2,p1,[P+p2],[P+p1],[P-p2],[P-p1]
	,p3,-p2,[P+p3],[P-p2],[P-p3],[P+p2]
	);
	multiply,replace_(mncx7,mncx5,mncx1,mncx3,mncx2,mncx1,mncx3,mncx2);
	redefine TOPO "y5";
	Print,"Topology changed from o3 to y5";
elseif ( count(mncx1,1) == 0 );
	multiply,replace_(
	 p7,p5,[P+p7],[P+p5],[P-p7],[P-p5]
	,p3,-p1,[P+p3],[P-p1],[P-p3],[P+p1]
	,p4,-p4,[P+p4],[P-p4],[P-p4],[P+p4]
	,p5,p3,[P+p5],[P+p3],[P-p5],[P-p3]
	);
	multiply,replace_(mncx7,mncx5,mncx3,mncx1,mncx5,mncx3);
	redefine TOPO "y4";
	Print,"Topology changed from o3 to y4";
elseif ( count(mncx2,1) == 0 );
	multiply,replace_(
	 p7,p5,[P+p7],[P+p5],[P-p7],[P-p5]
	,p4,-p1,[P+p4],[P-p1],[P-p4],[P+p1]
	,p1,p2,[P+p1],[P+p2],[P-p1],[P-p2]
	,p3,-p3,[P+p3],[P-p3],[P-p3],[P+p3]
	,p5,-p4,[P+p5],[P-p4],[P-p5],[P+p4]
	);
	multiply,replace_(mncx7,mncx5,mncx4,mncx1,mncx1,mncx2,mncx5,mncx4);
	redefine TOPO "y4";
	Print,"Topology changed from o3 to y4";
elseif ( count(mncx3,1) == 0 );
	multiply,replace_(
	 p7,p5,[P+p7],[P+p5],[P-p7],[P-p5]
	,p4,-p2,[P+p4],[P-p2],[P-p4],[P+p2]
	,p2,p3,[P+p2],[P+p3],[P-p2],[P-p3]
	,p5,p4,[P+p5],[P+p4],[P-p5],[P-p4]
	);
	multiply,replace_(mncx7,mncx5,mncx4,mncx2,mncx2,mncx3,mncx5,mncx4);
	redefine TOPO "y4";
	Print,"Topology changed from o3 to y4";
elseif ( count(mncx4,1) == 0 );
	multiply,replace_(
	 p7,p5,[P+p7],[P+p5],[P-p7],[P-p5]
	,p2,p1,[P+p2],[P+p1],[P-p2],[P-p1]
	,p3,-p2,[P+p3],[P-p2],[P-p3],[P+p2]
	,p1,p3,[P+p1],[P+p3],[P-p1],[P-p3]
	,p5,-p4,[P+p5],[P-p4],[P-p5],[P+p4]
	);
	multiply,replace_(mncx7,mncx5,mncx2,mncx1,mncx3,mncx2,mncx1,mncx3,mncx5,mncx4);
	redefine TOPO "y4";
	Print,"Topology changed from o3 to y4";
elseif ( ( count(mncx6,1) == 0 ) || ( count(mncx7,1) == 0 ) );
	Discard;
endif;
*
#break
*--#] o3 : 
*--#[ o4 :
#case o4
*
if ( count(mncx5,1) == 0 );
	multiply,replace_(
	 p6,p1,[P+p6],[P+p1],[P-p6],[P-p1]
	,p7,p2,[P+p7],[P+p2],[P-p7],[P-p2]
	,p1,p3,[P+p1],[P+p3],[P-p1],[P-p3]
	,p4,-p4,[P+p4],[P-p4],[P-p4],[P+p4]
	,p2,p5,[P+p2],[P+p5],[P-p2],[P-p5]
	,p3,-p6,[P+p3],[P-p6],[P-p3],[P+p6]
	);
	multiply,replace_(mncx6,mncx1,mncx7,mncx2,mncx1,mncx3,mncx2,mncx5,mncx3,mncx6);
	redefine TOPO "y2";
	Print,"Topology changed from o4 to y2";
elseif ( count(mncx1,1) == 0 );
	multiply,replace_(
	 p6,p1,[P+p6],[P+p1],[P-p6],[P-p1]
	,p7,p2,[P+p7],[P+p2],[P-p7],[P-p2]
	,p2,p4,[P+p2],[P+p4],[P-p2],[P-p4]
	,p3,-p3,[P+p3],[P-p3],[P-p3],[P+p3]
	,p4,-p6,[P+p4],[P-p6],[P-p4],[P+p6]
	);
	multiply,replace_(mncx6,mncx1,mncx7,mncx2,mncx2,mncx4,mncx4,mncx6);
	redefine TOPO "y3";
	Print,"Topology changed from o4 to y3";
elseif ( count(mncx2,1) == 0 );
	multiply,replace_(
	 p6,p1,[P+p6],[P+p1],[P-p6],[P-p1]
	,p7,p2,[P+p7],[P+p2],[P-p7],[P-p2]
	,p1,p4,[P+p1],[P+p4],[P-p1],[P-p4]
	,p4,-p3,[P+p4],[P-p3],[P-p4],[P+p3]
	,p5,-p5,[P+p5],[P-p5],[P-p5],[P+p5]
	,p3,-p6,[P+p3],[P-p6],[P-p3],[P+p6]
	);
	multiply,replace_(mncx6,mncx1,mncx7,mncx2,mncx1,mncx4,mncx4,mncx3,mncx3,mncx6);
	redefine TOPO "y3";
	Print,"Topology changed from o4 to y3";
elseif ( count(mncx3,1) == 0 );
	multiply,replace_(
	 p6,p1,[P+p6],[P+p1],[P-p6],[P-p1]
	,p7,p2,[P+p7],[P+p2],[P-p7],[P-p2]
	,p1,p3,[P+p1],[P+p3],[P-p1],[P-p3]
	,p4,-p4,[P+p4],[P-p4],[P-p4],[P+p4]
	,p2,p6,[P+p2],[P+p6],[P-p2],[P-p6]
	);
	multiply,replace_(mncx6,mncx1,mncx7,mncx2,mncx1,mncx3,mncx2,mncx6);
	redefine TOPO "y3";
	Print,"Topology changed from o4 to y3";
elseif ( count(mncx4,1) == 0 );
	multiply,replace_(
	 p6,p1,[P+p6],[P+p1],[P-p6],[P-p1]
	,p7,p2,[P+p7],[P+p2],[P-p7],[P-p2]
	,p1,p6,[P+p1],[P+p6],[P-p1],[P-p6]
	,p5,-p5,[P+p5],[P-p5],[P-p5],[P+p5]
	,p2,p3,[P+p2],[P+p3],[P-p2],[P-p3]
	,p3,-p4,[P+p3],[P-p4],[P-p3],[P+p4]
	);
	multiply,replace_(mncx6,mncx1,mncx7,mncx2,mncx1,mncx6,mncx2,mncx3,mncx3,mncx4);
	redefine TOPO "y3";
	Print,"Topology changed from o4 to y3";
elseif ( count(mncx7,1) == 0 );
	discard;
endif;
*
#break
*--#] o4 : 
*--#[ y1 :
#case y1
*
if ( count(mncx3,1) == 0 ) discard;
if ( count(mncx4,1) == 0 ) discard;
if ( count(mncx5,1) == 0 ) discard;
if ( count(mncx6,1) == 0 ) discard;
*
#break
*--#] y1 : 
*--#[ y2 :
#case y2
*
if ( count(mncx2,1) == 0 ) discard;
if ( count(mncx3,1) == 0 ) discard;
if ( count(mncx4,1) == 0 ) discard;
if ( count(mncx5,1) == 0 ) discard;
if ( count(mncx6,1) == 0 ) discard;
*
#break
*--#] y2 : 
*--#[ y3 :
#case y3
*
if ( count(mncx2,1) == 0 ) discard;
if ( count(mncx4,1) == 0 ) discard;
if ( count(mncx5,1) == 0 ) discard;
if ( count(mncx6,1) == 0 ) discard;
*
#break
*--#] y3 : 
*--#[ y4 :
#case y4
*
if ( count(mncx2,1) == 0 ) discard;
if ( count(mncx3,1) == 0 ) discard;
if ( count(mncx4,1) == 0 ) discard;
if ( count(mncx5,1) == 0 ) discard;
if ( count(mncx6,1) == 0 ) discard;
*
#break
*--#] y4 : 
*--#[ y5 :
#case y5
*
if ( count(mncx1,1) == 0 ) discard;
if ( count(mncx2,1) == 0 ) discard;
if ( count(mncx3,1) == 0 ) discard;
if ( count(mncx4,1) == 0 ) discard;
if ( count(mncx5,1) == 0 ) discard;
if ( count(mncx6,1) == 0 ) discard;
*
#break
*--#] y5 : 
*--#[ t1 :
#case t1
*
*	If 5 is missing we have t3, if 1,2,3,4 is missing, we have t2.
*
if ( count(mncx5,1) == 0 );
	multiply,replace_(p4,-p2,[P+p4],[P-p2],[P-p4],[P+p2]
	,p2,p3,[P+p2],[P+p3],[P-p2],[P-p3]
	,p3,-p4,[P+p3],[P-p4],[P-p3],[P+p4]);
	multiply,replace_(mncx4,mncx2,mncx2,mncx3,mncx3,mncx4);
	redefine TOPO "t3";
	Print,"Topology changed from t1 to t3";
elseif ( count(mncx1,1) == 0 );
	multiply,replace_(p5,p3,[P+p5],[P+p3],[P-p5],[P-p3]
	,p4,-p4,[P+p4],[P-p4],[P-p4],[P+p4]
	,p3,-p1,[P+p3],[P-p1],[P-p3],[P+p1]);
	multiply,replace_(mncx5,mncx3,mncx3,mncx1);
	redefine TOPO "t2";
	Print,"Topology changed from t1 to t2";
elseif ( count(mncx2,1) == 0 );
	multiply,replace_(p1,p2,[P+p1],[P+p2],[P-p1],[P-p2]
	,p4,-p1,[P+p4],[P-p1],[P-p4],[P+p1]
	,p5,-p3,[P+p5],[P-p3],[P-p5],[P+p3]
	,p3,-p4,[P+p3],[P-p4],[P-p3],[P+p4]);
	multiply,replace_(mncx1,mncx2,mncx4,mncx1,mncx5,mncx3,mncx3,mncx4);
	redefine TOPO "t2";
	Print,"Topology changed from t1 to t2";
elseif ( count(mncx3,1) == 0 );
	multiply,replace_(p2,p3,[P+p2],[P+p3],[P-p2],[P-p3]
	,p5,p4,[P+p5],[P+p4],[P-p5],[P-p4]
	,p4,-p2,[P+p4],[P-p2],[P-p4],[P+p2]);
	multiply,replace_(mncx2,mncx3,mncx5,mncx4,mncx4,mncx2);
	redefine TOPO "t2";
	Print,"Topology changed from t1 to t2";
elseif ( count(mncx4,1) == 0 );
	multiply,replace_(p1,p3,[P+p1],[P+p3],[P-p1],[P-p3]
	,p5,-p4,[P+p5],[P-p4],[P-p5],[P+p4]
	,p2,p1,[P+p2],[P+p1],[P-p2],[P-p1]
	p3,-p2,[P+p3],[P-p2],[P-p3],[P+p2]);
	multiply,replace_(mncx1,mncx3,mncx5,mncx4,mncx2,mncx1,mncx3,mncx2);
	redefine TOPO "t2";
	Print,"Topology changed from t1 to t2";
endif;
#break
*--#] t1 : 
*--#[ t2 :
#case t2
*
if ( count(mncx2,1) == 0 ) discard;
if ( count(mncx3,1) == 0 ) discard;
if ( count(mncx4,1) == 0 ) discard;
*
#break
*--#] t2 : 
*--#[ t3 :
#case t3
*
if ( count(mncx1,1) == 0 ) discard;
if ( count(mncx2,1) == 0 ) discard;
if ( count(mncx3,1) == 0 ) discard;
if ( count(mncx4,1) == 0 ) discard;
*
#break
*--#] t3 : 
*--#[ l1 :
#case l1
*
*
#break
*--#] l1 : 
*--#[ l2 :
#case l2
*
*
#break
*--#] l2 : 
*--#[ l3 :
#case l3
*
*
#break
*--#] l3 : 
*--#[ tr :
#case tr
*
*
#break
*--#] tr : 
#endswitch
#endprocedure

*--#] transfor : 
*--#[ triangl2 :
#procedure triangl2(P,PA,PB,P1,P3,EA,EB)
*
*   Routine solves the triangle recursion
*                     P
*      N1 -------------------------- N3
*          P1    \    N2    /    P3
*                 \        /
*                A \      / B
*                PA \    / PB
*                    \  /
*                     \/
*
*   mncA,mncB,mncN1,mncN2,mncN3 are the powers of the denominators
*   mncA and mncB don't have to be integers here.
*   EA and EB are 1/PA.PA^ep and 1/PB.PB^ep
*   P is the momentum in mncN2. We need it here to determine the extra
*   momenta in the numerator.
*
*   This routine differs from the routine triangle in that the final 
*   substitution of mncftri involves gamma functions rather than factorials.
*
id  `P' = mncx*`P';
if ( count(`P1'.`P1',1,`P3'.`P3',1,`P'.`P',1) < -4 );
id  mncx^mncm?/`P1'.`P1'^mncN1?/`P'.`P'^mncN2?/`P3'.`P3'^mncN3?/`PA'.`PA'^mncA?/`PB'.`PB'^mncB?
        *`EA'^mncx1?*`EB'^mncx2? =
        mncftri(mncN1,mncN2,mncN3,mncA,mncB,mncx1,mncx2,mncm)*mncpoinv(mncA,mncx1)*mncpoinv(mncB,mncx2)*`EA'^mncx1*`EB'^mncx2;
id  mncpoinv(1,mncx1?) = 1;
id  mncpoinv(mncx1?,0) = invfac_(mncx1-1);
id  mncpoinv(mncx1?neg0_,mncx2?) = mncx2*acc(mncPOINV(mncx1,mncx2))*ep;
id  mncpoinv(mncx1?pos_,mncx2?) = acc(mncPOINV(mncx1,mncx2));

id  mncftri(mncN1?,mncN2?,mncN3?,mncA?,mncB?,mncx1?,mncx2?,mncm?) =
        +sum_(mnck4,0,mncN3-1,sign_(mncN1+mnck4)*mncpo(5+mncm-2*mncN2-mncA-mncB-mncN1-mnck4,-2-mncx1-mncx2)
            *mncsumm1(mncN1,mncN2,mncN3,mncA,mncB,mncx1,mncx2,mncm,mnck4)*invfac_(mnck4))*invfac_(mncN1-1)
        +mncsumm2(mncN1,mncN2,mncN3,mncA,mncB,mncx1,mncx2,mncm)*mncN2*mncpoinv(4+mncm-2*mncN2-mncA-mncB+mncN2,-2-mncx1-mncx2)
        +sum_(mnck2,0,mncN1-1,sign_(mnck2+mncN3)*mncpo(5+mncm-2*mncN2-mncA-mncB-mnck2-mncN3,-2-mncx1-mncx2)
            *mncsumm3(mncN1,mncN2,mncN3,mncA,mncB,mncx1,mncx2,mncm,mnck2)*invfac_(mnck2))*invfac_(mncN3-1)
    ;
*
*   Evaluate the gamma functions.
*   We multiply numerator and denominator with gamma(1-2*ep)
*   Then mncpo(mncx,-2) represents a normalized gamma function.
*   The following identities can then be applied:
*   (the table has overal factors ep taken out)
*
if ( count(mncsumm2,1) );
    id  mncpoinv(1,mncy1?) = 1;
    id  mncpoinv(mncx1?neg0_,mncy1?) = mncy1*acc(mncPOINV(mncx1,mncy1))*ep;
    id  mncpoinv(mncx1?pos_,mncy1?) = acc(mncPOINV(mncx1,mncy1));
    id  mncsumm2(mncN1?,mncN2?,mncN3?,mncA?,mncB?,mncx1?,mncx2?,mncm?) =
        +sum_(mnck2,0,mncN1-1,sum_(mnck4,0,mncN3-1,sign_(mnck2+mnck4)*fac_(mnck2+mncN2+mnck4-1)
            *mncpo(4+mncm-2*mncN2-mncA-mncB-mnck2-mnck4,-2-mncx1-mncx2)
            *mncsumm2(mncN1,mncN2,mncN3,mncA,mncB,mncx1,mncx2,mncm,mnck2,mnck4)
         *invfac_(mnck4))*invfac_(mnck2));
    id  mncpo(mncx1?,0) = fac_(mncx1-1);
    id  mncpo(1,mncy1?) = 1;
    id  mncpo(mncx1?neg0_,mncy1?) = acc(mncPO(mncx1,mncy1))/mncy1/ep;
    id  mncpo(mncx1?pos_,mncy1?) = acc(mncPO(mncx1,mncy1));
    id  mncsumm2(mncN1?,mncN2?,mncN3?,mncA?,mncB?,mncx1?,mncx2?,mncm?,mnck2?,mnck4?) =
             sum_(mnck1,0,mncN2,invfac_(mnck1)*invfac_(mncN2-mnck1)
            *mncftri(mncN1-mnck2,0,mncN3-mnck4,mncA+mnck1+mnck2,mncB+mncN2-mnck1+mnck4,mncx1,mncx2));
else;
    id  mncpo(mncx1?,0) = fac_(mncx1-1);
    id  mncpo(1,mncy1?) = 1;
    id  mncpo(mncx1?neg0_,mncy1?) = acc(mncPO(mncx1,mncy1))/mncy1/ep;
    id  mncpo(mncx1?pos_,mncy1?) = acc(mncPO(mncx1,mncy1));
    id  mncsumm1(mncN1?,mncN2?,mncN3?,mncA?,mncB?,mncx1?,mncx2?,mncm?,mnck4?) =
            sum_(mnck1,0,mncN2-1,sum_(mnck3,0,mncN2-mnck1-1,
            fac_(mnck1+mncN1+mnck3+mnck4-1)*invfac_(mnck3)
            *mncpoinv(5+mncm-2*mncN2-mncA-mncB+mnck1+mnck3,-2-mncx1-mncx2)
            *mncftri(0,mncN2-mnck1-mnck3,mncN3-mnck4,mncA+mnck1+mncN1,mncB+mnck3+mnck4,mncx1,mncx2)
         )*invfac_(mnck1));
    id  mncsumm3(mncN1?,mncN2?,mncN3?,mncA?,mncB?,mncx1?,mncx2?,mncm?,mnck2?) =
            sum_(mnck3,0,mncN2-1,sum_(mnck1,0,mncN2-mnck3-1,
            fac_(mnck1+mnck2+mnck3+mncN3-1)*invfac_(mnck1)
            *mncpoinv(5+mncm-2*mncN2-mncA-mncB+mnck1+mnck3,-2-mncx1-mncx2)
            *mncftri(mncN1-mnck2,mncN2-mnck1-mnck3,0,mncA+mnck1+mnck2,mncB+mnck3+mncN3,mncx1,mncx2)
         )*invfac_(mnck3));
    id  mncpoinv(1,mncy1?) = 1;
    id  mncpoinv(mncx1?neg0_,mncy1?) = mncy1*acc(mncPOINV(mncx1,mncy1))*ep;
    id  mncpoinv(mncx1?pos_,mncy1?) = acc(mncPOINV(mncx1,mncy1));
endif;

id  mncftri(mncN1?,mncN2?,mncN3?,mncA?,mncB?,mncx1?,mncx2?) = mncpo(mncA,mncx1)*mncpo(mncB,mncx2)
    /`P1'.`P1'^mncN1/`P'.`P'^mncN2/`P3'.`P3'^mncN3/`PA'.`PA'^mncA/`PB'.`PB'^mncB;
id  mncpo(mncx1?,0) = fac_(mncx1-1);
id  mncpo(1,mncy1?) = 1;
id  mncpo(mncx1?neg0_,mncy1?) = acc(mncPO(mncx1,mncy1))/mncy1/ep;
id  mncpo(mncx1?pos_,mncy1?) = acc(mncPO(mncx1,mncy1));

else;

  repeat;
    if ( match(1/`P'.`P'/`P1'.`P1'/`P3'.`P3') > 0 );
      id  mncx^mncx4?/`PA'.`PA'^mncx1?/`PB'.`PB'^mncx2?/`P'.`P'^mncx3?*`EA'^mncy1?*`EB'^mncy2? =
          mncx^mncx4 /`PA'.`PA'^mncx1 /`PB'.`PB'^mncx2 /`P'.`P'^mncx3 *`EA'^mncy1*`EB'^mncy2*(
            +acc(mncx2+mncy2*ep)*`P'.`P'/`PB'.`PB'-acc(mncx2+mncy2*ep)*`P3'.`P3'/`PB'.`PB'
            +acc(mncx1+mncy1*ep)*`P'.`P'/`PA'.`PA'-acc(mncx1+mncy1*ep)*`P1'.`P1'/`PA'.`PA'
          )*mncdeno(4+mncx4-mncx1-mncx2-2*mncx3,-2-mncy1-mncy2);
      id,many,mncdeno(0,mncy1?) = 1/mncy1/ep;
      id,mncdeno(mncx1?,mncy1?) = acc(1-mncy1*ep/mncx1+mncy1^2*ep^2/mncx1^2-mncy1^3*ep^3/mncx1^3
                      +mncy1^4*ep^4/mncx1^4-mncy1^5*ep^5/mncx1^5+mncy1^6*ep^6/mncx1^6)/mncx1;
    endif;
  endrepeat;
  id  mncx = 1;

endif;

#endprocedure

*--#] triangl2 : 
*--#[ triangle :
#procedure triangle(P,PA,PB,P1,P3)
*
*   Routine solves the triangle recursion
*                     P
*      N1 -------------------------- N3
*          P1    \    N2    /    P3
*                 \        /
*                A \      / B
*                PA \    / PB
*                    \  /
*                     \/
*
*   mncA,mncB,mncN1,mncN2,mncN3 are the powers of the denominators
*   We assume that mncA and mncB are integers here. Otherwise see triangl2.
*   P is the momentum in mncN2. We need it here to determine the extra
*   momenta in the numerator.
*
*   We follow the algorithm of F.V.Tkachov Theor. Mat. Fiz. 56(1983)350.
*
*   There are three sums:
*   One in which the power of 1 becomes zero, one for 2 and one for 3.
*   Each sum has 4 constants to sum over, except that for each
*   one of them has its maximal value:
*   mnck1 = (a-mncA)-mnck2
*   mnck2 = mncN1-n1          sum1: mncN1
*   mnck3 = (b-mncB)-mnck4
*   mnck4 = mncN3-n3          sum3: mncN3
*   mnck1+mnck3 = mncN2-n2       sum2: mncN2
*   The gamma functions are evaluated using the tables in pochtabl.prc
*
*   It turns out that the easy cases are faster when the regular recursion
*   is used. We do that here is there are fewer than 6 powers in P,P1 and P3
*   combined. Test timings don't use these special cases.
*
*   Programmed by J.A.M.Vermaseren 28-oct-1990 + 13-nov-1990
*
*   Test versus benzbar:
*       1/p1.p1^3/mncp.mncp/p3.p3/pa.pa/pb.pb -> 0.96 sec versus 0.80 sec
*       1/p1.p1^3/mncp.mncp^3/p3.p3/pa.pa/pb.pb -> 3.07 sec versus 20.34 sec
*       1/p1.p1^3/mncp.mncp^3/p3.p3^3/pa.pa/pb.pb -> 6.21 sec versus 547.11 sec
*   triangle generates exactly the right number of terms
*   (times on Atari TT)
*
*   For the easy cases we take the original recursion, because this is much
*   faster. This is done for the combined powers of P1,P2,P3 at most 4
*   in the denominator. IT IS VERY DANGEROUS TO INCREASE THIS NUMBER!
*   In principle each two steps in the recursion can generate one
*   extra pole that has to be cancelled between the terms. This can
*   cause problems with the truncation of the powers of ep. We can
*   tolerate only one such pole here.
*
id  `P' = mncx*`P';
if ( count(`P1'.`P1',1,`P3'.`P3',1,`P'.`P',1) < -4 );
id  mncx^mncm?/`P1'.`P1'^mncN1?/`P'.`P'^mncN2?/`P3'.`P3'^mncN3?/`PA'.`PA'^mncA?/`PB'.`PB'^mncB? =
        mncftri(mncN1,mncN2,mncN3,mncA,mncB,mncm)*invfac_(mncA-1)*invfac_(mncB-1);
id  mncftri(mncN1?,mncN2?,mncN3?,mncA?,mncB?,mncm?) =
        +sum_(mnck4,0,mncN3-1,sign_(mncN1+mnck4)*mncpo(5+mncm-2*mncN2-mncA-mncB-mncN1-mnck4,-2)
            *mncsumm1(mncN1,mncN2,mncN3,mncA,mncB,mncm,mnck4)*invfac_(mnck4))*invfac_(mncN1-1)
        +mncsumm2(mncN1,mncN2,mncN3,mncA,mncB,mncm)*mncN2*mncpoinv(4+mncm-2*mncN2-mncA-mncB+mncN2,-2)
        +sum_(mnck2,0,mncN1-1,sign_(mnck2+mncN3)*mncpo(5+mncm-2*mncN2-mncA-mncB-mnck2-mncN3,-2)
            *mncsumm3(mncN1,mncN2,mncN3,mncA,mncB,mncm,mnck2)*invfac_(mnck2))*invfac_(mncN3-1)
    ;
*
*   Evaluate the gamma functions.
*   We multiply numerator and denominator with gamma(1-2*ep)
*   Then mncpo(mncx,-2) represents a normalized gamma function.
*   The following identities can then be applied:
*   (the table has overal factors ep taken out)
*
if ( count(mncsumm2,1) );
	id  mncpoinv(1,-2) = 1;
	id  mncpoinv(mncx1?neg0_,-2) = -2*acc(mncPOINV(mncx1,-2))*ep;
	id  mncpoinv(mncx1?,-2) = acc(mncPOINV(mncx1,-2));
	id  mncsumm2(mncN1?,mncN2?,mncN3?,mncA?,mncB?,mncm?) =
    	    +sum_(mnck2,0,mncN1-1,sum_(mnck4,0,mncN3-1,sign_(mnck2+mnck4)*fac_(mnck2+mncN2+mnck4-1)
        	    *mncpo(4+mncm-2*mncN2-mncA-mncB-mnck2-mnck4,-2)*mncsumm2(mncN1,mncN2,mncN3,mncA,mncB,mncm,mnck2,mnck4)
	         *invfac_(mnck4))*invfac_(mnck2));
	id  mncpo(1,-2) = 1;
	id  mncpo(mncx1?neg0_,-2) = -acc(mncPO(mncx1,-2))/2/ep;
	id  mncpo(mncx1?,-2) = acc(mncPO(mncx1,-2));
	id  mncsumm2(mncN1?,mncN2?,mncN3?,mncA?,mncB?,mncm?,mnck2?,mnck4?) =
            +sum_(mnck1,0,mncN2,invfac_(mnck1)*invfac_(mncN2-mnck1)
            *mncftri(mncN1-mnck2,0,mncN3-mnck4,mncA+mnck1+mnck2,mncB+mncN2-mnck1+mnck4));
else;
	id  mncpo(1,-2) = 1;
	id  mncpo(mncx1?neg0_,-2) = -acc(mncPO(mncx1,-2))/2/ep;
	id  mncpo(mncx1?,-2) = acc(mncPO(mncx1,-2));
	id  mncsumm1(mncN1?,mncN2?,mncN3?,mncA?,mncB?,mncm?,mnck4?) =
            sum_(mnck1,0,mncN2-1,sum_(mnck3,0,mncN2-mnck1-1,
            fac_(mnck1+mncN1+mnck3+mnck4-1)*invfac_(mnck3)
            *mncpoinv(5+mncm-2*mncN2-mncA-mncB+mnck1+mnck3,-2)
            *mncftri(0,mncN2-mnck1-mnck3,mncN3-mnck4,mncA+mnck1+mncN1,mncB+mnck3+mnck4)
         )*invfac_(mnck1));
	id  mncsumm3(mncN1?,mncN2?,mncN3?,mncA?,mncB?,mncm?,mnck2?) =
            sum_(mnck3,0,mncN2-1,sum_(mnck1,0,mncN2-mnck3-1,
            fac_(mnck1+mnck2+mnck3+mncN3-1)*invfac_(mnck1)
            *mncpoinv(5+mncm-2*mncN2-mncA-mncB+mnck1+mnck3,-2)
            *mncftri(mncN1-mnck2,mncN2-mnck1-mnck3,0,mncA+mnck1+mnck2,mncB+mnck3+mncN3)
         )*invfac_(mnck3));
	id  mncpoinv(1,-2) = 1;
	id  mncpoinv(mncx1?neg0_,-2) = -2*acc(mncPOINV(mncx1,-2))*ep;
	id  mncpoinv(mncx1?,-2) = acc(mncPOINV(mncx1,-2));
endif;
id  mncftri(mncN1?,mncN2?,mncN3?,mncA?,mncB?) = fac_(mncA-1)*fac_(mncB-1)
    /`P1'.`P1'^mncN1/`P'.`P'^mncN2/`P3'.`P3'^mncN3/`PA'.`PA'^mncA/`PB'.`PB'^mncB;

else;
  repeat;
    if ( match(1/`P'.`P'/`P1'.`P1'/`P3'.`P3') > 0 );
      id  mncx^mncx4?/`PA'.`PA'^mncx1?/`PB'.`PB'^mncx2?/`P'.`P'^mncx3? =
          mncx^mncx4 /`PA'.`PA'^mncx1 /`PB'.`PB'^mncx2 /`P'.`P'^mncx3 *(
            +mncx2*`P'.`P'/`PB'.`PB'-mncx2*`P3'.`P3'/`PB'.`PB'
            +mncx1*`P'.`P'/`PA'.`PA'-mncx1*`P1'.`P1'/`PA'.`PA'
          )*mncdeno(4+mncx4-mncx1-mncx2-2*mncx3,-2);
      id,many,mncdeno(0,-2)   = -1/2/ep;
      id,mncdeno(mncx1?,-2) = acc(1+2*ep/mncx1+4*ep^2/mncx1^2+8*ep^3/mncx1^3
                      +16*ep^4/mncx1^4+32*ep^5/mncx1^5+64*ep^6/mncx1^6)/mncx1;
    endif;
  endrepeat;
  id  mncx = 1;

endif;
#endprocedure
*--#] triangle : 
*--#[ trim :
#procedure trim(TOPO)
#switch `TOPO'
*--#[ la :
*
*
*--#] la : 
*--#[ be :
*
*
*--#] be : 
*--#[ no :
*
*
*--#] no : 
*--#[ fa :
*
*
*--#] fa : 
*--#[ bu :
*
*
*--#] bu : 
*--#[ o1 :
*
*
*--#] o1 : 
*--#[ o2 :
*
*
*--#] o2 : 
*--#[ o3 :
*
*
*--#] o3 : 
*--#[ o4 :
*
*
*--#] o4 : 
*--#[ y1 :
*
*
*--#] y1 : 
*--#[ y2 :
*
*
*--#] y2 : 
*--#[ y3 :
*
*
*--#] y3 : 
*--#[ y4 :
*
*
*--#] y4 : 
*--#[ y5 :
*
*
*--#] y5 : 
*--#[ t1 :
#case t1
*
#if 'TRIM' > 0
	id ep = 0;
#endif
*
#break
*--#] t1 : 
*--#[ t2 :
#case t2
*
#if 'TRIM' > 0
	id ep = 0;
#endif
*
#break
*--#] t2 : 
*--#[ t3 :
#case t3
*
#if 'TRIM' > 0
	id ep = 0;
#endif
*
#break
*--#] t3 : 
*--#[ l1 :
#case l1
*
#if 'TRIM' > 0
	id ep^{3-'TRIM'} = 0;
#endif
*
#break
*--#] l1 : 
*--#[ l2 :
#case l2
*
*
#break
*--#] l2 : 
*--#[ l3 :
#case l3
*
*
#break
*--#] l3 : 
*--#[ tr :
#case tr
*
#if 'TRIM' > 0
	id ep^{4-'TRIM'} = 0;
#endif
*
#break
*--#] tr : 
#endswitch
#endprocedure
*--#] trim : 
*--#[ two :
#procedure two(P1,E1,P2,E2,P3,E3,P4,E4,P5,E5,Q,EQ,REDUCTION,INTS)
*
*   Routine for the reduction of two loop diagrams.
*   All particles are massless and it treats only two point functions.
*   For the algorithm, see "Mincer:...." S.G.Gorishny, S.A.Larin,
*   L.R.Surguladze and F.V.Tkachov, Comp. Phys. Comm. 55(1989)381.
*   The core of this routine consists of the equations (3.8)-(3.11).
*   Note that equation 3.10 isn't right, but the equation 4.29 in
*   K.G.Chetyrkin and F.V.Tkachov, Nucl.Phys. B192(1981)159 is correct.
*   The odd parameters are the vectors and the even parameters
*   are symbols for 1/(p.p^ep). The last parameter indicates whether
*   there should be a tensor reduction first.
*
*	This routine is (mostly) superceeded by the routine newtwo. Only when
*	we have to calculate extra elements in the table tabtwo we need this
*	routine.
*
#if ( `REDUCTION' > 0 )
  id  `P4' = `P1'-`Q';
  id  `P3' = `P2'-`Q';
  id  `P5' = `P1'-`P2';
  .sort: Two loop momenta;
  id  `P1'.`Q' = `P1'.`P1'/2+`Q'.`Q'/2-`P4'.`P4'/2;
  id  `P2'.`Q' = `P2'.`P2'/2+`Q'.`Q'/2-`P3'.`P3'/2;
  id  `P1'.`P2' = `P1'.`P1'/2+`P2'.`P2'/2-`P5'.`P5'/2;
  .sort: Two loop scalars;
#endif
repeat;
  if ( ( ( count(`P1'.`P1',1) < 0 ) || ( count(`E1',1) > 0 ) ) &&
       ( ( count(`P2'.`P2',1) < 0 ) || ( count(`E2',1) > 0 ) ) &&
       ( ( count(`P3'.`P3',1) < 0 ) || ( count(`E3',1) > 0 ) ) &&
       ( ( count(`P4'.`P4',1) < 0 ) || ( count(`E4',1) > 0 ) ) &&
       ( ( count(`P5'.`P5',1) < 0 ) || ( count(`E5',1) > 0 ) ) );
    if ( count(`E5',1) == 0 );
      if ( count(`E2',1,`E3',1) == 0 );
        id  `E1'^mncy1?/`P1'.`P1'^mncx1?/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?*
            `E4'^mncy4?/`P4'.`P4'^mncx4?/`P5'.`P5'^mncx5?*`E5'^mncy5? =
              `E1'^mncy1/`P1'.`P1'^mncx1/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3*
              `E4'^mncy4/`P4'.`P4'^mncx4/`P5'.`P5'^mncx5*`E5'^mncy5*(
                + acc(mncx1,mncy1)*`P5'.`P5'/`P1'.`P1'
                + acc(mncx4,mncy4)*`P5'.`P5'/`P4'.`P4'
                - acc(mncx1,mncy1)*`P2'.`P2'/`P1'.`P1'
                - acc(mncx4,mncy4)*`P3'.`P3'/`P4'.`P4'
              )*mncdeno(4-mncx1-mncx4-2*mncx5,-mncy1-mncy4-2*mncy5-2);
      else;
        id  `E1'^mncy1?/`P1'.`P1'^mncx1?*`E2'^mncy2?/`P2'.`P2'^mncx2?*
            `E3'^mncy3?/`P3'.`P3'^mncx3?*`E4'^mncy4?/`P4'.`P4'^mncx4?*
            `E5'^mncy5?/`P5'.`P5'^mncx5? =
              `E1'^mncy1/`P1'.`P1'^mncx1*`E2'^mncy2/`P2'.`P2'^mncx2*
              `E3'^mncy3/`P3'.`P3'^mncx3*`E4'^mncy4/`P4'.`P4'^mncx4*
              `E5'^mncy5/`P5'.`P5'^mncx5*(
                + acc(mncx3,mncy3)*`P5'.`P5'/`P3'.`P3'
                + acc(mncx2,mncy2)*`P5'.`P5'/`P2'.`P2'
                - acc(mncx3,mncy3)*`P4'.`P4'/`P3'.`P3'
                - acc(mncx2,mncy2)*`P1'.`P1'/`P2'.`P2'
              )*mncdeno(4-mncx2-mncx3-2*mncx5,-mncy2-mncy3-2*mncy5-2);
      endif;
    else;
      if ( ( count(`P1'.`P1',1) < -1 ) && ( count(`E1',1) == 0 ) );
        id  `E1'^mncy1?/`P1'.`P1'^mncx1?*`E2'^mncy2?/`P2'.`P2'^mncx2?*
            `E3'^mncy3?/`P3'.`P3'^mncx3?*`E4'^mncy4?/`P4'.`P4'^mncx4?*
            `E5'^mncy5?/`P5'.`P5'^mncx5? =
              `E1'^mncy1/`P1'.`P1'^mncx1*`E2'^mncy2/`P2'.`P2'^mncx2*
              `E3'^mncy3/`P3'.`P3'^mncx3*`E4'^mncy4/`P4'.`P4'^mncx4*
              `E5'^mncy5/`P5'.`P5'^mncx5*(
                +acc(2*mncx4+mncx1+mncx5-5,+2*mncy4+mncy1+mncy5+2)*`P1'.`P1'*mncdeno(mncx1-1,mncy1)
                +`P4'.`P4'
                +acc(mncx5,mncy5)*`P4'.`P4'*`P1'.`P1'/`P5'.`P5'*mncdeno(mncx1-1,mncy1)
                -acc(mncx5,mncy5)*`P3'.`P3'*`P1'.`P1'/`P5'.`P5'*mncdeno(mncx1-1,mncy1)
              )/`Q'.`Q';
      else;
      if ( ( count(`P2'.`P2',1) < -1 ) && ( count(`E2',1) == 0 ) );
        id  `E1'^mncy1?/`P1'.`P1'^mncx1?*`E2'^mncy2?/`P2'.`P2'^mncx2?*
            `E3'^mncy3?/`P3'.`P3'^mncx3?*`E4'^mncy4?/`P4'.`P4'^mncx4?*
            `E5'^mncy5?/`P5'.`P5'^mncx5? =
              `E1'^mncy1/`P1'.`P1'^mncx1*`E2'^mncy2/`P2'.`P2'^mncx2*
              `E3'^mncy3/`P3'.`P3'^mncx3*`E4'^mncy4/`P4'.`P4'^mncx4*
              `E5'^mncy5/`P5'.`P5'^mncx5*(
                +acc(2*mncx3+mncx2+mncx5-5,+2*mncy3+mncy2+mncy5+2)*`P2'.`P2'*mncdeno(mncx2-1,mncy2)
                +`P3'.`P3'
                +acc(mncx5,mncy5)*`P3'.`P3'*`P2'.`P2'/`P5'.`P5'*mncdeno(mncx2-1,mncy2)
                -acc(mncx5,mncy5)*`P4'.`P4'*`P2'.`P2'/`P5'.`P5'*mncdeno(mncx2-1,mncy2)
              )/`Q'.`Q';
      else;
      if ( ( count(`P3'.`P3',1) < -1 ) && ( count(`E3',1) == 0 ) );
        id  `E1'^mncy1?/`P1'.`P1'^mncx1?*`E2'^mncy2?/`P2'.`P2'^mncx2?*
            `E3'^mncy3?/`P3'.`P3'^mncx3?*`E4'^mncy4?/`P4'.`P4'^mncx4?*
            `E5'^mncy5?/`P5'.`P5'^mncx5? =
              `E1'^mncy1/`P1'.`P1'^mncx1*`E2'^mncy2/`P2'.`P2'^mncx2*
              `E3'^mncy3/`P3'.`P3'^mncx3*`E4'^mncy4/`P4'.`P4'^mncx4*
              `E5'^mncy5/`P5'.`P5'^mncx5*(
                +acc(2*mncx2+mncx3+mncx5-5,+2*mncy2+mncy3+mncy5+2)*`P3'.`P3'*mncdeno(mncx3-1,mncy3)
                +`P2'.`P2'
                +acc(mncx5,mncy5)*`P2'.`P2'*`P3'.`P3'/`P5'.`P5'*mncdeno(mncx3-1,mncy3)
                -acc(mncx5,mncy5)*`P1'.`P1'*`P3'.`P3'/`P5'.`P5'*mncdeno(mncx3-1,mncy3)
              )/`Q'.`Q';
      else;
      if ( ( count(`P4'.`P4',1) < -1 ) && ( count(`E4',1) == 0 ) );
        id  `E1'^mncy1?/`P1'.`P1'^mncx1?*`E2'^mncy2?/`P2'.`P2'^mncx2?*
            `E3'^mncy3?/`P3'.`P3'^mncx3?*`E4'^mncy4?/`P4'.`P4'^mncx4?*
            `E5'^mncy5?/`P5'.`P5'^mncx5? =
              `E1'^mncy1/`P1'.`P1'^mncx1*`E2'^mncy2/`P2'.`P2'^mncx2*
              `E3'^mncy3/`P3'.`P3'^mncx3*`E4'^mncy4/`P4'.`P4'^mncx4*
              `E5'^mncy5/`P5'.`P5'^mncx5*(
                +acc(2*mncx1+mncx4+mncx5-5,+2*mncy1+mncy4+mncy5+2)*`P4'.`P4'*mncdeno(mncx4-1,mncy4)
                +`P1'.`P1'
                +acc(mncx5,mncy5)*`P1'.`P1'*`P4'.`P4'/`P5'.`P5'*mncdeno(mncx4-1,mncy4)
                -acc(mncx5,mncy5)*`P2'.`P2'*`P4'.`P4'/`P5'.`P5'*mncdeno(mncx4-1,mncy4)
              )/`Q'.`Q';
      else;
      if ( count(`E1',1,`E2',1,`E3',1,`E4',1) == 0 );
        if ( count(`P5'.`P5',1) < -1 );
*
*         Note: The equation 3.10 in the Mincer paper is wrong!
*
          id  1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'
              /`P4'.`P4'/`P5'.`P5'^mncx5?*`E5'^mncy5? =
                -acc(mncx5-2,2+mncy5)*mncdeno(mncx5-1,1+mncy5)*`P5'.`P5'/`Q'.`Q'
                /`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'/`P5'.`P5'^mncx5*`E5'^mncy5
                -mncG(1,0,mncx5,mncy5,0,0)*mncG(1,0,mncx5,mncy5+1,0,0)*mncdeno(mncx5-1,1+mncy5)
                *acc(3-2*mncx5-3*ep-2*mncy5*ep)*2*`EQ'^mncy5*`EQ'^2/`Q'.`Q'^mncx5/(`INTS');
        else;
        if ( count(`P5'.`P5',1) >= 0 );
          id  1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'
              /`P4'.`P4'/`P5'.`P5'^mncx5?*`E5'^mncy5? =
                -mncdeno(mncx5-1,2+mncy5)*acc(mncx5,1+mncy5)*`Q'.`Q'/`P5'.`P5'
                /`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'/`P5'.`P5'^mncx5*`E5'^mncy5
                -mncG(1,0,mncx5+1,mncy5,0,0)*mncG(1,0,mncx5+1,mncy5+1,0,0)*mncdeno(mncx5-1,2+mncy5)
                *acc(1-2*mncx5-3*ep-2*mncy5*ep)*2*`EQ'^mncy5*`EQ'^2/`Q'.`Q'^mncx5/(`INTS');
        else;
          id  1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'
              /`P4'.`P4'/`P5'.`P5'*`E5'^mncy5? = mncG311/`Q'.`Q'*`EQ'^2*`EQ'^mncy5
                /(`INTS');
*
*         mncG311 = 6*z3+9*z4*ep+102*z5*ep^2+order_(ep,3);
*           There seems to be also a normalization problem
*           The above expansion may not be enough!
*
        endif;
        endif;
*      else;
*        goto 1;
      endif;
      endif;
      endif;
      endif;
      endif;
    endif;
  endif;
endrepeat;
label 1;
id  mncdeno(0,mncy1?) = 1/mncy1/ep;
id	acc(0,mncx1?) = mncx1*ep;
id	acc(mncx1?,mncy1?) = acc(mncx1+mncy1*ep);
id  mncdeno(mncx1?,mncy1?) = mncaccm(1+ep*mncy1/mncx1)/mncx1;
repeat id mncaccm(mncx1?)*mncaccm(mncx2?) = mncaccm(mncx1*mncx2);
id  mncaccm(mncx1?) = mncaccm(mncx1-1);
id  mncaccm(mncx1?) = mncaccm(mncx1-mncx1^2,mncx1^3);
id  mncaccm(mncx1?,mncx2?) = acc(1-mncx1-mncx2+mncx2*mncx1+mncx2^2);
repeat id acc(mncx?)*acc(mncy?) = acc(mncx*mncy);
id	acc(mncx1?) = mncx1;
#endprocedure
*--#] two : 
*--#[ vertsub :
#procedure vertsub
#if 'GAUGE' == 0
	id	mncDg(mnci1?,mnci2?,mncp?) = d_(mnci1,mnci2)*mncDs(mncp);
#else
	repeat;
		id,once,mncDg(mnci1?,mnci2?,mncp?)*mncV3G(?a,mnci1?,mncp?,?b) =
			mncV3G(?a,mnci2,mncp,?b)*mncDs(mncp)
			-mncxi*mncp(mnci2)*mncV3G(?a,mncp,mncp,?b)*mncDs(mncp)*mncDs(mncp);

		id,once,mncDg(mnci1?,mnci2?,mncp?)*mncV3G(?a,mnci1?,-mncp?,?b) =
			mncV3G(?a,mnci2,-mncp,?b)*mncDs(mncp)
			+mncxi*mncp(mnci2)*mncV3G(?a,-mncp,-mncp,?b)*mncDs(mncp)*mncDs(mncp);

		id,once,mncDg(mnci2?,mnci1?,mncp?)*mncV3G(?a,mnci1?,mncp?,?b) =
			mncV3G(?a,mnci2,mncp,?b)*mncDs(mncp)
			-mncxi*mncp(mnci2)*mncV3G(?a,mncp,mncp,?b)*mncDs(mncp)*mncDs(mncp);

		id,once,mncDg(mnci2?,mnci1?,mncp?)*mncV3G(?a,mnci1?,-mncp?,?b) =
			mncV3G(?a,mnci2,-mncp,?b)*mncDs(mncp)
			+mncxi*mncp(mnci2)*mncV3G(?a,-mncp,-mncp,?b)*mncDs(mncp)*mncDs(mncp);
	endrepeat;
	id	mncDg(mnci1?,mnci2?,mncp?) = (d_(mnci1,mnci2)-mncxi*mncp(mnci1)*mncp(mnci2)*mncDs(mncp))*mncDs(mncp);
#endif

id	mncDs(p1?) = 1/p1.p1;
id	mncDL(mnci1?,mncj1?,p1?) = d_(mnci1,mncj1)/p1.p1-p1(mnci1)*p1(mncj1)/p1.p1^2;

.sort

repeat;
repeat;
	repeat;
		id,mncV3G(p1?,p1?,p2?,p2?,p3?,p3?) = 0;
		id,once,mncV3G(p1?,p1?,p2?,p2?,mnci3?,p3?) =
			p3.p3*p2(mnci3)-p2.p3*p3(mnci3);
		id,once,mncV3G(mnci3?,p3?,p1?,p1?,p2?,p2?) =
			p3.p3*p2(mnci3)-p2.p3*p3(mnci3);
		id,once,mncV3G(p2?,p2?,mnci3?,p3?,p1?,p1?) =
			p3.p3*p2(mnci3)-p2.p3*p3(mnci3);
	endrepeat;
	id,once,mncV3G(p1?,p1?,mnci2?,p2?,mnci3?,p3?) =
		p2(mnci2)*p2(mnci3)-p3(mnci2)*p3(mnci3)+p3.p3*d_(mnci2,mnci3)-p2.p2*d_(mnci2,mnci3);
	id,once,mncV3G(mnci3?,p3?,p1?,p1?,mnci2?,p2?) =
		p2(mnci2)*p2(mnci3)-p3(mnci2)*p3(mnci3)+p3.p3*d_(mnci2,mnci3)-p2.p2*d_(mnci2,mnci3);
	id,once,mncV3G(mnci2?,p2?,mnci3?,p3?,p1?,p1?) =
		p2(mnci2)*p2(mnci3)-p3(mnci2)*p3(mnci3)+p3.p3*d_(mnci2,mnci3)-p2.p2*d_(mnci2,mnci3);
endrepeat;

id,once,mncV3G(mnci1?,p1?,mnci2?,p2?,mnci3?,p3?) = 2*p1(mnci3)*d_(mnci1,mnci2)+p3(mnci3)*d_(mnci1,mnci2)
	                              +2*p2(mnci1)*d_(mnci2,mnci3)+p1(mnci1)*d_(mnci2,mnci3)
	                              +2*p3(mnci2)*d_(mnci3,mnci1)+p2(mnci2)*d_(mnci3,mnci1);
endrepeat;
id	mncV4G(mnci1?,mnci2?,mnci3?,mnci4?,mncx1?,mncx2?,mncx3?) =
	+mncx1*(d_(mnci1,mnci3)*d_(mnci2,mnci4)-d_(mnci1,mnci4)*d_(mnci2,mnci3))
	+mncx2*(d_(mnci1,mnci2)*d_(mnci3,mnci4)-d_(mnci1,mnci4)*d_(mnci2,mnci3))
	+mncx3*(d_(mnci1,mnci3)*d_(mnci2,mnci4)-d_(mnci1,mnci2)*d_(mnci3,mnci4));

id	D = acc(4-2*ep);
#endprocedure

*--#] vertsub : 
*--#[ vertsubm :
#procedure vertsubm
*
Multiply replace_(Dg,mncDg,v2gp,mncv2gp,v2gi,mncv2gi,v2gc,mncv2gc,
		v3g,mncv3g,v3gp,mncv3gp,Ds,mncDs,DL,mncDL,v4g,mncv4g,V4G,mncV4G
		v3gc,mncv3gc,v3gi,mncv3gi,v4gc,mncv4gc,v4gp,mncv4gp);
*
multiply,replace_(mncv4gi,mncv4g);
*id	mncv4gp(?a) = mncx18*mncv4g(?a);
id	mncv4gp(?a) = mncv4g(?a);
#ifdef `GAUGE'
#if ( `GAUGE' == 0 )
    id  mncDg(mnci1?,mnci2?,mncp?) = -i_*d_(mnci1,mnci2)*mncDs(mncp);
#else
    repeat;
        id  mncDg(mnci1?,mnci2?,p1?)*mncv2gi(mnci1?,p1?,?a) = -i_*mncv2gi(mnci2,p1,?a)/p1.p1;
        id  mncDg(mnci2?,mnci1?,p1?)*mncv2gi(mnci1?,p1?,?a) = -i_*mncv2gi(mnci2,p1,?a)/p1.p1;
        id  mncDg(mnci1?,mnci2?,p1?)*mncv2gi(?a,mnci1?,p1?) = -i_*mncv2gi(?a,mnci2,p1)/p1.p1;
        id  mncDg(mnci2?,mnci1?,p1?)*mncv2gi(?a,mnci1?,p1?) = -i_*mncv2gi(?a,mnci2,p1)/p1.p1;
        id  mncDg(mnci1?,mnci2?,-p1?)*mncv2gi(mnci1?,p1?,?a) = -i_*mncv2gi(mnci2,p1,?a)/p1.p1;
        id  mncDg(mnci2?,mnci1?,-p1?)*mncv2gi(mnci1?,p1?,?a) = -i_*mncv2gi(mnci2,p1,?a)/p1.p1;
        id  mncDg(mnci1?,mnci2?,-p1?)*mncv2gi(?a,mnci1?,p1?) = -i_*mncv2gi(?a,mnci2,p1)/p1.p1;
        id  mncDg(mnci2?,mnci1?,-p1?)*mncv2gi(?a,mnci1?,p1?) = -i_*mncv2gi(?a,mnci2,p1)/p1.p1;
	endrepeat;
*	repeat;
*        id  mncDg(mnci1?,mnci2?,p1?)*mncv2gp(mnci1?,p1?,?a) = -i_*mncv2gp(mnci2,p1,?a)/p1.p1;
*        id  mncDg(mnci2?,mnci1?,p1?)*mncv2gp(mnci1?,p1?,?a) = -i_*mncv2gp(mnci2,p1,?a)/p1.p1;
*        id  mncDg(mnci1?,mnci2?,p1?)*mncv2gp(?a,mnci1?,p1?) = -i_*mncv2gp(?a,mnci2,p1)/p1.p1;
*        id  mncDg(mnci2?,mnci1?,p1?)*mncv2gp(?a,mnci1?,p1?) = -i_*mncv2gp(?a,mnci2,p1)/p1.p1;
*        id  mncDg(mnci1?,mnci2?,-p1?)*mncv2gp(mnci1?,p1?,?a) = -i_*mncv2gp(mnci2,p1,?a)/p1.p1;
*        id  mncDg(mnci2?,mnci1?,-p1?)*mncv2gp(mnci1?,p1?,?a) = -i_*mncv2gp(mnci2,p1,?a)/p1.p1;
*        id  mncDg(mnci1?,mnci2?,-p1?)*mncv2gp(?a,mnci1?,p1?) = -i_*mncv2gp(?a,mnci2,p1)/p1.p1;
*        id  mncDg(mnci2?,mnci1?,-p1?)*mncv2gp(?a,mnci1?,p1?) = -i_*mncv2gp(?a,mnci2,p1)/p1.p1;
*	endrepeat;
*	repeat;
*        id  mncDg(mnci1?,mnci2?,p1?)*mncv2gc(mnci1?,p1?,?a) = -i_*mncv2gc(mnci2,p1,?a)/p1.p1;
*        id  mncDg(mnci2?,mnci1?,p1?)*mncv2gc(mnci1?,p1?,?a) = -i_*mncv2gc(mnci2,p1,?a)/p1.p1;
*        id  mncDg(mnci1?,mnci2?,p1?)*mncv2gc(?a,mnci1?,p1?) = -i_*mncv2gc(?a,mnci2,p1)/p1.p1;
*        id  mncDg(mnci2?,mnci1?,p1?)*mncv2gc(?a,mnci1?,p1?) = -i_*mncv2gc(?a,mnci2,p1)/p1.p1;
*        id  mncDg(mnci1?,mnci2?,-p1?)*mncv2gc(mnci1?,p1?,?a) = -i_*mncv2gc(mnci2,p1,?a)/p1.p1;
*        id  mncDg(mnci2?,mnci1?,-p1?)*mncv2gc(mnci1?,p1?,?a) = -i_*mncv2gc(mnci2,p1,?a)/p1.p1;
*        id  mncDg(mnci1?,mnci2?,-p1?)*mncv2gc(?a,mnci1?,p1?) = -i_*mncv2gc(?a,mnci2,p1)/p1.p1;
*        id  mncDg(mnci2?,mnci1?,-p1?)*mncv2gc(?a,mnci1?,p1?) = -i_*mncv2gc(?a,mnci2,p1)/p1.p1;
*    endrepeat;
    repeat;
        id,once,mncDg(mnci1?,mnci2?,mncp?)*mncv3g(?a,mnci1?,mncp?,?b) =
            -i_*mncv3g(?a,mnci2,mncp,?b)*mncDs(mncp)
            +i_*mncxi*mncp(mnci2)*mncv3g(?a,mncp,mncp,?b)*mncDs(mncp)*mncDs(mncp);

        id,once,mncDg(mnci1?,mnci2?,mncp?)*mncv3g(?a,mnci1?,-mncp?,?b) =
            -i_*mncv3g(?a,mnci2,-mncp,?b)*mncDs(mncp)
            -i_*mncxi*mncp(mnci2)*mncv3g(?a,-mncp,-mncp,?b)*mncDs(mncp)*mncDs(mncp);

        id,once,mncDg(mnci2?,mnci1?,mncp?)*mncv3g(?a,mnci1?,mncp?,?b) =
            -i_*mncv3g(?a,mnci2,mncp,?b)*mncDs(mncp)
            +i_*mncxi*mncp(mnci2)*mncv3g(?a,mncp,mncp,?b)*mncDs(mncp)*mncDs(mncp);

        id,once,mncDg(mnci2?,mnci1?,mncp?)*mncv3g(?a,mnci1?,-mncp?,?b) =
            -i_*mncv3g(?a,mnci2,-mncp,?b)*mncDs(mncp)
            -i_*mncxi*mncp(mnci2)*mncv3g(?a,-mncp,-mncp,?b)*mncDs(mncp)*mncDs(mncp);

        id,once,mncDg(mnci1?,mnci2?,mncp?)*mncv3gp(?a,mnci1?,mncp?,?b) =
            -i_*mncv3gp(?a,mnci2,mncp,?b)*mncDs(mncp)
            +i_*mncxi*mncp(mnci2)*mncv3gp(?a,mncp,mncp,?b)*mncDs(mncp)*mncDs(mncp);

        id,once,mncDg(mnci1?,mnci2?,mncp?)*mncv3gp(?a,mnci1?,-mncp?,?b) =
            -i_*mncv3gp(?a,mnci2,-mncp,?b)*mncDs(mncp)
            -i_*mncxi*mncp(mnci2)*mncv3gp(?a,-mncp,-mncp,?b)*mncDs(mncp)*mncDs(mncp);

        id,once,mncDg(mnci2?,mnci1?,mncp?)*mncv3gp(?a,mnci1?,mncp?,?b) =
            -i_*mncv3gp(?a,mnci2,mncp,?b)*mncDs(mncp)
            +i_*mncxi*mncp(mnci2)*mncv3gp(?a,mncp,mncp,?b)*mncDs(mncp)*mncDs(mncp);

        id,once,mncDg(mnci2?,mnci1?,mncp?)*mncv3gp(?a,mnci1?,-mncp?,?b) =
            -i_*mncv3gp(?a,mnci2,-mncp,?b)*mncDs(mncp)
            -i_*mncxi*mncp(mnci2)*mncv3gp(?a,-mncp,-mncp,?b)*mncDs(mncp)*mncDs(mncp);
    endrepeat;
#endif
#if ( `GAUGE' > 0 )
    if ( count(mncxi,1) > `GAUGE' ) discard;
#endif
#else
    id  mncDg(mnci1?,mnci2?,mncp?) = -i_*d_(mnci1,mnci2)*mncDs(mncp);
#endif
id  mncDs(p1?) = 1/p1.p1;
id  mncDL(mnci1?,mncj1?,p1?) = -i_*d_(mnci1,mncj1)/p1.p1+i_*p1(mnci1)*p1(mncj1)/p1.p1^2;
id  mncv3g(?a,p3?,-p3?) = -mncv3g(?a,-p3,-p3);
id  mncv3g(mnci1?index_,p1?,p2?,-p2?,?a) = -mncv3g(mnci1,p1,-p2,-p2,?a);
id  mncv3g(p3?,p1?,p2?,-p2?,?a) = -mncv3g(p3,p1,-p2,-p2,?a);
id  mncv3g(p1?,-p1?,?a) = -mncv3g(-p1,-p1,?a);

.sort:Gluon Propagators;

repeat;
  repeat;
    repeat;
      repeat;
        repeat;
          repeat;
            repeat;
              id,mncv3g(p1?,p1?,p2?,p2?,p3?,p3?) = 0;
              id,mncv2gi(p1?,p1?,?a) = 0;
              id,mncv2gi(p1?,-p1?,?a) = 0;
              id,mncv2gi(?a,p1?,p1?) = 0;
              id,mncv2gi(?a,p1?,-p1?) = 0;
*              id,mncv2gp(p1?,p1?,?a) = 0;
*              id,mncv2gp(p1?,-p1?,?a) = 0;
*              id,mncv2gp(?a,p1?,p1?) = 0;
*              id,mncv2gp(?a,p1?,-p1?) = 0;
*              id,mncv2gc(p1?,p1?,?a) = 0;
*              id,mncv2gc(p1?,-p1?,?a) = 0;
*              id,mncv2gc(?a,p1?,p1?) = 0;
*              id,mncv2gc(?a,p1?,-p1?) = 0;
              id,once,mncv3g(p1?,p1?,p2?,p2?,mnci3?,p3?) =
                    -i_*p3.p3*p2(mnci3)+i_*p2.p3*p3(mnci3);
              id    mncv3g(?a,p3?,-p3?) = -mncv3g(?a,-p3,-p3);
              id    mncv3g(mnci1?index_,p1?,p2?,-p2?,?a) = -mncv3g(mnci1,p1,-p2,-p2,?a);
              id    mncv3g(p3?,p1?,p2?,-p2?,?a) = -mncv3g(p3,p1,-p2,-p2,?a);
              id    mncv3g(p1?,-p1?,?a) = -mncv3g(-p1,-p1,?a);
            endrepeat;
            id,once,mncv3g(mnci3?,p3?,p1?,p1?,p2?,p2?) =
                -i_*p3.p3*p2(mnci3)+i_*p2.p3*p3(mnci3);
            id  mncv3g(?a,p3?,-p3?) = -mncv3g(?a,-p3,-p3);
            id  mncv3g(mnci1?index_,p1?,p2?,-p2?,?a) = -mncv3g(mnci1,p1,-p2,-p2,?a);
            id  mncv3g(p3?,p1?,p2?,-p2?,?a) = -mncv3g(p3,p1,-p2,-p2,?a);
            id  mncv3g(p1?,-p1?,?a) = -mncv3g(-p1,-p1,?a);
          endrepeat;
          id,once,mncv3g(p2?,p2?,mnci3?,p3?,p1?,p1?) =
                -i_*p3.p3*p2(mnci3)+i_*p2.p3*p3(mnci3);
          id    mncv3g(?a,p3?,-p3?) = -mncv3g(?a,-p3,-p3);
          id    mncv3g(mnci1?index_,p1?,p2?,-p2?,?a) = -mncv3g(mnci1,p1,-p2,-p2,?a);
          id    mncv3g(p3?,p1?,p2?,-p2?,?a) = -mncv3g(p3,p1,-p2,-p2,?a);
          id    mncv3g(p1?,-p1?,?a) = -mncv3g(-p1,-p1,?a);
        endrepeat;
        id,once,mncv3g(p1?,p1?,mnci2?,p2?,mnci3?,p3?) =
            -i_*p2(mnci2)*p2(mnci3)+i_*p3(mnci2)*p3(mnci3)-i_*p3.p3*d_(mnci2,mnci3)+i_*p2.p2*d_(mnci2,mnci3);
        id  mncv3g(?a,p3?,-p3?) = -mncv3g(?a,-p3,-p3);
        id  mncv3g(mnci1?index_,p1?,p2?,-p2?,?a) = -mncv3g(mnci1,p1,-p2,-p2,?a);
        id  mncv3g(p3?,p1?,p2?,-p2?,?a) = -mncv3g(p3,p1,-p2,-p2,?a);
        id  mncv3g(p1?,-p1?,?a) = -mncv3g(-p1,-p1,?a);
      endrepeat;
      id,once,mncv3g(mnci3?,p3?,p1?,p1?,mnci2?,p2?) =
        -i_*p2(mnci2)*p2(mnci3)+i_*p3(mnci2)*p3(mnci3)-i_*p3.p3*d_(mnci2,mnci3)+i_*p2.p2*d_(mnci2,mnci3);
      id    mncv3g(?a,p3?,-p3?) = -mncv3g(?a,-p3,-p3);
      id    mncv3g(mnci1?index_,p1?,p2?,-p2?,?a) = -mncv3g(mnci1,p1,-p2,-p2,?a);
      id    mncv3g(p3?,p1?,p2?,-p2?,?a) = -mncv3g(p3,p1,-p2,-p2,?a);
      id    mncv3g(p1?,-p1?,?a) = -mncv3g(-p1,-p1,?a);
    endrepeat;
    id,once,mncv3g(mnci2?,p2?,mnci3?,p3?,p1?,p1?) =
        -i_*p2(mnci2)*p2(mnci3)+i_*p3(mnci2)*p3(mnci3)-i_*p3.p3*d_(mnci2,mnci3)+i_*p2.p2*d_(mnci2,mnci3);
    id  mncv3g(?a,p3?,-p3?) = -mncv3g(?a,-p3,-p3);
    id  mncv3g(mnci1?index_,p1?,p2?,-p2?,?a) = -mncv3g(mnci1,p1,-p2,-p2,?a);
    id  mncv3g(p3?,p1?,p2?,-p2?,?a) = -mncv3g(p3,p1,-p2,-p2,?a);
    id  mncv3g(p1?,-p1?,?a) = -mncv3g(-p1,-p1,?a);
  endrepeat;
  id,once,mncv3g(mnci1?,p1?,mnci2?,p2?,mnci3?,p3?) =
             -2*i_*p1(mnci3)*d_(mnci1,mnci2)-i_*p3(mnci3)*d_(mnci1,mnci2)
             -2*i_*p2(mnci1)*d_(mnci2,mnci3)-i_*p1(mnci1)*d_(mnci2,mnci3)
             -2*i_*p3(mnci2)*d_(mnci3,mnci1)-i_*p2(mnci2)*d_(mnci3,mnci1);
  id    mncv3g(?a,p3?,-p3?) = -mncv3g(?a,-p3,-p3);
  id    mncv3g(mnci1?index_,p1?,p2?,-p2?,?a) = -mncv3g(mnci1,p1,-p2,-p2,?a);
  id    mncv3g(p3?,p1?,p2?,-p2?,?a) = -mncv3g(p3,p1,-p2,-p2,?a);
  id    mncv3g(p1?,-p1?,?a) = -mncv3g(-p1,-p1,?a);
endrepeat;
id  mncv4g(mnci1?,mnci2?,mnci3?,mnci4?) = -i_*(d_(mnci1,mnci3)*d_(mnci2,mnci4)-d_(mnci1,mnci4)*d_(mnci2,mnci3));

id  mncV4G(mnci1?,mnci2?,mnci3?,mnci4?,mncx1?,mncx2?,mncx3?) =
    -i_*mncx1*(d_(mnci1,mnci3)*d_(mnci2,mnci4)-d_(mnci1,mnci4)*d_(mnci2,mnci3))
    -i_*mncx2*(d_(mnci1,mnci2)*d_(mnci3,mnci4)-d_(mnci1,mnci4)*d_(mnci2,mnci3))
    -i_*mncx3*(d_(mnci1,mnci3)*d_(mnci2,mnci4)-d_(mnci1,mnci2)*d_(mnci3,mnci4));

#ifdef `GAUGE'
#if ( `GAUGE' != 0 )
    id  mncDg(mnci1?,mnci2?,mncp?) = -i_*(d_(mnci1,mnci2)-mncxi*mncp(mnci1)*mncp(mnci2)/mncp.mncp)/mncp.mncp;
#endif
#endif

id  D = acc(4-2*ep);

id	P.P = 0;

id  mncv2gi(mnci1?,p1?,mnci2?,p2?) = -i_*(d_(mnci1,mnci2)*p1.p2-p1(mnci2)*p2(mnci1));
id  mncv3gi(mnci1?,p1?,mnci2?,p2?,mnci3?,p3?) = i_*(
        d_(mnci1,mnci2)*(p1(mnci3)-p2(mnci3))+d_(mnci2,mnci3)*(p2(mnci1)-p3(mnci1))
        +d_(mnci3,mnci1)*(p3(mnci2)-p1(mnci2)));


id  mncv2gp(mnci1?,p1?,mnci2?,p2?) = -i_*(d_(mnci1,mnci2)*p1.p2-p1(mnci2)*p2(mnci1));
id  mncv3gp(mnci1?,p1?,mnci2?,p2?,mnci3?,p3?) = i_*(
        d_(mnci1,mnci2)*(p1(mnci3)-p2(mnci3))+d_(mnci2,mnci3)*(p2(mnci1)-p3(mnci1))
        +d_(mnci3,mnci1)*(p3(mnci2)-p1(mnci2)));

id	P.P = 0;

id	mncv2gc(mnci1?,p1?,mnci2?,p2?) = -i_*e_(mnci1,p1,mnci2,p2);
id	mncv3gc(mnci1?,p1?,mnci2?,p2?,mnci3?,p3?) = i_*(
			e_(mnci1,mnci2,mnci3,p1)+e_(mnci1,mnci2,mnci3,p2)+e_(mnci1,mnci2,mnci3,p3));
id	mncv3gc(mncp?,mnci1?,mnci2?,mnci3?) = i_*e_(mnci1,mnci2,mnci3,mncp);
id	mncv3gc(mnci1?,mnci2?,mnci3?,mncp?) = -i_*e_(mnci1,mnci2,mnci3,mncp);
*id	mncv4gc(mnci1?,mnci2?,mnci3?,mnci4?) = -i_*e_(mnci1,mnci2,mnci3,mnci4);
id	mncv4gc(mnci1?,mnci2?,mnci3?,mnci4?) = 0;

Contract;
id	P.P = 0;
Multiply replace_(mncxi,xi);

#endprocedure
*--#] vertsubm :
*--#[ ACCU :
#procedure ACCU(TEXT)
if ( count(ep,1) );
	if ( count(acc,1) == 1 );
		id	ep^mncx?*acc(mncy?) = acc(ep^mncx*mncy);
	else;
		id	ep^mncx? = acc(ep^mncx);
	endif;
endif;
.sort(PolyFun = acc):`TEXT';
#endprocedure
*--#] ACCU : 
*--#[ ACCU2 :
#procedure ACCU2(BRA,TEXT)
if ( count(ep,1) );
	if ( count(acc,1) == 1 );
		id	ep^mncx?*acc(mncy?) = acc(ep^mncx*mncy);
	else;
		id	ep^mncx? = acc(ep^mncx);
	endif;
endif;
`BRA';
.sort(PolyFun = acc):`TEXT';
#endprocedure
*--#] ACCU2 : 
*--#[ ACCUP :
#procedure ACCUP(TEXT)
id	acc(mncx?) = mncx;
.sort:`TEXT';
#endprocedure
*--#] ACCUP : 
*--#] Procedures :
*--#[ Tables :
*#ifdef `POW'
*#if ( `POW' >= 8 )
*#call pochtabl(24)
*#else
*#call pochtabl(20)
*#endif
*#else
*#call pochtabl(20)
*#endif
#call pochtabl(40)
#call tabtwo(20)
*--#[ notabl.h :
CTable sparse mncnoptab(4);
*Fill mncnoptab(3,3,3,3) =
*       - 18474865276279/324000 - 147056/3*ep^-3 - 9668041/30*ep^-2 + 85171103/
*      1800*ep^-1 - 484428616/3*z3 + 246960000*z5;
*Fill mncnoptab(4,2,2,4) =
*       - 6586797294014227/250047000 - 269984/27*ep^-3 - 57006874/945*ep^-2 + 
*      955059143/22050*ep^-1 - 1942771744/27*z3 + 109760000*z5;
*Fill mncnoptab(4,3,1,4) =
*       - 3041096169814853/357210000 - 291704/135*ep^-3 - 993209/75*ep^-2 + 
*      158917319/18900*ep^-1 - 3110543296/135*z3 + 35123200*z5;
*Fill mncnoptab(4,3,2,3) =
*       - 91660413154999/2976750 - 193760/9*ep^-3 - 6413092/45*ep^-2 + 27103277/
*      1890*ep^-1 - 775759936/9*z3 + 131712000*z5;
*Fill mncnoptab(4,3,3,2) =
*       - 357433853456101/14883750 - 1156064/45*ep^-3 - 4163404/25*ep^-2 + 
*      64087288/1575*ep^-1 - 3094354816/45*z3 + 105369600*z5;
*Fill mncnoptab(4,4,2,2) =
*       - 86747864238209/8930250 - 417088/27*ep^-3 - 38521988/405*ep^-2 + 
*      264311666/4725*ep^-1 - 769912640/27*z3 + 43904000*z5;
*Fill mncnoptab(4,4,3,1) =
*       - 1515457055404949/357210000 - 82712/135*ep^-3 - 18631369/2025*ep^-2 - 
*      89285363/2835*ep^-1 - 1559578048/135*z3 + 17561600*z5;
*Fill mncnoptab(5,1,1,5) =
*       - 54699046462671221/32006016000 + 39923/216*ep^-3 + 65445179/60480*
*      ep^-2 - 453971069/313600*ep^-1 - 121886869/27*z3 + 6860000*z5;
*Fill mncnoptab(5,2,1,4) =
*       - 10775201906664373/2000376000 + 860/27*ep^-3 - 1053382/945*ep^-2 - 
*      266829113/35280*ep^-1 - 390135008/27*z3 + 21952000*z5;
*Fill mncnoptab(5,2,2,3) =
*       - 2654032230525247/208372500 - 108592/45*ep^-3 - 35031746/1575*ep^-2 - 
*      1264086542/33075*ep^-1 - 1558464128/45*z3 + 52684800*z5;
*Fill mncnoptab(5,3,1,3) =
*       - 1553281109396459/381024000 + 6559/9*ep^-3 + 172871/540*ep^-2 - 
*      2946557347/100800*ep^-1 - 97752760/9*z3 + 16464000*z5;
*Fill mncnoptab(5,3,2,2) =
*       - 349190112856271/59535000 - 381136/45*ep^-3 - 36449102/675*ep^-2 + 
*      193339331/9450*ep^-1 - 770935424/45*z3 + 26342400*z5;
*Fill mncnoptab(5,3,3,1) =
*       - 495589548067253/317520000 - 19369/45*ep^-3 - 12264643/1800*ep^-2 - 
*      745482991/30240*ep^-1 - 195095096/45*z3 + 6585600*z5;
*Fill mncnoptab(5,4,1,2) =
*       - 1404687254200169/2000376000 - 22196/27*ep^-3 - 18341056/2835*ep^-2 - 
*      7901872933/1587600*ep^-1 - 55213792/27*z3 + 3136000*z5;
*Fill mncnoptab(5,4,2,1) =
*       - 2703599746937443/5000940000 - 141956/135*ep^-3 - 206700143/28350*
*      ep^-2 - 395097751/264600*ep^-1 - 219587104/135*z3 + 2508800*z5;
*Fill mncnoptab(5,5,1,1) =
*       - 2629892605029463/128024064000 - 9421/108*ep^-3 - 169868023/362880*
*      ep^-2 - 170678409/627200*ep^-1 - 1745339/27*z3 + 98000*z5;
*Fill mncnoptab(6,1,1,4) =
*       - 21394537161736301/25004700000 - 204262/675*ep^-3 - 11650321/10500*
*      ep^-2 + 954399088/165375*ep^-1 - 1550442608/675*z3 + 3512320*z5;
*Fill mncnoptab(6,2,1,3) =
*       - 1355689314527311/1041862500 + 9944/225*ep^-3 + 4198591/23625*ep^-2 - 
*      576422233/330750*ep^-1 - 780778304/225*z3 + 5268480*z5;
*Fill mncnoptab(6,2,2,2) =
*       - 102264570285053/86821875 - 377056/225*ep^-3 - 27899296/2625*ep^-2 + 
*      791190703/165375*ep^-1 - 770079104/225*z3 + 5268480*z5;
*Fill mncnoptab(6,3,1,2) =
*       - 712078941266617/2083725000 - 88616/225*ep^-3 - 65364799/23625*ep^-2
*       - 76182557/220500*ep^-1 - 220289344/225*z3 + 1505280*z5;
*Fill mncnoptab(6,3,2,1) =
*       - 71933674894463/463050000 - 88408/225*ep^-3 - 22366649/7875*ep^-2 - 
*      83726576/55125*ep^-1 - 109791872/225*z3 + 752640*z5;
*Fill mncnoptab(6,4,1,1) =
*       - 2549268572811643/200037600000 - 39952/675*ep^-3 - 181234189/567000*
*      ep^-2 - 659982313/3969000*ep^-1 - 27943568/675*z3 + 62720*z5;
*Fill mncnoptab(7,1,1,3) =
*       - 3723627858464321/33339600000 + 46897/1350*ep^-3 + 73683103/378000*
*      ep^-2 - 3880010633/15876000*ep^-1 - 195059276/675*z3 + 439040*z5;
*Fill mncnoptab(7,2,1,2) =
*       - 122256120796157/2083725000 - 8008/675*ep^-3 - 230717/875*ep^-2 - 
*      984557027/992250*ep^-1 - 111467072/675*z3 + 250880*z5;
*Fill mncnoptab(7,2,2,1) =
*       - 374471233554053/29172150000 - 352616/4725*ep^-3 - 77449193/165375*
*      ep^-2 + 1455586687/13891500*ep^-1 - 215345344/4725*z3 + 71680*z5;
*Fill mncnoptab(7,3,1,1) =
*       - 886148642962981/266716800000 - 8938/675*ep^-3 - 56364883/756000*ep^-2
*       - 1845718393/31752000*ep^-1 - 6977492/675*z3 + 15680*z5;
*Fill mncnoptab(8,1,1,2) =
*       - 952067717329531/408410100000 - 305366/33075*ep^-3 - 157911017/4630500
*      *ep^-2 + 15496117051/97240500*ep^-1 - 208616944/33075*z3 + 10240*z5;
*Fill mncnoptab(8,2,1,1) =
*       - 716689569830281/3267280800000 - 51952/33075*ep^-3 - 25922261/3087000*
*      ep^-2 - 18220093/24310125*ep^-1 - 28039568/33075*z3 + 1280*z5;
*Fill mncnoptab(9,1,1,1) =
*       - 1896551334050581/209105971200000 + 73249/1058400*ep^-3 + 51235081/
*      296352000*ep^-2 - 54957379097/49787136000*ep^-1 - 413312/33075*z3 + 20*
*      z5;
Fill mncnoptab(3,3,3,2) =
      427977441983/103680 - 52955/12*ep^-3 - 3917279/144*ep^-2 + 44625631/2880
      *ep^-1 + 10894318111/72*ep*z3 + 15370495*ep*z4 - 99078000*ep*z5 - 
      452482708047761/10368000*ep + 30740990/3*z3 - 15435000*z5;
Fill mncnoptab(4,2,1,4) =
      492417147546743/571536000 - 22771/54*ep^-3 - 1974617/1080*ep^-2 + 
      915359519/151200*ep^-1 + 6081755963/180*ep*z3 + 30675106/9*ep*z4 - 
      67110400/3*ep*z5 - 2327268549647543977/240045120000*ep + 61350212/27*z3
       - 3430000*z5;
Fill mncnoptab(4,2,2,3) =
      10310508922643/3888000 - 29239/18*ep^-3 - 410057/40*ep^-2 + 29037853/
      7200*ep^-1 + 18176277881/180*ep*z3 + 30621724/3*ep*z4 - 66463600*ep*z5
       - 6775865580736891/233280000*ep + 61243448/9*z3 - 10290000*z5;
Fill mncnoptab(4,3,1,3) =
      98209093589899/127008000 - 847/12*ep^-3 - 21579/16*ep^-2 - 513470983/
      100800*ep^-1 + 1219050631/40*ep*z3 + 3045119*ep*z4 - 20286000*ep*z5 - 
      152753095200805831/17781120000*ep + 6090238/3*z3 - 3087000*z5;
Fill mncnoptab(4,3,2,2) =
      746549351657/432000 - 18823/6*ep^-3 - 2095397/120*ep^-2 + 476289437/
      21600*ep^-1 + 3674812061/60*ep*z3 + 6207586*ep*z4 - 40454400*ep*z5 - 
      449125235438929/25920000*ep + 12415172/3*z3 - 6174000*z5;
Fill mncnoptab(4,3,3,1) =
      33417478515833/70560000 - 1981/60*ep^-3 - 6027293/3600*ep^-2 - 
      2496913651/302400*ep^-1 + 33147300541/1800*ep*z3 + 9111137/5*ep*z4 - 
      12359760*ep*z5 - 1343694916819313567/266716800000*ep + 18222274/15*z3 - 
      1852200*z5;
Fill mncnoptab(4,4,2,1) =
      111808019020979/571536000 - 20419/54*ep^-3 - 7607927/3240*ep^-2 + 
      618574609/453600*ep^-1 + 11269028347/1620*ep*z3 + 6219724/9*ep*z4 - 
      14131600/3*ep*z5 - 445250532042081389/240045120000*ep + 12439448/27*z3
       - 686000*z5;
Fill mncnoptab(5,1,1,4) =
      3404545910519813/16003008000 + 11537/216*ep^-3 + 2265673/30240*ep^-2 - 
      6664583011/4233600*ep^-1 + 6125595259/720*ep*z3 + 7568332/9*ep*z4 - 
      17149300/3*ep*z5 - 15988216912889349067/6721263360000*ep + 15136664/27*
      z3 - 857500*z5;
Fill mncnoptab(5,2,1,3) =
      94217706529879/254016000 + 1407/8*ep^-3 + 784633/1440*ep^-2 - 794391811/
      201600*ep^-1 + 11025810727/720*ep*z3 + 1515276*ep*z4 - 10304700*ep*z5 - 
      151196680058747123/35562240000*ep + 1010184*z3 - 1543500*z5;
Fill mncnoptab(5,2,2,2) =
      6657499764253/12960000 - 48041/60*ep^-3 - 17309333/3600*ep^-2 + 1298841/
      320*ep^-1 + 33499700221/1800*ep*z3 + 9286732/5*ep*z4 - 12506760*ep*z5 - 
      439852636788781/86400000*ep + 18573464/15*z3 - 1852200*z5;
Fill mncnoptab(5,3,1,2) =
      15299981746757/108864000 - 10171/72*ep^-3 - 4960199/4320*ep^-2 - 
      67110217/86400*ep^-1 + 2256184967/432*ep*z3 + 1537060/3*ep*z4 - 3562300*
      ep*z5 - 12594448880199007/9144576000*ep + 3074120/9*z3 - 514500*z5;
Fill mncnoptab(5,3,2,1) =
      115620267808099/1270080000 - 23387/120*ep^-3 - 1040799/800*ep^-2 + 
      1988123/120960*ep^-1 + 3798914129/1200*ep*z3 + 1550612/5*ep*z4 - 2172660
      *ep*z5 - 433205664999625789/533433600000*ep + 3101224/15*z3 - 308700*z5;
Fill mncnoptab(5,4,1,1) =
      116607543852899/16003008000 - 6157/216*ep^-3 - 12443447/90720*ep^-2 + 
      33603169/12700800*ep^-1 + 11782494547/45360*ep*z3 + 216868/9*ep*z4 - 
      567700/3*ep*z5 - 56108643614351387/960180480000*ep + 433736/27*z3 - 
      24500*z5;
Fill mncnoptab(6,1,1,3) =
      2037883590668579/44452800000 + 733/200*ep^-3 + 7183069/252000*ep^-2 - 
      1717712057/21168000*ep^-1 + 33824122981/18000*ep*z3 + 4538676/25*ep*z4
       - 1299396*ep*z5 - 9366902119661172109/18670176000000*ep + 3025784/25*z3
       - 185220*z5;
Fill mncnoptab(6,2,1,2) =
      35390275843033/1058400000 - 16667/300*ep^-3 - 1822397/6000*ep^-2 + 
      682534127/1512000*ep^-1 + 1280879763/1000*ep*z3 + 3119284/25*ep*z4 - 
      892584*ep*z5 - 434777012367296309/1333584000000*ep + 6238568/75*z3 - 
      123480*z5;
Fill mncnoptab(6,2,2,1) =
      43705933939733/3175200000 - 51667/900*ep^-3 - 643293/2000*ep^-2 + 
      164162507/504000*ep^-1 + 3941599109/9000*ep*z3 + 3185084/75*ep*z4 - 
      309288*ep*z5 - 139189622958910043/1333584000000*ep + 6370168/225*z3 - 
      41160*z5;
Fill mncnoptab(6,3,1,1) =
      4402290724537/1646400000 - 2127/200*ep^-3 - 13081511/252000*ep^-2 + 
      85049863/21168000*ep^-1 + 11976922627/126000*ep*z3 + 216756/25*ep*z4 - 
      70476*ep*z5 - 54838846552119547/2667168000000*ep + 144504/25*z3 - 8820*
      z5;
Fill mncnoptab(7,1,1,2) =
      238117911919931/133358400000 + 29933/5400*ep^-3 + 4181741/756000*ep^-2
       - 10958786353/63504000*ep^-1 + 3961449709/54000*ep*z3 + 1424992/225*ep*
      z4 - 54348*ep*z5 - 883201342630552501/56010528000000*ep + 2849984/675*z3
       - 6860*z5;
Fill mncnoptab(7,2,1,1) =
      37694309069933/133358400000 - 4981/5400*ep^-3 - 3848197/756000*ep^-2 - 
      229928551/63504000*ep^-1 + 4150542589/378000*ep*z3 + 217456/225*ep*z4 - 
      8484*ep*z5 - 16503907631292229/8001504000000*ep + 434912/675*z3 - 980*z5
      ;
Fill mncnoptab(8,1,1,1) =
      61242264325133/6534561600000 - 26581/264600*ep^-3 - 8290837/37044000*
      ep^-2 + 4495302041/3111696000*ep^-1 + 641079787/2646000*ep*z3 + 206656/
      11025*ep*z4 - 1452/7*ep*z5 - 152139085793242243/2744515872000000*ep + 
      413312/33075*z3 - 20*z5;
Fill mncnoptab(3,2,2,3) =
       - 13078015423/40500 - 1166/3*ep^-3 - 219653/90*ep^-2 + 179359/150*ep^-1
       - 621784364/45*ep*z3 - 1410728*ep*z4 + 8943600*ep*z5 + 565882214657/
      135000*ep - 2821456/3*z3 + 1440000*z5;
Fill mncnoptab(3,3,2,2) =
       - 931159283/4320 - 800*ep^-3 - 48001/12*ep^-2 + 1417247/180*ep^-1 - 
      62078545/6*ep*z3 - 1038120*ep*z4 + 6768000*ep*z5 + 4000067937751/1296000
      *ep - 692080*z3 + 1080000*z5;
Fill mncnoptab(3,3,3,1) =
       - 5573732533/57600 + 175/4*ep^-3 - 9581/48*ep^-2 - 7492889/2880*ep^-1
       - 94545971/24*ep*z3 - 403305*ep*z4 + 2574000*ep*z5 + 12321204871351/
      10368000*ep - 268870*z3 + 405000*z5;
Fill mncnoptab(4,1,1,4) =
       - 2807827829/72900 - 1630/27*ep^-3 - 3245/18*ep^-2 + 34576/27*ep^-1 - 
      42000568/27*ep*z3 - 1383640/9*ep*z4 + 3082000/3*ep*z5 + 979385889611/
      2187000*ep - 2767280/27*z3 + 160000*z5;
Fill mncnoptab(4,2,1,3) =
       - 28221879029/324000 + 4/3*ep^-3 - 1799/20*ep^-2 - 44113/75*ep^-1 - 
      35012467/10*ep*z3 - 356408*ep*z4 + 2289600*ep*z5 + 6698633885851/6480000
      *ep - 712816/3*z3 + 360000*z5;
Fill mncnoptab(4,2,2,2) =
       - 23078731723/216000 - 461*ep^-3 - 130721/60*ep^-2 + 19017283/3600*
      ep^-1 - 156219263/30*ep*z3 - 514644*ep*z4 + 3448800*ep*z5 + 
      19670240647171/12960000*ep - 343096*z3 + 540000*z5;
Fill mncnoptab(4,3,1,2) =
       - 9262246349/324000 - 338/3*ep^-3 - 11801/20*ep^-2 + 26071/25*ep^-1 - 
      14061799/10*ep*z3 - 137384*ep*z4 + 946800*ep*z5 + 869340324673/2160000*
      ep - 274768/3*z3 + 144000*z5;
Fill mncnoptab(4,3,2,1) =
       - 4269941147/216000 - 251/3*ep^-3 - 93673/180*ep^-2 + 3333209/10800*
      ep^-1 - 95416027/90*ep*z3 - 104348*ep*z4 + 717600*ep*z5 + 11837431004993/
      38880000*ep - 208696/3*z3 + 108000*z5;
Fill mncnoptab(4,4,1,1) =
       - 3869903417/2916000 - 364/27*ep^-3 - 89387/1620*ep^-2 + 432743/8100*
      ep^-1 - 67431383/810*ep*z3 - 71512/9*ep*z4 + 176800/3*ep*z5 + 
      3785470839041/174960000*ep - 143024/27*z3 + 8000*z5;
Fill mncnoptab(5,1,1,3) =
       - 94014346831/5184000 + 121/8*ep^-3 + 106063/1440*ep^-2 - 16207369/
      86400*ep^-1 - 482890991/720*ep*z3 - 66732*ep*z4 + 447900*ep*z5 + 
      59566361995607/311040000*ep - 44488*z3 + 67500*z5;
Fill mncnoptab(5,2,1,2) =
       - 1631016859/144000 - 15/2*ep^-3 - 14459/120*ep^-2 - 80399/288*ep^-1 - 
      32279897/60*ep*z3 - 53352*ep*z4 + 367200*ep*z5 + 1309588517171/8640000*
      ep - 35568*z3 + 54000*z5;
Fill mncnoptab(5,2,2,1) =
       - 1703250341/540000 - 201/5*ep^-3 - 28709/150*ep^-2 + 179513/450*ep^-1
       - 32408209/150*ep*z3 - 99576/5*ep*z4 + 152280*ep*z5 + 1861089308173/
      32400000*ep - 66384/5*z3 + 21600*z5;
Fill mncnoptab(5,3,1,1) =
       - 1507518839/1728000 - 49/8*ep^-3 - 37471/1440*ep^-2 + 1281373/86400*
      ep^-1 - 34159189/720*ep*z3 - 4452*ep*z4 + 33900*ep*z5 + 3821093000941/
      311040000*ep - 2968*z3 + 4500*z5;
Fill mncnoptab(6,1,1,2) =
       - 8071460023/8100000 - 181/25*ep^-3 - 24496/1125*ep^-2 + 1915223/13500*
      ep^-1 - 99509497/2250*ep*z3 - 94056/25*ep*z4 + 32136*ep*z5 + 
      5141063764979/486000000*ep - 62704/25*z3 + 4320*z5;
Fill mncnoptab(6,2,1,1) =
       - 35661097/400000 - 77/50*ep^-3 - 55603/9000*ep^-2 + 967589/108000*
      ep^-1 - 35320249/4500*ep*z3 - 17976/25*ep*z4 + 5856*ep*z5 + 
      3353461354561/1944000000*ep - 11984/25*z3 + 720*z5;
Fill mncnoptab(7,1,1,1) =
       - 3387368219/388800000 + 469/5400*ep^-3 + 14099/108000*ep^-2 - 1960937/
      1296000*ep^-1 - 4305961/18000*ep*z3 - 4144/225*ep*z4 + 196*ep*z5 + 
      1489128179587/23328000000*ep - 8288/675*z3 + 20*z5;
Fill mncnoptab(3,2,1,3) =
      2831372533/194400 + 455/18*ep^-3 + 6319/216*ep^-2 - 4589599/6480*ep^-1
       + 15385216/27*ep*z3 + 173950/3*ep*z4 - 363500*ep*z5 - 981631156921/
      5832000*ep + 347900/9*z3 - 60000*z5;
Fill mncnoptab(3,2,2,2) =
      145969549/3888 - 1435/9*ep^-3 - 70691/108*ep^-2 + 1431199/648*ep^-1 + 
      31188362/27*ep*z3 + 372740/3*ep*z4 - 721000*ep*z5 - 8538217571/23328*ep
       + 745480/9*z3 - 120000*z5;
Fill mncnoptab(3,3,2,1) =
      7510602449/777600 - 235/9*ep^-3 - 67391/432*ep^-2 + 2082899/12960*ep^-1
       + 63188269/216*ep*z3 + 90710/3*ep*z4 - 187000*ep*z5 - 4047664683001/
      46656000*ep + 181420/9*z3 - 30000*z5;
Fill mncnoptab(4,1,1,3) =
      15081744101/2916000 + 203/54*ep^-3 + 19823/3240*ep^-2 - 11583047/97200*
      ep^-1 + 77945816/405*ep*z3 + 172582/9*ep*z4 - 374300/3*ep*z5 - 
      5068206135881/87480000*ep + 345164/27*z3 - 20000*z5;
Fill mncnoptab(4,2,1,2) =
      1399378579/233280 - 740/27*ep^-3 - 70421/648*ep^-2 + 1649821/3888*ep^-1
       + 63915859/324*ep*z3 + 190060/9*ep*z4 - 380000/3*ep*z5 - 830598308171/
      13996800*ep + 380120/27*z3 - 20000*z5;
Fill mncnoptab(4,2,2,1) =
      8626579097/2332800 - 1505/54*ep^-3 - 70453/648*ep^-2 + 15165647/38880*
      ep^-1 + 32636837/324*ep*z3 + 97820/9*ep*z4 - 196000/3*ep*z5 - 
      4214387793553/139968000*ep + 195640/27*z3 - 10000*z5;
Fill mncnoptab(4,3,1,1) =
      7805797697/11664000 - 119/27*ep^-3 - 93743/6480*ep^-2 + 5998307/194400*
      ep^-1 + 65653693/3240*ep*z3 + 17638/9*ep*z4 - 42200/3*ep*z5 - 
      3678149914921/699840000*ep + 35276/27*z3 - 2000*z5;
Fill mncnoptab(5,1,1,2) =
      38410091629/46656000 + 763/216*ep^-3 - 13217/12960*ep^-2 - 88538189/
      777600*ep^-1 + 162821989/6480*ep*z3 + 19568/9*ep*z4 - 51700/3*ep*z5 - 
      17384289807653/2799360000*ep + 39136/27*z3 - 2500*z5;
Fill mncnoptab(5,2,1,1) =
      7464164057/46656000 - 193/216*ep^-3 - 42829/12960*ep^-2 + 3267047/777600
      *ep^-1 + 33840689/6480*ep*z3 + 4432/9*ep*z4 - 11300/3*ep*z5 - 
      3355464483121/2799360000*ep + 8864/27*z3 - 500*z5;
Fill mncnoptab(6,1,1,1) =
      9848776457/1166400000 - 769/5400*ep^-3 - 49837/324000*ep^-2 + 8517547/
      3888000*ep^-1 + 36299969/162000*ep*z3 + 4144/225*ep*z4 - 548/3*ep*z5 - 
      4938159875041/69984000000*ep + 8288/675*z3 - 20*z5;
Fill mncnoptab(2,2,2,2) =
       - 79897/27 - 64*ep^-3 - 500/3*ep^-2 + 10846/9*ep^-1 - 466976/3*ep*z3 - 
      14352*ep*z4 + 97440*ep*z5 + 2415263/54*ep - 9568*z3 + 17280*z5;
Fill mncnoptab(3,1,1,3) =
       - 1209925/864 + 9/2*ep^-3 + 123/8*ep^-2 - 4087/48*ep^-1 - 123208/3*ep*
      z3 - 4314*ep*z4 + 25260*ep*z5 + 74575541/5184*ep - 2876*z3 + 4320*z5;
Fill mncnoptab(3,2,1,2) =
       - 466685/648 - 4*ep^-3 - 310/9*ep^-2 + 473/108*ep^-1 - 478994/9*ep*z3
       - 5712*ep*z4 + 33600*ep*z5 + 65128439/3888*ep - 3808*z3 + 5760*z5;
Fill mncnoptab(3,2,2,1) =
       - 582479/972 - 148/9*ep^-3 - 1217/27*ep^-2 + 47689/162*ep^-1 - 955180/
      27*ep*z3 - 9328/3*ep*z4 + 22880*ep*z5 + 57290287/5832*ep - 18656/9*z3 + 
      3840*z5;
Fill mncnoptab(3,3,1,1) =
       - 1518557/10368 - 5/3*ep^-3 - 565/144*ep^-2 + 11917/864*ep^-1 - 514753/
      72*ep*z3 - 710*ep*z4 + 4680*ep*z5 + 273452161/124416*ep - 1420/3*z3 + 
      720*z5;
Fill mncnoptab(4,1,1,2) =
       - 1072745/2916 - 142/27*ep^-3 - 1705/162*ep^-2 + 56761/486*ep^-1 - 
      974044/81*ep*z3 - 8152/9*ep*z4 + 24080/3*ep*z5 + 7103453/2187*ep - 16304/
      27*z3 + 1280*z5;
Fill mncnoptab(4,2,1,1) =
       - 471157/23328 - 40/27*ep^-3 - 1019/324*ep^-2 + 16361/972*ep^-1 - 
      519899/162*ep*z3 - 2920/9*ep*z4 + 6560/3*ep*z5 + 204421561/279936*ep - 
      5840/27*z3 + 320*z5;
Fill mncnoptab(5,1,1,1) =
       - 2696245/373248 + 25/216*ep^-3 + 17/2592*ep^-2 - 63191/31104*ep^-1 - 
      286261/1296*ep*z3 - 160/9*ep*z4 + 500/3*ep*z5 + 369093769/4478976*ep - 
      320/27*z3 + 20*z5;
Fill mncnoptab(2,2,2,1) =
      50881/216 - 9*ep^-3 - 85/6*ep^-2 + 6803/36*ep^-1 + 30293/3*ep*z3 + 1476*
      ep*z4 - 5760*ep*z5 - 5699221/1296*ep + 984*z3 - 1080*z5;
Fill mncnoptab(3,1,1,2) =
      144325/432 + 3/2*ep^-3 - 15/4*ep^-2 - 377/8*ep^-1 + 30517/6*ep*z3 + 384*
      ep*z4 - 3000*ep*z5 - 4415225/2592*ep + 256*z3 - 540*z5;
Fill mncnoptab(3,2,1,1) =
      73417/1296 - 5/6*ep^-3 - 29/36*ep^-2 + 2027/216*ep^-1 + 30409/18*ep*z3
       + 176*ep*z4 - 1080*ep*z5 - 4203133/7776*ep + 352/3*z3 - 180*z5;
Fill mncnoptab(4,1,1,1) =
      44165/11664 - 13/54*ep^-3 + 59/324*ep^-2 + 6575/1944*ep^-1 + 31733/162*
      ep*z3 + 160/9*ep*z4 - 440/3*ep*z5 - 6225337/69984*ep + 320/27*z3 - 20*z5
      ;
Fill mncnoptab(2,1,1,2) =
       - 677/3 - 10/3*ep^-3 + 1/3*ep^-2 + 233/3*ep^-1 - 4480/3*ep*z3 + 56*ep*
      z4 + 760*ep*z5 + 1567/3*ep + 112/3*z3 + 160*z5;
Fill mncnoptab(2,2,1,1) =
       - 85/4 - 4/3*ep^-3 + 3/2*ep^-2 + 31/2*ep^-1 - 697*ep*z3 - 88*ep*z4 + 
      400*ep*z5 + 571/8*ep - 176/3*z3 + 80*z5;
Fill mncnoptab(3,1,1,1) =
       - 53/16 + 1/6*ep^-3 - 5/12*ep^-2 - 47/24*ep^-1 - 1151/6*ep*z3 - 16*ep*
      z4 + 120*ep*z5 + 3427/32*ep - 32/3*z3 + 20*z5;
Fill mncnoptab(2,1,1,1) =
       - 10 - 2/3*ep^-3 + 10/3*ep^-2 - 2*ep^-1 + 404/3*ep*z3 + 16*ep*z4 - 80*
      ep*z5 - 42*ep + 32/3*z3 - 20*z5;
Fill mncnoptab(1,1,1,1) =
      20*z5;
*--#] notabl.h : 
*--#[ gtabls.h :
Ctable,relax,mncT00(1:10,1:10);
Ctable,relax,mncT10(-6:10,1:10);
Ctable,relax,mncT20(-6:10,1:10);
Ctable,relax,mncT11(-6:10,-6:10);
fill mncT00(1,1) =
  ep^-1;
fill mncT00(1,2) =
  2-ep^-1;
fill mncT00(1,3) =
  -1+2*ep;
fill mncT00(1,4) =
  -1/3+4/3*ep^2;
fill mncT00(1,5) =
  -1/6-1/6*ep+2/3*ep^2+2/3*ep^3;
fill mncT00(1,6) =
  -1/10-1/6*ep+1/3*ep^2+2/3*ep^3+4/15*ep^4;
fill mncT00(1,7) =
  -1/15-13/90*ep+1/6*ep^2+5/9*ep^3+2/5*ep^4+4/45*ep^5;
fill mncT00(1,8) =
  -1/21-11/90*ep+7/90*ep^2+4/9*ep^3+4/9*ep^4+8/45*ep^5;
fill mncT00(1,9) =
  -1/28-29/280*ep+1/36*ep^2+127/360*ep^3+4/9*ep^4+11/45*ep^5;
fill mncT00(1,10) =
  -1/36-223/2520*ep-4/2835*ep^2+101/360*ep^3+229/540*ep^4+13/
  45*ep^5;
fill mncT00(2,1) =
  2-ep^-1;
fill mncT00(2,2) =
  2-2*ep^-1+4*ep;
fill mncT00(2,3) =
  -1-2*ep^-1+8*ep+4*ep^2;
fill mncT00(2,4) =
  -8/3-2*ep^-1+22/3*ep+32/3*ep^2+8/3*ep^3;
fill mncT00(2,5) =
  -23/6-2*ep^-1+35/6*ep+15*ep^2+26/3*ep^3+4/3*ep^4;
fill mncT00(2,6) =
  -71/15-2*ep^-1+62/15*ep+53/3*ep^2+46/3*ep^3+76/15*ep^4+8/
  15*ep^5;
fill mncT00(2,7) =
  -82/15-2*ep^-1+217/90*ep+1729/90*ep^2+196/9*ep^3+476/45*ep^4
  +104/45*ep^5;
fill mncT00(2,8) =
  -213/35-2*ep^-1+229/315*ep+899/45*ep^2+1247/45*ep^3+776/45*
  ep^4+248/45*ep^5;
fill mncT00(2,9) =
  -927/140-2*ep^-1-2263/2520*ep+6359/315*ep^2+3967/120*ep^3+
  1477/60*ep^4+151/15*ep^5;
fill mncT00(2,10) =
  -4469/630-2*ep^-1-3097/1260*ep+45329/2268*ep^2+85787/2268*ep^3
  +17489/540*ep^4+4273/270*ep^5;
fill mncT00(3,1) =
  -1+2*ep;
fill mncT00(3,2) =
  -1-2*ep^-1+8*ep+4*ep^2;
fill mncT00(3,3) =
  -5-6*ep^-1+23*ep+20*ep^2+4*ep^3;
fill mncT00(3,4) =
  -15-12*ep^-1+127/3*ep+178/3*ep^2+68/3*ep^3+8/3*ep^4;
fill mncT00(3,5) =
  -97/3-20*ep^-1+371/6*ep+751/6*ep^2+217/3*ep^3+50/3*ep^4+4/
  3*ep^5;
fill mncT00(3,6) =
  -58-30*ep^-1+2333/30*ep+6529/30*ep^2+500/3*ep^3+172/3*ep^4
  +136/15*ep^5;
fill mncT00(3,7) =
  -464/5-42*ep^-1+2603/30*ep+15089/45*ep^2+28489/90*ep^3+6416/
  45*ep^4+1508/45*ep^5;
fill mncT00(3,8) =
  -687/5-56*ep^-1+10807/126*ep+149903/315*ep^2+1061/2*ep^3+291
  *ep^4+268/3*ep^5;
fill mncT00(3,9) =
  -6733/35-72*ep^-1+2015/28*ep+1603937/2520*ep^2+513547/630*ep^3
  +62519/120*ep^4+11669/60*ep^5;
fill mncT00(3,10) =
  -3615/14-90*ep^-1+13466/315*ep+2051033/2520*ep^2+6665453/5670*
  ep^3+19284803/22680*ep^4+49856/135*ep^5;
fill mncT00(4,1) =
  -1/3+4/3*ep^2;
fill mncT00(4,2) =
  -8/3-2*ep^-1+22/3*ep+32/3*ep^2+8/3*ep^3;
fill mncT00(4,3) =
  -15-12*ep^-1+127/3*ep+178/3*ep^2+68/3*ep^3+8/3*ep^4;
fill mncT00(4,4) =
  -58-40*ep^-1+1180/9*ep+226*ep^2+1036/9*ep^3+24*ep^4+16/9*
  ep^5;
fill mncT00(4,5) =
  -505/3-100*ep^-1+5311/18*ep+11569/18*ep^2+3740/9*ep^3+1100/9
  *ep^4+152/9*ep^5;
fill mncT00(4,6) =
  -401-210*ep^-1+8123/15*ep+13433/9*ep^2+52729/45*ep^3+3992/9*
  ep^4+3976/45*ep^5;
fill mncT00(4,7) =
  -12467/15-392*ep^-1+77009/90*ep+405461/135*ep^2+249029/90*ep^3
  +57259/45*ep^4+14788/45*ep^5;
fill mncT00(4,8) =
  -23332/15-672*ep^-1+25051/21*ep+734401/135*ep^2+5421223/945*
  ep^3+138649/45*ep^4+43618/45*ep^5;
fill mncT00(4,9) =
  -18855/7-1080*ep^-1+618431/420*ep+1527913/168*ep^2+40749427/
  3780*ep^3+49720691/7560*ep^4+108841/45*ep^5;
fill mncT00(4,10) =
  -61445/14-1650*ep^-1+1187719/756*ep+13492646/945*ep^2+
  319245677/17010*ep^3+1605965/126*ep^4+36227755/6804*ep^5;
fill mncT00(5,1) =
  -1/6-1/6*ep+2/3*ep^2+2/3*ep^3;
fill mncT00(5,2) =
  -23/6-2*ep^-1+35/6*ep+15*ep^2+26/3*ep^3+4/3*ep^4;
fill mncT00(5,3) =
  -97/3-20*ep^-1+371/6*ep+751/6*ep^2+217/3*ep^3+50/3*ep^4+4/
  3*ep^5;
fill mncT00(5,4) =
  -505/3-100*ep^-1+5311/18*ep+11569/18*ep^2+3740/9*ep^3+1100/9
  *ep^4+152/9*ep^5;
fill mncT00(5,5) =
  -3835/6-350*ep^-1+34147/36*ep+43147/18*ep^2+63929/36*ep^3+
  5720/9*ep^4+1082/9*ep^5;
fill mncT00(5,6) =
  -11683/6-980*ep^-1+427073/180*ep+321547/45*ep^2+120747/20*ep^3
  +25521/10*ep^4+9106/15*ep^5;
fill mncT00(5,7) =
  -75782/15-2352*ep^-1+445667/90*ep+1953209/108*ep^2+465035/27*
  ep^3+1510033/180*ep^4+215411/90*ep^5;
fill mncT00(5,8) =
  -11610-5040*ep^-1+5635817/630*ep+152869817/3780*ep^2+81063041/
  1890*ep^3+89139203/3780*ep^4+351502/45*ep^5;
fill mncT00(5,9) =
  -339795/14-9900*ep^-1+7169401/504*ep+177345113/2160*ep^2+
  1450750099/15120*ep^3+177108377/3024*ep^4+66478591/3024*ep^5;
fill mncT00(5,10) =
  -329285/7-18150*ep^-1+30067363/1512*ep+333243523/2160*ep^2+
  26798048483/136080*ep^3+2559867239/19440*ep^4+1496306639/27216*ep^5;
fill mncT00(6,1) =
  -1/10-1/6*ep+1/3*ep^2+2/3*ep^3+4/15*ep^4;
fill mncT00(6,2) =
  -71/15-2*ep^-1+62/15*ep+53/3*ep^2+46/3*ep^3+76/15*ep^4+8/
  15*ep^5;
fill mncT00(6,3) =
  -58-30*ep^-1+2333/30*ep+6529/30*ep^2+500/3*ep^3+172/3*ep^4
  +136/15*ep^5;
fill mncT00(6,4) =
  -401-210*ep^-1+8123/15*ep+13433/9*ep^2+52729/45*ep^3+3992/9*
  ep^4+3976/45*ep^5;
fill mncT00(6,5) =
  -11683/6-980*ep^-1+427073/180*ep+321547/45*ep^2+120747/20*ep^3
  +25521/10*ep^4+9106/15*ep^5;
fill mncT00(6,6) =
  -37009/5-3528*ep^-1+1164389/150*ep+2400553/90*ep^2+2213339/90*
  ep^3+23205/2*ep^4+80157/25*ep^5;
fill mncT00(6,7) =
  -23499-10584*ep^-1+1544798/75*ep+74618423/900*ep^2+11272138/
  135*ep^3+23575927/540*ep^4+3092012/225*ep^5;
fill mncT00(6,8) =
  -64989-27720*ep^-1+29212361/630*ep+1058350894/4725*ep^2+
  1159995587/4725*ep^3+133238803/945*ep^4+93995227/1890*ep^5;
fill mncT00(6,9) =
  -2256507/14-65340*ep^-1+76200941/840*ep+4550075377/8400*ep^2+
  9721402571/15120*ep^3+30385900253/75600*ep^4+2369271799/15120*ep^5;
fill mncT00(6,10) =
  -5124141/14-141570*ep^-1+97914331/630*ep+45269411767/37800*ep^2
  +43425450739/28350*ep^3+43960605211/42525*ep^4+74891892349/170100*
  ep^5;
fill mncT00(7,1) =
  -1/15-13/90*ep+1/6*ep^2+5/9*ep^3+2/5*ep^4+4/45*ep^5;
fill mncT00(7,2) =
  -82/15-2*ep^-1+217/90*ep+1729/90*ep^2+196/9*ep^3+476/45*ep^4
  +104/45*ep^5;
fill mncT00(7,3) =
  -464/5-42*ep^-1+2603/30*ep+15089/45*ep^2+28489/90*ep^3+6416/
  45*ep^4+1508/45*ep^5;
fill mncT00(7,4) =
  -12467/15-392*ep^-1+77009/90*ep+405461/135*ep^2+249029/90*ep^3
  +57259/45*ep^4+14788/45*ep^5;
fill mncT00(7,5) =
  -75782/15-2352*ep^-1+445667/90*ep+1953209/108*ep^2+465035/27*
  ep^3+1510033/180*ep^4+215411/90*ep^5;
fill mncT00(7,6) =
  -23499-10584*ep^-1+1544798/75*ep+74618423/900*ep^2+11272138/
  135*ep^3+23575927/540*ep^4+3092012/225*ep^5;
fill mncT00(7,7) =
  -89691-38808*ep^-1+15230353/225*ep+839340229/2700*ep^2+
  2703725629/8100*ep^3+33824861/180*ep^4+526025219/8100*ep^5;
fill mncT00(7,8) =
  -293898-121968*ep^-1+583171907/3150*ep+6289238647/6300*ep^2+
  64919324111/56700*ep^3+39277798103/56700*ep^4+14806523023/56700*ep^5
  ;
fill mncT00(7,9) =
  -5970591/7-339768*ep^-1+910963763/2100*ep+1275352103/450*ep^2+
  37461814447/10800*ep^3+72796743971/32400*ep^4+5945016637/6480*ep^5;
fill mncT00(7,10) =
  -4484337/2-858858*ep^-1+16663386827/18900*ep+825227119253/113400
  *ep^2+1290630089159/136080*ep^3+2673094441009/408240*ep^4+
  1957097729129/680400*ep^5;
fill mncT00(8,1) =
  -1/21-11/90*ep+7/90*ep^2+4/9*ep^3+4/9*ep^4+8/45*ep^5;
fill mncT00(8,2) =
  -213/35-2*ep^-1+229/315*ep+899/45*ep^2+1247/45*ep^3+776/45*
  ep^4+248/45*ep^5;
fill mncT00(8,3) =
  -687/5-56*ep^-1+10807/126*ep+149903/315*ep^2+1061/2*ep^3+291
  *ep^4+268/3*ep^5;
fill mncT00(8,4) =
  -23332/15-672*ep^-1+25051/21*ep+734401/135*ep^2+5421223/945*
  ep^3+138649/45*ep^4+43618/45*ep^5;
fill mncT00(8,5) =
  -11610-5040*ep^-1+5635817/630*ep+152869817/3780*ep^2+81063041/
  1890*ep^3+89139203/3780*ep^4+351502/45*ep^5;
fill mncT00(8,6) =
  -64989-27720*ep^-1+29212361/630*ep+1058350894/4725*ep^2+
  1159995587/4725*ep^3+133238803/945*ep^4+93995227/1890*ep^5;
fill mncT00(8,7) =
  -293898-121968*ep^-1+583171907/3150*ep+6289238647/6300*ep^2+
  64919324111/56700*ep^3+39277798103/56700*ep^4+14806523023/56700*ep^5
  ;
fill mncT00(8,8) =
  -7885284/7-453024*ep^-1+6655456091/11025*ep+473865407/126*ep^2
  +9189330217/2025*ep^3+1644373427/567*ep^4+5518157081/4725*ep^5;
fill mncT00(8,9) =
  -26476593/7-1472328*ep^-1+73265477633/44100*ep+54627219331/4410*
  ep^2+3572949997297/226800*ep^3+2411251880873/226800*ep^4+
  206938354943/45360*ep^5;
fill mncT00(8,10) =
  -22789767/2-4294290*ep^-1+528877919/135*ep+29013083864323/793800
  *ep^2+116678567813779/2381400*ep^3+17786915424493/510300*ep^4+
  8105581054537/510300*ep^5;
fill mncT00(9,1) =
  -1/28-29/280*ep+1/36*ep^2+127/360*ep^3+4/9*ep^4+11/45*ep^5;
fill mncT00(9,2) =
  -927/140-2*ep^-1-2263/2520*ep+6359/315*ep^2+3967/120*ep^3+
  1477/60*ep^4+151/15*ep^5;
fill mncT00(9,3) =
  -6733/35-72*ep^-1+2015/28*ep+1603937/2520*ep^2+513547/630*ep^3
  +62519/120*ep^4+11669/60*ep^5;
fill mncT00(9,4) =
  -18855/7-1080*ep^-1+618431/420*ep+1527913/168*ep^2+40749427/
  3780*ep^3+49720691/7560*ep^4+108841/45*ep^5;
fill mncT00(9,5) =
  -339795/14-9900*ep^-1+7169401/504*ep+177345113/2160*ep^2+
  1450750099/15120*ep^3+177108377/3024*ep^4+66478591/3024*ep^5;
fill mncT00(9,6) =
  -2256507/14-65340*ep^-1+76200941/840*ep+4550075377/8400*ep^2+
  9721402571/15120*ep^3+30385900253/75600*ep^4+2369271799/15120*ep^5;
fill mncT00(9,7) =
  -5970591/7-339768*ep^-1+910963763/2100*ep+1275352103/450*ep^2+
  37461814447/10800*ep^3+72796743971/32400*ep^4+5945016637/6480*ep^5;
fill mncT00(9,8) =
  -26476593/7-1472328*ep^-1+73265477633/44100*ep+54627219331/4410*
  ep^2+3572949997297/226800*ep^3+2411251880873/226800*ep^4+
  206938354943/45360*ep^5;
fill mncT00(9,9) =
  -407455191/28-5521230*ep^-1+62145308573/11760*ep+8267348377283/
  176400*ep^2+26321703245023/423360*ep^3+4967716026299/113400*ep^4+
  1280830607257/64800*ep^5;
fill mncT00(9,10) =
  -1394685435/28-18404100*ep^-1+100114668349/7056*ep+1852144738247/
  11760*ep^2+1386280258914223/6350400*ep^3+510011325931501/3175200*
  ep^4+62160020883013/816480*ep^5;
fill mncT00(10,1) =
  -1/36-223/2520*ep-4/2835*ep^2+101/360*ep^3+229/540*ep^4+13/
  45*ep^5;
fill mncT00(10,2) =
  -4469/630-2*ep^-1-3097/1260*ep+45329/2268*ep^2+85787/2268*ep^3
  +17489/540*ep^4+4273/270*ep^5;
fill mncT00(10,3) =
  -3615/14-90*ep^-1+13466/315*ep+2051033/2520*ep^2+6665453/5670*
  ep^3+19284803/22680*ep^4+49856/135*ep^5;
fill mncT00(10,4) =
  -61445/14-1650*ep^-1+1187719/756*ep+13492646/945*ep^2+
  319245677/17010*ep^3+1605965/126*ep^4+36227755/6804*ep^5;
fill mncT00(10,5) =
  -329285/7-18150*ep^-1+30067363/1512*ep+333243523/2160*ep^2+
  26798048483/136080*ep^3+2559867239/19440*ep^4+1496306639/27216*ep^5;
fill mncT00(10,6) =
  -5124141/14-141570*ep^-1+97914331/630*ep+45269411767/37800*ep^2
  +43425450739/28350*ep^3+43960605211/42525*ep^4+74891892349/170100*
  ep^5;
fill mncT00(10,7) =
  -4484337/2-858858*ep^-1+16663386827/18900*ep+825227119253/113400
  *ep^2+1290630089159/136080*ep^3+2673094441009/408240*ep^4+
  1957097729129/680400*ep^5;
fill mncT00(10,8) =
  -22789767/2-4294290*ep^-1+528877919/135*ep+29013083864323/793800
  *ep^2+116678567813779/2381400*ep^3+17786915424493/510300*ep^4+
  8105581054537/510300*ep^5;
fill mncT00(10,9) =
  -1394685435/28-18404100*ep^-1+100114668349/7056*ep+1852144738247/
  11760*ep^2+1386280258914223/6350400*ep^3+510011325931501/3175200*
  ep^4+62160020883013/816480*ep^5;
fill mncT00(10,10) =
  -8074989065/42-69526600*ep^-1+1350488632313/31752*ep+
  47479977496171/79380*ep^2+24566922560195171/28576800*ep^3+
  18726665340585257/28576800*ep^4+10393828589694061/32148900*ep^5;
fill mncT10(-6,1) =
  -1/112-757/31360*ep-3727229/79027200*ep^2-596248999/7375872000*
  ep^3-805517926621/6195732480000*ep^4-116996591020151/578268364800000
  *ep^5;
fill mncT10(-6,2) =
  -143/140-1/2*ep^-1-317803/176400*ep-72277427/24696000*ep^2-
  15809639243/3457440000*ep^3-3390537990787/484041600000*ep^4-
  79974824548387/7529536000000*ep^5;
fill mncT10(-6,3) =
  -59/20-21/2*ep^-1-24049/1200*ep-1127389/72000*ep^2-6231227/
  160000*ep^3-1260578141/28800000*ep^4-15537540689/192000000*ep^5;
fill mncT10(-6,4) =
  235/4-105/2*ep^-1-30433/240*ep+1041767/14400*ep^2-51977471/
  288000*ep^3+178464223/5760000*ep^4-30193341199/115200000*ep^5;
fill mncT10(-6,5) =
  670/3-175/2*ep^-1-60443/144*ep+100289/192*ep^2-4637557/6912*ep^3
  +53277763/82944*ep^4-794249701/995328*ep^5;
fill mncT10(-6,6) =
  443/2-105/2*ep^-1-125593/240*ep+2499871/2880*ep^2-13702799/11520
  *ep^3+7218039/5120*ep^4-174569129/110592*ep^5;
fill mncT10(-6,7) =
  337/5-21/2*ep^-1-260689/1200*ep+33888383/72000*ep^2-376269769/
  480000*ep^3+31338072103/28800000*ep^4-2307104628361/1728000000*ep^5;
fill mncT10(-6,8) =
  353/70-1/2*ep^-1-86107/3600*ep+5200903/72000*ep^2-228739987/
  1440000*ep^3+23861797469/86400000*ep^4-696292338001/1728000000*ep^5;
fill mncT10(-6,9) =
  1/56-463/1960*ep+7054603/4939200*ep^2-1232361283/230496000*ep^3+
  1372388471947/96808320000*ep^4-1175386471449923/40659494400000*ep^5;
fill mncT10(-6,10) =
  1/1344*ep-3179/376320*ep^2+38770049/948326400*ep^3-9635223953/
  88510464000*ep^4+11802258330329/74348789760000*ep^5;
fill mncT10(-5,1) =
  -1/84-131/4410*ep-45907/823200*ep^2-32325739/345744000*ep^3-
  798737439/5378240000*ep^4-172809886751/752953600000*ep^5;
fill mncT10(-5,2) =
  -13/15-1/2*ep^-1-5267/3600*ep-55693/24000*ep^2-5155573/1440000
  *ep^3-52300417/9600000*ep^4-526842293/64000000*ep^5;
fill mncT10(-5,3) =
  5/4-15/2*ep^-1-3119/240*ep-22373/4800*ep^2-2122051/96000*ep^3-
  35026237/1920000*ep^4-543093073/12800000*ep^5;
fill mncT10(-5,4) =
  265/6-25*ep^-1-5579/72*ep+20767/288*ep^2-121699/1152*ep^3+
  315191/4608*ep^4-267971/2048*ep^5;
fill mncT10(-5,5) =
  1055/12-25*ep^-1-6547/36*ep+3175/12*ep^2-36151/108*ep^3+473935/
  1296*ep^4-391195/972*ep^5;
fill mncT10(-5,6) =
  173/4-15/2*ep^-1-30149/240*ep+78807/320*ep^2-4323407/11520*ep^3
  +66872909/138240*ep^4-186295291/331776*ep^5;
fill mncT10(-5,7) =
  71/15-1/2*ep^-1-75287/3600*ep+4216483/72000*ep^2-515461421/
  4320000*ep^3+50009271427/259200000*ep^4-4105017792749/15552000000*
  ep^5;
fill mncT10(-5,8) =
  1/42-379/1260*ep+43399/25200*ep^2-9167693/1512000*ep^3+
  1366105291/90720000*ep^4-156453380117/5443200000*ep^5;
fill mncT10(-5,9) =
  1/784*ep-2263/164640*ep^2+1428971/23049600*ep^3-1443954119/
  9680832000*ep^4+725260343671/4065949440000*ep^5;
fill mncT10(-5,10) =
  1/28224*ep-5797/23708160*ep^2+2202023/6638284800*ep^3+8689170961/
  5576159232000*ep^4-31132238888473/4683973754880000*ep^5;
fill mncT10(-4,1) =
  -1/60-17/450*ep-2441/36000*ep^2-26639/240000*ep^3-278431/
  1600000*ep^4-8544297/32000000*ep^5;
fill mncT10(-4,2) =
  -41/60-1/2*ep^-1-1337/1200*ep-41419/24000*ep^2-1262653/480000*
  ep^3-12728737/3200000*ep^4-383416719/64000000*ep^5;
fill mncT10(-4,3) =
  11/3-5*ep^-1-211/24*ep+167/96*ep^2-4763/384*ep^3-1851/512*ep^4
  -41841/2048*ep^5;
fill mncT10(-4,4) =
  53/2-10*ep^-1-416/9*ep+331/6*ep^2-595/9*ep^3+1505/24*ep^4-
  595/8*ep^5;
fill mncT10(-4,5) =
  299/12-5*ep^-1-755/12*ep+3889/36*ep^2-15913/108*ep^3+225715/
  1296*ep^4-371315/1944*ep^5;
fill mncT10(-4,6) =
  131/30-1/2*ep^-1-845/48*ep+25747/576*ep^2-570889/6912*ep^3+
  50613671/414720*ep^4-154047985/995328*ep^5;
fill mncT10(-4,7) =
  1/30-179/450*ep+4253/2000*ep^2-7480199/1080000*ep^3+1025875513/
  64800000*ep^4-108169063031/3888000000*ep^5;
fill mncT10(-4,8) =
  1/420*ep-101/4200*ep^2+24967/252000*ep^3-1045543/5040000*ep^4+
  159617923/907200000*ep^5;
fill mncT10(-4,9) =
  1/11760*ep-437/823200*ep^2+150043/345744000*ep^3+198757571/
  48404160000*ep^4-812570541017/60989241600000*ep^5;
fill mncT10(-4,10) =
  1/141120*ep-3529/118540800*ep^2-540767/11063808000*ep^3+
  10661942293/27880796160000*ep^4-8911337124349/23419868774400000*ep^5;
fill mncT10(-3,1) =
  -1/40-121/2400*ep-4127/48000*ep^2-43883/320000*ep^3-1357221/
  6400000*ep^4-41346027/128000000*ep^5;
fill mncT10(-3,2) =
  -11/24-1/2*ep^-1-73/96*ep-443/384*ep^2-891/512*ep^3-5361/
  2048*ep^4-32211/8192*ep^5;
fill mncT10(-3,3) =
  9/2-3*ep^-1-20/3*ep+29/6*ep^2-31/4*ep^3+27/8*ep^4-159/16*
  ep^5;
fill mncT10(-3,4) =
  12-3*ep^-1-74/3*ep+35*ep^2-499/12*ep^3+89/2*ep^4-747/16*ep^5
  ;
fill mncT10(-3,5) =
  47/12-1/2*ep^-1-167/12*ep+1111/36*ep^2-10793/216*ep^3+85315/
  1296*ep^4-594665/7776*ep^5;
fill mncT10(-3,6) =
  1/20-133/240*ep+2597/960*ep^2-91439/11520*ep^3+2244941/138240*
  ep^4-8504443/331776*ep^5;
fill mncT10(-3,7) =
  1/200*ep-557/12000*ep^2+40553/240000*ep^3-4125511/14400000*ep^4+
  81009257/864000000*ep^5;
fill mncT10(-3,8) =
  1/4200*ep-109/84000*ep^2+683/5040000*ep^3+171199/14400000*ep^4-
  507092773/18144000000*ep^5;
fill mncT10(-3,9) =
  1/39200*ep-1439/16464000*ep^2-573283/2304960000*ep^3+1163405147/
  968083200000*ep^4-159267256723/406594944000000*ep^5;
fill mncT10(-3,10) =
  1/235200*ep-1723/197568000*ep^2-3323987/55319040000*ep^3+
  6428460691/46467993600000*ep^4+7694842432037/39033114624000000*ep^5;
fill mncT10(-2,1) =
  -1/24-7/96*ep-15/128*ep^2-93/512*ep^3-567/2048*ep^4-3429/
  8192*ep^5;
fill mncT10(-2,2) =
  -1/6-1/2*ep^-1-5/12*ep-5/8*ep^2-15/16*ep^3-45/32*ep^4-135/
  64*ep^5;
fill mncT10(-2,3) =
  4-3/2*ep^-1-23/4*ep+47/8*ep^2-99/16*ep^3+183/32*ep^4-411/64*
  ep^5;
fill mncT10(-2,4) =
  10/3-1/2*ep^-1-39/4*ep+421/24*ep^2-375/16*ep^3+855/32*ep^4-
  1815/64*ep^5;
fill mncT10(-2,5) =
  1/12-5/6*ep+257/72*ep^2-3883/432*ep^3+40625/2592*ep^4-332755/
  15552*ep^5;
fill mncT10(-2,6) =
  1/80*ep-33/320*ep^2+239/768*ep^3-16369/46080*ep^4-28393/110592*
  ep^5;
fill mncT10(-2,7) =
  1/1200*ep-89/24000*ep^2-5057/1440000*ep^3+3402559/86400000*ep^4-
  297978833/5184000000*ep^5;
fill mncT10(-2,8) =
  1/8400*ep-7/24000*ep^2-4979/3360000*ep^3+2574119/604800000*ep^4+
  1593769/576000000*ep^5;
fill mncT10(-2,9) =
  1/39200*ep-153/5488000*ep^2-303141/768320000*ep^3+446130407/
  968083200000*ep^4+235332367979/135531648000000*ep^5;
fill mncT10(-2,10) =
  1/141120*ep-19/39513600*ep^2-1286911/11063808000*ep^3+395635669/
  27880796160000*ep^4+4644027020161/7806622924800000*ep^5;
fill mncT10(-1,1) =
  -1/12-1/8*ep-3/16*ep^2-9/32*ep^3-27/64*ep^4-81/128*ep^5;
fill mncT10(-1,2) =
  1/4-1/2*ep^-1-1/8*ep-3/16*ep^2-9/32*ep^3-27/64*ep^4-81/128*
  ep^5;
fill mncT10(-1,3) =
  5/2-1/2*ep^-1-5*ep+6*ep^2-6*ep^3+6*ep^4-6*ep^5;
fill mncT10(-1,4) =
  1/6-17/12*ep+39/8*ep^2-151/16*ep^3+407/32*ep^4-919/64*ep^5;
fill mncT10(-1,5) =
  1/24*ep-41/144*ep^2+523/864*ep^3-641/5184*ep^4-46589/31104*ep^5;
fill mncT10(-1,6) =
  1/240*ep-37/2880*ep^2-1301/34560*ep^3+63767/414720*ep^4-55825/
  995328*ep^5;
fill mncT10(-1,7) =
  1/1200*ep-67/72000*ep^2-52171/4320000*ep^3+3702677/259200000*ep^4
  +700238501/15552000000*ep^5;
fill mncT10(-1,8) =
  1/4200*ep+13/252000*ep^2-56531/15120000*ep^3-548003/907200000*ep^4
  +945051661/54432000000*ep^5;
fill mncT10(-1,9) =
  1/11760*ep+257/2469600*ep^2-1351993/1037232000*ep^3-679414663/
  435637440000*ep^4+1056611141567/182967724800000*ep^5;
fill mncT10(-1,10) =
  1/28224*ep+569/7902720*ep^2-3349369/6638284800*ep^3-6050070703/
  5576159232000*ep^4+8556135083879/4683973754880000*ep^5;
fill mncT10(0,1) =
  -1/4-3/8*ep-9/16*ep^2-27/32*ep^3-81/64*ep^4-243/128*ep^5;
fill mncT10(0,2) =
  1-1/2*ep^-1;
fill mncT10(0,3) =
  1/2-3*ep+6*ep^2-6*ep^3+6*ep^4-6*ep^5;
fill mncT10(0,4) =
  1/4*ep-9/8*ep^2+9/16*ep^3+87/32*ep^4-279/64*ep^5;
fill mncT10(0,5) =
  1/24*ep-5/144*ep^2-449/864*ep^3+2275/5184*ep^4+37975/31104*ep^5;
fill mncT10(0,6) =
  1/80*ep+13/960*ep^2-1951/11520*ep^3-24083/138240*ep^4+178885/
  331776*ep^5;
fill mncT10(0,7) =
  1/200*ep+143/12000*ep^2-42841/720000*ep^3-6769033/43200000*ep^4+
  281515271/2592000000*ep^5;
fill mncT10(0,8) =
  1/420*ep+101/12600*ep^2-16957/756000*ep^3-4615741/45360000*ep^4-
  69750733/2721600000*ep^5;
fill mncT10(0,9) =
  1/784*ep+291/54880*ep^2-196163/23049600*ep^3-616218973/9680832000*
  ep^4-235493357243/4065949440000*ep^5;
fill mncT10(0,10) =
  1/1344*ep+1349/376320*ep^2-909109/316108800*ep^3-10682456563/
  265531392000*ep^4-13079587690741/223046369280000*ep^5;
fill mncT10(1,1) =
  1/2*ep^-1;
fill mncT10(1,2) =
  3-ep^-1;
fill mncT10(1,3) =
  -3/2+3*ep+6*ep^2-6*ep^3+6*ep^4-6*ep^5;
fill mncT10(1,4) =
  -1/2-3/4*ep+39/8*ep^2+105/16*ep^3-105/32*ep^4+105/64*ep^5;
fill mncT10(1,5) =
  -1/4-5/6*ep+119/72*ep^2+3299/432*ep^3+13895/2592*ep^4-19285/
  15552*ep^5;
fill mncT10(1,6) =
  -3/20-11/16*ep+65/192*ep^2+13213/2304*ep^3+1265101/138240*ep^4
  +1354885/331776*ep^5;
fill mncT10(1,7) =
  -1/10-83/150*ep-3973/18000*ep^2+4308551/1080000*ep^3+632934263/
  64800000*ep^4+34727955719/3888000000*ep^5;
fill mncT10(1,8) =
  -1/14-9/20*ep-559/1200*ep^2+194473/72000*ep^3+39548249/4320000
  *ep^4+3093776137/259200000*ep^5;
fill mncT10(1,9) =
  -3/56-729/1960*ep-312307/548800*ep^2+411281683/230496000*ep^3+
  789265539653/96808320000*ep^4+547737213033523/40659494400000*ep^5;
fill mncT10(1,10) =
  -1/24-2099/6720*ep-3411341/5644800*ep^2+5367611413/4741632000*
  ep^3+28254903745891/3982970880000*ep^4+46982106507854437/
  3345695539200000*ep^5;
fill mncT10(2,1) =
  2-1/2*ep^-1-2*ep+2*ep^2-2*ep^3+2*ep^4-2*ep^5;
fill mncT10(2,2) =
  3-3/2*ep^-1+6*ep-6*ep^2+6*ep^3-6*ep^4+6*ep^5;
fill mncT10(2,3) =
  -3/2-3/2*ep^-1+15*ep+12*ep^2-12*ep^3+12*ep^4-12*ep^5;
fill mncT10(2,4) =
  -4-3/2*ep^-1+49/4*ep+295/8*ep^2+169/16*ep^3-233/32*ep^4+
  361/64*ep^5;
fill mncT10(2,5) =
  -23/4-3/2*ep^-1+89/12*ep+457/9*ep^2+1487/27*ep^3+700/81*ep^4
  -700/243*ep^5;
fill mncT10(2,6) =
  -71/10-3/2*ep^-1+511/240*ep+164303/2880*ep^2+3505459/34560*
  ep^3+25651559/414720*ep^4+8078735/995328*ep^5;
fill mncT10(2,7) =
  -41/5-3/2*ep^-1-1263/400*ep+465987/8000*ep^2+22952577/160000*
  ep^3+445571067/3200000*ep^4+3730168857/64000000*ep^5;
fill mncT10(2,8) =
  -639/70-3/2*ep^-1-23221/2800*ep+9404347/168000*ep^2+1808749211/
  10080000*ep^3+139327252843/604800000*ep^4+5435434915259/36288000000*
  ep^5;
fill mncT10(2,9) =
  -2781/280-3/2*ep^-1-259297/19600*ep+52749191/1029000*ep^2+
  45208808453/216090000*ep^3+3723811897181/11344725000*ep^4+
  663357839735273/2382392250000*ep^5;
fill mncT10(2,10) =
  -4469/420-3/2*ep^-1-4223269/235200*ep+8846797177/197568000*ep^2
  +38689293302239/165957120000*ep^3+59709391783310473/139403980800000*
  ep^4+51332799820998824911/117099343872000000*ep^5;
fill mncT10(3,1) =
  -3/4+27/8*ep-75/16*ep^2+171/32*ep^3-363/64*ep^4+747/128*ep^5
  ;
fill mncT10(3,2) =
  3/4-3/2*ep^-1+105/8*ep-105/16*ep^2+105/32*ep^3-105/64*ep^4+
  105/128*ep^5;
fill mncT10(3,3) =
  -3-9/2*ep^-1+171/4*ep+201/8*ep^2-297/16*ep^3+489/32*ep^4-
  873/64*ep^5;
fill mncT10(3,4) =
  -15-9*ep^-1+159/2*ep+543/4*ep^2+105/8*ep^3-105/16*ep^4+105/
  32*ep^5;
fill mncT10(3,5) =
  -149/4-15*ep^-1+335/3*ep+24041/72*ep^2+90941/432*ep^3+30905/
  2592*ep^4-70315/15552*ep^5;
fill mncT10(3,6) =
  -285/4-45/2*ep^-1+10293/80*ep+196431/320*ep^2+169797/256*ep^3
  +1264407/5120*ep^4+46389/4096*ep^5;
fill mncT10(3,7) =
  -591/5-63/2*ep^-1+48357/400*ep+7699887/8000*ep^2+229927077/
  160000*ep^3+2914218567/3200000*ep^4+15233331357/64000000*ep^5;
fill mncT10(3,8) =
  -1791/10-42*ep^-1+27859/350*ep+7153343/5250*ep^2+101471723/
  39375*ep^3+5250487699/2362500*ep^4+69188808181/70875000*ep^5;
fill mncT10(3,9) =
  -35673/140-54*ep^-1-64347/19600*ep+153855913/85750*ep^2+
  296173542391/72030000*ep^3+33238587150539/7563150000*ep^4+
  4145231326795487/1588261500000*ep^5;
fill mncT10(3,10) =
  -4845/14-135/2*ep^-1-2120191/15680*ep+392726021/175616*ep^2+
  893381947379/147517440*ep^3+189024874192657/24782929920*ep^4+
  23238823471233947/4163532226560*ep^5;
fill mncT10(4,1) =
  -1/4+11/24*ep+239/144*ep^2-2989/864*ep^3+23879/5184*ep^4-
  163669/31104*ep^5;
fill mncT10(4,2) =
  -1/2-3/2*ep^-1+173/12*ep+257/72*ep^2-3187/432*ep^3+19577/
  2592*ep^4-109867/15552*ep^5;
fill mncT10(4,3) =
  -15/2-9*ep^-1+85*ep+194/3*ep^2-302/9*ep^3+626/27*ep^4-1598/
  81*ep^5;
fill mncT10(4,4) =
  -89/2-30*ep^-1+1607/6*ep+14399/36*ep^2+4547/216*ep^3+3623/
  1296*ep^4-92053/7776*ep^5;
fill mncT10(4,5) =
  -625/4-75*ep^-1+3617/6*ep+100921/72*ep^2+281917/432*ep^3+
  99961/2592*ep^4-395051/15552*ep^5;
fill mncT10(4,6) =
  -825/2-315/2*ep^-1+87101/80*ep+3474373/960*ep^2+34090769/11520
  *ep^3+115905997/138240*ep^4-1176443/331776*ep^5;
fill mncT10(4,7) =
  -9107/10-294*ep^-1+498149/300*ep+34741013/4500*ep^2+296389693/
  33750*ep^3+1083612773/253125*ep^4+3003598556/3796875*ep^5;
fill mncT10(4,8) =
  -8891/5-504*ep^-1+4553953/2100*ep+454960141/31500*ep^2+
  4911347351/236250*ep^3+14142455467/1012500*ep^4+992017228511/
  212625000*ep^5;
fill mncT10(4,9) =
  -88875/28-810*ep^-1+9252927/3920*ep+168366909/6860*ep^2+
  8166579979/192080*ep^3+144167672767/4033680*ep^4+562192184635/
  33882912*ep^5;
fill mncT10(4,10) =
  -148145/28-2475/2*ep^-1+5844233/3136*ep+102041943371/2634240*
  ep^2+34685940027097/442552320*ep^3+5810307829273907/74348789760*ep^4
  +567484189539766993/12490596679680*ep^5;
fill mncT10(5,1) =
  -1/8+7/96*ep+1331/1152*ep^2-10697/13824*ep^3-16261/165888*ep^4
  +1688527/1990656*ep^5;
fill mncT10(5,2) =
  -11/8-3/2*ep^-1+1385/96*ep+13765/1152*ep^2-112975/13824*ep^3
  +625645/165888*ep^4-3023815/1990656*ep^5;
fill mncT10(5,3) =
  -16-15*ep^-1+3359/24*ep+40699/288*ep^2-146353/3456*ep^3+
  909331/41472*ep^4-9088057/497664*ep^5;
fill mncT10(5,4) =
  -225/2-75*ep^-1+5331/8*ep+32337/32*ep^2+10551/128*ep^3+6201/
  512*ep^4-76569/2048*ep^5;
fill mncT10(5,5) =
  -1025/2-525/2*ep^-1+103501/48*ep+2646365/576*ep^2+12919849/
  6912*ep^3+12547205/82944*ep^4-106259855/995328*ep^5;
fill mncT10(5,6) =
  -1750-735*ep^-1+650707/120*ep+22250591/1440*ep^2+185708083/
  17280*ep^3+552944999/207360*ep^4-58423921/497664*ep^5;
fill mncT10(5,7) =
  -49007/10-1764*ep^-1+850421/75*ep+760299527/18000*ep^2+
  43823276051/1080000*ep^3+1087265701763/64800000*ep^4+9074623643219/
  3888000000*ep^5;
fill mncT10(5,8) =
  -23775/2-3780*ep^-1+2859667/140*ep+23847883/240*ep^2+
  2424900241/20160*ep^3+16526858893/241920*ep^4+7708831711/414720*ep^5
  ;
fill mncT10(5,9) =
  -1448565/56-7425*ep^-1+12607711/392*ep+68703347107/329280*ep^2
  +8372383405609/27659520*ep^3+500539948415827/2323399680*ep^4+
  16253187395221297/195165573120*ep^5;
fill mncT10(5,10) =
  -2895365/56-27225/2*ep^-1+137893873/3136*ep+351913867217/878080*
  ep^2+6644184374413/9834496*ep^3+1574369597037737/2753658880*ep^4+
  8634850111386637/30840979456*ep^5;
fill mncT10(6,1) =
  -3/40-13/800*ep+35531/48000*ep^2+233003/2880000*ep^3-93186661/
  172800000*ep^4+5785099307/10368000000*ep^5;
fill mncT10(6,2) =
  -41/20-3/2*ep^-1+16777/1200*ep+1335301/72000*ep^2-19367987/
  4320000*ep^3-196568531/259200000*ep^4+20928087997/15552000000*ep^5;
fill mncT10(6,3) =
  -117/4-45/2*ep^-1+16461/80*ep+419211/1600*ep^2-885519/32000*
  ep^3+5867451/640000*ep^4-167036679/12800000*ep^5;
fill mncT10(6,4) =
  -999/4-315/2*ep^-1+110547/80*ep+3592917/1600*ep^2+10569807/
  32000*ep^3+5651397/640000*ep^4-934558713/12800000*ep^5;
fill mncT10(6,5) =
  -5677/4-735*ep^-1+181561/30*ep+22883293/1800*ep^2+275706917/
  54000*ep^3+823074373/1620000*ep^4-15404524363/48600000*ep^5;
fill mncT10(6,6) =
  -120561/20-2646*ep^-1+4004489/200*ep+640164857/12000*ep^2+
  24618330341/720000*ep^3+348715791533/43200000*ep^4-1386850102771/
  2592000000*ep^5;
fill mncT10(6,7) =
  -414603/20-7938*ep^-1+10807857/200*ep+720254637/4000*ep^2+
  12473875827/80000*ep^3+93453599817/1600000*ep^4+206943175107/
  32000000*ep^5;
fill mncT10(6,8) =
  -243381/4-20790*ep^-1+34826081/280*ep+8670420679/16800*ep^2+
  561756327107/1008000*ep^3+17090170665691/60480000*ep^4+
  238855334385083/3628800000*ep^5;
fill mncT10(6,9) =
  -8845353/56-49005*ep^-1+61371918/245*ep+715102622253/548800*ep^2
  +128719613722761/76832000*ep^3+11393633670678117/10756480000*ep^4+
  536420721540120849/1505907200000*ep^5;
fill mncT10(6,10) =
  -10411467/28-212355/2*ep^-1+7007897301/15680*ep+13054357748157/
  4390400*ep^2+5432640205465833/1229312000*ep^3+1141773110158691877/
  344207360000*ep^4+137203192797278262513/96378060800000*ep^5;
fill mncT10(7,1) =
  -1/20-1/25*ep+17713/36000*ep^2+82091/240000*ep^3-48738953/
  129600000*ep^4+427746437/2592000000*ep^5;
fill mncT10(7,2) =
  -13/5-3/2*ep^-1+16009/1200*ep+1713467/72000*ep^2+5388271/
  4320000*ep^3-914192377/259200000*ep^4+25764655399/15552000000*ep^5;
fill mncT10(7,3) =
  -957/20-63/2*ep^-1+112243/400*ep+10355459/24000*ep^2+39466867/
  1440000*ep^3-820748029/86400000*ep^4-52688239277/5184000000*ep^5;
fill mncT10(7,4) =
  -4991/10-294*ep^-1+760201/300*ep+40405069/9000*ep^2+276581461/
  270000*ep^3+34098109/8100000*ep^4-31522116779/243000000*ep^5;
fill mncT10(7,5) =
  -34601/10-1764*ep^-1+2884389/200*ep+557280473/18000*ep^2+
  2372481179/180000*ep^3+25064318153/16200000*ep^4-124218058181/
  162000000*ep^5;
fill mncT10(7,6) =
  -356391/20-7938*ep^-1+302601/5*ep+25242353/160*ep^2+189122879/
  1920*ep^3+535864919/23040*ep^4-88343129/55296*ep^5;
fill mncT10(7,7) =
  -1470819/20-29106*ep^-1+40709357/200*ep+7693396111/12000*ep^2+
  377114820443/720000*ep^3+8039414975059/43200000*ep^4+45909374983667/
  2592000000*ep^5;
fill mncT10(7,8) =
  -2560767/10-91476*ep^-1+403678357/700*ep+91955041481/42000*ep^2
  +5533074324853/2520000*ep^3+156314232405389/151200000*ep^4+
  1952097820330957/9072000000*ep^5;
fill mncT10(7,9) =
  -109180863/140-254826*ep^-1+27831938271/19600*ep+4471028447173/
  686000*ep^2+1110743856904309/144060000*ep^3+135627586834713397/
  30252600000*ep^4+8622826680259950451/6353046000000*ep^5;
fill mncT10(7,10) =
  -10657361/5-1288287/2*ep^-1+104096074001/33600*ep+70010581183721/
  4032000*ep^2+11415336636644921/483840000*ep^3+941071217126100521/
  58060800000*ep^4+43764869471914228121/6967296000000*ep^5;
fill mncT10(8,1) =
  -1/28-11/245*ep+841441/2469600*ep^2+140549527/345744000*ep^3-
  78460581929/435637440000*ep^4-119057887957/6776582400000*ep^5;
fill mncT10(8,2) =
  -429/140-3/2*ep^-1+741721/58800*ep+76963479/2744000*ep^2+
  81887763001/10372320000*ep^3-6160336923403/1452124800000*ep^4+
  1295154979900681/1829677248000000*ep^5;
fill mncT10(8,3) =
  -723/10-42*ep^-1+190459/525*ep+3999879/6125*ep^2+1606404113/
  11576250*ep^3-18966571957/810337500*ep^4-6990546924043/510512625000*
  ep^5;
fill mncT10(8,4) =
  -4583/5-504*ep^-1+2976049/700*ep+3633118901/441000*ep^2+
  26640129587/10290000*ep^3+1404226137989/19448100000*ep^4-
  312289819072471/1361367000000*ep^5;
fill mncT10(8,5) =
  -15261/2-3780*ep^-1+1708635/56*ep+160324043/2352*ep^2+
  1046272427/32928*ep^3+18358712195/4148928*ep^4-10404645445/6453888*
  ep^5;
fill mncT10(8,6) =
  -187149/4-20790*ep^-1+44283219/280*ep+9735744713/23520*ep^2+
  34385651633/131712*ep^3+10575190295741/165957120*ep^4-1096338717877/
  309786624*ep^5;
fill mncT10(8,7) =
  -2277627/10-91476*ep^-1+226386421/350*ep+584576884757/294000*
  ep^2+195459943419287/123480000*ep^3+28591792133478017/51861600000*
  ep^4+1079869635250403447/21781872000000*ep^5;
fill mncT10(8,8) =
  -32429661/35-339768*ep^-1+10790696937/4900*ep+2046677027189/
  257250*ep^2+91578785899761/12005000*ep^3+77932951717863967/
  22689450000*ep^4+1055840020003157587/1588261500000*ep^5;
fill mncT10(8,9) =
  -457261233/140-1104246*ep^-1+126658602561/19600*ep+
  56612672242069/2058000*ep^2+1477059000503353/48020000*ep^3+
  1532380088383876441/90757800000*ep^4+30091840120792481701/
  6353046000000*ep^5;
fill mncT10(8,10) =
  -40973075/4-6441435/2*ep^-1+22478238109/1344*ep+476548217134259/
  5644800*ep^2+510156069130971413/4741632000*ep^3+
  275923509539915048291/3982970880000*ep^4+83099258828924445467237/
  3345695539200000*ep^5;
fill mncT10(9,1) =
  -3/112-1371/31360*ep+6431963/26342400*ep^2+2966087647/7375872000
  *ep^3-611577766213/18587197440000*ep^4-132891842895899/
  1734805094400000*ep^5;
fill mncT10(9,2) =
  -1941/560-3/2*ep^-1+5574893/470400*ep+1384537139/43904000*ep^2
  +4946688512957/331914240000*ep^3-290639078154967/92935987200000*ep^4
  -134149663854043507/234198687744000000*ep^5;
fill mncT10(9,3) =
  -3606/35-54*ep^-1+8832897/19600*ep+15295528679/16464000*ep^2+
  1480090671851/4609920000*ep^3-216275657823529/11616998400000*ep^4-
  79790911767110501/3252759552000000*ep^5;
fill mncT10(9,4) =
  -11007/7-810*ep^-1+5227599/784*ep+619210523/43904*ep^2+
  41651662777/7375872*ep^3+489208925459/1239146496*ep^4-81859576744847/
  208176611328*ep^5;
fill mncT10(9,5) =
  -108615/7-7425*ep^-1+92424603/1568*ep+36431450201/263424*ep^2+
  1051649748017/14751744*ep^3+88092329320049/7434878976*ep^4-
  414528826232413/138784407552*ep^5;
fill mncT10(9,6) =
  -3127311/28-49005*ep^-1+2898678549/7840*ep+433169530321/439040*
  ep^2+47397954971827/73758720*ep^3+2054240925109729/12391464960*ep^4
  -2252571502338001/416353222656*ep^5;
fill mncT10(9,7) =
  -22145607/35-254826*ep^-1+35373882351/19600*ep+30313548935039/
  5488000*ep^2+20203931885697673/4609920000*ep^3+5933616533636271311/
  3872332800000*ep^4+462091977884877380377/3252759552000000*ep^5;
fill mncT10(9,8) =
  -103963002/35-1104246*ep^-1+20313977223/2800*ep+8587525177223/
  336000*ep^2+107219196240447/4480000*ep^3+50977876717066823/
  4838400000*ep^4+380601667803088541/193536000000*ep^5;
fill mncT10(9,9) =
  -47947185/4-8281845/2*ep^-1+78174883767/3136*ep+445278263627459/
  4390400*ep^2+403289285860381253/3687936000*ep^3+
  179134080933423547571/3097866240000*ep^4+40107079404902794050197/
  2602207641600000*ep^5;
fill mncT10(9,10) =
  -85433205/2-13803075*ep^-1+117761275265/1568*ep+467167231082219/
  1317120*ep^2+95619206829958873/221276160*ep^3+9875467238318703923/
  37174394880*ep^4+561612840013743600337/6245298339840*ep^5;
fill mncT10(10,1) =
  -1/48-4913/120960*ep+54821267/304819200*ep^2+287421825007/
  768144384000*ep^3+129457437294347/1935723847680000*ep^4-
  380383365844061513/4878024096153600000*ep^5;
fill mncT10(10,2) =
  -3209/840-3/2*ep^-1+23449001/2116800*ep+183663936121/5334336000*
  ep^2+295519349213141/13442526720000*ep^3-16723146461182439/
  33875167334400000*ep^4-139225311874684347619/85365421682688000000*ep^5
  ;
fill mncT10(10,3) =
  -7863/56-135/2*ep^-1+5105869/9408*ep+5979475273/4741632*ep^2+
  1404672849793/2389782528*ep^3+25182200308273/1204450394112*ep^4-
  24400676646773807/607042998632448*ep^5;
fill mncT10(10,4) =
  -142895/56-2475/2*ep^-1+279921139/28224*ep+324527671543/14224896
  *ep^2+79228822515679/7169347584*ep^3+4736815497678319/3613351182336*
  ep^4-1128953117831145521/1821128995897344*ep^5;
fill mncT10(10,5) =
  -1652695/56-27225/2*ep^-1+2991229469/28224*ep+3731016922625/
  14224896*ep^2+1070807836572329/7169347584*ep^3+106428276085837625/
  3613351182336*ep^4-8696857836147578215/1821128995897344*ep^5;
fill mncT10(10,6) =
  -13805781/56-212355/2*ep^-1+37220066537/47040*ep+51518379298877/
  23708160*ep^2+17681366933446277/11948912640*ep^3+2462941888380796757/
  6022251970560*ep^4-1155889915078838159/607042998632448*ep^5;
fill mncT10(10,7) =
  -64298663/40-1288287/2*ep^-1+65399895179/14400*ep+72673731308677/
  5184000*ep^2+21008503589356631/1866240000*ep^3+2699732995940530693/
  671846400000*ep^4+98615194279443444479/241864704000000*ep^5;
fill mncT10(10,8) =
  -68961035/8-6441435/2*ep^-1+85716427777/4032*ep+538624877659483/
  7257600*ep^2+180099386375368169/2612736000*ep^3+28379320048858941307/
  940584960000*ep^4+1897053674504596395521/338610585600000*ep^5;
fill mncT10(10,9) =
  -315660345/8-13803075*ep^-1+99248819645/1176*ep+991879090289449/
  2963520*ep^2+263813554159185809/746807040*ep^3+34403361676341944641/
  188195374080*ep^4+2243502897931080551873/47425234268160*ep^5;
fill mncT10(10,10) =
  -3802934135/24-52144950*ep^-1+12362003265215/42336*ep+
  141030167154691039/106686720*ep^2+16799338215122256935/10754021376*
  ep^3+25215345288750461743819/27100133867520*ep^4+
  826552886737401492355103/2731693493846016*ep^5;
fill mncT20(-6,1) =
  -1/84-23/980*ep-5843/154350*ep^2-453806/8103375*ep^3-67430704/
  850854375*ep^4-9775819136/89339709375*ep^5;
fill mncT20(-6,2) =
  -73/105-2/3*ep^-1-11492/11025*ep-1677703/1157625*ep^2-
  240693302/121550625*ep^3-34187537368/12762815625*ep^4-4827576638912/
  1340095640625*ep^5;
fill mncT20(-6,3) =
  72/5-14*ep^-1-3697/150*ep+30361/2250*ep^2-484709/16875*ep^3+
  2108492/253125*ep^4-135135596/3796875*ep^5;
fill mncT20(-6,4) =
  587/3-70*ep^-1-5104/15*ep+95062/225*ep^2-3304937/6750*ep^3+
  100310887/202500*ep^4-3255229337/6075000*ep^5;
fill mncT20(-6,5) =
  3275/6-350/3*ep^-1-47683/36*ep+79933/36*ep^2-968071/324*ep^3+
  757925/216*ep^4-44696575/11664*ep^5;
fill mncT20(-6,6) =
  485-70*ep^-1-49229/30*ep+439127/120*ep^2-26640239/4320*ep^3+
  49332629/5760*ep^4-1299375595/124416*ep^5;
fill mncT20(-6,7) =
  2092/15-14*ep^-1-16473/25*ep+17887891/9000*ep^2-2354883317/
  540000*ep^3+244404539179/32400000*ep^4-21223511520773/1944000000*
  ep^5;
fill mncT20(-6,8) =
  353/35-2/3*ep^-1-31619/450*ep+303089/1000*ep^2-1489855661/
  1620000*ep^3+68644660769/32400000*ep^4-22832247383309/5832000000*
  ep^5;
fill mncT20(-6,9) =
  1/28-1349/1960*ep+2479361/411600*ep^2-1852848323/57624000*ep^3+
  8626260284921/72606240000*ep^4-3329436346797163/10164873600000*ep^5;
fill mncT20(-6,10) =
  1/504*ep-4591/141120*ep^2+26553911/118540800*ep^3-26897921381/
  33191424000*ep^4+112312437169799/83642388480000*ep^5;
fill mncT20(-5,1) =
  -1/63-379/13230*ep-30823/694575*ep^2-4683932/72930375*ep^3-
  687208288/7657689375*ep^4-98880776192/804057384375*ep^5;
fill mncT20(-5,2) =
  -22/45-2/3*ep^-1-1033/1350*ep-10573/10125*ep^2-214376/151875*
  ep^3-4322512/2278125*ep^4-86870144/34171875*ep^5;
fill mncT20(-5,3) =
  46/3-10*ep^-1-1937/90*ep+11788/675*ep^2-236794/10125*ep^3+
  2350972/151875*ep^4-59300836/2278125*ep^5;
fill mncT20(-5,4) =
  1075/9-100/3*ep^-1-12457/54*ep+25549/81*ep^2-179305/486*ep^3+
  1142575/2916*ep^4-7163485/17496*ep^5;
fill mncT20(-5,5) =
  1775/9-100/3*ep^-1-30707/54*ep+175897/162*ep^2-773903/486*ep^3
  +5761805/2916*ep^4-38852975/17496*ep^5;
fill mncT20(-5,6) =
  90-10*ep^-1-5711/15*ep+368137/360*ep^2-8629087/4320*ep^3+
  160556317/51840*ep^4-507053099/124416*ep^5;
fill mncT20(-5,7) =
  142/15-2/3*ep^-1-13787/225*ep+6570173/27000*ep^2-1093489951/
  1620000*ep^3+137668367537/97200000*ep^4-13917130212319/5832000000*
  ep^5;
fill mncT20(-5,8) =
  1/21-551/630*ep+136597/18900*ep^2-40929769/1134000*ep^3+
  8420292103/68040000*ep^4-1284520788361/4082400000*ep^5;
fill mncT20(-5,9) =
  1/294*ep-3257/61740*ep^2+4361053/12965400*ep^3-5867075167/
  5445468000*ep^4+2880118282903/2287096560000*ep^5;
fill mncT20(-5,10) =
  1/10584*ep-8513/8890560*ep^2+14714953/7468070400*ep^3+77922221551/
  6273179136000*ep^4-395835392153543/5269470474240000*ep^5;
fill mncT20(-4,1) =
  -1/45-49/1350*ep-544/10125*ep^2-11528/151875*ep^3-238336/
  2278125*ep^4-4860032/34171875*ep^5;
fill mncT20(-4,2) =
  -11/45-2/3*ep^-1-337/675*ep-6794/10125*ep^2-136528/151875*ep^3
  -2738336/2278125*ep^4-54860032/34171875*ep^5;
fill mncT20(-4,3) =
  131/9-20/3*ep^-1-1067/54*ep+1565/81*ep^2-5080/243*ep^3+13700/
  729*ep^4-47260/2187*ep^5;
fill mncT20(-4,4) =
  562/9-40/3*ep^-1-3842/27*ep+17653/81*ep^2-130045/486*ep^3+
  856255/2916*ep^4-5371645/17496*ep^5;
fill mncT20(-4,5) =
  157/3-20/3*ep^-1-3427/18*ep+23569/54*ep^2-59156/81*ep^3+479815/
  486*ep^4-3400565/2916*ep^5;
fill mncT20(-4,6) =
  131/15-2/3*ep^-1-925/18*ep+39547/216*ep^2-1169689/2592*ep^3+
  130416407/155520*ep^4-469580545/373248*ep^5;
fill mncT20(-4,7) =
  1/15-173/150*ep+39883/4500*ep^2-10971971/270000*ep^3+2049129277/
  16200000*ep^4-281553155699/972000000*ep^5;
fill mncT20(-4,8) =
  2/315*ep-62/675*ep^2+75109/141750*ep^3-12130183/8505000*ep^4+
  49117903/72900000*ep^5;
fill mncT20(-4,9) =
  1/4410*ep-1913/926100*ep^2+493441/194481000*ep^3+2703618881/
  81682020000*ep^4-5052527519129/34306448400000*ep^5;
fill mncT20(-4,10) =
  1/52920*ep-5237/44452800*ep^2-9426899/37340352000*ep^3+96602667307/
  31365895680000*ep^4-104343711700451/26347352371200000*ep^5;
fill mncT20(-3,1) =
  -1/30-11/225*ep-232/3375*ep^2-4784/50625*ep^3-97408/759375*
  ep^4-1968896/11390625*ep^5;
fill mncT20(-3,2) =
  1/18-2/3*ep^-1-7/27*ep-28/81*ep^2-112/243*ep^3-448/729*ep^4-
  1792/2187*ep^5;
fill mncT20(-3,3) =
  37/3-4*ep^-1-167/9*ep+538/27*ep^2-1628/81*ep^3+4828/243*ep^4
  -14708/729*ep^5;
fill mncT20(-3,4) =
  77/3-4*ep^-1-223/3*ep+403/3*ep^2-1085/6*ep^3+2485/12*ep^4-
  5285/24*ep^5;
fill mncT20(-3,5) =
  47/6-2/3*ep^-1-727/18*ep+6667/54*ep^2-83453/324*ep^3+788095/
  1944*ep^4-6126365/11664*ep^5;
fill mncT20(-3,6) =
  1/10-8/5*ep+1339/120*ep^2-65581/1440*ep^3+2144431/17280*ep^4-
  10217753/41472*ep^5;
fill mncT20(-3,7) =
  1/75*ep-22/125*ep^2+19867/22500*ep^3-2410529/1350000*ep^4-
  106376777/81000000*ep^5;
fill mncT20(-3,8) =
  1/1575*ep-118/23625*ep^2+841/1417500*ep^3+8151533/85050000*ep^4-
  1499687771/5103000000*ep^5;
fill mncT20(-3,9) =
  1/14700*ep-263/771750*ep^2-879791/648270000*ep^3+2609273819/
  272273400000*ep^4-219838700171/114354828000000*ep^5;
fill mncT20(-3,10) =
  1/88200*ep-2563/74088000*ep^2-20465941/62233920000*ep^3+
  58042373213/52276492800000*ep^4+116022719392091/43912253952000000*ep^5
  ;
fill mncT20(-2,1) =
  -1/18-2/27*ep-8/81*ep^2-32/243*ep^3-128/729*ep^4-512/2187*
  ep^5;
fill mncT20(-2,2) =
  4/9-2/3*ep^-1-2/27*ep-8/81*ep^2-32/243*ep^3-128/729*ep^4-512/
  2187*ep^5;
fill mncT20(-2,3) =
  9-2*ep^-1-17*ep+20*ep^2-20*ep^3+20*ep^4-20*ep^5;
fill mncT20(-2,4) =
  20/3-2/3*ep^-1-28*ep+67*ep^2-215/2*ep^3+535/4*ep^4-1175/8*
  ep^5;
fill mncT20(-2,5) =
  1/6-43/18*ep+781/54*ep^2-16061/324*ep^3+214615/1944*ep^4-
  2073125/11664*ep^5;
fill mncT20(-2,6) =
  1/30*ep-139/360*ep^2+6721/4320*ep^3-84259/51840*ep^4-902827/
  124416*ep^5;
fill mncT20(-2,7) =
  1/450*ep-377/27000*ep^2-35201/1620000*ep^3+30326287/97200000*ep^4
  -3031593569/5832000000*ep^5;
fill mncT20(-2,8) =
  1/3150*ep-23/21000*ep^2-93791/11340000*ep^3+7404539/226800000*ep^4
  +1951554721/40824000000*ep^5;
fill mncT20(-2,9) =
  1/14700*ep-317/3087000*ep^2-2824597/1296540000*ep^3+1840664773/
  544546800000*ep^4+5160486513443/228709656000000*ep^5;
fill mncT20(-2,10) =
  1/52920*ep-29/44452800*ep^2-23874563/37340352000*ep^3+1050578059/
  31365895680000*ep^4+195040341925213/26347352371200000*ep^5;
fill mncT20(-1,1) =
  -1/9-4/27*ep-16/81*ep^2-64/243*ep^3-256/729*ep^4-1024/2187*
  ep^5;
fill mncT20(-1,2) =
  1-2/3*ep^-1;
fill mncT20(-1,3) =
  5-2/3*ep^-1-14*ep+20*ep^2-20*ep^3+20*ep^4-20*ep^5;
fill mncT20(-1,4) =
  1/3-4*ep+19*ep^2-95/2*ep^3+295/4*ep^4-695/8*ep^5;
fill mncT20(-1,5) =
  1/9*ep-28/27*ep^2+217/81*ep^3+1105/486*ep^4-69035/2916*ep^5;
fill mncT20(-1,6) =
  1/90*ep-49/1080*ep^2-2909/12960*ep^3+176471/155520*ep^4+77183/
  373248*ep^5;
fill mncT20(-1,7) =
  1/450*ep-77/27000*ep^2-108701/1620000*ep^3+8508787/97200000*ep^4
  +3586068931/5832000000*ep^5;
fill mncT20(-1,8) =
  1/1575*ep+19/47250*ep^2-57553/2835000*ep^3-2102489/170100000*ep^4
  +2150196743/10206000000*ep^5;
fill mncT20(-1,9) =
  1/4410*ep+439/926100*ep^2-2704141/388962000*ep^3-2439933731/
  163364040000*ep^4+4525924032779/68612896800000*ep^5;
fill mncT20(-1,10) =
  1/10584*ep+2743/8890560*ep^2-19721351/7468070400*ep^3-60095960177/
  6273179136000*ep^4+102403388672761/5269470474240000*ep^5;
fill mncT20(0,1) =
  -1/3-2/3*ep-4/3*ep^2-8/3*ep^3-16/3*ep^4-32/3*ep^5;
fill mncT20(0,2) =
  2-2/3*ep^-1;
fill mncT20(0,3) =
  1-8*ep+20*ep^2-20*ep^3+20*ep^4-20*ep^5;
fill mncT20(0,4) =
  2/3*ep-11/3*ep^2-5/6*ep^3+325/12*ep^4-965/24*ep^5;
fill mncT20(0,5) =
  1/9*ep-1/27*ep^2-457/162*ep^3+995/972*ep^4+98855/5832*ep^5;
fill mncT20(0,6) =
  1/30*ep+29/360*ep^2-3599/4320*ep^3-106051/51840*ep^4+600341/
  124416*ep^5;
fill mncT20(0,7) =
  1/75*ep+43/750*ep^2-11891/45000*ep^3-3854183/2700000*ep^4+
  28768321/162000000*ep^5;
fill mncT20(0,8) =
  2/315*ep+172/4725*ep^2-23929/283500*ep^3-14469227/17010000*ep^4-
  956061151/1020600000*ep^5;
fill mncT20(0,9) =
  1/294*ep+1447/61740*ep^2-566677/25930800*ep^3-5484186467/
  10890936000*ep^4-4758952611397/4574193120000*ep^5;
fill mncT20(0,10) =
  1/504*ep+2201/141120*ep^2+99943/118540800*ep^3-10086927493/
  33191424000*ep^4-74798499514553/83642388480000*ep^5;
fill mncT20(1,1) =
  1/3*ep^-1;
fill mncT20(1,2) =
  4-ep^-1;
fill mncT20(1,3) =
  -2+4*ep+20*ep^2-20*ep^3+20*ep^4-20*ep^5;
fill mncT20(1,4) =
  -2/3-2*ep+11*ep^2+65/2*ep^3-25/4*ep^4-55/8*ep^5;
fill mncT20(1,5) =
  -1/3-17/9*ep+133/54*ep^2+9697/324*ep^3+90685/1944*ep^4+48265/
  11664*ep^5;
fill mncT20(1,6) =
  -1/5-3/2*ep-17/24*ep^2+5783/288*ep^3+1068911/17280*ep^4+
  2624615/41472*ep^5;
fill mncT20(1,7) =
  -2/15-89/75*ep-8617/4500*ep^2+3351779/270000*ep^3+970238027/
  16200000*ep^4+101308463051/972000000*ep^5;
fill mncT20(1,8) =
  -2/21-43/45*ep-6341/2700*ep^2+1156907/162000*ep^3+510974491/
  9720000*ep^4+72810365483/583200000*ep^5;
fill mncT20(1,9) =
  -1/14-769/980*ep-1010321/411600*ep^2+205879523/57624000*ep^3+
  3214970899279/72606240000*ep^4+1341980656664563/10164873600000*ep^5;
fill mncT20(1,10) =
  -1/18-551/840*ep-5115629/2116800*ep^2+75291971/65856000*ep^3+
  54543220808719/1493614080000*ep^4+54914876768924611/418211942400000*
  ep^5;
fill mncT20(2,1) =
  2-1/3*ep^-1-4*ep+8*ep^2-16*ep^3+32*ep^4-64*ep^5;
fill mncT20(2,2) =
  4-4/3*ep^-1+8*ep-16*ep^2+32*ep^3-64*ep^4+128*ep^5;
fill mncT20(2,3) =
  -2-4/3*ep^-1+24*ep+28*ep^2-36*ep^3+52*ep^4-84*ep^5;
fill mncT20(2,4) =
  -16/3-4/3*ep^-1+18*ep+87*ep^2+105/2*ep^3-105/4*ep^4+105/8*
  ep^5;
fill mncT20(2,5) =
  -23/3-4/3*ep^-1+73/9*ep+6289/54*ep^2+68989/324*ep^3+192745/
  1944*ep^4-257915/11664*ep^5;
fill mncT20(2,6) =
  -142/15-4/3*ep^-1-233/90*ep+135527/1080*ep^2+4831027/12960*
  ep^3+64777463/155520*ep^4+59776703/373248*ep^5;
fill mncT20(2,7) =
  -164/15-4/3*ep^-1-5959/450*ep+3266573/27000*ep^2+827279549/
  1620000*ep^3+82540045037/97200000*ep^4+3971016625181/5832000000*ep^5
  ;
fill mncT20(2,8) =
  -426/35-4/3*ep^-1-74243/3150*ep+2252989/21000*ep^2+7047906613/
  11340000*ep^3+303789722423/226800000*ep^4+62608258173397/40824000000
  *ep^5;
fill mncT20(2,9) =
  -927/70-4/3*ep^-1-1476577/44100*ep+179362247/2058000*ep^2+
  5488605605993/7779240000*ep^3+2014683523898821/1089093600000*ep^4+
  3664245722376390233/1372257936000000*ep^5;
fill mncT20(2,10) =
  -4469/315-4/3*ep^-1-3789689/88200*ep+4624227637/74088000*ep^2+
  47595938660059/62233920000*ep^3+123202774990297213/52276492800000*ep^4
  +177176618299181880091/43912253952000000*ep^5;
fill mncT20(3,1) =
  -2/3+14/3*ep-38/3*ep^2+86/3*ep^3-182/3*ep^4+374/3*ep^5;
fill mncT20(3,2) =
  2-4/3*ep^-1+18*ep-26*ep^2+42*ep^3-74*ep^4+138*ep^5;
fill mncT20(3,3) =
  -2-4*ep^-1+66*ep+30*ep^2-30*ep^3+30*ep^4-30*ep^5;
fill mncT20(3,4) =
  -50/3-8*ep^-1+124*ep+269*ep^2+125/2*ep^3-145/4*ep^4+185/8*
  ep^5;
fill mncT20(3,5) =
  -134/3-40/3*ep^-1+1522/9*ep+19061/27*ep^2+115049/162*ep^3+
  134645/972*ep^4-243775/5832*ep^5;
fill mncT20(3,6) =
  -88-20*ep^-1+5417/30*ep+474037/360*ep^2+9565217/4320*ep^3+
  75824797/51840*ep^4+33326293/124416*ep^5;
fill mncT20(3,7) =
  -2224/15-28*ep^-1+20927/150*ep+18515191/9000*ep^2+2581018183/
  540000*ep^3+162439806679/32400000*ep^4+4861399866727/1944000000*ep^5
  ;
fill mncT20(3,8) =
  -1134/5-112/3*ep^-1+45233/1575*ep+4307843/1500*ep^2+
  48365901917/5670000*ep^3+1347457264207/113400000*ep^4+26378646127739/
  2916000000*ep^5;
fill mncT20(3,9) =
  -11366/35-48*ep^-1-205412/1225*ep+1902910333/514500*ep^2+
  2921999991203/216090000*ep^3+2096541650905573/90757800000*ep^4+
  872516058420356243/38118276000000*ep^5;
fill mncT20(3,10) =
  -9305/21-60*ep^-1-1638433/3528*ep+7361205209/1646400*ep^2+
  81972708321109/4148928000*ep^3+138028550387269363/3485099520000*ep^4
  +138795980231409673141/2927483596800000*ep^5;
fill mncT20(4,1) =
  -2/9+22/27*ep+118/81*ep^2-2018/243*ep^3+17158/729*ep^4-
  120338/2187*ep^5;
fill mncT20(4,2) =
  8/9-4/3*ep^-1+560/27*ep-1120/81*ep^2+2240/243*ep^3-4480/729*
  ep^4+8960/2187*ep^5;
fill mncT20(4,3) =
  -10/3-8*ep^-1+1178/9*ep+1370/27*ep^2-3550/81*ep^3+9530/243*
  ep^4-26350/729*ep^5;
fill mncT20(4,4) =
  -364/9-80/3*ep^-1+11414/27*ep+52583/81*ep^2+29995/486*ep^3-
  94465/2916*ep^4+301315/17496*ep^5;
fill mncT20(4,5) =
  -1490/9-200/3*ep^-1+25756/27*ep+213712/81*ep^2+439192/243*ep^3
  +121240/729*ep^4-122360/2187*ep^5;
fill mncT20(4,6) =
  -466-140*ep^-1+50969/30*ep+2595829/360*ep^2+37296929/4320*ep^3
  +203776669/51840*ep^4+45626581/124416*ep^5;
fill mncT20(4,7) =
  -15974/15-784/3*ep^-1+563653/225*ep+212948149/13500*ep^2+
  21367432837/810000*ep^3+981651206581/48600000*ep^4+20536825751653/
  2916000000*ep^5;
fill mncT20(4,8) =
  -31864/15-448*ep^-1+4807756/1575*ep+704184707/23625*ep^2+
  90017249191/1417500*ep^3+5633202721583/85050000*ep^4+190987510132879/
  5103000000*ep^5;
fill mncT20(4,9) =
  -26930/7-720*ep^-1+414236/147*ep+15650506589/308700*ep^2+
  17001990837739/129654000*ep^3+9261629868042749/54454680000*ep^4+
  2943607325873278459/22870965600000*ep^5;
fill mncT20(4,10) =
  -408245/63-1100*ep^-1+11019805/10584*ep+707513577751/8890560*
  ep^2+1814527882945273/7468070400*ep^3+2338002817201507471/
  6273179136000*ep^4+1826951548514338306297/5269470474240000*ep^5;
fill mncT20(5,1) =
  -1/9+13/54*ep+461/324*ep^2-6623/1944*ep^3+60269/11664*ep^4-
  459047/69984*ep^5;
fill mncT20(5,2) =
  1/9-4/3*ep^-1+1175/54*ep-785/324*ep^2-11845/1944*ep^3+111775/
  11664*ep^4-756925/69984*ep^5;
fill mncT20(5,3) =
  -62/9-40/3*ep^-1+5893/27*ep+17225/162*ep^2-73355/972*ep^3+
  345665/5832*ep^4-1772675/34992*ep^5;
fill mncT20(5,4) =
  -790/9-200/3*ep^-1+28721/27*ep+227557/162*ep^2+46625/972*ep^3
  -32195/5832*ep^4-567415/34992*ep^5;
fill mncT20(5,5) =
  -485-700/3*ep^-1+62669/18*ep+836537/108*ep^2+2614229/648*ep^3
  +872705/3888*ep^4-2444035/23328*ep^5;
fill mncT20(5,6) =
  -1813-1960/3*ep^-1+394943/45*ep+30703469/1080*ep^2+347378191/
  12960*ep^3+1441025999/155520*ep^4+151385327/373248*ep^5;
fill mncT20(5,7) =
  -80164/15-1568*ep^-1+1368386/75*ep+20352181/250*ep^2+542082151/
  5000*ep^3+6553417021/100000*ep^4+34239683791/2000000*ep^5;
fill mncT20(5,8) =
  -40180/3-3360*ep^-1+2038402/63*ep+1858182677/9450*ep^2+
  189734040541/567000*ep^3+9555153067133/34020000*ep^4+255951484910029/
  2041200000*ep^5;
fill mncT20(5,9) =
  -625915/21-6600*ep^-1+43566575/882*ep+155241292369/370440*ep^2
  +134457514968671/155584800*ep^3+59632498889714041/65345616000*ep^4
  +15336180514258890431/27445158720000*ep^5;
fill mncT20(5,10) =
  -3815020/63-12100*ep^-1+672043865/10584*ep+7209932656511/8890560
  *ep^2+14657572049878313/7468070400*ep^3+15493420641913630511/
  6273179136000*ep^4+9940372453388210088377/5269470474240000*ep^5;
fill mncT20(6,1) =
  -1/15+37/450*ep+13681/13500*ep^2-531047/405000*ep^3+10925689/
  12150000*ep^4-58905143/364500000*ep^5;
fill mncT20(6,2) =
  -22/45-4/3*ep^-1+14917/675*ep+145621/20250*ep^2-7176827/607500
  *ep^3+178762549/18225000*ep^4-3758759963/546750000*ep^5;
fill mncT20(6,3) =
  -40/3-20*ep^-1+14728/45*ep+140792/675*ep^2-1143752/10125*ep^3
  +11067512/151875*ep^4-126680072/2278125*ep^5;
fill mncT20(6,4) =
  -530/3-140*ep^-1+33557/15*ep+423607/150*ep^2+76397/1500*ep^3
  +536287/15000*ep^4-11154523/150000*ep^5;
fill mncT20(6,5) =
  -1225-1960/3*ep^-1+893521/90*ep+52848593/2700*ep^2+682276609/
  81000*ep^3+991720817/2430000*ep^4-19991371679/72900000*ep^5;
fill mncT20(6,6) =
  -5782-2352*ep^-1+1655967/50*ep+91233989/1000*ep^2+1443847463/
  20000*ep^3+8173903421/400000*ep^4+1458637007/8000000*ep^5;
fill mncT20(6,7) =
  -105938/5-7056*ep^-1+13461241/150*ep+196444423/600*ep^2+
  22085957393/60000*ep^3+222489175979/1200000*ep^4+911520869801/
  24000000*ep^5;
fill mncT20(6,8) =
  -194530/3-18480*ep^-1+26018777/126*ep+36860355869/37800*ep^2+
  3184378641517/2268000*ep^3+135220583203421/136080000*ep^4+
  2985861528034573/8164800000*ep^5;
fill mncT20(6,9) =
  -1213465/7-43560*ep^-1+60822598/147*ep+194807431393/77175*ep^2
  +71368977411709/16206750*ep^3+13453624222021897/3403417500*ep^4+
  1454776080000749701/714717675000*ep^5;
fill mncT20(6,10) =
  -8757815/21-94380*ep^-1+285953499/392*ep+86753994798313/14817600
  *ep^2+148907578338425071/12446784000*ep^3+134583634360736251897/
  10455298560000*ep^4+73478148911479794387679/8782450790400000*ep^5;
fill mncT20(7,1) =
  -2/45+17/675*ep+14621/20250*ep^2-266827/607500*ep^3-2337451/
  18225000*ep^4+292240037/546750000*ep^5;
fill mncT20(7,2) =
  -44/45-4/3*ep^-1+14924/675*ep+154756/10125*ep^2-1870036/151875
  *ep^3+13127716/2278125*ep^4-60303796/34171875*ep^5;
fill mncT20(7,3) =
  -116/5-28*ep^-1+34276/75*ep+412444/1125*ep^2-2379164/16875*
  ep^3+17847484/253125*ep^4-185697404/3796875*ep^5;
fill mncT20(7,4) =
  -1666/5-784/3*ep^-1+938503/225*ep+35955539/6750*ep^2+35076907/
  202500*ep^3+360336491/6075000*ep^4-26477428517/182250000*ep^5;
fill mncT20(7,5) =
  -13916/5-1568*ep^-1+1802036/75*ep+50033084/1125*ep^2+287204996/
  16875*ep^3+221622524/253125*ep^4-2634047644/3796875*ep^5;
fill mncT20(7,6) =
  -80066/5-7056*ep^-1+5093047/50*ep+760464367/3000*ep^2+
  31791539167/180000*ep^3+469636512367/10800000*ep^4-549658402433/
  648000000*ep^5;
fill mncT20(7,7) =
  -1064182/15-25872*ep^-1+17267879/50*ep+9947129741/9000*ep^2+
  589989515933/540000*ep^3+15486776900429/32400000*ep^4+
  153970495460477/1944000000*ep^5;
fill mncT20(7,8) =
  -3889732/15-81312*ep^-1+1550451076/1575*ep+93444165512/23625*
  ep^2+1773570582514/354375*ep^3+16430603243333/5315625*ep^4+
  154326257660627/159468750*ep^5;
fill mncT20(7,9) =
  -28622858/35-226512*ep^-1+8945694844/3675*ep+4693005624746/
  385875*ep^2+754866033770809/40516875*ep^3+124746450400539397/
  8508543750*ep^4+11669819549415577201/1786794187500*ep^5;
fill mncT20(7,10) =
  -103252721/45-572572*ep^-1+201215003399/37800*ep+
  1052670739682273/31752000*ep^2+1584389477988125111/26671680000*ep^3+
  1260115013745961428977/22404211200000*ep^4+600882741173995469811239/
  18819537408000000*ep^5;
fill mncT20(8,1) =
  -2/63+11/6615*ep+735761/1389150*ep^2-15307249/291721500*ep^3-
  20069423959/61261515000*ep^4+5172990804431/12864918150000*ep^5;
fill mncT20(8,2) =
  -146/105-4/3*ep^-1+241897/11025*ep+51352127/2315250*ep^2-
  4773167543/486202500*ep^3+121383985487/102102525000*ep^4+
  32097376872217/21441530250000*ep^5;
fill mncT20(8,3) =
  -554/15-112/3*ep^-1+955123/1575*ep+194381393/330750*ep^2-
  9944115137/69457500*ep^3+720242324633/14586075000*ep^4-
  106786845347297/3063075750000*ep^5;
fill mncT20(8,4) =
  -8888/15-448*ep^-1+1247644/175*ep+58053334/6125*ep^2+135651199/
  214375*ep^3+298200803/15006250*ep^4-231974825609/1050437500*ep^5;
fill mncT20(8,5) =
  -17476/3-3360*ep^-1+5423872/105*ep+1026210586/11025*ep^2+
  39090448813/1157625*ep^3+462912373583/243101250*ep^4-78990538402847/
  51051262500*ep^5;
fill mncT20(8,6) =
  -119554/3-18480*ep^-1+56805143/210*ep+11147568661/17640*ep^2+
  597336826967/1481760*ep^3+11261910805309/124467840*ep^4-
  7996110736781/2091059712*ep^5;
fill mncT20(8,7) =
  -3134692/15-81312*ep^-1+586429352/525*ep+180345975898/55125*ep^2
  +16981787031817/5788125*ep^3+1400937773650811/1215506250*ep^4+
  40384500100087813/255256312500*ep^5;
fill mncT20(8,8) =
  -94105352/105-302016*ep^-1+42304774636/11025*ep+15966836211554/
  1157625*ep^2+1917150465063091/121550625*ep^3+222944364852849553/
  25525631250*ep^4+12784984115109386899/5360382562500*ep^5;
fill mncT20(8,9) =
  -344915714/105-981552*ep^-1+125188224652/11025*ep+57327608405708/
  1157625*ep^2+169691073788368/2480625*ep^3+616775730790589453/
  12762815625*ep^4+25521414100086000862/1340095640625*ep^5;
fill mncT20(8,10) =
  -95522999/9-2862860*ep^-1+223988205851/7560*ep+198479962759177/
  1270080*ep^2+53777209618419011/213373440*ep^3+7693053960436534657/
  35846737920*ep^4+653914768896638272619/6022251970560*ep^5;
fill mncT20(9,1) =
  -1/42-17/1960*ep+988423/2469600*ep^2+130080361/1037232000*ep^3
  -132124778273/435637440000*ep^4+39081330520489/182967724800000*ep^5;
fill mncT20(9,2) =
  -367/210-4/3*ep^-1+1911101/88200*ep+1042101407/37044000*ep^2-
  86110890751/15558480000*ep^3-17042462394457/6534561600000*ep^4+
  7907446988034401/2744515872000000*ep^5;
fill mncT20(9,3) =
  -1922/35-48*ep^-1+1897591/2450*ep+301069579/343000*ep^2-
  4948522049/48020000*ep^3+80071131619/6722800000*ep^4-18482489761289/
  941192000000*ep^5;
fill mncT20(9,4) =
  -6998/7-720*ep^-1+16770571/1470*ep+3293023879/205800*ep^2+
  51986235451/28812000*ep^3-478953480881/4033680000*ep^4-
  174098181323789/564715200000*ep^5;
fill mncT20(9,5) =
  -239485/21-6600*ep^-1+59678963/588*ep+8999125993/49392*ep^2+
  273368291219/4148928*ep^3+1420652321425/348509952*ep^4-
  91124037255205/29274835968*ep^5;
fill mncT20(9,6) =
  -637747/7-43560*ep^-1+629646273/980*ep+119042517491/82320*ep^2
  +6030757537057/6914880*ep^3+107478921385259/580849920*ep^4-
  105005045961691/9758278656*ep^5;
fill mncT20(9,7) =
  -19467998/35-226512*ep^-1+23281533403/7350*ep+2995897232957/
  343000*ep^2+349928274306329/48020000*ep^3+17758196394663413/
  6722800000*ep^4+289303778474762561/941192000000*ep^5;
fill mncT20(9,8) =
  -41386202/15-981552*ep^-1+283630630979/22050*ep+395546421637189/
  9261000*ep^2+175501506642798899/3889620000*ep^3+37418073001064553109/
  1633640400000*ep^4+3822672350863462613219/686128968000000*ep^5;
fill mncT20(9,9) =
  -162519643/14-3680820*ep^-1+262595305811/5880*ep+87238249360337/
  493920*ep^2+9315219944358107/41489280*ep^3+101175453391617973/
  697019904*ep^4+15089495884566992579/292748359680*ep^5;
fill mncT20(9,10) =
  -1794820885/42-12269400*ep^-1+239935332475/1764*ep+
  629668364238581/987840*ep^2+156590334768924257/165957120*ep^3+
  20499084628777351687/27880796160*ep^4+315771825523270174417/
  936794750976*ep^5;
fill mncT20(10,1) =
  -1/54-899/68040*ep+26608661/85730400*ep^2+22301027281/
  108020304000*ep^3-30764322105499/136105583040000*ep^4+
  13987748932332121/171493034630400000*ep^5;
fill mncT20(10,2) =
  -1949/945-4/3*ep^-1+25400111/1190700*ep+50002245931/1500282000*
  ep^2-307591759849/1890355320000*ep^3-12413937459889229/
  2381847703200000*ep^4+8738028774226905791/3001128106032000000*ep^5;
fill mncT20(10,3) =
  -1627/21-60*ep^-1+25410289/26460*ep+41398021589/33339600*ep^2-
  190296782231/42007896000*ep^3-1878209166342451/52929948960000*ep^4-
  604812037282539071/66691735689600000*ep^5;
fill mncT20(10,4) =
  -101455/63-1100*ep^-1+275221241/15876*ep+103162952009/4000752*
  ep^2+4293929585705/1008189504*ep^3-89566560900055/254063755008*ep^4
  -27959241939151255/64024066262016*ep^5;
fill mncT20(10,5) =
  -1329680/63-12100*ep^-1+737272054/3969*ep+84298599661/250047*
  ep^2+3965429329817/31505922*ep^3+34545751893985/3969746172*ep^4-
  2913598743696175/500188017672*ep^5;
fill mncT20(10,6) =
  -4079713/21-94380*ep^-1+36973908163/26460*ep+20570227539667/
  6667920*ep^2+3033514159050163/1680315840*ep^3+157783074769647667/
  423439591680*ep^4-528901375770096745/21341355420672*ep^5;
fill mncT20(10,7) =
  -61332271/45-572572*ep^-1+459094453861/56700*ep+1531948229048633/
  71442000*ep^2+1529532469520022109/90016920000*ep^3+
  659328793858498496657/113421319200000*ep^4+84193338407945687943061/
  142910862192000000*ep^5;
fill mncT20(10,8) =
  -69552769/9-2862860*ep^-1+434310052219/11340*ep+7004672898859/
  58320*ep^2+350749945127471/2939328*ep^3+5985907366175321/105815808*
  ep^4+33984285466122253/2720977920*ep^5;
fill mncT20(10,9) =
  -1551477785/42-12269400*ep^-1+1627394154415/10584*ep+
  7543699807403531/13335840*ep^2+2260333080623120459/3360631680*ep^3+
  68488673475056100559/169375836672*ep^4+5610227992150949456143/
  42682710841344*ep^5;
fill mncT20(10,10) =
  -29016110695/189-139053200/3*ep^-1+51295527403105/95256*ep+
  554800602494906533/240045120*ep^2+385811958544034384741/120982740480*
  ep^3+140661160501409433770533/60975301201920*ep^4+
  5972748132827112581530465/6146310361153536*ep^5;
fill mncT11(-6,-6) =
  1/25971865920*ep+54143/374368864117248*ep^2+1461092694913/
  3372689096832287232000*ep^3+1521012295134409487/
  1215382242934483026923520000*ep^4+144702912918207566541491/
  39815922278533663962014515200000*ep^5;
fill mncT11(-6,-5) =
  1/5194373184*ep+191897/267406331512320*ep^2+1446714588313/
  674537819366457446400*ep^3+215051810762400977/
  34725206940985229340672000*ep^4+143219674905396635366459/
  7963184455706732792402903040000*ep^5;
fill mncT11(-6,-4) =
  1/856215360*ep+1349351/308545767129600*ep^2+291188566637/
  22237510528564531200*ep^3+1515740361197464559/
  40067546470367572316160000*ep^4+144212179045019487639827/
  1312612822369241669077401600000*ep^5;
fill mncT11(-6,-3) =
  1/109771200*ep+21271/608571532800*ep^2+1781801717/16869602889216000*
  ep^3+715217051621027/2338126960445337600000*ep^4+5235259582269107603/
  5892079940322250752000000*ep^5;
fill mncT11(-6,-2) =
  1/9979200*ep+22531/55324684800*ep^2+1933272617/1533600262656000*ep^3
  +781840739076527/212556996404121600000*ep^4+63017127138305883733/
  5892079940322250752000000*ep^5;
fill mncT11(-6,-1) =
  1/544320*ep+11509/1371686400*ep^2+19034489/691329945600*ep^3+
  716347562557/8710757314560000*ep^4+5281738326720781/
  21951108432691200000*ep^5;
fill mncT11(-6,0) =
  1/12096*ep+14701/30481920*ep^2+142493173/76814438400*ep^3+
  1175022146197/193572384768000*ep^4+362229416590381/19512096384614400*
  ep^5;
fill mncT11(-6,1) =
  -1/168-491/11760*ep-2809459/14817600*ep^2-164251523/230496000*
  ep^3-9394096633/3872332800*ep^4-953372760821057/121978483200000*ep^5
  ;
fill mncT11(-6,2) =
  -89/105-1/6*ep^-1-1805329/529200*ep-97649753/8232000*ep^2-
  2971437071/76832000*ep^3-528741075088307/4356374400000*ep^4-
  683016375960851521/1829677248000000*ep^5;
fill mncT11(-6,3) =
  -53/10-7/2*ep^-1-132547/3600*ep-5766373/72000*ep^2-94663519/
  288000*ep^3-73265935007/86400000*ep^4-14991092330803/5184000000*ep^5
  ;
fill mncT11(-6,4) =
  19-35/2*ep^-1-127459/720*ep+746551/14400*ep^2-117119053/96000*
  ep^3-12251704507/17280000*ep^4-2900897885237/345600000*ep^5;
fill mncT11(-6,5) =
  1865/18-175/6*ep^-1-65051/144*ep+552703/576*ep^2-21762941/6912*
  ep^3+393823703/82944*ep^4-17125296709/995328*ep^5;
fill mncT11(-6,6) =
  1313/12-35/2*ep^-1-117053/240*ep+7250177/4800*ep^2-1244217599/
  288000*ep^3+174112515313/17280000*ep^4-25434137985631/1036800000*
  ep^5;
fill mncT11(-6,7) =
  2027/60-7/2*ep^-1-74183/400*ep+5800583/8000*ep^2-222102029/96000
  *ep^3+546926396573/86400000*ep^4-81787562480723/5184000000*ep^5;
fill mncT11(-6,8) =
  353/140-1/6*ep^-1-373727/19600*ep+800940667/8232000*ep^2-
  29289691863/76832000*ep^3+5385992171933273/4356374400000*ep^4-
  709521618026979929/203297472000000*ep^5;
fill mncT11(-6,9) =
  1/112-5471/31360*ep+14340133/8780800*ep^2-24494628927/2458624000*
  ep^3+6237727760217/137682944000*ep^4-864838163864034797/
  5204415283200000*ep^5;
fill mncT11(-6,10) =
  1/2016*ep-42589/5080320*ep^2+827883523/12802406400*ep^3-
  9821121950233/32262064128000*ep^4+15684812553506807/16260080320512000*
  ep^5;
fill mncT11(-5,-6) =
  1/5194373184*ep+191897/267406331512320*ep^2+1446714588313/
  674537819366457446400*ep^3+215051810762400977/
  34725206940985229340672000*ep^4+143219674905396635366459/
  7963184455706732792402903040000*ep^5;
fill mncT11(-5,-5) =
  1/1198701504*ep+188597/61709153425920*ep^2+1414297457413/
  155662573699951718400*ep^3+209999513637846077/
  8013509294073514463232000*ep^4+139865314491088852726559/
  1837657951316938336708362240000*ep^5;
fill mncT11(-5,-4) =
  1/230519520*ep+14411/912857299200*ep^2+1659590243/35426166067353600*
  ep^3+94747430653571/701438088133601280000*ep^4+4854449588337788357/
  12373367874676726579200000*ep^5;
fill mncT11(-5,-3) =
  1/34927200*ep+2917/27662342400*ep^2+1687155977/5367600919296000*ep^3
  +96432007853561/106278498202060800000*ep^4+54350675476108434613/
  20622279791127877632000000*ep^5;
fill mncT11(-5,-2) =
  1/3810240*ep+1387/1371686400*ep^2+14843729/4839309619200*ep^3+
  77510868451/8710757314560000*ep^4+3973230536370181/
  153657759028838400000*ep^5;
fill mncT11(-5,-1) =
  1/254016*ep+1543/91445760*ep^2+86761273/1613103206400*ep^3+
  92265059071/580717154304000*ep^4+189942040247089/409754024076902400*
  ep^5;
fill mncT11(-5,0) =
  1/7056*ep+41/52920*ep^2+198451/69148800*ep^3+38167517/4148928000*
  ep^4+13589568749/487913932800*ep^5;
fill mncT11(-5,1) =
  -1/126-1373/26460*ep-278951/1234800*ep^2-428917169/518616000*
  ep^3-24133350683/8712748800*ep^4-808252068538657/91483862400000*ep^5
  ;
fill mncT11(-5,2) =
  -67/90-1/6*ep^-1-10367/3600*ep-699593/72000*ep^2-26955169/
  864000*ep^3-25135874401/259200000*ep^4-4614144435149/15552000000*
  ep^5;
fill mncT11(-5,3) =
  -7/4-5/2*ep^-1-16687/720*ep-515657/14400*ep^2-54125287/288000*
  ep^3-7162742651/17280000*ep^4-1628632766623/1036800000*ep^5;
fill mncT11(-5,4) =
  655/36-25/3*ep^-1-3409/36*ep+3161/27*ep^2-49598/81*ep^3+
  1147271/3888*ep^4-2667887/729*ep^5;
fill mncT11(-5,5) =
  85/2-25/3*ep^-1-12743/72*ep+414557/864*ep^2-14012279/10368*ep^3
  +347829317/124416*ep^4-10748954831/1492992*ep^5;
fill mncT11(-5,6) =
  259/12-5/2*ep^-1-26179/240*ep+5674733/14400*ep^2-1023344371/
  864000*ep^3+158892462077/51840000*ep^4-22936759409299/3110400000*
  ep^5;
fill mncT11(-5,7) =
  71/30-1/6*ep^-1-60467/3600*ep+17415031/216000*ep^2-773765929/
  2592000*ep^3+715830606667/777600000*ep^4-116118457957877/46656000000
  *ep^5;
fill mncT11(-5,8) =
  1/84-1961/8820*ep+14678609/7408800*ep^2-35755774219/3111696000*
  ep^3+13000149370291/261382464000*ep^4-95609558172939007/
  548903174400000*ep^5;
fill mncT11(-5,9) =
  1/1176*ep-13513/987840*ep^2+11790271/118540800*ep^3-304304606929/
  697019904000*ep^4+148251273664517/117099343872000*ep^5;
fill mncT11(-5,10) =
  1/42336*ep-27589/106686720*ep^2+34849789/38407219200*ep^3+
  317044794767/677503346688000*ep^4-5172935456652193/341461686730752000*
  ep^5;
fill mncT11(-4,-6) =
  1/856215360*ep+1349351/308545767129600*ep^2+291188566637/
  22237510528564531200*ep^3+1515740361197464559/
  40067546470367572316160000*ep^4+144212179045019487639827/
  1312612822369241669077401600000*ep^5;
fill mncT11(-4,-5) =
  1/230519520*ep+14411/912857299200*ep^2+1659590243/35426166067353600*
  ep^3+94747430653571/701438088133601280000*ep^4+4854449588337788357/
  12373367874676726579200000*ep^5;
fill mncT11(-4,-4) =
  1/52390800*ep+14123/207467568000*ep^2+8083406479/40257006894720000*
  ep^3+92187701272739/159417747303091200000*ep^4+51962531752521149719/
  30933419686691816448000000*ep^5;
fill mncT11(-4,-3) =
  1/9525600*ep+1279/3429216000*ep^2+66497617/60491370240000*ep^3+
  2757573631/871075731456000*ep^4+3532802670886561/384144397572096000000
  *ep^5;
fill mncT11(-4,-2) =
  1/1270080*ep+263/91445760*ep^2+69071293/8065516032000*ep^3+
  71796516667/2903585771520000*ep^4+3679611959381101/
  51219253009612800000*ep^5;
fill mncT11(-4,-1) =
  1/105840*ep+1/26460*ep^2+364073/3111696000*ep^3+63883327/
  186701760000*ep^4+546850483751/548903174400000*ep^5;
fill mncT11(-4,0) =
  1/3780*ep+71/52920*ep^2+529973/111132000*ep^3+698334139/
  46675440000*ep^4+879324400001/19603684800000*ep^5;
fill mncT11(-4,1) =
  -1/90-1/15*ep-14927/54000*ep^2-3184063/3240000*ep^3-628561811/
  194400000*ep^4-23803415627/2332800000*ep^5;
fill mncT11(-4,2) =
  -28/45-1/6*ep^-1-2789/1200*ep-1633991/216000*ep^2-310028443/
  12960000*ep^3-57229724639/777600000*ep^4-10450629954547/46656000000*
  ep^5;
fill mncT11(-4,3) =
  19/36-5/3*ep^-1-57/4*ep-223/27*ep^2-8182/81*ep^3-582373/3888*
  ep^4-2237203/2916*ep^5;
fill mncT11(-4,4) =
  73/6-10/3*ep^-1-883/18*ep+926/9*ep^2-25784/81*ep^3+103267/216*
  ep^4-4865789/2916*ep^5;
fill mncT11(-4,5) =
  37/3-5/3*ep^-1-449/8*ep+157679/864*ep^2-1769167/3456*ep^3+
  153246119/124416*ep^4-476712269/165888*ep^5;
fill mncT11(-4,6) =
  131/60-1/6*ep^-1-17149/1200*ep+13715489/216000*ep^2-946662581/
  4320000*ep^3+494298681041/777600000*ep^4-8467731288263/5184000000*
  ep^5;
fill mncT11(-4,7) =
  1/60-53/180*ep+266561/108000*ep^2-87124181/6480000*ep^3+
  21293362823/388800000*ep^4-6769202801/37324800*ep^5;
fill mncT11(-4,8) =
  1/630*ep-53/2205*ep^2+9018689/55566000*ep^3-5067714581/7779240000*
  ep^4+16436907354443/9801842400000*ep^5;
fill mncT11(-4,9) =
  1/17640*ep-563/987840*ep^2+2929291/1778112000*ep^3+9789209929/
  3485099520000*ep^4-303031735346099/8782450790400000*ep^5;
fill mncT11(-4,10) =
  1/211680*ep-3737/106686720*ep^2+3220069/192036096000*ep^3+
  1849098148199/3387516733440000*ep^4-17893832061607469/
  8536542168268800000*ep^5;
fill mncT11(-3,-6) =
  1/109771200*ep+21271/608571532800*ep^2+1781801717/16869602889216000*
  ep^3+715217051621027/2338126960445337600000*ep^4+5235259582269107603/
  5892079940322250752000000*ep^5;
fill mncT11(-3,-5) =
  1/34927200*ep+2917/27662342400*ep^2+1687155977/5367600919296000*ep^3
  +96432007853561/106278498202060800000*ep^4+54350675476108434613/
  20622279791127877632000000*ep^5;
fill mncT11(-3,-4) =
  1/9525600*ep+1279/3429216000*ep^2+66497617/60491370240000*ep^3+
  2757573631/871075731456000*ep^4+3532802670886561/384144397572096000000
  *ep^5;
fill mncT11(-3,-3) =
  1/2116800*ep+1249/762048000*ep^2+64485187/13442526720000*ep^3+
  13352658713/967861923840000*ep^4+3421865471751211/85365421682688000000
  *ep^5;
fill mncT11(-3,-2) =
  1/352800*ep+209/21168000*ep^2+600599/20744640000*ep^3+829559/
  9957427200*ep^4+885842668847/3659354496000000*ep^5;
fill mncT11(-3,-1) =
  1/37800*ep+521/5292000*ep^2+658699/2222640000*ep^3+32087681/
  37340352000*ep^4+979800893347/392073696000000*ep^5;
fill mncT11(-3,0) =
  1/1800*ep+31/12000*ep^2+18961/2160000*ep^3+698329/25920000*ep^4+
  622296697/7776000000*ep^5;
fill mncT11(-3,1) =
  -1/60-323/3600*ep-8431/24000*ep^2-5219689/4320000*ep^3-
  1010598197/259200000*ep^4-189197104081/15552000000*ep^5;
fill mncT11(-3,2) =
  -17/36-1/6*ep^-1-7/4*ep-293/54*ep^2-10979/648*ep^3-200341/
  3888*ep^4-3640769/23328*ep^5;
fill mncT11(-3,3) =
  5/3-ep^-1-9*ep+58/9*ep^2-5849/108*ep^3-3065/324*ep^4-1329407/
  3888*ep^5;
fill mncT11(-3,4) =
  35/6-ep^-1-139/6*ep+578/9*ep^2-18179/108*ep^3+233215/648*ep^4
  -3293897/3888*ep^5;
fill mncT11(-3,5) =
  47/24-1/6*ep^-1-1103/96*ep+159143/3456*ep^2-2004967/13824*ep^3
  +193964447/497664*ep^4-625422901/663552*ep^5;
fill mncT11(-3,6) =
  1/40-329/800*ep+50941/16000*ep^2-46047001/2880000*ep^3+
  3470853629/57600000*ep^4-1929124683769/10368000000*ep^5;
fill mncT11(-3,7) =
  1/300*ep-841/18000*ep^2+309163/1080000*ep^3-13185257/12960000*ep^4
  +8539596691/3888000000*ep^5;
fill mncT11(-3,8) =
  1/6300*ep-1259/882000*ep^2+3355417/1111320000*ep^3+367419121/
  31116960000*ep^4-16828556763959/196036848000000*ep^5;
fill mncT11(-3,9) =
  1/58800*ep-1793/16464000*ep^2-338951/5927040000*ep^3+1515706901/
  774466560000*ep^4-162680266832969/29274835968000000*ep^5;
fill mncT11(-3,10) =
  1/352800*ep-11797/889056000*ep^2-12737699/320060160000*ep^3+
  342043914019/1129172244480000*ep^4-5184963405893189/
  14227570280448000000*ep^5;
fill mncT11(-2,-6) =
  1/9979200*ep+22531/55324684800*ep^2+1933272617/1533600262656000*ep^3
  +781840739076527/212556996404121600000*ep^4+63017127138305883733/
  5892079940322250752000000*ep^5;
fill mncT11(-2,-5) =
  1/3810240*ep+1387/1371686400*ep^2+14843729/4839309619200*ep^3+
  77510868451/8710757314560000*ep^4+3973230536370181/
  153657759028838400000*ep^5;
fill mncT11(-2,-4) =
  1/1270080*ep+263/91445760*ep^2+69071293/8065516032000*ep^3+
  71796516667/2903585771520000*ep^4+3679611959381101/
  51219253009612800000*ep^5;
fill mncT11(-2,-3) =
  1/352800*ep+209/21168000*ep^2+600599/20744640000*ep^3+829559/
  9957427200*ep^4+885842668847/3659354496000000*ep^5;
fill mncT11(-2,-2) =
  1/75600*ep+1423/31752000*ep^2+1737677/13335840000*ep^3+419308739/
  1120210560000*ep^4+2559077496341/2352442176000000*ep^5;
fill mncT11(-2,-1) =
  1/10800*ep+209/648000*ep^2+36853/38880000*ep^3+10193/3732480*ep^4
  +1111096141/139968000000*ep^5;
fill mncT11(-2,0) =
  1/720*ep+253/43200*ep^2+49169/2592000*ep^3+8860237/155520000*ep^4
  +1566217001/9331200000*ep^5;
fill mncT11(-2,1) =
  -1/36-7/54*ep-307/648*ep^2-6101/3888*ep^3-115633/23328*ep^4-
  2138849/139968*ep^5;
fill mncT11(-2,2) =
  -5/18-1/6*ep^-1-127/108*ep-2159/648*ep^2-40519/3888*ep^3-
  727775/23328*ep^4-13187287/139968*ep^5;
fill mncT11(-2,3) =
  11/6-1/2*ep^-1-25/4*ep+97/8*ep^2-545/16*ep^3+1537/32*ep^4-
  10625/64*ep^5;
fill mncT11(-2,4) =
  5/3-1/6*ep^-1-299/36*ep+6187/216*ep^2-103013/1296*ep^3+1504375/
  7776*ep^4-20294069/46656*ep^5;
fill mncT11(-2,5) =
  1/24-179/288*ep+14881/3456*ep^2-800819/41472*ep^3+32595961/
  497664*ep^4-1102859819/5971968*ep^5;
fill mncT11(-2,6) =
  1/120*ep-757/7200*ep^2+242359/432000*ep^3-43044433/25920000*ep^4
  +4074665071/1555200000*ep^5;
fill mncT11(-2,7) =
  1/1800*ep-461/108000*ep^2+3287/720000*ep^3+3937531/77760000*ep^4
  -5571523609/23328000000*ep^5;
fill mncT11(-2,8) =
  1/12600*ep-2167/5292000*ep^2-1838653/2222640000*ep^3+1565353577/
  186701760000*ep^4-1969039700503/130691232000000*ep^5;
fill mncT11(-2,9) =
  1/58800*ep-2929/49392000*ep^2-210289/658560000*ep^3+10265988779/
  6970199040000*ep^4-7503545288719/29274835968000000*ep^5;
fill mncT11(-2,10) =
  1/211680*ep-1133/106686720*ep^2-20839151/192036096000*ep^3+
  1005421668539/3387516733440000*ep^4+3636684674926231/
  8536542168268800000*ep^5;
fill mncT11(-1,-6) =
  1/544320*ep+11509/1371686400*ep^2+19034489/691329945600*ep^3+
  716347562557/8710757314560000*ep^4+5281738326720781/
  21951108432691200000*ep^5;
fill mncT11(-1,-5) =
  1/254016*ep+1543/91445760*ep^2+86761273/1613103206400*ep^3+
  92265059071/580717154304000*ep^4+189942040247089/409754024076902400*
  ep^5;
fill mncT11(-1,-4) =
  1/105840*ep+1/26460*ep^2+364073/3111696000*ep^3+63883327/
  186701760000*ep^4+546850483751/548903174400000*ep^5;
fill mncT11(-1,-3) =
  1/37800*ep+521/5292000*ep^2+658699/2222640000*ep^3+32087681/
  37340352000*ep^4+979800893347/392073696000000*ep^5;
fill mncT11(-1,-2) =
  1/10800*ep+209/648000*ep^2+36853/38880000*ep^3+10193/3732480*ep^4
  +1111096141/139968000000*ep^5;
fill mncT11(-1,-1) =
  1/2160*ep+203/129600*ep^2+35419/7776000*ep^3+6106487/466560000*
  ep^4+1064948251/27993600000*ep^5;
fill mncT11(-1,0) =
  1/216*ep+23/1296*ep^2+427/7776*ep^3+7547/46656*ep^4+132547/
  279936*ep^5;
fill mncT11(-1,1) =
  -1/18-23/108*ep-463/648*ep^2-8807/3888*ep^3-163039/23328*ep^4
  -2977367/139968*ep^5;
fill mncT11(-1,2) =
  -1/6*ep^-1-2/3*ep-4/3*ep^2-14/3*ep^3-40/3*ep^4-122/3*ep^5;
fill mncT11(-1,3) =
  5/4-1/6*ep^-1-37/8*ep+197/16*ep^2-901/32*ep^3+3845/64*ep^4-
  15877/128*ep^5;
fill mncT11(-1,4) =
  1/12-77/72*ep+2683/432*ep^2-60473/2592*ep^3+1053499/15552*ep^4
  -15759953/93312*ep^5;
fill mncT11(-1,5) =
  1/36*ep-43/144*ep^2+6583/5184*ep^3-55583/20736*ep^4+1116007/
  746496*ep^5;
fill mncT11(-1,6) =
  1/360*ep-119/7200*ep^2-12041/1296000*ep^3+6722789/25920000*ep^4-
  3468808529/4665600000*ep^5;
fill mncT11(-1,7) =
  1/1800*ep-211/108000*ep^2-62167/6480000*ep^3+3518981/77760000*ep^4
  -169501453/7776000000*ep^5;
fill mncT11(-1,8) =
  1/6300*ep-401/1323000*ep^2-2005079/555660000*ep^3+391786789/
  46675440000*ep^4+154028720287/10890936000000*ep^5;
fill mncT11(-1,9) =
  1/17640*ep-121/2963520*ep^2-2512789/1778112000*ep^3+15188895707/
  10455298560000*ep^4+2773974518263/325275955200000*ep^5;
fill mncT11(-1,10) =
  1/42336*ep+551/106686720*ep^2-23198471/38407219200*ep^3+
  34557361427/677503346688000*ep^4+1401049384583171/341461686730752000*
  ep^5;
fill mncT11(0,-6) =
  1/12096*ep+14701/30481920*ep^2+142493173/76814438400*ep^3+
  1175022146197/193572384768000*ep^4+362229416590381/19512096384614400*
  ep^5;
fill mncT11(0,-5) =
  1/7056*ep+41/52920*ep^2+198451/69148800*ep^3+38167517/4148928000*
  ep^4+13589568749/487913932800*ep^5;
fill mncT11(0,-4) =
  1/3780*ep+71/52920*ep^2+529973/111132000*ep^3+698334139/
  46675440000*ep^4+879324400001/19603684800000*ep^5;
fill mncT11(0,-3) =
  1/1800*ep+31/12000*ep^2+18961/2160000*ep^3+698329/25920000*ep^4+
  622296697/7776000000*ep^5;
fill mncT11(0,-2) =
  1/720*ep+253/43200*ep^2+49169/2592000*ep^3+8860237/155520000*ep^4
  +1566217001/9331200000*ep^5;
fill mncT11(0,-1) =
  1/216*ep+23/1296*ep^2+427/7776*ep^3+7547/46656*ep^4+132547/
  279936*ep^5;
fill mncT11(0,0) =
  1/36*ep+23/216*ep^2+427/1296*ep^3+7547/7776*ep^4+132547/46656*
  ep^5;
fill mncT11(0,1) =
  -1/6-1/2*ep-3/2*ep^2-9/2*ep^3-27/2*ep^4-81/2*ep^5;
fill mncT11(0,2) =
  1/2-1/6*ep^-1-1/2*ep+1/2*ep^2-1/2*ep^3+1/2*ep^4-1/2*ep^5;
fill mncT11(0,3) =
  1/4-19/8*ep+151/16*ep^2-799/32*ep^3+3631/64*ep^4-15439/128*
  ep^5;
fill mncT11(0,4) =
  1/6*ep-47/36*ep^2+697/216*ep^3-2123/1296*ep^4-85583/7776*ep^5;
fill mncT11(0,5) =
  1/36*ep-13/144*ep^2-2147/5184*ep^3+36787/20736*ep^4-1243883/
  746496*ep^5;
fill mncT11(0,6) =
  1/120*ep-19/2400*ep^2-79541/432000*ep^3+676763/2880000*ep^4+
  1092053971/1555200000*ep^5;
fill mncT11(0,7) =
  1/300*ep+17/9000*ep^2-14077/180000*ep^3-119341/6480000*ep^4+
  813955783/1944000000*ep^5;
fill mncT11(0,8) =
  1/630*ep+71/26460*ep^2-2011631/55566000*ep^3-1183313023/
  23337720000*ep^4+68567159309/363031200000*ep^5;
fill mncT11(0,9) =
  1/1176*ep+2167/987840*ep^2-2147569/118540800*ep^3-30974065249/
  697019904000*ep^4+1001999162669/13011038208000*ep^5;
fill mncT11(0,10) =
  1/2016*ep+1193/725760*ep^2-123315497/12802406400*ep^3-
  1087179659173/32262064128000*ep^4+60277238568413/2322868617216000*ep^5
  ;
fill mncT11(1,-6) =
  -1/168-491/11760*ep-2809459/14817600*ep^2-164251523/230496000*
  ep^3-9394096633/3872332800*ep^4-953372760821057/121978483200000*ep^5
  ;
fill mncT11(1,-5) =
  -1/126-1373/26460*ep-278951/1234800*ep^2-428917169/518616000*
  ep^3-24133350683/8712748800*ep^4-808252068538657/91483862400000*ep^5
  ;
fill mncT11(1,-4) =
  -1/90-1/15*ep-14927/54000*ep^2-3184063/3240000*ep^3-628561811/
  194400000*ep^4-23803415627/2332800000*ep^5;
fill mncT11(1,-3) =
  -1/60-323/3600*ep-8431/24000*ep^2-5219689/4320000*ep^3-
  1010598197/259200000*ep^4-189197104081/15552000000*ep^5;
fill mncT11(1,-2) =
  -1/36-7/54*ep-307/648*ep^2-6101/3888*ep^3-115633/23328*ep^4-
  2138849/139968*ep^5;
fill mncT11(1,-1) =
  -1/18-23/108*ep-463/648*ep^2-8807/3888*ep^3-163039/23328*ep^4
  -2977367/139968*ep^5;
fill mncT11(1,0) =
  -1/6-1/2*ep-3/2*ep^2-9/2*ep^3-27/2*ep^4-81/2*ep^5;
fill mncT11(1,1) =
  1/3*ep^-1;
fill mncT11(1,2) =
  5/2-1/2*ep^-1-5/2*ep+5/2*ep^2-5/2*ep^3+5/2*ep^4-5/2*ep^5;
fill mncT11(1,3) =
  -1+9/2*ep-1/4*ep^2-111/8*ep^3+719/16*ep^4-3471/32*ep^5;
fill mncT11(1,4) =
  -1/3+1/9*ep+331/54*ep^2-1391/324*ep^3-14147/1944*ep^4+345409/
  11664*ep^5;
fill mncT11(1,5) =
  -1/6-7/24*ep+2759/864*ep^2+4931/1152*ep^3-1045681/124416*ep^4
  +3278833/497664*ep^5;
fill mncT11(1,6) =
  -1/10-47/150*ep+30253/18000*ep^2+5658839/1080000*ep^3-
  104471693/64800000*ep^4-13141480309/3888000000*ep^5;
fill mncT11(1,7) =
  -1/15-5/18*ep+8173/9000*ep^2+7556441/1620000*ep^3+241319777/
  97200000*ep^4-1397739257/388800000*ep^5;
fill mncT11(1,8) =
  -1/21-524/2205*ep+902201/1852200*ep^2+3014463589/777924000*ep^3
  +1208942969/268912000*ep^4-57410968341421/45741931200000*ep^5;
fill mncT11(1,9) =
  -1/28-227/1120*ep+4829183/19756800*ep^2+17493523283/5531904000*
  ep^3+2131548126517/398297088000*ep^4+1653666696353377/
  1301103820800000*ep^5;
fill mncT11(1,10) =
  -1/36-493/2835*ep+11263261/114307200*ep^2+741728374799/
  288054144000*ep^3+812764988352467/145179288576000*ep^4+
  6149677687096924787/1829259036057600000*ep^5;
fill mncT11(2,-6) =
  -89/105-1/6*ep^-1-1805329/529200*ep-97649753/8232000*ep^2-
  2971437071/76832000*ep^3-528741075088307/4356374400000*ep^4-
  683016375960851521/1829677248000000*ep^5;
fill mncT11(2,-5) =
  -67/90-1/6*ep^-1-10367/3600*ep-699593/72000*ep^2-26955169/
  864000*ep^3-25135874401/259200000*ep^4-4614144435149/15552000000*
  ep^5;
fill mncT11(2,-4) =
  -28/45-1/6*ep^-1-2789/1200*ep-1633991/216000*ep^2-310028443/
  12960000*ep^3-57229724639/777600000*ep^4-10450629954547/46656000000*
  ep^5;
fill mncT11(2,-3) =
  -17/36-1/6*ep^-1-7/4*ep-293/54*ep^2-10979/648*ep^3-200341/
  3888*ep^4-3640769/23328*ep^5;
fill mncT11(2,-2) =
  -5/18-1/6*ep^-1-127/108*ep-2159/648*ep^2-40519/3888*ep^3-
  727775/23328*ep^4-13187287/139968*ep^5;
fill mncT11(2,-1) =
  -1/6*ep^-1-2/3*ep-4/3*ep^2-14/3*ep^3-40/3*ep^4-122/3*ep^5;
fill mncT11(2,0) =
  1/2-1/6*ep^-1-1/2*ep+1/2*ep^2-1/2*ep^3+1/2*ep^4-1/2*ep^5;
fill mncT11(2,1) =
  5/2-1/2*ep^-1-5/2*ep+5/2*ep^2-5/2*ep^3+5/2*ep^4-5/2*ep^5;
fill mncT11(2,2) =
  3-ep^-1+7*ep-17*ep^2+27*ep^3-37*ep^4+47*ep^5;
fill mncT11(2,3) =
  -ep^-1+37/2*ep-27/4*ep^2-209/8*ep^3+1305/16*ep^4-5513/32*
  ep^5;
fill mncT11(2,4) =
  -5/3-ep^-1+343/18*ep+2581/108*ep^2-30839/648*ep^3+175645/
  3888*ep^4-564887/23328*ep^5;
fill mncT11(2,5) =
  -17/6-ep^-1+1249/72*ep+40177/864*ep^2-251579/10368*ep^3-
  1938527/124416*ep^4+60671869/1492992*ep^5;
fill mncT11(2,6) =
  -56/15-ep^-1+26869/1800*ep+6747947/108000*ep^2+99246511/
  6480000*ep^3-16902461257/388800000*ep^4+700982831959/23328000000*
  ep^5;
fill mncT11(2,7) =
  -67/15-ep^-1+7363/600*ep+7963583/108000*ep^2+77642911/1296000*
  ep^3-4851581503/129600000*ep^4-72804350141/23328000000*ep^5;
fill mncT11(2,8) =
  -178/35-ep^-1+843481/88200*ep+1007464943/12348000*ep^2+
  326316812099/3111696000*ep^3-3321224463607/726062400000*ep^4-
  81840394319902889/2744515872000000*ep^5;
fill mncT11(2,9) =
  -787/140-ep^-1+2427349/352800*ep+8586842269/98784000*ep^2+
  7377872489189/49787136000*ep^3+373227039620317/7744665600000*ep^4-
  6457306438212806471/175649015808000000*ep^5;
fill mncT11(2,10) =
  -3839/630-ep^-1+13517821/3175200*ep+722967654779/8001504000*ep^2
  +762299414847911/4032758016000*ep^3+5863782749601411287/
  50812751001600000*ep^4-2410867506661744804829/128048132524032000000*
  ep^5;
fill mncT11(3,-6) =
  -53/10-7/2*ep^-1-132547/3600*ep-5766373/72000*ep^2-94663519/
  288000*ep^3-73265935007/86400000*ep^4-14991092330803/5184000000*ep^5
  ;
fill mncT11(3,-5) =
  -7/4-5/2*ep^-1-16687/720*ep-515657/14400*ep^2-54125287/288000*
  ep^3-7162742651/17280000*ep^4-1628632766623/1036800000*ep^5;
fill mncT11(3,-4) =
  19/36-5/3*ep^-1-57/4*ep-223/27*ep^2-8182/81*ep^3-582373/3888*
  ep^4-2237203/2916*ep^5;
fill mncT11(3,-3) =
  5/3-ep^-1-9*ep+58/9*ep^2-5849/108*ep^3-3065/324*ep^4-1329407/
  3888*ep^5;
fill mncT11(3,-2) =
  11/6-1/2*ep^-1-25/4*ep+97/8*ep^2-545/16*ep^3+1537/32*ep^4-
  10625/64*ep^5;
fill mncT11(3,-1) =
  5/4-1/6*ep^-1-37/8*ep+197/16*ep^2-901/32*ep^3+3845/64*ep^4-
  15877/128*ep^5;
fill mncT11(3,0) =
  1/4-19/8*ep+151/16*ep^2-799/32*ep^3+3631/64*ep^4-15439/128*
  ep^5;
fill mncT11(3,1) =
  -1+9/2*ep-1/4*ep^2-111/8*ep^3+719/16*ep^4-3471/32*ep^5;
fill mncT11(3,2) =
  -ep^-1+37/2*ep-27/4*ep^2-209/8*ep^3+1305/16*ep^4-5513/32*
  ep^5;
fill mncT11(3,3) =
  -3/2-3*ep^-1+225/4*ep+57/8*ep^2-1635/16*ep^3+6957/32*ep^4-
  24375/64*ep^5;
fill mncT11(3,4) =
  -15/2-6*ep^-1+449/4*ep+2363/24*ep^2-33247/144*ep^3+257735/
  864*ep^4-1975171/5184*ep^5;
fill mncT11(3,5) =
  -58/3-10*ep^-1+6497/36*ep+126887/432*ep^2-1603513/5184*ep^3+
  13345907/62208*ep^4-160892713/746496*ep^5;
fill mncT11(3,6) =
  -38-15*ep^-1+30613/120*ep+4364099/7200*ep^2-100543913/432000*
  ep^3-73359169/25920000*ep^4-101532208097/1555200000*ep^5;
fill mncT11(3,7) =
  -643/10-21*ep^-1+198433/600*ep+37491071/36000*ep^2+40354283/
  432000*ep^3-31200286513/129600000*ep^4-456002246177/7776000000*ep^5;
fill mncT11(3,8) =
  -989/10-28*ep^-1+2534177/6300*ep+1411806601/882000*ep^2+
  167103911539/222264000*ep^3-5874194518813/17287200000*ep^4-
  44948630072541313/196036848000000*ep^5;
fill mncT11(3,9) =
  -4983/35-36*ep^-1+4556749/9800*ep+18784846207/8232000*ep^2+
  2508753664829/1382976000*ep^3-667379229950441/5808499200000*ep^4-
  2514512912366469071/4879139328000000*ep^5;
fill mncT11(3,10) =
  -2733/14-45*ep^-1+12100511/23520*ep+36522506621/11854080*ep^2+
  499108024384793/149361408000*ep^3+238057627322242549/376390748160000*
  ep^4-730345405419777932839/948504685363200000*ep^5;
fill mncT11(4,-6) =
  19-35/2*ep^-1-127459/720*ep+746551/14400*ep^2-117119053/96000*
  ep^3-12251704507/17280000*ep^4-2900897885237/345600000*ep^5;
fill mncT11(4,-5) =
  655/36-25/3*ep^-1-3409/36*ep+3161/27*ep^2-49598/81*ep^3+
  1147271/3888*ep^4-2667887/729*ep^5;
fill mncT11(4,-4) =
  73/6-10/3*ep^-1-883/18*ep+926/9*ep^2-25784/81*ep^3+103267/216*
  ep^4-4865789/2916*ep^5;
fill mncT11(4,-3) =
  35/6-ep^-1-139/6*ep+578/9*ep^2-18179/108*ep^3+233215/648*ep^4
  -3293897/3888*ep^5;
fill mncT11(4,-2) =
  5/3-1/6*ep^-1-299/36*ep+6187/216*ep^2-103013/1296*ep^3+1504375/
  7776*ep^4-20294069/46656*ep^5;
fill mncT11(4,-1) =
  1/12-77/72*ep+2683/432*ep^2-60473/2592*ep^3+1053499/15552*ep^4
  -15759953/93312*ep^5;
fill mncT11(4,0) =
  1/6*ep-47/36*ep^2+697/216*ep^3-2123/1296*ep^4-85583/7776*ep^5;
fill mncT11(4,1) =
  -1/3+1/9*ep+331/54*ep^2-1391/324*ep^3-14147/1944*ep^4+345409/
  11664*ep^5;
fill mncT11(4,2) =
  -5/3-ep^-1+343/18*ep+2581/108*ep^2-30839/648*ep^3+175645/
  3888*ep^4-564887/23328*ep^5;
fill mncT11(4,3) =
  -15/2-6*ep^-1+449/4*ep+2363/24*ep^2-33247/144*ep^3+257735/
  864*ep^4-1975171/5184*ep^5;
fill mncT11(4,4) =
  -91/3-20*ep^-1+6647/18*ep+46397/108*ep^2-463897/648*ep^3+
  2998481/3888*ep^4-21706837/23328*ep^5;
fill mncT11(4,5) =
  -95-50*ep^-1+32401/36*ep+206587/144*ep^2-7720667/5184*ep^3+
  23993707/20736*ep^4-1006400483/746496*ep^5;
fill mncT11(4,6) =
  -241-105*ep^-1+218491/120*ep+27182593/7200*ep^2-912704891/
  432000*ep^3+25055078317/25920000*ep^4-2377547244179/1555200000*ep^5;
fill mncT11(4,7) =
  -5243/10-196*ep^-1+2917037/900*ep+150586423/18000*ep^2-
  973581653/648000*ep^3-2685625673/21600000*ep^4-21233987539753/
  11664000000*ep^5;
fill mncT11(4,8) =
  -5094/5-336*ep^-1+2757512/525*ep+1203147311/73500*ep^2+
  41798420893/18522000*ep^3-23640276255767/12965400000*ep^4-
  48468564911944603/16336404000000*ep^5;
fill mncT11(4,9) =
  -12723/7-540*ep^-1+15515811/1960*ep+9610794797/329280*ep^2+
  5562667894709/460992000*ep^3-3161052127785863/1161699840000*ep^4-
  1879943028022084523/325275955200000*ep^5;
fill mncT11(4,10) =
  -42475/14-825*ep^-1+158826085/14112*ep+1722812465123/35562240*
  ep^2+2862905548098763/89616844800*ep^3+51383427764068223/
  225834448896000*ep^4-6023904889151281594517/569102811217920000*ep^5;
fill mncT11(5,-6) =
  1865/18-175/6*ep^-1-65051/144*ep+552703/576*ep^2-21762941/6912*
  ep^3+393823703/82944*ep^4-17125296709/995328*ep^5;
fill mncT11(5,-5) =
  85/2-25/3*ep^-1-12743/72*ep+414557/864*ep^2-14012279/10368*ep^3
  +347829317/124416*ep^4-10748954831/1492992*ep^5;
fill mncT11(5,-4) =
  37/3-5/3*ep^-1-449/8*ep+157679/864*ep^2-1769167/3456*ep^3+
  153246119/124416*ep^4-476712269/165888*ep^5;
fill mncT11(5,-3) =
  47/24-1/6*ep^-1-1103/96*ep+159143/3456*ep^2-2004967/13824*ep^3
  +193964447/497664*ep^4-625422901/663552*ep^5;
fill mncT11(5,-2) =
  1/24-179/288*ep+14881/3456*ep^2-800819/41472*ep^3+32595961/
  497664*ep^4-1102859819/5971968*ep^5;
fill mncT11(5,-1) =
  1/36*ep-43/144*ep^2+6583/5184*ep^3-55583/20736*ep^4+1116007/
  746496*ep^5;
fill mncT11(5,0) =
  1/36*ep-13/144*ep^2-2147/5184*ep^3+36787/20736*ep^4-1243883/
  746496*ep^5;
fill mncT11(5,1) =
  -1/6-7/24*ep+2759/864*ep^2+4931/1152*ep^3-1045681/124416*ep^4
  +3278833/497664*ep^5;
fill mncT11(5,2) =
  -17/6-ep^-1+1249/72*ep+40177/864*ep^2-251579/10368*ep^3-
  1938527/124416*ep^4+60671869/1492992*ep^5;
fill mncT11(5,3) =
  -58/3-10*ep^-1+6497/36*ep+126887/432*ep^2-1603513/5184*ep^3+
  13345907/62208*ep^4-160892713/746496*ep^5;
fill mncT11(5,4) =
  -95-50*ep^-1+32401/36*ep+206587/144*ep^2-7720667/5184*ep^3+
  23993707/20736*ep^4-1006400483/746496*ep^5;
fill mncT11(5,5) =
  -1455/4-175*ep^-1+446189/144*ep+1074551/192*ep^2-92479423/
  20736*ep^3+81031771/27648*ep^4-11094823867/2985984*ep^5;
fill mncT11(5,6) =
  -4557/4-490*ep^-1+6086473/720*ep+28575877/1600*ep^2-
  23703069623/2592000*ep^3+75358338539/17280000*ep^4-69528709761587/
  9331200000*ep^5;
fill mncT11(5,7) =
  -15239/5-1176*ep^-1+1961923/100*ep+871210943/18000*ep^2-
  2501501699/216000*ep^3+57388478537/21600000*ep^4-52691121964811/
  3888000000*ep^5;
fill mncT11(5,8) =
  -7207-2520*ep^-1+16965961/420*ep+4066003721/35280*ep^2+
  88549370213/74088000*ep^3-51961797853837/10372320000*ep^4-
  112317791140034653/4356374400000*ep^5;
fill mncT11(5,9) =
  -108175/7-4950*ep^-1+178300085/2352*ep+489246542041/1975680*ep^2
  +97721162938507/1659571200*ep^3-7710456819734617/464679936000*ep^4
  -20412668993201052719/390331146240000*ep^5;
fill mncT11(5,10) =
  -428725/14-9075*ep^-1+1863930935/14112*ep+17420500082353/
  35562240*ep^2+19591470539173193/89616844800*ep^3-3490364875570682747/
  225834448896000*ep^4-59881195837843542836887/569102811217920000*ep^5;
fill mncT11(6,-6) =
  1313/12-35/2*ep^-1-117053/240*ep+7250177/4800*ep^2-1244217599/
  288000*ep^3+174112515313/17280000*ep^4-25434137985631/1036800000*
  ep^5;
fill mncT11(6,-5) =
  259/12-5/2*ep^-1-26179/240*ep+5674733/14400*ep^2-1023344371/
  864000*ep^3+158892462077/51840000*ep^4-22936759409299/3110400000*
  ep^5;
fill mncT11(6,-4) =
  131/60-1/6*ep^-1-17149/1200*ep+13715489/216000*ep^2-946662581/
  4320000*ep^3+494298681041/777600000*ep^4-8467731288263/5184000000*
  ep^5;
fill mncT11(6,-3) =
  1/40-329/800*ep+50941/16000*ep^2-46047001/2880000*ep^3+
  3470853629/57600000*ep^4-1929124683769/10368000000*ep^5;
fill mncT11(6,-2) =
  1/120*ep-757/7200*ep^2+242359/432000*ep^3-43044433/25920000*ep^4
  +4074665071/1555200000*ep^5;
fill mncT11(6,-1) =
  1/360*ep-119/7200*ep^2-12041/1296000*ep^3+6722789/25920000*ep^4-
  3468808529/4665600000*ep^5;
fill mncT11(6,0) =
  1/120*ep-19/2400*ep^2-79541/432000*ep^3+676763/2880000*ep^4+
  1092053971/1555200000*ep^5;
fill mncT11(6,1) =
  -1/10-47/150*ep+30253/18000*ep^2+5658839/1080000*ep^3-
  104471693/64800000*ep^4-13141480309/3888000000*ep^5;
fill mncT11(6,2) =
  -56/15-ep^-1+26869/1800*ep+6747947/108000*ep^2+99246511/
  6480000*ep^3-16902461257/388800000*ep^4+700982831959/23328000000*
  ep^5;
fill mncT11(6,3) =
  -38-15*ep^-1+30613/120*ep+4364099/7200*ep^2-100543913/432000*
  ep^3-73359169/25920000*ep^4-101532208097/1555200000*ep^5;
fill mncT11(6,4) =
  -241-105*ep^-1+218491/120*ep+27182593/7200*ep^2-912704891/
  432000*ep^3+25055078317/25920000*ep^4-2377547244179/1555200000*ep^5;
fill mncT11(6,5) =
  -4557/4-490*ep^-1+6086473/720*ep+28575877/1600*ep^2-
  23703069623/2592000*ep^3+75358338539/17280000*ep^4-69528709761587/
  9331200000*ep^5;
fill mncT11(6,6) =
  -8673/2-1764*ep^-1+5986513/200*ep+821439983/12000*ep^2-
  18129375839/720000*ep^3+421716164459/43200000*ep^4-2440992111923/
  103680000*ep^5;
fill mncT11(6,7) =
  -139503/10-5292*ep^-1+17533043/200*ep+886911423/4000*ep^2-
  30367486541/720000*ep^3+82520804861/8640000*ep^4-17712342624601/
  288000000*ep^5;
fill mncT11(6,8) =
  -78521/2-13860*ep^-1+187205549/840*ep+221181512717/352800*ep^2
  -115715020399/29635200*ep^3-289203450863189/20744640000*ep^4-
  1302317090554369133/8712748800000*ep^5;
fill mncT11(6,9) =
  -1388409/14-32670*ep^-1+1989252439/3920*ep+5225117077949/3292800
  *ep^2+152407746348439/553190400*ep^3-57305585470090057/774466560000*
  ep^4-229501098284133484783/650551910400000*ep^5;
fill mncT11(6,10) =
  -1604691/7-70785*ep^-1+24874620107/23520*ep+217302808748161/
  59270400*ep^2+37867626431250733/29872281600*ep^3-
  44685664886587404371/376390748160000*ep^4-759955588865113975328047/
  948504685363200000*ep^5;
fill mncT11(7,-6) =
  2027/60-7/2*ep^-1-74183/400*ep+5800583/8000*ep^2-222102029/96000
  *ep^3+546926396573/86400000*ep^4-81787562480723/5184000000*ep^5;
fill mncT11(7,-5) =
  71/30-1/6*ep^-1-60467/3600*ep+17415031/216000*ep^2-773765929/
  2592000*ep^3+715830606667/777600000*ep^4-116118457957877/46656000000
  *ep^5;
fill mncT11(7,-4) =
  1/60-53/180*ep+266561/108000*ep^2-87124181/6480000*ep^3+
  21293362823/388800000*ep^4-6769202801/37324800*ep^5;
fill mncT11(7,-3) =
  1/300*ep-841/18000*ep^2+309163/1080000*ep^3-13185257/12960000*ep^4
  +8539596691/3888000000*ep^5;
fill mncT11(7,-2) =
  1/1800*ep-461/108000*ep^2+3287/720000*ep^3+3937531/77760000*ep^4
  -5571523609/23328000000*ep^5;
fill mncT11(7,-1) =
  1/1800*ep-211/108000*ep^2-62167/6480000*ep^3+3518981/77760000*ep^4
  -169501453/7776000000*ep^5;
fill mncT11(7,0) =
  1/300*ep+17/9000*ep^2-14077/180000*ep^3-119341/6480000*ep^4+
  813955783/1944000000*ep^5;
fill mncT11(7,1) =
  -1/15-5/18*ep+8173/9000*ep^2+7556441/1620000*ep^3+241319777/
  97200000*ep^4-1397739257/388800000*ep^5;
fill mncT11(7,2) =
  -67/15-ep^-1+7363/600*ep+7963583/108000*ep^2+77642911/1296000*
  ep^3-4851581503/129600000*ep^4-72804350141/23328000000*ep^5;
fill mncT11(7,3) =
  -643/10-21*ep^-1+198433/600*ep+37491071/36000*ep^2+40354283/
  432000*ep^3-31200286513/129600000*ep^4-456002246177/7776000000*ep^5;
fill mncT11(7,4) =
  -5243/10-196*ep^-1+2917037/900*ep+150586423/18000*ep^2-
  973581653/648000*ep^3-2685625673/21600000*ep^4-21233987539753/
  11664000000*ep^5;
fill mncT11(7,5) =
  -15239/5-1176*ep^-1+1961923/100*ep+871210943/18000*ep^2-
  2501501699/216000*ep^3+57388478537/21600000*ep^4-52691121964811/
  3888000000*ep^5;
fill mncT11(7,6) =
  -139503/10-5292*ep^-1+17533043/200*ep+886911423/4000*ep^2-
  30367486541/720000*ep^3+82520804861/8640000*ep^4-17712342624601/
  288000000*ep^5;
fill mncT11(7,7) =
  -532091/10-19404*ep^-1+63271401/200*ep+3391764741/4000*ep^2-
  160369010221/2160000*ep^3+45079119479/8640000*ep^4-562005021127483/
  2592000000*ep^5;
fill mncT11(7,8) =
  -878053/5-60984*ep^-1+1021262989/1050*ep+1237038993709/441000*
  ep^2+6809609127931/61740000*ep^3-366227813869447/5186160000*ep^4-
  2411323300828693423/3630312000000*ep^5;
fill mncT11(7,9) =
  -18034071/35-169884*ep^-1+25853745639/9800*ep+22610051516631/
  2744000*ep^2+9993527473165147/6914880000*ep^3-120104412190290221/
  387233280000*ep^4-3028135184250064568279/1626379776000000*ep^5;
fill mncT11(7,10) =
  -6857708/5-429429*ep^-1+325970190527/50400*ep+2784773997117157/
  127008000*ep^2+314001610292351747/45722880000*ep^3-
  95626190195515256131/161310320640000*ep^4-9860721257991817665174811/
  2032510040064000000*ep^5;
fill mncT11(8,-6) =
  353/140-1/6*ep^-1-373727/19600*ep+800940667/8232000*ep^2-
  29289691863/76832000*ep^3+5385992171933273/4356374400000*ep^4-
  709521618026979929/203297472000000*ep^5;
fill mncT11(8,-5) =
  1/84-1961/8820*ep+14678609/7408800*ep^2-35755774219/3111696000*
  ep^3+13000149370291/261382464000*ep^4-95609558172939007/
  548903174400000*ep^5;
fill mncT11(8,-4) =
  1/630*ep-53/2205*ep^2+9018689/55566000*ep^3-5067714581/7779240000*
  ep^4+16436907354443/9801842400000*ep^5;
fill mncT11(8,-3) =
  1/6300*ep-1259/882000*ep^2+3355417/1111320000*ep^3+367419121/
  31116960000*ep^4-16828556763959/196036848000000*ep^5;
fill mncT11(8,-2) =
  1/12600*ep-2167/5292000*ep^2-1838653/2222640000*ep^3+1565353577/
  186701760000*ep^4-1969039700503/130691232000000*ep^5;
fill mncT11(8,-1) =
  1/6300*ep-401/1323000*ep^2-2005079/555660000*ep^3+391786789/
  46675440000*ep^4+154028720287/10890936000000*ep^5;
fill mncT11(8,0) =
  1/630*ep+71/26460*ep^2-2011631/55566000*ep^3-1183313023/
  23337720000*ep^4+68567159309/363031200000*ep^5;
fill mncT11(8,1) =
  -1/21-524/2205*ep+902201/1852200*ep^2+3014463589/777924000*ep^3
  +1208942969/268912000*ep^4-57410968341421/45741931200000*ep^5;
fill mncT11(8,2) =
  -178/35-ep^-1+843481/88200*ep+1007464943/12348000*ep^2+
  326316812099/3111696000*ep^3-3321224463607/726062400000*ep^4-
  81840394319902889/2744515872000000*ep^5;
fill mncT11(8,3) =
  -989/10-28*ep^-1+2534177/6300*ep+1411806601/882000*ep^2+
  167103911539/222264000*ep^3-5874194518813/17287200000*ep^4-
  44948630072541313/196036848000000*ep^5;
fill mncT11(8,4) =
  -5094/5-336*ep^-1+2757512/525*ep+1203147311/73500*ep^2+
  41798420893/18522000*ep^3-23640276255767/12965400000*ep^4-
  48468564911944603/16336404000000*ep^5;
fill mncT11(8,5) =
  -7207-2520*ep^-1+16965961/420*ep+4066003721/35280*ep^2+
  88549370213/74088000*ep^3-51961797853837/10372320000*ep^4-
  112317791140034653/4356374400000*ep^5;
fill mncT11(8,6) =
  -78521/2-13860*ep^-1+187205549/840*ep+221181512717/352800*ep^2
  -115715020399/29635200*ep^3-289203450863189/20744640000*ep^4-
  1302317090554369133/8712748800000*ep^5;
fill mncT11(8,7) =
  -878053/5-60984*ep^-1+1021262989/1050*ep+1237038993709/441000*
  ep^2+6809609127931/61740000*ep^3-366227813869447/5186160000*ep^4-
  2411323300828693423/3630312000000*ep^5;
fill mncT11(8,8) =
  -23526338/35-226512*ep^-1+13076140537/3675*ep+2369104264591/
  220500*ep^2+276406698978143/216090000*ep^3-1272364093560383/
  3630312000*ep^4-10493366424372887233/4235364000000*ep^5;
fill mncT11(8,9) =
  -79327391/35-736164*ep^-1+333168518807/29400*ep+894920683392109/
  24696000*ep^2+54340449286415137/6914880000*ep^3-1380763360930866373/
  1161699840000*ep^4-4426483375360648100903/542126592000000*ep^5;
fill mncT11(8,10) =
  -6878157-2147145*ep^-1+325203879839/10080*ep+558376514581289/
  5080320*ep^2+2276261966505252557/64012032000*ep^3-
  353006015772044616599/161310320640000*ep^4-1416153373047555093193573/
  58071715430400000*ep^5;
fill mncT11(9,-6) =
  1/112-5471/31360*ep+14340133/8780800*ep^2-24494628927/2458624000*
  ep^3+6237727760217/137682944000*ep^4-864838163864034797/
  5204415283200000*ep^5;
fill mncT11(9,-5) =
  1/1176*ep-13513/987840*ep^2+11790271/118540800*ep^3-304304606929/
  697019904000*ep^4+148251273664517/117099343872000*ep^5;
fill mncT11(9,-4) =
  1/17640*ep-563/987840*ep^2+2929291/1778112000*ep^3+9789209929/
  3485099520000*ep^4-303031735346099/8782450790400000*ep^5;
fill mncT11(9,-3) =
  1/58800*ep-1793/16464000*ep^2-338951/5927040000*ep^3+1515706901/
  774466560000*ep^4-162680266832969/29274835968000000*ep^5;
fill mncT11(9,-2) =
  1/58800*ep-2929/49392000*ep^2-210289/658560000*ep^3+10265988779/
  6970199040000*ep^4-7503545288719/29274835968000000*ep^5;
fill mncT11(9,-1) =
  1/17640*ep-121/2963520*ep^2-2512789/1778112000*ep^3+15188895707/
  10455298560000*ep^4+2773974518263/325275955200000*ep^5;
fill mncT11(9,0) =
  1/1176*ep+2167/987840*ep^2-2147569/118540800*ep^3-30974065249/
  697019904000*ep^4+1001999162669/13011038208000*ep^5;
fill mncT11(9,1) =
  -1/28-227/1120*ep+4829183/19756800*ep^2+17493523283/5531904000*
  ep^3+2131548126517/398297088000*ep^4+1653666696353377/
  1301103820800000*ep^5;
fill mncT11(9,2) =
  -787/140-ep^-1+2427349/352800*ep+8586842269/98784000*ep^2+
  7377872489189/49787136000*ep^3+373227039620317/7744665600000*ep^4-
  6457306438212806471/175649015808000000*ep^5;
fill mncT11(9,3) =
  -4983/35-36*ep^-1+4556749/9800*ep+18784846207/8232000*ep^2+
  2508753664829/1382976000*ep^3-667379229950441/5808499200000*ep^4-
  2514512912366469071/4879139328000000*ep^5;
fill mncT11(9,4) =
  -12723/7-540*ep^-1+15515811/1960*ep+9610794797/329280*ep^2+
  5562667894709/460992000*ep^3-3161052127785863/1161699840000*ep^4-
  1879943028022084523/325275955200000*ep^5;
fill mncT11(9,5) =
  -108175/7-4950*ep^-1+178300085/2352*ep+489246542041/1975680*ep^2
  +97721162938507/1659571200*ep^3-7710456819734617/464679936000*ep^4
  -20412668993201052719/390331146240000*ep^5;
fill mncT11(9,6) =
  -1388409/14-32670*ep^-1+1989252439/3920*ep+5225117077949/3292800
  *ep^2+152407746348439/553190400*ep^3-57305585470090057/774466560000*
  ep^4-229501098284133484783/650551910400000*ep^5;
fill mncT11(9,7) =
  -18034071/35-169884*ep^-1+25853745639/9800*ep+22610051516631/
  2744000*ep^2+9993527473165147/6914880000*ep^3-120104412190290221/
  387233280000*ep^4-3028135184250064568279/1626379776000000*ep^5;
fill mncT11(9,8) =
  -79327391/35-736164*ep^-1+333168518807/29400*ep+894920683392109/
  24696000*ep^2+54340449286415137/6914880000*ep^3-1380763360930866373/
  1161699840000*ep^4-4426483375360648100903/542126592000000*ep^5;
fill mncT11(9,9) =
  -487558929/56-2760615*ep^-1+656747596753/15680*ep+
  366565498288861/2634240*ep^2+144763052912195807/3687936000*ep^3-
  10749363204853737433/3097866240000*ep^4-8985300007371764321381/
  289134182400000*ep^5;
fill mncT11(9,10) =
  -1673149335/56-9202050*ep^-1+1289073256967/9408*ep+
  11312477611942837/23708160*ep^2+10298545085451680663/59744563200*ep^3
  -134009329612247902531/30111259852800*ep^4-
  40019532931754029975386181/379401874145280000*ep^5;
fill mncT11(10,-6) =
  1/2016*ep-42589/5080320*ep^2+827883523/12802406400*ep^3-
  9821121950233/32262064128000*ep^4+15684812553506807/16260080320512000*
  ep^5;
fill mncT11(10,-5) =
  1/42336*ep-27589/106686720*ep^2+34849789/38407219200*ep^3+
  317044794767/677503346688000*ep^4-5172935456652193/341461686730752000*
  ep^5;
fill mncT11(10,-4) =
  1/211680*ep-3737/106686720*ep^2+3220069/192036096000*ep^3+
  1849098148199/3387516733440000*ep^4-17893832061607469/
  8536542168268800000*ep^5;
fill mncT11(10,-3) =
  1/352800*ep-11797/889056000*ep^2-12737699/320060160000*ep^3+
  342043914019/1129172244480000*ep^4-5184963405893189/
  14227570280448000000*ep^5;
fill mncT11(10,-2) =
  1/211680*ep-1133/106686720*ep^2-20839151/192036096000*ep^3+
  1005421668539/3387516733440000*ep^4+3636684674926231/
  8536542168268800000*ep^5;
fill mncT11(10,-1) =
  1/42336*ep+551/106686720*ep^2-23198471/38407219200*ep^3+
  34557361427/677503346688000*ep^4+1401049384583171/341461686730752000*
  ep^5;
fill mncT11(10,0) =
  1/2016*ep+1193/725760*ep^2-123315497/12802406400*ep^3-
  1087179659173/32262064128000*ep^4+60277238568413/2322868617216000*ep^5
  ;
fill mncT11(10,1) =
  -1/36-493/2835*ep+11263261/114307200*ep^2+741728374799/
  288054144000*ep^3+812764988352467/145179288576000*ep^4+
  6149677687096924787/1829259036057600000*ep^5;
fill mncT11(10,2) =
  -3839/630-ep^-1+13517821/3175200*ep+722967654779/8001504000*ep^2
  +762299414847911/4032758016000*ep^3+5863782749601411287/
  50812751001600000*ep^4-2410867506661744804829/128048132524032000000*
  ep^5;
fill mncT11(10,3) =
  -2733/14-45*ep^-1+12100511/23520*ep+36522506621/11854080*ep^2+
  499108024384793/149361408000*ep^3+238057627322242549/376390748160000*
  ep^4-730345405419777932839/948504685363200000*ep^5;
fill mncT11(10,4) =
  -42475/14-825*ep^-1+158826085/14112*ep+1722812465123/35562240*
  ep^2+2862905548098763/89616844800*ep^3+51383427764068223/
  225834448896000*ep^4-6023904889151281594517/569102811217920000*ep^5;
fill mncT11(10,5) =
  -428725/14-9075*ep^-1+1863930935/14112*ep+17420500082353/
  35562240*ep^2+19591470539173193/89616844800*ep^3-3490364875570682747/
  225834448896000*ep^4-59881195837843542836887/569102811217920000*ep^5;
fill mncT11(10,6) =
  -1604691/7-70785*ep^-1+24874620107/23520*ep+217302808748161/
  59270400*ep^2+37867626431250733/29872281600*ep^3-
  44685664886587404371/376390748160000*ep^4-759955588865113975328047/
  948504685363200000*ep^5;
fill mncT11(10,7) =
  -6857708/5-429429*ep^-1+325970190527/50400*ep+2784773997117157/
  127008000*ep^2+314001610292351747/45722880000*ep^3-
  95626190195515256131/161310320640000*ep^4-9860721257991817665174811/
  2032510040064000000*ep^5;
fill mncT11(10,8) =
  -6878157-2147145*ep^-1+325203879839/10080*ep+558376514581289/
  5080320*ep^2+2276261966505252557/64012032000*ep^3-
  353006015772044616599/161310320640000*ep^4-1416153373047555093193573/
  58071715430400000*ep^5;
fill mncT11(10,9) =
  -1673149335/56-9202050*ep^-1+1289073256967/9408*ep+
  11312477611942837/23708160*ep^2+10298545085451680663/59744563200*ep^3
  -134009329612247902531/30111259852800*ep^4-
  40019532931754029975386181/379401874145280000*ep^5;
fill mncT11(10,10) =
  -29016110695/252-34763300*ep^-1+64837836509717/127008*ep+
  588017945454375487/320060160*ep^2+617147766869674120613/806551603200*
  ep^3+5319449752682429703959/406502008012800*ep^4-
  2063640067151239842477253231/5121925300961280000*ep^5;
*--#] gtabls.h : 
*--#[ poch.h :
*
*	Table can be extended with the procedure makepochs
*
CTable,relax,mncpoch(0:21,0:20);
Fill mncpoch(0,0) = 1;
Fill mncpoch(1,0) = 1;
Fill mncpoch(2,0) = 1;
Fill mncpoch(3,0) = 1;
Fill mncpoch(3,1) = 1/2+1/4*ep+1/8*ep^2+1/16*ep^3+1/32*ep^4+1/64*ep^5+1/128*
      ep^6;
Fill mncpoch(4,0) = 1;
Fill mncpoch(4,1) = 1/3+1/9*ep+1/27*ep^2+1/81*ep^3+1/243*ep^4+1/729*ep^5+1/2187
      *ep^6;
Fill mncpoch(4,2) = 1/12+5/72*ep+19/432*ep^2+65/2592*ep^3+211/15552*ep^4+665/
      93312*ep^5+2059/559872*ep^6;
Fill mncpoch(5,0) = 1;
Fill mncpoch(5,1) = 1/4+1/16*ep+1/64*ep^2+1/256*ep^3+1/1024*ep^4+1/4096*ep^5+1/
      16384*ep^6;
Fill mncpoch(5,2) = 1/24+7/288*ep+37/3456*ep^2+175/41472*ep^3+781/497664*ep^4+
      3367/5971968*ep^5+14197/71663616*ep^6;
Fill mncpoch(5,3) = 1/144+13/1728*ep+115/20736*ep^2+865/248832*ep^3+5971/
      2985984*ep^4+39193/35831808*ep^5+249355/429981696*ep^6;
Fill mncpoch(6,0) = 1;
Fill mncpoch(6,1) = 1/5+1/25*ep+1/125*ep^2+1/625*ep^3+1/3125*ep^4+1/15625*ep^5+
      1/78125*ep^6;
Fill mncpoch(6,2) = 1/40+9/800*ep+61/16000*ep^2+369/320000*ep^3+2101/6400000*
      ep^4+11529/128000000*ep^5+61741/2560000000*ep^6;
Fill mncpoch(6,3) = 1/360+47/21600*ep+1489/1296000*ep^2+39743/77760000*ep^3+
      965041/4665600000*ep^4+22102367/279936000000*ep^5+487056529/
      16796160000000*ep^6;
Fill mncpoch(6,4) = 1/2880+77/172800*ep+3799/10368000*ep^2+153713/622080000*
      ep^3+5576431/37324800000*ep^4+189395297/2239488000000*ep^5+6168915439/
      134369280000000*ep^6;
Fill mncpoch(7,0) = 1;
Fill mncpoch(7,1) = 1/6+1/36*ep+1/216*ep^2+1/1296*ep^3+1/7776*ep^4+1/46656*ep^5
      +1/279936*ep^6;
Fill mncpoch(7,2) = 1/60+11/1800*ep+91/54000*ep^2+671/1620000*ep^3+4651/
      48600000*ep^4+31031/1458000000*ep^5+201811/43740000000*ep^6;
Fill mncpoch(7,3) = 1/720+37/43200*ep+919/2592000*ep^2+19153/155520000*ep^3+
      361711/9331200000*ep^4+6418657/559872000000*ep^5+109195759/33592320000000
      *ep^6;
Fill mncpoch(7,4) = 1/8640+19/172800*ep+2059/31104000*ep^2+20111/622080000*ep^3
      +1568371/111974400000*ep^4+4198453/746496000000*ep^5+864917299/
      403107840000000*ep^6;
Fill mncpoch(7,5) = 1/86400+29/1728000*ep+4669/311040000*ep^2+22267/2073600000*
      ep^3+7580461/1119744000000*ep^4+88399969/22394880000000*ep^5+8820914509/
      4031078400000000*ep^6;
Fill mncpoch(8,0) = 1;
Fill mncpoch(8,1) = 1/7+1/49*ep+1/343*ep^2+1/2401*ep^3+1/16807*ep^4+1/117649*
      ep^5+1/823543*ep^6;
Fill mncpoch(8,2) = 1/84+13/3528*ep+127/148176*ep^2+1105/6223392*ep^3+9031/
      261382464*ep^4+70993/10978063488*ep^5+543607/461078666496*ep^6;
Fill mncpoch(8,3) = 1/1260+107/264600*ep+7669/55566000*ep^2+460223/11668860000*
      ep^3+24973741/2450460600000*ep^4+1270750247/514596726000000*ep^5+
      61865369749/108065312460000000*ep^6;
Fill mncpoch(8,4) = 1/20160+319/8467200*ep+64171/3556224000*ep^2+10419739/
      1493614080000*ep^3+1493652451/627317913600000*ep^4+197497515259/
      263473523712000000*ep^5+24696622766131/110658879959040000000*ep^6;
Fill mncpoch(8,5) = 1/302400+17/4704000*ep+128431/53343360000*ep^2+9466693/
      7468070400000*ep^3+5469663511/9409768704000000*ep^4+321083468933/
      1317367618560000000*ep^5+159551679717991/1659883199385600000000*ep^6;
Fill mncpoch(8,6) = 1/3628800+223/508032000*ep+268921/640120320000*ep^2+
      28291163/89616844800000*ep^3+23293096201/112917224448000000*ep^4+
      650533401001/5269470474240000000*ep^5+1389059807609881/
      19918598392627200000000*ep^6;
Fill mncpoch(9,0) = 1;
Fill mncpoch(9,1) = 1/8+1/64*ep+1/512*ep^2+1/4096*ep^3+1/32768*ep^4+1/262144*
      ep^5+1/2097152*ep^6;
Fill mncpoch(9,2) = 1/112+15/6272*ep+169/351232*ep^2+1695/19668992*ep^3+15961/
      1101463552*ep^4+144495/61681958912*ep^5+1273609/3454189699072*ep^6;
Fill mncpoch(9,3) = 1/2016+73/338688*ep+3565/56899584*ep^2+145585/9559130112*
      ep^3+5369221/1605933858816*ep^4+185450473/269796888281088*ep^5+6121074205/
      45325877231222784*ep^6;
Fill mncpoch(9,4) = 1/40320+533/33868800*ep+178669/28449792000*ep^2+48214517/
      23897825280000*ep^3+11455801981/20074173235200000*ep^4+2504107460933/
      16862305517568000000*ep^5+516331837889869/14164336634757120000000*ep^6;
Fill mncpoch(9,5) = 1/806400+743/677376000*ep+334699/568995840000*ep^2+
      118501307/477956505600000*ep^3+36341076451/401483464704000000*ep^4+
      10135733515643/337246110351360000000*ep^5+2644835876174899/
      283286732695142400000000*ep^6;
Fill mncpoch(9,6) = 1/14515200+341/4064256000*ep+621139/10241925120000*ep^2+
      97473409/2867739033600000*ep^3+118218740011/7226702364672000000*ep^4+
      1601369656249/224830740234240000000*ep^5+14751190477417339/
      5099161188512563200000000*ep^6;
Fill mncpoch(9,7) = 1/203212800+481/56899584000*ep+1227199/143386951680000*ep^2
      +29920141/4460927385600000*ep^3+457513138951/101173833105408000000*ep^4+
      78464166359381/28328673269514240000000*ep^5+113616040090237399/
      71388256639175884800000000*ep^6;
Fill mncpoch(10,0) = 1;
Fill mncpoch(10,1) = 1/9+1/81*ep+1/729*ep^2+1/6561*ep^3+1/59049*ep^4+1/531441*
      ep^5+1/4782969*ep^6;
Fill mncpoch(10,2) = 1/144+17/10368*ep+217/746496*ep^2+2465/53747712*ep^3+26281/
      3869835264*ep^4+269297/278628139008*ep^5+2685817/20061226008576*ep^6;
Fill mncpoch(10,3) = 1/3024+191/1524096*ep+24385/768144384*ep^2+2601215/
      387144769536*ep^3+250388161/195120963846144*ep^4+22554022271/
      98340965778456576*ep^5+1939873287745/49563846752342114304*ep^6;
Fill mncpoch(10,4) = 1/72576+275/36578304*ep+47485/18435465216*ep^2+6589955/
      9291474468864*ep^3+803944381/4682903132307456*ep^4+90085350275/
      2360183178682957824*ep^5+9507042710845/1189532322056210743296*ep^6;
Fill mncpoch(10,5) = 1/1814400+1879/4572288000*ep+2134141/11522165760000*ep^2+
      1899351439/29035857715200000*ep^3+1459738363381/73170361442304000000*ep^4
      +1017224854753399/184389310834606080000000*ep^5+661228869152666221/
      464661063303207321600000000*ep^6;
Fill mncpoch(10,6) = 1/43545600+2509/109734912000*ep+3714811/276531978240000*
      ep^2+4239682369/696860585164800000*ep^3+4130738255851/
      1756088674615296000000*ep^4+3619589955939529/4425343460030545920000000*
      ep^5+2941570541394569491/11151865519276975718400000000*ep^6;
Fill mncpoch(10,7) = 1/914457600+3349/2304433152000*ep+6527971/5807171543040000
      *ep^2+9723178009/14634072288460800000*ep^3+12298207783411/
      36877862166921216000000*ep^4+13950084494004769/92932212660641464320000000
      *ep^5+14659641516358575451/234189175904816490086400000000*ep^6;
Fill mncpoch(10,8) = 1/14631321600+4609/36870930432000*ep+12335311/
      92914744688640000*ep^2+25265669869/234145156615372800000*ep^3+
      44132951818351/590045794670739456000000*ep^4+69557603785127029/
      1486915402570263429120000000*ep^5+102302222285618631991/
      3747026814477063841382400000000*ep^6;
Fill mncpoch(11,0) = 1;
Fill mncpoch(11,1) = 1/10+1/100*ep+1/1000*ep^2+1/10000*ep^3+1/100000*ep^4+1/
      1000000*ep^5+1/10000000*ep^6;
Fill mncpoch(11,2) = 1/180+19/16200*ep+271/1458000*ep^2+3439/131220000*ep^3+
      40951/11809800000*ep^4+468559/1062882000000*ep^5+5217031/95659380000000*
      ep^6;
Fill mncpoch(11,3) = 1/4320+121/1555200*ep+9781/559872000*ep^2+660241/
      201553920000*ep^3+40194301/72559411200000*ep^4+2288547961/
      26121388032000000*ep^5+124353617221/9403699691520000000*ep^6;
Fill mncpoch(11,4) = 1/120960+1207/304819200*ep+913789/768144384000*ep^2+
      555426703/1935723847680000*ep^3+296460129781/4878024096153600000*ep^4+
      145189272301687/12292620722307072000000*ep^5+66898216741040749/
      30977404220213821440000000*ep^6;
Fill mncpoch(11,5) = 1/3628800+1627/9144576000*ep+1597129/23044331520000*ep^2+
      1226220883/58071715430400000*ep^3+811472900641/146340722884608000000*ep^4
      +486007890570907/368778621669212160000000*ep^5+271021530780821689/
      929322126606414643200000000*ep^6;
Fill mncpoch(11,6) = 1/108864000+2131/274337280000*ep+2671153/691329945600000*
      ep^2+514496399/348430292582400000*ep^3+2108003826121/
      4390221686538240000000*ep^4+1548441818935891/11063358650076364800000000*
      ep^5+1051436207524510753/27879663798192439296000000000*ep^6;
Fill mncpoch(11,7) = 1/3048192000+2761/7681443840000*ep+4410583/
      19357238476800000*ep^2+1070229857/9756048192307200000*ep^3+5479227875671/
      122926207223070720000000*ep^4+5000355380608621/
      309774042202138214400000000*ep^5+4201660097307941983/
      780630586349388300288000000000*ep^6;
Fill mncpoch(11,8) = 1/73156608000+3601/184354652160000*ep+7435423/
      464573723443200000*ep^2+2319380921/234145156615372800000*ep^3+
      15220627743871/2950228973353697280000000*ep^4+17785682685460261/
      7434577012851317145600000000*ep^5+19141633553094561223/
      18735134072385319206912000000000*ep^6;
Fill mncpoch(11,9) = 1/1316818944000+4861/3318383738880000*ep+13560283/
      8362327021977600000*ep^2+5736572237/4214612819076710400000*ep^3+
      51361032836971/53104121520366551040000000*ep^4+82500584060043721/
      133822386231323708620800000000*ep^5+123092369468749649683/
      337232413302935745724416000000000*ep^6;
Fill mncpoch(12,0) = 1;
Fill mncpoch(12,1) = 1/11+1/121*ep+1/1331*ep^2+1/14641*ep^3+1/161051*ep^4+1/
      1771561*ep^5+1/19487171*ep^6;
Fill mncpoch(12,2) = 1/220+21/24200*ep+331/2662000*ep^2+4641/292820000*ep^3+
      61051/32210200000*ep^4+771561/3543122000000*ep^5+9487171/389743420000000*
      ep^6;
Fill mncpoch(12,3) = 1/5940+299/5880600*ep+59701/5821794000*ep^2+9950399/
      5763576060000*ep^3+1495099501/5705940299400000*ep^4+210020850599/
      5648880896406000000*ep^5+28144165209301/5592392087441940000000*ep^6;
Fill mncpoch(12,4) = 1/190080+1691/752716800*ep+1792261/2980758528000*ep^2+
      1523994731/11803803770880000*ep^3+1137122864101/46743062932684800000*ep^4
      +777937168743371/185102529213431808000000*ep^5+500357399225265541/
      733006015685189959680000000*ep^6;
Fill mncpoch(12,5) = 1/6652800+15797/184415616000*ep+150376909/5112000875520000
      *ep^2+1118222752373/141704664269414400000*ep^3+7158394096103581/
      3928053293548167168000000*ep^4+41422030615640017157/
      108885637297155193896960000000*ep^5+222897788899387733574829/
      3018309865877141974823731200000000*ep^6;
Fill mncpoch(12,6) = 1/239500800+20417/6638962176000*ep+244703449/
      184032031518720000*ep^2+2248752686753/5101367913698918400000*ep^3+
      17547631508902441/141409918567734018048000000*ep^4+122492088186769294577/
      3919882942697586980290560000000*ep^5+788811236322261874520569/
      108659155171577111093654323200000000*ep^6;
Fill mncpoch(12,7) = 1/8382528000+25961/232363676160000*ep+388631233/
      6441121103155200000*ep^2+880664848501/35709575395892428800000*ep^3+
      41959661109350161/4949347149870690631680000000*ep^4+355116449377006587161/
      137195902994415544310169600000000*ep^5+2757576831668386393741153/38030704\
      31005198888277901312000000000*ep^6;
Fill mncpoch(12,8) = 1/268240896000+32891/7435637637120000*ep+616565863/
      206115875300966400000*ep^2+1735225134619/1142706412668557721600000*ep^3+
      102085212023898511/158379108795862100213760000000*ep^4+
      1062566968702623268391/4390268895821297417925427200000000*ep^5+
      10121165924777565643690783/121698253792166364424892841984000000000*ep^6;
Fill mncpoch(12,9) = 1/7242504192000+42131/200762216202240000*ep+1005856303/
      5565128633126092800000*ep^2+3594047582563/30853073142051058483200000*ep^3
      +268130210338309111/4276235937488276705771520000000*ep^4+
      3540090112228599454031/118537260187175030283986534400000000*ep^5+
      42831598561769824598937223/3285852852388491839472106733568000000000*ep^6;
Fill mncpoch(12,10) = 1/144850083840000+55991/4015244324044800000*ep+1781891563/
      111302572662521856000000*ep^2+8533450995199/617061462841021169664000000*
      ep^3+859498364305599811/85524718749765534115430400000000*ep^4+
      15452737441504212834491/2370745203743500605679730688000000000*ep^5+
      257006539501018214484982483/65717057047769836789442134671360000000000*
      ep^6;
Fill mncpoch(13,0) = 1;
Fill mncpoch(13,1) = 1/12+1/144*ep+1/1728*ep^2+1/20736*ep^3+1/248832*ep^4+1/
      2985984*ep^5+1/35831808*ep^6;
Fill mncpoch(13,2) = 1/264+23/34848*ep+397/4599936*ep^2+6095/607191552*ep^3+
      87781/80149284864*ep^4+1214423/10579705602048*ep^5+16344637/
      1396521139470336*ep^6;
Fill mncpoch(13,3) = 1/7920+181/5227200*ep+21871/3449952000*ep^2+2205361/
      2276968320000*ep^3+200416951/1502799091200000*ep^4+17022590641/
      991847400192000000*ep^5+1378875935431/654619284126720000000*ep^6;
Fill mncpoch(13,4) = 1/285120+763/564537600*ep+364699/1117784448000*ep^2+
      139778527/2213213207040000*ep^3+46985048971/4382162149939200000*ep^4+
      14473200299383/8676681056879616000000*ep^5+4189304622793459/
      17179828492621639680000000*ep^6;
Fill mncpoch(13,5) = 1/11404800+2021/45163008000*ep+2459191/178845511680000*
      ep^2+2335527761/708228226252800000*ep^3+1907847025231/
      2804583775961088000000*ep^4+1407526687069601/11106151752805908480000000*
      ep^5+964841205958233871/43980360941111397580800000000*ep^6;
Fill mncpoch(13,6) = 1/479001600+18107/13277924352000*ep+192204079/
      368064063037440000*ep^2+1562214174863/10202735827397836800000*ep^3+
      10767108840037111/282819837135468036096000000*ep^4+66294052036125743567/
      7839765885395173960581120000000*ep^5+376037049102838201214599/
      217318310343154222187308646400000000*ep^6;
Fill mncpoch(13,7) = 1/20118067200+22727/557672822784000*ep+297202819/
      15458690647572480000*ep^2+2935291198643/428514904750709145600000*ep^3+
      24328154177767771/11878433159689657516032000000*ep^4+
      178690124337412845587/329270167186597306344407040000000*ep^5+
      1201585423541685547826539/9127369034412477331866963148800000000*ep^6;
Fill mncpoch(13,8) = 1/804722688000+28271/22306912911360000*ep+453937243/
      618347625902899200000*ep^2+1090383854767/3428119238005673164800000*ep^3+
      54553594631909011/475137326387586300641280000000*ep^4+
      481135252976716402571/13170806687463892253776281600000000*ep^5+
      3868999266044601283680163/365094761376499093274678525952000000000*ep^6;
Fill mncpoch(13,9) = 1/28970016768000+35201/803048864808960000*ep+697880173/
      22260514532504371200000*ep^2+411529154909/24682458513640846786560000*ep^3
      +125851020719893261/17104943749953106823086080000000*ep^4+
      1353282826565576701301/474149040748700121135946137600000000*ep^5+
      13247249254144047823696093/13143411409553967357888426934272000000000*ep^6
      ;
Fill mncpoch(13,10) = 1/869100503040000+44441/24091465944268800000*ep+
      1108515013/667815435975131136000000*ep^2+4106181518569/
      3702368777046127017984000000*ep^3+315556606877781061/
      513148312498593204692582400000000*ep^4+4269025874116273704941/14224471222\
      461003634078384128000000000*ep^5+52693048330978416857350933/3943023422866\
      19020736652808028160000000000*ep^6;
Fill mncpoch(13,11) = 1/19120211066880000+58301/530012250773913600000*ep+
      1916566873/14691939591452884992000000*ep^2+376756195621/
      3258084523800591775825920000*ep^3+968286715791163561/
      11289262874969050503236812800000000*ep^4+17689479754981800660401/31293836\
      6894142079949724450816000000000*ep^5+297869237735026174010508793/
      8674651530305618456206361776619520000000000*ep^6;
Fill mncpoch(14,0) = 1;
Fill mncpoch(14,1) = 1/13+1/169*ep+1/2197*ep^2+1/28561*ep^3+1/371293*ep^4+1/
      4826809*ep^5+1/62748517*ep^6;
Fill mncpoch(14,2) = 1/312+25/48672*ep+469/7592832*ep^2+7825/1184481792*ep^3+
      122461/184779159552*ep^4+1840825/28825548890112*ep^5+26916709/
      4496785626857472*ep^6;
Fill mncpoch(14,3) = 1/10296+431/17667936*ep+123985/30318178176*ep^2+29756735/
      52025993750016*ep^3+6435002161/89276605275027456*ep^4+1300327044191/
      153198654651947114496*ep^5+250535610806545/262888891382741248475136*ep^6;
Fill mncpoch(14,4) = 1/411840+3013/3533587200*ep+5684779/30318178176000*ep^2+
      8597132257/260129968750080000*ep^3+11398215827131/2231915131875686400000*
      ep^4+13843191192775273/19149831831493389312000000*ep^5+
      15792076962253449859/164305557114213280296960000000*ep^6;
Fill mncpoch(14,5) = 1/18532800+11899/477034272000*ep+85194151/
      12278862161280000*ep^2+475777842799/316057912031347200000*ep^3+
      2283980112402751/8135330655686876928000000*ep^4+9896078581316259199/
      209403411077380212126720000000*ep^5+39815208848047266256351/
      5390043801131766660141772800000000*ep^6;
Fill mncpoch(14,6) = 1/889574400+30233/45795290112000*ep+535325959/
      2357541534965760000*ep^2+7251045288557/121366238220037324800000*ep^3+
      83204158230308311/6247933943567521480704000000*ep^4+852093272814154275653/
      321643639414856005826641920000000*ep^5+8031393576834107804233519/16558214\
      557076787179955526041600000000*ep^6;
Fill mncpoch(14,7) = 1/43589145600+263111/15707784508416000*ep+39775926271/
      5660457225452789760000*ep^2+4534773218406131/2039802365764167317913600000
      *ep^3+433223309194517878591/735063180526775334683344896000000*ep^4+
      36623467593521271300764651/264887367734628759606490166722560000000*ep^5+
      2830261534635430995623633510311/95454811836850819811794796480141721600000\
      000*ep^6;
Fill mncpoch(14,8) = 1/2092278988800+323171/753973656403968000*ep+59185576531/
      271701946821733908480000*ep^2+8089458944857991/
      97910513556680031259852800000*ep^3+919076213422688818051/
      35283032665285216064800555008000000*ep^4+91823184971687961712907711/
      12714593651262180461111528002682880000000*ep^5+
      8345162024035009976100870632971/45818309681688393509661502310468026368000\
      00000*ep^6;
Fill mncpoch(14,9) = 1/94152554496000+395243/33928814538178560000*ep+
      87671530027/12226587606978025881600000*ep^2+2881624291392787/
      881194622010120281338675200000*ep^3+1957498343068993541371/15877364699378\
      34722916024975360000000*ep^4+232904005553356464226598423/5721567143067981\
      20750018760120729600000000*ep^5+25131019512276517065840272175427/
      206182393567597770793476760397106118656000000000*ep^6;
Fill mncpoch(14,10) = 1/3766102179840000+485333/1357152581527142400000*ep+
      131395179997/489063504279121035264000000*ep^2+5249102644578733/
      35247784880404811253547008000000*ep^3+4321956629319483821221/635094587975\
      13388916640999014400000000*ep^4+622269078288748761680398313/2288626857227\
      1924830000750404829184000000000*ep^5+81191240775309893005627356193597/
      8247295742703910831739070415884244746240000000000*ep^6;
Fill mncpoch(14,11) = 1/124281371934720000+605453/44786035190395699200000*ep+
      204122194357/16139095641210994163712000000*ep^2+10152934241811301/
      1163176901053358771367051264000000*ep^3+10419808934951351201821/209581214\
      0317941834249152967475200000000*ep^4+1873896527555105068043136833/
      755246862884973519390024763359363072000000000*ep^5+
      306283691665229113778968952573557/272160759509229057447389323724180076625\
      920000000000*ep^6;
Fill mncpoch(14,12) = 1/2982752926433280000+785633/1074864844569496780800000*ep
      +345677548297/387338295389063859929088000000*ep^2+22609770372241993/
      27916245625280610512809230336000000*ep^3+30788951063304162695521/
      50299491367630604021979671219404800000000*ep^4+
      7421449730141249102522110613/18125924709239364465360594320624713728000000\
      000*ep^5+1643480504042079377071402842823897/65318582282214973787373437693\
      80321839022080000000000*ep^6;
Fill mncpoch(15,0) = 1;
Fill mncpoch(15,1) = 1/14+1/196*ep+1/2744*ep^2+1/38416*ep^3+1/537824*ep^4+1/
      7529536*ep^5+1/105413504*ep^6;
Fill mncpoch(15,2) = 1/364+27/66248*ep+547/12057136*ep^2+9855/2194398752*ep^3+
      166531/399380572864*ep^4+2702727/72687264261248*ep^5+42664987/
      13229082095547136*ep^6;
Fill mncpoch(15,3) = 1/13104+253/14309568*ep+42715/15626048256*ep^2+6015745/
      17063644695552*ep^3+763256971/18633500007542784*ep^4+90472789513/
      20347782008236720128*ep^5+10223601479155/22219777952994498379776*ep^6;
Fill mncpoch(15,4) = 1/576576+3875/6925830912*ep+9400015/83193080914944*ep^2+
      18271772975/999315287950307328*ep^3+31127621401111/
      12003775238859091623936*ep^4+48562095793871375/
      144189348169175408586719232*ep^5+71141542266920852455/
      1732002450208135007943671414784*ep^6;
Fill mncpoch(15,5) = 1/28828800+25381/1731457728000*ep+387438661/
      103991351143680000*ep^2+4610928219841/6245720549689420800000*ep^3+
      47147998264059421/375117976214346613248000000*ep^4+434927426929788929401/
      22529585651433657591674880000000*ep^5+3723760724060950629591781/135312691\
      4225105474955993292800000000*ep^6;
Fill mncpoch(15,6) = 1/1556755200+96163/280496151936000*ep+5412131209/
      50539796655828480000*ep^2+232845928739887/9106260561447175526400000*ep^3+
      8480563352761350841/1640766027961552086346752000000*ep^4+
      275468243066220953681263/295633222918112454917957775360000000*ep^5+
      8229495794026176501671293609/53267194105385502127117631964364800000000*
      ep^6;
Fill mncpoch(15,7) = 1/87178291200+237371/31415569016832000*ep+32340901531/
      11320914450905579520000*ep^2+3319563339382991/
      4079604731528334635827200000*ep^3+285218744266688443051/
      1470126361053550669366689792000000*ep^4+21662662113612051435032711/
      529774735469257519212980333445120000000*ep^5+
      1502482345725330152998011257971/19090962367370163962358959296028344320000\
      0000*ep^6;
Fill mncpoch(15,8) = 1/4881984307200+288851/1759271864942592000*ep+6744421573/
      90567315607244636160000*ep^2+5749983097429271/
      228457864965586739606323200000*ep^3+581227874122347314131/
      82327076218998837484534628352000000*ep^4+7369181867632927309499513/
      4238197883754060153703842667560960000000*ep^5+
      4158040723545531838249255762651/10690938925727291818921017205775872819200\
      000000*ep^6;
Fill mncpoch(15,9) = 1/263627152588800+348911/95000680706899968000*ep+
      9738077953/4890635042791210352640000*ep^2+9844065830429531/
      12336724708141683938741452800000*ep^3+1172462467897944945991/444566211582\
      5937224164869931008000000*ep^4+17428909842197294946102293/228862685722719\
      248300007504048291840000000*ep^5+11485502999402118579489581785711/
      577310701989273758221734929111897132236800000000*ep^6;
Fill mncpoch(15,10) = 1/13181357629440000+420983/4750034035344998400000*ep+
      14072518921/244531752139560517632000000*ep^2+3388741583229943/
      123367247081416839387414528000000*ep^3+2393629384830687205471/22228310579\
      1296861208243496550400000000*ep^4+6010531141202007201947387/1634733469447\
      994630714339314630656000000000*ep^5+32711862019428960669368433503047/
      28865535099463687911086746455594856611840000000000*ep^6;
Fill mncpoch(15,11) = 1/579979735695360000+511073/209001497555179929600000*ep+
      20650028431/10759397094140662775808000000*ep^2+5993247069118249/
      5428158871582340933046239232000000*ep^3+5093287527115002467521/9780456654\
      817061893162713848217600000000*ep^4+107624328462384132170626979/
      503497908589982346260016508906242048000000000*ep^5+
      100582992277662265940130925269817/127008354437640226808781684404617369092\
      0960000000000*ep^6;
Fill mncpoch(15,12) = 1/20879270485032960000+631193/7524053911986477465600000*
      ep+31481300311/387338295389063859929088000000*ep^2+11287394379818497/
      195413719376964273589664612352000000*ep^3+11872496591633991765721/
      352096439573414228153857698535833600000000*ep^4+
      44479481424974775838628477/2589417815605623495051513474374959104000000000
      *ep^5+362383882407292799553197505474577/457230075975504816511614063856622\
      52873154560000000000*ep^6;
Fill mncpoch(15,13) = 1/542861032610856960000+811373/
      195625401711648414105600000*ep+52366041331/
      10070795680115660358156288000000*ep^2+24496833037645909/50807567038010711\
      13331279921152000000*ep^3+33941693475249191183821/91545074289087699320003\
      00161931673600000000*ep^4+1185015560027737611941951879/471274042440223476\
      099375452336242556928000000000*ep^5+1856996607647877139991103732382117/
      1188798197536312522930196566027218574702018560000000000*ep^6;
Fill mncpoch(16,0) = 1;
Fill mncpoch(16,1) = 1/15+1/225*ep+1/3375*ep^2+1/50625*ep^3+1/759375*ep^4+1/
      11390625*ep^5+1/170859375*ep^6;
Fill mncpoch(16,2) = 1/420+29/88200*ep+631/18522000*ep^2+12209/3889620000*ep^3+
      221551/816820200000*ep^4+3861089/171532242000000*ep^5+65445871/
      36021770820000000*ep^6;
Fill mncpoch(16,3) = 1/16380+587/44717400*ep+229909/122078502000*ep^2+75104063/
      333274310460000*ep^3+22099571341/909838867555800000*ep^4+6074505299687/
      2483860108427334000000*ep^5+1591540832089909/6780938096006621820000000*
      ep^6;
Fill mncpoch(16,4) = 1/786240+181/476985600*ep+1660831/23439072384000*ep^2+
      150723401/14219703912960000*ep^3+970805468551/698756250282854400000*ep^4+
      23559283621507/141304041723866112000000*ep^5+391284412543967671/
      20831041830932342231040000000*ep^6;
Fill mncpoch(16,5) = 1/43243200+7793/865728864000*ep+328609891/
      155987026715520000*ep^2+1199908541813/3122860274844710400000*ep^3+
      33868064779952131/562676964321519919872000000*ep^4+95788093578258793133/
      11264792825716828795837440000000*ep^5+2262193177982682942722971/202969037\
      1337658212433989939200000000*ep^6;
Fill mncpoch(16,6) = 1/2594592000+653/3462915456000*ep+505096201/
      9359221602931200000*ep^2+16378601009/1387937899930982400000*ep^3+
      73707865232274001/33760617859291195192320000000*ep^4+16223415984884756209/
      45059171302867315183349760000000*ep^5+6646895816217486003329401/121781422\
      280259492746039396352000000000*ep^6;
Fill mncpoch(16,7) = 1/163459296000+4327/1178083838131200*ep+6711529309/
      5306678648861990400000*ep^2+62692963759919/191231471790390686054400000*
      ep^3+12245902756182085981/172280432935962969066408960000000*ep^4+
      84513205394696034097007/6208297681280361553277113282560000000*ep^5+
      13305358910031620309537534029/5593055381065477723347351356258304000000000
      *ep^6;
Fill mncpoch(16,8) = 1/10461394944000+52279/753973656403968000*ep+38620655011/
      1358509734108669542400000*ep^2+849477191073451/
      97910513556680031259852800000*ep^3+387257944458431377171/
      176415163326426080324002775040000000*ep^4+6193229394256281368037763/
      12714593651262180461111528002682880000000*ep^5+
      2246413060563394670926707349531/22909154840844196754830751155234013184000\
      000000*ep^6;
Fill mncpoch(16,9) = 1/659067881472000+2503/1900013614137999360*ep+22793611/
      35646028008682291200000*ep^2+1412951119346707/
      6168362354070841969370726400000*ep^3+750951562578273758971/11114155289564\
      843060412174827520000000*ep^4+1989289526080312570057597/11443134286135962\
      4150003752024145920000000*ep^5+5830714928654901859656485624131/
      1443276754973184395554337322779742830592000000000*ep^6;
Fill mncpoch(16,10) = 1/39544072888320000+74587/2850020421206999040000*ep+
      11017990873/733595256418681552896000000*ep^2+2339387863912039/
      370101741244250518162243584000000*ep^3+1453469738111059070671/66684931737\
      3890583624730489651200000000*ep^4+4483443596678889935329033/6865880571681\
      577449000225121448755200000000*ep^5+15255361713233596392711645893431/
      86596605298391063733260239366784569835520000000000*ep^6;
Fill mncpoch(16,11) = 1/2174924008857600000+445007/783755615831924736000000*ep+
      3119956589/8069547820605497081856000000*ep^2+782683688577779/
      4071119153686755699784679424000000*ep^3+2863709208190501272871/3667671245\
      5563982099360176930816000000000*ep^4+51901967990923850782124981/
      1888117157212433798475061908398407680000000000*ep^5+
      8288022434505328561539365461571/95256265828230170106586263303463026819072\
      0000000000*ep^6;
Fill mncpoch(16,12) = 1/104396352425164800000+535097/37620269559932387328000000
      *ep+4497296267/387338295389063859929088000000*ep^2+1349909677549421/
      195413719376964273589664612352000000*ep^3+5904043279451184720121/
      1760482197867071140769288492679168000000000*ep^4+
      127887004997460598130082251/906296235461968223268029716031235686400000000\
      00*ep^5+24417898826815043961294119451197/45723007597550481651161406385662\
      252873154560000000000*ep^6;
Fill mncpoch(16,13) = 1/4071457744581427200000+655217/
      1467190512837363105792000000*ep+6746001011/
      15106193520173490537234432000000*ep^2+2484371175567269/762113505570160666\
      9996919881728000000*ep^3+13364609919679693527121/686588057168157744900022\
      51214487552000000000*ep^4+357223711219164139055478611/3534555318301676070\
      745315892521819176960000000000*ep^5+16898299179023887779595169301169/
      356639459260893756879058969808165572410605568000000000*ep^6;
Fill mncpoch(16,14) = 1/114000816848279961600000+835397/
      41081334359446166962176000000*ep+11046624767/
      422973418564857735042564096000000*ep^2+5270904366292553/21339178155964498\
      6759913756688384000000*ep^3+37107398637644498515621/192244656007084168572\
      0063034005651456000000000*ep^4+1312368152152133530847563151/9896754891244\
      6929980868844990610936954880000000000*ep^5+
      415538987011799426321335346471897/499295242965251259630682557731431801374\
      84779520000000000*ep^6;
Fill mncpoch(17,0) = 1;
Fill mncpoch(17,1) = 1/16+1/256*ep+1/4096*ep^2+1/65536*ep^3+1/1048576*ep^4+1/
      16777216*ep^5+1/268435456*ep^6;
Fill mncpoch(17,2) = 1/480+31/115200*ep+721/27648000*ep^2+14911/6635520000*ep^3
      +289201/1592524800000*ep^4+5386591/382205952000000*ep^5+97576081/
      91729428480000000*ep^6;
Fill mncpoch(17,3) = 1/20160+337/33868800*ep+75769/56899584000*ep^2+14206753/
      95591301120000*ep^3+2399181961/160593385881600000*ep^4+378434270257/
      269796888281088000000*ep^5+56891840784409/453258772312227840000000*ep^6;
Fill mncpoch(17,4) = 1/1048320+6061/22895308800*ep+22987441/500033544192000*
      ep^2+69831137221/10920732605153280000*ep^3+185839346519401/
      238508800096547635200000*ep^4+452720097659125981/
      5209032194108600352768000000*ep^5+1035175813192084068961/
      113765263119331831704453120000000*ep^6;
Fill mncpoch(17,5) = 1/62899200+2627/457906176000*ep+37330861/30002012651520000
      *ep^2+45924434747/218414652103065600000*ep^3+436586760238021/
      14310528005792858112000000*ep^4+415769333764108067/
      104180643882172007055360000000*ep^5+3305276375544114114781/
      6825915787159909902267187200000000*ep^6;
Fill mncpoch(17,6) = 1/4151347200+12059/110813294592000*ep+6887351221/
      239596073035038720000*ep^2+37088446512379/6395617842881966899200000*ep^3+
      13682171803118081701/13828349075165673550774272000000*ep^4+
      18507364188749222564633/123041577104363015327333744640000000*ep^5+
      16768921235956947907208330581/798106729055908611660443787932467200000000*
      ep^6;
Fill mncpoch(17,7) = 1/290594304000+8837/4654158372864000*ep+10071852541/
      16771725112452710400000*ep^2+38384146937093/268615949401042609766400000*
      ep^3+27514282993368915181/967984435261597148554199040000000*ep^4+
      77380131181928255170229/15503238715149739931244051824640000000*ep^5+
      44653625308676613940352053021/55867471033913602816231065155272704000000000
      *ep^6;
Fill mncpoch(17,8) = 1/20922789888000+95549/3015894625615872000*ep+128904492469/
      10868077872869356339200000*ep^2+5173650253288037/
      1566568216906880500157644800000*ep^3+4300186483879412144461/5645285226445\
      634570368088801280000000*ep^4+125281902357438362924784317/813733993680779\
      549511137792171704320000000*ep^5+82715366553943572077600287179109/
      2932371819628057184618336147869953687552000000000*ep^6;
Fill mncpoch(17,9) = 1/1506440871936000+113567/217144413044342784000*ep+
      180060747619/782501606846593656422400000*ep^2+8417984803887179/
      112792911617295396011350425600000*ep^3+8092067738790391925011/40646053630\
      4085689066502393692160000000*ep^4+54216955774992728925926503/117177695090\
      03225512960384207272542208000000*ep^5+204825505198170945801018253560859/
      211130771013220117292520202646636665503744000000000*ep^6;
Fill mncpoch(17,10) = 1/105450861035520000+134159/15200108913103994880000*ep+
      35589400117/7825016068465936564224000000*ep^2+13547983294352027/
      7895503813210677720794529792000000*ep^3+15066569538722815424611/284522375\
      41285998234655167558451200000000*ep^4+83047939830906265693317461/
      585888475450161275648019210363627110400000000*ep^5+
      504097061172824764853457056020459/147791539709254082104764141852645665852\
      62080000000000*ep^6;
Fill mncpoch(17,11) = 1/6959756828344320000+158183/1003207188264863662080000*ep
      +49161501517/516451060518751813238784000000*ep^2+21815374681462883/
      521103251671904729572438966272000000*ep^3+28168883572409422954411/
      1877847677724875883487241058857779200000000*ep^4+
      179723548251415405272856013/386686393797106441927692678839993892864000000\
      00*ep^5+1259690802731425411701598305875059/975424162081076941891443336227\
      461394627297280000000000*ep^6;
Fill mncpoch(17,12) = 1/417585409700659200000+935059/
      300962156479459098624000000*ep+13683247289/
      6197412726225021758865408000000*ep^2+7124376132408439/6253239020062856754\
      869267595264000000*ep^3+53842285403156473734811/1126708606634925530092344\
      63531466752000000000*ep^4+2007338082278875133511508177/116005918139131932\
      57830780365199816785920000000000*ep^5+131404439458218746096631125941339/
      2341017988994584660539464006945907347105513472000000000*ep^6;
Fill mncpoch(17,13) = 1/21714441304434278400000+1115239/
      15650032136931873128448000000*ep+19424497661/
      322265461763701131461001216000000*ep^2+12024244516391011/3251684290432685\
      51253201914953728000000*ep^3+108005494827239782784311/5858884754501612756\
      480192103636271104000000000*ep^4+683914217018861020339953331/861758249033\
      55149915314368427198638981120000000000*ep^5+
      1864653300791185841202712983266579/60866467713859201174026064180593591024\
      7433502720000000000*ep^6;
Fill mncpoch(17,14) = 1/912006534786239692800000+1355479/
      657301349751138671394816000000*ep+28728505517/
      13535149394075447521362051072000000*ep^2+21686675147956723/13657074019817\
      279152634480428056576000000*ep^3+238255665765867861122311/246073159689067\
      735772168068352723386368000000000*ep^4+12964333968216612136097386837/
      25335692521586414075102424317596399860449280000000000*ep^5+
      6225025530325288300609163682475811/25563916439820864493090946955849308230\
      392207114240000000000*ep^6;
Fill mncpoch(17,15) = 1/27360196043587190784000000+1715839/
      19719040492534160141844480000000*ep+46394783861/
      406054481822263425640861532160000000*ep^2+45093029184966667/4097122205945\
      18374579034412841697280000000*ep^3+644498765693232564125311/7382194790672\
      032073165042050581701591040000000000*ep^4+46143130426104224537268397117/
      760070775647592422253072729527891995813478400000000000*ep^5+
      29504419402816573996559219101590779/7669174931946259347927284086754792469\
      11766213427200000000000*ep^6;
Fill mncpoch(18,0) = 1;
Fill mncpoch(18,1) = 1/17+1/289*ep+1/4913*ep^2+1/83521*ep^3+1/1419857*ep^4+1/
      24137569*ep^5+1/410338673*ep^6;
Fill mncpoch(18,2) = 1/544+33/147968*ep+817/40247296*ep^2+17985/10947264512*
      ep^3+371281/2977655947264*ep^4+7360353/809922417655808*ep^5+141903217/
      220298897602379776*ep^6;
Fill mncpoch(18,3) = 1/24480+767/99878400*ep+392449/407503872000*ep^2+167445503/
      1662615797760000*ep^3+64341277441/6783472454860800000*ep^4+23090095523327/
      27676567615832064000000*ep^5+7896872313485569/112920395872594821120000000
      *ep^6;
Fill mncpoch(18,4) = 1/1370880+7409/39152332800*ep+34344361/1118190624768000*
      ep^2+127496303969/31935524243374080000*ep^3+414575867232601/
      912078572390763724800000*ep^4+1233810004615062929/
      26048964027480211980288000000*ep^5+3446031540223992082441/
      743958412624834854157025280000000*ep^6;
Fill mncpoch(18,5) = 1/89107200+124877/33083721216000*ep+9370684129/
      12283324013076480000*ep^2+547736118544133/4560552539575035494400000*ep^3+
      27484044889650755641/1693241946893419178360832000000*ep^4+
      1243049340091966141204157/628666870042588672541809704960000000*ep^5+
      52134825205663579992245684689/233411435509412322341323107257548800000000*
      ep^6;
Fill mncpoch(18,6) = 1/6415718400+5771/88223256576000*ep+14191662109/
      884399328941506560000*ep^2+109647349355177/36484420316600283955200000*
      ep^3+58016445791093343061/121913420176326180841979904000000*ep^4+
      337564241429821575056833/5029334960340709380334477639680000000*ep^5+
      146132963874211695782571401869/168056233566776872085752637225435136000000\
      00*ep^6;
Fill mncpoch(18,7) = 1/494010316800+695089/672525884878848000*ep+2491409046949/
      8239948547748016619520000*ep^2+746158649625630001/
      11217536354962239905149747200000*ep^3+1680520133126409356069941/137439947\
      629722554255471938633728000000*ep^4+371076347615267005360649932609/
      187105247105199096461229278378411950080000000*ep^5+
      672203138641751347243174296203656069/229245839279220457762613181371911403\
      1248179200000000*ep^6;
Fill mncpoch(18,8) = 1/39520825344000+11083/717360943870771200*ep+3509845866349/
      659195883819841329561600000*ep^2+81598335099127831/
      59826860559798612827465318400000*ep^3+3180163710978816320207101/109951958\
      10377804340437755090698240000000*ep^4+17866913657179536531741418541/
      332631550409242838153296494894954577920000000*ep^5+1657296852483437668283\
      659946775174349/183396671423376366210090545097529122499854336000000000*
      ep^6;
Fill mncpoch(18,9) = 1/3201186852864000+1768477/7844341921226883072000*ep+
      43626282040741/480553799304664329250406400000*ep^2+6341322098576939297/
      235514419279703219256599972413440000*ep^3+473413816892251673970873181/
      72139479711888774277612111150071152640000000*ep^4+
      246122147257642086960153029784733/176774043781038423151026042543469555844\
      382720000000*ep^5+2883473637413744217699157744337822684821/10829390050878\
      951048339636597463997154493898686464000000000*ep^6;
Fill mncpoch(18,10) = 1/256094948229120000+2074783/627547353698150645760000*ep+
      59514244080691/38444303944373146340032512000000*ep^2+49936180540264833931/
      94205767711881287702639988965376000000*ep^3+855807609806410679522595331/
      5771158376951101942208968892005692211200000000*ep^4+
      508261152987004516562001115242019/141419235024830738520820834034775644675\
      50617600000000*ep^5+6775559655584679353950165584470869480171/
      866351204070316083867170927797119772359511894917120000000000*ep^6;
Fill mncpoch(18,11) = 1/19719311013642240000+2424847/48321146234757599723520000
      *ep+11533647869413/422887343388104609740357632000000*ep^2+
      15639756978914436191/1450768822762971830620655830066790400000*ep^3+
      1540172095689748578368373331/44437919502523484955009060468443830026240000\
      0000*ep^4+149631422498934380414278193855029/15556115852731381237290291743\
      8253209143056793600000000*ep^5+15942160155576398219385344873862572054971/
      66709042713414338457772161440378222471682415908618240000000000*ep^6;
Fill mncpoch(18,12) = 1/1419790392982241280000+566651/
      695824505780509436018688000*ep+15666233612413/
      30447888723943531901305749504000000*ep^2+122986290854820760483/5222767761\
      94669859023436098824044544000000*ep^3+2795886722575639507051899931/
      31995302041816909167606523537279557618892800000000*ep^4+
      44679233920126784544816320489899/1600057630566656355835572865079175865471\
      441305600000000*ep^5+38295171949969044501800041051694943775171/
      4803051075365832368959595623707232017961133945420513280000000000*ep^6;
Fill mncpoch(18,13) = 1/92286375543845683200000+16616723/
      1130714821893327833530368000000*ep+4296630026537/
      395822553411265914716974743552000000*ep^2+39337394008338706103/6789598090\
      530708167304669284712579072000000*ep^3+5205742684399278649369003531/
      2079694632718099095894424029923171245228032000000000*ep^4+
      3386116294275986540181282069222449/36401311095391432095259282680551250939\
      47528970240000000000*ep^5+19275537051500212631939807407885805145047/
      62439663979755820796474743108194016233494741290466672640000000000*ep^6;
Fill mncpoch(18,14) = 1/5168037030455358259200000+19679783/
      63320030026026358677700608000000*ep+1203785183113/44332125982061782448301\
      17127782400000*ep^2+65148257709241446563/38021749306971965736906147994390\
      4428032000000*ep^3+10194568240871006282100573031/116462899432213549370087\
      745675697589732769792000000000*ep^4+7847055465116321469102850816127429/
      203847342134192019733451983011087005261061622333440000000000*ep^5+
      52925939449671092126750056917072000886883/3496621182866325964602585614058\
      864909075705512266133667840000000000*ep^6;
Fill mncpoch(18,15) = 1/232561666370491121664000000+23763863/
      2849401351171186140496527360000000*ep+8791883561309/997472834596390105086\
      776353751040000000*ep^2+115417715850340651571/171097871881373845816077665\
      97475699261440000000*ep^3+21978947864622487488802815031/52408304744496097\
      21653948555406391537974640640000000000*ep^4+
      20670452807251665569569965217814069/9173130396038640888005339235498915236\
      747773005004800000000000*ep^5+171113635511127627373867081882550116977011/
      157347953228984668407116352632648920908406748051976015052800000000000*
      ep^6;
Fill mncpoch(18,16) = 1/7441973323855715893248000000+29889983/
      91180843237477956495888875520000000*ep+2804717413153/63838261414168966725\
      55368664006656000000*ep^2+235691963923794646091/5475131900203963066114485\
      31119222376366080000000*ep^3+58075879215443408921577738031/16770657518238\
      7511092926353773004529215188500480000000000*ep^4+
      10213734180205588474482562633289147/4193431038189092977373869364799504108\
      2275533737164800000000000*ep^5+784305135624330012093778824553194147329483/
      5035134503327509389027723284244765469069015937663232481689600000000000*
      ep^6;
Fill mncpoch(19,0) = 1;
Fill mncpoch(19,1) = 1/18+1/324*ep+1/5832*ep^2+1/104976*ep^3+1/1889568*ep^4+1/
      34012224*ep^5+1/612220032*ep^6;
Fill mncpoch(19,2) = 1/612+35/187272*ep+919/57305232*ep^2+21455/17535400992*
      ep^3+469711/5365832703552*ep^4+9874655/1641944807286912*ep^5+201881359/
      502435111029795072*ep^6;
Fill mncpoch(19,3) = 1/29376+433/71912448*ep+125065/176041672704*ep^2+30119905/
      430950014779392*ep^3+6532281721/1054965636179951616*ep^4+1323011798353/
      2582555877368521555968*ep^5+255342792121705/6322096787798140769009664*
      ep^6;
Fill mncpoch(19,4) = 1/1762560+2981/21573734400*ep+5559121/264062509056000*ep^2
      +8301230861/3232125110845440000*ep^3+10856480458201/
      39561211356748185600000*ep^4+12993299923745141/
      484229227006597791744000000*ep^5+14592263864677675681/
      5926965738560756970946560000000*ep^6;
Fill mncpoch(19,5) = 1/123379200+26987/10571129856000*ep+437557369/
      905734406062080000*ep^2+5525173283603/77603323911399014400000*ep^3+
      59880470075790961/6649052792728667553792000000*ep^4+584846868682225266107/
      569690843280992236008898560000000*ep^5+5296028087750682494768809/48811111\
      452315414781242428620800000000*ep^6;
Fill mncpoch(19,6) = 1/9623577600+436511/10719125673984000*ep+111347457841/
      11939390940710338560000*ep^2+21679055891892671/
      13298571205400803501670400000*ep^3+3567707614652029688401/
      14812480551423630972300558336000000*ep^4+522830736837015369430864031/
      16498733337397697122187253896970240000000*ep^5+
      70359053570403260874728970376561/1837694914052705096257705088060133212160\
      0000000*ep^6;
Fill mncpoch(19,7) = 1/808380518400+529331/900406556614656000*ep+160479961261/
      1002908839019668439040000*ep^2+36574805896138691/
      1117079981253667494140313600000*ep^3+6962581097931622987021/1244248366319\
      585001673246900224000000*ep^4+1169097514347028615086153251/13858936003414\
      06558263729327345500160000000*ep^5+178874684852094456927025715134381/
      1543663727804272280856472273970511898214400000000*ep^6;
Fill mncpoch(19,8) = 1/71137485619200+6936481/871593546802987008000*ep+
      27144205309621/10678973317881429538897920000*ep^2+78915368289828852361/
      130841344044279566253666651340800000*ep^3+189838243670759861066750701/
      1603099549153083872835824692223803392000000*ep^4+
      399733753113342469138829668028641/196415604201153803501140047270521728715\
      98080000000*ep^5+762126859139026684033692640366200630181/2406531122417544\
      67740880813276977714544308859699200000000*ep^6;
Fill mncpoch(19,9) = 1/6402373705728000+1632341/15688683842453766144000*ep+
      37144122156541/961107598609328658500812800000*ep^2+24885047642990928509/
      2355144192797032192565999724134400000*ep^3+342287031737439448024305781/
      144278959423777548555224222300142305280000000*ep^4+
      163822407857362995880992338849717/353548087562076846302052085086939111688\
      765440000000*ep^5+1765722588362175280360157427240228938221/21658780101757\
      902096679273194927994308987797372928000000000*ep^6;
Fill mncpoch(19,10) = 1/576213633515520000+634871/470660515273612984320000*ep+
      50108441924941/86499683874839579265073152000000*ep^2+12842724447592821487/
      70654325783910965776979991724032000000*ep^3+604540602047063899917440581/
      12985106348139979369970180007012807475200000000*ep^4+
      36491320739769019782145968968861/3535480875620768463020520850869391116887\
      654400000000*ep^5+4001224686465313155038158061435416431421/19492902091582\
      11188701134587543519487808901763563520000000000*ep^6;
Fill mncpoch(19,11) = 1/50706799749365760000+736973/41418125344077942620160000*
      ep+67038885805291/7611972180985882975326437376000000*ep^2+
      19687528766084643169/6217580668984164988374239271714816000000*ep^3+
      1056821216013888103206719131/11426893586363181845573758406171270578176000\
      00000*ep^4+14491834801117137497336689574663/62224463410925524949161166975\
      301283657222717440000000*ep^5+8995027630880172313079771602899231919171/
      171537538405922584605699843703829714927183355193589760000000000*ep^6;
Fill mncpoch(19,12) = 1/4259371178946723840000+853661/
      3479122528902547180093440000*ep+12778797804013/
      91343666171830595703917248512000000*ep^2+30125455273167325777/52227677619\
      4669859023436098824044544000000*ep^3+1847759019119841608016698731/
      95985906125450727502819570611838672856678400000000*ep^4+
      20618515544753006667442994530613/3733467804655531496949670018518077019433\
      363046400000000*ep^5+20363062671292178341579800591748333959571/
      14409153226097497106878786871121696053883401836261539840000000000*ep^6;
Fill mncpoch(19,13) = 1/332230951957844459520000+989797/
      271371557254398680047288320000*ep+17109951516613/712480596140278646490554\
      5383936000000*ep^2+15476805930275572451/135791961810614163346093385694251\
      58144000000*ep^3+3269950574303538456569500531/748690067778515674521992650\
      7723416482820915200000000*ep^4+125449545403314235905692629918727/
      873631466289394370286222784333230022547406952857600000000*ep^5+4726122658\
      9307477581910161281668248682971/11239139516356047743365453759474922922029\
      05343228400107520000000000*ep^6;
Fill mncpoch(19,14) = 1/23256166637049112166400000+5765801/
      94980045039039538016550912000000*ep+4633029920081/99747283459639010508677\
      635375104000000*ep^2+972276647483105227/380217493069719657369061479943904\
      42803200000*ep^3+5950278111359178723522658531/524083047444960972165394855\
      540639153797464064000000000*ep^4+1321573779274851026418875128258963/
      305771013201288029600177974516630507891592433500160000000000*ep^5+
      184429809438582369103388536652477688571/125878362583187734725693082106119\
      136726725398441580812042240000000*ep^6;
Fill mncpoch(19,15) = 1/1395369998222946729984000000+6786821/
      5698802702342372280993054720000000*ep+6414896199989/598483700757834063052\
      0658122506240000000*ep^2+7917927319201484899/1140652479209158972107184439\
      8317132840960000000*ep^3+11407222563588671298837120031/314449828466976583\
      29923691332438349227847843840000000000*ep^4+
      426490180342842088866751065140089/262089439886818311085866835299969006764\
      2220858572800000000000*ep^5+61460857526770605266414768298646940834171/
      944087719373908010442698115795893525450440488311856090316800000000000*
      ep^6;
Fill mncpoch(19,16) = 1/66977759914701443039232000000+8148181/
      273542529712433869487666626560000000*ep+9267281033573/2872721763637603502\
      64991589880299520000000*ep^2+41416329948615369689/16425395700611889198343\
      45593357667129098240000000*ep^3+24093292924829250726795954031/
      1509359176641487599836337183957040762936696504320000000000*ep^4+
      2557031623473562434471511531976501/29354017267323650841617085553596528757\
      5928736160153600000000000*ep^5+193044191107999031795357544599330752205579/
      45316210529947584501249509558202889221621143438969092335206400000000000*
      ep^6;
Fill mncpoch(19,17) = 1/2277243837099849063333888000000+10190221/93004460102227\
      51562580665303040000000*ep+14618125319789/9767253996367851909009714055930\
      183680000000*ep^2+83207445227846071073/5584634538208042327436775017416068\
      2389340160000000*ep^3+62323702501770178695925461031/513182120058105783944\
      35464254539385939847681146880000000000*ep^4+
      319162535360951652254196420838183/369643180403334862449992929193437769540\
      058408497971200000000000*ep^5+858212753688871384631081484547427071719971/
      1540751158018217873042483324978898233535118876924949139397017600000000000
      *ep^6;
Fill mncpoch(20,0) = 1;
Fill mncpoch(20,1) = 1/19+1/361*ep+1/6859*ep^2+1/130321*ep^3+1/2476099*ep^4+1/
      47045881*ep^5+1/893871739*ep^6;
Fill mncpoch(20,2) = 1/684+37/233928*ep+1027/80003376*ep^2+25345/27361154592*
      ep^3+586531/9357514870464*ep^4+13033657/3200270085698688*ep^5+281651707/
      1094492369308951296*ep^6;
Fill mncpoch(20,3) = 1/34884+971/202815576*ep+628885/1179169758864*ep^2+
      339598655/6855692978035296*ep^3+165130395661/39858998974297210944*ep^4+
      74980524443111/231740220036563984428416*ep^5+32441726871224245/
      1347337639292583005466810624*ep^6;
Fill mncpoch(20,4) = 1/2232576+10675/103841574912*ep+71280865/4829879332306944*
      ep^2+381087985915/224647347504260579328*ep^3+1784196875682361/
      10448797427118168065703936*ep^4+7643622142560484675/
      485994465930120233072021471232*ep^5+30724413617353537431505/
      22604574599341752280645862669942784*ep^6;
Fill mncpoch(20,5) = 1/167443200+68879/38940590592000*ep+2849921641/
      9056023748075520000*ep^2+91821183361439/2106068882852442931200000*ep^3+
      2538718674137225881/489787379396164128079872000000*ep^4+
      63246613519325064668399/113904952952371929626255032320000000*ep^5+
      1460644458774764824986123721/26489735858603615953881870316339200000000*
      ep^6;
Fill mncpoch(20,6) = 1/14065228800+598433/22897067268096000*ep+209231949649/
      37274593747078840320000*ep^2+55824156998159297/
      60680056652744585733734400000*ep^3+12586696512349442395441/
      98782277826135966007660904448000000*ep^4+2526566903875289523623661473/
      160809645718723261783191339568988160000000*ep^5+
      465632559513010972701751825732369/261785238458423972322092845511147205427\
      200000000*ep^6;
Fill mncpoch(20,7) = 1/1279935820800+9407549/27087230578157568000*ep+
      50674936658761/573245977236325485281280000*ep^2+205140415810486182629/
      12131581686413266791988317388800000*ep^3+693440824795419090681592081/
      256740177966296508588177081366478848000000*ep^4+
      2066962792941526519197177519796109/54333821166936143593912480458755372010\
      70080000000*ep^5+5612369498835806831267039256237912043801/114986448400302\
      292943222606744942158764758060236800000000*ep^6;
Fill mncpoch(20,8) = 1/122873838796800+11171129/2600374135503126528000*ep+
      70376116340581/55031613814687246587002880000*ep^2+329254327066408022609/
      1164631841895673612030878469324800000*ep^3+1274107170923194951194372301/
      24647057084764464824464999811181969408000000*ep^4+
      4313952717438254671224548622393689/52160468320258697850155981240405157130\
      2727680000000*ep^5+13220370232255564004345228715718974090421/
      11038699046429020122549370247514447241416773782732800000000*ep^6;
Fill mncpoch(20,9) = 1/12164510040883200+144045379/2831807433562904788992000*ep
      +11563936671172141/659223701886138526865707499520000*ep^2+
      682964638539938251189939/153462373174751016183696825024459571200000*ep^3+
      33107756416321668892839436318381/3572489871502561642000421416131600619615\
      0272000000*ep^4+1395424523824507178967790057413570374899/8316490627611523\
      711990816225401006051377683963576320000000*ep^5+5295200568974199167131002\
      0002288914759772858221/19360171434176932904150448056006372252757025767518\
      78288179200000000*ep^6;
Fill mncpoch(20,10) = 1/1216451004088320000+33464927/56636148671258095779840000
      *ep+15459129684443701/65922370188613852686570749952000000*ep^2+
      208568335200260476871279/3069247463495020323673936500489191424000000*ep^3
      +57384334759425043431682350760501/357248987150256164200042141613160061961\
      5027200000000*ep^4+546257828615772235565008402289813568431/16632981255223\
      0474239816324508020121027553679271526400000000*ep^5+116534384861495429218\
      360696197566696018666694901/193601714341769329041504480560063722527570257\
      675187828817920000000000*ep^6;
Fill mncpoch(20,11) = 1/120428649404743680000+2575873/
      373798581230303432146944000*ep+20456163600317701/652631464867277141597050\
      4245248000000*ep^2+104797168713396265839349/10128516629533567068123990451\
      6143316992000000*ep^3+98044336735330748463653354832901/353676497278753602\
      558041720197028461341887692800000000*ep^4+3901695014800776788641589261496\
      3791437/609875979358178405545993189862740443767696823995596800000000*ep^5
      +252777220486702037010828869195404425757546325701/19166569719835163575108\
      943575446308530229455509843595052974080000000000*ep^6;
Fill mncpoch(20,12) = 1/11561150342855393280000+14819303/
      179423318990545647430533120000*ep+26924582630540851/626526206272586055933\
      168407543808000000*ep^2+157029189692522423246587/972337596435222438539903\
      0833549758431232000000*ep^3+166585387478920575522984290444251/
      33952943738760345845572005138914732288821218508800000000*ep^4+22477262491\
      5717378138883377323504506457/17564428205515538079724603868046924780509668\
      5310731878400000000*ep^5+547107566079481220911421539531192588299392600251/
      1839990693104175703210458583242845618902027728944985125085511680000000000
      *ep^6;
Fill mncpoch(20,13) = 1/1052064681199840788480000+136291/
      130620176225117231329428111360*ep+722918946514099/11635486687919455324473\
      12756867072000000*ep^2+235564594067231841654859/8848272127560524190713118\
      05853028017242112000000*ep^3+284094712260931388092304139835051/
      3089717880227191471947052467641240638282730884300800000000*ep^4+207012112\
      16649520775829064379093487461/7611252222390066501213995009487000738220856\
      36346504806400000000*ep^5+11976844398997963570755101321250803507248947718\
      51/1674391530724799889921517310750989513200845233339936463827815628800000\
      00000*ep^6;
Fill mncpoch(20,14) = 1/88373433220786626232320000+19622959/
      1371511850363730928958995169280000*ep+6691889361450493/684166617249663973\
      079019901037838336000000*ep^2+39636503525768697284027/8258387319056489244\
      665576854628261494259712000000*ep^3+491704082578217610786112219715251/
      259536301939084083643552407281864213615749394281267200000000*ep^4+
      368001459911488032779259477943263214661/575410668012689027491778022717217\
      255809496741077957633638400000000*ep^5+2696874473789118126876345385681906\
      474383259909651/140648888580883190753407454103083119108870999600554662961\
      53651281920000000000*ep^6;
Fill mncpoch(20,15) = 1/6628007491558996967424000000+113634299/
      514316943886399098359623188480000000*ep+1791861632884649/1026249925874495\
      9596185298515567575040000000*ep^2+36759343878994477827661/371627429357542\
      016009950958458271767241687040000000*ep^3+
      876782662026233073157512154812451/194652226454313062732664305461398160211\
      81204571095040000000000*ep^4+3783897589621264775867769177810666436777/
      215779000504758385309416758518956470928561277904234112614400000000000*
      ep^5+1279299988357065097769419812185359092380304604391/210973332871324786\
      130111181154624678663306499400831994442304769228800000000000*ep^6;
Fill mncpoch(20,16) = 1/424192479459775805915136000000+133033679/32916284408729\
      542295015884062720000000*ep+2455488433612397/6567999525596774141558591049\
      96324802560000000*ep^2+19662996236659528938043/79280518262942296748789537\
      80443131034489323520000000*ep^3+1649218782291627541449949696825951/
      1245774249307603601489051554952948225355597092550082560000000000*ep^4+
      8354443569737343846589672770612297481117/13809856032304536659802672545213\
      214139427921785870983207321600000000000*ep^5+3321394909630494639499669865\
      710145065396621598387/135022933037647863123271155938959794344516159616532\
      47644307505230643200000000000*ep^6;
Fill mncpoch(20,17) = 1/21633816452448566101671936000000+158899519/167873050484\
      5206657045810087198720000000*ep+3512363456777501/334967975805435481219488\
      14354812564930560000000*ep^2+304157289802731019494563/3638975788269051420\
      769439785223397144830599495680000000*ep^3+
      3419357635687618766938680368107951/63534486714687783675941629302600359493\
      135451720054210560000000000*ep^4+6996460118839792568226709790805116460079/
      234767552549177123216645433268624640370274670359806714524467200000000000*
      ep^5+2032407026008299343034169136508042531424864017959/
      1377233916984008203857365790577389902314064828088631259719365533525606400\
      00000000*ep^6;
Fill mncpoch(20,18) = 1/778817392288148379660189696000000+197698279/60434298174\
      427439653649163139153920000000*ep+5484764391463397/1205884712899567732390\
      157316773252337500160000000*ep^2+602080169996039164077371/131003128377685\
      851147699832268042297213901581844480000000*ep^3+
      8675349539385611774407351611598951/22872415217287602123338986548936129417\
      52876261921951580160000000000*ep^4+23024688913827073458150756334330874369\
      639/845163189177037643579923559767048705332988813295304172288081920000000\
      0000*ep^5+43929885665398066829245940510472343485868209330587/
      2479021050571214766943258423039301824165316690559536267494857960346091520\
      0000000000*ep^6;
Fill mncpoch(21,0) = 1;
Fill mncpoch(21,1) = 1/20+1/400*ep+1/8000*ep^2+1/160000*ep^3+1/3200000*ep^4+1/
      64000000*ep^5+1/1280000000*ep^6;
Fill mncpoch(21,2) = 1/760+39/288800*ep+1141/109744000*ep^2+29679/41702720000*
      ep^3+723901/15847033600000*ep^4+16954119/6021872768000000*ep^5+386128261/
      2288311651840000000*ep^6;
Fill mncpoch(21,3) = 1/41040+541/140356800*ep+195211/480020256000*ep^2+58726081/
      1641669275520000*ep^3+15907469851/5614508922278400000*ep^4+4023543044521/
      19201620514192128000000*ep^5+969677567613091/65669542158537077760000000*
      ep^6;
Fill mncpoch(21,4) = 1/2790720+12617/162252460800*ep+99566119/9433358070912000*
      ep^2+629037362933/548455438242823680000*ep^3+3479915570656231/
      31887199179437768755200000*ep^4+17614167008208763517/
      1853921760292511875427328000000*ep^5+83646110364087120543919/
      107787011143406640437344849920000000*ep^6;
Fill mncpoch(21,5) = 1/223257600+65003/51920787456000*ep+2537876509/
      12074698330767360000*ep^2+77146426286027/2808091843803257241600000*ep^3+
      2012181692155397581/653049839194885504106496000000*ep^4+
      47283967911884477681243/151873270603162572835006709760000000*ep^5+
      1029886941650541728844759229/35319647811471487938509160421785600000000*
      ep^6;
Fill mncpoch(21,6) = 1/20093184000+80507/4672870871040000*ep+3786057037/
      1086722849769062400000*ep^2+5433818183507/10109130637691726069760000*ep^3
      +4118329620082710781/58774485527539695369584640000000*ep^4+
      111134550341646825629867/13668594354284631555150603878400000000*ep^5+
      2752917010147434113410217197/3178768303032433914465824437960704000000000*
      ep^6;
Fill mncpoch(21,7) = 1/1969132032000+679829/3205589417533440000*ep+264567310933/
      5218443124591037644800000*ep^2+15471775567772353/
      1699041586276848400544563200000*ep^3+18883399732921434619381/138295188956\
      59035241072526622720000000*ep^4+4063600108536162615902797349/225133504006\
      21256649646787539658342400000000*ep^5+796393353947420464985775918751573/
      36649933384179356125092998371560608759808000000000*ep^6;
Fill mncpoch(21,8) = 1/204789731328000+10465697/4333956892505210880000*ep+
      61749193007917/91719356357812077645004800000*ep^2+54096040178685508069/
      388210613965224537343626156441600000*ep^3+979648908410397655642573141/
      41078428474607441374108333018636615680000000*ep^4+
      3103576326078171977720055003798977/86934113867097829750259968734008595217\
      1212800000000*ep^5+8896412581122772353147560018397791958397/1839783174404\
      8366870915617079190745402361289637888000000000*ep^6;
Fill mncpoch(21,9) = 1/22117290983424000+12229277/468067344390562775040000*ep+
      83316501339577/9905690486643704385660518400000*ep^2+83483103265175749201/
      41926746308244250033111624895692800000*ep^3+1715794564692390894522071041/
      4436470275257603668403699966012754493440000000*ep^4+
      6129517304478378711481289050285757/93888842976465656130280766232729282834\
      490982400000000*ep^5+19706306708954751481141731761700747288457/
      1986965828357223622058886644552600503455019280891904000000000*ep^6;
Fill mncpoch(21,10) = 1/2432902008176640000+155685007/
      566361486712580957798400000*ep+13376052237829537/
      131844740377227705373141499904000000*ep^2+33546276427873663571287/
      1227698985398008129469574600195676569600000*ep^3+
      42869410876462125767012740349281/7144979743005123284000842832263201239230\
      054400000000*ep^4+1894408519005680278985033026339791282367/16632981255223\
      04742398163245080201210275536792715264000000000*ep^5+75002216130999040005\
      632021996598286884167697697/387203428683538658083008961120127445055140515\
      350375657635840000000000*ep^6;
Fill mncpoch(21,11) = 1/267619220899430400000+178964263/
      62299763538383905357824000000*ep+3508441426211573/29005842882990095182091\
      12997888000000*ep^2+249405288261152635886123/6752344419689044712082660301\
      07622113280000000*ep^3+71899258642387961096351961171721/78594777173056356\
      1240092711548952136315305984000000000*ep^4+356816976715204207666505099655\
      8344401943/182962793807453521663797956958822133130309047198679040000000000
      *ep^5+31613310718398363686217874079707021030633138421/8518475431037850477\
      826197144642803791213091337708264467988480000000000*ep^6;
Fill mncpoch(21,12) = 1/28902875857138483200000+68276701/
      2242791487381820592881664000000*ep+4568061960487877/313263103136293027966\
      584203771904000000*ep^2+122520682680406128102601/243084399108805609634975\
      77083874396078080000000*ep^3+119435764265920301764172676919321/
      84882359346900864613930012847286830722053046272000000000*ep^4+73971957065\
      9117117205428798902799366287/21955535256894422599655754835058655975637085\
      66384148480000000000*ep^5+13210710645113143179406447455713718431899764673/
      183999069310417570321045858324284561890202772894498512508551168000000000*
      ep^6;
Fill mncpoch(21,13) = 1/3005899089142402252800000+77976391/
      233250314687709341659693056000000*ep+5929486236521699/3257936272617447490\
      8524757192278016000000*ep^2+180034861033933286675911/25280777507315783402\
      03748016722937192120320000000*ep^3+198018469620920758028858699460871/
      8827765372077689919848721336117830395093516812288000000000*ep^4+137995882\
      7191566739687075611760671309617/22833756667170199503641985028461002214662\
      5690903951441920000000000*ep^5+138333486542783263039119021658018467993464\
      984507/956795160414171365669438463286279721829054419051392265044466073600\
      00000000*ep^6;
Fill mncpoch(21,14) = 1/294578110735955420774400000+89061751/
      22858530839395515482649919488000000*ep+1100941866605621/45611107816644264\
      8719346600691892224000000*ep^2+265465219546700294335831/24775161957169467\
      7339967305638847844827791360000000*ep^3+330443458297860188895697838498071/
      865121006463613612145174690939547378719164647604224000000000*ep^4+
      371569579831022268697049515535951917591/319672593340382793050987790398454\
      0310052759672655320186880000000000*ep^5+588062054430723474927416519522183\
      40414543449167/1875318514411775876712099388041108254784946661340728839487\
      153504256000000000*ep^6;
Fill mncpoch(21,15) = 1/26512029966235987869696000000+101994671/205726777554559\
      6393438492753920000000*ep+1440136160440589/410499970349798383847411940622\
      70300160000000*ep^2+131947126603765803454997/7432548587150840320199019169\
      165435344833740800000000*ep^3+560815778698370791596289811665471/
      77860890581725225093065722184559264084724818284380160000000000*ep^4+
      2150849539585028745812789751048513353533/86311600201903354123766703407582\
      5883714245111616936450457600000000000*ep^5+644522266561735863051652284582\
      933977506909725971/843893331485299144520444724618498714653225997603327977\
      769219076915200000000000*ep^6;
Fill mncpoch(21,16) = 1/2120962397298879029575680000000+4700567/658325688174590\
      8459003176812544000000*ep+1909103457032669/328399976279838707077929552498\
      1624012800000000*ep^2+201079916992041251032741/59460388697206722561592153\
      3533234827586699264000000000*ep^3+982104956468853833677919602528111/
      6228871246538018007445257774764741126777985462750412800000000000*ep^4+
      24732839655047676871730070400369814083/3945673152087010474229335012918061\
      18269369193882028091637760000000000*ep^5+14908925622888415093420089880528\
      34130671436230531/6751146651882393156163557796947989717225807980826623822\
      1537526153216000000000000*ep^6;
Fill mncpoch(21,17) = 1/144225443016323774011146240000000+27382711/223830733979\
      3608876061080116264960000000*ep+2592084677757329/223311983870290320812992\
      095698750432870400000000*ep^2+318411200189355854830121/404330643141005713\
      41882664280259968275895549952000000000*ep^3+
      1815997238747320968392957220400411/42356324476458522450627752868400239662\
      0903011467028070400000000000*ep^4+1872198545452668789019780076649838497053
      /939070210196708492866581733074498561481098681439226858097868800000000000
      *ep^5+3779020496465907922039085085124472799077917940351/
      4590779723280027346191219301924633007713549426962104199064551778418688000\
      000000000*ep^6;
Fill mncpoch(21,18) = 1/7788173922881483796601896960000000+32555879/12086859634\
      8854879307298326278307840000000*ep+3674765594251649/120588471289956773239\
      01573167732523375001600000000*ep^2+1620589892856994073881483/
      6550156418884292557384991613402114860695079092224000000000*ep^3+
      3702303588088847790211455041232811/22872415217287602123338986548936129417\
      528762619219515801600000000000*ep^4+2194423691588781637301433536686607339\
      77/2414751969077250410228353027905853443808539466558011920823091200000000\
      000*ep^5+11288449477143071208076450493848872632073685174991/
      2479021050571214766943258423039301824165316690559536267494857960346091520\
      00000000000*ep^6;
Fill mncpoch(21,19) = 1/295950609069496384270872084480000000+40315631/459300666\
      1256485413677336398575697920000000*ep+5685875368931369/458236190901835738\
      308259780373835888250060800000000*ep^2+3164824289660551569998563/
      248905943917603117180629681309280364706413005504512000000000*ep^3+
      9227910200640807772651340119417411/86915177825692888068688148885957291786\
      6092979530341600460800000000000*ep^4+164864004605711110259964848862893050\
      3757/21410800792484953637358063514098567201769049936814372364631408640000\
      0000000*ep^5+47556711908537510787153661623430506914067600903431/
      9420279992170616114384382007549346931828203424126237816480460249315147776\
      000000000000*ep^6;
*--#] poch.h : 
*--#] Tables : 
#endif
